"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/base/common/strings","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","os","vs/platform/telemetry/common/telemetry","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensions/common/extensions","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/performance","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/remote/common/remoteHosts","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/themables","vs/base/common/htmlContent","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],Ee=function(ae){for(var e=[],E=0,A=ae.length;E<A;E++)e[E]=ve[ae[E]];return e};define(ve[140],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class E{static get(){const a=new Map,I=new Map,D=new Map,P=new Map;function w(b,f){b.has(f.detail)||b.set(f.detail,-f.timestamp)}function y(b,f){const p=b.get(f.detail);!p||p>=0||b.set(f.detail,p+f.timestamp)}let T=[];typeof ae.getStats=="function"&&(T=ae.getStats().slice(0).sort((b,f)=>b.timestamp-f.timestamp));for(const b of T)switch(b.type){case 10:w(a,b);break;case 11:case 12:y(a,b);break;case 21:w(I,b);break;case 22:y(I,b);break;case 33:w(D,b);break;case 34:y(D,b);break;case 31:w(P,b);break;case 32:y(P,b);break}let S=0;D.forEach(b=>S+=b);function v(b){const f=[];return b.forEach((p,u)=>f.push([u,p])),f}return{amdLoad:v(a),amdInvoke:v(I),nodeRequire:v(D),nodeEval:v(P),nodeRequireTotal:S}}static toMarkdownTable(a,I){let D="";const P=[];return a.forEach((w,y)=>{P[y]=w.length}),I.forEach(w=>{w.forEach((y,T)=>{typeof y>"u"&&(y=w[T]="-");const S=y.toString().length;P[T]=Math.max(S,P[T])})}),a.forEach((w,y)=>{D+=`| ${w+" ".repeat(P[y]-w.toString().length)} `}),D+=`|
`,a.forEach((w,y)=>{D+=`| ${"-".repeat(P[y])} `}),D+=`|
`,I.forEach(w=>{w.forEach((y,T)=>{typeof y<"u"&&(D+=`| ${y+" ".repeat(P[T]-y.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=E}),define(ve[86],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(D){return(P,w,y)=>{let T=null,S=null;if(typeof y.value=="function"?(T="value",S=y.value):typeof y.get=="function"&&(T="get",S=y.get),!S)throw new Error("not supported");y[T]=D(S,w)}}function A(D,P,w){let y=null,T=null;if(typeof w.value=="function"?(y="value",T=w.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(y="get",T=w.get),!T)throw new Error("not supported");const S=`$memoize$${P}`;w[y]=function(...v){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,v)}),this[S]}}e.memoize=A;function a(D,P,w){return E((y,T)=>{const S=`$debounce$${T}`,v=`$debounce$result$${T}`;return function(...b){this[v]||(this[v]=w?w():void 0),clearTimeout(this[S]),P&&(this[v]=P(this[v],...b),b=[this[v]]),this[S]=setTimeout(()=>{y.apply(this,b),this[v]=w?w():void 0},D)}})}e.debounce=a;function I(D,P,w){return E((y,T)=>{const S=`$throttle$timer$${T}`,v=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...p){if(this[v]||(this[v]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...p)),this[f])return;const u=this[b]+D;u<=Date.now()?(this[b]=Date.now(),y.apply(this,[this[v]]),this[v]=w?w():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),y.apply(this,[this[v]]),this[v]=w?w():void 0},u-Date.now()))}})}e.throttle=I}),define(ve[9],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?C.isErrorNoTelemetry(r)?new C(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(n=>{n(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=E,e.errorHandler=new E;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function a(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=a;function I(t){y(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=I;function D(t){y(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function P(t){if(t instanceof Error){const{name:r,message:n}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:r,message:n,stack:i,noTelemetry:C.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const w="Canceled";function y(t){return t instanceof T?!0:t instanceof Error&&t.name===w&&t.message===w}e.isCancellationError=y;class T extends Error{constructor(){super(w),this.name=this.message}}e.CancellationError=T;function S(){const t=new Error(w);return t.name=t.message,t}e.canceled=S;function v(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=v;function b(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=b;function f(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function p(t){const r=new Error(`${t} has been disposed`);return r.name="DISPOSED",r}e.disposed=p;function u(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=u;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class m extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=m;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class C extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof C)return r;const n=new C;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype);debugger}}e.BugIndicatingError=k}),define(ve[18],Ee([1,0,9]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(W,K=0){return W[W.length-(1+K)]}e.tail=A;function a(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=a;function I(W,K,_=(V,Q)=>V===Q){if(W===K)return!0;if(!W||!K||W.length!==K.length)return!1;for(let V=0,Q=W.length;V<Q;V++)if(!_(W[V],K[V]))return!1;return!0}e.equals=I;function D(W,K){const _=W.length-1;K<_&&(W[K]=W[_]),W.pop()}e.removeFastWithoutKeepingOrder=D;function P(W,K,_){return w(W.length,V=>_(W[V],K))}e.binarySearch=P;function w(W,K){let _=0,V=W-1;for(;_<=V;){const Q=(_+V)/2|0,G=K(Q);if(G<0)_=Q+1;else if(G>0)V=Q-1;else return Q}return-(_+1)}e.binarySearch2=w;function y(W,K){let _=0,V=W.length;if(V===0)return 0;for(;_<V;){const Q=Math.floor((_+V)/2);K(W[Q])?V=Q:_=Q+1}return _}e.findFirstInSorted=y;function T(W,K,_){if(W=W|0,W>=K.length)throw new TypeError("invalid index");const V=K[Math.floor(K.length*Math.random())],Q=[],G=[],X=[];for(const ce of K){const pe=_(ce,V);pe<0?Q.push(ce):pe>0?G.push(ce):X.push(ce)}return W<Q.length?T(W,Q,_):W<Q.length+X.length?X[0]:T(W-(Q.length+X.length),G,_)}e.quickSelect=T;function S(W,K){const _=[];let V;for(const Q of W.slice(0).sort(K))!V||K(V[0],Q)!==0?(V=[Q],_.push(V)):V.push(Q);return _}e.groupBy=S;function v(W,K,_){const V=[];function Q(ce,pe,Pe){if(pe===0&&Pe.length===0)return;const Ae=V[V.length-1];Ae&&Ae.start+Ae.deleteCount===ce?(Ae.deleteCount+=pe,Ae.toInsert.push(...Pe)):V.push({start:ce,deleteCount:pe,toInsert:Pe})}let G=0,X=0;for(;;){if(G===W.length){Q(G,0,K.slice(X));break}if(X===K.length){Q(G,W.length-G,[]);break}const ce=W[G],pe=K[X],Pe=_(ce,pe);Pe===0?(G+=1,X+=1):Pe<0?(Q(G,1,[]),G+=1):Pe>0&&(Q(G,0,[pe]),X+=1)}return V}e.sortedDiff=v;function b(W,K,_){const V=v(W,K,_),Q=[],G=[];for(const X of V)Q.push(...W.slice(X.start,X.start+X.deleteCount)),G.push(...X.toInsert);return{removed:Q,added:G}}e.delta=b;function f(W,K,_){if(_===0)return[];const V=W.slice(0,_).sort(K);return u(W,K,V,_,W.length),V}e.top=f;function p(W,K,_,V,Q){return _===0?Promise.resolve([]):new Promise((G,X)=>{(async()=>{const ce=W.length,pe=W.slice(0,_).sort(K);for(let Pe=_,Ae=Math.min(_+V,ce);Pe<ce;Pe=Ae,Ae=Math.min(Ae+V,ce)){if(Pe>_&&await new Promise(Ne=>setTimeout(Ne)),Q&&Q.isCancellationRequested)throw new E.CancellationError;u(W,K,pe,Pe,Ae)}return pe})().then(G,X)})}e.topAsync=p;function u(W,K,_,V,Q){for(const G=_.length;V<Q;V++){const X=W[V];if(K(X,_[G-1])<0){_.pop();const ce=y(_,pe=>K(X,pe)<0);_.splice(ce,0,X)}}}function h(W){return W.filter(K=>!!K)}e.coalesce=h;function m(W){let K=0;for(let _=0;_<W.length;_++)W[_]&&(W[K]=W[_],K+=1);W.length=K}e.coalesceInPlace=m;function d(W,K,_){W.splice(_,0,W.splice(K,1)[0])}e.move=d;function C(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=C;function k(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=k;function t(W,K=_=>_){const _=new Set;return W.filter(V=>{const Q=K(V);return _.has(Q)?!1:(_.add(Q),!0)})}e.distinct=t;function r(W){const K=new Set;return _=>{const V=W(_);return K.has(V)?!1:(K.add(V),!0)}}e.uniqueFilter=r;function n(W,K){const _=i(W,K);if(_!==-1)return W[_]}e.findLast=n;function i(W,K){for(let _=W.length-1;_>=0;_--){const V=W[_];if(K(V))return _}return-1}e.lastIndex=i;function o(W,K){return W.length>0?W[0]:K}e.firstOrDefault=o;function c(W,K){return W.length>0?W[W.length-1]:K}e.lastOrDefault=c;function l(W,K,_=(V,Q)=>V===Q){let V=0;for(let Q=0,G=Math.min(W.length,K.length);Q<G&&_(W[Q],K[Q]);Q++)V++;return V}e.commonPrefixLength=l;function s(W){return[].concat(...W)}e.flatten=s;function g(W,K){let _=typeof K=="number"?W:0;typeof K=="number"?_=W:(_=0,K=W);const V=[];if(_<=K)for(let Q=_;Q<K;Q++)V.push(Q);else for(let Q=_;Q>K;Q--)V.push(Q);return V}e.range=g;function R(W,K,_){return W.reduce((V,Q)=>(V[K(Q)]=_?_(Q):Q,V),Object.create(null))}e.index=R;function O(W,K){return W.push(K),()=>z(W,K)}e.insert=O;function z(W,K){const _=W.indexOf(K);if(_>-1)return W.splice(_,1),K}e.remove=z;function ie(W,K,_){const V=W.slice(0,K),Q=W.slice(K);return V.concat(_,Q)}e.arrayInsert=ie;function ee(W,K){let _;if(typeof K=="number"){let V=K;_=()=>{const Q=Math.sin(V++)*179426549;return Q-Math.floor(Q)}}else _=Math.random;for(let V=W.length-1;V>0;V-=1){const Q=Math.floor(_()*(V+1)),G=W[V];W[V]=W[Q],W[Q]=G}}e.shuffle=ee;function F(W,K){const _=W.indexOf(K);_>-1&&(W.splice(_,1),W.unshift(K))}e.pushToStart=F;function Z(W,K){const _=W.indexOf(K);_>-1&&(W.splice(_,1),W.push(K))}e.pushToEnd=Z;function $(W,K){for(const _ of K)W.push(_)}e.pushMany=$;function x(W,K){return Array.isArray(W)?W.map(K):K(W)}e.mapArrayOrNot=x;function le(W){return Array.isArray(W)?W:[W]}e.asArray=le;function be(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=be;function Y(W,K){for(const _ of W){const V=K(_);if(V!==void 0)return V}}e.mapFind=Y;function H(W,K,_){const V=ne(W,K),Q=W.length,G=_.length;W.length=Q+G;for(let X=Q-1;X>=V;X--)W[X+G]=W[X];for(let X=0;X<G;X++)W[X+V]=_[X]}e.insertInto=H;function U(W,K,_,V){const Q=ne(W,K),G=W.splice(Q,_);return H(W,Q,V),G}e.splice=U;function ne(W,K){return K<0?Math.max(K+W.length,0):Math.min(K,W.length)}var se;(function(W){function K(Q){return Q<0}W.isLessThan=K;function _(Q){return Q>0}W.isGreaterThan=_;function V(Q){return Q===0}W.isNeitherLessOrGreaterThan=V,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(se=e.CompareResult||(e.CompareResult={}));function de(W,K){return(_,V)=>K(W(_),W(V))}e.compareBy=de;function re(...W){return(K,_)=>{for(const V of W){const Q=V(K,_);if(!se.isNeitherLessOrGreaterThan(Q))return Q}return se.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const j=(W,K)=>W-K;e.numberComparator=j;function N(W,K){if(W.length===0)return;let _=W[0];for(let V=1;V<W.length;V++){const Q=W[V];K(Q,_)>0&&(_=Q)}return _}e.findMaxBy=N;function M(W,K){if(W.length===0)return;let _=W[0];for(let V=1;V<W.length;V++){const Q=W[V];K(Q,_)>=0&&(_=Q)}return _}e.findLastMaxBy=M;function q(W,K){return N(W,(_,V)=>-K(_,V))}e.findMinBy=q;class te{constructor(K){this.f=K,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(K){let _=this.c;for(;_<this.f.length&&K(this.f[_]);)_++;const V=_===this.c?null:this.f.slice(this.c,_);return this.c=_,V}takeFromEndWhile(K){let _=this.d;for(;_>=0&&K(this.f[_]);)_--;const V=_===this.d?null:this.f.slice(_+1,this.d+1);return this.d=_,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const K=this.f[this.c];return this.c++,K}removeLast(){const K=this.f[this.d];return this.d--,K}takeCount(K){const _=this.f.slice(this.c,this.c+K);return this.c+=K,_}}e.ArrayQueue=te;class ue{constructor(K){this.iterate=K}forEach(K){this.iterate(_=>(K(_),!0))}toArray(){const K=[];return this.iterate(_=>(K.push(_),!0)),K}filter(K){return new ue(_=>this.iterate(V=>K(V)?_(V):!0))}map(K){return new ue(_=>this.iterate(V=>_(K(V))))}some(K){let _=!1;return this.iterate(V=>(_=K(V),!_)),_}findFirst(K){let _;return this.iterate(V=>K(V)?(_=V,!1):!0),_}findLast(K){let _;return this.iterate(V=>(K(V)&&(_=V),!0)),_}findLastMaxBy(K){let _,V=!0;return this.iterate(Q=>((V||se.isGreaterThan(K(Q,_)))&&(V=!1,_=Q),!0)),_}}ue.empty=new ue(W=>{}),e.CallbackIterable=ue}),define(ve[87],Ee([1,0,9]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(w,y){if(!w)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=A;function a(w,y="Unreachable"){throw new Error(y)}e.assertNever=a;function I(w){if(!w)throw new E.BugIndicatingError("Assertion Failed")}e.assert=I;function D(w){if(!w()){debugger;w(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(w,y){let T=0;for(;T<w.length-1;){const S=w[T],v=w[T+1];if(!y(S,v))return!1;T++}return!0}e.checkAdjacentItems=P}),define(ve[69],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(A){const a=this;let I=!1,D;return function(){return I||(I=!0,D=A.apply(a,arguments)),D}}e.once=E}),define(ve[55],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(A){function a(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}A.is=a;const I=Object.freeze([]);function D(){return I}A.empty=D;function*P(C){yield C}A.single=P;function w(C){return a(C)?C:P(C)}A.wrap=w;function y(C){return C||I}A.from=y;function T(C){return!C||C[Symbol.iterator]().next().done===!0}A.isEmpty=T;function S(C){return C[Symbol.iterator]().next().value}A.first=S;function v(C,k){for(const t of C)if(k(t))return!0;return!1}A.some=v;function b(C,k){for(const t of C)if(k(t))return t}A.find=b;function*f(C,k){for(const t of C)k(t)&&(yield t)}A.filter=f;function*p(C,k){let t=0;for(const r of C)yield k(r,t++)}A.map=p;function*u(...C){for(const k of C)for(const t of k)yield t}A.concat=u;function h(C,k,t){let r=t;for(const n of C)r=k(r,n);return r}A.reduce=h;function*m(C,k,t=C.length){for(k<0&&(k+=C.length),t<0?t+=C.length:t>C.length&&(t=C.length);k<t;k++)yield C[k]}A.slice=m;function d(C,k=Number.POSITIVE_INFINITY){const t=[];if(k===0)return[t,C];const r=C[Symbol.iterator]();for(let n=0;n<k;n++){const i=r.next();if(i.done)return[t,A.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return r}}]}A.consume=d})(E=e.Iterable||(e.Iterable={}))}),define(ve[70],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var a;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(a=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function D(t,r=!1){let n=0;const i=t.length;let o="",c=0,l=16,s=0;function g(Z){let $=0,x=0;for(;$<Z;){const le=t.charCodeAt(n);if(le>=48&&le<=57)x=x*16+le-48;else if(le>=65&&le<=70)x=x*16+le-65+10;else if(le>=97&&le<=102)x=x*16+le-97+10;else break;n++,$++}return $<Z&&(x=-1),x}function R(Z){n=Z,o="",c=0,l=16,s=0}function O(){const Z=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&y(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&y(t.charCodeAt(n)))for(n++;n<t.length&&y(t.charCodeAt(n));)n++;else return s=3,t.substring(Z,n);let $=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&y(t.charCodeAt(n))){for(n++;n<t.length&&y(t.charCodeAt(n));)n++;$=n}else s=3;return t.substring(Z,$)}function z(){let Z="",$=n;for(;;){if(n>=i){Z+=t.substring($,n),s=2;break}const x=t.charCodeAt(n);if(x===34){Z+=t.substring($,n),n++;break}if(x===92){if(Z+=t.substring($,n),n++,n>=i){s=2;break}switch(t.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const be=g(4);be>=0?Z+=String.fromCharCode(be):s=4;break}default:s=5}$=n;continue}if(x>=0&&x<=31)if(w(x)){Z+=t.substring($,n),s=2;break}else s=6;n++}return Z}function ie(){if(o="",s=0,c=n,n>=i)return c=i,l=17;let Z=t.charCodeAt(n);if(P(Z)){do n++,o+=String.fromCharCode(Z),Z=t.charCodeAt(n);while(P(Z));return l=15}if(w(Z))return n++,o+=String.fromCharCode(Z),Z===13&&t.charCodeAt(n)===10&&(n++,o+=`
`),l=14;switch(Z){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,o=z(),l=10;case 47:{const $=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!w(t.charCodeAt(n));)n++;return o=t.substring($,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const x=i-1;let le=!1;for(;n<x;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,le=!0;break}n++}return le||(n++,s=1),o=t.substring($,n),l=13}return o+=String.fromCharCode(Z),n++,l=16}case 45:if(o+=String.fromCharCode(Z),n++,n===i||!y(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),l=11;default:for(;n<i&&ee(Z);)n++,Z=t.charCodeAt(n);if(c!==n){switch(o=t.substring(c,n),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(Z),n++,l=16}}function ee(Z){if(P(Z)||w(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let Z;do Z=ie();while(Z>=12&&Z<=15);return Z}return{setPosition:R,getPosition:()=>n,scan:r?F:ie,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>s}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function S(t,r){const n=[],i=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function s(g,R,O,z){c.value=g,c.offset=R,c.length=O,c.type=z,c.colonOffset=void 0,o=c}try{d(t,{onObjectBegin:(g,R)=>{if(r<=g)throw i;o=void 0,l=r>g,n.push("")},onObjectProperty:(g,R,O)=>{if(r<R||(s(g,R,O,"property"),n[n.length-1]=g,r<=R+O))throw i},onObjectEnd:(g,R)=>{if(r<=g)throw i;o=void 0,n.pop()},onArrayBegin:(g,R)=>{if(r<=g)throw i;o=void 0,n.push(0)},onArrayEnd:(g,R)=>{if(r<=g)throw i;o=void 0,n.pop()},onLiteralValue:(g,R,O)=>{if(r<R||(s(g,R,O,k(g)),r<=R+O))throw i},onSeparator:(g,R,O)=>{if(r<=R)throw i;if(g===":"&&o&&o.type==="property")o.colonOffset=R,l=!1,o=void 0;else if(g===","){const z=n[n.length-1];typeof z=="number"?n[n.length-1]=z+1:(l=!0,n[n.length-1]=""),o=void 0}}})}catch(g){if(g!==i)throw g}return{path:n,previousNode:o,isAtPropertyKey:l,matches:g=>{let R=0;for(let O=0;R<g.length&&O<n.length;O++)if(g[R]===n[O]||g[R]==="*")R++;else if(g[R]!=="**")return!1;return R===g.length}}}e.getLocation=S;function v(t,r=[],n=I.DEFAULT){let i=null,o=[];const c=[];function l(g){Array.isArray(o)?o.push(g):i!==null&&(o[i]=g)}return d(t,{onObjectBegin:()=>{const g={};l(g),c.push(o),o=g,i=null},onObjectProperty:g=>{i=g},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const g=[];l(g),c.push(o),o=g,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:l,onError:(g,R,O)=>{r.push({error:g,offset:R,length:O})}},n),o[0]}e.parse=v;function b(t,r=[],n=I.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){i.type==="property"&&(i.length=g-i.offset,i=i.parent)}function c(g){return i.children.push(g),g}d(t,{onObjectBegin:g=>{i=c({type:"object",offset:g,length:-1,parent:i,children:[]})},onObjectProperty:(g,R,O)=>{i=c({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:g,offset:R,length:O,parent:i})},onObjectEnd:(g,R)=>{i.length=g+R-i.offset,i=i.parent,o(g+R)},onArrayBegin:(g,R)=>{i=c({type:"array",offset:g,length:-1,parent:i,children:[]})},onArrayEnd:(g,R)=>{i.length=g+R-i.offset,i=i.parent,o(g+R)},onLiteralValue:(g,R,O)=>{c({type:k(g),offset:R,length:O,parent:i,value:g}),o(R+O)},onSeparator:(g,R,O)=>{i.type==="property"&&(g===":"?i.colonOffset=R:g===","&&o(R))},onError:(g,R,O)=>{r.push({error:g,offset:R,length:O})}},n);const s=i.children[0];return s&&delete s.parent,s}e.parseTree=b;function f(t,r){if(!t)return;let n=t;for(const i of r)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===i){n=c.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=f;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=p;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const r=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(r[n.children[0].value]=u(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function h(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=h;function m(t,r,n=!1){if(h(t,r,n)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const c=m(i[o],r,n);if(c)return c}return t}}e.findNodeAtOffset=m;function d(t,r,n=I.DEFAULT){const i=D(t,!1);function o(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(de){return de?re=>de(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=o(r.onObjectBegin),s=c(r.onObjectProperty),g=o(r.onObjectEnd),R=o(r.onArrayBegin),O=o(r.onArrayEnd),z=c(r.onLiteralValue),ie=c(r.onSeparator),ee=o(r.onComment),F=c(r.onError),Z=n&&n.disallowComments,$=n&&n.allowTrailingComma;function x(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:Z||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(de){case 12:case 13:Z?le(10):ee();break;case 16:le(1);break;case 15:case 14:break;default:return de}}}function le(de,re=[],j=[]){if(F(de),re.length+j.length>0){let N=i.getToken();for(;N!==17;){if(re.indexOf(N)!==-1){x();break}else if(j.indexOf(N)!==-1)break;N=x()}}}function be(de){const re=i.getTokenValue();return de?z(re):s(re),x(),!0}function Y(){switch(i.getToken()){case 11:{let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(le(2),de=0)}catch{le(2)}z(de);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return x(),!0}function H(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(be(!1),i.getToken()===6?(ie(":"),x(),se()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function U(){l(),x();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||le(4,[],[]),ie(","),x(),i.getToken()===2&&$)break}else de&&le(6,[],[]);H()||le(4,[],[2,5]),de=!0}return g(),i.getToken()!==2?le(7,[2],[]):x(),!0}function ne(){R(),x();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||le(4,[],[]),ie(","),x(),i.getToken()===4&&$)break}else de&&le(6,[],[]);se()||le(4,[],[4,5]),de=!0}return O(),i.getToken()!==4?le(8,[4],[]):x(),!0}function se(){switch(i.getToken()){case 3:return ne();case 1:return U();case 10:return be(!0);default:return Y()}}return x(),i.getToken()===17?n.allowEmptyContent?!0:(le(4,[],[]),!1):se()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=d;function C(t,r){const n=D(t),i=[];let o,c=0,l;do switch(l=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:c!==l&&i.push(t.substring(c,l)),r!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,r)),c=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=C;function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(ve[141],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(a){this.d=a,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(a){this.c=a}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(ve[2],Ee([1,0,69,55]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const a=!1;let I=null;function D(c){I=c}if(e.setDisposableTracker=D,a){const c="__is_disposable_tracked__";D(new class{trackDisposable(l){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[c]||console.log(s)},3e3)}setParent(l,s){if(l&&l!==m.None)try{l[c]=!0}catch{}}markAsDisposed(l){if(l&&l!==m.None)try{l[c]=!0}catch{}}markAsSingleton(l){}})}function P(c){return I?.trackDisposable(c),c}function w(c){I?.markAsDisposed(c)}function y(c,l){I?.setParent(c,l)}function T(c,l){if(!!I)for(const s of c)I.setParent(s,l)}function S(c){return I?.markAsSingleton(c),c}e.markAsSingleton=S;function v(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=v;function b(c){if(A.Iterable.is(c)){const l=[];for(const s of c)if(s)try{s.dispose()}catch(g){l.push(g)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=b;function f(c){for(const l of c)v(l)&&l.dispose();return[]}e.disposeIfDisposable=f;function p(...c){const l=u(()=>b(c));return T(c,l),l}e.combinedDisposable=p;function u(c){const l=P({dispose:(0,E.once)(()=>{w(l),c()})});return l}e.toDisposable=u;class h{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{b(this.c)}finally{this.c.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return y(l,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(l),l}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class m{constructor(){this.q=new h,P(this),y(this.q,this)}dispose(){w(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class d{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&y(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&y(l,null),l}}e.MutableDisposable=d;class C{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=C;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(l){let s=l;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,w(this))},this}}e.SafeDisposable=k;class t{constructor(){this.a=new Map}acquire(l,...s){let g=this.a.get(l);g||(g={counter:0,object:this.b(l,...s)},this.a.set(l,g));const{object:R}=g,O=(0,E.once)(()=>{--g.counter===0&&(this.c(l,g.object),this.a.delete(l))});return g.counter++,{object:R,dispose:O}}}e.ReferenceCollection=t;class r{constructor(l){this.a=l}async acquire(l,...s){const g=this.a.acquire(l,...s);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(R){throw g.dispose(),R}}}e.AsyncReferenceCollection=r;class n{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=n;function i(c){const l=new h;try{c(l)}finally{l.dispose()}}e.disposeOnReturn=i;class o{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get(l){return this.a.get(l)}set(l,s,g=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this.a.get(l)?.dispose(),this.a.set(l,s)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ve[88],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(I){this.element=I,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class A{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let I=this.a;for(;I!==E.Undefined;){const D=I.next;I.prev=E.Undefined,I.next=E.Undefined,I=D}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,D){const P=new E(I);if(this.a===E.Undefined)this.a=P,this.b=P;else if(D){const y=this.b;this.b=P,P.prev=y,y.next=P}else{const y=this.a;this.a=P,P.next=y,y.prev=P}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==E.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==E.Undefined&&I.next!==E.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===E.Undefined&&I.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):I.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):I.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==E.Undefined;)yield I.element,I=I.next}}e.LinkedList=A}),define(ve[27],Ee([1,0]),function(ae,e){"use strict";var E,A,a;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function I(f,p,u){let h=f.get(p);return h===void 0&&(h=u,f.set(p,h)),h}e.getOrSet=I;function D(f){const p=[];return f.forEach((u,h)=>{p.push(`${h} => ${u}`)}),`Map(${f.size}) {${p.join(", ")}}`}e.mapToString=D;function P(f){const p=[];return f.forEach(u=>{p.push(u)}),`Set(${f.size}) {${p.join(", ")}}`}e.setToString=P;class w{constructor(p,u){this.uri=p,this.value=u}}class y{constructor(p,u){this[E]="ResourceMap",p instanceof y?(this.b=new Map(p.b),this.c=u??y.a):(this.b=new Map,this.c=p??y.a)}set(p,u){return this.b.set(this.c(p),new w(p,u)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,u){typeof u<"u"&&(p=p.bind(u));for(const[h,m]of this.b)p(m.value,m.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}y.a=f=>f.toString(),e.ResourceMap=y;class T{constructor(p,u){this[A]="ResourceSet",!p||typeof p=="function"?this.a=new y(p):(this.a=new y(u),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,u){this.a.forEach((h,m)=>p.call(u,m,m,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var S;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class v{constructor(){this[a]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,u=0){const h=this.a.get(p);if(!!h)return u!==0&&this.j(h,u),h.value}set(p,u,h=0){let m=this.a.get(p);if(m)m.value=u,h!==0&&this.j(m,h);else{switch(m={key:p,value:u,next:void 0,previous:void 0},h){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(p,m),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const u=this.a.get(p);if(!!u)return this.a.delete(p),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,u){const h=this.e;let m=this.b;for(;m;){if(u?p.bind(u)(m.value,m.key,this):p(m.value,m.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const p=this,u=this.e;let h=this.b;const m={[Symbol.iterator](){return m},next(){if(p.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.key,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return m}values(){const p=this,u=this.e;let h=this.b;const m={[Symbol.iterator](){return m},next(){if(p.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.value,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return m}entries(){const p=this,u=this.e;let h=this.b;const m={[Symbol.iterator](){return m},next(){if(p.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:[h.key,h.value],done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return m}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>p;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const u=p.next,h=p.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}p.next=void 0,p.previous=void 0,this.e++}j(p,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(p===this.b)return;const h=p.next,m=p.previous;p===this.c?(m.next=void 0,this.c=m):(h.previous=m,m.next=h),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(u===2){if(p===this.c)return;const h=p.next,m=p.previous;p===this.b?(h.previous=void 0,this.b=h):(h.previous=m,m.next=h),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((u,h)=>{p.push([h,u])}),p}fromJSON(p){this.clear();for(const[u,h]of p)this.set(u,h)}}e.LinkedMap=v;class b extends v{constructor(p,u=1){super(),this.k=p,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,u=2){return super.get(p,u)}peek(p){return super.get(p,0)}set(p,u){return super.set(p,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(ae,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ve[142],Ee([0]),e):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(W,K){for(var _=0;_<K.length;_++){var V=K[_];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(W,V.key,V)}}function E(W,K,_){return K&&e(W.prototype,K),_&&e(W,_),Object.defineProperty(W,"prototype",{writable:!1}),W}function A(W,K){if(!!W){if(typeof W=="string")return a(W,K);var _=Object.prototype.toString.call(W).slice(8,-1);if(_==="Object"&&W.constructor&&(_=W.constructor.name),_==="Map"||_==="Set")return Array.from(W);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return a(W,K)}}function a(W,K){(K==null||K>W.length)&&(K=W.length);for(var _=0,V=new Array(K);_<K;_++)V[_]=W[_];return V}function I(W,K){var _=typeof Symbol<"u"&&W[Symbol.iterator]||W["@@iterator"];if(_)return(_=_.call(W)).next.bind(_);if(Array.isArray(W)||(_=A(W))||K&&W&&typeof W.length=="number"){_&&(W=_);var V=0;return function(){return V>=W.length?{done:!0}:{done:!1,value:W[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=D();function P(W){ae.defaults=W}var w=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(K){return v[K]};function f(W,K){if(K){if(w.test(W))return W.replace(y,b)}else if(T.test(W))return W.replace(S,b);return W}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(W){return W.replace(p,function(K,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var h=/(^|[^\[])\^/g;function m(W,K){W=typeof W=="string"?W:W.source,K=K||"";var _={replace:function(Q,G){return G=G.source||G,G=G.replace(h,"$1"),W=W.replace(Q,G),_},getRegex:function(){return new RegExp(W,K)}};return _}var d=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(W,K,_){if(W){var V;try{V=decodeURIComponent(u(_)).replace(d,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}K&&!C.test(_)&&(_=o(K,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var t={},r=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(W,K){t[" "+W]||(r.test(W)?t[" "+W]=W+"/":t[" "+W]=g(W,"/",!0)),W=t[" "+W];var _=W.indexOf(":")===-1;return K.substring(0,2)==="//"?_?K:W.replace(n,"$1")+K:K.charAt(0)==="/"?_?K:W.replace(i,"$1")+K:W+K}var c={exec:function(){}};function l(W){for(var K=1,_,V;K<arguments.length;K++){_=arguments[K];for(V in _)Object.prototype.hasOwnProperty.call(_,V)&&(W[V]=_[V])}return W}function s(W,K){var _=W.replace(/\|/g,function(G,X,ce){for(var pe=!1,Pe=X;--Pe>=0&&ce[Pe]==="\\";)pe=!pe;return pe?"|":" |"}),V=_.split(/ \|/),Q=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>K)V.splice(K);else for(;V.length<K;)V.push("");for(;Q<V.length;Q++)V[Q]=V[Q].trim().replace(/\\\|/g,"|");return V}function g(W,K,_){var V=W.length;if(V===0)return"";for(var Q=0;Q<V;){var G=W.charAt(V-Q-1);if(G===K&&!_)Q++;else if(G!==K&&_)Q++;else break}return W.slice(0,V-Q)}function R(W,K){if(W.indexOf(K[1])===-1)return-1;for(var _=W.length,V=0,Q=0;Q<_;Q++)if(W[Q]==="\\")Q++;else if(W[Q]===K[0])V++;else if(W[Q]===K[1]&&(V--,V<0))return Q;return-1}function O(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(W,K){if(K<1)return"";for(var _="";K>1;)K&1&&(_+=W),K>>=1,W+=W;return _+W}function ie(W,K,_,V){var Q=K.href,G=K.title?f(K.title):null,X=W[1].replace(/\\([\[\]])/g,"$1");if(W[0].charAt(0)!=="!"){V.state.inLink=!0;var ce={type:"link",raw:_,href:Q,title:G,text:X,tokens:V.inlineTokens(X)};return V.state.inLink=!1,ce}return{type:"image",raw:_,href:Q,title:G,text:f(X)}}function ee(W,K){var _=W.match(/^(\s+)(?:```)/);if(_===null)return K;var V=_[1];return K.split(`
`).map(function(Q){var G=Q.match(/^\s+/);if(G===null)return Q;var X=G[0];return X.length>=V.length?Q.slice(V.length):Q}).join(`
`)}var F=function(){function W(_){this.options=_||ae.defaults}var K=W.prototype;return K.space=function(V){var Q=this.rules.block.newline.exec(V);if(Q&&Q[0].length>0)return{type:"space",raw:Q[0]}},K.code=function(V){var Q=this.rules.block.code.exec(V);if(Q){var G=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?G:g(G,`
`)}}},K.fences=function(V){var Q=this.rules.block.fences.exec(V);if(Q){var G=Q[0],X=ee(G,Q[3]||"");return{type:"code",raw:G,lang:Q[2]?Q[2].trim():Q[2],text:X}}},K.heading=function(V){var Q=this.rules.block.heading.exec(V);if(Q){var G=Q[2].trim();if(/#$/.test(G)){var X=g(G,"#");(this.options.pedantic||!X||/ $/.test(X))&&(G=X.trim())}return{type:"heading",raw:Q[0],depth:Q[1].length,text:G,tokens:this.lexer.inline(G)}}},K.hr=function(V){var Q=this.rules.block.hr.exec(V);if(Q)return{type:"hr",raw:Q[0]}},K.blockquote=function(V){var Q=this.rules.block.blockquote.exec(V);if(Q){var G=Q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Q[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},K.list=function(V){var Q=this.rules.block.list.exec(V);if(Q){var G,X,ce,pe,Pe,Ae,Ne,$e,me,we,ye,Me,je=Q[1].trim(),Ge=je.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+je.slice(0,-1):"",loose:!1,items:[]};je=Ge?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ge?je:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(Me=!1,!(!(Q=Ke.exec(V))||this.rules.block.hr.test(V)));){if(G=Q[0],V=V.substring(G.length),$e=Q[2].split(`
`,1)[0],me=V.split(`
`,1)[0],this.options.pedantic?(pe=2,ye=$e.trimLeft()):(pe=Q[2].search(/[^ ]/),pe=pe>4?1:pe,ye=$e.slice(pe),pe+=Q[1].length),Ae=!1,!$e&&/^ *$/.test(me)&&(G+=me+`
`,V=V.substring(me.length+1),Me=!0),!Me)for(var Xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");V&&(we=V.split(`
`,1)[0],$e=we,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test($e)||xe.test($e)||Xe.test($e)||it.test(V)));){if($e.search(/[^ ]/)>=pe||!$e.trim())ye+=`
`+$e.slice(pe);else if(!Ae)ye+=`
`+$e;else break;!Ae&&!$e.trim()&&(Ae=!0),G+=we+`
`,V=V.substring(we.length+1)}He.loose||(Ne?He.loose=!0:/\n *\n *$/.test(G)&&(Ne=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(ye),X&&(ce=X[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:G,task:!!X,checked:ce,loose:!1,text:ye}),He.raw+=G}He.items[He.items.length-1].raw=G.trimRight(),He.items[He.items.length-1].text=ye.trimRight(),He.raw=He.raw.trimRight();var _e=He.items.length;for(Pe=0;Pe<_e;Pe++){this.lexer.state.top=!1,He.items[Pe].tokens=this.lexer.blockTokens(He.items[Pe].text,[]);var fe=He.items[Pe].tokens.filter(function(Ce){return Ce.type==="space"}),Ie=fe.every(function(Ce){for(var Te=Ce.raw.split(""),Be=0,ze=I(Te),Ve;!(Ve=ze()).done;){var nt=Ve.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&fe.length&&Ie&&(He.loose=!0,He.items[Pe].loose=!0)}return He}},K.html=function(V){var Q=this.rules.block.html.exec(V);if(Q){var G={type:"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:Q[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]);G.type="paragraph",G.text=X,G.tokens=this.lexer.inline(X)}return G}},K.def=function(V){var Q=this.rules.block.def.exec(V);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var G=Q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:Q[0],href:Q[2],title:Q[3]}}},K.table=function(V){var Q=this.rules.block.table.exec(V);if(Q){var G={type:"table",header:s(Q[1]).map(function(Ne){return{text:Ne}}),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Q[3]&&Q[3].trim()?Q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=Q[0];var X=G.align.length,ce,pe,Pe,Ae;for(ce=0;ce<X;ce++)/^ *-+: *$/.test(G.align[ce])?G.align[ce]="right":/^ *:-+: *$/.test(G.align[ce])?G.align[ce]="center":/^ *:-+ *$/.test(G.align[ce])?G.align[ce]="left":G.align[ce]=null;for(X=G.rows.length,ce=0;ce<X;ce++)G.rows[ce]=s(G.rows[ce],G.header.length).map(function(Ne){return{text:Ne}});for(X=G.header.length,pe=0;pe<X;pe++)G.header[pe].tokens=this.lexer.inline(G.header[pe].text);for(X=G.rows.length,pe=0;pe<X;pe++)for(Ae=G.rows[pe],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=this.lexer.inline(Ae[Pe].text);return G}}},K.lheading=function(V){var Q=this.rules.block.lheading.exec(V);if(Q)return{type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1],tokens:this.lexer.inline(Q[1])}},K.paragraph=function(V){var Q=this.rules.block.paragraph.exec(V);if(Q){var G=Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1];return{type:"paragraph",raw:Q[0],text:G,tokens:this.lexer.inline(G)}}},K.text=function(V){var Q=this.rules.block.text.exec(V);if(Q)return{type:"text",raw:Q[0],text:Q[0],tokens:this.lexer.inline(Q[0])}},K.escape=function(V){var Q=this.rules.inline.escape.exec(V);if(Q)return{type:"escape",raw:Q[0],text:f(Q[1])}},K.tag=function(V){var Q=this.rules.inline.tag.exec(V);if(Q)return!this.lexer.state.inLink&&/^<a /i.test(Q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]):Q[0]}},K.link=function(V){var Q=this.rules.inline.link.exec(V);if(Q){var G=Q[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var X=g(G.slice(0,-1),"\\");if((G.length-X.length)%2===0)return}else{var ce=R(Q[2],"()");if(ce>-1){var pe=Q[0].indexOf("!")===0?5:4,Pe=pe+Q[1].length+ce;Q[2]=Q[2].substring(0,ce),Q[0]=Q[0].substring(0,Pe).trim(),Q[3]=""}}var Ae=Q[2],Ne="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);$e&&(Ae=$e[1],Ne=$e[3])}else Ne=Q[3]?Q[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(G)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),ie(Q,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},Q[0],this.lexer)}},K.reflink=function(V,Q){var G;if((G=this.rules.inline.reflink.exec(V))||(G=this.rules.inline.nolink.exec(V))){var X=(G[2]||G[1]).replace(/\s+/g," ");if(X=Q[X.toLowerCase()],!X||!X.href){var ce=G[0].charAt(0);return{type:"text",raw:ce,text:ce}}return ie(G,X,G[0],this.lexer)}},K.emStrong=function(V,Q,G){G===void 0&&(G="");var X=this.rules.inline.emStrong.lDelim.exec(V);if(!!X&&!(X[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=X[1]||X[2]||"";if(!ce||ce&&(G===""||this.rules.inline.punctuation.exec(G))){var pe=X[0].length-1,Pe,Ae,Ne=pe,$e=0,me=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,Q=Q.slice(-1*V.length+pe);(X=me.exec(Q))!=null;)if(Pe=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!Pe){if(Ae=Pe.length,X[3]||X[4]){Ne+=Ae;continue}else if((X[5]||X[6])&&pe%3&&!((pe+Ae)%3)){$e+=Ae;continue}if(Ne-=Ae,!(Ne>0)){if(Ae=Math.min(Ae,Ae+Ne+$e),Math.min(pe,Ae)%2){var we=V.slice(1,pe+X.index+Ae);return{type:"em",raw:V.slice(0,pe+X.index+Ae+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ye=V.slice(2,pe+X.index+Ae-1);return{type:"strong",raw:V.slice(0,pe+X.index+Ae+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},K.codespan=function(V){var Q=this.rules.inline.code.exec(V);if(Q){var G=Q[2].replace(/\n/g," "),X=/[^ ]/.test(G),ce=/^ /.test(G)&&/ $/.test(G);return X&&ce&&(G=G.substring(1,G.length-1)),G=f(G,!0),{type:"codespan",raw:Q[0],text:G}}},K.br=function(V){var Q=this.rules.inline.br.exec(V);if(Q)return{type:"br",raw:Q[0]}},K.del=function(V){var Q=this.rules.inline.del.exec(V);if(Q)return{type:"del",raw:Q[0],text:Q[2],tokens:this.lexer.inlineTokens(Q[2])}},K.autolink=function(V,Q){var G=this.rules.inline.autolink.exec(V);if(G){var X,ce;return G[2]==="@"?(X=f(this.options.mangle?Q(G[1]):G[1]),ce="mailto:"+X):(X=f(G[1]),ce=X),{type:"link",raw:G[0],text:X,href:ce,tokens:[{type:"text",raw:X,text:X}]}}},K.url=function(V,Q){var G;if(G=this.rules.inline.url.exec(V)){var X,ce;if(G[2]==="@")X=f(this.options.mangle?Q(G[0]):G[0]),ce="mailto:"+X;else{var pe;do pe=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(pe!==G[0]);X=f(G[0]),G[1]==="www."?ce="http://"+X:ce=X}return{type:"link",raw:G[0],text:X,href:ce,tokens:[{type:"text",raw:X,text:X}]}}},K.inlineText=function(V,Q){var G=this.rules.inline.text.exec(V);if(G){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):f(G[0]):G[0]:X=f(this.options.smartypants?Q(G[0]):G[0]),{type:"text",raw:G[0],text:X}}},W}(),Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=m(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.listItemStart=m(/^( *)(bull) */).replace("bull",Z.bullet).getRegex(),Z.list=m(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=m(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=m(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=m(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=l({},Z),Z.gfm=l({},Z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.table=m(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.gfm.paragraph=m(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=l({},Z.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:m(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=m($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=m(Z._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=m($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=m($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=m($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=m($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=m($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=m($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=m($.reflink).replace("label",$._label).replace("ref",Z._label).getRegex(),$.nolink=m($.nolink).replace("ref",Z._label).getRegex(),$.reflinkSearch=m($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=l({},$),$.pedantic=l({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=l({},$.normal,{escape:m($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=m($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=l({},$.gfm,{br:m($.br).replace("{2,}","*").getRegex(),text:m($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function le(W){var K="",_,V,Q=W.length;for(_=0;_<Q;_++)V=W.charCodeAt(_),Math.random()>.5&&(V="x"+V.toString(16)),K+="&#"+V+";";return K}var be=function(){function W(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||ae.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:Z.normal,inline:$.normal};this.options.pedantic?(V.block=Z.pedantic,V.inline=$.pedantic):this.options.gfm&&(V.block=Z.gfm,this.options.breaks?V.inline=$.breaks:V.inline=$.gfm),this.tokenizer.rules=V}W.lex=function(V,Q){var G=new W(Q);return G.lex(V)},W.lexInline=function(V,Q){var G=new W(Q);return G.inlineTokens(V)};var K=W.prototype;return K.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Q;Q=this.inlineQueue.shift();)this.inlineTokens(Q.src,Q.tokens);return this.tokens},K.blockTokens=function(V,Q){var G=this;Q===void 0&&(Q=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Ne,$e,me){return $e+"    ".repeat(me.length)});for(var X,ce,pe,Pe;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(X=Ne.call({lexer:G},V,Q))?(V=V.substring(X.raw.length),Q.push(X),!0):!1}))){if(X=this.tokenizer.space(V)){V=V.substring(X.raw.length),X.raw.length===1&&Q.length>0?Q[Q.length-1].raw+=`
`:Q.push(X);continue}if(X=this.tokenizer.code(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(X);continue}if(X=this.tokenizer.fences(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.heading(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.hr(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.blockquote(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.list(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.html(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.def(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.lheading(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(pe=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,$e=V.slice(1),me=void 0;G.options.extensions.startBlock.forEach(function(we){me=we.call({lexer:this},$e),typeof me=="number"&&me>=0&&(Ne=Math.min(Ne,me))}),Ne<1/0&&Ne>=0&&(pe=V.substring(0,Ne+1))}(),this.state.top&&(X=this.tokenizer.paragraph(pe))){ce=Q[Q.length-1],Pe&&ce.type==="paragraph"?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(X),Pe=pe.length!==V.length,V=V.substring(X.raw.length);continue}if(X=this.tokenizer.text(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(X);continue}if(V){var Ae="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Q},K.inline=function(V,Q){return Q===void 0&&(Q=[]),this.inlineQueue.push({src:V,tokens:Q}),Q},K.inlineTokens=function(V,Q){var G=this;Q===void 0&&(Q=[]);var X,ce,pe,Pe=V,Ae,Ne,$e;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)me.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+z("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+z("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Ne||($e=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(X=ye.call({lexer:G},V,Q))?(V=V.substring(X.raw.length),Q.push(X),!0):!1}))){if(X=this.tokenizer.escape(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.tag(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&X.type==="text"&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):Q.push(X);continue}if(X=this.tokenizer.link(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&X.type==="text"&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):Q.push(X);continue}if(X=this.tokenizer.emStrong(V,Pe,$e)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.codespan(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.br(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.del(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.autolink(V,le)){V=V.substring(X.raw.length),Q.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(V,le))){V=V.substring(X.raw.length),Q.push(X);continue}if(pe=V,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Me=V.slice(1),je=void 0;G.options.extensions.startInline.forEach(function(Ge){je=Ge.call({lexer:this},Me),typeof je=="number"&&je>=0&&(ye=Math.min(ye,je))}),ye<1/0&&ye>=0&&(pe=V.substring(0,ye+1))}(),X=this.tokenizer.inlineText(pe,x)){V=V.substring(X.raw.length),X.raw.slice(-1)!=="_"&&($e=X.raw.slice(-1)),Ne=!0,ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):Q.push(X);continue}if(V){var we="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return Q},E(W,null,[{key:"rules",get:function(){return{block:Z,inline:$}}}]),W}(),Y=function(){function W(_){this.options=_||ae.defaults}var K=W.prototype;return K.code=function(V,Q,G){var X=(Q||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(V,X);ce!=null&&ce!==V&&(G=!0,V=ce)}return V=V.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+f(X,!0)+'">'+(G?V:f(V,!0))+`</code></pre>
`:"<pre><code>"+(G?V:f(V,!0))+`</code></pre>
`},K.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},K.html=function(V){return V},K.heading=function(V,Q,G,X){if(this.options.headerIds){var ce=this.options.headerPrefix+X.slug(G);return"<h"+Q+' id="'+ce+'">'+V+"</h"+Q+`>
`}return"<h"+Q+">"+V+"</h"+Q+`>
`},K.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},K.list=function(V,Q,G){var X=Q?"ol":"ul",ce=Q&&G!==1?' start="'+G+'"':"";return"<"+X+ce+`>
`+V+"</"+X+`>
`},K.listitem=function(V){return"<li>"+V+`</li>
`},K.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},K.paragraph=function(V){return"<p>"+V+`</p>
`},K.table=function(V,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Q+`</table>
`},K.tablerow=function(V){return`<tr>
`+V+`</tr>
`},K.tablecell=function(V,Q){var G=Q.header?"th":"td",X=Q.align?"<"+G+' align="'+Q.align+'">':"<"+G+">";return X+V+("</"+G+`>
`)},K.strong=function(V){return"<strong>"+V+"</strong>"},K.em=function(V){return"<em>"+V+"</em>"},K.codespan=function(V){return"<code>"+V+"</code>"},K.br=function(){return this.options.xhtml?"<br/>":"<br>"},K.del=function(V){return"<del>"+V+"</del>"},K.link=function(V,Q,G){if(V=k(this.options.sanitize,this.options.baseUrl,V),V===null)return G;var X='<a href="'+f(V)+'"';return Q&&(X+=' title="'+Q+'"'),X+=">"+G+"</a>",X},K.image=function(V,Q,G){if(V=k(this.options.sanitize,this.options.baseUrl,V),V===null)return G;var X='<img src="'+V+'" alt="'+G+'"';return Q&&(X+=' title="'+Q+'"'),X+=this.options.xhtml?"/>":">",X},K.text=function(V){return V},W}(),H=function(){function W(){}var K=W.prototype;return K.strong=function(V){return V},K.em=function(V){return V},K.codespan=function(V){return V},K.del=function(V){return V},K.html=function(V){return V},K.text=function(V){return V},K.link=function(V,Q,G){return""+G},K.image=function(V,Q,G){return""+G},K.br=function(){return""},W}(),U=function(){function W(){this.seen={}}var K=W.prototype;return K.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},K.getNextSafeSlug=function(V,Q){var G=V,X=0;if(this.seen.hasOwnProperty(G)){X=this.seen[V];do X++,G=V+"-"+X;while(this.seen.hasOwnProperty(G))}return Q||(this.seen[V]=X,this.seen[G]=0),G},K.slug=function(V,Q){Q===void 0&&(Q={});var G=this.serialize(V);return this.getNextSafeSlug(G,Q.dryrun)},W}(),ne=function(){function W(_){this.options=_||ae.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new U}W.parse=function(V,Q){var G=new W(Q);return G.parse(V)},W.parseInline=function(V,Q){var G=new W(Q);return G.parseInline(V)};var K=W.prototype;return K.parse=function(V,Q){Q===void 0&&(Q=!0);var G="",X,ce,pe,Pe,Ae,Ne,$e,me,we,ye,Me,je,Ge,He,Ke,Xe,it,Ye,xe,_e=V.length;for(X=0;X<_e;X++){if(ye=V[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(xe=this.options.extensions.renderers[ye.type].call({parser:this},ye),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){G+=xe||"";continue}switch(ye.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(me="",$e="",Pe=ye.header.length,ce=0;ce<Pe;ce++)$e+=this.renderer.tablecell(this.parseInline(ye.header[ce].tokens),{header:!0,align:ye.align[ce]});for(me+=this.renderer.tablerow($e),we="",Pe=ye.rows.length,ce=0;ce<Pe;ce++){for(Ne=ye.rows[ce],$e="",Ae=Ne.length,pe=0;pe<Ae;pe++)$e+=this.renderer.tablecell(this.parseInline(Ne[pe].tokens),{header:!1,align:ye.align[pe]});we+=this.renderer.tablerow($e)}G+=this.renderer.table(me,we);continue}case"blockquote":{we=this.parse(ye.tokens),G+=this.renderer.blockquote(we);continue}case"list":{for(Me=ye.ordered,je=ye.start,Ge=ye.loose,Pe=ye.items.length,we="",ce=0;ce<Pe;ce++)Ke=ye.items[ce],Xe=Ke.checked,it=Ke.task,He="",Ke.task&&(Ye=this.renderer.checkbox(Xe),Ge?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=Ye+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=Ye+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:Ye}):He+=Ye),He+=this.parse(Ke.tokens,Ge),we+=this.renderer.listitem(He,it,Xe);G+=this.renderer.list(we,Me,je);continue}case"html":{G+=this.renderer.html(ye.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(we=ye.tokens?this.parseInline(ye.tokens):ye.text;X+1<_e&&V[X+1].type==="text";)ye=V[++X],we+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);G+=Q?this.renderer.paragraph(we):we;continue}default:{var fe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return G},K.parseInline=function(V,Q){Q=Q||this.renderer;var G="",X,ce,pe,Pe=V.length;for(X=0;X<Pe;X++){if(ce=V[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(pe=this.options.extensions.renderers[ce.type].call({parser:this},ce),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){G+=pe||"";continue}switch(ce.type){case"escape":{G+=Q.text(ce.text);break}case"html":{G+=Q.html(ce.text);break}case"link":{G+=Q.link(ce.href,ce.title,this.parseInline(ce.tokens,Q));break}case"image":{G+=Q.image(ce.href,ce.title,ce.text);break}case"strong":{G+=Q.strong(this.parseInline(ce.tokens,Q));break}case"em":{G+=Q.em(this.parseInline(ce.tokens,Q));break}case"codespan":{G+=Q.codespan(ce.text);break}case"br":{G+=Q.br();break}case"del":{G+=Q.del(this.parseInline(ce.tokens,Q));break}case"text":{G+=Q.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return G},W}();function se(W,K,_){if(typeof W>"u"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof K=="function"&&(_=K,K=null),K=l({},se.defaults,K||{}),O(K),_){var V=K.highlight,Q;try{Q=be.lex(W,K)}catch(Pe){return _(Pe)}var G=function(Ae){var Ne;if(!Ae)try{K.walkTokens&&se.walkTokens(Q,K.walkTokens),Ne=ne.parse(Q,K)}catch($e){Ae=$e}return K.highlight=V,Ae?_(Ae):_(null,Ne)};if(!V||V.length<3||(delete K.highlight,!Q.length))return G();var X=0;se.walkTokens(Q,function(Pe){Pe.type==="code"&&(X++,setTimeout(function(){V(Pe.text,Pe.lang,function(Ae,Ne){if(Ae)return G(Ae);Ne!=null&&Ne!==Pe.text&&(Pe.text=Ne,Pe.escaped=!0),X--,X===0&&G()})},0))}),X===0&&G();return}function ce(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+f(Pe.message+"",!0)+"</pre>";throw Pe}try{var pe=be.lex(W,K);if(K.walkTokens){if(K.async)return Promise.all(se.walkTokens(pe,K.walkTokens)).then(function(){return ne.parse(pe,K)}).catch(ce);se.walkTokens(pe,K.walkTokens)}return ne.parse(pe,K)}catch(Pe){ce(Pe)}}se.options=se.setOptions=function(W){return l(se.defaults,W),P(se.defaults),se},se.getDefaults=D,se.defaults=ae.defaults,se.use=function(){for(var W=arguments.length,K=new Array(W),_=0;_<W;_++)K[_]=arguments[_];var V=l.apply(void 0,[{}].concat(K)),Q=se.defaults.extensions||{renderers:{},childTokens:{}},G;K.forEach(function(X){if(X.extensions&&(G=!0,X.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Pe=Q.renderers?Q.renderers[pe.name]:null;Pe?Q.renderers[pe.name]=function(){for(var Ae=arguments.length,Ne=new Array(Ae),$e=0;$e<Ae;$e++)Ne[$e]=arguments[$e];var me=pe.renderer.apply(this,Ne);return me===!1&&(me=Pe.apply(this,Ne)),me}:Q.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[pe.level]?Q[pe.level].unshift(pe.tokenizer):Q[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?Q.startBlock?Q.startBlock.push(pe.start):Q.startBlock=[pe.start]:pe.level==="inline"&&(Q.startInline?Q.startInline.push(pe.start):Q.startInline=[pe.start]))}pe.childTokens&&(Q.childTokens[pe.name]=pe.childTokens)})),X.renderer&&function(){var pe=se.defaults.renderer||new Y,Pe=function($e){var me=pe[$e];pe[$e]=function(){for(var we=arguments.length,ye=new Array(we),Me=0;Me<we;Me++)ye[Me]=arguments[Me];var je=X.renderer[$e].apply(pe,ye);return je===!1&&(je=me.apply(pe,ye)),je}};for(var Ae in X.renderer)Pe(Ae);V.renderer=pe}(),X.tokenizer&&function(){var pe=se.defaults.tokenizer||new F,Pe=function($e){var me=pe[$e];pe[$e]=function(){for(var we=arguments.length,ye=new Array(we),Me=0;Me<we;Me++)ye[Me]=arguments[Me];var je=X.tokenizer[$e].apply(pe,ye);return je===!1&&(je=me.apply(pe,ye)),je}};for(var Ae in X.tokenizer)Pe(Ae);V.tokenizer=pe}(),X.walkTokens){var ce=se.defaults.walkTokens;V.walkTokens=function(pe){var Pe=[];return Pe.push(X.walkTokens.call(this,pe)),ce&&(Pe=Pe.concat(ce.call(this,pe))),Pe}}G&&(V.extensions=Q),se.setOptions(V)})},se.walkTokens=function(W,K){for(var _=[],V=function(){var ce=G.value;switch(_=_.concat(K.call(se,ce)),ce.type){case"table":{for(var pe=I(ce.header),Pe;!(Pe=pe()).done;){var Ae=Pe.value;_=_.concat(se.walkTokens(Ae.tokens,K))}for(var Ne=I(ce.rows),$e;!($e=Ne()).done;)for(var me=$e.value,we=I(me),ye;!(ye=we()).done;){var Me=ye.value;_=_.concat(se.walkTokens(Me.tokens,K))}break}case"list":{_=_.concat(se.walkTokens(ce.items,K));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[ce.type]?se.defaults.extensions.childTokens[ce.type].forEach(function(je){_=_.concat(se.walkTokens(ce[je],K))}):ce.tokens&&(_=_.concat(se.walkTokens(ce.tokens,K)))}},Q=I(W),G;!(G=Q()).done;)V();return _},se.parseInline=function(W,K){if(typeof W>"u"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");K=l({},se.defaults,K||{}),O(K);try{var _=be.lexInline(W,K);return K.walkTokens&&se.walkTokens(_,K.walkTokens),ne.parseInline(_,K)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+f(V.message+"",!0)+"</pre>";throw V}},se.Parser=ne,se.parser=ne.parse,se.Renderer=Y,se.TextRenderer=H,se.Lexer=be,se.lexer=be.lex,se.Tokenizer=F,se.Slugger=U,se.parse=se;var de=se.options,re=se.setOptions,j=se.use,N=se.walkTokens,M=se.parseInline,q=se,te=ne.parse,ue=be.lex;ae.Lexer=be,ae.Parser=ne,ae.Renderer=Y,ae.Slugger=U,ae.TextRenderer=H,ae.Tokenizer=F,ae.getDefaults=D,ae.lexer=ue,ae.marked=se,ae.options=de,ae.parse=q,ae.parseInline=M,ae.parser=te,ae.setOptions=re,ae.use=j,ae.walkTokens=N,Object.defineProperty(ae,"__esModule",{value:!0})}),define(ve[89],Ee([1,0,27]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new E.LRUCache(1e4);function a(y){return w(y,"NFC",A)}e.normalizeNFC=a;const I=new E.LRUCache(1e4);function D(y){return w(y,"NFD",I)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function w(y,T,S){if(!y)return y;const v=S.get(y);if(v)return v;let b;return P.test(y)?b=y.normalize(T):b=y,S.set(y,b),b}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(T){return D(T).replace(y,"")}}()}),define(ve[143],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,w,y){return Math.min(Math.max(P,w),y)}e.clamp=E;function A(P,w){return(w+P%w)%w}e.rot=A;class a{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=a;class I{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=I;class D{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const y=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function ae(a){const I=[];typeof a=="number"&&I.push("code/timeOrigin",a);function D(w){I.push(w,Date.now())}function P(){const w=[];for(let y=0;y<I.length;y+=2)w.push({name:I[y],startTime:I[y+1]});return w}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(a){performance.mark(a)},getMarks(){let a=performance.timeOrigin;typeof a!="number"&&(a=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(a)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(a+D.startTime)});return I}};if(typeof process=="object"){const a=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(a)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function E(a){return a.MonacoPerformanceMarks||(a.MonacoPerformanceMarks=e()),a.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=E(A))}(),define(ve[3],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let E=!1,A=!1,a=!1,I=!1,D=!1,P=!1,w=!1,y=!1,T=!1,S=!1,v,b=e.LANGUAGE_DEFAULT,f,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const h=typeof u?.versions?.electron=="string",m=h&&u?.type==="renderer";if(typeof navigator=="object"&&!m){p=navigator.userAgent,E=p.indexOf("Windows")>=0,A=p.indexOf("Macintosh")>=0,y=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=p.indexOf("Linux")>=0,S=p?.indexOf("Mobi")>=0,P=!0,v=e.LANGUAGE_DEFAULT,b=v;const c=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),l=c&&c.getAttribute("data-settings");if(l)try{const s=JSON.parse(l);v=s.locale,f=s._translationsConfigFile,b=s.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof u=="object"){E=u.platform==="win32",A=u.platform==="darwin",a=u.platform==="linux",I=a&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=h,T=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT;const c=u.env.VSCODE_NLS_CONFIG;if(c)try{const l=JSON.parse(c),s=l.availableLanguages["*"];v=l.locale,b=s||e.LANGUAGE_DEFAULT,f=l._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var d;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function C(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let k=0;A?k=1:E?k=3:a&&(k=2),e.isWindows=E,e.isMacintosh=A,e.isLinux=a,e.isLinuxSnap=I,e.isNative=D,e.isElectron=w,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=S,e.isCI=T,e.platform=k,e.userAgent=p,e.language=b;var t;(function(c){function l(){return e.language}c.value=l;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=s;function g(){return e.language==="en"}c.isDefault=g})(t=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",s=>{if(s.data&&s.data.vscodeScheduleAsyncWork)for(let g=0,R=c.length;g<R;g++){const O=c[g];if(O.id===s.data.vscodeScheduleAsyncWork){c.splice(g,1),O.callback();return}}});let l=0;return s=>{const g=++l;c.push({id:g,callback:s}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return c=>setTimeout(c)})();var r;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||y?2:E?1:3;let n=!0,i=!1;function o(){if(!i){i=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,n=new Uint16Array(c.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[28],Ee([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const a=E.globals.vscode.process;A={get platform(){return a.platform},get arch(){return a.arch},get env(){return a.env},cwd(){return a.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ve[7],Ee([1,0,28]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,a=97,I=90,D=122,P=46,w=47,y=92,T=58,S=63;class v extends Error{constructor(r,n,i){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const c=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${c} ${o} of type ${n}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function b(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function f(t,r){if(typeof t!="string")throw new v(r,"string",t)}const p=E.platform==="win32";function u(t){return t===w||t===y}function h(t){return t===w}function m(t){return t>=A&&t<=I||t>=a&&t<=D}function d(t,r,n,i){let o="",c=0,l=-1,s=0,g=0;for(let R=0;R<=t.length;++R){if(R<t.length)g=t.charCodeAt(R);else{if(i(g))break;g=w}if(i(g)){if(!(l===R-1||s===1))if(s===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const O=o.lastIndexOf(n);O===-1?(o="",c=0):(o=o.slice(0,O),c=o.length-1-o.lastIndexOf(n)),l=R,s=0;continue}else if(o.length!==0){o="",c=0,l=R,s=0;continue}}r&&(o+=o.length>0?`${n}..`:"..",c=2)}else o.length>0?o+=`${n}${t.slice(l+1,R)}`:o=t.slice(l+1,R),c=R-l-1;l=R,s=0}else g===P&&s!==-1?++s:s=-1}return o}function C(t,r){b(r,"pathObject");const n=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${i}`:`${n}${t}${i}`:i}e.win32={resolve(...t){let r="",n="",i=!1;for(let o=t.length-1;o>=-1;o--){let c;if(o>=0){if(c=t[o],f(c,"path"),c.length===0)continue}else r.length===0?c=E.cwd():(c=E.env[`=${r}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===y)&&(c=`${r}\\`));const l=c.length;let s=0,g="",R=!1;const O=c.charCodeAt(0);if(l===1)u(O)&&(s=1,R=!0);else if(u(O))if(R=!0,u(c.charCodeAt(1))){let z=2,ie=z;for(;z<l&&!u(c.charCodeAt(z));)z++;if(z<l&&z!==ie){const ee=c.slice(ie,z);for(ie=z;z<l&&u(c.charCodeAt(z));)z++;if(z<l&&z!==ie){for(ie=z;z<l&&!u(c.charCodeAt(z));)z++;(z===l||z!==ie)&&(g=`\\\\${ee}\\${c.slice(ie,z)}`,s=z)}}}else s=1;else m(O)&&c.charCodeAt(1)===T&&(g=c.slice(0,2),s=2,l>2&&u(c.charCodeAt(2))&&(R=!0,s=3));if(g.length>0)if(r.length>0){if(g.toLowerCase()!==r.toLowerCase())continue}else r=g;if(i){if(r.length>0)break}else if(n=`${c.slice(s)}\\${n}`,i=R,R&&r.length>0)break}return n=d(n,!i,"\\",u),i?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){f(t,"path");const r=t.length;if(r===0)return".";let n=0,i,o=!1;const c=t.charCodeAt(0);if(r===1)return h(c)?"\\":t;if(u(c))if(o=!0,u(t.charCodeAt(1))){let s=2,g=s;for(;s<r&&!u(t.charCodeAt(s));)s++;if(s<r&&s!==g){const R=t.slice(g,s);for(g=s;s<r&&u(t.charCodeAt(s));)s++;if(s<r&&s!==g){for(g=s;s<r&&!u(t.charCodeAt(s));)s++;if(s===r)return`\\\\${R}\\${t.slice(g)}\\`;s!==g&&(i=`\\\\${R}\\${t.slice(g,s)}`,n=s)}}}else n=1;else m(c)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),n=2,r>2&&u(t.charCodeAt(2))&&(o=!0,n=3));let l=n<r?d(t.slice(n),!o,"\\",u):"";return l.length===0&&!o&&(l="."),l.length>0&&u(t.charCodeAt(r-1))&&(l+="\\"),i===void 0?o?`\\${l}`:l:o?`${i}\\${l}`:`${i}${l}`},isAbsolute(t){f(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return u(n)||r>2&&m(n)&&t.charCodeAt(1)===T&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let c=0;c<t.length;++c){const l=t[c];f(l,"path"),l.length>0&&(r===void 0?r=n=l:r+=`\\${l}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof n=="string"&&u(n.charCodeAt(0))){++o;const c=n.length;c>1&&u(n.charCodeAt(1))&&(++o,c>2&&(u(n.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&u(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r)return"";const n=e.win32.resolve(t),i=e.win32.resolve(r);if(n===i||(t=n.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===y;)o++;let c=t.length;for(;c-1>o&&t.charCodeAt(c-1)===y;)c--;const l=c-o;let s=0;for(;s<r.length&&r.charCodeAt(s)===y;)s++;let g=r.length;for(;g-1>s&&r.charCodeAt(g-1)===y;)g--;const R=g-s,O=l<R?l:R;let z=-1,ie=0;for(;ie<O;ie++){const F=t.charCodeAt(o+ie);if(F!==r.charCodeAt(s+ie))break;F===y&&(z=ie)}if(ie!==O){if(z===-1)return i}else{if(R>O){if(r.charCodeAt(s+ie)===y)return i.slice(s+ie+1);if(ie===2)return i.slice(s+ie)}l>O&&(t.charCodeAt(o+ie)===y?z=ie:ie===2&&(z=3)),z===-1&&(z=0)}let ee="";for(ie=o+z+1;ie<=c;++ie)(ie===c||t.charCodeAt(ie)===y)&&(ee+=ee.length===0?"..":"\\..");return s+=z,ee.length>0?`${ee}${i.slice(s,g)}`:(i.charCodeAt(s)===y&&++s,i.slice(s,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const n=r.charCodeAt(2);if(n!==S&&n!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(m(r.charCodeAt(0))&&r.charCodeAt(1)===T&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){f(t,"path");const r=t.length;if(r===0)return".";let n=-1,i=0;const o=t.charCodeAt(0);if(r===1)return u(o)?t:".";if(u(o)){if(n=i=1,u(t.charCodeAt(1))){let s=2,g=s;for(;s<r&&!u(t.charCodeAt(s));)s++;if(s<r&&s!==g){for(g=s;s<r&&u(t.charCodeAt(s));)s++;if(s<r&&s!==g){for(g=s;s<r&&!u(t.charCodeAt(s));)s++;if(s===r)return t;s!==g&&(n=i=s+1)}}}}else m(o)&&t.charCodeAt(1)===T&&(n=r>2&&u(t.charCodeAt(2))?3:2,i=n);let c=-1,l=!0;for(let s=r-1;s>=i;--s)if(u(t.charCodeAt(s))){if(!l){c=s;break}}else l=!1;if(c===-1){if(n===-1)return".";c=n}return t.slice(0,c)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let n=0,i=-1,o=!0,c;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let l=r.length-1,s=-1;for(c=t.length-1;c>=n;--c){const g=t.charCodeAt(c);if(u(g)){if(!o){n=c+1;break}}else s===-1&&(o=!1,s=c+1),l>=0&&(g===r.charCodeAt(l)?--l===-1&&(i=c):(l=-1,i=s))}return n===i?i=s:i===-1&&(i=t.length),t.slice(n,i)}for(c=t.length-1;c>=n;--c)if(u(t.charCodeAt(c))){if(!o){n=c+1;break}}else i===-1&&(o=!1,i=c+1);return i===-1?"":t.slice(n,i)},extname(t){f(t,"path");let r=0,n=-1,i=0,o=-1,c=!0,l=0;t.length>=2&&t.charCodeAt(1)===T&&m(t.charCodeAt(0))&&(r=i=2);for(let s=t.length-1;s>=r;--s){const g=t.charCodeAt(s);if(u(g)){if(!c){i=s+1;break}continue}o===-1&&(c=!1,o=s+1),g===P?n===-1?n=s:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||o===-1||l===0||l===1&&n===o-1&&n===i+1?"":t.slice(n,o)},format:C.bind(null,"\\"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let i=0,o=t.charCodeAt(0);if(n===1)return u(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(u(o)){if(i=1,u(t.charCodeAt(1))){let z=2,ie=z;for(;z<n&&!u(t.charCodeAt(z));)z++;if(z<n&&z!==ie){for(ie=z;z<n&&u(t.charCodeAt(z));)z++;if(z<n&&z!==ie){for(ie=z;z<n&&!u(t.charCodeAt(z));)z++;z===n?i=z:z!==ie&&(i=z+1)}}}}else if(m(o)&&t.charCodeAt(1)===T){if(n<=2)return r.root=r.dir=t,r;if(i=2,u(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let c=-1,l=i,s=-1,g=!0,R=t.length-1,O=0;for(;R>=i;--R){if(o=t.charCodeAt(R),u(o)){if(!g){l=R+1;break}continue}s===-1&&(g=!1,s=R+1),o===P?c===-1?c=R:O!==1&&(O=1):c!==-1&&(O=-1)}return s!==-1&&(c===-1||O===0||O===1&&c===s-1&&c===l+1?r.base=r.name=t.slice(l,s):(r.name=t.slice(l,c),r.base=t.slice(l,s),r.ext=t.slice(c,s))),l>0&&l!==i?r.dir=t.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(p){const t=/\\/g;return()=>{const r=E.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let r="",n=!1;for(let i=t.length-1;i>=-1&&!n;i--){const o=i>=0?t[i]:k();f(o,"path"),o.length!==0&&(r=`${o}/${r}`,n=o.charCodeAt(0)===w)}return r=d(r,!n,"/",h),n?`/${r}`:r.length>0?r:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w,n=t.charCodeAt(t.length-1)===w;return t=d(t,!r,"/",h),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const i=t[n];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const n=1,i=t.length,o=i-n,c=1,l=r.length-c,s=o<l?o:l;let g=-1,R=0;for(;R<s;R++){const z=t.charCodeAt(n+R);if(z!==r.charCodeAt(c+R))break;z===w&&(g=R)}if(R===s)if(l>s){if(r.charCodeAt(c+R)===w)return r.slice(c+R+1);if(R===0)return r.slice(c+R)}else o>s&&(t.charCodeAt(n+R)===w?g=R:R===0&&(g=0));let O="";for(R=n+g+1;R<=i;++R)(R===i||t.charCodeAt(R)===w)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(c+g)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w;let n=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===w){if(!i){n=o;break}}else i=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let n=0,i=-1,o=!0,c;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let l=r.length-1,s=-1;for(c=t.length-1;c>=0;--c){const g=t.charCodeAt(c);if(g===w){if(!o){n=c+1;break}}else s===-1&&(o=!1,s=c+1),l>=0&&(g===r.charCodeAt(l)?--l===-1&&(i=c):(l=-1,i=s))}return n===i?i=s:i===-1&&(i=t.length),t.slice(n,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===w){if(!o){n=c+1;break}}else i===-1&&(o=!1,i=c+1);return i===-1?"":t.slice(n,i)},extname(t){f(t,"path");let r=-1,n=0,i=-1,o=!0,c=0;for(let l=t.length-1;l>=0;--l){const s=t.charCodeAt(l);if(s===w){if(!o){n=l+1;break}continue}i===-1&&(o=!1,i=l+1),s===P?r===-1?r=l:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||i===-1||c===0||c===1&&r===i-1&&r===n+1?"":t.slice(r,i)},format:C.bind(null,"/"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===w;let i;n?(r.root="/",i=1):i=0;let o=-1,c=0,l=-1,s=!0,g=t.length-1,R=0;for(;g>=i;--g){const O=t.charCodeAt(g);if(O===w){if(!s){c=g+1;break}continue}l===-1&&(s=!1,l=g+1),O===P?o===-1?o=g:R!==1&&(R=1):o!==-1&&(R=-1)}if(l!==-1){const O=c===0&&n?1:c;o===-1||R===0||R===1&&o===l-1&&o===c+1?r.base=r.name=t.slice(O,l):(r.name=t.slice(O,o),r.base=t.slice(O,l),r.ext=t.slice(o,l))}return c>0?r.dir=t.slice(0,c-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ve[56],Ee([1,0,7]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(T){const S=(0,E.extname)(T),v=A[S.toLowerCase()];return v!==void 0?v:D(T)}e.getMediaOrTextMime=I;function D(T){const S=(0,E.extname)(T);return a[S.toLowerCase()]}e.getMediaMime=D;function P(T){for(const S in a)if(a[S]===T)return S}e.getExtensionForMimeType=P;const w=/^(.+)\/(.+?)(;.+)?$/;function y(T,S){const v=w.exec(T);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:S?void 0:T}e.normalizeMimeType=y}),define(ve[57],Ee([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var a;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(a=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(P,...w){const y=w.reduce((v,b)=>(v[b]=!0,v),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(v=>!y[v]).forEach(v=>{for(let b=0;b<T.length;b++)if(v.search(T[b])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=I;function D(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var A in E)(typeof exports=="object"?exports:ae)[A]=E[A]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function E(A){if(e[A])return e[A].exports;var a=e[A]={i:A,l:!1,exports:{}};return ae[A].call(a.exports,a,a.exports,E),a.l=!0,a.exports}return E.m=ae,E.c=e,E.d=function(A,a,I){E.o(A,a)||Object.defineProperty(A,a,{enumerable:!0,get:I})},E.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},E.t=function(A,a){if(1&a&&(A=E(A)),8&a||4&a&&typeof A=="object"&&A&&A.__esModule)return A;var I=Object.create(null);if(E.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:A}),2&a&&typeof A!="string")for(var D in A)E.d(I,D,function(P){return A[P]}.bind(null,D));return I},E.n=function(A){var a=A&&A.__esModule?function(){return A.default}:function(){return A};return E.d(a,"a",a),a},E.o=function(A,a){return Object.prototype.hasOwnProperty.call(A,a)},E.p="",E(E.s=0)}([function(ae,e,E){(function(A){var a;e=ae.exports=j,a=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],y=0,T=y++;w[T]="0|[1-9]\\d*";var S=y++;w[S]="[0-9]+";var v=y++;w[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=y++;w[b]="("+w[T]+")\\.("+w[T]+")\\.("+w[T]+")";var f=y++;w[f]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var p=y++;w[p]="(?:"+w[T]+"|"+w[v]+")";var u=y++;w[u]="(?:"+w[S]+"|"+w[v]+")";var h=y++;w[h]="(?:-("+w[p]+"(?:\\."+w[p]+")*))";var m=y++;w[m]="(?:-?("+w[u]+"(?:\\."+w[u]+")*))";var d=y++;w[d]="[0-9A-Za-z-]+";var C=y++;w[C]="(?:\\+("+w[d]+"(?:\\."+w[d]+")*))";var k=y++,t="v?"+w[b]+w[h]+"?"+w[C]+"?";w[k]="^"+t+"$";var r="[v=\\s]*"+w[f]+w[m]+"?"+w[C]+"?",n=y++;w[n]="^"+r+"$";var i=y++;w[i]="((?:<|>)?=?)";var o=y++;w[o]=w[S]+"|x|X|\\*";var c=y++;w[c]=w[T]+"|x|X|\\*";var l=y++;w[l]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[h]+")?"+w[C]+"?)?)?";var s=y++;w[s]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[C]+"?)?)?";var g=y++;w[g]="^"+w[i]+"\\s*"+w[l]+"$";var R=y++;w[R]="^"+w[i]+"\\s*"+w[s]+"$";var O=y++;w[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=y++;w[z]="(?:~>?)";var ie=y++;w[ie]="(\\s*)"+w[z]+"\\s+",P[ie]=new RegExp(w[ie],"g");var ee=y++;w[ee]="^"+w[z]+w[l]+"$";var F=y++;w[F]="^"+w[z]+w[s]+"$";var Z=y++;w[Z]="(?:\\^)";var $=y++;w[$]="(\\s*)"+w[Z]+"\\s+",P[$]=new RegExp(w[$],"g");var x=y++;w[x]="^"+w[Z]+w[l]+"$";var le=y++;w[le]="^"+w[Z]+w[s]+"$";var be=y++;w[be]="^"+w[i]+"\\s*("+r+")$|^$";var Y=y++;w[Y]="^"+w[i]+"\\s*("+t+")$|^$";var H=y++;w[H]="(\\s*)"+w[i]+"\\s*("+r+"|"+w[l]+")",P[H]=new RegExp(w[H],"g");var U=y++;w[U]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var ne=y++;w[ne]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var se=y++;w[se]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)a(de,w[de]),P[de]||(P[de]=new RegExp(w[de]));function re(me,we){if(me instanceof j)return me;if(typeof me!="string"||me.length>I||!(we?P[n]:P[k]).test(me))return null;try{return new j(me,we)}catch{return null}}function j(me,we){if(me instanceof j){if(me.loose===we)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof j))return new j(me,we);a("SemVer",me,we),this.loose=we;var ye=me.trim().match(we?P[n]:P[k]);if(!ye)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var je=+Me;if(je>=0&&je<D)return je}return Me}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=re,e.valid=function(me,we){var ye=re(me,we);return ye?ye.version:null},e.clean=function(me,we){var ye=re(me.trim().replace(/^[=v]+/,""),we);return ye?ye.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(me){return a("SemVer.compare",this.version,this.loose,me),me instanceof j||(me=new j(me,this.loose)),this.compareMain(me)||this.comparePre(me)},j.prototype.compareMain=function(me){return me instanceof j||(me=new j(me,this.loose)),M(this.major,me.major)||M(this.minor,me.minor)||M(this.patch,me.patch)},j.prototype.comparePre=function(me){if(me instanceof j||(me=new j(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var we=0;do{var ye=this.prerelease[we],Me=me.prerelease[we];if(a("prerelease compare",we,ye,Me),ye===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ye===void 0)return-1;if(ye!==Me)return M(ye,Me)}while(++we)},j.prototype.inc=function(me,we){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,we,ye,Me){typeof ye=="string"&&(Me=ye,ye=void 0);try{return new j(me,ye).inc(we,Me).version}catch{return null}},e.diff=function(me,we){if(W(me,we))return null;var ye=re(me),Me=re(we);if(ye.prerelease.length||Me.prerelease.length){for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==Me[je])return"pre"+je;return"prerelease"}for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==Me[je])return je},e.compareIdentifiers=M;var N=/^[0-9]+$/;function M(me,we){var ye=N.test(me),Me=N.test(we);return ye&&Me&&(me=+me,we=+we),ye&&!Me?-1:Me&&!ye?1:me<we?-1:me>we?1:0}function q(me,we,ye){return new j(me,ye).compare(new j(we,ye))}function te(me,we,ye){return q(me,we,ye)>0}function ue(me,we,ye){return q(me,we,ye)<0}function W(me,we,ye){return q(me,we,ye)===0}function K(me,we,ye){return q(me,we,ye)!==0}function _(me,we,ye){return q(me,we,ye)>=0}function V(me,we,ye){return q(me,we,ye)<=0}function Q(me,we,ye,Me){var je;switch(we){case"===":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),je=me===ye;break;case"!==":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),je=me!==ye;break;case"":case"=":case"==":je=W(me,ye,Me);break;case"!=":je=K(me,ye,Me);break;case">":je=te(me,ye,Me);break;case">=":je=_(me,ye,Me);break;case"<":je=ue(me,ye,Me);break;case"<=":je=V(me,ye,Me);break;default:throw new TypeError("Invalid operator: "+we)}return je}function G(me,we){if(me instanceof G){if(me.loose===we)return me;me=me.value}if(!(this instanceof G))return new G(me,we);a("comparator",me,we),this.loose=we,this.parse(me),this.semver===X?this.value="":this.value=this.operator+this.semver.version,a("comp",this)}e.rcompareIdentifiers=function(me,we){return M(we,me)},e.major=function(me,we){return new j(me,we).major},e.minor=function(me,we){return new j(me,we).minor},e.patch=function(me,we){return new j(me,we).patch},e.compare=q,e.compareLoose=function(me,we){return q(me,we,!0)},e.rcompare=function(me,we,ye){return q(we,me,ye)},e.sort=function(me,we){return me.sort(function(ye,Me){return e.compare(ye,Me,we)})},e.rsort=function(me,we){return me.sort(function(ye,Me){return e.rcompare(ye,Me,we)})},e.gt=te,e.lt=ue,e.eq=W,e.neq=K,e.gte=_,e.lte=V,e.cmp=Q,e.Comparator=G;var X={};function ce(me,we){if(me instanceof ce)return me.loose===we?me:new ce(me.raw,we);if(me instanceof G)return new ce(me.value,we);if(!(this instanceof ce))return new ce(me,we);if(this.loose=we,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function Pe(me,we,ye,Me,je,Ge,He,Ke,Xe,it,Ye,xe,_e){return((we=pe(ye)?"":pe(Me)?">="+ye+".0.0":pe(je)?">="+ye+"."+Me+".0":">="+we)+" "+(Ke=pe(Xe)?"":pe(it)?"<"+(+Xe+1)+".0.0":pe(Ye)?"<"+Xe+"."+(+it+1)+".0":xe?"<="+Xe+"."+it+"."+Ye+"-"+xe:"<="+Ke)).trim()}function Ae(me,we){for(var ye=0;ye<me.length;ye++)if(!me[ye].test(we))return!1;if(we.prerelease.length){for(ye=0;ye<me.length;ye++)if(a(me[ye].semver),me[ye].semver!==X&&me[ye].semver.prerelease.length>0){var Me=me[ye].semver;if(Me.major===we.major&&Me.minor===we.minor&&Me.patch===we.patch)return!0}return!1}return!0}function Ne(me,we,ye){try{we=new ce(we,ye)}catch{return!1}return we.test(me)}function $e(me,we,ye,Me){var je,Ge,He,Ke,Xe;switch(me=new j(me,Me),we=new ce(we,Me),ye){case">":je=te,Ge=V,He=ue,Ke=">",Xe=">=";break;case"<":je=ue,Ge=_,He=te,Ke="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(me,we,Me))return!1;for(var it=0;it<we.set.length;++it){var Ye=we.set[it],xe=null,_e=null;if(Ye.forEach(function(fe){fe.semver===X&&(fe=new G(">=0.0.0")),xe=xe||fe,_e=_e||fe,je(fe.semver,xe.semver,Me)?xe=fe:He(fe.semver,_e.semver,Me)&&(_e=fe)}),xe.operator===Ke||xe.operator===Xe||(!_e.operator||_e.operator===Ke)&&Ge(me,_e.semver)||_e.operator===Xe&&He(me,_e.semver))return!1}return!0}G.prototype.parse=function(me){var we=this.loose?P[be]:P[Y],ye=me.match(we);if(!ye)throw new TypeError("Invalid comparator: "+me);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new j(ye[2],this.loose):this.semver=X},G.prototype.toString=function(){return this.value},G.prototype.test=function(me){return a("Comparator.test",me,this.loose),this.semver===X||(typeof me=="string"&&(me=new j(me,this.loose)),Q(me,this.operator,this.semver,this.loose))},G.prototype.intersects=function(me,we){if(!(me instanceof G))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ce(me.value,we),Ne(this.value,ye,we);if(me.operator==="")return ye=new ce(this.value,we),Ne(me.semver,ye,we);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Ge=this.semver.version===me.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ke=Q(this.semver,"<",me.semver,we)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Xe=Q(this.semver,">",me.semver,we)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||je||Ge&&He||Ke||Xe},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(me){var we=this.loose;me=me.trim(),a("range",me,we);var ye=we?P[ne]:P[U];me=me.replace(ye,Pe),a("hyphen replace",me),me=me.replace(P[H],"$1$2$3"),a("comparator trim",me,P[H]),me=(me=(me=me.replace(P[ie],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var Me=we?P[be]:P[Y],je=me.split(" ").map(function(Ge){return function(He,Ke){return a("comp",He),He=function(Xe,it){return Xe.trim().split(/\s+/).map(function(Ye){return function(xe,_e){a("caret",xe,_e);var fe=_e?P[le]:P[x];return xe.replace(fe,function(Ie,Ce,Te,Be,ze){var Ve;return a("caret",xe,Ie,Ce,Te,Be,ze),pe(Ce)?Ve="":pe(Te)?Ve=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Be)?Ve=Ce==="0"?">="+Ce+"."+Te+".0 <"+Ce+"."+(+Te+1)+".0":">="+Ce+"."+Te+".0 <"+(+Ce+1)+".0.0":ze?(a("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ve=Ce==="0"?Te==="0"?">="+Ce+"."+Te+"."+Be+ze+" <"+Ce+"."+Te+"."+(+Be+1):">="+Ce+"."+Te+"."+Be+ze+" <"+Ce+"."+(+Te+1)+".0":">="+Ce+"."+Te+"."+Be+ze+" <"+(+Ce+1)+".0.0"):(a("no pr"),Ve=Ce==="0"?Te==="0"?">="+Ce+"."+Te+"."+Be+" <"+Ce+"."+Te+"."+(+Be+1):">="+Ce+"."+Te+"."+Be+" <"+Ce+"."+(+Te+1)+".0":">="+Ce+"."+Te+"."+Be+" <"+(+Ce+1)+".0.0"),a("caret return",Ve),Ve})}(Ye,it)}).join(" ")}(He,Ke),a("caret",He),He=function(Xe,it){return Xe.trim().split(/\s+/).map(function(Ye){return function(xe,_e){var fe=_e?P[F]:P[ee];return xe.replace(fe,function(Ie,Ce,Te,Be,ze){var Ve;return a("tilde",xe,Ie,Ce,Te,Be,ze),pe(Ce)?Ve="":pe(Te)?Ve=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Be)?Ve=">="+Ce+"."+Te+".0 <"+Ce+"."+(+Te+1)+".0":ze?(a("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ve=">="+Ce+"."+Te+"."+Be+ze+" <"+Ce+"."+(+Te+1)+".0"):Ve=">="+Ce+"."+Te+"."+Be+" <"+Ce+"."+(+Te+1)+".0",a("tilde return",Ve),Ve})}(Ye,it)}).join(" ")}(He,Ke),a("tildes",He),He=function(Xe,it){return a("replaceXRanges",Xe,it),Xe.split(/\s+/).map(function(Ye){return function(xe,_e){xe=xe.trim();var fe=_e?P[R]:P[g];return xe.replace(fe,function(Ie,Ce,Te,Be,ze,Ve){a("xRange",xe,Ie,Ce,Te,Be,ze,Ve);var nt=pe(Te),Je=nt||pe(Be),Ze=Je||pe(ze);return Ce==="="&&Ze&&(Ce=""),nt?Ie=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ze?(Je&&(Be=0),Ze&&(ze=0),Ce===">"?(Ce=">=",Je?(Te=+Te+1,Be=0,ze=0):Ze&&(Be=+Be+1,ze=0)):Ce==="<="&&(Ce="<",Je?Te=+Te+1:Be=+Be+1),Ie=Ce+Te+"."+Be+"."+ze):Je?Ie=">="+Te+".0.0 <"+(+Te+1)+".0.0":Ze&&(Ie=">="+Te+"."+Be+".0 <"+Te+"."+(+Be+1)+".0"),a("xRange return",Ie),Ie})}(Ye,it)}).join(" ")}(He,Ke),a("xrange",He),He=function(Xe,it){return a("replaceStars",Xe,it),Xe.trim().replace(P[se],"")}(He,Ke),a("stars",He),He}(Ge,we)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ge){return!!Ge.match(Me)})),je=je.map(function(Ge){return new G(Ge,we)})},ce.prototype.intersects=function(me,we){if(!(me instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Me){return me.set.some(function(je){return je.every(function(Ge){return Me.intersects(Ge,we)})})})})},e.toComparators=function(me,we){return new ce(me,we).set.map(function(ye){return ye.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new j(me,this.loose));for(var we=0;we<this.set.length;we++)if(Ae(this.set[we],me))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(me,we,ye){var Me=null,je=null;try{var Ge=new ce(we,ye)}catch{return null}return me.forEach(function(He){Ge.test(He)&&(Me&&je.compare(He)!==-1||(je=new j(Me=He,ye)))}),Me},e.minSatisfying=function(me,we,ye){var Me=null,je=null;try{var Ge=new ce(we,ye)}catch{return null}return me.forEach(function(He){Ge.test(He)&&(Me&&je.compare(He)!==1||(je=new j(Me=He,ye)))}),Me},e.validRange=function(me,we){try{return new ce(me,we).range||"*"}catch{return null}},e.ltr=function(me,we,ye){return $e(me,we,"<",ye)},e.gtr=function(me,we,ye){return $e(me,we,">",ye)},e.outside=$e,e.prerelease=function(me,we){var ye=re(me,we);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(me,we,ye){return me=new ce(me,ye),we=new ce(we,ye),me.intersects(we)},e.coerce=function(me){if(me instanceof j)return me;if(typeof me!="string")return null;var we=me.match(P[O]);return we==null?null:re((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,E(1))},function(ae,e){var E,A,a=ae.exports={};function I(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(u){if(E===setTimeout)return setTimeout(u,0);if((E===I||!E)&&setTimeout)return E=setTimeout,setTimeout(u,0);try{return E(u,0)}catch{try{return E.call(null,u,0)}catch{return E.call(this,u,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:I}catch{E=I}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var w,y=[],T=!1,S=-1;function v(){T&&w&&(T=!1,w.length?y=w.concat(y):S=-1,y.length&&b())}function b(){if(!T){var u=P(v);T=!0;for(var h=y.length;h;){for(w=y,y=[];++S<h;)w&&w[S].run();S=-1,h=y.length}w=null,T=!1,function(m){if(A===clearTimeout)return clearTimeout(m);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(m);try{A(m)}catch{try{return A.call(null,m)}catch{return A.call(this,m)}}}(u)}}function f(u,h){this.fun=u,this.array=h}function p(){}a.nextTick=function(u){var h=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)h[m-1]=arguments[m];y.push(new f(u,h)),y.length!==1||T||P(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},a.title="browser",a.browser=!0,a.env={},a.argv=[],a.version="",a.versions={},a.on=p,a.addListener=p,a.once=p,a.off=p,a.removeListener=p,a.removeAllListeners=p,a.emit=p,a.prependListener=p,a.prependOnceListener=p,a.listeners=function(u){return[]},a.binding=function(u){throw new Error("process.binding is not supported")},a.cwd=function(){return"/"},a.chdir=function(u){throw new Error("process.chdir is not supported")},a.umask=function(){return 0}}])}),define(ve[144],Ee([1,0]),function(ae,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(P,w,y){this.level=P,this.key=w,this.value=y,this.forward=[]}}const a=void 0;class I{constructor(P,w=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new A(this.c,a,a)}get size(){return this.f}clear(){this.e=new A(this.c,a,a)}has(P){return Boolean(I.g(this,P,this.comparator))}get(P){return I.g(this,P,this.comparator)?.value}set(P,w){return I.h(this,P,w,this.comparator)&&(this.f+=1),this}delete(P){const w=I.k(this,P,this.comparator);return w&&(this.f-=1),w}forEach(P,w){let y=this.e.forward[0];for(;y;)P.call(w,y.value,y.key,this),y=y.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this.e.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static g(P,w,y){let T=P.e;for(let S=P.d-1;S>=0;S--)for(;T.forward[S]&&y(T.forward[S].key,w)<0;)T=T.forward[S];if(T=T.forward[0],T&&y(T.key,w)===0)return T}static h(P,w,y,T){const S=[];let v=P.e;for(let b=P.d-1;b>=0;b--){for(;v.forward[b]&&T(v.forward[b].key,w)<0;)v=v.forward[b];S[b]=v}if(v=v.forward[0],v&&T(v.key,w)===0)return v.value=y,!1;{const b=I.j(P);if(b>P.d){for(let f=P.d;f<b;f++)S[f]=P.e;P.d=b}v=new A(b,w,y);for(let f=0;f<b;f++)v.forward[f]=S[f].forward[f],S[f].forward[f]=v;return!0}}static j(P,w=.5){let y=1;for(;Math.random()<w&&y<P.c;)y+=1;return y}static k(P,w,y){const T=[];let S=P.e;for(let v=P.d-1;v>=0;v--){for(;S.forward[v]&&y(S.forward[v].key,w)<0;)S=S.forward[v];T[v]=S}if(S=S.forward[0],!S||y(S.key,w)!==0)return!1;for(let v=0;v<P.d&&T[v].forward[v]===S;v++)T[v].forward[v]=S.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===a;)P.d-=1;return!0}}e.SkipList=I}),define(ve[90],Ee([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=E.globals.performance&&typeof E.globals.performance.now=="function";class a{static create(D=!0){return new a(D)}constructor(D){this.a=A&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=a}),define(ve[6],Ee([1,0,9,69,2,88,90]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,w=!1;var y;(function(c){c.None=()=>a.Disposable.None;function l(q){if(w){const{onDidAddListener:te}=q,ue=f.create();let W=0;q.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),te?.()}}}function s(q,te){return $(q,()=>{},0,void 0,void 0,te)}c.defer=s;function g(q){return(te,ue=null,W)=>{let K=!1,_;return _=q(V=>{if(!K)return _?_.dispose():K=!0,te.call(ue,V)},null,W),K&&_.dispose(),_}}c.once=g;function R(q,te,ue){return Z((W,K=null,_)=>q(V=>W.call(K,te(V)),null,_),ue)}c.map=R;function O(q,te,ue){return Z((W,K=null,_)=>q(V=>{te(V),W.call(K,V)},null,_),ue)}c.forEach=O;function z(q,te,ue){return Z((W,K=null,_)=>q(V=>te(V)&&W.call(K,V),null,_),ue)}c.filter=z;function ie(q){return q}c.signal=ie;function ee(...q){return(te,ue=null,W)=>(0,a.combinedDisposable)(...q.map(K=>K(_=>te.call(ue,_),null,W)))}c.any=ee;function F(q,te,ue,W){let K=ue;return R(q,_=>(K=te(K,_),K),W)}c.reduce=F;function Z(q,te){let ue;const W={onWillAddFirstListener(){ue=q(K.fire,K)},onDidRemoveLastListener(){ue?.dispose()}};te||l(W);const K=new u(W);return te?.add(K),K.event}function $(q,te,ue=100,W=!1,K,_){let V,Q,G,X=0;const ce={leakWarningThreshold:K,onWillAddFirstListener(){V=q(Pe=>{X++,Q=te(Q,Pe),W&&!G&&(pe.fire(Q),Q=void 0);const Ae=()=>{const Ne=Q;Q=void 0,G=void 0,(!W||X>1)&&pe.fire(Ne),X=0};typeof ue=="number"?(clearTimeout(G),G=setTimeout(Ae,ue)):G===void 0&&(G=0,queueMicrotask(Ae))})},onDidRemoveLastListener(){V.dispose()}};_||l(ce);const pe=new u(ce);return _?.add(pe),pe.event}c.debounce=$;function x(q,te=0,ue){return c.debounce(q,(W,K)=>W?(W.push(K),W):[K],te,void 0,void 0,ue)}c.accumulate=x;function le(q,te=(W,K)=>W===K,ue){let W=!0,K;return z(q,_=>{const V=W||!te(_,K);return W=!1,K=_,V},ue)}c.latch=le;function be(q,te,ue){return[c.filter(q,te,ue),c.filter(q,W=>!te(W),ue)]}c.split=be;function Y(q,te=!1,ue=[]){let W=ue.slice(),K=q(Q=>{W?W.push(Q):V.fire(Q)});const _=()=>{W?.forEach(Q=>V.fire(Q)),W=null},V=new u({onWillAddFirstListener(){K||(K=q(Q=>V.fire(Q)))},onDidAddFirstListener(){W&&(te?setTimeout(_):_())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return V.event}c.buffer=Y;class H{constructor(te){this.event=te,this.c=new a.DisposableStore}map(te){return new H(R(this.event,te,this.c))}forEach(te){return new H(O(this.event,te,this.c))}filter(te){return new H(z(this.event,te,this.c))}reduce(te,ue){return new H(F(this.event,te,ue,this.c))}latch(){return new H(le(this.event,void 0,this.c))}debounce(te,ue=100,W=!1,K){return new H($(this.event,te,ue,W,K,this.c))}on(te,ue,W){return this.event(te,ue,W)}once(te,ue,W){return g(this.event)(te,ue,W)}dispose(){this.c.dispose()}}function U(q){return new H(q)}c.chain=U;function ne(q,te,ue=W=>W){const W=(...Q)=>V.fire(ue(...Q)),K=()=>q.on(te,W),_=()=>q.removeListener(te,W),V=new u({onWillAddFirstListener:K,onDidRemoveLastListener:_});return V.event}c.fromNodeEventEmitter=ne;function se(q,te,ue=W=>W){const W=(...Q)=>V.fire(ue(...Q)),K=()=>q.addEventListener(te,W),_=()=>q.removeEventListener(te,W),V=new u({onWillAddFirstListener:K,onDidRemoveLastListener:_});return V.event}c.fromDOMEventEmitter=se;function de(q){return new Promise(te=>g(q)(te))}c.toPromise=de;function re(q,te){return te(void 0),q(ue=>te(ue))}c.runAndSubscribe=re;function j(q,te){let ue=null;function W(_){ue?.dispose(),ue=new a.DisposableStore,te(_,ue)}W(void 0);const K=q(_=>W(_));return(0,a.toDisposable)(()=>{K.dispose(),ue?.dispose()})}c.runAndSubscribeWithStore=j;class N{constructor(te,ue){this.obs=te,this.c=0,this.d=!1;const W={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ue||l(W),this.emitter=new u(W),ue&&ue.add(this.emitter)}beginUpdate(te){this.c++}handleChange(te,ue){this.d=!0}endUpdate(te){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function M(q,te){return new N(q,te).emitter.event}c.fromObservable=M})(y=e.Event||(e.Event={}));class T{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${T.c++}`,T.all.add(this)}start(l){this.d=new D.StopWatch(!0),this.listenerCount=l}stop(){if(this.d){const l=this.d.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.d=void 0}}}T.all=new Set,T.c=0,e.EventProfiling=T;let S=-1;function v(c){const l=S;return S=c,{dispose(){S=l}}}e.setGlobalLeakWarningThreshold=v;class b{constructor(l,s=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=s,this.d=0}dispose(){this.c?.clear()}check(l,s){const g=this.threshold;if(g<=0||s<g)return;this.c||(this.c=new Map);const R=this.c.get(l.value)||0;if(this.c.set(l.value,R+1),this.d-=1,this.d<=0){this.d=g*.5;let O,z=0;for(const[ie,ee]of this.c)(!O||z<ee)&&(O=ie,z=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${z}):`),console.warn(O)}return()=>{const O=this.c.get(l.value)||0;this.c.set(l.value,O-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(l,s,g){this.callback=l,this.callbackThis=s,this.stack=g,this.subscription=new a.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class u{constructor(l){this.j=!1,this.d=l,this.f=S>0||this.d?.leakWarningThreshold?new b(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const l=Array.from(this.q);queueMicrotask(()=>{for(const s of l)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(l,s,g)=>{if(this.q||(this.q=new I.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),a.Disposable.None;const R=this.q.isEmpty();R&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(z=f.create(),O=this.f.check(z,this.q.size+1)),P&&(z=z??f.create());const ie=new p(l,s,z),ee=this.q.push(ie);R&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,l,s);const F=ie.subscription.set(()=>{O?.(),this.j||(ee(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return g instanceof a.DisposableStore?g.add(F):Array.isArray(g)&&g.push(F),F}),this.l}fire(l){if(this.q){this.m||(this.m=new m);for(const s of this.q)this.m.push(this,s,l);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=u;class h{constructor(){this.c=new I.LinkedList}get size(){return this.c.size}push(l,s,g){this.c.push(new d(l,s,g))}clear(l){const s=new I.LinkedList;for(const g of this.c)g.emitter!==l&&s.push(g);this.c=s}deliver(){for(;this.c.size>0;){const l=this.c.shift();try{l.listener.invoke(l.event)}catch(s){(0,E.onUnexpectedError)(s)}}}}e.EventDeliveryQueue=h;class m extends h{clear(l){this.c.clear()}}class d{constructor(l,s,g){this.emitter=l,this.listener=s,this.event=g}}class C extends u{async fireAsync(l,s,g){if(!!this.q){this.c||(this.c=new I.LinkedList);for(const R of this.q)this.c.push([R,l]);for(;this.c.size>0&&!s.isCancellationRequested;){const[R,O]=this.c.shift(),z=[],ie={...O,token:s,waitUntil:ee=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");g&&(ee=g(ee,R.callback)),z.push(ee)}};try{R.invoke(ie)}catch(ee){(0,E.onUnexpectedError)(ee);continue}Object.freeze(z),await Promise.allSettled(z).then(ee=>{for(const F of ee)F.status==="rejected"&&(0,E.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=C;class k extends u{constructor(l){super(l),this.h=0,this.s=new I.LinkedList,this.t=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.t(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.q&&(this.h!==0?this.s.push(l):super.fire(l))}}e.PauseableEmitter=k;class t extends k{constructor(l){super(l),this.c=l.delay??100}fire(l){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(l)}}e.DebounceEmitter=t;class r extends u{constructor(l){super(l),this.c=[],this.h=l?.merge}fire(l){!this.hasListeners()||(this.c.push(l),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(s=>super.fire(s)),this.c=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.d=!1,this.f=[],this.c=new u({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(l){const s={event:l,listener:null};this.f.push(s),this.d&&this.j(s);const g=()=>{this.d&&this.k(s);const R=this.f.indexOf(s);this.f.splice(R,1)};return(0,a.toDisposable)((0,A.once)(g))}g(){this.d=!0,this.f.forEach(l=>this.j(l))}h(){this.d=!1,this.f.forEach(l=>this.k(l))}j(l){l.listener=l.event(s=>this.c.fire(s))}k(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.c=[]}wrapEvent(l){return(s,g,R)=>l(O=>{const z=this.c[this.c.length-1];z?z.push(()=>s.call(g,O)):s.call(g,O)},void 0,R)}bufferEvents(l){const s=[];this.c.push(s);const g=l();return this.c.pop(),s.forEach(R=>R()),g}}e.EventBufferer=i;class o{constructor(){this.c=!1,this.d=y.None,this.f=a.Disposable.None,this.g=new u({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(l){this.d=l,this.c&&(this.f.dispose(),this.f=l(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ve[19],Ee([1,0,6]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,w){const y=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(y)}}});var a;(function(P){function w(y){return y===P.None||y===P.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(a=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new I),this.a}cancel(){this.a?this.a instanceof I&&this.a.cancel():this.a=a.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof I&&this.a.dispose():this.a=a.None}}e.CancellationTokenSource=D}),define(ve[145],Ee([1,0,19]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,w=this.b(P.token);return this.a={promise:w,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class a{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const w=JSON.stringify(P);return this.b!==w&&(this.b=w,this.a=this.c(P)),this.a}}e.LRUCachedFunction=a;class I{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const w=this.b(P);return this.a.set(P,w),w}}e.CachedFunction=I}),define(ve[44],Ee([1,0,9,2]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function a(C){const k=C;return k?typeof k.read=="function":!1}e.isReadable=a;function I(C){const k=C;return k?[k.on,k.pause,k.resume,k.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=I;function D(C){const k=C;return k?I(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(C,k){return new w(C,k)}e.newWriteableStream=P;class w{constructor(k,t){this.e=k,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(t=>t(k))}h(k){this.c.error.length===0?(0,E.onUnexpectedError)(k):this.c.error.slice(0).forEach(t=>t(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,t){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(k,t){if(this.a.destroyed)return;let r;switch(k){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(C,k){const t=[];let r;for(;(r=C.read())!==null;)t.push(r);return k(t)}e.consumeReadable=y;function T(C,k,t){const r=[];let n;for(;(n=C.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?k(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return C.read()}}}e.peekReadable=T;function S(C,k){return new Promise((t,r)=>{const n=[];v(C,{onData:i=>{k&&n.push(i)},onError:i=>{k?r(i):t(void 0)},onEnd:()=>{t(k?k(n):void 0)}})})}e.consumeStream=S;function v(C,k){let t=!1;return C.on("error",r=>{t||k.onError(r)}),C.on("end",()=>{t||k.onEnd()}),C.on("data",r=>{t||k.onData(r)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=v;function b(C,k){return new Promise((t,r)=>{const n=new A.DisposableStore,i=[],o=s=>{if(i.push(s),i.length>k)return n.dispose(),C.pause(),t({stream:C,buffer:i,ended:!1})},c=s=>r(s),l=()=>t({stream:C,buffer:i,ended:!0});n.add((0,A.toDisposable)(()=>C.removeListener("error",c))),C.on("error",c),n.add((0,A.toDisposable)(()=>C.removeListener("end",l))),C.on("end",l),n.add((0,A.toDisposable)(()=>C.removeListener("data",o))),C.on("data",o)})}e.peekStream=b;function f(C,k){const t=P(k);return t.end(C),t}e.toStream=f;function p(){const C=P(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=p;function u(C){let k=!1;return{read:()=>k?null:(k=!0,C)}}e.toReadable=u;function h(C,k,t){const r=P(t);return v(C,{onData:n=>r.write(k.data(n)),onError:n=>r.error(k.error?k.error(n):n),onEnd:()=>r.end()}),r}e.transform=h;function m(C,k,t){let r=!1;return{read:()=>{const n=k.read();return r?n:(r=!0,n!==null?t([C,n]):C)}}}e.prefixedReadable=m;function d(C,k,t){let r=!1;const n=P(t);return v(k,{onData:i=>r?n.write(i):(r=!0,n.write(t([C,i]))),onError:i=>n.error(i),onEnd:()=>{r||(r=!0,n.write(C)),n.end()}}),n}e.prefixedStream=d}),define(ve[15],Ee([1,0,44]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let a,I;class D{static alloc(s){return A?new D(Buffer.allocUnsafe(s)):new D(new Uint8Array(s))}static wrap(s){return A&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new D(s)}static fromString(s,g){return!(g?.dontUseNodeBuffer||!1)&&A?new D(Buffer.from(s)):(a||(a=new TextEncoder),new D(a.encode(s)))}static fromByteArray(s){const g=D.alloc(s.length);for(let R=0,O=s.length;R<O;R++)g.buffer[R]=s[R];return g}static concat(s,g){if(typeof g>"u"){g=0;for(let z=0,ie=s.length;z<ie;z++)g+=s[z].byteLength}const R=D.alloc(g);let O=0;for(let z=0,ie=s.length;z<ie;z++){const ee=s[z];R.set(ee,O),O+=ee.byteLength}return R}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=D.alloc(this.byteLength);return s.set(this),s}toString(){return A?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(s,g){return new D(this.buffer.subarray(s,g))}set(s,g){if(s instanceof D)this.buffer.set(s.buffer,g);else if(s instanceof Uint8Array)this.buffer.set(s,g);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),g);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return y(this.buffer,s)}writeUInt32BE(s,g){T(this.buffer,s,g)}readUInt32LE(s){return S(this.buffer,s)}writeUInt32LE(s,g){v(this.buffer,s,g)}readUInt8(s){return b(this.buffer,s)}writeUInt8(s,g){f(this.buffer,s,g)}}e.VSBuffer=D;function P(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0}e.readUInt16LE=P;function w(l,s,g){l[g+0]=s&255,s=s>>>8,l[g+1]=s&255}e.writeUInt16LE=w;function y(l,s){return l[s]*2**24+l[s+1]*2**16+l[s+2]*2**8+l[s+3]}e.readUInt32BE=y;function T(l,s,g){l[g+3]=s,s=s>>>8,l[g+2]=s,s=s>>>8,l[g+1]=s,s=s>>>8,l[g]=s}e.writeUInt32BE=T;function S(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0|l[s+2]<<16>>>0|l[s+3]<<24>>>0}e.readUInt32LE=S;function v(l,s,g){l[g+0]=s&255,s=s>>>8,l[g+1]=s&255,s=s>>>8,l[g+2]=s&255,s=s>>>8,l[g+3]=s&255}e.writeUInt32LE=v;function b(l,s){return l[s]}e.readUInt8=b;function f(l,s,g){l[g]=s}e.writeUInt8=f;function p(l){return E.consumeReadable(l,s=>D.concat(s))}e.readableToBuffer=p;function u(l){return E.toReadable(l)}e.bufferToReadable=u;function h(l){return E.consumeStream(l,s=>D.concat(s))}e.streamToBuffer=h;async function m(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await h(l.stream)])}e.bufferedStreamToBuffer=m;function d(l){return E.toStream(l,s=>D.concat(s))}e.bufferToStream=d;function C(l){return E.transform(l,{data:s=>typeof s=="string"?D.fromString(s):D.wrap(s)},s=>D.concat(s))}e.streamToBufferReadableStream=C;function k(l){return E.newWriteableStream(s=>D.concat(s),l)}e.newWriteableBufferStream=k;function t(l,s){return E.prefixedReadable(l,s,g=>D.concat(g))}e.prefixedBufferReadable=t;function r(l,s){return E.prefixedStream(l,s,g=>D.concat(g))}e.prefixedBufferStream=r;function n(l){let s=0,g=0,R=0;const O=new Uint8Array(Math.floor(l.length/4*3)),z=ee=>{switch(g){case 3:O[R++]=s|ee,g=0;break;case 2:O[R++]=s|ee>>>2,s=ee<<6,g=3;break;case 1:O[R++]=s|ee>>>4,s=ee<<4,g=2;break;default:s=ee<<2,g=1}};for(let ee=0;ee<l.length;ee++){const F=l.charCodeAt(ee);if(F>=65&&F<=90)z(F-65);else if(F>=97&&F<=122)z(F-97+26);else if(F>=48&&F<=57)z(F-48+52);else if(F===43||F===45)z(62);else if(F===47||F===95)z(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const ie=R;for(;g>0;)z(0);return D.wrap(O).slice(0,ie)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:l},s=!0,g=!1){const R=g?o:i;let O="";const z=l.byteLength%3;let ie=0;for(;ie<l.byteLength-z;ie+=3){const ee=l[ie+0],F=l[ie+1],Z=l[ie+2];O+=R[ee>>>2],O+=R[(ee<<4|F>>>4)&63],O+=R[(F<<2|Z>>>6)&63],O+=R[Z&63]}if(z===1){const ee=l[ie+0];O+=R[ee>>>2],O+=R[ee<<4&63],s&&(O+="==")}else if(z===2){const ee=l[ie+0],F=l[ie+1];O+=R[ee>>>2],O+=R[(ee<<4|F>>>4)&63],O+=R[F<<2&63],s&&(O+="=")}return O}e.encodeBase64=c}),define(ve[16],Ee([1,0,145,141]),function(ae,e,E,A){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function I(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=I;const D=/{(\d+)}/g;function P(fe,...Ie){return Ie.length===0?fe:fe.replace(D,function(Ce,Te){const Be=parseInt(Te,10);return isNaN(Be)||Be<0||Be>=Ie.length?Ce:Ie[Be]})}e.format=P;const w=/{([^}]+)}/g;function y(fe,Ie){return fe.replace(w,(Ce,Te)=>Ie[Te]??Ce)}e.format2=y;function T(fe){return fe.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=T;function S(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function v(fe,Ie){let Ce=0;const Te=Ie.charCodeAt(0);for(let Be=fe.length-1;Be>=0;Be--)fe.charCodeAt(Be)===Te&&Ce++;return Ce}e.count=v;function b(fe,Ie,Ce="\u2026"){return fe.length<=Ie?fe:`${fe.substr(0,Ie)}${Ce}`}e.truncate=b;function f(fe,Ie=" "){const Ce=p(fe,Ie);return u(Ce,Ie)}e.trim=f;function p(fe,Ie){if(!fe||!Ie)return fe;const Ce=Ie.length;if(Ce===0||fe.length===0)return fe;let Te=0;for(;fe.indexOf(Ie,Te)===Te;)Te=Te+Ce;return fe.substring(Te)}e.ltrim=p;function u(fe,Ie){if(!fe||!Ie)return fe;const Ce=Ie.length,Te=fe.length;if(Ce===0||Te===0)return fe;let Be=Te,ze=-1;for(;ze=fe.lastIndexOf(Ie,Be-1),!(ze===-1||ze+Ce!==Be);){if(ze===0)return"";Be=ze}return fe.substring(0,Be)}e.rtrim=u;function h(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function m(fe){return fe.replace(/\*/g,"")}e.stripWildcards=m;function d(fe,Ie,Ce={}){if(!fe)throw new Error("Cannot create regex from empty string");Ie||(fe=S(fe)),Ce.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Te="";return Ce.global&&(Te+="g"),Ce.matchCase||(Te+="i"),Ce.multiline&&(Te+="m"),Ce.unicode&&(Te+="u"),new RegExp(fe,Te)}e.createRegExp=d;function C(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function k(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function t(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=t;function r(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=r;function n(fe){for(let Ie=0,Ce=fe.length;Ie<Ce;Ie++){const Te=fe.charCodeAt(Ie);if(Te!==32&&Te!==9)return Ie}return-1}e.firstNonWhitespaceIndex=n;function i(fe,Ie=0,Ce=fe.length){for(let Te=Ie;Te<Ce;Te++){const Be=fe.charCodeAt(Te);if(Be!==32&&Be!==9)return fe.substring(Ie,Te)}return fe.substring(Ie,Ce)}e.getLeadingWhitespace=i;function o(fe,Ie=fe.length-1){for(let Ce=Ie;Ce>=0;Ce--){const Te=fe.charCodeAt(Ce);if(Te!==32&&Te!==9)return Ce}return-1}e.lastNonWhitespaceIndex=o;function c(fe,Ie,Ce){const Te=[];let Be=0;for(const ze of fe.matchAll(Ie)){if(Te.push(fe.slice(Be,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Be=ze.index+ze[0].length,Te.push(Ce(ze[0],...ze.slice(1),ze.index,fe,ze.groups))}return Te.push(fe.slice(Be)),Promise.all(Te).then(ze=>ze.join(""))}e.replaceAsync=c;function l(fe,Ie){return fe<Ie?-1:fe>Ie?1:0}e.compare=l;function s(fe,Ie,Ce=0,Te=fe.length,Be=0,ze=Ie.length){for(;Ce<Te&&Be<ze;Ce++,Be++){const Je=fe.charCodeAt(Ce),Ze=Ie.charCodeAt(Be);if(Je<Ze)return-1;if(Je>Ze)return 1}const Ve=Te-Ce,nt=ze-Be;return Ve<nt?-1:Ve>nt?1:0}e.compareSubstring=s;function g(fe,Ie){return R(fe,Ie,0,fe.length,0,Ie.length)}e.compareIgnoreCase=g;function R(fe,Ie,Ce=0,Te=fe.length,Be=0,ze=Ie.length){for(;Ce<Te&&Be<ze;Ce++,Be++){let Je=fe.charCodeAt(Ce),Ze=Ie.charCodeAt(Be);if(Je===Ze)continue;if(Je>=128||Ze>=128)return s(fe.toLowerCase(),Ie.toLowerCase(),Ce,Te,Be,ze);z(Je)&&(Je-=32),z(Ze)&&(Ze-=32);const at=Je-Ze;if(at!==0)return at}const Ve=Te-Ce,nt=ze-Be;return Ve<nt?-1:Ve>nt?1:0}e.compareSubstringIgnoreCase=R;function O(fe){return fe>=48&&fe<=57}e.isAsciiDigit=O;function z(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=z;function ie(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=ie;function ee(fe,Ie){return fe.length===Ie.length&&R(fe,Ie)===0}e.equalsIgnoreCase=ee;function F(fe,Ie){const Ce=Ie.length;return Ie.length>fe.length?!1:R(fe,Ie,0,Ce)===0}e.startsWithIgnoreCase=F;function Z(fe,Ie){const Ce=Math.min(fe.length,Ie.length);let Te;for(Te=0;Te<Ce;Te++)if(fe.charCodeAt(Te)!==Ie.charCodeAt(Te))return Te;return Ce}e.commonPrefixLength=Z;function $(fe,Ie){const Ce=Math.min(fe.length,Ie.length);let Te;const Be=fe.length-1,ze=Ie.length-1;for(Te=0;Te<Ce;Te++)if(fe.charCodeAt(Be-Te)!==Ie.charCodeAt(ze-Te))return Te;return Ce}e.commonSuffixLength=$;function x(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=x;function le(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=le;function be(fe,Ie){return(fe-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=be;function Y(fe,Ie,Ce){const Te=fe.charCodeAt(Ce);if(x(Te)&&Ce+1<Ie){const Be=fe.charCodeAt(Ce+1);if(le(Be))return be(Te,Be)}return Te}e.getNextCodePoint=Y;function H(fe,Ie){const Ce=fe.charCodeAt(Ie-1);if(le(Ce)&&Ie>1){const Te=fe.charCodeAt(Ie-2);if(x(Te))return be(Te,Ce)}return Ce}class U{get offset(){return this.e}constructor(Ie,Ce=0){this.c=Ie,this.d=Ie.length,this.e=Ce}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=H(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=Y(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.CodePointIterator=U;class ne{get offset(){return this.c.offset}constructor(Ie,Ce=0){this.c=new U(Ie,Ce)}nextGraphemeLength(){const Ie=Ge.getInstance(),Ce=this.c,Te=Ce.offset;let Be=Ie.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const ze=Ce.offset,Ve=Ie.getGraphemeBreakType(Ce.nextCodePoint());if(Me(Be,Ve)){Ce.setOffset(ze);break}Be=Ve}return Ce.offset-Te}prevGraphemeLength(){const Ie=Ge.getInstance(),Ce=this.c,Te=Ce.offset;let Be=Ie.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const ze=Ce.offset,Ve=Ie.getGraphemeBreakType(Ce.prevCodePoint());if(Me(Ve,Be)){Ce.setOffset(ze);break}Be=Ve}return Te-Ce.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ne;function se(fe,Ie){return new ne(fe,Ie).nextGraphemeLength()}e.nextCharLength=se;function de(fe,Ie){return new ne(fe,Ie).prevGraphemeLength()}e.prevCharLength=de;function re(fe,Ie){Ie>0&&le(fe.charCodeAt(Ie))&&Ie--;const Ce=Ie+se(fe,Ie);return[Ce-de(fe,Ce),Ce]}e.getCharContainingOffset=re;function j(fe){const Ie=new ne(fe);let Ce=0;for(;!Ie.eol();)Ce++,Ie.nextGraphemeLength();return Ce}e.charCount=j;let N;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(fe){return N||(N=M()),N.test(fe)}e.containsRTL=q;const te=/^[\t\n\r\x20-\x7E]*$/;function ue(fe){return te.test(fe)}e.isBasicASCII=ue,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=W;function K(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=K;function _(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=_;function V(fe,Ie){if(fe.length<Ie)return fe;const Ce=/\b/g;let Te=0;for(;Ce.test(fe)&&!(fe.length-Ce.lastIndex<Ie);)Te=Ce.lastIndex,Ce.lastIndex+=1;return fe.substring(Te).replace(/^\s/,"")}e.lcut=V;const Q=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,X=/\x1b\[0?m/g;function ce(fe){return fe&&(fe=fe.replace(Q,""),fe=fe.replace(G,""),fe=fe.replace(X,"")),fe}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Pe(fe){return pe(fe)?fe.substr(1):fe}e.stripUTF8BOM=Pe;function Ae(fe,Ie){if(!fe||!Ie||fe.length<Ie.length)return!1;const Ce=Ie.length,Te=fe.toLowerCase();let Be=0,ze=-1;for(;Be<Ce;){const Ve=Te.indexOf(Ie[Be],ze+1);if(Ve<0)return!1;ze=Ve,Be++}return!0}e.fuzzyContains=Ae;function Ne(fe,Ie=!1){return fe?(Ie&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=Ne;function $e(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=$e;function me(fe,Ie=1){if(Ie===0)return"";let Ce=-1;do Ce=fe.indexOf(`
`,Ce+1),Ie--;while(Ie>0&&Ce>=0);return Ce===-1?fe:(fe[Ce-1]==="\r"&&Ce--,fe.substr(0,Ce))}e.getNLines=me;function we(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=we;function ye(fe){return Ge.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=ye;function Me(fe,Ie){return fe===0?Ie!==5&&Ie!==7:fe===2&&Ie===3?!1:fe===4||fe===2||fe===3||Ie===4||Ie===2||Ie===3?!0:!(fe===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(fe===11||fe===9)&&(Ie===9||Ie===10)||(fe===12||fe===10)&&Ie===10||Ie===5||Ie===13||Ie===7||fe===1||fe===13&&Ie===14||fe===6&&Ie===6)}var je;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ge{static getInstance(){return Ge.c||(Ge.c=new Ge),Ge.c}constructor(){this.d=He()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ce=this.d,Te=Ce.length/3;let Be=1;for(;Be<=Te;)if(Ie<Ce[3*Be])Be=2*Be;else if(Ie>Ce[3*Be+1])Be=2*Be+1;else return Ce[3*Be+2];return 0}}Ge.c=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(fe,Ie){if(fe===0)return 0;const Ce=Xe(fe,Ie);if(Ce!==void 0)return Ce;const Te=new U(Ie,fe);return Te.prevCodePoint(),Te.offset}e.getLeftDeleteOffset=Ke;function Xe(fe,Ie){const Ce=new U(Ie,fe);let Te=Ce.prevCodePoint();for(;it(Te)||Te===65039||Te===8419;){if(Ce.offset===0)return;Te=Ce.prevCodePoint()}if(!_(Te))return;let Be=Ce.offset;return Be>0&&Ce.prevCodePoint()===8205&&(Be=Ce.offset),Be}function it(fe){return 127995<=fe&&fe<=127999}var Ye;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class xe{static getInstance(Ie){return xe.d.get(Array.from(Ie))}static getLocales(){return xe.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}a=xe,xe.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),xe.d=new E.LRUCachedFunction(fe=>{function Ie(Ze){const at=new Map;for(let st=0;st<Ze.length;st+=2)at.set(Ze[st],Ze[st+1]);return at}function Ce(Ze,at){const st=new Map(Ze);for(const[bt,ut]of at)st.set(bt,ut);return st}function Te(Ze,at){if(!Ze)return at;const st=new Map;for(const[bt,ut]of Ze)at.has(bt)&&st.set(bt,ut);return st}const Be=a.c.value;let ze=fe.filter(Ze=>!Ze.startsWith("_")&&Ze in Be);ze.length===0&&(ze=["_default"]);let Ve;for(const Ze of ze){const at=Ie(Be[Ze]);Ve=Te(Ve,at)}const nt=Ie(Be._common),Je=Ce(nt,Ve);return new xe(Je)}),xe.e=new A.Lazy(()=>Object.keys(xe.c.value).filter(fe=>!fe.startsWith("_"))),e.AmbiguousCharacters=xe;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(Ie){return _e.e().has(Ie)}static get codePoints(){return _e.e()}}_e.d=void 0,e.InvisibleCharacters=_e}),define(ve[146],Ee([1,0,27,16]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function a(...G){return function(X,ce){for(let pe=0,Pe=G.length;pe<Pe;pe++){const Ae=G[pe](X,ce);if(Ae)return Ae}return null}}e.or=a,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(G,X,ce){if(!ce||ce.length<X.length)return null;let pe;return G?pe=A.startsWithIgnoreCase(ce,X):pe=ce.indexOf(X)===0,pe?X.length>0?[{start:0,end:X.length}]:[]:null}function D(G,X){const ce=X.toLowerCase().indexOf(G.toLowerCase());return ce===-1?null:[{start:ce,end:ce+G.length}]}e.matchesContiguousSubString=D;function P(G,X){return w(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=P;function w(G,X,ce,pe){if(ce===G.length)return[];if(pe===X.length)return null;if(G[ce]===X[pe]){let Pe=null;return(Pe=w(G,X,ce+1,pe+1))?h({start:pe,end:pe+1},Pe):null}return w(G,X,ce,pe+1)}function y(G){return 97<=G&&G<=122}function T(G){return 65<=G&&G<=90}e.isUpper=T;function S(G){return 48<=G&&G<=57}function v(G){return G===32||G===9||G===10||G===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>b.add(G.charCodeAt(0)));function f(G){return v(G)||b.has(G)}function p(G,X){return G===X||f(G)&&f(X)}function u(G){return y(G)||T(G)||S(G)}function h(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function m(G,X){for(let ce=X;ce<G.length;ce++){const pe=G.charCodeAt(ce);if(T(pe)||S(pe)||ce>0&&!u(G.charCodeAt(ce-1)))return ce}return G.length}function d(G,X,ce,pe){if(ce===G.length)return[];if(pe===X.length)return null;if(G[ce]!==X[pe].toLowerCase())return null;{let Pe=null,Ae=pe+1;for(Pe=d(G,X,ce+1,pe+1);!Pe&&(Ae=m(X,Ae))<X.length;)Pe=d(G,X,ce+1,Ae),Ae++;return Pe===null?null:h({start:pe,end:pe+1},Pe)}}function C(G){let X=0,ce=0,pe=0,Pe=0,Ae=0;for(let ye=0;ye<G.length;ye++)Ae=G.charCodeAt(ye),T(Ae)&&X++,y(Ae)&&ce++,u(Ae)&&pe++,S(Ae)&&Pe++;const Ne=X/G.length,$e=ce/G.length,me=pe/G.length,we=Pe/G.length;return{upperPercent:Ne,lowerPercent:$e,alphaPercent:me,numericPercent:we}}function k(G){const{upperPercent:X,lowerPercent:ce}=G;return ce===0&&X>.6}function t(G){const{upperPercent:X,lowerPercent:ce,alphaPercent:pe,numericPercent:Pe}=G;return ce>.2&&X<.8&&pe>.6&&Pe<.2}function r(G){let X=0,ce=0,pe=0,Pe=0;for(let Ae=0;Ae<G.length;Ae++)pe=G.charCodeAt(Ae),T(pe)&&X++,y(pe)&&ce++,v(pe)&&Pe++;return(X===0||ce===0)&&Pe===0?G.length<=30:X<=5}function n(G,X){if(!X||(X=X.trim(),X.length===0)||!r(G)||X.length>60)return null;const ce=C(X);if(!t(ce)){if(!k(ce))return null;X=X.toLowerCase()}let pe=null,Pe=0;for(G=G.toLowerCase();Pe<X.length&&(pe=d(G,X,0,Pe))===null;)Pe=m(X,Pe+1);return pe}e.matchesCamelCase=n;function i(G,X,ce=!1){if(!X||X.length===0)return null;let pe=null,Pe=0;for(G=G.toLowerCase(),X=X.toLowerCase();Pe<X.length&&(pe=o(G,X,0,Pe,ce))===null;)Pe=c(X,Pe+1);return pe}e.matchesWords=i;function o(G,X,ce,pe,Pe){if(ce===G.length)return[];if(pe===X.length)return null;if(p(G.charCodeAt(ce),X.charCodeAt(pe))){let Ae=null,Ne=pe+1;if(Ae=o(G,X,ce+1,pe+1,Pe),!Pe)for(;!Ae&&(Ne=c(X,Ne))<X.length;)Ae=o(G,X,ce+1,Ne,Pe),Ne++;return Ae?G.charCodeAt(ce)!==X.charCodeAt(pe)?Ae:h({start:pe,end:pe+1},Ae):null}else return null}function c(G,X){for(let ce=X;ce<G.length;ce++)if(f(G.charCodeAt(ce))||ce>0&&f(G.charCodeAt(ce-1)))return ce;return G.length}const l=a(e.matchesPrefix,n,D),s=a(e.matchesPrefix,n,P),g=new E.LRUCache(1e4);function R(G,X,ce=!1){if(typeof G!="string"||typeof X!="string")return null;let pe=g.get(G);pe||(pe=new RegExp(A.convertSimple2RegExpPattern(G),"i"),g.set(G,pe));const Pe=pe.exec(X);return Pe?[{start:Pe.index,end:Pe.index+Pe[0].length}]:ce?s(G,X):l(G,X)}e.matchesFuzzy=R;function O(G,X){const ce=te(G,G.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?ie(ce):null}e.matchesFuzzy2=O;function z(G,X,ce,pe,Pe,Ae){const Ne=Math.min(13,G.length);for(;ce<Ne;ce++){const $e=te(G,X,ce,pe,Pe,Ae,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if($e)return $e}return[0,Ae]}e.anyScore=z;function ie(G){if(typeof G>"u")return[];const X=[],ce=G[1];for(let pe=G.length-1;pe>1;pe--){const Pe=G[pe]+ce,Ae=X[X.length-1];Ae&&Ae.end===Pe?Ae.end=Pe+1:X.push({start:Pe,end:Pe+1})}return X}e.createMatches=ie;const ee=128;function F(){const G=[],X=[];for(let ce=0;ce<=ee;ce++)X[ce]=0;for(let ce=0;ce<=ee;ce++)G.push(X.slice(0));return G}function Z(G){const X=[];for(let ce=0;ce<=G;ce++)X[ce]=0;return X}const $=Z(2*ee),x=Z(2*ee),le=F(),be=F(),Y=F(),H=!1;function U(G,X,ce,pe,Pe){function Ae($e,me,we=" "){for(;$e.length<me;)$e=we+$e;return $e}let Ne=` |   |${pe.split("").map($e=>Ae($e,3)).join("|")}
`;for(let $e=0;$e<=ce;$e++)$e===0?Ne+=" |":Ne+=`${X[$e-1]}|`,Ne+=G[$e].slice(0,Pe+1).map(me=>Ae(me.toString(),3)).join("|")+`
`;return Ne}function ne(G,X,ce,pe){G=G.substr(X),ce=ce.substr(pe),console.log(U(be,G,G.length,ce,ce.length)),console.log(U(Y,G,G.length,ce,ce.length)),console.log(U(le,G,G.length,ce,ce.length))}function se(G,X){if(X<0||X>=G.length)return!1;const ce=G.codePointAt(X);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(ce)}}function de(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function re(G,X,ce){return X[G]!==ce[G]}function j(G,X,ce,pe,Pe,Ae,Ne=!1){for(;X<ce&&Pe<Ae;)G[X]===pe[Pe]&&(Ne&&($[X]=Pe),X+=1),Pe+=1;return X===ce}e.isPatternInWord=j;var N;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(N||(N={}));var M;(function(G){G.Default=[-100,0];function X(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}G.isDefault=X})(M=e.FuzzyScore||(e.FuzzyScore={}));class q{constructor(X,ce){this.firstMatchCanBeWeak=X,this.boostFullMatch=ce}}q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=q;function te(G,X,ce,pe,Pe,Ae,Ne=q.default){const $e=G.length>ee?ee:G.length,me=pe.length>ee?ee:pe.length;if(ce>=$e||Ae>=me||$e-ce>me-Ae||!j(X,ce,$e,Pe,Ae,me,!0))return;ue($e,me,ce,Ae,X,Pe);let we=1,ye=1,Me=ce,je=Ae;const Ge=[!1];for(we=1,Me=ce;Me<$e;we++,Me++){const Ye=$[Me],xe=x[Me],_e=Me+1<$e?x[Me+1]:me;for(ye=Ye-Ae+1,je=Ye;je<_e;ye++,je++){let fe=Number.MIN_SAFE_INTEGER,Ie=!1;je<=xe&&(fe=W(G,X,Me,ce,pe,Pe,je,me,Ae,le[we-1][ye-1]===0,Ge));let Ce=0;fe!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ce=fe+be[we-1][ye-1]);const Te=je>Ye,Be=Te?be[we][ye-1]+(le[we][ye-1]>0?-5:0):0,ze=je>Ye+1&&le[we][ye-1]>0,Ve=ze?be[we][ye-2]+(le[we][ye-2]>0?-5:0):0;if(ze&&(!Te||Ve>=Be)&&(!Ie||Ve>=Ce))be[we][ye]=Ve,Y[we][ye]=3,le[we][ye]=0;else if(Te&&(!Ie||Be>=Ce))be[we][ye]=Be,Y[we][ye]=2,le[we][ye]=0;else if(Ie)be[we][ye]=Ce,Y[we][ye]=1,le[we][ye]=le[we-1][ye-1]+1;else throw new Error("not possible")}}if(H&&ne(G,ce,pe,Ae),!Ge[0]&&!Ne.firstMatchCanBeWeak)return;we--,ye--;const He=[be[we][ye],Ae];let Ke=0,Xe=0;for(;we>=1;){let Ye=ye;do{const xe=Y[we][Ye];if(xe===3)Ye=Ye-2;else if(xe===2)Ye=Ye-1;else break}while(Ye>=1);Ke>1&&X[ce+we-1]===Pe[Ae+ye-1]&&!re(Ye+Ae-1,pe,Pe)&&Ke+1>le[we][Ye]&&(Ye=ye),Ye===ye?Ke++:Ke=1,Xe||(Xe=Ye),we--,ye=Ye-1,He.push(ye)}me===$e&&Ne.boostFullMatch&&(He[0]+=2);const it=Xe-$e;return He[0]-=it,He}e.fuzzyScore=te;function ue(G,X,ce,pe,Pe,Ae){let Ne=G-1,$e=X-1;for(;Ne>=ce&&$e>=pe;)Pe[Ne]===Ae[$e]&&(x[Ne]=$e,Ne--),$e--}function W(G,X,ce,pe,Pe,Ae,Ne,$e,me,we,ye){if(X[ce]!==Ae[Ne])return Number.MIN_SAFE_INTEGER;let Me=1,je=!1;return Ne===ce-pe?Me=G[ce]===Pe[Ne]?7:5:re(Ne,Pe,Ae)&&(Ne===0||!re(Ne-1,Pe,Ae))?(Me=G[ce]===Pe[Ne]?7:5,je=!0):se(Ae,Ne)&&(Ne===0||!se(Ae,Ne-1))?Me=5:(se(Ae,Ne-1)||de(Ae,Ne-1))&&(Me=5,je=!0),Me>1&&ce===pe&&(ye[0]=!0),je||(je=re(Ne,Pe,Ae)||se(Ae,Ne-1)||de(Ae,Ne-1)),ce===pe?Ne>me&&(Me-=je?3:5):we?Me+=je?2:0:Me+=je?0:1,Ne+1===$e&&(Me-=je?3:5),Me}function K(G,X,ce,pe,Pe,Ae,Ne){return V(G,X,ce,pe,Pe,Ae,!0,Ne)}e.fuzzyScoreGracefulAggressive=K;function _(G,X,ce,pe,Pe,Ae,Ne){return V(G,X,ce,pe,Pe,Ae,!1,Ne)}e.fuzzyScoreGraceful=_;function V(G,X,ce,pe,Pe,Ae,Ne,$e){let me=te(G,X,ce,pe,Pe,Ae,$e);if(me&&!Ne)return me;if(G.length>=3){const we=Math.min(7,G.length-1);for(let ye=ce+1;ye<we;ye++){const Me=Q(G,ye);if(Me){const je=te(Me,Me.toLowerCase(),ce,pe,Pe,Ae,$e);je&&(je[0]-=3,(!me||je[0]>me[0])&&(me=je))}}}return me}function Q(G,X){if(X+1>=G.length)return;const ce=G[X],pe=G[X+1];if(ce!==pe)return G.slice(0,X)+pe+ce+G.slice(X+2)}}),define(ve[91],Ee([1,0,16]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(h){return a(h,0)}e.hash=A;function a(h,m){switch(typeof h){case"object":return h===null?I(349,m):Array.isArray(h)?w(h,m):y(h,m);case"string":return P(h,m);case"boolean":return D(h,m);case"number":return I(h,m);case"undefined":return I(937,m);default:return I(617,m)}}e.doHash=a;function I(h,m){return(m<<5)-m+h|0}e.numberHash=I;function D(h,m){return I(h?433:863,m)}function P(h,m){m=I(149417,m);for(let d=0,C=h.length;d<C;d++)m=I(h.charCodeAt(d),m);return m}e.stringHash=P;function w(h,m){return m=I(104579,m),h.reduce((d,C)=>a(C,d),m)}function y(h,m){return m=I(181387,m),Object.keys(h).sort().reduce((d,C)=>(d=P(C,d),a(h[C],d)),m)}class T{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=a(m,this.g),this.g}}e.Hasher=T;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function v(h,m,d=32){const C=d-m,k=~((1<<C)-1);return(h<<m|(k&h)>>>C)>>>0}function b(h,m=0,d=h.byteLength,C=0){for(let k=0;k<d;k++)h[m+k]=C}function f(h,m,d="0"){for(;h.length<m;)h=d+h;return h}function p(h,m=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):f((h>>>0).toString(16),m/4)}e.toHexString=p;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const d=m.length;if(d===0)return;const C=this.p;let k=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=m.charCodeAt(0),n=0);;){let i=r;if(E.isHighSurrogate(r))if(n+1<d){const o=m.charCodeAt(n+1);E.isLowSurrogate(o)?(n++,i=E.computeCodePoint(r,o)):i=65533}else{t=r;break}else E.isLowSurrogate(r)&&(i=65533);if(k=this.w(C,k,i),n++,n<d)r=m.charCodeAt(n);else break}this.r=k,this.u=t}w(m,d,C){return C<128?m[d++]=C:C<2048?(m[d++]=192|(C&1984)>>>6,m[d++]=128|(C&63)>>>0):C<65536?(m[d++]=224|(C&61440)>>>12,m[d++]=128|(C&4032)>>>6,m[d++]=128|(C&63)>>>0):(m[d++]=240|(C&1835008)>>>18,m[d++]=128|(C&258048)>>>12,m[d++]=128|(C&4032)>>>6,m[d++]=128|(C&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=u.g,d=this.q;for(let l=0;l<64;l+=4)m.setUint32(l,d.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)m.setUint32(l,v(m.getUint32(l-12,!1)^m.getUint32(l-32,!1)^m.getUint32(l-56,!1)^m.getUint32(l-64,!1),1),!1);let C=this.h,k=this.l,t=this.m,r=this.n,n=this.o,i,o,c;for(let l=0;l<80;l++)l<20?(i=k&t|~k&r,o=1518500249):l<40?(i=k^t^r,o=1859775393):l<60?(i=k&t|k&r|t&r,o=2400959708):(i=k^t^r,o=3395469782),c=v(C,5)+i+n+o+m.getUint32(l*4,!1)&4294967295,n=r,r=t,t=v(k,30),k=C,C=c;this.h=this.h+C&4294967295,this.l=this.l+k&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(ve[58],Ee([1,0,16]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(a){a[a.Ignore=0]="Ignore",a[a.Info=1]="Info",a[a.Warning=2]="Warning",a[a.Error=3]="Error"})(A||(A={})),function(a){const I="error",D="warning",P="warn",w="info",y="ignore";function T(v){return v?E.equalsIgnoreCase(I,v)?a.Error:E.equalsIgnoreCase(D,v)||E.equalsIgnoreCase(P,v)?a.Warning:E.equalsIgnoreCase(w,v)?a.Info:a.Ignore:a.Ignore}a.fromValue=T;function S(v){switch(v){case a.Error:return I;case a.Warning:return D;case a.Info:return w;default:return y}}a.toString=S}(A||(A={})),e.default=A}),define(ve[147],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ve[59],Ee([1,0,18,16]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class a{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),p=this.b.charCodeAt(this.c);return f-p}value(){return this.b[this.c]}}e.StringIterator=a;class I{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,A.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=I;class D{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const p=this.b.charCodeAt(f);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,A.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class w{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,A.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(T||(T={}));class S{static forUris(b=()=>!1,f=()=>!1){return new S(new w(b,f))}static forPaths(b=!1){return new S(new D(void 0,!b))}static forStrings(){return new S(new a)}static forConfigKeys(){return new S(new I)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const p=f.slice(0);(0,E.shuffle)(p);for(const u of p)this.set(u,b)}else{const p=b.slice(0);(0,E.shuffle)(p);for(const u of p)this.set(u[0],u[1])}}set(b,f){const p=this.b.reset(b);let u;this.c||(this.c=new y,this.c.segment=p.value());const h=[];for(u=this.c;;){const d=p.cmp(u.segment);if(d>0)u.left||(u.left=new y,u.left.segment=p.value()),h.push([-1,u]),u=u.left;else if(d<0)u.right||(u.right=new y,u.right.segment=p.value()),h.push([1,u]),u=u.right;else if(p.hasNext())p.next(),u.mid||(u.mid=new y,u.mid.segment=p.value()),h.push([0,u]),u=u.mid;else break}const m=u.value;u.value=f,u.key=b;for(let d=h.length-1;d>=0;d--){const C=h[d][1];C.updateHeight();const k=C.balanceFactor();if(k<-1||k>1){const t=h[d][0],r=h[d+1][0];if(t===1&&r===1)h[d][1]=C.rotateLeft();else if(t===-1&&r===-1)h[d][1]=C.rotateRight();else if(t===1&&r===-1)C.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=C.rotateLeft();else if(t===-1&&r===1)C.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=C.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return m}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let p=this.c;for(;p;){const u=f.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else break}return p}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const p=this.b.reset(b),u=[];let h=this.c;for(;h;){const m=p.cmp(h.segment);if(m>0)u.push([-1,h]),h=h.left;else if(m<0)u.push([1,h]),h=h.right;else if(p.hasNext())p.next(),u.push([0,h]),h=h.mid;else break}if(!!h){if(f?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this.f(h.right);if(m.key){const{key:d,value:C,segment:k}=m;this.e(m.key,!1),h.key=d,h.value=C,h.segment=k}}else{const m=h.left??h.right;if(u.length>0){const[d,C]=u[u.length-1];switch(d){case-1:C.left=m;break;case 0:C.mid=m;break;case 1:C.right=m;break}}else this.c=m}for(let m=u.length-1;m>=0;m--){const d=u[m][1];d.updateHeight();const C=d.balanceFactor();if(C>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),u[m][1]=d.rotateLeft()):C<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),u[m][1]=d.rotateRight()),m>0)switch(u[m-1][0]){case-1:u[m-1][1].left=u[m][1];break;case 1:u[m-1][1].right=u[m][1];break;case 0:u[m-1][1].mid=u[m][1];break}else this.c=u[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let p=this.c,u;for(;p;){const h=f.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(f.hasNext())f.next(),u=p.value||u,p=p.mid;else break}return p&&p.value||u}findSuperstr(b){return this.g(b,!1)}g(b,f){const p=this.b.reset(b);let u=this.c;for(;u;){const h=p.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(p.hasNext())p.next(),u=u.mid;else return u.mid?this.h(u.mid):f?u.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,p]of this)b(p,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){!b||(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const p=f.balanceFactor();return p<-1||p>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.TernarySearchTree=S}),define(ve[8],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function A(r){return Array.isArray(r)&&r.every(n=>E(n))}e.isStringArray=A;function a(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=a;function I(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=I;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function w(r){return r===!0||r===!1}e.isBoolean=w;function y(r){return typeof r>"u"}e.isUndefined=y;function T(r){return!S(r)}e.isDefined=T;function S(r){return y(r)||r===null}e.isUndefinedOrNull=S;function v(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=v;function b(r){if(S(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=b;function f(...r){const n=[];for(let i=0;i<r.length;i++){const o=r[i];if(S(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.assertAllDefined=f;const p=Object.prototype.hasOwnProperty;function u(r){if(!a(r))return!1;for(const n in r)if(p.call(r,n))return!1;return!0}e.isEmptyObject=u;function h(r){return typeof r=="function"}e.isFunction=h;function m(...r){return r.length>0&&r.every(h)}e.areFunctions=m;function d(r,n){const i=Math.min(r.length,n.length);for(let o=0;o<i;o++)C(r[o],n[o])}e.validateConstraints=d;function C(r,n){if(E(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(h(n)){try{if(r instanceof n)return}catch{}if(!S(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=C;function k(r){return r===null?void 0:r}e.withNullAsUndefined=k;function t(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=t}),define(ve[45],Ee([1,0,8]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function a(P,w){if((0,E.isString)(w)){const y=A[w];if(y===void 0)throw new Error(`${P} references an unknown codicon: ${w}`);w=y}return A[P]=w,{id:P}}function I(){return A}e.getCodiconFontCharacters=I;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:a("add",6e4),plus:a("plus",6e4),gistNew:a("gist-new",6e4),repoCreate:a("repo-create",6e4),lightbulb:a("lightbulb",60001),lightBulb:a("light-bulb",60001),repo:a("repo",60002),repoDelete:a("repo-delete",60002),gistFork:a("gist-fork",60003),repoForked:a("repo-forked",60003),gitPullRequest:a("git-pull-request",60004),gitPullRequestAbandoned:a("git-pull-request-abandoned",60004),recordKeys:a("record-keys",60005),keyboard:a("keyboard",60005),tag:a("tag",60006),tagAdd:a("tag-add",60006),tagRemove:a("tag-remove",60006),person:a("person",60007),personFollow:a("person-follow",60007),personOutline:a("person-outline",60007),personFilled:a("person-filled",60007),gitBranch:a("git-branch",60008),gitBranchCreate:a("git-branch-create",60008),gitBranchDelete:a("git-branch-delete",60008),sourceControl:a("source-control",60008),mirror:a("mirror",60009),mirrorPublic:a("mirror-public",60009),star:a("star",60010),starAdd:a("star-add",60010),starDelete:a("star-delete",60010),starEmpty:a("star-empty",60010),comment:a("comment",60011),commentAdd:a("comment-add",60011),alert:a("alert",60012),warning:a("warning",60012),search:a("search",60013),searchSave:a("search-save",60013),logOut:a("log-out",60014),signOut:a("sign-out",60014),logIn:a("log-in",60015),signIn:a("sign-in",60015),eye:a("eye",60016),eyeUnwatch:a("eye-unwatch",60016),eyeWatch:a("eye-watch",60016),circleFilled:a("circle-filled",60017),primitiveDot:a("primitive-dot",60017),closeDirty:a("close-dirty",60017),debugBreakpoint:a("debug-breakpoint",60017),debugBreakpointDisabled:a("debug-breakpoint-disabled",60017),debugHint:a("debug-hint",60017),primitiveSquare:a("primitive-square",60018),edit:a("edit",60019),pencil:a("pencil",60019),info:a("info",60020),issueOpened:a("issue-opened",60020),gistPrivate:a("gist-private",60021),gitForkPrivate:a("git-fork-private",60021),lock:a("lock",60021),mirrorPrivate:a("mirror-private",60021),close:a("close",60022),removeClose:a("remove-close",60022),x:a("x",60022),repoSync:a("repo-sync",60023),sync:a("sync",60023),clone:a("clone",60024),desktopDownload:a("desktop-download",60024),beaker:a("beaker",60025),microscope:a("microscope",60025),vm:a("vm",60026),deviceDesktop:a("device-desktop",60026),file:a("file",60027),fileText:a("file-text",60027),more:a("more",60028),ellipsis:a("ellipsis",60028),kebabHorizontal:a("kebab-horizontal",60028),mailReply:a("mail-reply",60029),reply:a("reply",60029),organization:a("organization",60030),organizationFilled:a("organization-filled",60030),organizationOutline:a("organization-outline",60030),newFile:a("new-file",60031),fileAdd:a("file-add",60031),newFolder:a("new-folder",60032),fileDirectoryCreate:a("file-directory-create",60032),trash:a("trash",60033),trashcan:a("trashcan",60033),history:a("history",60034),clock:a("clock",60034),folder:a("folder",60035),fileDirectory:a("file-directory",60035),symbolFolder:a("symbol-folder",60035),logoGithub:a("logo-github",60036),markGithub:a("mark-github",60036),github:a("github",60036),terminal:a("terminal",60037),console:a("console",60037),repl:a("repl",60037),zap:a("zap",60038),symbolEvent:a("symbol-event",60038),error:a("error",60039),stop:a("stop",60039),variable:a("variable",60040),symbolVariable:a("symbol-variable",60040),array:a("array",60042),symbolArray:a("symbol-array",60042),symbolModule:a("symbol-module",60043),symbolPackage:a("symbol-package",60043),symbolNamespace:a("symbol-namespace",60043),symbolObject:a("symbol-object",60043),symbolMethod:a("symbol-method",60044),symbolFunction:a("symbol-function",60044),symbolConstructor:a("symbol-constructor",60044),symbolBoolean:a("symbol-boolean",60047),symbolNull:a("symbol-null",60047),symbolNumeric:a("symbol-numeric",60048),symbolNumber:a("symbol-number",60048),symbolStructure:a("symbol-structure",60049),symbolStruct:a("symbol-struct",60049),symbolParameter:a("symbol-parameter",60050),symbolTypeParameter:a("symbol-type-parameter",60050),symbolKey:a("symbol-key",60051),symbolText:a("symbol-text",60051),symbolReference:a("symbol-reference",60052),goToFile:a("go-to-file",60052),symbolEnum:a("symbol-enum",60053),symbolValue:a("symbol-value",60053),symbolRuler:a("symbol-ruler",60054),symbolUnit:a("symbol-unit",60054),activateBreakpoints:a("activate-breakpoints",60055),archive:a("archive",60056),arrowBoth:a("arrow-both",60057),arrowDown:a("arrow-down",60058),arrowLeft:a("arrow-left",60059),arrowRight:a("arrow-right",60060),arrowSmallDown:a("arrow-small-down",60061),arrowSmallLeft:a("arrow-small-left",60062),arrowSmallRight:a("arrow-small-right",60063),arrowSmallUp:a("arrow-small-up",60064),arrowUp:a("arrow-up",60065),bell:a("bell",60066),bold:a("bold",60067),book:a("book",60068),bookmark:a("bookmark",60069),debugBreakpointConditionalUnverified:a("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:a("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:a("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:a("debug-breakpoint-data-unverified",60072),debugBreakpointData:a("debug-breakpoint-data",60073),debugBreakpointDataDisabled:a("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:a("debug-breakpoint-log-unverified",60074),debugBreakpointLog:a("debug-breakpoint-log",60075),debugBreakpointLogDisabled:a("debug-breakpoint-log-disabled",60075),briefcase:a("briefcase",60076),broadcast:a("broadcast",60077),browser:a("browser",60078),bug:a("bug",60079),calendar:a("calendar",60080),caseSensitive:a("case-sensitive",60081),check:a("check",60082),checklist:a("checklist",60083),chevronDown:a("chevron-down",60084),dropDownButton:a("drop-down-button",60084),chevronLeft:a("chevron-left",60085),chevronRight:a("chevron-right",60086),chevronUp:a("chevron-up",60087),chromeClose:a("chrome-close",60088),chromeMaximize:a("chrome-maximize",60089),chromeMinimize:a("chrome-minimize",60090),chromeRestore:a("chrome-restore",60091),circle:a("circle",60092),circleOutline:a("circle-outline",60092),debugBreakpointUnverified:a("debug-breakpoint-unverified",60092),circleSlash:a("circle-slash",60093),circuitBoard:a("circuit-board",60094),clearAll:a("clear-all",60095),clippy:a("clippy",60096),closeAll:a("close-all",60097),cloudDownload:a("cloud-download",60098),cloudUpload:a("cloud-upload",60099),code:a("code",60100),collapseAll:a("collapse-all",60101),colorMode:a("color-mode",60102),commentDiscussion:a("comment-discussion",60103),compareChanges:a("compare-changes",60157),creditCard:a("credit-card",60105),dash:a("dash",60108),dashboard:a("dashboard",60109),database:a("database",60110),debugContinue:a("debug-continue",60111),debugDisconnect:a("debug-disconnect",60112),debugPause:a("debug-pause",60113),debugRestart:a("debug-restart",60114),debugStart:a("debug-start",60115),debugStepInto:a("debug-step-into",60116),debugStepOut:a("debug-step-out",60117),debugStepOver:a("debug-step-over",60118),debugStop:a("debug-stop",60119),debug:a("debug",60120),deviceCameraVideo:a("device-camera-video",60121),deviceCamera:a("device-camera",60122),deviceMobile:a("device-mobile",60123),diffAdded:a("diff-added",60124),diffIgnored:a("diff-ignored",60125),diffModified:a("diff-modified",60126),diffRemoved:a("diff-removed",60127),diffRenamed:a("diff-renamed",60128),diff:a("diff",60129),discard:a("discard",60130),editorLayout:a("editor-layout",60131),emptyWindow:a("empty-window",60132),exclude:a("exclude",60133),extensions:a("extensions",60134),eyeClosed:a("eye-closed",60135),fileBinary:a("file-binary",60136),fileCode:a("file-code",60137),fileMedia:a("file-media",60138),filePdf:a("file-pdf",60139),fileSubmodule:a("file-submodule",60140),fileSymlinkDirectory:a("file-symlink-directory",60141),fileSymlinkFile:a("file-symlink-file",60142),fileZip:a("file-zip",60143),files:a("files",60144),filter:a("filter",60145),flame:a("flame",60146),foldDown:a("fold-down",60147),foldUp:a("fold-up",60148),fold:a("fold",60149),folderActive:a("folder-active",60150),folderOpened:a("folder-opened",60151),gear:a("gear",60152),gift:a("gift",60153),gistSecret:a("gist-secret",60154),gist:a("gist",60155),gitCommit:a("git-commit",60156),gitCompare:a("git-compare",60157),gitMerge:a("git-merge",60158),githubAction:a("github-action",60159),githubAlt:a("github-alt",60160),globe:a("globe",60161),grabber:a("grabber",60162),graph:a("graph",60163),gripper:a("gripper",60164),heart:a("heart",60165),home:a("home",60166),horizontalRule:a("horizontal-rule",60167),hubot:a("hubot",60168),inbox:a("inbox",60169),issueClosed:a("issue-closed",60324),issueReopened:a("issue-reopened",60171),issues:a("issues",60172),italic:a("italic",60173),jersey:a("jersey",60174),json:a("json",60175),bracket:a("bracket",60175),kebabVertical:a("kebab-vertical",60176),key:a("key",60177),law:a("law",60178),lightbulbAutofix:a("lightbulb-autofix",60179),linkExternal:a("link-external",60180),link:a("link",60181),listOrdered:a("list-ordered",60182),listUnordered:a("list-unordered",60183),liveShare:a("live-share",60184),loading:a("loading",60185),location:a("location",60186),mailRead:a("mail-read",60187),mail:a("mail",60188),markdown:a("markdown",60189),megaphone:a("megaphone",60190),mention:a("mention",60191),milestone:a("milestone",60192),mortarBoard:a("mortar-board",60193),move:a("move",60194),multipleWindows:a("multiple-windows",60195),mute:a("mute",60196),noNewline:a("no-newline",60197),note:a("note",60198),octoface:a("octoface",60199),openPreview:a("open-preview",60200),package_:a("package",60201),paintcan:a("paintcan",60202),pin:a("pin",60203),play:a("play",60204),run:a("run",60204),plug:a("plug",60205),preserveCase:a("preserve-case",60206),preview:a("preview",60207),project:a("project",60208),pulse:a("pulse",60209),question:a("question",60210),quote:a("quote",60211),radioTower:a("radio-tower",60212),reactions:a("reactions",60213),references:a("references",60214),refresh:a("refresh",60215),regex:a("regex",60216),remoteExplorer:a("remote-explorer",60217),remote:a("remote",60218),remove:a("remove",60219),replaceAll:a("replace-all",60220),replace:a("replace",60221),repoClone:a("repo-clone",60222),repoForcePush:a("repo-force-push",60223),repoPull:a("repo-pull",60224),repoPush:a("repo-push",60225),report:a("report",60226),requestChanges:a("request-changes",60227),rocket:a("rocket",60228),rootFolderOpened:a("root-folder-opened",60229),rootFolder:a("root-folder",60230),rss:a("rss",60231),ruby:a("ruby",60232),saveAll:a("save-all",60233),saveAs:a("save-as",60234),save:a("save",60235),screenFull:a("screen-full",60236),screenNormal:a("screen-normal",60237),searchStop:a("search-stop",60238),server:a("server",60240),settingsGear:a("settings-gear",60241),settings:a("settings",60242),shield:a("shield",60243),smiley:a("smiley",60244),sortPrecedence:a("sort-precedence",60245),splitHorizontal:a("split-horizontal",60246),splitVertical:a("split-vertical",60247),squirrel:a("squirrel",60248),starFull:a("star-full",60249),starHalf:a("star-half",60250),symbolClass:a("symbol-class",60251),symbolColor:a("symbol-color",60252),symbolCustomColor:a("symbol-customcolor",60252),symbolConstant:a("symbol-constant",60253),symbolEnumMember:a("symbol-enum-member",60254),symbolField:a("symbol-field",60255),symbolFile:a("symbol-file",60256),symbolInterface:a("symbol-interface",60257),symbolKeyword:a("symbol-keyword",60258),symbolMisc:a("symbol-misc",60259),symbolOperator:a("symbol-operator",60260),symbolProperty:a("symbol-property",60261),wrench:a("wrench",60261),wrenchSubaction:a("wrench-subaction",60261),symbolSnippet:a("symbol-snippet",60262),tasklist:a("tasklist",60263),telescope:a("telescope",60264),textSize:a("text-size",60265),threeBars:a("three-bars",60266),thumbsdown:a("thumbsdown",60267),thumbsup:a("thumbsup",60268),tools:a("tools",60269),triangleDown:a("triangle-down",60270),triangleLeft:a("triangle-left",60271),triangleRight:a("triangle-right",60272),triangleUp:a("triangle-up",60273),twitter:a("twitter",60274),unfold:a("unfold",60275),unlock:a("unlock",60276),unmute:a("unmute",60277),unverified:a("unverified",60278),verified:a("verified",60279),versions:a("versions",60280),vmActive:a("vm-active",60281),vmOutline:a("vm-outline",60282),vmRunning:a("vm-running",60283),watch:a("watch",60284),whitespace:a("whitespace",60285),wholeWord:a("whole-word",60286),window:a("window",60287),wordWrap:a("word-wrap",60288),zoomIn:a("zoom-in",60289),zoomOut:a("zoom-out",60290),listFilter:a("list-filter",60291),listFlat:a("list-flat",60292),listSelection:a("list-selection",60293),selection:a("selection",60293),listTree:a("list-tree",60294),debugBreakpointFunctionUnverified:a("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:a("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:a("debug-breakpoint-function-disabled",60296),debugStackframeActive:a("debug-stackframe-active",60297),circleSmallFilled:a("circle-small-filled",60298),debugStackframeDot:a("debug-stackframe-dot",60298),debugStackframe:a("debug-stackframe",60299),debugStackframeFocused:a("debug-stackframe-focused",60299),debugBreakpointUnsupported:a("debug-breakpoint-unsupported",60300),symbolString:a("symbol-string",60301),debugReverseContinue:a("debug-reverse-continue",60302),debugStepBack:a("debug-step-back",60303),debugRestartFrame:a("debug-restart-frame",60304),callIncoming:a("call-incoming",60306),callOutgoing:a("call-outgoing",60307),menu:a("menu",60308),expandAll:a("expand-all",60309),feedback:a("feedback",60310),groupByRefType:a("group-by-ref-type",60311),ungroupByRefType:a("ungroup-by-ref-type",60312),account:a("account",60313),bellDot:a("bell-dot",60314),debugConsole:a("debug-console",60315),library:a("library",60316),output:a("output",60317),runAll:a("run-all",60318),syncIgnored:a("sync-ignored",60319),pinned:a("pinned",60320),githubInverted:a("github-inverted",60321),debugAlt:a("debug-alt",60305),serverProcess:a("server-process",60322),serverEnvironment:a("server-environment",60323),pass:a("pass",60324),stopCircle:a("stop-circle",60325),playCircle:a("play-circle",60326),record:a("record",60327),debugAltSmall:a("debug-alt-small",60328),vmConnect:a("vm-connect",60329),cloud:a("cloud",60330),merge:a("merge",60331),exportIcon:a("export",60332),graphLeft:a("graph-left",60333),magnet:a("magnet",60334),notebook:a("notebook",60335),redo:a("redo",60336),checkAll:a("check-all",60337),pinnedDirty:a("pinned-dirty",60338),passFilled:a("pass-filled",60339),circleLargeFilled:a("circle-large-filled",60340),circleLarge:a("circle-large",60341),circleLargeOutline:a("circle-large-outline",60341),combine:a("combine",60342),gather:a("gather",60342),table:a("table",60343),variableGroup:a("variable-group",60344),typeHierarchy:a("type-hierarchy",60345),typeHierarchySub:a("type-hierarchy-sub",60346),typeHierarchySuper:a("type-hierarchy-super",60347),gitPullRequestCreate:a("git-pull-request-create",60348),runAbove:a("run-above",60349),runBelow:a("run-below",60350),notebookTemplate:a("notebook-template",60351),debugRerun:a("debug-rerun",60352),workspaceTrusted:a("workspace-trusted",60353),workspaceUntrusted:a("workspace-untrusted",60354),workspaceUnspecified:a("workspace-unspecified",60355),terminalCmd:a("terminal-cmd",60356),terminalDebian:a("terminal-debian",60357),terminalLinux:a("terminal-linux",60358),terminalPowershell:a("terminal-powershell",60359),terminalTmux:a("terminal-tmux",60360),terminalUbuntu:a("terminal-ubuntu",60361),terminalBash:a("terminal-bash",60362),arrowSwap:a("arrow-swap",60363),copy:a("copy",60364),personAdd:a("person-add",60365),filterFilled:a("filter-filled",60366),wand:a("wand",60367),debugLineByLine:a("debug-line-by-line",60368),inspect:a("inspect",60369),layers:a("layers",60370),layersDot:a("layers-dot",60371),layersActive:a("layers-active",60372),compass:a("compass",60373),compassDot:a("compass-dot",60374),compassActive:a("compass-active",60375),azure:a("azure",60376),issueDraft:a("issue-draft",60377),gitPullRequestClosed:a("git-pull-request-closed",60378),gitPullRequestDraft:a("git-pull-request-draft",60379),debugAll:a("debug-all",60380),debugCoverage:a("debug-coverage",60381),runErrors:a("run-errors",60382),folderLibrary:a("folder-library",60383),debugContinueSmall:a("debug-continue-small",60384),beakerStop:a("beaker-stop",60385),graphLine:a("graph-line",60386),graphScatter:a("graph-scatter",60387),pieChart:a("pie-chart",60388),bracketDot:a("bracket-dot",60389),bracketError:a("bracket-error",60390),lockSmall:a("lock-small",60391),azureDevops:a("azure-devops",60392),verifiedFilled:a("verified-filled",60393),newLine:a("newline",60394),layout:a("layout",60395),layoutActivitybarLeft:a("layout-activitybar-left",60396),layoutActivitybarRight:a("layout-activitybar-right",60397),layoutPanelLeft:a("layout-panel-left",60398),layoutPanelCenter:a("layout-panel-center",60399),layoutPanelJustify:a("layout-panel-justify",60400),layoutPanelRight:a("layout-panel-right",60401),layoutPanel:a("layout-panel",60402),layoutSidebarLeft:a("layout-sidebar-left",60403),layoutSidebarRight:a("layout-sidebar-right",60404),layoutStatusbar:a("layout-statusbar",60405),layoutMenubar:a("layout-menubar",60406),layoutCentered:a("layout-centered",60407),layoutSidebarRightOff:a("layout-sidebar-right-off",60416),layoutPanelOff:a("layout-panel-off",60417),layoutSidebarLeftOff:a("layout-sidebar-left-off",60418),target:a("target",60408),indent:a("indent",60409),recordSmall:a("record-small",60410),errorSmall:a("error-small",60411),arrowCircleDown:a("arrow-circle-down",60412),arrowCircleLeft:a("arrow-circle-left",60413),arrowCircleRight:a("arrow-circle-right",60414),arrowCircleUp:a("arrow-circle-up",60415),heartFilled:a("heart-filled",60420),map:a("map",60421),mapFilled:a("map-filled",60422),circleSmall:a("circle-small",60423),bellSlash:a("bell-slash",60424),bellSlashDot:a("bell-slash-dot",60425),commentUnresolved:a("comment-unresolved",60426),gitPullRequestGoToChanges:a("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:a("git-pull-request-new-changes",60428),searchFuzzy:a("search-fuzzy",60429),commentDraft:a("comment-draft",60430),dialogError:a("dialog-error","error"),dialogWarning:a("dialog-warning","warning"),dialogInfo:a("dialog-info","info"),dialogClose:a("dialog-close","close"),treeItemExpanded:a("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:a("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:a("tree-filter-on-type-off","list-selection"),treeFilterClear:a("tree-filter-clear","close"),treeItemLoading:a("tree-item-loading","loading"),menuSelection:a("menu-selection","check"),menuSubmenu:a("menu-submenu","chevron-right"),menuBarMore:a("menubar-more","more"),scrollbarButtonLeft:a("scrollbar-button-left","triangle-left"),scrollbarButtonRight:a("scrollbar-button-right","triangle-right"),scrollbarButtonUp:a("scrollbar-button-up","triangle-up"),scrollbarButtonDown:a("scrollbar-button-down","triangle-down"),toolBarMore:a("toolbar-more","more"),quickInputBack:a("quick-input-back","arrow-left")}}),define(ve[37],Ee([1,0,7,3,16,8]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function P(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function w(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function y(o,c=E.posix.sep){if(!o)return"";const l=o.length,s=o.charCodeAt(0);if(D(s)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let R=3;const O=R;for(;R<l&&!D(o.charCodeAt(R));R++);if(O!==R&&!D(o.charCodeAt(R+1))){for(R+=1;R<l;R++)if(D(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,c)}}return c}else if(h(s)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<l;g++)if(D(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=y;function T(o){if(!A.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let l=2;const s=l;for(;l<o.length&&(c=o.charCodeAt(l),c!==92);l++);return!(s===l||(c=o.charCodeAt(l+1),isNaN(c)||c===92))}e.isUNC=T;const S=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(o,c=A.isWindows){const l=c?S:v;return!(!o||o.length===0||/^\s+$/.test(o)||(l.lastIndex=0,l.test(o))||c&&b.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=f;function p(o,c,l){const s=o===c;return!l||s?s:!o||!c?!1:(0,a.equalsIgnoreCase)(o,c)}e.isEqual=p;function u(o,c,l,s=E.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(l){if(!(0,a.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let R=c.length;return c.charAt(c.length-1)===s&&R--,o.charAt(R)===s}return c.charAt(c.length-1)!==s&&(c+=s),o.indexOf(c)===0}e.isEqualOrParent=u;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function m(o,c){return A.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(c,o)),o=(0,E.normalize)(o),A.isWindows?(o=(0,a.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,a.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=m;function d(o){const c=(0,E.normalize)(o);return A.isWindows?o.length>3?!1:C(c)&&(o.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=d;function C(o,c=A.isWindows){return c?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function k(o){return C(o)?o[0]:void 0}e.getDriveLetter=k;function t(o,c,l){return c.length>o.length?-1:o===c?0:(l&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=t;function r(o){const c=o.split(":");let l,s,g;for(const R of c){const O=Number(R);(0,I.isNumber)(O)?s===void 0?s=O:g===void 0&&(g=O):l=l?[l,R].join(":"):R}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:s!==void 0?s:void 0,column:g!==void 0?g:s!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,c,l=8){let s="";for(let R=0;R<l;R++)s+=n.charAt(Math.floor(Math.random()*n.length));let g;return c?g=`${c}-${s}`:g=s,o?(0,E.join)(o,g):g}e.randomPath=i}),define(ve[23],Ee([1,0,8]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([d,C])=>{m[d]=C&&typeof C=="object"?A(C):C}),m}e.deepClone=A;function a(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const d=m.shift();Object.freeze(d);for(const C in d)if(I.call(d,C)){const k=d[C];typeof k=="object"&&!Object.isFrozen(k)&&!(0,E.isTypedArray)(k)&&m.push(k)}}return h}e.deepFreeze=a;const I=Object.prototype.hasOwnProperty;function D(h,m){return P(h,m,new Set)}e.cloneAndChange=D;function P(h,m,d){if((0,E.isUndefinedOrNull)(h))return h;const C=m(h);if(typeof C<"u")return C;if(Array.isArray(h)){const k=[];for(const t of h)k.push(P(t,m,d));return k}if((0,E.isObject)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const k={};for(const t in h)I.call(h,t)&&(k[t]=P(h[t],m,d));return d.delete(h),k}return h}function w(h,m,d=!0){return(0,E.isObject)(h)?((0,E.isObject)(m)&&Object.keys(m).forEach(C=>{C in h?d&&((0,E.isObject)(h[C])&&(0,E.isObject)(m[C])?w(h[C],m[C],d):h[C]=m[C]):h[C]=m[C]}),h):m}e.mixin=w;function y(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let d,C;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(d=0;d<h.length;d++)if(!y(h[d],m[d]))return!1}else{const k=[];for(C in h)k.push(C);k.sort();const t=[];for(C in m)t.push(C);if(t.sort(),!y(k,t))return!1;for(d=0;d<k.length;d++)if(!y(h[k[d]],m[k[d]]))return!1}return!0}e.equals=y;function T(h){const m=new Set;return JSON.stringify(h,(d,C)=>{if((0,E.isObject)(C)||Array.isArray(C)){if(m.has(C))return"[Circular]";m.add(C)}return C})}e.safeStringify=T;function S(h,m){const d=Object.create(null);return!h||!m||Object.keys(m).forEach(k=>{const t=h[k],r=m[k];y(t,r)||(d[k]=r)}),d}e.distinct=S;function v(h,m){const d=m.toLowerCase(),C=Object.keys(h).find(k=>k.toLowerCase()===d);return C?h[C]:h[m]}e.getCaseInsensitive=v;function b(h,m){const d=Object.create(null);for(const[C,k]of Object.entries(h))m(C,k)&&(d[C]=k);return d}e.filter=b;function f(h){let m=[],d=Object.getPrototypeOf(h);for(;Object.prototype!==d;)m=m.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return m}e.getAllPropertyNames=f;function p(h){const m=[];for(const d of f(h))typeof h[d]=="function"&&m.push(d);return m}e.getAllMethodNames=p;function u(h,m){const d=k=>function(){const t=Array.prototype.slice.call(arguments,0);return m(k,t)},C={};for(const k of h)C[k]=d(k);return C}e.createProxyObject=u}),define(ve[92],Ee([1,0,45]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(D){function P(w){return w&&typeof w=="object"&&typeof w.id=="string"}D.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function a(D){return{id:D}}e.themeColorFromId=a;var I;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function w(m){const d=P.exec(m.id);if(!d)return w(E.Codicon.error);const[,C,k]=d,t=["codicon","codicon-"+C];return k&&t.push("codicon-modifier-"+k.substring(1)),t}D.asClassNameArray=w;function y(m){return w(m).join(" ")}D.asClassName=y;function T(m){return"."+w(m).join(".")}D.asCSSSelector=T;function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||A.isThemeColor(m.color))}D.isThemeIcon=S;const v=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function b(m){const d=v.exec(m);if(!d)return;const[,C]=d;return{id:C}}D.fromString=b;function f(m){return{id:m}}D.fromId=f;function p(m,d){let C=m.id;const k=C.lastIndexOf("~");return k!==-1&&(C=C.substring(0,k)),d&&(C=`${C}~${d}`),{id:C}}D.modify=p;function u(m){const d=m.id.lastIndexOf("~");if(d!==-1)return m.id.substring(d+1)}D.getModifier=u;function h(m,d){return m.id===d.id&&m.color?.id===d.color?.id}D.isEqual=h})(I=e.ThemeIcon||(e.ThemeIcon={}))}),define(ve[148],Ee([1,0,146,16,92]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const I="$(",D=new RegExp(`\\$\\(${a.ThemeIcon.iconNameExpression}(?:${a.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${D.source}`,"g");function w(h){return h.replace(P,(m,d)=>d?m:`\\${m}`)}e.escapeIcons=w;const y=new RegExp(`\\\\${D.source}`,"g");function T(h){return h.replace(y,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=T;const S=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function v(h){return h.indexOf(I)===-1?h:h.replace(S,(m,d,C,k)=>C?m:d||k||"")}e.stripIcons=v;function b(h){return h?h.replace(/\$\((.*?)\)/g,(m,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=b;const f=new RegExp(`\\$\\(${a.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(h){f.lastIndex=0;let m="";const d=[];let C=0;for(;;){const k=f.lastIndex,t=f.exec(h),r=h.substring(k,t?.index);if(r.length>0){m+=r;for(let n=0;n<r.length;n++)d.push(C)}if(!t)break;C+=t[0].length}return{text:m,iconOffsets:d}}e.parseLabelWithIcons=p;function u(h,m,d=!1){const{text:C,iconOffsets:k}=m;if(!k||k.length===0)return(0,E.matchesFuzzy)(h,C,d);const t=(0,A.ltrim)(C," "),r=C.length-t.length,n=(0,E.matchesFuzzy)(h,t,d);if(n)for(const i of n){const o=k[i.start+r]+r;i.start+=o,i.end+=o}return n}e.matchesFuzzyIconAware=u}),define(ve[4],Ee([1,0,7,3]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const a=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//;function P(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!a.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!I.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,i){return!n&&!i?"file":n}function y(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==S&&(i=S+i):i=S;break}return i}const T="",S="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,c,l,s,g=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=w(i,g),this.authority=o||T,this.path=y(this.scheme,c||T),this.query=l||T,this.fragment=s||T,P(this,g))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:c,path:l,query:s,fragment:g}=i;return o===void 0?o=this.scheme:o===null&&(o=T),c===void 0?c=this.authority:c===null&&(c=T),l===void 0?l=this.path:l===null&&(l=T),s===void 0?s=this.query:s===null&&(s=T),g===void 0?g=this.fragment:g===null&&(g=T),o===this.scheme&&c===this.authority&&l===this.path&&s===this.query&&g===this.fragment?this:new p(o,c,l,s,g)}static parse(i,o=!1){const c=v.exec(i);return c?new p(c[2]||T,r(c[4]||T),r(c[5]||T),r(c[7]||T),r(c[9]||T),o):new p(T,T,T,T,T)}static file(i){let o=T;if(A.isWindows&&(i=i.replace(/\\/g,S)),i[0]===S&&i[1]===S){const c=i.indexOf(S,2);c===-1?(o=i.substring(2),i=S):(o=i.substring(2,c),i=i.substring(c)||S)}return new p("file",o,i,T,T)}static from(i){const o=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return P(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return A.isWindows&&i.scheme==="file"?c=b.file(E.win32.join(d(i,!0),...o)).path:c=E.posix.join(i.path,...o),i.with({path:c})}toString(i=!1){return C(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const o=new p(i);return o._formatted=i.external,o._fsPath=i._sep===f?i.fsPath:null,o}}else return i}}e.URI=b;const f=A.isWindows?1:void 0;class p extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=f),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(n,i,o){let c,l=-1;for(let s=0;s<n.length;s++){const g=n.charCodeAt(s);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||i&&g===47||o&&g===91||o&&g===93||o&&g===58)l!==-1&&(c+=encodeURIComponent(n.substring(l,s)),l=-1),c!==void 0&&(c+=n.charAt(s));else{c===void 0&&(c=n.substr(0,s));const R=u[g];R!==void 0?(l!==-1&&(c+=encodeURIComponent(n.substring(l,s)),l=-1),c+=R):l===-1&&(l=s)}}return l!==-1&&(c+=encodeURIComponent(n.substring(l))),c!==void 0?c:n}function m(n){let i;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);c===35||c===63?(i===void 0&&(i=n.substr(0,o)),i+=u[c]):i!==void 0&&(i+=n[o])}return i!==void 0?i:n}function d(n,i){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,A.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function C(n,i){const o=i?m:h;let c="",{scheme:l,authority:s,path:g,query:R,fragment:O}=n;if(l&&(c+=l,c+=":"),(s||l==="file")&&(c+=S,c+=S),s){let z=s.indexOf("@");if(z!==-1){const ie=s.substr(0,z);s=s.substr(z+1),z=ie.lastIndexOf(":"),z===-1?c+=o(ie,!1,!1):(c+=o(ie.substr(0,z),!1,!1),c+=":",c+=o(ie.substr(z+1),!1,!0)),c+="@"}s=s.toLowerCase(),z=s.lastIndexOf(":"),z===-1?c+=o(s,!1,!0):(c+=o(s.substr(0,z),!1,!0),c+=s.substr(z))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const z=g.charCodeAt(1);z>=65&&z<=90&&(g=`/${String.fromCharCode(z+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const z=g.charCodeAt(0);z>=65&&z<=90&&(g=`${String.fromCharCode(z+32)}:${g.substr(2)}`)}c+=o(g,!0,!1)}return R&&(c+="?",c+=o(R,!1,!1)),O&&(c+="#",c+=i?O:h(O,!1,!1)),c}function k(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+k(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,i=>k(i)):n}}),define(ve[149],Ee([1,0,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(y){const T=y;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=A;function a(y){const T=[];let S;try{const v=JSON.parse(y.arguments),b=v[v.length-1];b&&b.__$stack&&(v.pop(),S=b.__$stack),T.push(...v)}catch{T.push("Unable to log remote console arguments",y.arguments)}return{args:T,stack:S}}e.parse=a;function I(y){if(typeof y!="string")return I(a(y).stack);const T=y;if(T){const S=D(T),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(v&&v.length===4)return{uri:E.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=I;function D(y){if(!y)return y;const T=y.indexOf(`
`);return T===-1?y:y.substring(0,T)}function P(y,T){const{args:S,stack:v}=a(y),b=typeof S[0]=="string"&&S.length===1;let f=D(v);f&&(f=`(${f.trim()})`);let p=[];if(typeof S[0]=="string"?f&&b?p=[`%c[${T}] %c${S[0]} %c${f}`,w("blue"),w(""),w("grey")]:p=[`%c[${T}] %c${S[0]}`,w("blue"),w(""),...S.slice(1)]:p=[`%c[${T}]%`,w("blue"),...S],f&&!b&&p.push(f),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,p)}e.log=P;function w(y){return`color: ${y}`}}),define(ve[46],Ee([1,0,15,16,4]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(y){return JSON.stringify(y,P)}e.stringify=I;function D(y){let T=JSON.parse(y);return T=w(T),T}e.parse=D;function P(y,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,A.regExpFlags)(T)}:T}function w(y,T=0){if(!y||T>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return a.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof E.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let S=0;S<y.length;++S)y[S]=w(y[S],T+1);else for(const S in y)Object.hasOwnProperty.call(y,S)&&(y[S]=w(y[S],T+1))}return y}e.revive=w}),define(ve[13],Ee([1,0,9,3,4]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${I.vscodeRemoteResource}`}set(T,S,v){this.a[T]=S,this.b[T]=v}setConnectionToken(T,S){this.c[T]=S}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(u){return E.onUnexpectedError(u),T}const S=T.authority;let v=this.a[S];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const b=this.b[S],f=this.c[S];let p=`path=${encodeURIComponent(T.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),a.URI.from({scheme:A.isWeb?this.d:I.vscodeRemoteResource,authority:`${v}:${b}`,path:A.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:p})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(T){const S=this.b(T,ae);return this.uriToBrowserUri(S)}uriToBrowserUri(T){return T.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===I.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${I.vscodeFileResource}://${P.a}`)?T.with({scheme:I.vscodeFileResource,authority:T.authority||P.a,query:null,fragment:null}):T}asFileUri(T){const S=this.b(T,ae);return this.uriToFileUri(S)}uriToFileUri(T){return T.scheme===I.vscodeFileResource?T.with({scheme:I.file,authority:T.authority!==P.a?T.authority:null,query:null,fragment:null}):T}b(T,S){return a.URI.isUri(T)?T:a.URI.parse(S.toUrl(T))}}P.a="vscode-app",e.FileAccess=new P;var w;(function(y){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(T.get("3"));const S="vscode-coi";function v(f){let p;typeof f=="string"?p=new URL(f).searchParams:f instanceof URL?p=f.searchParams:a.URI.isUri(f)&&(p=new URL(f.toString(!0)).searchParams);const u=p?.get(S);if(!!u)return T.get(u)}y.getHeadersFromQuery=v;function b(f,p,u){if(!globalThis.crossOriginIsolated)return;const h=p&&u?"3":u?"2":"1";f instanceof URLSearchParams?f.set(S,h):f[S]=h}y.addSearchParam=b})(w=e.COI||(e.COI={}))}),define(ve[20],Ee([1,0,37,13,7,3,16,4]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(b){return(0,P.uriToFsPath)(b,!0)}e.originalFSPath=w;class y{constructor(f){this.a=f}compare(f,p,u=!1){return f===p?0:(0,D.compare)(this.getComparisonKey(f,u),this.getComparisonKey(p,u))}isEqual(f,p,u=!1){return f===p?!0:!f||!p?!1:this.getComparisonKey(f,u)===this.getComparisonKey(p,u)}getComparisonKey(f,p=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,p,u=!1){if(f.scheme===p.scheme){if(f.scheme===A.Schemas.file)return E.isEqualOrParent(w(f),w(p),this.a(f))&&f.query===p.query&&(u||f.fragment===p.fragment);if((0,e.isEqualAuthority)(f.authority,p.authority))return E.isEqualOrParent(f.path,p.path,this.a(f),"/")&&f.query===p.query&&(u||f.fragment===p.fragment)}return!1}joinPath(f,...p){return P.URI.joinPath(f,...p)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return a.posix.basename(f.path)}extname(f){return a.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let p;return f.scheme===A.Schemas.file?p=P.URI.file(a.dirname(w(f))).path:(p=a.posix.dirname(f.path),f.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),p="/")),f.with({path:p})}normalizePath(f){if(!f.path.length)return f;let p;return f.scheme===A.Schemas.file?p=P.URI.file(a.normalize(w(f))).path:p=a.posix.normalize(f.path),f.with({path:p})}relativePath(f,p){if(f.scheme!==p.scheme||!(0,e.isEqualAuthority)(f.authority,p.authority))return;if(f.scheme===A.Schemas.file){const m=a.relative(w(f),w(p));return I.isWindows?E.toSlashes(m):m}let u=f.path||"/";const h=p.path||"/";if(this.a(f)){let m=0;for(const d=Math.min(u.length,h.length);m<d&&!(u.charCodeAt(m)!==h.charCodeAt(m)&&u.charAt(m).toLowerCase()!==h.charAt(m).toLowerCase());m++);u=h.substr(0,m)+u.substr(m)}return a.posix.relative(u,h)}resolvePath(f,p){if(f.scheme===A.Schemas.file){const u=P.URI.file(a.resolve(w(f),p));return f.with({authority:u.authority,path:u.path})}return p=E.toPosixPath(p),f.with({path:a.posix.resolve(f.path,p)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,p){return f===p||f!==void 0&&p!==void 0&&(0,D.equalsIgnoreCase)(f,p)}hasTrailingPathSeparator(f,p=a.sep){if(f.scheme===A.Schemas.file){const u=w(f);return u.length>E.getRoot(u).length&&u[u.length-1]===p}else{const u=f.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,p=a.sep){return(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,p=a.sep){let u=!1;if(f.scheme===A.Schemas.file){const h=w(f);u=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===p}else{p="/";const h=f.path;u=h.length===1&&h.charCodeAt(h.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(b=>b.scheme===A.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new y(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(b,f){const p=[];for(let u=0;u<b.length;u++){const h=f(b[u]);b.some((m,d)=>d===u?!1:(0,e.isEqualOrParent)(h,f(m)))||p.push(b[u])}return p}e.distinctParents=T;var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(p){const u=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[C,k]=d.split(":");C&&k&&u.set(C,k)});const m=p.path.substring(0,p.path.indexOf(";"));return m&&u.set(b.META_DATA_MIME,m),u}b.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function v(b,f,p){if(f){let u=b.path;return u&&u[0]!==a.posix.sep&&(u=a.posix.sep+u),b.with({scheme:p,authority:f,path:u})}return b.with({scheme:p})}e.toLocalResource=v}),define(ve[14],Ee([1,0,19,9,6,2,20,3,147]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(j){return!!j&&typeof j.then=="function"}e.isThenable=y;function T(j){const N=new E.CancellationTokenSource,M=j(N.token),q=new Promise((te,ue)=>{const W=N.token.onCancellationRequested(()=>{W.dispose(),N.dispose(),ue(new A.CancellationError)});Promise.resolve(M).then(K=>{W.dispose(),N.dispose(),te(K)},K=>{W.dispose(),N.dispose(),ue(K)})});return new class{cancel(){N.cancel()}then(te,ue){return q.then(te,ue)}catch(te){return this.then(void 0,te)}finally(te){return q.finally(te)}}}e.createCancelablePromise=T;function S(j,N,M){return new Promise((q,te)=>{const ue=N.onCancellationRequested(()=>{ue.dispose(),q(M)});j.then(q,te).finally(()=>ue.dispose())})}e.raceCancellation=S;function v(j,N){return new Promise((M,q)=>{const te=N.onCancellationRequested(()=>{te.dispose(),q(new A.CancellationError)});j.then(M,q).finally(()=>te.dispose())})}e.raceCancellationError=v;async function b(j){let N=-1;const M=j.map((te,ue)=>te.then(W=>(N=ue,W))),q=await Promise.race(M);return j.forEach((te,ue)=>{ue!==N&&te.cancel()}),q}e.raceCancellablePromises=b;function f(j,N,M){let q;const te=setTimeout(()=>{q?.(void 0),M?.()},N);return Promise.race([j.finally(()=>clearTimeout(te)),new Promise(ue=>q=ue)])}e.raceTimeout=f;function p(j){return new Promise((N,M)=>{const q=j();y(q)?q.then(N,M):N(q)})}e.asPromise=p;class u{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const M=()=>{this.b=null;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(M,M).then(q)})}return new Promise((M,q)=>{this.b.then(M,q)})}return this.a=N(),new Promise((M,q)=>{this.a.then(te=>{this.a=null,M(te)},te=>{this.a=null,q(te)})})}}e.Throttler=u;class h{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=h;class m{constructor(){this.a=new Map}queue(N,M){const te=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(N)===te&&this.a.delete(N)});return this.a.set(N,te),te}}e.SequencerByKey=m;const d=(j,N)=>{let M=!0;const q=setTimeout(()=>{M=!1,N()},j);return{isTriggered:()=>M,dispose:()=>{clearTimeout(q),M=!1}}},C=j=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,j())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class k{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,M=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((te,ue)=>{this.d=te,this.f=ue}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=M===w.MicrotaskDelay?C(q):d(M,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=k;class t{constructor(N){this.a=new k(N),this.b=new u}trigger(N,M){return this.a.trigger(()=>this.b.queue(N),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class r{constructor(){this.a=!1,this.b=new Promise((N,M)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class n extends r{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function i(j,N){return N?new Promise((M,q)=>{const te=setTimeout(()=>{ue.dispose(),M()},j),ue=N.onCancellationRequested(()=>{clearTimeout(te),ue.dispose(),q(new A.CancellationError)})}):T(M=>i(j,M))}e.timeout=i;function o(j,N=0){const M=setTimeout(j,N);return(0,I.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=o;function c(j){const N=[];let M=0;const q=j.length;function te(){return M<q?j[M++]():null}function ue(W){W!=null&&N.push(W);const K=te();return K?K.then(ue):Promise.resolve(N)}return Promise.resolve(null).then(ue)}e.sequence=c;function l(j,N=q=>!!q,M=null){let q=0;const te=j.length,ue=()=>{if(q>=te)return Promise.resolve(M);const W=j[q++];return Promise.resolve(W()).then(_=>N(_)?Promise.resolve(_):ue())};return ue()}e.first=l;function s(j,N=q=>!!q,M=null){if(j.length===0)return Promise.resolve(M);let q=j.length;const te=()=>{q=-1;for(const ue of j)ue.cancel?.()};return new Promise((ue,W)=>{for(const K of j)K.then(_=>{--q>=0&&N(_)?(te(),ue(_)):q===0&&ue(M)}).catch(_=>{--q>=0&&(te(),W(_))})})}e.firstParallel=s;class g{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new a.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((M,q)=>{this.f.push({factory:N,c:M,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const M=N.factory();M.then(N.c,N.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=g;class R extends g{constructor(){super(1)}}e.Queue=R;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new H;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,M=D.extUri){const q=M.getComparisonKey(N);let te=this.a.get(q);return te||(te=new R,a.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(q),this.f()}),this.a.set(q,te)),te}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class z{constructor(N,M){this.a=-1,typeof N=="function"&&typeof M=="number"&&this.setIfNotSet(N,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},M)}setIfNotSet(N,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},M))}}e.TimeoutTimer=z;class ie{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,M){this.cancel(),this.a=setInterval(()=>{N()},M)}}e.IntervalTimer=ie;class ee{constructor(N,M){this.b=-1,this.a=N,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ee;class F{constructor(N,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=N,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class Z extends ee{constructor(N,M){super(N,M),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Z;class $ extends I.Disposable{constructor(N,M){super(),this.g=N,this.h=M,this.a=[],this.b=this.B(new I.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of N)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,P.setTimeout0)(()=>{if(N)return;const M=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(j,N)=>{const M=requestIdleCallback(j,typeof N=="number"?{timeout:N}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(M))}}}}();class x{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=x;async function le(j,N,M){let q;for(let te=0;te<M;te++)try{return await j()}catch(ue){q=ue,await i(N)}throw q}e.retry=le;class be{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,M,q){return this.a={taskId:N,cancel:()=>q?.(),promise:M},M.then(()=>this.d(N),()=>this.d(N)),M}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let M,q;const te=new Promise((ue,W)=>{M=ue,q=W});this.b={run:N,promise:te,promiseResolve:M,promiseReject:q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=be;class Y{constructor(N,M=()=>Date.now()){this.d=N,this.f=M,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,M)=>{this.a=N,this.b=M})}complete(N){return new Promise(M=>{this.a(N),this.f=!0,M()})}error(N){return new Promise(M=>{this.b(N),this.d=!0,M()})}cancel(){new Promise(N=>{this.b(new A.CancellationError),this.d=!0,N()})}}e.DeferredPromise=H;var U;(function(j){async function N(q){let te;const ue=await Promise.all(q.map(W=>W.then(K=>K,K=>{te||(te=K)})));if(typeof te<"u")throw te;return ue}j.settled=N;function M(q){return new Promise(async(te,ue)=>{try{await q(te,ue)}catch(W){ue(W)}})}j.withAsyncBody=M})(U=e.Promises||(e.Promises={}));var ne;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ne||(ne={}));class se{static fromArray(N){return new se(M=>{M.emitMany(N)})}static fromPromise(N){return new se(async M=>{M.emitMany(await N)})}static fromPromises(N){return new se(async M=>{await Promise.all(N.map(async q=>M.emitOne(await q)))})}static merge(N){return new se(async M=>{await Promise.all(N.map(async q=>{for await(const te of q)M.emitOne(te)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new a.Emitter,queueMicrotask(async()=>{const M={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(N(M)),this.j()}catch(q){this.k(q)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await a.Event.toPromise(this.f.event)}while(!0)}}}static map(N,M){return new se(async q=>{for await(const te of N)q.emitOne(M(te))})}map(N){return se.map(this,N)}static filter(N,M){return new se(async q=>{for await(const te of N)M(te)&&q.emitOne(te)})}filter(N){return se.filter(this,N)}static coalesce(N){return se.filter(N,M=>!!M)}coalesce(){return se.coalesce(this)}static async toPromise(N){const M=[];for await(const q of N)M.push(q);return M}toPromise(){return se.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}se.EMPTY=se.fromArray([]),e.AsyncIterableObject=se;class de extends se{constructor(N,M){super(M),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function re(j){const N=new E.CancellationTokenSource,M=j(N.token);return new de(N,async q=>{const te=N.token.onCancellationRequested(()=>{te.dispose(),N.dispose(),q.reject(new A.CancellationError)});try{for await(const ue of M){if(N.token.isCancellationRequested)return;q.emitOne(ue)}te.dispose(),N.dispose()}catch(ue){te.dispose(),N.dispose(),q.reject(ue)}})}e.createCancelableAsyncIterable=re}),define(ve[71],Ee([1,0,18,14,37,27,7,3,16]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",S="[^/\\\\]",v=/\//g;function b(Y,H){switch(Y){case 0:return"";case 1:return`${S}*?`;default:return`(?:${T}|${S}+${T}${H?`|${T}${S}+`:""})*?`}}function f(Y,H){if(!Y)return[];const U=[];let ne=!1,se=!1,de="";for(const re of Y){switch(re){case H:if(!ne&&!se){U.push(de),de="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":se=!0;break;case"]":se=!1;break}de+=re}return de&&U.push(de),U}e.splitGlobAware=f;function p(Y){if(!Y)return"";let H="";const U=f(Y,e.GLOB_SPLIT);if(U.every(ne=>ne===e.GLOBSTAR))H=".*";else{let ne=!1;U.forEach((se,de)=>{if(se===e.GLOBSTAR){if(ne)return;H+=b(2,de===U.length-1)}else{let re=!1,j="",N=!1,M="";for(const q of se){if(q!=="}"&&re){j+=q;continue}if(N&&(q!=="]"||!M)){let te;q==="-"?te=q:(q==="^"||q==="!")&&!M?te="^":q===e.GLOB_SPLIT?te="":te=(0,w.escapeRegExpCharacters)(q),M+=te;continue}switch(q){case"{":re=!0;continue;case"[":N=!0;continue;case"}":{H+=`(?:${f(j,",").map(W=>p(W)).join("|")})`,re=!1,j="";break}case"]":{H+="["+M+"]",N=!1,M="";break}case"?":H+=S;continue;case"*":H+=b(1);continue;default:H+=(0,w.escapeRegExpCharacters)(q)}}de<U.length-1&&(U[de+1]!==e.GLOBSTAR||de+2<U.length)&&(H+=T)}ne=se===e.GLOBSTAR})}return H}const u=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},n=function(){return null};function i(Y,H){if(!Y)return n;let U;typeof Y!="string"?U=Y.pattern:U=Y,U=U.trim();const ne=`${U}_${!!H.trimForExclusions}`;let se=t.get(ne);if(se)return o(se,Y);let de;return u.test(U)?se=l(U.substr(4),U):(de=h.exec(c(U,H)))?se=s(de[1],U):(H.trimForExclusions?d:m).test(U)?se=g(U,H):(de=C.exec(c(U,H)))?se=R(de[1].substr(1),U,!0):(de=k.exec(c(U,H)))?se=R(de[1],U,!1):se=O(U),t.set(ne,se),o(se,Y)}function o(Y,H){if(typeof H=="string")return Y;const U=function(ne,se){return(0,a.isEqualOrParent)(ne,H.base,!P.isLinux)?Y((0,w.ltrim)(ne.substr(H.base.length),D.sep),se):null};return U.allBasenames=Y.allBasenames,U.allPaths=Y.allPaths,U.basenames=Y.basenames,U.patterns=Y.patterns,U}function c(Y,H){return H.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function l(Y,H){return function(U,ne){return typeof U=="string"&&U.endsWith(Y)?H:null}}function s(Y,H){const U=`/${Y}`,ne=`\\${Y}`,se=function(re,j){return typeof re!="string"?null:j?j===Y?H:null:re===Y||re.endsWith(U)||re.endsWith(ne)?H:null},de=[Y];return se.basenames=de,se.patterns=[H],se.allBasenames=de,se}function g(Y,H){const U=le(Y.slice(1,-1).split(",").map(j=>i(j,H)).filter(j=>j!==n),Y),ne=U.length;if(!ne)return n;if(ne===1)return U[0];const se=function(j,N){for(let M=0,q=U.length;M<q;M++)if(U[M](j,N))return Y;return null},de=U.find(j=>!!j.allBasenames);de&&(se.allBasenames=de.allBasenames);const re=U.reduce((j,N)=>N.allPaths?j.concat(N.allPaths):j,[]);return re.length&&(se.allPaths=re),se}function R(Y,H,U){const ne=D.sep===D.posix.sep,se=ne?Y:Y.replace(v,D.sep),de=D.sep+se,re=D.posix.sep+Y;let j;return U?j=function(N,M){return typeof N=="string"&&(N===se||N.endsWith(de)||!ne&&(N===Y||N.endsWith(re)))?H:null}:j=function(N,M){return typeof N=="string"&&(N===se||!ne&&N===Y)?H:null},j.allPaths=[(U?"*/":"./")+Y],j}function O(Y){try{const H=new RegExp(`^${p(Y)}$`);return function(U){return H.lastIndex=0,typeof U=="string"&&H.test(U)?Y:null}}catch{return n}}function z(Y,H,U){return!Y||typeof H!="string"?!1:ie(Y)(H,void 0,U)}e.match=z;function ie(Y,H={}){if(!Y)return r;if(typeof Y=="string"||ee(Y)){const U=i(Y,H);if(U===n)return r;const ne=function(se,de){return!!U(se,de)};return U.allBasenames&&(ne.allBasenames=U.allBasenames),U.allPaths&&(ne.allPaths=U.allPaths),ne}return $(Y,H)}e.parse=ie;function ee(Y){const H=Y;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=ee;function F(Y){return Y.allBasenames||[]}e.getBasenameTerms=F;function Z(Y){return Y.allPaths||[]}e.getPathTerms=Z;function $(Y,H){const U=le(Object.getOwnPropertyNames(Y).map(j=>x(j,Y[j],H)).filter(j=>j!==n)),ne=U.length;if(!ne)return n;if(!U.some(j=>!!j.requiresSiblings)){if(ne===1)return U[0];const j=function(q,te){let ue;for(let W=0,K=U.length;W<K;W++){const _=U[W](q,te);if(typeof _=="string")return _;(0,A.isThenable)(_)&&(ue||(ue=[]),ue.push(_))}return ue?(async()=>{for(const W of ue){const K=await W;if(typeof K=="string")return K}return null})():null},N=U.find(q=>!!q.allBasenames);N&&(j.allBasenames=N.allBasenames);const M=U.reduce((q,te)=>te.allPaths?q.concat(te.allPaths):q,[]);return M.length&&(j.allPaths=M),j}const se=function(j,N,M){let q,te;for(let ue=0,W=U.length;ue<W;ue++){const K=U[ue];K.requiresSiblings&&M&&(N||(N=(0,D.basename)(j)),q||(q=N.substr(0,N.length-(0,D.extname)(j).length)));const _=K(j,N,q,M);if(typeof _=="string")return _;(0,A.isThenable)(_)&&(te||(te=[]),te.push(_))}return te?(async()=>{for(const ue of te){const W=await ue;if(typeof W=="string")return W}return null})():null},de=U.find(j=>!!j.allBasenames);de&&(se.allBasenames=de.allBasenames);const re=U.reduce((j,N)=>N.allPaths?j.concat(N.allPaths):j,[]);return re.length&&(se.allPaths=re),se}function x(Y,H,U){if(H===!1)return n;const ne=i(Y,U);if(ne===n)return n;if(typeof H=="boolean")return ne;if(H){const se=H.when;if(typeof se=="string"){const de=(re,j,N,M)=>{if(!M||!ne(re,j))return null;const q=se.replace("$(basename)",()=>N),te=M(q);return(0,A.isThenable)(te)?te.then(ue=>ue?Y:null):te?Y:null};return de.requiresSiblings=!0,de}}return ne}function le(Y,H){const U=Y.filter(j=>!!j.basenames);if(U.length<2)return Y;const ne=U.reduce((j,N)=>{const M=N.basenames;return M?j.concat(M):j},[]);let se;if(H){se=[];for(let j=0,N=ne.length;j<N;j++)se.push(H)}else se=U.reduce((j,N)=>{const M=N.patterns;return M?j.concat(M):j},[]);const de=function(j,N){if(typeof j!="string")return null;if(!N){let q;for(q=j.length;q>0;q--){const te=j.charCodeAt(q-1);if(te===47||te===92)break}N=j.substr(q)}const M=ne.indexOf(N);return M!==-1?se[M]:null};de.basenames=ne,de.patterns=se,de.allBasenames=ne;const re=Y.filter(j=>!j.basenames);return re.push(de),re}function be(Y,H){return(0,E.equals)(Y,H,(U,ne)=>typeof U=="string"&&typeof ne=="string"?U===ne:typeof U!="string"&&typeof ne!="string"?U.base===ne.base&&U.pattern===ne.pattern:!1)}e.patternsEquals=be}),define(ve[93],Ee([1,0,9,148,20,16,4]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(h="",m=!1){if(this.value=h,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(h,m=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(h):h).replace(/([ \t]+)/g,(d,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,m){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(h,m,d){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(h),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(h,m){const d=new RegExp((0,I.escapeRegExpCharacters)(m),"g");return h.replace(d,(C,k)=>h.charAt(k-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=w;function y(u){return T(u)?!u.value:Array.isArray(u)?u.every(y):!0}e.isEmptyMarkdownString=y;function T(u){return u instanceof w?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function S(u,h){return u===h?!0:!u||!h?!1:u.value===h.value&&u.isTrusted===h.isTrusted&&u.supportThemeIcons===h.supportThemeIcons&&u.supportHtml===h.supportHtml&&(u.baseUri===h.baseUri||!!u.baseUri&&!!h.baseUri&&(0,a.isEqual)(D.URI.from(u.baseUri),D.URI.from(h.baseUri)))}e.markdownStringEqual=S;function v(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function b(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function f(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function p(u){const h=[],m=u.split("|").map(C=>C.trim());u=m[0];const d=m[1];if(d){const C=/height=(\d+)/.exec(d),k=/width=(\d+)/.exec(d),t=C?C[1]:"",r=k?k[1]:"",n=isFinite(parseInt(r)),i=isFinite(parseInt(t));n&&h.push(`width="${r}"`),i&&h.push(`height="${t}"`)}return{href:u,dimensions:h}}e.parseHrefAndDimensions=p}),define(ve[150],Ee([1,0,18,37,7,3,20,16]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(n,i){const{os:o,tildify:c,relative:l}=i;if(l){const R=y(n,l,o);if(typeof R=="string")return R}let s=n.fsPath;if(o===1&&!I.isWindows?s=s.replace(/\//g,"\\"):o!==1&&I.isWindows&&(s=s.replace(/\\/g,"/")),o!==1&&c?.userHome){const R=c.userHome.fsPath;let O;n.scheme!==c.userHome.scheme&&n.path.startsWith(a.posix.sep)?O=c.userHome.with({path:n.path}).fsPath:O=n.fsPath,s=v(O,R,o)}return(o===1?a.win32:a.posix).normalize(T(s,o===1))}e.getPathLabel=w;function y(n,i,o){const c=o===1?a.win32:a.posix,l=o===3?D.extUri:D.extUriIgnorePathCase,s=i.getWorkspace(),g=(0,E.firstOrDefault)(s.folders);if(!g)return;n.scheme!==g.uri.scheme&&n.path.startsWith(a.posix.sep)&&(n=g.uri.with({path:n.path}));const R=i.getWorkspaceFolder(n);if(!R)return;let O;if(l.isEqual(R.uri,n)?O="":O=l.relativePath(R.uri,n)??"",O&&(O=c.normalize(O)),s.folders.length>1&&!i.noPrefix){const z=R.name?R.name:l.basenameOrAuthority(R.uri);O=O?`${z} \u2022 ${O}`:z}return O}function T(n,i=I.isWindows){return(0,A.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=T;let S=Object.create(null);function v(n,i,o=I.OS){if(o===1||!n||!i)return n;let c=S.original===i?S.normalized:void 0;c||(c=i,I.isWindows&&(c=(0,A.toSlashes)(c)),c=`${(0,P.rtrim)(c,a.posix.sep)}${a.posix.sep}`,S={original:i,normalized:c});let l=n;return I.isWindows&&(l=(0,A.toSlashes)(l)),(o===3?l.startsWith(c):(0,P.startsWithIgnoreCase)(l,c))?`~/${l.substr(c.length)}`:n}e.tildify=v;function b(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=b;const f="\u2026",p="\\\\",u="~";function h(n,i=a.sep){const o=new Array(n.length);let c=!1;for(let l=0;l<n.length;l++){const s=n[l];if(s===""){o[l]=`.${i}`;continue}if(!s){o[l]=s;continue}c=!0;let g="",R=s;R.indexOf(p)===0?(g=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length)):R.indexOf(i)===0?(g=R.substr(0,R.indexOf(i)+i.length),R=R.substr(R.indexOf(i)+i.length)):R.indexOf(u)===0&&(g=R.substr(0,R.indexOf(u)+u.length),R=R.substr(R.indexOf(u)+u.length));const O=R.split(i);for(let z=1;c&&z<=O.length;z++)for(let ie=O.length-z;c&&ie>=0;ie--){c=!1;let ee=O.slice(ie,ie+z).join(i);for(let F=0;!c&&F<n.length;F++)if(F!==l&&n[F]&&n[F].indexOf(ee)>-1){const Z=ie+z===O.length,$=ie>0&&n[F].indexOf(i)>-1?i+ee:ee,x=n[F].endsWith($);c=!Z||x}if(!c){let F="";(O[0].endsWith(":")||g!=="")&&(ie===1&&(ie=0,z++,ee=O[0]+i+ee),ie>0&&(F=O[0]+i),F=g+F),ie>0&&(F=F+f+i),F=F+ee,ie+z<O.length&&(F=F+i+f),o[l]=F}}c&&(o[l]=s)}return o}e.shorten=h;var m;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function d(n,i=Object.create(null)){const o=[];let c=!1,l="";for(const s of n)if(s==="$"||c&&s==="{")l&&o.push({value:l,type:m.TEXT}),l="",c=!0;else if(s==="}"&&c){const g=i[l];if(typeof g=="string")g.length&&o.push({value:g,type:m.VARIABLE});else if(g){const R=o[o.length-1];(!R||R.type!==m.SEPARATOR)&&o.push({value:g.label,type:m.SEPARATOR})}l="",c=!1}else l+=s;return l&&!c&&o.push({value:l,type:m.TEXT}),o.filter((s,g)=>{if(s.type===m.SEPARATOR){const R=o[g-1],O=o[g+1];return[R,O].every(z=>z&&(z.type===m.VARIABLE||z.type===m.TEXT)&&z.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=d;function C(n,i){return I.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function k(n,i){return I.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=k;function t(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=t;function r(n){const i=n.indexOf("/")!==-1?a.posix:a.win32,o=i.basename(n),c=i.dirname(n);return o.length?{name:o,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ve[72],Ee([1,0,15,4]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function a(S){return S.toJSON()}class I{constructor(v){this.a=v}transformIncoming(v){const b=this.a.transformIncoming(v);return b===v?v:a(A.URI.from(b))}transformOutgoing(v){const b=this.a.transformOutgoing(v);return b===v?v:a(A.URI.from(b))}transformOutgoingURI(v){const b=this.a.transformOutgoing(v);return b===v?v:A.URI.from(b)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function D(S,v,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof A.URI)return v.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const p=D(S[f],v,b+1);p!==null&&(S[f]=p)}}return null}function P(S,v){const b=D(S,v,0);return b===null?S:b}e.transformOutgoingURIs=P;function w(S,v,b,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?A.URI.revive(v.transformIncoming(S)):v.transformIncoming(S);if(S instanceof E.VSBuffer)return null;for(const p in S)if(Object.hasOwnProperty.call(S,p)){const u=w(S[p],v,b,f+1);u!==null&&(S[p]=u)}}return null}function y(S,v){const b=w(S,v,!1,0);return b===null?S:b}e.transformIncomingURIs=y;function T(S,v){const b=w(S,v,!0,0);return b===null?S:b}e.transformAndReviveIncomingURIs=T}),define(ve[21],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(a){return E.test(a)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let a;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?a=crypto.getRandomValues.bind(crypto):a=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const I=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){a(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let w=0,y="";return y+=D[I[w++]],y+=D[I[w++]],y+=D[I[w++]],y+=D[I[w++]],y+="-",y+=D[I[w++]],y+=D[I[w++]],y+="-",y+=D[I[w++]],y+=D[I[w++]],y+="-",y+=D[I[w++]],y+=D[I[w++]],y+="-",y+=D[I[w++]],y+=D[I[w++]],y+=D[I[w++]],y+=D[I[w++]],y+=D[I[w++]],y+=D[I[w++]],y}}()}),define(ve[151],Ee([1,0,18,21]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function a(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=a;function I(P,w,y){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:w,data:y}),value:void 0}}e.createFileDataTransferItem=I;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(w){return this.a.has(this.b(w))}get(w){return this.a.get(this.b(w))?.[0]}append(w,y){const T=this.a.get(w);T?T.push(y):this.a.set(this.b(w),[y])}replace(w,y){this.a.set(this.b(w),[y])}delete(w){this.a.delete(this.b(w))}*entries(){for(const[w,y]of this.a.entries())for(const T of y)yield[w,T]}values(){return Array.from(this.a.values()).flat()}forEach(w){for(const[y,T]of this.entries())w(T,y)}b(w){return w.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:P=>(0,E.distinct)(P.map(w=>w.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function ae(e,E,A){function a(b){return new Promise(f=>E.exists(b,f))}function I(b){return new Promise((f,p)=>{const u=new Date;E.utimes(b,u,u,h=>h?p(h):f())})}function D(b){return new Promise((f,p)=>E.mkdir(b,{recursive:!0},u=>u&&u.code!=="EEXIST"?p(u):f(b)))}function P(b){return new Promise((f,p)=>E.rm(b,{recursive:!0,force:!0,maxRetries:3},u=>u?p(u):f()))}function w(b){return new Promise((f,p)=>E.readFile(b,"utf8",(u,h)=>u?p(u):f(h)))}function y(b,f){return new Promise((p,u)=>E.writeFile(b,f,"utf8",h=>h?u(h):p()))}async function T(b){const f=e.join(b,"languagepacks.json");try{return JSON.parse(await w(f))}catch{}}function S(b,f){try{for(;f;){if(b[f])return f;{const p=f.lastIndexOf("-");if(p>0)f=f.substring(0,p);else return}}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function v(b,f,p,u){if(u==="pseudo")return Promise.resolve({locale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:u,availableLanguages:{}});if(u&&(u==="en"||u==="en-us"))return Promise.resolve({locale:u,availableLanguages:{}});const h=u;A.mark("code/willGenerateNls");const m=function(d){return A.mark("code/didGenerateNls"),Promise.resolve({locale:d,availableLanguages:{}})};try{return b?T(f).then(d=>{if(!d||(u=S(d,u),!u))return m(h);const C=d[u];let k;return!C||typeof C.hash!="string"||!C.translations||typeof(k=C.translations.vscode)!="string"?m(h):a(k).then(t=>{if(!t)return m(h);const r=C.hash+"."+u,n=e.join(f,"clp",r),i=e.join(n,b),o=e.join(n,"tcf.json"),c=e.join(n,"corrupted.info"),l={locale:h,availableLanguages:{"*":u},_languagePackId:r,_translationsConfigFile:o,_cacheRoot:n,_resolvedLanguagePackCoreLocation:i,_corruptedFile:c};return a(c).then(s=>{let g;return s?g=P(n):g=Promise.resolve(void 0),g.then(()=>a(i).then(R=>R?(I(i).catch(()=>{}),A.mark("code/didGenerateNls"),l):D(i).then(()=>Promise.all([w(p),w(k)])).then(O=>{const z=JSON.parse(O[0]),ie=JSON.parse(O[1]).contents,ee=Object.keys(z.bundles),F=[];for(const Z of ee){const $=z.bundles[Z],x=Object.create(null);for(const le of $){const be=z.keys[le],Y=z.messages[le],H=ie[le];let U;if(H){U=[];for(let ne=0;ne<be.length;ne++){const se=be[ne],de=typeof se=="string"?se:se.key;let re=H[de];re===void 0&&(re=Y[ne]),U.push(re)}}else U=Y;x[le]=U}F.push(y(e.join(i,Z.replace(/\//g,"!")+".nls.json"),JSON.stringify(x)))}return F.push(y(o,JSON.stringify(C.translations))),Promise.all(F)}).then(()=>(A.mark("code/didGenerateNls"),l)).catch(O=>(console.error("Generating translation files failed.",O),m(u)))))})})}):m(h)}catch(d){return console.error("Generating translation files failed.",d),m(u)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(ve[152],Ee([94,31,47]),function(e,E,A){return ae(e,E,A)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),A=require("../common/performance");module.exports=ae(e,E,A)}else throw new Error("Unknown context")}(),define(ve[153],Ee([1,0,29]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function a(D){const P=D.replace(/\-/g,":").toLowerCase();return!A.has(P)}function I(){const D=(0,E.networkInterfaces)();for(const P in D){const w=D[P];if(w){for(const{mac:y}of w)if(a(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=I}),define(ve[95],Ee([1,0,29,9,59,21,153]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(T){return this.a||(this.a=a.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(T)}value(){if(this.b===void 0){let T=0,S=0;const v=(0,E.networkInterfaces)();for(const b in v){const f=v[b];if(f)for(const{mac:p,internal:u}of f)u||(S+=1,this.c(p.toUpperCase())&&(T+=1))}this.b=S>0?T/S:0}return this.b}};let P;async function w(){return P||(P=(async()=>await y()||I.generateUuid())()),P}e.getMachineId=w;async function y(){try{const T=await new Promise((v,b)=>{ae(["crypto"],v,b)}),S=(0,D.getMac)();return T.createHash("sha256").update(S,"utf8").digest("hex")}catch(T){A.onUnexpectedError(T);return}}}),define(ve[22],Ee([1,0,31,29,281,14,37,89,7,3,20,4]),function(ae,e,E,A,a,I,D,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function b($,x=v.UNLINK){if((0,D.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return x===v.UNLINK?p($):f($)}async function f($){try{const x=(0,D.randomPath)((0,A.tmpdir)());try{await E.promises.rename($,x)}catch(le){return le.code==="ENOENT"?void 0:p($)}p(x).catch(le=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function p($){return(0,a.promisify)(E.rm)($,{recursive:!0,force:!0,maxRetries:3})}function u($){if((0,D.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function h($,x){return C(await(x?m($):(0,a.promisify)(E.readdir)($)))}async function m($){try{return await(0,a.promisify)(E.readdir)($,{withFileTypes:!0})}catch(be){console.warn("[node.js fs] readdir with filetypes failed with error: ",be)}const x=[],le=await h($);for(const be of le){let Y=!1,H=!1,U=!1;try{const ne=await e.Promises.lstat((0,w.join)($,be));Y=ne.isFile(),H=ne.isDirectory(),U=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:be,isFile:()=>Y,isDirectory:()=>H,isSymbolicLink:()=>U})}return x}function d($){return C(E.readdirSync($))}e.readdirSync=d;function C($){return $.map(x=>typeof x=="string"?y.isMacintosh?(0,P.normalizeNFC)(x):x:(x.name=y.isMacintosh?(0,P.normalizeNFC)(x.name):x.name,x))}async function k($){const x=await h($),le=[];for(const be of x)await r.existsDirectory((0,w.join)($,be))&&le.push(be);return le}function t($,x=1e3){return new Promise(le=>{let be=!1;const Y=setInterval(()=>{be||(be=!0,E.access($,H=>{be=!1,H&&(clearInterval(Y),le(void 0))}))},x)})}e.whenDeleted=t;var r;(function($){async function x(Y){let H;try{if(H=await e.Promises.lstat(Y),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(y.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw ne}throw U}}$.stat=x;async function le(Y){try{const{stat:H,symbolicLink:U}=await $.stat(Y);return H.isFile()&&U?.dangling!==!0}catch{}return!1}$.existsFile=le;async function be(Y){try{const{stat:H,symbolicLink:U}=await $.stat(Y);return H.isDirectory()&&U?.dangling!==!0}catch{}return!1}$.existsDirectory=be})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new I.ResourceQueue;function i($,x,le){return n.queueFor(S.URI.file($),T.extUriBiasedIgnorePathCase).queue(()=>{const be=g(le);return new Promise((Y,H)=>l($,x,be,U=>U?H(U):Y()))})}let o=!0;function c($){o=$}e.configureFlushOnWrite=c;function l($,x,le,be){if(!o)return E.writeFile($,x,{mode:le.mode,flag:le.flag},be);E.open($,le.flag,le.mode,(Y,H)=>{if(Y)return be(Y);E.writeFile(H,x,U=>{if(U)return E.close(H,()=>be(U));E.fdatasync(H,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),c(!1)),E.close(H,se=>be(se))))})})}function s($,x,le){const be=g(le);if(!o)return E.writeFileSync($,x,{mode:be.mode,flag:be.flag});const Y=E.openSync($,be.flag,be.mode);try{E.writeFileSync(Y,x);try{E.fdatasyncSync(Y)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),c(!1)}}finally{E.closeSync(Y)}}e.writeFileSync=s;function g($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function R($,x){if($!==x)try{await e.Promises.rename($,x)}catch(le){if($.toLowerCase()!==x.toLowerCase()&&le.code==="EXDEV"||$.endsWith("."))await O($,x,{preserveSymlinks:!1}),await b($,v.MOVE);else throw le}}async function O($,x,le){return ie($,x,{root:{source:$,target:x},options:le,handledSourcePaths:new Set})}const z=511;async function ie($,x,le){if(le.handledSourcePaths.has($))return;le.handledSourcePaths.add($);const{stat:be,symbolicLink:Y}=await r.stat($);if(Y){if(le.options.preserveSymlinks)try{return await Z($,x,le)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(Y.dangling)return}return be.isDirectory()?ee($,x,be.mode&z,le):F($,x,be.mode&z)}async function ee($,x,le,be){await e.Promises.mkdir(x,{recursive:!0,mode:le});const Y=await h($);for(const H of Y)await ie((0,w.join)($,H),(0,w.join)(x,H),be)}async function F($,x,le){await e.Promises.copyFile($,x),await e.Promises.chmod(x,le)}async function Z($,x,le){let be=await e.Promises.readlink($);(0,D.isEqualOrParent)(be,le.root.source,!y.isLinux)&&(be=(0,w.join)(le.root.target,be.substr(le.root.source.length+1))),await e.Promises.symlink(be,x)}e.Promises=new class{get access(){return(0,a.promisify)(E.access)}get stat(){return(0,a.promisify)(E.stat)}get lstat(){return(0,a.promisify)(E.lstat)}get utimes(){return(0,a.promisify)(E.utimes)}get read(){return($,x,le,be,Y)=>new Promise((H,U)=>{E.read($,x,le,be,Y,(ne,se,de)=>ne?U(ne):H({bytesRead:se,buffer:de}))})}get readFile(){return(0,a.promisify)(E.readFile)}get write(){return($,x,le,be,Y)=>new Promise((H,U)=>{E.write($,x,le,be,Y,(ne,se,de)=>ne?U(ne):H({bytesWritten:se,buffer:de}))})}get appendFile(){return(0,a.promisify)(E.appendFile)}get fdatasync(){return(0,a.promisify)(E.fdatasync)}get truncate(){return(0,a.promisify)(E.truncate)}get rename(){return(0,a.promisify)(E.rename)}get copyFile(){return(0,a.promisify)(E.copyFile)}get open(){return(0,a.promisify)(E.open)}get close(){return(0,a.promisify)(E.close)}get symlink(){return(0,a.promisify)(E.symlink)}get readlink(){return(0,a.promisify)(E.readlink)}get chmod(){return(0,a.promisify)(E.chmod)}get mkdir(){return(0,a.promisify)(E.mkdir)}get unlink(){return(0,a.promisify)(E.unlink)}get rmdir(){return(0,a.promisify)(E.rmdir)}get realpath(){return(0,a.promisify)(E.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return b}get move(){return R}get copy(){return O}}}),define(ve[154],Ee([1,0,31,7,3,16,22]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(a.isLinux)return v;const b=(0,A.dirname)(v);if(v===b)return v;const f=((0,A.basename)(v)||v).toLowerCase();try{const u=(0,D.readdirSync)(b).filter(h=>h.toLowerCase()===f);if(u.length===1){const h=P(b);if(h)return(0,A.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(f);if(h>=0){const m=P(b);if(m)return(0,A.join)(m,u[h])}}}catch{}return null}e.realcaseSync=P;async function w(v){if(a.isLinux)return v;const b=(0,A.dirname)(v);if(v===b)return v;const f=((0,A.basename)(v)||v).toLowerCase();try{const u=(await D.Promises.readdir(b)).filter(h=>h.toLowerCase()===f);if(u.length===1){const h=await w(b);if(h)return(0,A.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(f);if(h>=0){const m=await w(b);if(m)return(0,A.join)(m,u[h])}}}catch{}return null}e.realcase=w;async function y(v){try{return await D.Promises.realpath(v)}catch{const f=S(v);return await D.Promises.access(f,E.constants.R_OK),f}}e.realpath=y;function T(v){try{return E.realpathSync(v)}catch{const f=S(v);return E.accessSync(f,E.constants.R_OK),f}}e.realpathSync=T;function S(v){return(0,I.rtrim)((0,A.normalize)(v),A.sep)}}),define(ve[155],Ee([1,0,96]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(P,w,y,T=1){let S=!1;return new Promise(v=>{const b=setTimeout(()=>{if(!S)return S=!0,v(0)},y);a(P,w,T,f=>{if(!S)return S=!0,clearTimeout(b),v(f)})})}e.findFreePort=A;function a(P,w,y,T){if(w===0)return T(0);const S=new E.Socket;S.once("connect",()=>(D(S),a(P+y,w-1,y,T))),S.once("data",()=>{}),S.once("error",v=>(D(S),v.code!=="ECONNREFUSED"?a(P+y,w-1,y,T):T(P))),S.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(P,w,y,T="127.0.0.1"){let S=!1,v,b=1;const f=E.createServer({pauseOnConnect:!0});function p(u,h){S||(S=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),h(u))}return new Promise(u=>{v=setTimeout(()=>{p(0,u)},y),f.on("listening",()=>{p(P,u)}),f.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&b<w?(P++,b++,f.listen(P,T)):p(0,u)}),f.on("close",()=>{p(0,u)}),f.listen(P,T)})}e.findFreePortFaster=I;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(ve[97],Ee([1,0,29,7,22]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(C){C[C.x64=0]="x64",C[C.x86=1]="x86",C[C.ARM=2]="ARM"})(w||(w={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class S{constructor(k,t,r){this.exePath=k,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await a.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:C=!1}={}){return C?y===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:C=!1,findPreview:k=!1}={}){const t=v({useAlternateBitness:C});if(!t)return null;const r=A.join(t,"PowerShell");if(!await a.SymlinkSupport.existsDirectory(r))return null;let n=-1,i=null;for(const l of await a.Promises.readdir(r)){let s=-1;if(k){const R=l.indexOf("-");if(R<0)continue;const O=l.substring(0,R);if(!I.test(O)||l.substring(R+1)!=="preview")continue;s=parseInt(O,10)}else{if(!I.test(l))continue;s=parseInt(l,10)}if(s<=n)continue;const g=A.join(r,l,"pwsh.exe");!await a.SymlinkSupport.existsFile(g)||(i=g,n=s)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",c=k?" Preview":"";return new S(i,`PowerShell${c}${o}`,!0)}async function f({findPreview:C}={}){if(!process.env.LOCALAPPDATA)return null;const k=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await a.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=C?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await a.Promises.readdir(k))if(t.test(n)){const i=A.join(k,n,"pwsh.exe");return new S(i,r)}return null}function p(){const C=A.join(E.homedir(),".dotnet","tools","pwsh.exe");return new S(C,".NET Core PowerShell Global Tool")}function u(){const C=A.join(process.env.windir,y===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(C,"Windows PowerShell",!0)}async function*h(){let C=await b();C&&(yield C),C=await b({useAlternateBitness:!0}),C&&(yield C),C=await f(),C&&(yield C),C=p(),C&&(yield C),C=await b({findPreview:!0}),C&&(yield C),C=await f({findPreview:!0}),C&&(yield C),C=await b({useAlternateBitness:!0,findPreview:!0}),C&&(yield C),C=u(),C&&(yield C)}async function*m(){for await(const C of h())await C.exists()&&(yield C)}e.enumeratePowerShellInstallations=m;async function d(){for await(const C of m())return C;return null}e.getFirstAvailablePowerShellInstallation=d}),define(ve[98],Ee([1,0,7,3,28,57,8,22]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function w(S=a.env){return S.comspec||"cmd.exe"}e.getWindowsShell=w;function y(S){let v=[],b=!1;const f=function(p){if(b){v.push(p);return}(!S.send(p,h=>{if(h&&console.error(h),b=!1,v.length>0){const m=v.slice(0);v=[],m.forEach(d=>f(d))}})||A.isWindows)&&(b=!0)};return{send:f}}e.createQueuedSender=y;var T;(function(S){async function v(b,f,p){if(E.isAbsolute(b))return b;if(f===void 0&&(f=a.cwd()),E.dirname(b)!=="."||(p===void 0&&D.isString(a.env.PATH)&&(p=a.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(f,b);async function h(m){if(await P.Promises.exists(m)){let d;try{d=await P.Promises.stat(m)}catch(C){C.message.startsWith("EACCES")&&(d=await P.Promises.lstat(m))}return d?!d.isDirectory():!1}return!1}for(const m of p){let d;if(E.isAbsolute(m)?d=E.join(m,b):d=E.join(f,m,b),await h(d))return d;let C=d+".com";if(await h(C)||(C=d+".exe",await h(C)))return C}return E.join(f,b)}S.findExecutable=v})(T=e.win32||(e.win32={}))}),define(ve[99],Ee([1,0,48,13]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function a(D){return new Promise((P,w)=>{let y;const T=new Map;function S(b,f,p,u,h){const m=T.get(f);if(b===D||m){const d={name:v(p),cmd:p,pid:b,ppid:f,load:u,mem:h};T.set(b,d),b===D&&(y=d),m&&(m.children||(m.children=[]),m.children.push(d),m.children.length>1&&(m.children=m.children.sort((C,k)=>C.pid-k.pid)))}}function v(b){const f=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,u=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,C=/\\pipe\\winpty-control/,k=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(d.exec(b))return"electron-crash-reporter";if(C.exec(b))return"winpty-process";if(k.exec(b))return"console-window-host (Windows internal process)";let r=t.exec(b);if(r&&r.length===2){if(r[1]==="renderer")return f.exec(b)?"shared-process":p.exec(b)?"issue-reporter":u.exec(b)?"process-explorer":"window";if(r[1]==="utility"){if(h.exec(b))return"utility-network-service";if(m.exec(b))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do r=n.exec(b),r&&(i+=r+" ");while(r);return i&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${i}`:b}if(process.platform==="win32"){const b=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,p)=>{ae(["windows-process-tree"],f,p)}).then(f=>{f.getProcessList(D,p=>{if(!p){w(new Error(`Root process ${D} not found`));return}f.getProcessCpuUsage(p,u=>{const h=new Map;u.forEach(m=>{const d=b(m.commandLine||"");h.set(m.pid,{name:v(d),cmd:d,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),y=h.get(D),y?(h.forEach(m=>{const d=h.get(m.ppid);d&&(d.children||(d.children=[]),d.children.push(m))}),h.forEach(m=>{m.children&&(m.children=m.children.sort((d,C)=>d.pid-C.pid))}),P(y)):w(new Error(`Root process ${D} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let b=function(){let f=[y];const p=[];for(;f.length;){const h=f.shift();h&&(p.push(h.pid),h.children&&(f=f.concat(h.children)))}let u=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);u+=" "+p.join(" "),(0,E.exec)(u,{},(h,m,d)=>{if(h||d)w(h||new Error(d.toString()));else{const C=m.toString().split(`
`);for(let k=0;k<p.length;k++){const t=T.get(p[k]);t.load=parseFloat(C[k])}if(!y){w(new Error(`Root process ${D} not found`));return}P(y)}})};(0,E.exec)("which ps",{},(f,p,u)=>{if(f||u)if(process.platform!=="linux")w(f||new Error(u.toString()));else{const h=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(h,{},(m,d,C)=>{m||C?w(m||new Error(C.toString())):(I(d,S),b())})}else{const h=p.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${h} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,C,k)=>{d||k&&!k.includes("screen size is bogus")?w(d||new Error(k.toString())):(I(C,S),process.platform==="linux"?b():y?P(y):w(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=a;function I(D,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=D.toString().split(`
`);for(const T of y){const S=w.exec(T.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(ve[156],Ee([1,0,29,3,97,98]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(S,v){return S===1?A.isWindows?T():I.getWindowsShell(v):w(S,v)}e.getSystemShell=D;let P=null;function w(S,v){if(A.isLinux&&S===2||A.isMacintosh&&S===3)return"/bin/bash";if(!P){let b;if(A.isWindows)b="/bin/bash";else{if(b=v.SHELL,!b)try{b=(0,E.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}P=b}return P}let y=null;async function T(){return y||(y=(await(0,a.getFirstAvailablePowerShellInstallation)()).exePath),y}});var Le=this&&this.__decorate||function(ae,e,E,A){var a=arguments.length,I=a<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,E):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ae,e,E,A);else for(var P=ae.length-1;P>=0;P--)(D=ae[P])&&(I=(a<3?D(I):a>3?D(e,E,I):D(e,E))||I);return a>3&&I&&Object.defineProperty(e,E,I),I};define(ve[42],Ee([1,0,18,14,15,19,86,9,6,2,46,16,8]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var b;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(b||(b={}));function f(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function u(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function m(H){let U=0;for(let ne=0;;ne+=7){const se=H.read(1);if(U|=(se.buffer[0]&127)<<ne,!(se.buffer[0]&128))return U}}const d=n(0);function C(H,U){if(U===0){H.write(d);return}let ne=0;for(let de=U;de!==0;de=de>>>7)ne++;const se=a.VSBuffer.alloc(ne);for(let de=0;U!==0;de++)se.buffer[de]=U&127,U=U>>>7,U>0&&(se.buffer[de]|=128);H.write(se)}class k{constructor(U){this.b=U,this.a=0}read(U){const ne=this.b.slice(this.a,this.a+U);return this.a+=ne.byteLength,ne}}e.BufferReader=k;class t{constructor(){this.a=[]}get buffer(){return a.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var r;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(r||(r={}));function n(H){const U=a.VSBuffer.alloc(1);return U.writeUInt8(H,0),U}const i={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},o=typeof Buffer<"u";function c(H,U){if(typeof U>"u")H.write(i.Undefined);else if(typeof U=="string"){const ne=a.VSBuffer.fromString(U);H.write(i.String),C(H,ne.byteLength),H.write(ne)}else if(o&&Buffer.isBuffer(U)){const ne=a.VSBuffer.wrap(U);H.write(i.Buffer),C(H,ne.byteLength),H.write(ne)}else if(U instanceof a.VSBuffer)H.write(i.VSBuffer),C(H,U.byteLength),H.write(U);else if(Array.isArray(U)){H.write(i.Array),C(H,U.length);for(const ne of U)c(H,ne)}else if(typeof U=="number"&&(U|0)===U)H.write(i.Uint),C(H,U);else{const ne=a.VSBuffer.fromString(JSON.stringify(U));H.write(i.Object),C(H,ne.byteLength),H.write(ne)}}e.serialize=c;function l(H){switch(H.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return H.read(m(H)).toString();case r.Buffer:return H.read(m(H)).buffer;case r.VSBuffer:return H.read(m(H));case r.Array:{const ne=m(H),se=[];for(let de=0;de<ne;de++)se.push(l(H));return se}case r.Object:return JSON.parse(H.read(m(H)).toString());case r.Int:return m(H)}}e.deserialize=l;class s{constructor(U,ne,se=null,de=1e3){this.h=U,this.j=ne,this.k=se,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(U,ne){this.b.set(U,ne),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const ne=this.o([U.type]);this.k?.logOutgoing(ne,0,1,u(U.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([U.type,U.id],U.data);this.k?.logOutgoing(ne,U.id,1,u(U.type),U.data);return}}}o(U,ne=void 0){const se=new t;return c(se,U),c(se,ne),this.p(se.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const ne=new k(U),se=l(ne),de=l(ne),re=se[0];switch(re){case 100:return this.k?.logIncoming(U.byteLength,se[1],1,`${f(re)}: ${se[2]}.${se[3]}`,de),this.s({type:re,id:se[1],channelName:se[2],name:se[3],arg:de});case 102:return this.k?.logIncoming(U.byteLength,se[1],1,`${f(re)}: ${se[2]}.${se[3]}`,de),this.t({type:re,id:se[1],channelName:se[2],name:se[3],arg:de});case 101:return this.k?.logIncoming(U.byteLength,se[1],1,`${f(re)}`),this.u({type:re,id:se[1]});case 103:return this.k?.logIncoming(U.byteLength,se[1],1,`${f(re)}`),this.u({type:re,id:se[1]})}}s(U){const ne=this.b.get(U.channelName);if(!ne){this.v(U);return}const se=new I.CancellationTokenSource;let de;try{de=ne.call(this.j,U.name,U.arg,se.token)}catch(N){de=Promise.reject(N)}const re=U.id;de.then(N=>{this.m({id:re,data:N,type:201}),this.d.delete(U.id)},N=>{N instanceof Error?this.m({id:re,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:re,data:N,type:203}),this.d.delete(U.id)});const j=(0,y.toDisposable)(()=>se.cancel());this.d.set(U.id,j)}t(U){const ne=this.b.get(U.channelName);if(!ne){this.v(U);return}const se=U.id,re=ne.listen(this.j,U.name,U.arg)(j=>this.m({id:se,data:j,type:204}));this.d.set(U.id,re)}u(U){const ne=this.d.get(U.id);ne&&(ne.dispose(),this.d.delete(U.id))}v(U){let ne=this.g.get(U.channelName);ne||(ne=[],this.g.set(U.channelName,ne));const se=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:U,timeoutTimer:se})}w(U){const ne=this.g.get(U);if(ne){for(const se of ne)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=s;var g;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(U,ne=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ne}getChannel(U){const ne=this;return{call(se,de,re){return ne.a?Promise.reject(new P.CancellationError):ne.m(U,se,de,re)},listen(se,de){return ne.a?w.Event.None:ne.o(U,se,de)}}}m(U,ne,se,de=I.CancellationToken.None){const re=this.g++,N={id:re,type:100,channelName:U,name:ne,arg:se};if(de.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((te,ue)=>{if(de.isCancellationRequested)return ue(new P.CancellationError);const W=()=>{const Q=G=>{switch(G.type){case 201:this.f.delete(re),te(G.data);break;case 202:{this.f.delete(re);const X=new Error(G.data.message);X.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,X.name=G.data.name,ue(X);break}case 203:this.f.delete(re),ue(G.data);break}};this.f.set(re,Q),this.p(N)};let K=null;this.b===h.Idle?W():(K=(0,A.createCancelablePromise)(Q=>this.u()),K.then(()=>{K=null,W()}));const _=()=>{K?(K.cancel(),K=null):this.p({id:re,type:101}),ue(new P.CancellationError)},V=de.onCancellationRequested(_);M=(0,y.combinedDisposable)((0,y.toDisposable)(_),V),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(U,ne,se){const de=this.g++,j={id:de,type:102,channelName:U,name:ne,arg:se};let N=null;const M=new w.Emitter({onWillAddFirstListener:()=>{N=(0,A.createCancelablePromise)(te=>this.u()),N.then(()=>{N=null,this.d.add(M),this.p(j)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(M),this.p({id:de,type:103}))}}),q=te=>M.fire(te.data);return this.f.set(de,q),M.event}p(U){switch(U.type){case 100:case 102:{const ne=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(ne,U.id,0,`${f(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const ne=this.q([U.type,U.id]);this.j?.logOutgoing(ne,U.id,0,f(U.type));return}}}q(U,ne=void 0){const se=new t;return c(se,U),c(se,ne),this.r(se.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const ne=new k(U),se=l(ne),de=l(ne),re=se[0];switch(re){case 200:return this.j?.logIncoming(U.byteLength,0,0,u(re)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,se[1],0,u(re),de),this.t({type:se[0],id:se[1],data:de})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}Le([D.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class O{get connections(){const U=[];return this.f.forEach(ne=>U.push(ne)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:ne,onDidClientDisconnect:se})=>{w.Event.once(ne.onMessage)(re=>{const j=new k(re),N=l(j),M=new s(ne,N),q=new R(ne);this.a.forEach((ue,W)=>M.registerChannel(W,ue));const te={channelServer:M,channelClient:q,ctx:N};this.f.add(te),this.g.fire(te),se(()=>{M.dispose(),q.dispose(),this.f.delete(te),this.h.fire(te)})})})}getChannel(U,ne){const se=this;return{call(de,re,j){let N;if((0,v.isFunction)(ne)){const q=(0,E.getRandomElement)(se.connections.filter(ne));N=q?Promise.resolve(q):w.Event.toPromise(w.Event.filter(se.onDidAddConnection,ne))}else N=ne.routeCall(se,de,re);const M=N.then(q=>q.channelClient.getChannel(U));return ie(M).call(de,re,j)},listen(de,re){if((0,v.isFunction)(ne))return se.j(U,ne,de,re);const j=ne.routeEvent(se,de,re).then(N=>N.channelClient.getChannel(U));return ie(j).listen(de,re)}}}j(U,ne,se,de){const re=this;let j=new y.DisposableStore;const N=new w.Emitter({onWillAddFirstListener:()=>{j=new y.DisposableStore;const M=new w.EventMultiplexer,q=new Map,te=W=>{const _=W.channelClient.getChannel(U).listen(se,de),V=M.add(_);q.set(W,V)},ue=W=>{const K=q.get(W);!K||(K.dispose(),q.delete(W))};re.connections.filter(ne).forEach(te),w.Event.filter(re.onDidAddConnection,ne)(te,void 0,j),re.onDidRemoveConnection(ue,void 0,j),M.event(N.fire,N,j),j.add(M)},onDidRemoveLastListener:()=>{j.dispose()}});return N.event}registerChannel(U,ne){this.a.set(U,ne),this.f.forEach(se=>{se.channelServer.registerChannel(U,ne)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class z{constructor(U,ne,se=null){const de=new t;c(de,ne),U.send(de.buffer),this.a=new R(U,se),this.d=new s(U,ne,se)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,ne){this.d.registerChannel(U,ne)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=z;function ie(H){return{call(U,ne,se){return H.then(de=>de.call(U,ne,se))},listen(U,ne){const se=new w.Relay;return H.then(de=>se.input=de.listen(U,ne)),se.event}}}e.getDelayedChannel=ie;function ee(H){let U=!1;return{call(ne,se,de){return U?H.call(ne,se,de):(0,A.timeout)(0).then(()=>U=!0).then(()=>H.call(ne,se,de))},listen(ne,se){if(U)return H.listen(ne,se);const de=new w.Relay;return(0,A.timeout)(0).then(()=>U=!0).then(()=>de.input=H.listen(ne,se)),de.event}}}e.getNextTickChannel=ee;class F{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const ne of U.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await w.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=F;var Z;(function(H){function U(re,j){const N=re,M=j&&j.disableMarshalling,q=new Map;for(const te in N)se(te)&&q.set(te,w.Event.buffer(N[te],!0));return new class{listen(te,ue,W){const K=q.get(ue);if(K)return K;if(de(ue)){const _=N[ue];if(typeof _=="function")return _.call(N,W)}throw new Error(`Event not found: ${ue}`)}call(te,ue,W){const K=N[ue];if(typeof K=="function"){if(!M&&Array.isArray(W))for(let _=0;_<W.length;_++)W[_]=(0,T.revive)(W[_]);return K.apply(N,W)}throw new Error(`Method not found: ${ue}`)}}}H.fromService=U;function ne(re,j){const N=j&&j.disableMarshalling;return new Proxy({},{get(M,q){if(typeof q=="string")return j?.properties?.has(q)?j.properties.get(q):de(q)?function(te){return re.listen(q,te)}:se(q)?re.listen(q):async function(...te){let ue;j&&!(0,v.isUndefinedOrNull)(j.context)?ue=[j.context,...te]:ue=te;const W=await re.call(q,ue);return N?W:(0,T.revive)(W)};throw new Error(`Property not found: ${String(q)}`)}})}H.toService=ne;function se(re){return re[0]==="o"&&re[1]==="n"&&S.isUpperAsciiLetter(re.charCodeAt(2))}function de(re){return/^onDynamic/.test(re)&&S.isUpperAsciiLetter(re.charCodeAt(9))}})(Z=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const U=H.toString();if(U!=="[object Object]")return U}return H}function le(H){return Array.isArray(H)?H.map(x):x(H)}function be(H,U,ne,se,de,re,j){j=le(j);const N=$[de],M=N[se%N.length];let q=[`%c[${H}]%c[${String(U).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(re)?(q=q.concat(j),q.push(")")):q.push(j),console.log.apply(console,q)}class Y{constructor(U,ne){this.d=U,this.f=ne,this.a=0,this.b=0}logOutgoing(U,ne,se,de,re){this.b+=U,be(this.d,this.b,U,ne,se,de,re)}logIncoming(U,ne,se,de,re){this.a+=U,be(this.f,this.a,U,ne,se,de,re)}}e.IPCLogger=Y}),define(ve[100],Ee([1,0,14,15,6,2,42]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(R){R.Created="created",R.Read="read",R.Write="write",R.Open="open",R.Error="error",R.Close="close",R.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",R.NodeEndReceived="nodeEndReceived",R.NodeEndSent="nodeEndSent",R.NodeDrainBegin="nodeDrainBegin",R.NodeDrainEnd="nodeDrainEnd",R.zlibInflateError="zlibInflateError",R.zlibInflateData="zlibInflateData",R.zlibInflateInitialWrite="zlibInflateInitialWrite",R.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",R.zlibInflateWrite="zlibInflateWrite",R.zlibInflateFlushFired="zlibInflateFlushFired",R.zlibDeflateError="zlibDeflateError",R.zlibDeflateData="zlibDeflateData",R.zlibDeflateWrite="zlibDeflateWrite",R.zlibDeflateFlushFired="zlibDeflateFlushFired",R.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",R.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",R.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",R.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",R.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",R.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",R.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",R.ProtocolHeaderRead="protocolHeaderRead",R.ProtocolMessageRead="protocolMessageRead",R.ProtocolHeaderWrite="protocolHeaderWrite",R.ProtocolMessageWrite="protocolMessageWrite",R.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var w;(function(R){R.enableDiagnostics=!1,R.records=[];const O=new WeakMap;let z=0;function ie(F,Z){if(!O.has(F)){const $=String(++z);O.set(F,$)}return O.get(F)}function ee(F,Z,$,x){if(!R.enableDiagnostics)return;const le=ie(F,Z);if(x instanceof A.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const be=A.VSBuffer.alloc(x.byteLength);be.set(x),R.records.push({timestamp:Date.now(),id:le,label:Z,type:$,buff:be})}else R.records.push({timestamp:Date.now(),id:le,label:Z,type:$,data:x})}R.traceSocketEvent=ee})(w=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(R){R[R.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",R[R.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function S(){return T||(T=A.VSBuffer.alloc(0)),T}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,z){if(O===0)return S();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const Z=this.a[0];return z&&(this.a.shift(),this.b-=O),Z}if(this.a[0].byteLength>O){const Z=this.a[0].slice(0,O);return z&&(this.a[0]=this.a[0].slice(O),this.b-=O),Z}const ie=A.VSBuffer.alloc(O);let ee=0,F=0;for(;O>0;){const Z=this.a[F];if(Z.byteLength>O){const $=Z.slice(0,O);ie.set($,ee),ee+=O,z&&(this.a[F]=Z.slice(O),this.b-=O),O-=O}else ie.set(Z,ee),ee+=Z.byteLength,z?(this.a.shift(),this.b-=Z.byteLength):F++,O-=Z.byteLength}return ie}}e.ChunkStream=v;var b;(function(R){R[R.None=0]="None",R[R.Regular=1]="Regular",R[R.Control=2]="Control",R[R.Ack=3]="Ack",R[R.Disconnect=5]="Disconnect",R[R.ReplayRequest=6]="ReplayRequest",R[R.Pause=7]="Pause",R[R.Resume=8]="Resume",R[R.KeepAlive=9]="KeepAlive",R[R.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",R[R.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(b||(b={}));function f(R){switch(R){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(R){R[R.HeaderLength=13]="HeaderLength",R[R.AcknowledgeTime=2e3]="AcknowledgeTime",R[R.TimeoutTime=2e4]="TimeoutTime",R[R.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",R[R.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",R[R.KeepAliveSendTime=5e3]="KeepAliveSendTime",R[R.LatencySampleTime=6e4]="LatencySampleTime",R[R.LatencySampleCount=5]="LatencySampleCount",R[R.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",R[R.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(O,z,ie,ee){this.type=O,this.id=z,this.ack=ie,this.data=ee,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends I.Disposable{constructor(O){super(),this.f=this.B(new a.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new v,this.B(this.a.onData(z=>this.acceptChunk(z))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const z=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=z.readUInt32BE(9),this.g.messageType=z.readUInt8(0),this.g.id=z.readUInt32BE(1),this.g.ack=z.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const ie=this.g.messageType,ee=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",z),this.f.fire(new u(ie,ee,F,z)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const z=A.VSBuffer.alloc(13);z.writeUInt8(O.type,0),z.writeUInt32BE(O.id,1),z.writeUInt32BE(O.ack,5),z.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(z,O.data)}g(O,z){const ie=this.f===0;return this.d.push(O,z),this.f+=O.byteLength+z.byteLength,ie}h(){const O=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,z){this.g(O,z)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class d extends I.Disposable{constructor(O){super(),this.f=new a.Emitter,this.onMessage=this.f.event,this.g=new a.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new m(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(z=>{z.type===1&&this.f.fire(z.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new u(1,0,0,O))}}e.Protocol=d;class C extends D.IPCClient{static fromSocket(O,z){return new C(new d(O),z)}get onDidDispose(){return this.b.onDidDispose}constructor(O,z,ie=null){super(O,z,ie),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=C;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=k;class t{constructor(O){this.data=O,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let O=0,z=this.a;for(;z;)z=z.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let z=0,ie=this.a;for(;ie;)O[z++]=ie.data,ie=ie.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const z=new t(O);if(!this.a){this.a=z,this.b=z;return}this.b.next=z,this.b=z}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const O=Date.now();for(let z=0;z<n.a;z++)this.c[z]=O-1e3*z;setInterval(()=>{for(let z=n.a;z>=1;z--)this.c[z]=this.c[z-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),z=(1+n.a)*1e3;let ie=0;for(let ee=0;ee<n.a;ee++)O-this.c[ee]<=z&&ie++;return 1-ie/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var i;(function(R){R[R.Good=0]="Good",R[R.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function o(R){switch(R){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class c{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=c;class l{constructor(O,z){this.roundTripTime=O,this.recentHighRoundTripCount=z}}e.HighRoundTripTimeEvent=l;class s{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new k,this.onControlMessage=this.x.event,this.y=new k,this.onMessage=this.y.event,this.z=new k,this.onDidDispose=this.z.event,this.A=new k,this.onSocketClose=this.A.event,this.B=new k,this.onSocketTimeout=this.B.event,this.C=new k,this.onHighRoundTripTime=this.C.event,this.D=new k,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??n.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new I.DisposableStore,this.o=O.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new g),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new u(5,0,0,S());this.p.write(O),this.p.flush()}sendPause(){const O=new u(7,0,0,S());this.p.write(O)}sendResume(){const O=new u(8,0,0,S());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,z){this.a=!0,this.t.dispose(),this.t=new I.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(ie=>this.E(ie))),this.t.add(this.o.onClose(ie=>this.A.fire(ie))),this.r=this.t.add(new g),this.t.add(this.r.onSendLatencyRequest(ie=>this.J(ie))),this.t.add(this.r.onHighRoundTripTime(ie=>this.C.fire(ie))),this.t.add(this.r.onDidChangeConnectionHealth(ie=>this.D.fire(ie))),this.q.acceptChunk(z)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new u(3,0,this.h,S());this.p.write(O);const z=this.b.toArray();for(let ie=0,ee=z.length;ie<ee;ie++)this.p.write(z[ie]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const z=this.b.peek();if(z&&z.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const z=Date.now();z-this.m>1e4&&(this.m=z,this.p.write(new u(6,0,0,S())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const z=this.b.toArray();for(let ie=0,ee=z.length;ie<ee;ie++)this.p.write(z[ie]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const z=++this.c;this.h=this.g;const ie=new u(1,z,this.h,O);this.b.push(ie),this.a||(this.p.write(ie),this.G())}sendControl(O){const z=new u(2,0,0,O);this.p.write(z)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),z=Date.now()-O.writtenTime,ie=Date.now()-this.q.lastReadTime,ee=Date.now()-this.n;if(z>=2e4&&ie>=2e4&&ee>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:z,timeSinceLastReceivedSomeData:ie});return}const F=Math.max(2e4-z,2e4-ie,2e4-ee,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new u(3,0,this.h,S());this.p.write(O)}I(){this.h=this.g;const O=new u(9,0,this.h,S());this.p.write(O)}J(O){this.h=this.g;const z=new u(10,0,this.h,O);this.p.write(z)}K(O){this.h=this.g;const z=new u(11,0,this.h,O);this.p.write(z)}}e.PersistentProtocol=s;class g extends I.Disposable{constructor(){super(),this.a=this.B(new a.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new a.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new a.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,z=A.VSBuffer.alloc(4);z.writeUInt32BE(O,0),this.a.fire(z)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const z=O.readUInt32BE(0);if(this.g<=0||z!==this.h)return;const ie=Date.now()-this.g,ee=this.k++;this.j[ee%this.j.length]=ie;const F=this.l,Z=this.j.filter($=>$>=1e3).length;this.l=Z>=3?1:0,ie>1e3&&this.b.fire(new l(ie,Z)),F!==this.l&&this.c.fire(this.l)}}}),define(ve[101],Ee([1,0,48,14,15,19,149,9,6,2,23,98,57,42]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends b.ChannelServer{constructor(h){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",m=>a.VSBuffer.wrap(Buffer.from(m,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=f;class p{constructor(h,m){this.i=h,this.j=m,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const d=m&&m.timeout?m.timeout:6e4;this.b=new A.Delayer(d),this.d=null,this.f=null}getChannel(h){const m=this;return{call(d,C,k){return m.k(h,d,C,k)},listen(d,C){return m.l(h,d,C)}}}k(h,m,d,C=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(C.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const k=this.n(h),t=(0,A.createCancelablePromise)(i=>k.call(m,d,i)),r=C.onCancellationRequested(()=>t.cancel()),n=(0,y.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,m,d){if(!this.b)return w.Event.None;this.b.cancel();let C;const k=new w.Emitter({onWillAddFirstListener:()=>{C=this.n(h).listen(m,d)(k.fire,k),this.c.add(C)},onDidRemoveLastListener:()=>{this.c.delete(C),C.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,v.removeDangerousEnvVariables)(m.env),this.d=(0,E.fork)(this.i,h,m);const d=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.j.serverName}`);return}d.fire(a.VSBuffer.wrap(Buffer.from(o,"base64")))});const k=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&k.send(o.buffer.toString("base64")),r=d.event,n={send:t,onMessage:r};this.f=new b.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,y.dispose)(l)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(h){let m=this.g.get(h);return m||(m=this.m.getChannel(h),this.g.set(h,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(ve[60],Ee([1,0,15,9,6,2,7,3,21,42,100]),function(ae,e,E,A,a,I,D,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(l,s){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,s)}constructor(l,s=""){this.f=!0,this.debugLabel=s,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=g=>{if(this.traceSocketEvent("error",{code:g?.code,message:g?.message}),g){if(g.code==="EPIPE")return;(0,A.onUnexpectedError)(g)}},this.socket.on("error",this.a),this.b=g=>{this.traceSocketEvent("close",{hadError:g}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const s=g=>{this.traceSocketEvent("read",g),l(E.VSBuffer.wrap(g))};return this.socket.on("data",s),{dispose:()=>this.socket.off("data",s)}}onClose(l){const s=g=>{l({type:0,hadError:g,error:void 0})};return this.socket.on("close",s),{dispose:()=>this.socket.off("close",s)}}onEnd(l){const s=()=>{l()};return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,s=>{if(s){if(s.code==="EPIPE")return;(0,A.onUnexpectedError)(s)}})}catch(s){if(s.code==="EPIPE")return;(0,A.onUnexpectedError)(s)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,s)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const g=()=>{this.socket.off("close",g),this.socket.off("end",g),this.socket.off("error",g),this.socket.off("timeout",g),this.socket.off("drain",g),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",g),this.socket.on("end",g),this.socket.on("error",g),this.socket.on("timeout",g),this.socket.on("drain",g)})}}e.NodeSocket=v;var b;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var f;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(f||(f={}));class p extends I.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,s){this.socket.traceSocketEvent(l,s)}constructor(l,s,g,R){super(),this.f=this.B(new a.Emitter),this.g=this.B(new a.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:s,inflateBytesLength:g?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new u(this,s,g,R,this.f,(O,z)=>this.k(O,z))),this.B(this.a.onError(O=>{console.error(O),(0,A.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new T.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this.a.writeMessage(l)}k(l,s){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let g=2;l.byteLength<126?g+=0:l.byteLength<2**16?g+=2:g+=8;const R=E.VSBuffer.alloc(g);if(s?R.writeUInt8(194,0):R.writeUInt8(130,0),l.byteLength<126)R.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){R.writeUInt8(126,1);let O=1;R.writeUInt8(l.byteLength>>>8&255,++O),R.writeUInt8(l.byteLength>>>0&255,++O)}else{R.writeUInt8(127,1);let O=1;R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(l.byteLength>>>24&255,++O),R.writeUInt8(l.byteLength>>>16&255,++O),R.writeUInt8(l.byteLength>>>8&255,++O),R.writeUInt8(l.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([R,l]))}end(){this.h=!0,this.socket.end()}l(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const s=this.b.peek(this.j.readLen),g=s.readUInt8(0),R=(g&128)>>>7,O=(g&64)>>>6,z=s.readUInt8(1),ie=(z&128)>>>7,ee=z&127;this.j.state=2,this.j.readLen=2+(ie?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(R),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const s=this.b.read(this.j.readLen),g=s.readUInt8(1),R=(g&128)>>>7;let O=g&127,z=1;O===126?O=s.readUInt8(++z)*2**8+s.readUInt8(++z):O===127&&(O=s.readUInt8(++z)*0+s.readUInt8(++z)*0+s.readUInt8(++z)*0+s.readUInt8(++z)*0+s.readUInt8(++z)*2**24+s.readUInt8(++z)*2**16+s.readUInt8(++z)*2**8+s.readUInt8(++z));let ie=0;R&&(ie=s.readUInt8(++z)*2**24+s.readUInt8(++z)*2**16+s.readUInt8(++z)*2**8+s.readUInt8(++z)),this.j.state=3,this.j.readLen=O,this.j.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const s=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",s),d(s,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",s),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(s,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await a.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class u extends I.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(l,s,g,R,O,z){super(),this.k=l,this.l=O,this.m=z,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new a.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,s?(this.b=this.B(new h(this.k,R,g,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(ie=>this.a.fire(ie))),this.B(this.f.onError(ie=>this.a.fire(ie)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const s=await this.r(this.f,l);this.m(s,!0)}else this.m(l,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(l,s){return new Promise((g,R)=>{l.write(s),l.flush(O=>g(O))})}acceptFrame(l,s,g){this.h.push({data:l,isCompressed:s,isLastFrameOfMessage:g}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const s=await this.u(this.b,l.data,l.isLastFrameOfMessage);this.l.fire(s)}else this.l.fire(l.data)}this.s=!1}}u(l,s,g){return new Promise((R,O)=>{l.write(s),g&&l.write(E.VSBuffer.fromByteArray([0,0,255,255])),l.flush(z=>R(z))})}}class h extends I.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(l,s,g,R){super(),this.h=l,this.j=s,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(R),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(E.VSBuffer.wrap(O))}),g&&(this.h.traceSocketEvent("zlibInflateInitialWrite",g.buffer),this.b.write(g.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const s=E.VSBuffer.concat(this.g);this.g.length=0,l(s)})}}class m extends I.Disposable{constructor(l,s){super(),this.g=l,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",g=>{this.g.traceSocketEvent("zlibDeflateError",{message:g?.message,code:g?.code}),this.a.fire(g)}),this.b.on("data",g=>{this.g.traceSocketEvent("zlibDeflateData",g),this.f.push(E.VSBuffer.wrap(g))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let s=E.VSBuffer.concat(this.f);this.f.length=0,s=s.slice(0,s.byteLength-4),l(s)})}}function d(c,l){if(l===0)return;const s=c.byteLength>>>2;for(let ee=0;ee<s;ee++){const F=c.readUInt32BE(ee*4);c.writeUInt32BE(F^l,ee*4)}const g=s*4,R=c.byteLength-g,O=l>>>24&255,z=l>>>16&255,ie=l>>>8&255;R>=1&&c.writeUInt8(c.readUInt8(g)^O,g),R>=2&&c.writeUInt8(c.readUInt8(g+1)^z,g+1),R>=3&&c.writeUInt8(c.readUInt8(g+2)^ie,g+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const C={[2]:107,[1]:103};function k(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):l=(0,D.join)(S().os.tmpdir(),`vscode-ipc-${c}.sock`),r(l),l}e.createRandomIPCHandle=k;function t(c,l,s){const g=S().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${g}-${s}-${l}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${g.substr(0,8)}-${s}-${l}.sock`):R=(0,D.join)(c,`${s}-${l}.sock`),r(R),R}e.createStaticIPCHandle=t;function r(c){const l=C[P.platform];typeof l=="number"&&c.length>=l&&console.warn(`WARNING: IPC handle "${c}" is longer than ${l} chars, try a shorter --user-data-dir`)}class n extends y.IPCServer{static b(l){const s=a.Event.fromNodeEventEmitter(l,"connection");return a.Event.map(s,g=>({protocol:new T.Protocol(new v(g,"ipc-server-connection")),onDidClientDisconnect:a.Event.once(a.Event.fromNodeEventEmitter(g,"close"))}))}constructor(l){super(n.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function i(c){return new Promise((l,s)=>{const g=S().net.createServer();g.on("error",s),g.listen(c,()=>{g.removeListener("error",s),l(new n(g))})})}e.serve=i;function o(c,l){return new Promise((s,g)=>{const R=S().net.createConnection(c,()=>{R.removeListener("error",g),s(T.Client.fromSocket(new v(R,`ipc-client${l}`),l))});R.once("error",g)})}e.connect=o}),define(ve[157],Ee([1,0,14,6,2,8]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function P(S){const v=S;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class y extends a.Disposable{constructor(v,b=Object.create(null)){super(),this.m=v,this.n=b,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new E.ThrottledDelayer(y.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(v=>this.r(v)))}r(v){v.changed?.forEach((b,f)=>this.s(f,b)),v.deleted?.forEach(b=>this.s(b,void 0))}s(v,b){if(this.c===w.Closed)return;let f=!1;(0,I.isUndefinedOrNull)(b)?f=this.f.delete(v):this.f.get(v)!==b&&(this.f.set(v,b),f=!0),f&&this.b.fire(v)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(v,b){const f=this.f.get(v);return(0,I.isUndefinedOrNull)(f)?b:f}getBoolean(v,b){const f=this.get(v);return(0,I.isUndefinedOrNull)(f)?b:f==="true"}getNumber(v,b){const f=this.get(v);return(0,I.isUndefinedOrNull)(f)?b:parseInt(f,10)}async set(v,b){if(this.c===w.Closed)return;if((0,I.isUndefinedOrNull)(b))return this.delete(v);const f=String(b);if(this.f.get(v)!==f)return this.f.set(v,f),this.j.set(v,f),this.h.delete(v),this.b.fire(v),this.w()}async delete(v){if(!(this.c===w.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire(v),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(v).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(v){if(!!this.u)return this.w(v)}async w(v){return this.g.trigger(()=>this.v(),v)}async whenFlushed(){if(!!this.u)return new Promise(v=>this.l.push(v))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}y.a=100,e.Storage=y;class T{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((b,f)=>this.a.set(f,b)),v.delete?.forEach(b=>this.a.delete(b))}async close(){}}e.InMemoryStorageDatabase=T}),define(ve[102],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(a,I){this.lineNumber=a,this.column=I}with(a=this.lineNumber,I=this.column){return a===this.lineNumber&&I===this.column?this:new E(a,I)}delta(a=0,I=0){return this.with(this.lineNumber+a,this.column+I)}equals(a){return E.equals(this,a)}static equals(a,I){return!a&&!I?!0:!!a&&!!I&&a.lineNumber===I.lineNumber&&a.column===I.column}isBefore(a){return E.isBefore(this,a)}static isBefore(a,I){return a.lineNumber<I.lineNumber?!0:I.lineNumber<a.lineNumber?!1:a.column<I.column}isBeforeOrEqual(a){return E.isBeforeOrEqual(this,a)}static isBeforeOrEqual(a,I){return a.lineNumber<I.lineNumber?!0:I.lineNumber<a.lineNumber?!1:a.column<=I.column}static compare(a,I){const D=a.lineNumber|0,P=I.lineNumber|0;if(D===P){const w=a.column|0,y=I.column|0;return w-y}return D-P}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(a){return new E(a.lineNumber,a.column)}static isIPosition(a){return a&&typeof a.lineNumber=="number"&&typeof a.column=="number"}}e.Position=E}),define(ve[49],Ee([1,0,102]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(I,D,P,w){I>P||I===P&&D>w?(this.startLineNumber=P,this.startColumn=w,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=P,this.endColumn=w)}isEmpty(){return A.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return A.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}static strictContainsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<=I.startColumn||D.lineNumber===I.endLineNumber&&D.column>=I.endColumn)}containsRange(I){return A.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return A.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return A.plusRange(this,I)}static plusRange(I,D){let P,w,y,T;return D.startLineNumber<I.startLineNumber?(P=D.startLineNumber,w=D.startColumn):D.startLineNumber===I.startLineNumber?(P=D.startLineNumber,w=Math.min(D.startColumn,I.startColumn)):(P=I.startLineNumber,w=I.startColumn),D.endLineNumber>I.endLineNumber?(y=D.endLineNumber,T=D.endColumn):D.endLineNumber===I.endLineNumber?(y=D.endLineNumber,T=Math.max(D.endColumn,I.endColumn)):(y=I.endLineNumber,T=I.endColumn),new A(P,w,y,T)}intersectRanges(I){return A.intersectRanges(this,I)}static intersectRanges(I,D){let P=I.startLineNumber,w=I.startColumn,y=I.endLineNumber,T=I.endColumn;const S=D.startLineNumber,v=D.startColumn,b=D.endLineNumber,f=D.endColumn;return P<S?(P=S,w=v):P===S&&(w=Math.max(w,v)),y>b?(y=b,T=f):y===b&&(T=Math.min(T,f)),P>y||P===y&&w>T?null:new A(P,w,y,T)}equalsRange(I){return A.equalsRange(this,I)}static equalsRange(I,D){return!I&&!D?!0:!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(I){return new E.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(I){return new E.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new A(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new A(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(I){return new A(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(I){return new A(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new A(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,D=I){return new A(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new A(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const y=I.startLineNumber|0,T=D.startLineNumber|0;if(y===T){const S=I.startColumn|0,v=D.startColumn|0;if(S===v){const b=I.endLineNumber|0,f=D.endLineNumber|0;if(b===f){const p=I.endColumn|0,u=D.endColumn|0;return p-u}return b-f}return S-v}return y-T}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.Range=A}),define(ve[158],Ee([1,0,6,2]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class a{constructor(){this.a=new Map,this.b=new Map,this.c=new E.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,w){return this.a.set(P,w),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===w&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,w){this.b.get(P)?.dispose();const y=new I(this,P,w);return this.b.set(P,y),(0,A.toDisposable)(()=>{const T=this.b.get(P);!T||T!==y||(this.b.delete(P),T.dispose())})}async getOrCreate(P){const w=this.get(P);if(w)return w;const y=this.b.get(P);return!y||y.isResolved?null:(await y.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const y=this.b.get(P);return!!(!y||y.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=a;class I extends A.Disposable{get isResolved(){return this.c}constructor(P,w,y){super(),this.f=P,this.g=w,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ve[159],Ee([1,0,45,4,49,158]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(g,R,O){this._tokenBrand=void 0,this.offset=g,this.type=R,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class P{constructor(g,R){this._tokenizationResultBrand=void 0,this.tokens=g,this.endState=R}}e.TokenizationResult=P;class w{constructor(g,R){this._encodedTokenizationResultBrand=void 0,this.tokens=g,this.endState=R}}e.EncodedTokenizationResult=w;var y;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(y=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(s){const g=new Map;g.set(0,E.Codicon.symbolMethod),g.set(1,E.Codicon.symbolFunction),g.set(2,E.Codicon.symbolConstructor),g.set(3,E.Codicon.symbolField),g.set(4,E.Codicon.symbolVariable),g.set(5,E.Codicon.symbolClass),g.set(6,E.Codicon.symbolStruct),g.set(7,E.Codicon.symbolInterface),g.set(8,E.Codicon.symbolModule),g.set(9,E.Codicon.symbolProperty),g.set(10,E.Codicon.symbolEvent),g.set(11,E.Codicon.symbolOperator),g.set(12,E.Codicon.symbolUnit),g.set(13,E.Codicon.symbolValue),g.set(15,E.Codicon.symbolEnum),g.set(14,E.Codicon.symbolConstant),g.set(15,E.Codicon.symbolEnum),g.set(16,E.Codicon.symbolEnumMember),g.set(17,E.Codicon.symbolKeyword),g.set(27,E.Codicon.symbolSnippet),g.set(18,E.Codicon.symbolText),g.set(19,E.Codicon.symbolColor),g.set(20,E.Codicon.symbolFile),g.set(21,E.Codicon.symbolReference),g.set(22,E.Codicon.symbolCustomColor),g.set(23,E.Codicon.symbolFolder),g.set(24,E.Codicon.symbolTypeParameter),g.set(25,E.Codicon.account),g.set(26,E.Codicon.issues);function R(ie){let ee=g.get(ie);return ee||(console.info("No codicon found for CompletionItemKind "+ie),ee=E.Codicon.symbolProperty),ee}s.toIcon=R;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function z(ie,ee){let F=O.get(ie);return typeof F>"u"&&!ee&&(F=9),F}s.fromString=z})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var S;(function(s){s[s.Deprecated=1]="Deprecated"})(S=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var f;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(f=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(s){return s&&A.URI.isUri(s.uri)&&a.Range.isIRange(s.range)&&(a.Range.isIRange(s.originSelectionRange)||a.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=m;var d;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(d=e.SymbolKind||(e.SymbolKind={}));var C;(function(s){s[s.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));var k;(function(s){const g=new Map;g.set(0,E.Codicon.symbolFile),g.set(1,E.Codicon.symbolModule),g.set(2,E.Codicon.symbolNamespace),g.set(3,E.Codicon.symbolPackage),g.set(4,E.Codicon.symbolClass),g.set(5,E.Codicon.symbolMethod),g.set(6,E.Codicon.symbolProperty),g.set(7,E.Codicon.symbolField),g.set(8,E.Codicon.symbolConstructor),g.set(9,E.Codicon.symbolEnum),g.set(10,E.Codicon.symbolInterface),g.set(11,E.Codicon.symbolFunction),g.set(12,E.Codicon.symbolVariable),g.set(13,E.Codicon.symbolConstant),g.set(14,E.Codicon.symbolString),g.set(15,E.Codicon.symbolNumber),g.set(16,E.Codicon.symbolBoolean),g.set(17,E.Codicon.symbolArray),g.set(18,E.Codicon.symbolObject),g.set(19,E.Codicon.symbolKey),g.set(20,E.Codicon.symbolNull),g.set(21,E.Codicon.symbolEnumMember),g.set(22,E.Codicon.symbolStruct),g.set(23,E.Codicon.symbolEvent),g.set(24,E.Codicon.symbolOperator),g.set(25,E.Codicon.symbolTypeParameter);function R(O){let z=g.get(O);return z||(console.info("No codicon found for SymbolKind "+O),z=E.Codicon.symbolProperty),z}s.toIcon=R})(k=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(g){this.value=g}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var r;(function(s){function g(R){return!R||typeof R!="object"?!1:typeof R.id=="string"&&typeof R.title=="string"}s.is=g})(r=e.Command||(e.Command={}));var n;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(s){s[s.Unresolved=0]="Unresolved",s[s.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var c;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var l;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(l=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[160],Ee([10,11]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(ve[161],Ee([1,0,6,2,160]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class I extends A.Disposable{constructor(v,b="",f="",p=!0,u){super(),this.h=this.B(new E.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=b,this.u=f,this.w=p,this.C=u}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,b){this.C&&await this.C(v)}}e.Action=I;class D extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new E.Emitter),this.onWillRun=this.f.event,this.h=this.B(new E.Emitter),this.onDidRun=this.h.event}async run(v,b){if(!v.enabled)return;this.f.fire({action:v});let f;try{await this.runAction(v,b)}catch(p){f=p}this.h.fire({action:v,error:f})}async runAction(v,b){await v.run(b)}}e.ActionRunner=D;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let b=[];for(const f of v)f.length&&(b.length?b=[...b,new P,...f]:b=f);return b}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class w{get actions(){return this.a}constructor(v,b,f,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=b,this.class=p,this.a=f}async run(){}}e.SubmenuAction=w;class y extends I{constructor(){super(y.ID,a.localize(0,null),void 0,!1)}}y.ID="vs.actions.empty",e.EmptySubmenuAction=y;function T(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async()=>S.run(),tooltip:S.label}}e.toAction=T}),define(ve[162],Ee([10,11]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(ve[163],Ee([1,0,162]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,a=A*60,I=a*24,D=I*7,P=I*30,w=I*365;function y(S,v,b,f){typeof S!="number"&&(S=S.getTime());const p=Math.round((new Date().getTime()-S)/1e3);if(p<-30)return(0,E.localize)(0,null,y(new Date().getTime()+p*1e3,!1));if(!f&&p<30)return(0,E.localize)(1,null);let u;return p<A?(u=p,v?u===1?b?(0,E.localize)(2,null,u):(0,E.localize)(3,null,u):b?(0,E.localize)(4,null,u):(0,E.localize)(5,null,u):u===1?b?(0,E.localize)(6,null,u):(0,E.localize)(7,null,u):b?(0,E.localize)(8,null,u):(0,E.localize)(9,null,u)):p<a?(u=Math.floor(p/A),v?u===1?b?(0,E.localize)(10,null,u):(0,E.localize)(11,null,u):b?(0,E.localize)(12,null,u):(0,E.localize)(13,null,u):u===1?b?(0,E.localize)(14,null,u):(0,E.localize)(15,null,u):b?(0,E.localize)(16,null,u):(0,E.localize)(17,null,u)):p<I?(u=Math.floor(p/a),v?u===1?b?(0,E.localize)(18,null,u):(0,E.localize)(19,null,u):b?(0,E.localize)(20,null,u):(0,E.localize)(21,null,u):u===1?b?(0,E.localize)(22,null,u):(0,E.localize)(23,null,u):b?(0,E.localize)(24,null,u):(0,E.localize)(25,null,u)):p<D?(u=Math.floor(p/I),v?u===1?(0,E.localize)(26,null,u):(0,E.localize)(27,null,u):u===1?(0,E.localize)(28,null,u):(0,E.localize)(29,null,u)):p<P?(u=Math.floor(p/D),v?u===1?b?(0,E.localize)(30,null,u):(0,E.localize)(31,null,u):b?(0,E.localize)(32,null,u):(0,E.localize)(33,null,u):u===1?b?(0,E.localize)(34,null,u):(0,E.localize)(35,null,u):b?(0,E.localize)(36,null,u):(0,E.localize)(37,null,u)):p<w?(u=Math.floor(p/P),v?u===1?b?(0,E.localize)(38,null,u):(0,E.localize)(39,null,u):b?(0,E.localize)(40,null,u):(0,E.localize)(41,null,u):u===1?b?(0,E.localize)(42,null,u):(0,E.localize)(43,null,u):b?(0,E.localize)(44,null,u):(0,E.localize)(45,null,u)):(u=Math.floor(p/w),v?u===1?b?(0,E.localize)(46,null,u):(0,E.localize)(47,null,u):b?(0,E.localize)(48,null,u):(0,E.localize)(49,null,u):u===1?b?(0,E.localize)(50,null,u):(0,E.localize)(51,null,u):b?(0,E.localize)(52,null,u):(0,E.localize)(53,null,u))}e.fromNow=y;function T(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ve[164],Ee([10,11]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(ve[38],Ee([1,0,18,8,164]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function I(S,v){return v&&(S.stack||S.stacktrace)?a.localize(0,null,P(S),D(S.stack)||D(S.stacktrace)):P(S)}function D(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?a.localize(1,null,S.message):S.message||a.localize(2,null)}function w(S=null,v=!1){if(!S)return a.localize(3,null);if(Array.isArray(S)){const b=E.coalesce(S),f=w(b[0],v);return b.length>1?a.localize(4,null,f,b.length):f}if(A.isString(S))return S;if(S.detail){const b=S.detail;if(b.error)return I(b.error,v);if(b.exception)return I(b.exception,v)}return S.stack?I(S,v):S.message?S.message:a.localize(5,null)}e.toErrorMessage=w;function y(S){const v=S;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=y;function T(S,v){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=v,b}e.createErrorWithActions=T}),define(ve[165],Ee([10,11]),function(ae,e){return ae.create("vs/base/common/jsonErrorMessages",e)}),define(ve[166],Ee([1,0,165]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(a){switch(a){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ve[167],Ee([10,11]),function(ae,e){return ae.create("vs/base/node/zip",e)}),define(ve[168],Ee([10,11]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[169],Ee([10,11]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(ve[170],Ee([10,11]),function(ae,e){return ae.create("vs/platform/environment/node/argvHelper",e)}),define(ve[171],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[172],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[173],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ve[174],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ve[175],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[176],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[177],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[178],Ee([10,11]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[179],Ee([10,11]),function(ae,e){return ae.create("vs/platform/files/common/fileService",e)}),define(ve[180],Ee([10,11]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(ve[181],Ee([10,11]),function(ae,e){return ae.create("vs/platform/files/common/io",e)}),define(ve[182],Ee([10,11]),function(ae,e){return ae.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[183],Ee([10,11]),function(ae,e){return ae.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[184],Ee([10,11]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(ve[185],Ee([10,11]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(ve[186],Ee([10,11]),function(ae,e){return ae.create("vs/platform/shell/node/shellEnv",e)}),define(ve[187],Ee([10,11]),function(ae,e){return ae.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[188],Ee([10,11]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[189],Ee([10,11]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[190],Ee([10,11]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[191],Ee([10,11]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(ve[192],Ee([10,11]),function(ae,e){return ae.create("vs/server/node/serverEnvironmentService",e)}),define(ve[193],Ee([10,11]),function(ae,e){return ae.create("vs/server/node/serverServices",e)}),define(ve[194],Ee([10,11]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(ve[195],Ee([10,11]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[196],Ee([10,11]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[197],Ee([1,0,6,2]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class a{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,w,y){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(P,w,y){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}a.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=a;class I extends A.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,w,y){this.b.call("attach",[P,w,y])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,w){this.b.call("terminate",[P,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,w){return this.b.call("openExtensionDevelopmentHostWindow",[P,w])}}e.ExtensionHostDebugChannelClient=I}),define(ve[198],Ee([1,0,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class A{constructor(D){this.a=D}listen(D,P,w){throw new Error("Invalid listen")}call(D,P,w){switch(P){case"download":return this.a.download(E.URI.revive(w[0]),E.URI.revive(w[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=A;class a{constructor(D,P){this.a=D,this.b=P}async download(D,P){const w=this.b();w&&(D=w.transformOutgoingURI(D),P=w.transformOutgoingURI(P)),await this.a.call("download",[D,P])}}e.DownloadServiceChannelClient=a}),define(ve[103],Ee([1,0,163,86,13,7,28,20,4]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class y{get appRoot(){return(0,I.dirname)(a.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,I.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?w.URI.file((0,I.join)(f,"argv.json")):(0,P.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,I.resolve)(f):(0,I.normalize)((0,I.join)(a.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,I.resolve)(f)):w.URI.file((0,I.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,I.resolve)(f);const p=D.env.VSCODE_EXTENSIONS;if(p)return p;const u=D.env.VSCODE_PORTABLE;return u?(0,I.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,I.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,I.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);u&&u[1]&&u[2]&&f.push([u[1],u[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?w.URI.file((0,I.join)(f,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,u){this.a=f,this.b=p,this.c=u,this.editSessionId=this.args.editSessionId}}Le([A.memoize],y.prototype,"appRoot",null),Le([A.memoize],y.prototype,"userHome",null),Le([A.memoize],y.prototype,"userDataPath",null),Le([A.memoize],y.prototype,"appSettingsHome",null),Le([A.memoize],y.prototype,"tmpDir",null),Le([A.memoize],y.prototype,"cacheHome",null),Le([A.memoize],y.prototype,"stateResource",null),Le([A.memoize],y.prototype,"userRoamingDataHome",null),Le([A.memoize],y.prototype,"userDataSyncHome",null),Le([A.memoize],y.prototype,"userDataSyncLogResource",null),Le([A.memoize],y.prototype,"editSessionsLogResource",null),Le([A.memoize],y.prototype,"sync",null),Le([A.memoize],y.prototype,"machineSettingsResource",null),Le([A.memoize],y.prototype,"workspaceStorageHome",null),Le([A.memoize],y.prototype,"localHistoryHome",null),Le([A.memoize],y.prototype,"keyboardLayoutResource",null),Le([A.memoize],y.prototype,"argvResource",null),Le([A.memoize],y.prototype,"isExtensionDevelopment",null),Le([A.memoize],y.prototype,"untitledWorkspacesHome",null),Le([A.memoize],y.prototype,"installSourcePath",null),Le([A.memoize],y.prototype,"builtinExtensionsPath",null),Le([A.memoize],y.prototype,"extensionsPath",null),Le([A.memoize],y.prototype,"extensionDevelopmentLocationURI",null),Le([A.memoize],y.prototype,"extensionDevelopmentKind",null),Le([A.memoize],y.prototype,"extensionTestsLocationURI",null),Le([A.memoize],y.prototype,"debugExtensionHost",null),Le([A.memoize],y.prototype,"logLevel",null),Le([A.memoize],y.prototype,"extensionLogLevel",null),Le([A.memoize],y.prototype,"serviceMachineIdResource",null),Le([A.memoize],y.prototype,"telemetryLogResource",null),Le([A.memoize],y.prototype,"disableWorkspaceTrust",null),Le([A.memoize],y.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=y;function T(b,f){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId,b.extensionEnvironment)}e.parseExtensionHostPort=T;function S(b,f){return v(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,f,b.extensionEnvironment)}e.parsePtyHostPort=S;function v(b,f,p,u,h,m){const C=Number(f||b)||(u?null:p),k=C?Boolean(!!f):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:C,break:k,debugId:h,env:t}}}),define(ve[61],Ee([1,0,282,3,169]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const I={o:(0,a.localize)(0,null),e:(0,a.localize)(1,null),t:(0,a.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,a.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,a.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,a.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,a.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,a.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,a.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,a.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,a.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,a.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,a.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,a.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,a.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,a.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,a.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,a.localize)(17,null)},category:{type:"string",cat:"e",description:(0,a.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,a.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,a.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,a.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,a.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,a.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,a.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,a.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,a.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,a.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,a.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,a.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,a.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,a.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,a.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,a.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,a.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,a.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,u,h=D){const m=p.find(c=>c.length>0&&c[0]!=="-"),d={},C=["_"],k=[],t={};let r;for(const c in u){const l=u[c];l.type==="subcommand"?c===m&&(r=l):(l.alias&&(d[c]=l.alias),l.type==="string"||l.type==="string[]"?(C.push(c),l.deprecates&&C.push(...l.deprecates)):l.type==="boolean"&&(k.push(c),l.deprecates&&k.push(...l.deprecates)),l.global&&(t[c]=l))}if(r&&m){const c=t;for(const R in r.options)c[R]=r.options[R];const l=p.filter(R=>R!==m),s=h.getSubcommandReporter?h.getSubcommandReporter(m):void 0,g=P(l,c,s);return{[m]:g,_:[]}}const n=E(p,{string:C,boolean:k,alias:d}),i={},o=n;i._=n._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in u){const l=u[c];if(l.type==="subcommand")continue;l.alias&&delete o[l.alias];let s=o[c];if(l.deprecates)for(const g of l.deprecates)o.hasOwnProperty(g)&&(s||(s=o[g],s&&h.onDeprecatedOption(g,l.deprecationMessage||(0,a.localize)(36,null,c))),delete o[g]);if(typeof s<"u"){if(l.type==="string[]"){if(Array.isArray(s)||(s=[s]),!l.allowEmptyValue){const g=s.filter(R=>R.length>0);g.length!==s.length&&(h.onEmptyValue(c),s=g.length>0?g:void 0)}}else l.type==="string"&&(Array.isArray(s)?(s=s.pop(),h.onMultipleValues(c,s)):!s&&!l.allowEmptyValue&&(h.onEmptyValue(c),s=void 0));i[c]=s,l.deprecationMessage&&h.onDeprecatedOption(c,l.deprecationMessage)}delete o[c]}for(const c in o)h.onUnknownOption(c);return i}e.parseArgs=P;function w(p,u){let h="";return u.args&&(Array.isArray(u.args)?h=` <${u.args.join("> <")}>`:h=` <${u.args}>`),u.alias?`-${u.alias} --${p}${h}`:`--${p}${h}`}function y(p,u){const h=[];for(const m in p){const d=p[m],C=w(m,d);h.push([C,d.description])}return T(h,u)}e.formatOptions=y;function T(p,u){const m=p.reduce((k,t)=>Math.max(k,t[0].length),12)+2+1;if(u-m<25)return p.reduce((k,t)=>k.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=u-m-1,C=[];for(const k of p){const t=k[0],r=v(k[1],d),n=S(m-t.length-2);C.push("  "+t+n+r[0]);for(let i=1;i<r.length;i++)C.push(S(m)+r[i])}return C}function S(p){return" ".repeat(p)}function v(p,u){const h=[];for(;p.length;){const m=p.length<u?p.length:p.lastIndexOf(" ",u),d=p.slice(0,m).trim();p=p.slice(m),h.push(d)}return h}function b(p,u,h,m,d){const C=process.stdout.isTTY&&process.stdout.columns||80,k=d?.noInputFiles!==!0?`[${(0,a.localize)(37,null)}...]`:"",t=[`${p} ${h}`];t.push(""),t.push(`${(0,a.localize)(38,null)}: ${u} [${(0,a.localize)(39,null)}]${k}`),t.push(""),d?.noPipe!==!0&&(A.isWindows?t.push((0,a.localize)(40,null,u)):t.push((0,a.localize)(41,null,u)),t.push(""));const r={},n=[];for(const i in m){const o=m[i];if(o.type==="subcommand")o.description&&n.push({command:i,description:o.description});else if(o.description&&o.cat){let c=r[o.cat];c||(r[o.cat]=c={}),c[i]=o}}for(const i in r){const o=i,c=r[o];c&&(t.push(I[o]),t.push(...y(c,C)),t.push(""))}return n.length&&(t.push((0,a.localize)(42,null)),t.push(...T(n.map(i=>[i.command,i.description]),C)),t.push("")),t.join(`
`)}e.buildHelpMessage=b;function f(p,u){return`${p||(0,a.localize)(43,null)}
${u||(0,a.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ve[199],Ee([1,0,283,170,61]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const I=2048;function D(v,b){const f=(C,k)=>{console.warn((0,A.localize)(0,null,C,k))},p=C=>{console.warn((0,A.localize)(1,null,C))},u=(C,k)=>{console.warn((0,A.localize)(2,null,C,k))},h=C=>({onUnknownOption:k=>{C!=="tunnel"&&console.warn((0,A.localize)(3,null,k,C))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:u,getSubcommandReporter:C!=="tunnel"?h:void 0}),m={onUnknownOption:C=>{console.warn((0,A.localize)(4,null,C))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:u,getSubcommandReporter:h},d=(0,a.parseArgs)(v,a.OPTIONS,b?m:void 0);return d.goto&&d._.forEach(C=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,A.localize)(5,null))),d["max-memory"]&&E(parseInt(d["max-memory"])>=I,`The max-memory argument cannot be specified lower than ${I} MB.`),d}function P(v){const b=v.findIndex(f=>!/^-/.test(f));if(b>-1)return[...v.slice(0,b),...v.slice(b+1)]}function w(v){let[,...b]=v;process.env.VSCODE_DEV&&(b=P(b)||[]);const f=!S(process.env);return D(b,f)}e.parseMainProcessArgv=w;function y(v){let[,,...b]=v;return process.env.VSCODE_DEV&&(b=P(b)||[]),D(b,!0)}e.parseCLIProcessArgv=y;function T(v,...b){const f=v.indexOf("--");return f===-1?v.push(...b):v.splice(f,0,...b),v}e.addArg=T;function S(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function ae(e,E,A){function a(D,P){const w=I(D,P),y=[w];return e.isAbsolute(w)||y.unshift(A),e.resolve(...y)}function I(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,P);const T=D["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(S,"AppData","Roaming")}break;case"darwin":y=e.join(E.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,P)}return{getUserDataPath:a}}if(typeof define=="function")define(ve[200],Ee([94,29,28]),function(e,E,A){return ae(e,E,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=ae(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[201],Ee([1,0,29,103,200]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class I extends A.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,a.getUserDataPath)(P,w.nameShort)},w)}}e.NativeEnvironmentService=I}),define(ve[202],Ee([1,0,8,174]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function a(D,P,w){try{I(D,P,w)}catch(y){console.error(y?.message??y)}return D}e.localizeManifest=a;function I(D,P,w){const y=(T,S,v)=>{const b=T[S];if((0,E.isString)(b)){const f=b,p=f.length;if(p>1&&f[0]==="%"&&f[p-1]==="%"){const u=f.substr(1,p-2);let h=P[u];h===void 0&&w&&(h=w[u]);const m=typeof h=="string"?h:h?.message,d=w?.[u],C=typeof d=="string"?d:d?.message;if(!m){C||console.warn(`[${D.name}]: ${(0,A.localize)(0,null,u)}`);return}if(v&&(S==="title"||S==="category")&&C&&C!==m){const k={value:m,original:C};T[S]=k}else T[S]=m}}else if((0,E.isObject)(b))for(const f in b)b.hasOwnProperty(f)&&(f==="commands"?y(b,f,!0):y(b,f,v));else if(Array.isArray(b))for(let f=0;f<b.length;f++)y(b,f,v)};for(const T in D)D.hasOwnProperty(T)&&y(D,T)}}),define(ve[203],Ee([1,0,9]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(I,D){this.a.set(I,D)}updateManifest(I){if(!(typeof I.main>"u"&&typeof I.browser>"u")&&(I.activationEvents===void 0&&Object.assign(I,{activationEvents:[]}),!(!Array.isArray(I.activationEvents)||!I.contributes)))for(const D in I.contributes){const P=this.a.get(D);if(!P)continue;const w=I.contributes[D],y=Array.isArray(w)?w:[w];try{P(y,I.activationEvents)}catch(T){(0,E.onUnexpectedError)(T)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(ve[73],Ee([1,0,20,58,178,50]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(h){return h=h.trim(),h==="*"||D.test(h)}e.isValidVersionStr=w;function y(h){if(!w(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=h.match(D);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=y;function T(h){if(!h)return null;const m=h.majorBase,d=h.majorMustEqual,C=h.minorBase;let k=h.minorMustEqual;const t=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(m===0||(k=!1),r=!1);let n=0;if(h.preRelease){const i=P.exec(h.preRelease);if(i){const[,o,c,l]=i;n=Date.UTC(Number(o),Number(c)-1,Number(l))}}return{majorBase:m,majorMustEqual:d,minorBase:C,minorMustEqual:k,patchBase:t,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:n}}e.normalizeVersion=T;function S(h,m,d){let C;typeof h=="string"?C=T(y(h)):C=h;let k;m instanceof Date?k=m.getTime():typeof m=="string"&&(k=new Date(m).getTime());let t;if(typeof d=="string"?t=T(y(d)):t=d,!C||!t)return!1;const r=C.majorBase,n=C.minorBase,i=C.patchBase;let o=t.majorBase,c=t.minorBase,l=t.patchBase;const s=t.notBefore;let g=t.majorMustEqual,R=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:n>c?!0:n<c||k&&k<s?!1:i>=l:(r===1&&o===0&&(!g||!R||!O)&&(o=1,c=0,l=0,g=!0,R=!1,O=!1),r<o?!1:r>o?!g:n<c?!1:n>c?!R:i<l?!1:i>l?!O:!(k&&k<s))}e.isValidVersion=S;function v(h,m,d,C,k){const t=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return t.push([A.default.Error,a.localize(0,null)]),t;if(typeof C.name!="string")return t.push([A.default.Error,a.localize(1,null,"name")]),t;if(typeof C.version!="string")return t.push([A.default.Error,a.localize(2,null,"version")]),t;if(!C.engines)return t.push([A.default.Error,a.localize(3,null,"engines")]),t;if(typeof C.engines.vscode!="string")return t.push([A.default.Error,a.localize(4,null,"engines.vscode")]),t;if(typeof C.extensionDependencies<"u"&&!u(C.extensionDependencies))return t.push([A.default.Error,a.localize(5,null,"extensionDependencies")]),t;if(typeof C.activationEvents<"u"){if(!u(C.activationEvents))return t.push([A.default.Error,a.localize(6,null,"activationEvents")]),t;if(typeof C.main>"u"&&typeof C.browser>"u")return t.push([A.default.Error,a.localize(7,null,"activationEvents","main")]),t}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&t.push([A.default.Warning,a.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return t.push([A.default.Error,a.localize(9,null,"main")]),t;{const i=(0,E.joinPath)(d,C.main);(0,E.isEqualOrParent)(i,d)||t.push([A.default.Warning,a.localize(10,null,i.path,d.path)])}if(typeof C.activationEvents>"u")return t.push([A.default.Error,a.localize(11,null,"activationEvents","main")]),t}if(typeof C.browser<"u"){if(typeof C.browser!="string")return t.push([A.default.Error,a.localize(12,null,"browser")]),t;{const i=(0,E.joinPath)(d,C.browser);(0,E.isEqualOrParent)(i,d)||t.push([A.default.Warning,a.localize(13,null,i.path,d.path)])}if(typeof C.activationEvents>"u")return t.push([A.default.Error,a.localize(14,null,"activationEvents","browser")]),t}if(!I.valid(C.version))return t.push([A.default.Error,a.localize(15,null)]),t;const r=[];if(!b(h,m,C,k,r))for(const i of r)t.push([A.default.Error,i]);return t}e.validateExtensionManifest=v;function b(h,m,d,C,k){return C||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(h,m,d.engines.vscode,k)}e.isValidExtensionVersion=b;function f(h,m,d){return h==="*"||p(m,d,h)}e.isEngineValid=f;function p(h,m,d,C=[]){const k=T(y(d));if(!k)return C.push(a.localize(16,null,d)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return C.push(a.localize(17,null,d)),!1}else if(!k.majorMustEqual)return C.push(a.localize(18,null,d)),!1;return S(h,m,k)?!0:(C.push(a.localize(19,null,h,d)),!1)}function u(h){if(!Array.isArray(h))return!1;for(let m=0,d=h.length;m<d;m++)if(typeof h[m]!="string")return!1;return!0}}),define(ve[204],Ee([1,0,15,21]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function a(I,D,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const T=(await D.readFile(I.serviceMachineIdResource)).value.toString();w=(0,A.isUUID)(T)?T:null}catch{w=null}if(!w){w=(0,A.generateUuid)();try{await D.writeFile(I.serviceMachineIdResource,E.VSBuffer.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=a}),define(ve[62],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(a,I=[],D=!1){this.ctor=a,this.staticArguments=I,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E}),define(ve[205],Ee([1,0,62]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var a;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(a=e.InstantiationType||(e.InstantiationType={}));function I(P,w,y){w instanceof E.SyncDescriptor||(w=new E.SyncDescriptor(w,[],Boolean(y))),A.push([P,w])}e.registerSingleton=I;function D(){return A}e.getSingletonServiceDescriptors=D}),define(ve[206],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(I,D){this.key=I,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class A{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const D of this.a.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const P=this.lookupOrInsertNode(I),w=this.lookupOrInsertNode(D);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(I){const D=this.b(I);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(I){const D=this.b(I);let P=this.a.get(D);return P||(P=new E(D,I),this.a.set(D,P)),P}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[D,P]of this.a)I.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,D]of this.a){const P=new Set([I]),w=this.c(D,P);if(w)return w}}c(I,D){for(const[P,w]of I.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const y=this.c(w,D);if(y)return y;D.delete(P)}}}e.Graph=A}),define(ve[5],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=a("instantiationService");function A(D,P,w){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:D,index:w}):(P[E.DI_DEPENDENCIES]=[{id:D,index:w}],P[E.DI_TARGET]=P)}function a(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const P=function(w,y,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,w,T)};return P.toString=()=>D,E.serviceIds.set(D,P),P}e.createDecorator=a;function I(D){return D}e.refineServiceDecorator=I}),define(ve[24],Ee([1,0,8,4,5]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,a.createDecorator)("configurationService");function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof A.URI)}e.isConfigurationOverrides=I;function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function y(u,h){const m=Object.create(null);for(const d in u)T(m,d,u[d],h);return m}e.toValuesTree=y;function T(u,h,m,d){const C=h.split("."),k=C.pop();let t=u;for(let r=0;r<C.length;r++){const n=C[r];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${h} as ${C.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[k]=m}catch{d(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(t)}`)}else d(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function S(u,h){const m=h.split(".");v(u,m)}e.removeFromValueTree=S;function v(u,h){const m=h.shift();if(h.length===0){delete u[m];return}if(Object.keys(u).indexOf(m)!==-1){const d=u[m];typeof d=="object"&&!Array.isArray(d)&&(v(d,h),Object.keys(d).length===0&&delete u[m])}}function b(u,h,m){function d(t,r){let n=t;for(const i of r){if(typeof n!="object"||n===null)return;n=n[i]}return n}const C=h.split("."),k=d(u,C);return typeof k>"u"?m:k}e.getConfigurationValue=b;function f(u,h,m){Object.keys(h).forEach(d=>{d!=="__proto__"&&(d in u?E.isObject(u[d])&&E.isObject(h[d])?f(u[d],h[d],m):m&&(u[d]=h[d]):u[d]=h[d])})}e.merge=f;function p(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ve[104],Ee([1,0,3,16,5]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",E.isMacintosh),I.set("isLinux",E.isLinux),I.set("isWindows",E.isWindows),I.set("isWeb",E.isWeb),I.set("isMacNative",E.isMacintosh&&!E.isWeb),I.set("isEdge",E.isEdge),I.set("isFirefox",E.isFirefox),I.set("isChrome",E.isChrome),I.set("isSafari",E.isSafari);const D=Object.prototype.hasOwnProperty;var P;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return S.INSTANCE}static true(){return v.INSTANCE}static has(F){return b.create(F)}static equals(F,Z){return f.create(F,Z)}static notEquals(F,Z){return h.create(F,Z)}static regex(F,Z){return n.create(F,Z)}static in(F,Z){return p.create(F,Z)}static notIn(F,Z){return u.create(F,Z)}static not(F){return m.create(F)}static and(...F){return c.create(F,null,!0)}static or(...F){return l.create(F,null,!0)}static greater(F,Z){return C.create(F,Z)}static greaterEquals(F,Z){return k.create(F,Z)}static smaller(F,Z){return t.create(F,Z)}static smallerEquals(F,Z){return r.create(F,Z)}static deserialize(F,Z=!1){if(!!F)return this.c(F,Z)}static c(F,Z){const $=F.split("||");return l.create($.map(x=>this.d(x,Z)),null,!0)}static d(F,Z){const $=F.split("&&");return c.create($.map(x=>this.f(x,Z)),null,!0)}static f(F,Z){if(F=F.trim(),F.indexOf("!=")>=0){const $=F.split("!=");return h.create($[0].trim(),this.g($[1],Z))}if(F.indexOf("==")>=0){const $=F.split("==");return f.create($[0].trim(),this.g($[1],Z))}if(F.indexOf("=~")>=0){const $=F.split("=~");return n.create($[0].trim(),this.h($[1],Z))}if(F.indexOf(" not in ")>=0){const $=F.split(" not in ");return u.create($[0].trim(),this.g($[1],Z))}if(F.indexOf(" in ")>=0){const $=F.split(" in ");return p.create($[0].trim(),this.g($[1],Z))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const $=F.split(">=");return k.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const $=F.split(">");return C.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const $=F.split("<=");return r.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const $=F.split("<");return t.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(F)?m.create(F.substr(1).trim()):b.create(F)}static g(F,Z){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const $=/^'([^']*)'$/.exec(F);return $?$[1].trim():F}static h(F,Z){if((0,A.isFalsyOrWhitespace)(F)){if(Z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=F.indexOf("/"),x=F.lastIndexOf("/");if($===x||$<0){if(Z)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const le=F.slice($+1,x),be=F[x+1]==="i"?"i":"";try{return new RegExp(le,be)}catch(Y){if(Z)throw new Error(`bad regexp-value '${F}', parse error: ${Y}`);return console.warn(`bad regexp-value '${F}', parse error: ${Y}`),null}}}e.ContextKeyExpr=w;function y(ee,F){const Z=ee?ee.substituteConstants():void 0,$=F?F.substituteConstants():void 0;return!Z&&!$?!0:!Z||!$?!1:Z.equals($)}e.expressionsAreEqualWithConstantSubstitution=y;function T(ee,F){return ee.cmp(F)}class S{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}S.INSTANCE=new S,e.ContextKeyFalseExpr=S;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class b{static create(F,Z=null){const $=I.get(F);return typeof $=="boolean"?$?v.INSTANCE:S.INSTANCE:new b(F,Z)}constructor(F,Z){this.key=F,this.c=Z,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:g(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=I.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:S.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=m.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class f{static create(F,Z,$=null){if(typeof Z=="boolean")return Z?b.create(F,$):m.create(F,$);const x=I.get(F);return typeof x=="boolean"?Z===(x?"true":"false")?v.INSTANCE:S.INSTANCE:new f(F,Z,$)}constructor(F,Z,$){this.c=F,this.d=Z,this.f=$,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=I.get(this.c);if(typeof F=="boolean"){const Z=F?"true":"false";return this.d===Z?v.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class p{static create(F,Z){return new p(F,Z)}constructor(F,Z){this.d=F,this.f=Z,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:R(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const Z=F.getValue(this.f),$=F.getValue(this.d);return Array.isArray(Z)?Z.includes($):typeof $=="string"&&typeof Z=="object"&&Z!==null?D.call(Z,$):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=p;class u{static create(F,Z){return new u(F,Z)}constructor(F,Z){this.d=F,this.f=Z,this.type=11,this.c=p.create(F,Z)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=u;class h{static create(F,Z,$=null){if(typeof Z=="boolean")return Z?m.create(F,$):b.create(F,$);const x=I.get(F);return typeof x=="boolean"?Z===(x?"true":"false")?S.INSTANCE:v.INSTANCE:new h(F,Z,$)}constructor(F,Z,$){this.c=F,this.d=Z,this.f=$,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=I.get(this.c);if(typeof F=="boolean"){const Z=F?"true":"false";return this.d===Z?S.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class m{static create(F,Z=null){const $=I.get(F);return typeof $=="boolean"?$?S.INSTANCE:v.INSTANCE:new m(F,Z)}constructor(F,Z){this.c=F,this.d=Z,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:g(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=I.get(this.c);return typeof F=="boolean"?F?S.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=m;function d(ee,F){if(typeof ee=="string"){const Z=parseFloat(ee);isNaN(Z)||(ee=Z)}return typeof ee=="string"||typeof ee=="number"?F(ee):S.INSTANCE}class C{static create(F,Z,$=null){return d(Z,x=>new C(F,x,$))}constructor(F,Z,$){this.c=F,this.d=Z,this.f=$,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=C;class k{static create(F,Z,$=null){return d(Z,x=>new k(F,x,$))}constructor(F,Z,$){this.c=F,this.d=Z,this.f=$,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=k;class t{static create(F,Z,$=null){return d(Z,x=>new t(F,x,$))}constructor(F,Z,$){this.c=F,this.d=Z,this.f=$,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class r{static create(F,Z,$=null){return d(Z,x=>new r(F,x,$))}constructor(F,Z,$){this.c=F,this.d=Z,this.f=$,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class n{static create(F,Z){return new n(F,Z)}constructor(F,Z){this.d=F,this.f=Z,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const Z=this.f?this.f.source:"",$=F.f?F.f.source:"";return Z<$?-1:Z>$?1:0}equals(F){if(F.type===this.type){const Z=this.f?this.f.source:"",$=F.f?F.f.source:"";return this.d===F.d&&Z===$}return!1}substituteConstants(){return this}evaluate(F){const Z=F.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=i.create(this)),this.c}}e.ContextKeyRegexExpr=n;class i{static create(F){return new i(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new i(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=i;function o(ee){let F=null;for(let Z=0,$=ee.length;Z<$;Z++){const x=ee[Z].substituteConstants();if(ee[Z]!==x&&F===null){F=[];for(let le=0;le<Z;le++)F[le]=ee[le]}F!==null&&(F[Z]=x)}return F===null?ee:F}class c{static create(F,Z,$){return c.d(F,Z,$)}constructor(F,Z){this.expr=F,this.c=Z,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Z=0,$=this.expr.length;Z<$;Z++){const x=T(this.expr[Z],F.expr[Z]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Z=0,$=this.expr.length;Z<$;Z++)if(!this.expr[Z].equals(F.expr[Z]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:c.create(F,this.c,!1)}evaluate(F){for(let Z=0,$=this.expr.length;Z<$;Z++)if(!this.expr[Z].evaluate(F))return!1;return!0}static d(F,Z,$){const x=[];let le=!1;for(const be of F)if(!!be){if(be.type===1){le=!0;continue}if(be.type===0)return S.INSTANCE;if(be.type===6){x.push(...be.expr);continue}x.push(be)}if(x.length===0&&le)return v.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(T);for(let be=1;be<x.length;be++)x[be-1].equals(x[be])&&(x.splice(be,1),be--);if(x.length===1)return x[0];for(;x.length>1;){const be=x[x.length-1];if(be.type!==9)break;x.pop();const Y=x.pop(),H=x.length===0,U=l.create(be.expr.map(ne=>c.create([ne,Y],null,$)),null,H);U&&(x.push(U),x.sort(T))}if(x.length===1)return x[0];if($){for(let be=0;be<x.length;be++)for(let Y=be+1;Y<x.length;Y++)if(x[be].negate().equals(x[Y]))return S.INSTANCE;if(x.length===1)return x[0]}return new c(x,Z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Z of this.expr)F.push(...Z.keys());return F}map(F){return new c(this.expr.map(Z=>Z.map(F)),null)}negate(){if(!this.c){const F=[];for(const Z of this.expr)F.push(Z.negate());this.c=l.create(F,this,!0)}return this.c}}class l{static create(F,Z,$){return l.d(F,Z,$)}constructor(F,Z){this.expr=F,this.c=Z,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Z=0,$=this.expr.length;Z<$;Z++){const x=T(this.expr[Z],F.expr[Z]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Z=0,$=this.expr.length;Z<$;Z++)if(!this.expr[Z].equals(F.expr[Z]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:l.create(F,this.c,!1)}evaluate(F){for(let Z=0,$=this.expr.length;Z<$;Z++)if(this.expr[Z].evaluate(F))return!0;return!1}static d(F,Z,$){let x=[],le=!1;if(F){for(let be=0,Y=F.length;be<Y;be++){const H=F[be];if(!!H){if(H.type===0){le=!0;continue}if(H.type===1)return v.INSTANCE;if(H.type===9){x=x.concat(H.expr);continue}x.push(H)}}if(x.length===0&&le)return S.INSTANCE;x.sort(T)}if(x.length!==0){if(x.length===1)return x[0];for(let be=1;be<x.length;be++)x[be-1].equals(x[be])&&(x.splice(be,1),be--);if(x.length===1)return x[0];if($){for(let be=0;be<x.length;be++)for(let Y=be+1;Y<x.length;Y++)if(x[be].negate().equals(x[Y]))return v.INSTANCE;if(x.length===1)return x[0]}return new l(x,Z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Z of this.expr)F.push(...Z.keys());return F}map(F){return new l(this.expr.map(Z=>Z.map(F)),null)}negate(){if(!this.c){const F=[];for(const Z of this.expr)F.push(Z.negate());for(;F.length>1;){const Z=F.shift(),$=F.shift(),x=[];for(const le of ie(Z))for(const be of ie($))x.push(c.create([le,be],null,!1));F.unshift(l.create(x,null,!1))}this.c=l.create(F,this,!0)}return this.c}}class s extends b{static all(){return s.d.values()}constructor(F,Z,$){super(F,null),this.f=Z,typeof $=="object"?s.d.push({...$,key:F}):$!==!0&&s.d.push({key:F,description:$,type:Z!=null?typeof Z:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return f.create(this.key,F)}notEqualsTo(F){return h.create(this.key,F)}}s.d=[],e.RawContextKey=s,e.IContextKeyService=(0,a.createDecorator)("contextKeyService");function g(ee,F){return ee<F?-1:ee>F?1:0}function R(ee,F,Z,$){return ee<Z?-1:ee>Z?1:F<$?-1:F>$?1:0}function O(ee,F){if(ee.type===0||F.type===1)return!0;if(ee.type===9)return F.type===9?z(ee.expr,F.expr):!1;if(F.type===9){for(const Z of F.expr)if(O(ee,Z))return!0;return!1}if(ee.type===6){if(F.type===6)return z(F.expr,ee.expr);for(const Z of ee.expr)if(O(Z,F))return!0;return!1}return ee.equals(F)}e.implies=O;function z(ee,F){let Z=0,$=0;for(;Z<ee.length&&$<F.length;){const x=ee[Z].cmp(F[$]);if(x<0)return!1;x===0&&Z++,$++}return Z===ee.length}function ie(ee){return ee.type===9?ee.expr:[ee]}}),define(ve[74],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class A{constructor(){this.a={}}async getPassword(I,D){return this.a[I]?.[D]??null}async setPassword(I,D,P){this.a[I]=this.a[I]??{},this.a[I][D]=P}async deletePassword(I,D){return this.a[I]?.[D]?(delete this.a[I][D],Object.keys(this.a[I]).length===0&&delete this.a[I],!0):!1}async findPassword(I){return JSON.stringify(this.a[I])??null}async findCredentials(I){const D=[];for(const P of Object.keys(this.a[I]||{}))D.push({account:P,password:this.a[I][P]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=A}),define(ve[207],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function A(I){return!!I.hostName&&!!I.errorMessage}e.isRemoteDiagnosticError=A;class a{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=a}),define(ve[75],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,E.createDecorator)("downloadService")}),define(ve[208],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ve[25],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[32],Ee([1,0,172,5]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function a(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=a;function I(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function D(h,m){switch(h){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(h,m){return m==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(h,m,d){return P(m,d)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===d?!0:y(d).includes(h)}e.isTargetPlatformCompatible=w;function y(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T;var S;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var b;(function(h){h.Install="install",h.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var p;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ve[209],Ee([1,0,6,2,46,23,4,72,32]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(u,h){return D.URI.revive(h?h.transformIncoming(u):u)}function T(u,h){return h?h.transformOutgoingURI(u):u}function S(u,h){h=h||P.DefaultURITransformer;const m=u.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...u,manifest:void 0},h),manifest:m}}function v(u,h){return h?(0,I.cloneAndChange)(u,m=>m instanceof D.URI?h.transformOutgoingURI(m):void 0):u}class b{constructor(h,m){this.a=h,this.b=m,this.onInstallExtension=E.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=E.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=E.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=E.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,m){const d=this.b(h);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return E.Event.map(this.onDidInstallExtensions,C=>C.map(k=>({...k,local:k.local?v(k.local,d):k.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension;case"onDidUpdateExtensionMetadata":return this.onDidUpdateExtensionMetadata}throw new Error("Invalid listen")}call(h,m,d){const C=this.b(h);switch(m){case"zip":return this.a.zip(S(d[0],C)).then(k=>T(k,C));case"unzip":return this.a.unzip(y(d[0],C));case"install":return this.a.install(y(d[0],C),(0,a.revive)(d[1]));case"installFromLocation":return this.a.installFromLocation(y(d[0],C),D.URI.revive(d[1]));case"getManifest":return this.a.getManifest(y(d[0],C));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],(0,a.revive)(d[1]));case"uninstall":return this.a.uninstall(S(d[0],C),(0,a.revive)(d[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(d[0],C));case"getInstalled":return this.a.getInstalled(d[0],D.URI.revive(d[1])).then(k=>k.map(t=>v(t,C)));case"getMetadata":return this.a.getMetadata(S(d[0],C),D.URI.revive(d[1]));case"updateMetadata":return this.a.updateMetadata(S(d[0],C),d[1],D.URI.revive(d[2])).then(k=>v(k,C));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=b;class f extends A.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new E.Emitter),this.f=this.B(new E.Emitter),this.g=this.B(new E.Emitter),this.h=this.B(new E.Emitter),this.j=this.B(new E.Emitter),this.B(this.k.listen("onInstallExtension")(m=>this.c.fire({identifier:m.identifier,source:this.l(m.source)?D.URI.revive(m.source):m.source,profileLocation:D.URI.revive(m.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(m=>this.f.fire(m.map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.l(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(m=>this.g.fire({identifier:m.identifier,profileLocation:D.URI.revive(m.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(m=>this.h.fire({...m,profileLocation:D.URI.revive(m.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(m=>this.j.fire(S(m,null))))}l(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.m||(this.m=this.k.call("getTargetPlatform")),this.m}async canInstall(h){const m=await this.getTargetPlatform();return h.allTargetPlatforms.some(d=>(0,w.isTargetPlatformCompatible)(d,h.allTargetPlatforms,m))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(m=>D.URI.revive(m)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,m){return Promise.resolve(this.k.call("install",[h,m])).then(d=>S(d,null))}installFromLocation(h,m){return Promise.resolve(this.k.call("installFromLocation",[h,m])).then(d=>S(d,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,m){return Promise.resolve(this.k.call("installFromGallery",[h,m])).then(d=>S(d,null))}uninstall(h,m){return Promise.resolve(this.k.call("uninstall",[h,m]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(m=>S(m,null))}getInstalled(h=null,m){return Promise.resolve(this.k.call("getInstalled",[h,m])).then(d=>d.map(C=>S(C,null)))}getMetadata(h,m){return Promise.resolve(this.k.call("getMetadata",[h,m]))}updateMetadata(h,m,d){return Promise.resolve(this.k.call("updateMetadata",[h,m,d])).then(C=>S(C,null))}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,m){const d=await this.k.call("download",[h,m]);return D.URI.revive(d)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class p{constructor(h){this.a=h}listen(h,m){throw new Error("Invalid listen")}call(h,m,d){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(ve[76],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,E.createDecorator)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((I,D)=>ae(["node-vsce-sign"],async P=>I(P),D))),this.a}async verify(I,D){let P;try{P=await this.b()}catch{return!1}return P.verify(I,D)}}e.ExtensionSignatureVerificationService=A}),define(ve[17],Ee([1,0,59,7,16,8,4,180,5,3,13]),function(ae,e,E,A,a,I,D,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function S(U){return U.create===!0}e.isFileOpenForWriteOptions=S;var v;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function h(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=h;function m(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;function C(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var k;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{constructor(ne,se){super(ne),this.code=se}}e.FileSystemProviderError=t;function r(U,ne){const se=new t(U.toString(),ne);return i(se,ne),se}e.createFileSystemProviderError=r;function n(U){return U||r((0,P.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=n;function i(U,ne){return U.name=ne?`${ne} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function o(U){if(!U)return k.Unknown;if(U instanceof t)return U.code;const ne=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!ne)return k.Unknown;switch(ne[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=o;function c(U){if(U instanceof z)return U.fileOperationResult;switch(o(U)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var l;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class s{constructor(ne,se,de){this.resource=ne,this.operation=se,this.target=de}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=s;var g;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class R{constructor(ne,se){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const re of ne){const j=de.get(re.type);switch(j?j.push([re.resource,re]):de.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,j]of de)switch(re){case 1:this.a=E.TernarySearchTree.forUris(()=>se),this.a.fill(j);break;case 0:this.b=E.TernarySearchTree.forUris(()=>se),this.b.fill(j);break;case 2:this.c=E.TernarySearchTree.forUris(()=>se),this.c.fill(j);break}}contains(ne,...se){return this.d(ne,{includeChildren:!1},...se)}affects(ne,...se){return this.d(ne,{includeChildren:!0},...se)}d(ne,se,...de){if(!ne)return!1;const re=de.length>0;return!!((!re||de.includes(1))&&(this.a?.get(ne)||se.includeChildren&&this.a?.findSuperstr(ne))||(!re||de.includes(0))&&(this.b?.get(ne)||se.includeChildren&&this.b?.findSuperstr(ne))||(!re||de.includes(2))&&(this.c?.findSubstr(ne)||se.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=R;function O(U,ne,se){return!U||!ne||U===ne||ne.length>U.length?!1:(ne.charAt(ne.length-1)!==A.sep&&(ne+=A.sep),se?(0,a.startsWithIgnoreCase)(U,ne):U.indexOf(ne)===0)}e.isParent=O;class z extends Error{constructor(ne,se,de){super(ne),this.fileOperationResult=se,this.options=de}}e.FileOperationError=z;class ie extends z{constructor(ne,se,de,re){super(ne,se,re),this.fileOperationResult=se,this.size=de}}e.TooLargeFileOperationError=ie;class ee extends z{constructor(ne,se,de){super(ne,2,de),this.stat=se}}e.NotModifiedSinceFileOperationError=ee;var F;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Z;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=$;async function x(U,ne){if(!ne.hasProvider(D.URI.from({scheme:U.scheme})))return new Promise(se=>{const de=ne.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===U.scheme&&re.added&&(de.dispose(),se())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(ne){return(0,I.isNumber)(ne)||(ne=0),ne<le.KB?(0,P.localize)(1,null,ne.toFixed(0)):ne<le.MB?(0,P.localize)(2,null,(ne/le.KB).toFixed(2)):ne<le.GB?(0,P.localize)(3,null,(ne/le.MB).toFixed(2)):ne<le.TB?(0,P.localize)(4,null,(ne/le.GB).toFixed(2)):(0,P.localize)(5,null,(ne/le.TB).toFixed(2))}}le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB,e.ByteSize=le;var be;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(be=e.Arch||(e.Arch={}));function Y(U){return{maxFileSize:U===0?300*le.MB:16*le.GB,maxHeapSize:U===0?700*le.MB:2*700*le.MB}}e.getPlatformFileLimits=Y;function H(U){const ne=typeof U=="string"||U?.scheme===T.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===T.Schemas.file?1024*le.MB:ne?10*le.MB:y.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=H}),define(ve[210],Ee([1,0,15,38,9,6,2,44,4,21,17]),function(ae,e,E,A,a,I,D,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends D.Disposable{constructor(b,f){super(),this.a=b,this.b=f,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new I.Emitter),this.onDidWatchError=this.g.event,this.h=(0,y.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(b){return this.a.call("stat",[b])}readdir(b){return this.a.call("readdir",[b])}async readFile(b,f){const{buffer:p}=await this.a.call("readFile",[b,f]);return p}readFileStream(b,f,p){const u=(0,P.newWriteableStream)(m=>E.VSBuffer.concat(m.map(d=>E.VSBuffer.wrap(d))).buffer),h=this.a.listen("readFileStream",[b,f])(m=>{if(m instanceof E.VSBuffer)u.write(m.buffer);else{if(m==="end")u.end();else{let d;if(m instanceof Error)d=m;else{const C=m;d=(0,T.createFileSystemProviderError)(C.message??(0,A.toErrorMessage)(C),C.code??T.FileSystemProviderErrorCode.Unknown)}u.error(d),u.end()}h.dispose()}});return p.onCancellationRequested(()=>{u.error((0,a.canceled)()),u.end(),h.dispose()}),u}writeFile(b,f,p){return this.a.call("writeFile",[b,E.VSBuffer.wrap(f),p])}open(b,f){return this.a.call("open",[b,f])}close(b){return this.a.call("close",[b])}async read(b,f,p,u,h){const[m,d]=await this.a.call("read",[b,f,h]);return p.set(m.buffer.slice(0,d),u),d}write(b,f,p,u,h){return this.a.call("write",[b,f,E.VSBuffer.wrap(p),u,h])}mkdir(b){return this.a.call("mkdir",[b])}delete(b,f){return this.a.call("delete",[b,f])}rename(b,f,p){return this.a.call("rename",[b,f,p])}copy(b,f,p){return this.a.call("copy",[b,f,p])}cloneFile(b,f){return this.a.call("cloneFile",[b,f])}i(){this.B(this.a.listen("fileChange",[this.h])(b=>{if(Array.isArray(b)){const f=b;this.f.fire(f.map(p=>({resource:w.URI.revive(p.resource),type:p.type})))}else{const f=b;this.g.fire(f)}}))}watch(b,f){const p=(0,y.generateUuid)();return this.a.call("watch",[this.h,p,b,f]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=S}),define(ve[105],Ee([1,0,15,9,181,17]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(T,S,v,b,f,p){let u;try{await P(T,S,v,b,f,p)}catch(h){u=h}finally{u&&f.errorTransformer&&(u=f.errorTransformer(u)),typeof u<"u"&&v.error(u),v.end()}}e.readFileIntoStream=D;async function P(T,S,v,b,f,p){w(p);const u=await T.open(S,{create:!1});try{w(p);let h=0,m=0,d=f&&typeof f.length=="number"?f.length:void 0,C=E.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),k=f&&typeof f.position=="number"?f.position:0,t=0;do m=await T.read(u,k,C.buffer,t,C.byteLength-t),k+=m,t+=m,h+=m,typeof d=="number"&&(d-=m),t===C.byteLength&&(await v.write(b(C)),C=E.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),t=0);while(m>0&&(typeof d!="number"||d>0)&&w(p)&&y(h,f));if(t>0){let r=t;typeof d=="number"&&(r=Math.min(t,d)),v.write(b(C.slice(0,r)))}}catch(h){throw(0,I.ensureFileSystemProviderError)(h)}finally{await T.close(u)}}function w(T){if(T.isCancellationRequested)throw(0,A.canceled)();return!0}function y(T,S){if(S?.limits){if(typeof S.limits.memory=="number"&&T>S.limits.memory)throw(0,I.createFileSystemProviderError)((0,a.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&T>S.limits.size)throw(0,I.createFileSystemProviderError)((0,a.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[63],Ee([1,0,71,2,7,3,4,17]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(h){return h.recursive===!0}e.isRecursiveWatchRequest=w;class y extends A.Disposable{constructor(m,d,C,k){super(),this.h=m,this.i=d,this.j=C,this.k=k,this.c=this.B(new A.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new A.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(d=>this.h(d))),m.add(this.b.onDidLogMessage(d=>this.i(d))),m.add(this.b.onDidError(d=>this.n(d)))}n(m){this.k.restartOnError?this.g<y.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}y.a=5,e.AbstractWatcherClient=y;class T extends y{constructor(m,d,C){super(m,d,C,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class S extends y{constructor(m,d,C){super(m,d,C,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function v(h){return h.map(m=>({type:m.type,resource:D.URI.file(m.path)}))}e.toFileChanges=v;function b(h){const m=new u;for(const d of h)m.processEvent(d);return m.coalesce()}e.coalesceEvents=b;function f(h,m){return typeof m=="string"&&!m.startsWith(E.GLOBSTAR)&&!(0,a.isAbsolute)(m)?{base:h,pattern:m}:m}e.normalizeWatcherPattern=f;function p(h,m){const d=[];for(const C of m)d.push((0,E.parse)(f(h,C)));return d}e.parseWatcherPatterns=p;class u{constructor(){this.a=new Set,this.b=new Map}c(m){return I.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const d=this.b.get(this.c(m));let C=!1;if(d){const k=d.type,t=m.type;d.path!==m.path&&(m.type===2||m.type===1)?C=!0:k===1&&t===2?(this.b.delete(this.c(m)),this.a.delete(d)):k===2&&t===1?d.type=0:k===1&&t===0||(d.type=t)}else C=!0;C&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],d=[];return Array.from(this.a).filter(C=>C.type!==2?(m.push(C),!1):!0).sort((C,k)=>C.path.length-k.path.length).filter(C=>d.some(k=>(0,P.isParent)(C.path,k,!I.isLinux))?!1:(d.push(C.path),!0)).concat(m)}}}),define(ve[211],Ee([1,0,31,14,19,37,2,89,7,3,154,22,63]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class b extends D.Disposable{constructor(u,h,m,d){super(),this.j=u,this.k=h,this.l=m,this.m=d,this.c=this.B(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},C=>this.k(C))),this.f=this.B(new A.RunOnceWorker(C=>this.u(C),b.b)),this.g=(0,v.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new a.CancellationTokenSource,this.ready=this.n()}async n(){try{const u=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await S.Promises.stat(u);this.B(await this.s(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.w(u):this.z(u)}}async r(u){let h=u.path;try{h=await S.Promises.realpath(u.path),u.path===h&&(h=await(0,T.realcase)(u.path)??u.path),u.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async s(u,h){if(y.isMacintosh&&(0,I.isEqualOrParent)(u,"/Volumes/",!0))return this.w(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const m=new a.CancellationTokenSource(this.i.token),d=new D.DisposableStore;try{const C=(0,w.basename)(u),k=(0,E.watch)(u);d.add((0,D.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.z(`Started watching: '${u}'`);const t=new Set;if(h)try{for(const n of await S.Promises.readdir(u))t.add(n)}catch(n){this.w(n)}const r=new Map;d.add((0,D.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),k.on("error",(n,i)=>{this.w(`Failed to watch ${u} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),k.on("change",(n,i)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${i}`);let o="";if(i&&(o=i.toString(),y.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(h)if(n==="rename"){r.get(o)?.dispose();const c=setTimeout(async()=>{if(r.delete(o),o===C&&!await S.Promises.exists(u)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.v((0,w.join)(u,o));if(m.token.isCancellationRequested)return;let s;l?t.has(o)?s=0:(s=1,t.add(o)):(t.delete(o),s=2),this.t({path:(0,w.join)(this.j.path,o),type:s})},b.a);r.set(o,(0,D.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(o)?c=0:(c=1,t.add(o)),this.t({path:(0,w.join)(this.j.path,o),type:c})}else if(n==="rename"||o!==C){const c=setTimeout(async()=>{const l=await S.Promises.exists(u);m.token.isCancellationRequested||(l?(this.t({path:this.j.path,type:0},!0),d.add(await this.s(u,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},b.a);d.clear(),d.add((0,D.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(C){await S.Promises.exists(u)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${u} for changes using fs.watch() (${C.toString()})`)}return(0,D.toDisposable)(()=>{m.dispose(!0),d.dispose()})}t(u,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),!h&&this.g.some(m=>m(u.path))?this.m&&this.z(` >> ignored (excluded) ${u.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(m=>m(u.path))?this.m&&this.z(` >> ignored (not included) ${u.path}`):this.f.work(u))}u(u){const h=(0,v.coalesceEvents)(u);if(h.length>0){if(this.m)for(const d of h)this.z(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(u){if(y.isLinux)return S.Promises.exists(u);try{const h=(0,w.basename)(u);return(await S.Promises.readdir((0,w.dirname)(u))).some(d=>d===h)}catch(h){return this.z(h),!1}}setVerboseLogging(u){this.m=u}w(u){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}y(u){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}z(u){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}b.a=100,b.b=75,e.NodeJSFileWatcherLibrary=b;async function f(p,u,h,m,d=512){const C=await S.Promises.open(p,"r"),k=Buffer.allocUnsafe(d),t=new a.CancellationTokenSource(m);let r,n=!1;const i={path:p,excludes:[],recursive:!1},o=new b(i,c=>{(async()=>{for(const{type:l}of c)if(l===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:s}=await S.Promises.read(C,k,0,d,null);if(!s||t.token.isCancellationRequested)break;u(k.slice(0,s))}}catch(s){r=new Error(s),t.dispose(!0)}finally{n=!1}}})()});return await o.ready,h(),new Promise((c,l)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await S.Promises.close(C)}catch(s){r=new Error(s)}r?l(r):c()})})}e.watchFileContents=f}),define(ve[212],Ee([1,0,6,71,2,3,211]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends a.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(y){const T=this.i(y),S=T.filter(b=>{const f=this.c.get(b.path);return f?!(0,A.patternsEquals)(f.request.excludes,b.excludes)||!(0,A.patternsEquals)(f.request.includes,b.includes):!0}),v=Array.from(this.c.values()).filter(({request:b})=>!T.find(f=>f.path===b.path&&(0,A.patternsEquals)(f.excludes,b.excludes)&&(0,A.patternsEquals)(f.includes,b.includes))).map(({request:b})=>b.path);S.length&&this.j(`Request to start watching: ${S.map(b=>`${b.path} (excludes: ${b.excludes.length>0?b.excludes:"<none>"}, includes: ${b.includes&&b.includes.length>0?JSON.stringify(b.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const b of v)this.h(b);for(const b of S)this.g(b)}g(y){const T=new D.NodeJSFileWatcherLibrary(y,v=>this.a.fire(v),v=>this.b.fire(v),this.f),S={request:y,instance:T};this.c.set(y.path,S)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const T=this.c.get(y);T&&(this.c.delete(y),T.instance.dispose())}i(y){const T=new Map;for(const S of y){const v=I.isLinux?S.path:S.path.toLowerCase();T.set(v,S)}return Array.from(T.values())}async setVerboseLogging(y){this.f=y;for(const[,T]of this.c)T.instance.setVerboseLogging(y)}j(y){this.f&&this.b.fire({type:"trace",message:this.k(y)})}k(y,T){return T?`[File Watcher (node.js)] ${y} (path: ${T.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=P}),define(ve[213],Ee([1,0,63,212]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class a extends E.AbstractNonRecursiveWatcherClient{constructor(D,P,w){super(D,P,w),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=a}),define(ve[214],Ee([1,0,13,42,101,63]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends I.AbstractUniversalWatcherClient{constructor(w,y,T){super(w,y,T),this.m()}l(w){const y=w.add(new a.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(y.onDidProcessExit(({code:T,signal:S})=>this.n(`terminated by itself with code ${T}, signal: ${S}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ve[77],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...a){this.a=new Map;for(const[I,D]of a)this.set(I,D)}set(a,I){const D=this.a.get(a);return this.a.set(a,I),D}has(a){return this.a.has(a)}get(a){return this.a.get(a)}}e.ServiceCollection=E}),define(ve[106],Ee([1,0,14,9,2,62,206,5,77,88]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class S extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new w.ServiceCollection,h=!1,m,d=T){this.f=u,this.g=h,this.h=m,this.i=d,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=d?m?._globalGraph??new D.Graph(C=>C):void 0}createChild(u){return new v(u,this.g,this,this.i)}invokeFunction(u,...h){const m=f.traceInvocation(this.i,u);let d=!1;try{return u({get:k=>{if(d)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(k,m);if(!t)throw new Error(`[invokeFunction] unknown service '${k}'`);return t}},...h)}finally{d=!0,m.stop()}}createInstance(u,...h){let m,d;return u instanceof I.SyncDescriptor?(m=f.traceCreation(this.i,u.ctor),d=this.j(u.ctor,u.staticArguments.concat(h),m)):(m=f.traceCreation(this.i,u),d=this.j(u,h,m)),m.stop(),d}j(u,h=[],m){const d=P._util.getServiceDependencies(u).sort((t,r)=>t.index-r.index),C=[];for(const t of d){const r=this.m(t.id,m);r||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),C.push(r)}const k=d.length>0?d[0].index:h.length;if(h.length!==k){console.trace(`[createInstance] First service dependency of ${u.name} at position ${k+1} conflicts with ${h.length} static arguments`);const t=k-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,k)}return Reflect.construct(u,h.concat(C))}k(u,h){if(this.f.get(u)instanceof I.SyncDescriptor)this.f.set(u,h);else if(this.h)this.h.k(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const h=this.f.get(u);return!h&&this.h?this.h.l(u):h}m(u,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const m=this.l(u);return m instanceof I.SyncDescriptor?this.q(u,m,h.branch(u,!0)):(h.branch(u,!1),m)}q(u,h,m){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,h,m)}finally{this.o.delete(u)}}r(u,h,m){const d=new D.Graph(t=>t.id.toString());let C=0;const k=[{id:u,desc:h,_trace:m}];for(;k.length;){const t=k.pop();if(d.lookupOrInsertNode(t),C++>1e3)throw new S(d);for(const r of P._util.getServiceDependencies(t.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof I.SyncDescriptor){const i={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};d.insertEdge(t,i),k.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:r}of t){if(this.l(r.id)instanceof I.SyncDescriptor){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}d.removeNode(r)}}return this.l(u)}s(u,h,m=[],d,C){if(this.f.get(u)instanceof I.SyncDescriptor)return this.t(u,h,m,d,C);if(this.h)return this.h.s(u,h,m,d,C);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(u,h,m=[],d,C){if(d){const k=new v(void 0,this.g,this,this.i);k.c=String(u);const t=new Map,r=new E.IdleValue(()=>{const n=k.j(h,m,C);for(const[i,o]of t){const c=n[i];if(typeof c=="function")for(const l of o)c.apply(n,l)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=t.get(i);return l||(l=new y.LinkedList,t.set(i,l)),(g,R,O)=>{const z=l.push([g,R,O]);return(0,a.toDisposable)(z)}}if(i in n)return n[i];const o=r.value;let c=o[i];return typeof c!="function"||(c=c.bind(o),n[i]=c),c},set(n,i,o){return r.value[i]=o,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,m,C)}u(u,h){if(h&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=v;var b;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(b||(b={}));class f{static traceInvocation(u,h){return u?new f(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(u,h){return u?new f(1,h.name):f.c}constructor(u,h){this.type=u,this.name=h,this.g=Date.now(),this.h=[]}branch(u,h){const m=new f(3,u.toString());return this.h.push([u,h,m]),m}stop(){const u=Date.now()-this.g;f.f+=u;let h=!1;function m(C,k){const t=[],r=new Array(C+1).join("	");for(const[n,i,o]of k.h)if(i&&o){h=!0,t.push(`${r}CREATES -> ${n}`);const c=m(C+1,o);c&&t.push(c)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(u>2||h)&&f.all.add(d.join(`
`))}}f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0,e.Trace=f}),define(ve[215],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,E.createDecorator)("labelService");var A;(function(a){a[a.SHORT=0]="SHORT",a[a.MEDIUM=1]="MEDIUM",a[a.LONG=2]="LONG"})(A=e.Verbosity||(e.Verbosity={}))});var Re=this&&this.__param||function(ae,e){return function(E,A){e(E,A,ae)}};define(ve[78],Ee([1,0,19,2,3,183,32,5]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function w(T){return T.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=w,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let y=class extends A.Disposable{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new E.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const f=v.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(u=>u.startsWith("lp-"))).map(p=>{const u=p.properties.localizedLanguages?.[0],h=w(p);return{...this.f(h,u,p),extensionId:p.identifier.id,galleryExtension:p}});return f.push(this.f("en","English")),f}f(S,v,b){const f=v??S;let p;if(f!==S&&(p=`(${S})`),S.toLowerCase()===a.language.toLowerCase()&&(p??="",p+=(0,I.localize)(0,null)),b?.installCount){p??="";const u=b.installCount;let h;u>1e6?h=`${Math.floor(u/1e5)/10}M`:u>1e3?h=`${Math.floor(u/1e3)}K`:h=String(u),p+=` $(cloud-download) ${h}`}return{id:S,label:f,description:p}}};y=Le([Re(0,D.IExtensionGalleryService)],y),e.LanguagePackBaseService=y}),define(ve[12],Ee([1,0,38,6,2,27,3,8,4,5]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function T(){return new Date().toISOString()}function S(l){return(0,P.isNumber)(l)}e.isLogLevel=S;var v;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function b(l,s,g){switch(s){case v.Trace:l.trace(g);break;case v.Debug:l.debug(g);break;case v.Info:l.info(g);break;case v.Warning:l.warn(g);break;case v.Error:l.error(g);break;case v.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=b;function f(l){let s="";for(let g=0;g<l.length;g++){let R=l[g];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}s+=(g>0?" ":"")+R}return s}e.format=f;class p extends a.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==v.Off&&this.b<=s}}e.AbstractLogger=p;class u extends p{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...g){this.f(v.Trace)&&this.g(v.Trace,f([s,...g]))}debug(s,...g){this.f(v.Debug)&&this.g(v.Debug,f([s,...g]))}info(s,...g){this.f(v.Info)&&this.g(v.Info,f([s,...g]))}warn(s,...g){this.f(v.Warning)&&this.g(v.Warning,f([s,...g]))}error(s,...g){if(this.f(v.Error))if(s instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=s.stack,this.g(v.Error,f(R))}else this.g(v.Error,f([s,...g]))}flush(){}}e.AbstractMessageLogger=u;class h extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!D.isWindows}trace(s,...g){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,s,...g):console.log(`[main ${T()}]`,s,...g))}debug(s,...g){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,s,...g):console.log(`[main ${T()}]`,s,...g))}info(s,...g){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,s,...g):console.log(`[main ${T()}]`,s,...g))}warn(s,...g){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${T()}]\x1B[0m`,s,...g):console.warn(`[main ${T()}]`,s,...g))}error(s,...g){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${T()}]\x1B[0m`,s,...g):console.error(`[main ${T()}]`,s,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class m extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...g){this.f(v.Trace)&&console.log("%cTRACE","color: #888",s,...g)}debug(s,...g){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...g)}info(s,...g){this.f(v.Info)&&console.log("%c INFO","color: #33f",s,...g)}warn(s,...g){this.f(v.Warning)&&console.log("%c WARN","color: #993",s,...g)}error(s,...g){this.f(v.Error)&&console.log("%c  ERR","color: #f33",s,...g)}dispose(){}flush(){}}e.ConsoleLogger=m;class d extends p{constructor(s,g=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(g)}trace(s,...g){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(s),...g])}debug(s,...g){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(s),...g])}info(s,...g){this.f(v.Info)&&this.g.log(v.Info,[this.h(s),...g])}warn(s,...g){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(s),...g])}error(s,...g){this.f(v.Error)&&this.g.log(v.Error,[this.h(s),...g])}h(s){return typeof s=="string"?s:(0,E.toErrorMessage)(s,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=d;class C extends p{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const g of this.g)g.setLevel(s);super.setLevel(s)}trace(s,...g){for(const R of this.g)R.trace(s,...g)}debug(s,...g){for(const R of this.g)R.debug(s,...g)}info(s,...g){for(const R of this.g)R.info(s,...g)}warn(s,...g){for(const R of this.g)R.warn(s,...g)}error(s,...g){for(const R of this.g)R.error(s,...g)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogger=C;class k extends a.Disposable{constructor(s,g){if(super(),this.j=s,this.b=new I.ResourceMap,this.c=new I.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,g)for(const R of g)this.c.set(R.resource,R)}getLogger(s){return this.b.get(s)}createLogger(s,g){let R=this.b.get(s);const O=g?.logLevel==="always"?v.Trace:g?.logLevel;return R||(R=this.k(s,O??this.getLogLevel(s)??this.j,g),this.b.set(s,R)),this.registerLogger({resource:s,id:g?.id??s.toString(),logLevel:O,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId}),R}setLogLevel(s,g){if(w.URI.isUri(s)){const R=s,O=g,z=this.c.get(R);z&&O!==z.logLevel&&(z.logLevel=O===this.j?void 0:O,this.b.get(R)?.setLevel(O),this.c.set(z.resource,z),this.g.fire([R,O]))}else{this.j=s;for(const[R,O]of this.b.entries())this.c.get(R)?.logLevel===void 0&&O.setLevel(this.j);this.g.fire(this.j)}}setVisibility(s,g){const R=this.c.get(s);R&&g!==!R.hidden&&(R.hidden=!g,this.c.set(R.resource,R),this.h.fire([s,g]))}getLogLevel(s){let g;return s&&(g=this.c.get(s)?.logLevel),g??this.j}registerLogger(s){const g=this.c.get(s.resource);g?g.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this.c.set(s.resource,s),this.f.fire({added:[s],removed:[]}))}deregisterLogger(s){const g=this.c.get(s);if(g){this.c.delete(s);const R=this.b.get(s);R&&(this.b.delete(s),R.dispose()),this.f.fire({added:[],removed:[g]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(s){return this.c.get(s)}dispose(){this.b.forEach(s=>s.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=k;class t{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(s){}getLevel(){return v.Info}trace(s,...g){}debug(s,...g){}info(s,...g){}warn(s,...g){}error(s,...g){}critical(s,...g){}dispose(){}flush(){}}e.NullLogger=t;class r extends t{}e.NullLogService=r;class n extends k{constructor(){super(v.Info)}k(s,g,R){return new t}}e.NullLoggerService=n;function i(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const s=c(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function o(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=o;function c(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=c}),define(ve[216],Ee([1,0,74,6,2,12,3,14]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class qt extends a.Disposable{constructor(T){super(),this.g=T,this.c=this.B(new A.Emitter),this.onDidChangePassword=this.c.event}async getPassword(T,S){this.g.trace("Getting password from keytar:",T,S);let v;try{v=await this.h()}catch{return null}const b=await(0,P.retry)(()=>v.getPassword(T,S),50,3);if(!b)return this.g.trace("Did not get a password from keytar for account:",S),b;let f,p;try{const u=JSON.parse(b);f=u.content,p=u.hasNextChunk}catch{}if(!f||!p)return this.g.trace("Got password from keytar for account:",S),b;try{let u=1;for(;p;){const h=await(0,P.retry)(()=>v.getPassword(T,`${S}-${u}`),50,3),m=JSON.parse(h);f+=m.content,p=m.hasNextChunk,u++}return this.g.trace(`Got ${u}-chunked password from keytar for account:`,S),f}catch(u){return this.g.error(u),b}}async setPassword(T,S,v){this.g.trace("Setting password using keytar:",T,S);let b;try{b=await this.h()}catch(f){throw this.i?.(f),f}if(D.isWindows&&v.length>qt.a){let f=0,p=0,u=!0;for(;u;){const h=v.substring(f,f+qt.b);f+=qt.b,u=v.length-f>0;const m={content:h,hasNextChunk:u};await(0,P.retry)(()=>b.setPassword(T,p?`${S}-${p}`:S,JSON.stringify(m)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,S)}else await(0,P.retry)(()=>b.setPassword(T,S,v),50,3),this.g.trace("Got password from keytar for account:",S);this.c.fire({service:T,account:S})}async deletePassword(T,S){this.g.trace("Deleting password using keytar:",T,S);let v;try{v=await this.h()}catch(h){throw this.i?.(h),h}const b=await v.getPassword(T,S);if(!b)return this.g.trace("Did not get a password to delete from keytar for account:",S),!1;let f,p;try{const h=JSON.parse(b);f=h.content,p=h.hasNextChunk}catch{}let u=0;if(f&&p)try{for(u++;p;){const h=`${S}-${u}`,m=await v.getPassword(T,h);await v.deletePassword(T,h),p=JSON.parse(m).hasNextChunk,u++}}catch(h){this.g.error(h)}return await v.deletePassword(T,S)?(this.c.fire({service:T,account:S}),this.g.trace(`Deleted${u?` ${u}-chunked`:""} password from keytar for account:`,S),!0):(this.g.trace(`Keytar failed to delete${u?` ${u}-chunked`:""} password for account:`,S),!1)}async findPassword(T){let S;try{S=await this.h()}catch{return null}return await S.findPassword(T)}async findCredentials(T){let S;try{S=await this.h()}catch{return[]}return await S.findCredentials(T)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=Le([Re(0,I.ILogService)],w),e.BaseCredentialsMainService=w}),define(ve[217],Ee([1,0,12]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let A=class{constructor(I,D){this.a=I,this.b=D}c(){return new Promise((I,D)=>ae(["vscode-encrypt"],I,D))}async encrypt(I){let D;try{D=await this.c()}catch{return I}try{return D.encrypt(this.a,I)}catch(P){return this.b.error(P),I}}async decrypt(I){let D;try{D=await this.c()}catch{return I}try{return D.decrypt(this.a,I)}catch(P){return this.b.error(P),I}}};A=Le([Re(1,E.ILogService)],A),e.EncryptionMainService=A}),define(ve[218],Ee([1,0,18,14,9,6,2,7,63,12]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends D.Disposable{constructor(v,b){super(),this.a=v,this.b=b,this.c=this.B(new I.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new I.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(v,b){return b.recursive||this.b?.watcher?.forceUniversal?this.l(v,b):this.u(v,b)}l(v,b){const f={path:this.C(v),excludes:b.excludes,includes:b.includes,recursive:b.recursive},p=(0,E.insert)(this.j,f);return this.m(),(0,D.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,a.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(b=>this.c.fire((0,w.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const b of this.j)(0,w.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const b of this.j)(0,w.isRecursiveWatchRequest)(b)&&v.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,b){const f={path:this.C(v),excludes:b.excludes,includes:b.includes,recursive:!1},p=(0,E.insert)(this.s,f);return this.v(),(0,D.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,a.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,w.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ve[107],Ee([1,0,18,14,15,19,6,91,55,2,59,13,47,20,44,179,17,105,12,9]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends y.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(t,r){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const n=new y.DisposableStore;return this.h.set(t,r),this.c.fire({added:!0,scheme:t,provider:r}),n.add(r.onDidChangeFile(i=>this.R.fire(new u.FileChangesEvent(i,!this.O(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:t}))),(0,y.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:r}),this.h.delete(t),(0,y.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const r=[];this.f.fire({scheme:t,join(n){r.push(n)}}),!this.h.has(t)&&await A.Promises.settled(r)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,r){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([t,r])=>({scheme:t,capabilities:r.capabilities}))}async j(t){if(!(0,b.isAbsolutePath)(t))throw new u.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const r=this.h.get(t.scheme);if(!r){const n=new d.ErrorNoTelemetry;throw n.message=(0,p.localize)(1,null,t.toString()),n}return r}async k(t){const r=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r)||(0,u.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const r=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,r){try{return await this.n(t,r)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async n(t,r){const n=await this.j(t),i=this.O(n),o=r?.resolveTo,c=r?.resolveSingleChildDescendants,l=r?.resolveMetadata,s=await n.stat(t);let g;return this.p(n,t,s,void 0,!!l,(R,O)=>(g||(g=T.TernarySearchTree.forUris(()=>!i),g.set(t,!0),o&&g.fill(!0,o)),g.get(R.resource)||g.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&c?O===1:!1))}async p(t,r,n,i,o,c){const{providerExtUri:l}=this.N(t),s={resource:r,name:l.basename(r),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(s.isDirectory&&c(s,i)){try{const g=await t.readdir(r),R=await A.Promises.settled(g.map(async([O,z])=>{try{const ie=l.joinPath(r,O),ee=o?await t.stat(ie):{type:z};return await this.p(t,ie,ee,g.length,o,c)}catch(ie){return this.b.trace(ie),null}}));s.children=(0,E.coalesce)(R)}catch(g){this.b.trace(g),s.children=[]}return s}return s}async resolveAll(t){return A.Promises.settled(t.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const r=await this.j(t),n=await r.stat(t);return this.p(r,t,n,void 0,!0,()=>!1)}async exists(t){const r=await this.j(t);try{return!!await r.stat(t)}catch{return!1}}async canCreateFile(t,r){try{await this.r(t,r)}catch(n){return n}return!0}async r(t,r){if(!r?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,r)}async createFile(t,r=a.VSBuffer.fromString(""),n){await this.r(t,n);const i=await this.writeFile(t,r);return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,r,n){const i=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(i);try{await this.s(i,t,n)||await this.P(i,o.dirname(t));let l;if((0,u.hasReadWriteCapability)(i)&&!(r instanceof a.VSBuffer))if((0,f.isReadableStream)(r)){const s=await(0,f.peekStream)(r,3);s.ended?l=a.VSBuffer.concat(s.buffer):l=s}else l=(0,f.peekReadable)(r,s=>a.VSBuffer.concat(s),3);else l=r;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&l instanceof a.VSBuffer?await this.cb(i,t,n,l):await this.Y(i,t,n,l instanceof a.VSBuffer?(0,a.bufferToReadable)(l):l),this.m.fire(new u.FileOperationEvent(t,4))}catch(c){throw new u.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(c).toString()),(0,u.toFileOperationResult)(c),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,r,n){if(!!n?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(r)));let o;try{o=await t.stat(r)}catch{return}if((o.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,p.localize)(6,null,this.nb(r)),0,n);if(this.mb(r,o),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&n.mtime<o.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:o.size}))throw new u.FileOperationError((0,p.localize)(7,null),3,n);return o}async readFile(t,r,n){const i=await this.k(t);return r?.atomic?this.t(i,t,r,n):this.u(i,t,r,n)}async t(t,r,n,i){return new Promise((o,c)=>{this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.u(t,r,n,i);o(l)}catch(l){c(l)}})})}async u(t,r,n,i){const o=await this.v(t,r,{...n,preferUnbuffered:!0},i);return{...o,value:await(0,a.streamToBuffer)(o.value)}}async readFileStream(t,r,n){const i=await this.k(t);return this.v(i,t,r,n)}async v(t,r,n,i){const o=new I.CancellationTokenSource(i),c=this.F(r,n).then(s=>s,s=>{throw o.cancel(),s});let l;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await c,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?l=this.D(t,r,n):(0,u.hasFileReadStreamCapability)(t)?l=this.z(t,r,o.token,n):l=this.C(t,r,o.token,n),{...await c,value:l}}catch(s){throw l&&await(0,f.consumeStream)(l),this.w(s,r,n)}}w(t,r,n){const i=(0,p.localize)(8,null,this.nb(r),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}z(t,r,n,i=Object.create(null)){const o=t.readFileStream(r,i,n);return(0,f.transform)(o,{data:c=>c instanceof a.VSBuffer?c:a.VSBuffer.wrap(c),error:c=>this.w(c,r,i)},c=>a.VSBuffer.concat(c))}C(t,r,n,i=Object.create(null)){const o=(0,a.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,r,o,c=>c,{...i,bufferSize:this.a,errorTransformer:c=>this.w(c,r,i)},n),o}D(t,r,n){const i=(0,f.newWriteableStream)(o=>a.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?o=await t.readFile(r,{atomic:!0}):o=await t.readFile(r),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.G(r,o.byteLength,n),i.end(a.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async F(t,r){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,r);if(typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&r.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,p.localize)(10,null),n,r);return this.G(t,n.size,r),n}G(t,r,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&r>n.limits.size&&(i=7),typeof i=="number")throw new u.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),i,r,n)}}async canMove(t,r,n){return this.H(t,r,"move",n)}async canCopy(t,r,n){return this.H(t,r,"copy",n)}async H(t,r,n,i){if(t.toString()!==r.toString())try{const o=n==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(r),r);await this.M(o,t,c,r,n,i)}catch(o){return o}return!0}async move(t,r,n){const i=this.lb(await this.l(t),t),o=this.lb(await this.l(r),r),c=await this.I(i,t,o,r,"move",!!n),l=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,c==="move"?2:3,l)),l}async copy(t,r,n){const i=await this.k(t),o=this.lb(await this.l(r),r),c=await this.I(i,t,o,r,"copy",!!n),l=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,c==="copy"?3:2,l)),l}async I(t,r,n,i,o,c){if(r.toString()===i.toString())return o;const{exists:l,isSameResourceWithDifferentPathCase:s}=await this.M(t,r,n,i,o,c);if(l&&!s&&c&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),o==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(r,i,{overwrite:c});else{const g=await this.resolve(r);g.isDirectory?await this.L(t,g,n,i):await this.J(t,r,n,i)}return o}else return t===n?(await t.rename(r,i,{overwrite:c}),o):(await this.I(t,r,n,i,"copy",c),await this.del(r,{recursive:!0}),"copy")}async J(t,r,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.eb(t,r,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.kb(t,r,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.ib(t,r,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.gb(t,r,n,i)}async L(t,r,n,i){await n.mkdir(i),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async o=>{const c=this.N(n).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),n,c):this.J(t,o.resource,n,c)}))}async M(t,r,n,i,o,c){let l=!1;if(t===n){const{providerExtUri:g,isPathCaseSensitive:R}=this.N(t);if(R||(l=g.isEqual(r,i)),l&&o==="copy")throw new Error((0,p.localize)(12,null,this.nb(r),this.nb(i)));if(!l&&g.isEqualOrParent(i,r))throw new Error((0,p.localize)(13,null,this.nb(r),this.nb(i)))}const s=await this.exists(i);if(s&&!l){if(!c)throw new u.FileOperationError((0,p.localize)(14,null,this.nb(r),this.nb(i)),4);if(t===n){const{providerExtUri:g}=this.N(t);if(g.isEqualOrParent(r,i))throw new Error((0,p.localize)(15,null,this.nb(r),this.nb(i)))}}return{exists:s,isSameResourceWithDifferentPathCase:l}}N(t){const r=this.O(t);return{providerExtUri:r?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:r}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const r=this.lb(await this.j(t),t);await this.P(r,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async P(t,r){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(r,i.dirname(r));)try{if(((await t.stat(r)).type&u.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(r)));break}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(i.basename(r)),r=i.dirname(r)}for(let o=n.length-1;o>=0;o--){r=i.joinPath(r,n[o]);try{await t.mkdir(r)}catch(c){if((0,u.toFileSystemProviderErrorCode)(c)!==u.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,r){try{await this.Q(t,r)}catch(n){return n}return!0}async Q(t,r){const n=this.lb(await this.j(t),t);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let o;try{o=await n.stat(t)}catch{}if(o)this.mb(t,o);else throw new u.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!r?.recursive){const l=await this.resolve(t);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return n}async del(t,r){const n=await this.Q(t,r),i=!!r?.useTrash,o=!!r?.recursive;await n.delete(t,{recursive:o,useTrash:i}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,r){const n=await this.j(t),i=this.lb(await this.l(r),r);if(n===i&&this.N(n).providerExtUri.isEqual(t,r))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,r);await this.P(i,this.N(i).providerExtUri.dirname(r));const o=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(t,r,{overwrite:!0})):o.queue(()=>this.J(n,t,i,r))}watch(t,r={recursive:!1,excludes:[]}){const n=new y.DisposableStore;let i=!1,o=()=>{i=!0};return n.add((0,y.toDisposable)(()=>o())),(async()=>{try{const c=await this.W(t,r);i?(0,y.dispose)(c):o=()=>(0,y.dispose)(c)}catch(c){this.b.error(c)}})(),n}async W(t,r){const n=await this.j(t),i=(0,P.hash)([this.N(n).providerExtUri.getComparisonKey(t),r]);let o=this.U.get(i);return o||(o={count:0,disposable:n.watch(t,r)},this.U.set(i,o)),o.count+=1,(0,y.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,y.dispose)(o.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,y.dispose)(t.disposable);this.U.clear()}async Y(t,r,n,i){return this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(i)||(0,f.isReadableBufferedStream)(i)?await this.Z(t,o,i):await this.ab(t,o,i)}catch(c){throw(0,u.ensureFileSystemProviderError)(c)}finally{await t.close(o)}})}async Z(t,r,n){let i=0,o;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=a.VSBuffer.concat(n.buffer);await this.bb(t,r,c,c.byteLength,i,0),i+=c.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((c,l)=>{(0,f.listenStream)(o,{onData:async s=>{o.pause();try{await this.bb(t,r,s,s.byteLength,i,0)}catch(g){return l(g)}i+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>l(s),onEnd:()=>c()})})}async ab(t,r,n){let i=0,o;for(;(o=n.read())!==null;)await this.bb(t,r,o,o.byteLength,i,0),i+=o.byteLength}async bb(t,r,n,i,o,c){let l=0;for(;l<i;)l+=await t.write(r,o+l,n.buffer,c+l,i-l)}async cb(t,r,n,i){return this.X.queueFor(r,this.N(t).providerExtUri).queue(()=>this.db(t,r,n,i))}async db(t,r,n,i){let o;i instanceof a.VSBuffer?o=i:(0,f.isReadableStream)(i)?o=await(0,a.streamToBuffer)(i):(0,f.isReadableBufferedStream)(i)?o=await(0,a.bufferedStreamToBuffer)(i):o=(0,a.readableToBuffer)(i),await t.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(t,r,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.fb(t,r,n,i))}async fb(t,r,n,i){let o,c;try{o=await t.open(r,{create:!1}),c=await n.open(i,{create:!0,unlock:!1});const l=a.VSBuffer.alloc(this.a);let s=0,g=0,R=0;do R=await t.read(o,s,l.buffer,g,l.byteLength-g),await this.bb(n,c,l,R,s,g),s+=R,g+=R,g===l.byteLength&&(g=0);while(R>0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await A.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async gb(t,r,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.hb(t,r,n,i))}async hb(t,r,n,i){return n.writeFile(i,await t.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(t,r,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.jb(t,r,n,i))}async jb(t,r,n,i){const o=await n.open(i,{create:!0,unlock:!1});try{const c=await t.readFile(r);await this.bb(n,o,a.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,u.ensureFileSystemProviderError)(c)}finally{await n.close(o)}}async kb(t,r,n,i){const o=await(0,a.streamToBuffer)(this.C(t,r,I.CancellationToken.None));await this.cb(n,i,void 0,o)}lb(t,r){if(t.capabilities&2048)throw new u.FileOperationError((0,p.localize)(20,null,this.nb(r)),6);return t}mb(t,r){if((r.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};C=Le([Re(0,m.ILogService)],C),e.FileService=C}),define(ve[64],Ee([1,0,31,284,14,27,15,6,37,2,7,3,20,44,22,182,17,105,218,38,214,213]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(r)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=P.Event.None,this.H=new I.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.C(n));return{type:this.G(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(n){try{const i=await f.Promises.readdir(this.C(n),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat((0,v.joinPath)(n,c.name))).type:l=this.G(c),o.push([c.name,l])}catch(l){this.a.trace(l)}})),o}catch(i){throw this.Y(i)}}G(n,i){let o;return i?.dangling?o=u.FileType.Unknown:n.isFile()?o=u.FileType.File:n.isDirectory()?o=u.FileType.Directory:o=u.FileType.Unknown,i&&(o|=u.FileType.SymbolicLink),o}async I(n){const i=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const c=new a.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,y.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(n,i){let o;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),o=await this.I(n));const c=this.C(n);return await f.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(n){t.D&&this.a.trace(n)}readFileStream(n,i,o){const c=(0,b.newWriteableStream)(l=>D.VSBuffer.concat(l.map(s=>D.VSBuffer.wrap(s))).buffer);return(0,h.readFileIntoStream)(this,n,c,l=>l.buffer,{...i,bufferSize:256*1024},o),c}async writeFile(n,i,o){let c;try{const l=this.C(n);if(!o.create||!o.overwrite){if(await f.Promises.exists(l)){if(!o.overwrite)throw(0,u.createFileSystemProviderError)((0,p.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,u.createFileSystemProviderError)((0,p.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(l){throw await this.Z(n,l)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){t.O=n}async open(n,i){const o=this.C(n);let c;(0,u.isFileOpenForWriteOptions)(i)&&(c=await this.I(n));let l;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:g}=await f.SymlinkSupport.stat(o);g.mode&128||await f.Promises.chmod(o,g.mode|128)}catch(g){this.a.trace(g)}let s;if((0,u.isFileOpenForWriteOptions)(i)){if(S.isWindows)try{await f.Promises.truncate(o,0),s="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}s||(s="w")}else s="r";l=await f.Promises.open(o,s)}catch(s){throw c?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.Z(n,s):this.Y(s)}if(this.L.set(l,0),(0,u.isFileOpenForWriteOptions)(i)&&this.N.set(l,n),c){const s=this.M.get(l);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.M.set(l,c),s&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),s.dispose())}return l}async close(n){const i=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&t.O)try{await f.Promises.fdatasync(n)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await f.Promises.close(n)}catch(o){throw this.Y(o)}finally{i&&(this.M.get(n)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,o,c,l){const s=this.P(n,i);let g=null;try{g=(await f.Promises.read(n,o,c,l,s)).bytesRead}catch(R){throw this.Y(R)}finally{this.Q(n,s,g)}return g}P(n,i){return i===this.L.get(n)?null:i}Q(n,i,o){const c=this.L.get(n);typeof c=="number"&&(typeof i=="number"||(typeof o=="number"?this.L.set(n,c+o):this.L.delete(n)))}async write(n,i,o,c,l){return(0,a.retry)(()=>this.R(n,i,o,c,l),100,3)}async R(n,i,o,c,l){const s=this.P(n,i);let g=null;try{g=(await f.Promises.write(n,o,c,l,s)).bytesWritten}catch(R){throw await this.Z(this.N.get(n),R)}finally{this.Q(n,s,g)}return g}async mkdir(n){try{await f.Promises.mkdir(this.C(n))}catch(i){throw this.Y(i)}}async delete(n,i){try{const o=this.C(n);i.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(n,i,o){const c=this.C(n),l=this.C(i);if(c!==l)try{await this.S(n,i,"move",o.overwrite),await f.Promises.move(c,l)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,p.localize)(2,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(l)),s.toString()))),this.Y(s)}}async copy(n,i,o){const c=this.C(n),l=this.C(i);if(c!==l)try{await this.S(n,i,"copy",o.overwrite),await f.Promises.copy(c,l,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,p.localize)(3,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(l)),s.toString()))),this.Y(s)}}async S(n,i,o,c){const l=this.C(n),s=this.C(i);let g=!1;if(!!(this.capabilities&1024)||(g=(0,w.isEqual)(l,s,!0)),g&&o==="copy")throw(0,u.createFileSystemProviderError)((0,p.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!g&&await f.Promises.exists(s)){if(!c)throw(0,u.createFileSystemProviderError)((0,p.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.U(n,i,!1)}async U(n,i,o){const c=this.C(n),l=this.C(i),s=!!(this.capabilities&1024);if((0,w.isEqual)(c,l,!s))return;const g=new y.DisposableStore;try{const[R,O]=await Promise.all([this.I(n),this.I(i)]);g.add(R),g.add(O),o&&await f.Promises.mkdir((0,T.dirname)(l),{recursive:!0}),await f.Promises.copyFile(c,l)}catch(R){if(R.code==="ENOENT"&&!o)return this.U(n,i,!0);throw this.Y(R)}finally{g.dispose()}}p(n,i,o){return new C.UniversalWatcherClient(c=>n(c),c=>i(c),o)}y(n,i,o){return new k.NodeJSWatcherClient(c=>n(c),c=>i(c),o)}Y(n){if(n instanceof u.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=u.FileSystemProviderErrorCode.NoPermissions;break;default:i=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,i)}async Z(n,i){let o=this.Y(i);if(n&&o.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.C(n));c.mode&128||(o=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ve[219],Ee([1,0,6,64,2,15,44,19]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends a.Disposable{constructor(S,v){super(),this.a=S,this.b=v,this.w=new Map,this.y=new Map}call(S,v,b){const f=this.c(S);switch(v){case"stat":return this.g(f,b[0]);case"readdir":return this.h(f,b[0]);case"open":return this.l(f,b[0],b[1]);case"close":return this.m(b[0]);case"read":return this.n(b[0],b[1],b[2]);case"readFile":return this.i(f,b[0],b[1]);case"write":return this.p(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.k(f,b[0],b[1],b[2]);case"rename":return this.t(f,b[0],b[1],b[2]);case"copy":return this.u(f,b[0],b[1],b[2]);case"cloneFile":return this.v(f,b[0],b[1]);case"mkdir":return this.r(f,b[0]);case"delete":return this.s(f,b[0],b[1]);case"watch":return this.C(f,b[0],b[1],b[2],b[3]);case"unwatch":return this.D(b[0],b[1])}throw new Error(`IPC Command ${v} not found`)}listen(S,v,b){const f=this.c(S);switch(v){case"fileChange":return this.z(f,b[0]);case"readFileStream":return this.j(f,b[0],b[1])}throw new Error(`Unknown event ${v}`)}g(S,v){const b=this.f(S,v,!0);return this.a.stat(b)}h(S,v){const b=this.f(S,v);return this.a.readdir(b)}async i(S,v,b){const f=this.f(S,v,!0),p=await this.a.readFile(f,b);return I.VSBuffer.wrap(p)}j(S,v,b){const f=this.f(S,v,!0),p=new P.CancellationTokenSource,u=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),h=this.a.readFileStream(f,b,p.token);return(0,D.listenStream)(h,{onData:m=>u.fire(I.VSBuffer.wrap(m)),onError:m=>u.fire(m),onEnd:()=>{u.fire("end"),u.dispose(),p.dispose()}}),u.event}k(S,v,b,f){const p=this.f(S,v);return this.a.writeFile(p,b.buffer,f)}l(S,v,b){const f=this.f(S,v,!0);return this.a.open(f,b)}m(S){return this.a.close(S)}async n(S,v,b){const f=I.VSBuffer.alloc(b),p=0,u=await this.a.read(S,v,f.buffer,p,b);return[f,u]}p(S,v,b,f,p){return this.a.write(S,v,b.buffer,f,p)}r(S,v){const b=this.f(S,v);return this.a.mkdir(b)}s(S,v,b){const f=this.f(S,v);return this.a.delete(f,b)}t(S,v,b,f){const p=this.f(S,v),u=this.f(S,b);return this.a.rename(p,u,f)}u(S,v,b,f){const p=this.f(S,v),u=this.f(S,b);return this.a.copy(p,u,f)}v(S,v,b){const f=this.f(S,v),p=this.f(S,b);return this.a.cloneFile(f,p)}z(S,v){const b=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(v,this.F(S,b))},onDidRemoveLastListener:()=>{(0,a.dispose)(this.w.get(v)),this.w.delete(v)}});return b.event}async C(S,v,b,f,p){const u=this.w.get(v);if(u){const h=this.f(S,f),m=u.watch(b,h,p);this.y.set(v+b,m)}}async D(S,v){const b=S+v,f=this.y.get(b);f&&((0,a.dispose)(f),this.y.delete(b))}dispose(){super.dispose();for(const[,S]of this.y)S.dispose();this.y.clear();for(const[,S]of this.w)S.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class y extends a.Disposable{constructor(S,v,b,f){super(),this.c=S,this.f=b,this.g=f,this.a=new Map,this.b=this.B(new A.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h(S){const v=this.B(new E.Emitter);this.B(v.event(b=>{S.fire(b.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type})))})),this.B(this.b.onDidChangeFile(b=>v.fire(b))),this.B(this.b.onDidWatchError(b=>S.fire(b)))}i(S){}j(S){}watch(S,v,b){const f=this.j(this.g);return Array.isArray(f)&&(b.excludes=[...b.excludes,...f]),this.a.set(S,this.b.watch(v,b)),(0,a.toDisposable)(()=>{(0,a.dispose)(this.a.get(S)),this.a.delete(S)})}dispose(){super.dispose();for(const[,S]of this.a)S.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=y}),define(ve[108],Ee([1,0,4,6,12,2]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class D extends a.AbstractLoggerService{constructor(S,v,b,f){super(v,b),this.l=S,this.m=f,this.B(f.listen("onDidChangeLogLevel",S)(p=>{(0,a.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(E.URI.revive(p[0]),p[1])})),this.B(f.listen("onDidChangeVisibility",S)(([p,u])=>super.setVisibility(E.URI.revive(p),u))),this.B(f.listen("onDidChangeLoggers",S)(({added:p,removed:u})=>{for(const h of p)super.registerLogger({...h,resource:E.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new a.AdapterLogger({log:(S,v)=>{this.m.call("consoleLog",[S,v])}})}registerLogger(S){super.registerLogger(S),this.m.call("registerLogger",[S,this.l])}deregisterLogger(S){super.deregisterLogger(S),this.m.call("deregisterLogger",[S,this.l])}setLogLevel(S,v){super.setLogLevel(S,v),this.m.call("setLogLevel",[S,v])}setVisibility(S,v){super.setVisibility(S,v),this.m.call("setVisibility",[S,v])}k(S,v,b){return new P(this.m,S,v,b,this.l)}static setLogLevel(S,v,b){return S.call("setLogLevel",[v,b])}}e.LoggerChannelClient=D;class P extends a.AbstractMessageLogger{constructor(S,v,b,f,p){super(f?.logLevel==="always"),this.m=S,this.n=v,this.k=!1,this.l=[],this.setLevel(b),this.m.call("createLogger",[v,f,p]).then(()=>{this.r(this.l),this.k=!0})}g(S,v){const b=[[S,v]];this.k?this.r(b):this.l.push(...b)}r(S){this.m.call("log",[this.n,S])}}class w{constructor(S,v){this.a=S,this.b=v}listen(S,v){const b=this.b(S);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(p=>this.c(p,b)),removed:[...f.removed].map(p=>this.c(p,b))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,f=>[b.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,f=>(0,a.isLogLevel)(f)?f:[b.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${v}`)}async call(S,v,b){const f=this.b(S);switch(v){case"setLogLevel":return(0,a.isLogLevel)(b[0])?this.a.setLogLevel(b[0]):this.a.setLogLevel(E.URI.revive(f.transformIncoming(b[0][0])),b[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,f)))}throw new Error(`Call not found: ${v}`)}c(S,v){return{...S,resource:v.transformOutgoingURI(S.resource)}}}e.LoggerChannel=w;class y extends I.Disposable{constructor(S,v){super(),v.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(b=>v.call("setLogLevel",[b]))),v.call("getRegisteredLoggers").then(b=>{for(const f of b)S.registerLogger({...f,resource:E.URI.revive(f.resource)})}),this.B(v.listen("onDidChangeVisibility")(([b,f])=>S.setVisibility(E.URI.revive(b),f))),this.B(v.listen("onDidChangeLoggers")(({added:b,removed:f})=>{for(const p of b)S.registerLogger({...p,resource:E.URI.revive(p.resource)});for(const p of f)S.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=y}),define(ve[109],Ee([1,0,2,12]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class a extends E.Disposable{constructor(D,P=[]){super(),this.a=new A.MultiplexLogger([D,...P]),this.B(D.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.LogService=a}),define(ve[110],Ee([1,0,17,12]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var a;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(a||(a={}));async function I(y,T,S,v,b){try{const f=await new Promise((u,h)=>{ae(["spdlog"],u,h)});f.setFlushOn(a.Trace);const p=await f.createAsyncRotatingLogger(y,T,S,v);return b?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(f){console.error(f)}return null}function D(y,T,S){switch(T){case A.LogLevel.Trace:y.trace(S);break;case A.LogLevel.Debug:y.debug(S);break;case A.LogLevel.Info:y.info(S);break;case A.LogLevel.Warning:y.warn(S);break;case A.LogLevel.Error:y.error(S);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function P(y,T){switch(T){case A.LogLevel.Trace:y.setLevel(a.Trace);break;case A.LogLevel.Debug:y.setLevel(a.Debug);break;case A.LogLevel.Info:y.setLevel(a.Info);break;case A.LogLevel.Warning:y.setLevel(a.Warning);break;case A.LogLevel.Error:y.setLevel(a.Error);break;case A.LogLevel.Off:y.setLevel(a.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class w extends A.AbstractMessageLogger{constructor(T,S,v,b,f){super(),this.k=[],this.setLevel(f),this.l=this.n(T,S,v,b),this.B(this.onDidChangeLogLevel(p=>{this.m&&P(this.m,p)}))}async n(T,S,v,b){const f=v?6:1,p=30/f*E.ByteSize.MB,u=await I(T,S,p,f,b);if(u){this.m=u,P(this.m,this.getLevel());for(const{level:h,message:m}of this.k)D(this.m,h,m);this.k=[]}}g(T,S){this.m?D(this.m,T,S):this.getLevel()<=T&&this.k.push({level:T,message:S})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=w}),define(ve[220],Ee([1,0,21,12,110]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class I extends A.AbstractLoggerService{k(P,w,y){return new a.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!y?.donotRotate,!!y?.donotUseFormatters,w)}}e.LoggerService=I}),define(ve[221],Ee([1,0,58,184,5]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var D;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function y(f,p){return p-f}w.compare=y;const T=Object.create(null);T[w.Error]=(0,A.localize)(0,null),T[w.Warning]=(0,A.localize)(1,null),T[w.Info]=(0,A.localize)(2,null);function S(f){return T[f]||""}w.toString=S;function v(f){switch(f){case E.default.Error:return w.Error;case E.default.Warning:return w.Warning;case E.default.Info:return w.Info;case E.default.Ignore:return w.Hint}}w.fromSeverity=v;function b(f){switch(f){case w.Error:return E.default.Error;case w.Warning:return E.default.Warning;case w.Info:return E.default.Info;case w.Hint:return E.default.Ignore}}w.toSeverity=b}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(w){const y="";function T(v){return S(v,!0)}w.makeKey=T;function S(v,b){const f=[y];return v.source?f.push(v.source.replace("\xA6","\\\xA6")):f.push(y),v.code?typeof v.code=="string"?f.push(v.code.replace("\xA6","\\\xA6")):f.push(v.code.value.replace("\xA6","\\\xA6")):f.push(y),v.severity!==void 0&&v.severity!==null?f.push(D.toString(v.severity)):f.push(y),v.message&&b?f.push(v.message.replace("\xA6","\\\xA6")):f.push(y),v.startLineNumber!==void 0&&v.startLineNumber!==null?f.push(v.startLineNumber.toString()):f.push(y),v.startColumn!==void 0&&v.startColumn!==null?f.push(v.startColumn.toString()):f.push(y),v.endLineNumber!==void 0&&v.endLineNumber!==null?f.push(v.endLineNumber.toString()):f.push(y),v.endColumn!==void 0&&v.endColumn!==null?f.push(v.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}w.makeKeyOptionalMessage=S})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,a.createDecorator)("markerService")}),define(ve[65],Ee([1,0,6,55,2,5]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,I.createDecorator)("policy");class D extends a.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const T=Object.keys(this.f).length;return this.f={...y,...this.f},T!==Object.keys(this.f).length&&await this.i(y),A.Iterable.reduce(this.g.entries(),(S,[v,b])=>({...S,[v]:b}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(y,[T,S])=>({...y,[T]:{definition:S,value:this.g.get(T)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ve[51],Ee([1,0,3,28]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const I=E.globals.vscode.context.configuration();if(I)a=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:I.version})}Object.assign(a,{extensionsGallery:A.env.EXTENSIONS_GALLERY?JSON.parse(A.env.EXTENSIONS_GALLERY):a.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else a={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.75.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.75.1",commit:"441438abd1ac652551dbe4d408dfcec8a499b8bf",date:"2023-02-13T16:47:00.619Z"},Object.keys(a).length===0&&Object.assign(a,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(ve[26],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[39],Ee([1,0,87,8]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class a{constructor(){this.a=new Map}add(D,P){E.ok(A.isString(D)),E.ok(A.isObject(P)),E.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new a}),define(ve[222],Ee([1,0,6,39]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function a(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,y){this.a[a(w)]=y,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const D=new I;A.Registry.add(e.Extensions.JSONContribution,D)}),define(ve[52],Ee([1,0,18,6,8,168,24,222,39]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=w.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:i,source:o}of t)for(const c in i)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const l=this.a.get(c),s=l?.valuesSources??new Map;if(o)for(const z of Object.keys(i[c]))s.set(z,o);const g={...l?.value||{},...i[c]};this.a.set(c,{source:o,value:g,valuesSources:s});const R=(0,D.getLanguageTagSettingPlainKey)(c),O={type:"object",default:g,description:I.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:a.isString(o)?void 0:o,defaultValueSource:o};n.push(...p(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:i[c],source:o});const l=this.d[c];l&&(this.w(c,l),this.r(c,l))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:i}of t)for(const o in n){const c=this.a.get(o),l=a.isString(i)?i:i?.id,s=a.isString(c?.source)?c?.source:c?.source?.id;if(l===s)if(r.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const g=this.d[o];g&&(this.w(o,g),this.r(o,g))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,r){const n=i=>{if(i.properties)for(const o in i.properties){r.add(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>n(o))};for(const i of t){n(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,n,i,o=3,c){o=a.isUndefinedOrNull(t.scope)?o:t.scope;const l=t.properties;if(l)for(const g in l){const R=l[g];if(r&&d(g,R)){delete l[g];continue}if(R.source=n,R.defaultDefaultValue=l[g].default,this.w(g,R),e.OVERRIDE_PROPERTY_REGEX.test(g)?R.scope=void 0:(R.scope=a.isUndefinedOrNull(R.scope)?o:R.scope,R.restricted=a.isUndefinedOrNull(R.restricted)?!!i?.includes(g):R.restricted),l[g].hasOwnProperty("included")&&!l[g].included){this.f[g]=l[g],delete l[g];continue}else this.d[g]=l[g],l[g].policy?.name&&this.e.set(l[g].policy.name,g);!l[g].deprecationMessage&&l[g].markdownDeprecationMessage&&(l[g].deprecationMessage=l[g].markdownDeprecationMessage),c.add(g)}const s=t.allOf;if(s)for(const g of s)this.p(g,r,n,i,o,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const i=n.properties;if(i)for(const c in i)this.r(c,i[c]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let i=n?.value,o=n?.source;a.isUndefined(i)&&(i=r.defaultDefaultValue,o=void 0),a.isUndefined(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=o}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(k){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let r=f.exec(k);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=f.exec(k)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=p;function u(k){return k.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=u;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const m=new v;w.Registry.add(e.Extensions.Configuration,m);function d(k,t){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?I.localize(7,null,k):m.getConfigurationProperties()[k]!==void 0?I.localize(8,null,k):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,k,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.validateProperty=d;function C(){const k=[],t=m.getConfigurationProperties();for(const r of Object.keys(t))k.push([r,t[r].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=C}),define(ve[111],Ee([1,0,18,6,70,2,27,23,8,4,24,52,39]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(r){return Object.isFrozen(r)?r:P.deepFreeze(r)}class f{constructor(n={},i=[],o=[],c){this.b=n,this.c=i,this.d=o,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof f)return i;const o=new p("");return o.parseRaw(i),o.configurationModel});this.f=n.reduce((i,o)=>o===i?o:i.merge(o),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,T.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const o=this.rawConfiguration.getValue(n),c=i?this.rawConfiguration.getOverrideValue(n,i):void 0,l=i?this.rawConfiguration.override(i).getValue(n):o;return{value:o,override:c,merged:l}}getOverrideValue(n,i){const o=this.i(i);return o?n?(0,T.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const o of this.overrides)o.identifiers.includes(n)&&i.push(...o.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return E.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),c=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const s of n)if(l.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.h(i,s.contents);for(const g of s.overrides){const[R]=o.filter(O=>E.equals(O.identifiers,g.identifiers));R?(this.h(R.contents,g.contents),R.keys.push(...g.keys),R.keys=E.distinct(R.keys)):o.push(P.deepClone(g))}for(const g of s.keys)c.indexOf(g)===-1&&c.push(g)}return new f(i,c,o,l.every(s=>s instanceof f)?void 0:l)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const c of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[c];const s=i[c];s&&(typeof l=="object"&&typeof s=="object"?(l=P.deepClone(l),this.h(l,s)):l=s),o[c]=l}return new f(o,this.keys,this.overrides)}h(n,i){for(const o of Object.keys(i)){if(o in n&&w.isObject(n[o])&&w.isObject(i[o])){this.h(n[o],i[o]);continue}n[o]=P.deepClone(i[o])}}i(n){let i=null,o=null;const c=l=>{l&&(o?this.h(o,l):o=P.deepClone(l))};for(const l of this.overrides)E.equals(l.identifiers,[n])?i=l.contents:l.identifiers.includes(n)&&c(l.contents);return c(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,n),S.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,S.overrideIdentifiersFromKey)(n))),1))}j(n,i,o){(0,T.addToValueTree)(this.contents,n,i,c=>console.error(c)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),S.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,T.toValuesTree)(this.contents[n],c=>console.error(c))})}}e.ConfigurationModel=f;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!w.isUndefinedOrNull(n)){const o=this.g(n);this.parseRaw(o,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:o,keys:c,overrides:l,restricted:s,hasExcludedProperties:g}=this.h(n,i);this.b=new f(o,c,l,g?[n]:void 0),this.c=s||[]}g(n){let i={},o=null,c=[];const l=[],s=[];function g(O){Array.isArray(c)?c.push(O):o!==null&&(c[o]=O)}const R={onObjectBegin:()=>{const O={};g(O),l.push(c),c=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const O=[];g(O),l.push(c),c=O,o=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:g,onError:(O,z,ie)=>{s.push({error:O,offset:z,length:ie})}};if(n)try{a.visit(n,R),i=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(n,i){const o=v.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),c=this.i(n,o,!0,i);n=c.raw;const l=(0,T.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),s=Object.keys(n),g=this.j(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:l,keys:s,overrides:g,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(n,i,o,c){let l=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const s={},g=[];for(const R in n)if(S.OVERRIDE_PROPERTY_REGEX.test(R)&&o){const O=this.i(n[R],i,!1,c);s[R]=O.raw,l=l||O.hasExcludedProperties,g.push(...O.restricted)}else{const O=i[R],z=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&g.push(R),(z===void 0||c.scopes===void 0||c.scopes.includes(z))&&!(c.skipRestricted&&O?.restricted)?s[R]=n[R]:l=!0}return{raw:s,restricted:g,hasExcludedProperties:l}}j(n,i){const o=[];for(const c of Object.keys(n))if(S.OVERRIDE_PROPERTY_REGEX.test(c)){const l={};for(const s in n[c])l[s]=n[c][s];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(c),keys:Object.keys(l),contents:(0,T.toValuesTree)(l,i)})}return o}}e.ConfigurationModelParser=p;class u extends I.Disposable{constructor(n,i,o,c){super(),this.f=n,this.g=i,this.h=c,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&o.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class h{constructor(n,i,o,c,l,s,g,R,O,z,ie,ee,F){this.a=n,this.b=i,this.c=o,this.overrideIdentifiers=c,this.d=l,this.f=s,this.g=g,this.h=R,this.i=O,this.j=z,this.k=ie,this.l=ee,this.m=F}get value(){return b(this.c)}n(n,i,o){const c=n.inspect(i,o);return{get value(){return b(c.value)},get override(){return b(c.override)},get merged(){return b(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(n,i,o,c,l=new f,s=new f,g=new D.ResourceMap,R=new f,O=new D.ResourceMap){this.c=n,this.d=i,this.f=o,this.g=c,this.h=l,this.i=s,this.j=g,this.l=R,this.m=O,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(n,i,o){return this.q(n,i,o).getValue(n)}updateValue(n,i,o={}){let c;o.resource?(c=this.m.get(o.resource),c||(c=new f,this.m.set(o.resource,c))):c=this.l,i===void 0?c.removeValue(n):c.setValue(n,i),o.resource||(this.a=null)}inspect(n,i,o){const c=this.q(n,i,o),l=this.u(i.resource,o),s=i.resource?this.m.get(i.resource)||this.l:this.l,g=new Set;for(const R of c.overrides)for(const O of R.identifiers)c.getOverrideValue(n,O)!==void 0&&g.add(O);return new h(n,i,c.getValue(n),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,l||void 0,s)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const o=[];if(!i){const{added:c,updated:l,removed:s}=k(this.c,n);i=[...c,...l,...s]}for(const c of i)for(const l of(0,S.overrideIdentifiersFromKey)(c)){const s=this.c.getKeysForOverrideIdentifier(l),g=n.getKeysForOverrideIdentifier(l),R=[...g.filter(O=>s.indexOf(O)===-1),...s.filter(O=>g.indexOf(O)===-1),...s.filter(O=>!P.equals(this.c.override(l).getValue(O),n.override(l).getValue(O)))];o.push([l,R])}return this.updateDefaultConfiguration(n),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:o,removed:c}=k(this.d,n),l=[...i,...o,...c];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:o,removed:c,overrides:l}=k(this.applicationConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateApplicationConfiguration(n),{keys:s,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:o,removed:c,overrides:l}=k(this.localUserConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateLocalUserConfiguration(n),{keys:s,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:o,removed:c,overrides:l}=k(this.remoteUserConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateRemoteUserConfiguration(n),{keys:s,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:o,removed:c,overrides:l}=k(this.workspaceConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateWorkspaceConfiguration(n),{keys:s,overrides:l}}compareAndUpdateFolderConfiguration(n,i){const o=this.p.get(n),{added:c,updated:l,removed:s,overrides:g}=k(o,i),R=[...c,...l,...s];return(R.length||!o)&&this.updateFolderConfiguration(n,i),{keys:R,overrides:g}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:c,removed:l,overrides:s}=k(i,void 0);return{keys:[...o,...c,...l],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,o){let c=this.r(i,o);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(c=c.merge(this.d)),c}r({resource:n},i){let o=this.s();if(i&&n){const c=i.getFolder(n);c&&(o=this.t(c.uri)||o);const l=this.m.get(n);l&&(o=o.merge(l))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const o=this.s(),c=this.j.get(n);c?(i=o.merge(c),this.b.set(n,i)):i=o}return i}u(n,i){if(i&&n){const o=i.getFolder(n);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:o,overrides:c,keys:l}=this.j.get(i);return n.push([i,{contents:o,overrides:c,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(o=>n.add(o))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.i.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(c=>i.add(c))),[...i.values()]}static parse(n){const i=this.x(n.defaults),o=this.x(n.policy),c=this.x(n.application),l=this.x(n.user),s=this.x(n.workspace),g=n.folders.reduce((R,O)=>(R.set(y.URI.revive(O[0]),this.x(O[1])),R),new D.ResourceMap);return new m(i,o,c,l,new f,s,g,new f,new D.ResourceMap)}static x(n){return new f(n.contents,n.keys,n.overrides)}}e.Configuration=m;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,i=new Map;for(const c of r)c.keys.forEach(l=>n.add(l)),c.overrides.forEach(([l,s])=>{const g=(0,D.getOrSet)(i,l,new Set);s.forEach(R=>g.add(R))});const o=[];return i.forEach((c,l)=>o.push([l,[...c.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=d;class C{constructor(n,i,o,c){this.change=n,this.f=i,this.g=o,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const s of l)this.affectedKeys.add(s);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(n,i){const o=this.a+n,c=this.d.indexOf(o);if(c<0)return!1;const l=c+o.length;if(l>=this.d.length)return!1;const s=this.d.charCodeAt(l);if(s!==this.b&&s!==this.c)return!1;if(i){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,R=this.g.getValue(n,i,this.h);return!P.equals(g,R)}return!0}}e.ConfigurationChangeEvent=C;function k(r,n){const{added:i,removed:o,updated:c}=t(n?.rawConfiguration,r?.rawConfiguration),l=[],s=r?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const R=g.filter(O=>!s.includes(O));for(const O of R)l.push([O,n.getKeysForOverrideIdentifier(O)])}if(r){const R=s.filter(O=>!g.includes(O));for(const O of R)l.push([O,r.getKeysForOverrideIdentifier(O)])}if(n&&r){for(const R of s)if(g.includes(R)){const O=t({contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});l.push([R,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:o,updated:c,overrides:l}}function t(r,n){const i=r?n?r.keys.filter(l=>n.keys.indexOf(l)===-1):[...r.keys]:[],o=n?r?n.keys.filter(l=>r.keys.indexOf(l)===-1):[...n.keys]:[],c=[];if(r&&n){for(const l of n.keys)if(r.keys.indexOf(l)!==-1){const s=(0,T.getConfigurationValue)(n.contents,l),g=(0,T.getConfigurationValue)(r.contents,l);P.equals(s,g)||c.push(l)}}return{added:i,removed:o,updated:c}}}),define(ve[223],Ee([1,0,18,6,2,23,8,111,52,12,65,39]),function(ae,e,E,A,a,I,D,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends a.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:h})=>this.c(Array.from(u),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,h){this.h(u,S.Registry.as(w.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new P.ConfigurationModel;const u=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,h){const m=this.f();for(const d of u){const C=m[d],k=h[d];C!==void 0?this.b.addValue(d,C):k?this.b.addValue(d,k.default):this.b.removeValue(d)}}}e.DefaultConfiguration=v;class b{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let f=class extends a.Disposable{get configurationModel(){return this.b}constructor(u,h,m){super(),this.c=u,this.f=h,this.g=m,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const h={},m=[],d=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const C of u){const k=d[C];if(!k){m.push(C);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}m.push(C),h[k.policy.name]={type:k.type}}}return(0,D.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),m}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const h=S.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),m=(0,E.coalesce)(u.map(d=>h.get(d)));this.j(m,!0)}j(u,h){this.g.trace("PolicyConfiguration#update",u);const m=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),d=[],C=this.b.isEmpty();for(const k of u){const t=m[k]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(C?r!==void 0:!(0,I.equals)(this.b.getValue(k),r))&&d.push([k,r])}else this.b.getValue(k)!==void 0&&d.push([k,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const k=this.b;this.b=new P.ConfigurationModel;for(const t of k.keys)this.b.setValue(t,k.getValue(t));for(const[t,r]of d)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);h&&this.a.fire(this.b)}}};f=Le([Re(1,T.IPolicyService),Re(2,y.ILogService)],f),e.PolicyConfiguration=f}),define(ve[112],Ee([1,0,14,6,2,20,24,111,223,65]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends a.Disposable{constructor(v,b,f,p){super(),this.i=v,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=f instanceof y.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,f,p)),this.f=this.B(new P.UserSettings(this.i,void 0,I.extUriBiasedIgnorePathCase,b)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:h})=>this.k(u,h))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,b,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(v,b,new P.ConfigurationModel,f)}getConfigurationData(){return this.a.toData()}getValue(v,b){const f=typeof v=="string"?v:void 0,p=(0,D.isConfigurationOverrides)(v)?v:(0,D.isConfigurationOverrides)(b)?b:{};return this.a.getValue(f,p,void 0)}updateValue(v,b,f,p){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const b=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(f,b,2)}k(v,b){const f=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(v,b);this.m(p,f,7)}l(v){const b=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(v);this.m(f,b,7)}m(v,b,f){const p=new P.ConfigurationChangeEvent(v,{data:b},this.a);p.source=f,p.sourceConfig=this.n(f),this.h.fire(p)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ve[113],Ee([1,0,9,5]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var a;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(a=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends E.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof I&&w._code===a.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof I&&w._code===a.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof I&&w._code===a.NoResolverFound}static isHandled(w){return w instanceof I&&w.isHandled}constructor(w,y=a.Unknown,T){super(w),this._message=w,this._code=y,this._detail=T,this.isHandled=y===a.NotAvailable&&T===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function D(P){const w=P.indexOf("+");return w===-1?P:P.substring(0,w)}e.getRemoteAuthorityPrefix=D}),define(ve[66],Ee([1,0,13]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=A;function a(y){if(!y)return;const T=y.indexOf("+");return T<0?y:y.substr(0,T)}e.getRemoteName=a;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=I;function D(y){const{host:T,port:S}=w(y);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:S}}e.parseAuthorityWithPort=D;function P(y,T){let{host:S,port:v}=w(y);return typeof v>"u"&&(v=T),{host:S,port:v}}e.parseAuthorityWithOptionalPort=P;function w(y){const T=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const S=y.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const v=y.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:y,port:void 0}}}),define(ve[33],Ee([1,0,16,5,66]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=I;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(p){this.value=p,this.c=p.toLowerCase()}static equals(p,u){if(typeof p>"u"||p===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){const h=typeof p=="string"?p:p.value,m=typeof u=="string"?u:u.value;return E.equalsIgnoreCase(h,m)}return p.c===u.c}static toKey(p){return typeof p=="string"?p.toLowerCase():p.c}}e.ExtensionIdentifier=y;function T(f){return S(f)}e.isApplicationScopedExtension=T;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function b(f,p){if(p){const u=`onResolveRemoteAuthority:${(0,a.getRemoteName)(p)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[224],Ee([1,0,2,7,22,33]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends E.Disposable{constructor(w,y){super(),this.b=w,this.a=(0,A.join)(this.b.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this.B(y.onDidInstallExtensions(T=>this.c(T))),this.B(y.onDidUninstallExtension(T=>this.f(T)))}c(w){w.some(y=>!!y.local)&&this.invalidate()}f(w){w.error||this.invalidate()}invalidate(){a.Promises.rm(this.a,a.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(ve[53],Ee([1,0,15,185,52,5,39]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function w(p){return p.res.statusCode===204}async function y(p){return w(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=y;async function T(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return y(p)}e.asTextOrError=T;async function S(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(w(p))return null;const h=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(h)}catch(m){throw m.message+=`:
`+h,m}}e.asJson=S;function v(p){f(p)}e.updateProxyConfigurationsScope=v;let b;function f(p){const u=D.Registry.as(a.Extensions.Configuration),h=b;b={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[b],remove:h?[h]:[]})}f(2)}),define(ve[225],Ee([1,0,19,13,17,53]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(w,y){this.a=w,this.b=y}async download(w,y,T=E.CancellationToken.None){if(w.scheme===A.Schemas.file||w.scheme===A.Schemas.vscodeRemote){await this.b.copy(w,y);return}const S={type:"GET",url:w.toString(!0)},v=await this.a.request(S,T);if(v.res.statusCode===200)await this.b.writeFile(y,v.stream);else{const b=await(0,I.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${b}`)}}};D=Le([Re(0,I.IRequestService),Re(1,a.IFileService)],D),e.DownloadService=D}),define(ve[226],Ee([1,0,15,19]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class a{constructor(P){this.a=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,y,T=A.CancellationToken.None){switch(w){case"request":return this.a.request(y[0],T).then(async({res:S,stream:v})=>{const b=await(0,E.streamToBuffer)(v);return[{statusCode:S.statusCode,headers:S.headers},b]});case"resolveProxy":return this.a.resolveProxy(y[0])}throw new Error("Invalid call")}}e.RequestChannel=a;class I{constructor(P){this.a=P}async request(P,w){const[y,T]=await this.a.call("request",[P],w);return{res:y,stream:(0,E.bufferToStream)(T)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=I}),define(ve[227],Ee([1,0,79,8]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function a(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function I(D,P,w={}){const y=(0,E.parse)(D),T=w.proxyUrl||a(y,P);if(!T)return null;const S=(0,E.parse)(T);if(!/^https?:$/.test(S.protocol||""))return null;const v={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,A.isBoolean)(w.strictSSL)?w.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((b,f)=>{ae(["http-proxy-agent"],b,f)}))(v):new(await new Promise((b,f)=>{ae(["https-proxy-agent"],b,f)}))(v)}e.getProxyAgent=I}),define(ve[80],Ee([1,0,48,7,186,19,38,9,3,21,156,199,14,143]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let f;async function p(h,m,d,C){return d["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(C)&&!d["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(C)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(k,t)=>{const r=new I.CancellationTokenSource;let n=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,b.clamp)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,a.localize)(0,null)))},n);try{k(await u(m,r.token))}catch(c){!(0,P.isCancellationError)(c)&&!r.token.isCancellationRequested?t(new Error((0,a.localize)(1,null,(0,D.toErrorMessage)(c)))):k({})}finally{clearTimeout(o),r.dispose()}})),f)}e.getResolvedShellEnv=p;async function u(h,m){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const C=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",C);const k=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(k+"({.*})"+k),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",r);const n=await(0,T.getSystemShell)(w.OS,r);return h.trace("getUnixShellEnvironment#shell",n),new Promise((i,o)=>{if(m.isCancellationRequested)return o(new P.CancellationError);const c=(0,A.basename)(n);let l,s;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(l=`& '${process.execPath}' ${g} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,s=["-Login","-Command"]):(l=`'${process.execPath}' ${g} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,c==="tcsh"||c==="csh"?s=["-ic"]:s=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),l);const R=(0,E.spawn)(n,[...s,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(R.kill(),o(new P.CancellationError))),R.on("error",ie=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ie)),o(ie)});const O=[];R.stdout.on("data",ie=>O.push(ie));const z=[];R.stderr.on("data",ie=>z.push(ie)),R.on("close",(ie,ee)=>{const F=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",F);const Z=Buffer.concat(z).toString("utf8");if(Z.trim()&&h.trace("getUnixShellEnvironment#stderr",Z),ie||ee)return o(new Error((0,a.localize)(2,null,ie,ee)));const $=t.exec(F),x=$?$[1]:"{}";try{const le=JSON.parse(x);d?le.ELECTRON_RUN_AS_NODE=d:delete le.ELECTRON_RUN_AS_NODE,C?le.ELECTRON_NO_ATTACH_CONSOLE=C:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){h.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(le)),o(le)}})})}}),define(ve[228],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ve[114],Ee([1,0,3,28,4,21]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(y){if(E.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function P(y,T,S,v,b,f,p,u,h,m){const d=Object.create(null);d["common.machineId"]=p,d.sessionID=(0,I.generateUuid)()+Date.now(),d.commitHash=b,d.version=f,d["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,E.PlatformToString)(E.platform),d["common.nodePlatform"]=A.platform,d["common.nodeArch"]=v,d["common.product"]=m||"desktop",u&&(d["common.msftInternal"]=u);let C=0;const k=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),E.isLinuxSnap&&(d["common.snap"]="true");const t=D(S);t&&(d["common.platformDetail"]=t);try{const r=await y.readFile(a.URI.file(h));d["common.source"]=r.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=P;function w(y){const T=A.env.USERDNSDOMAIN;if(!T)return!1;const S=T.toLowerCase();return y.some(v=>S===v)}e.verifyMicrosoftInternalDomain=w}),define(ve[229],Ee([1,0,18,9,2,23,17]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(y){function T(S,v){return S.callstack<v.callstack?-1:S.callstack>v.callstack?1:0}y.compare=T})(P=e.ErrorEvent||(e.ErrorEvent={}));class w{constructor(T,S=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new a.DisposableStore,this.c=T,this.d=S;const v=A.errorHandler.addListener(b=>this.j(b));this.h.add((0,a.toDisposable)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),A.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof D.FileOperationError))return;const S=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,v=T.message?T.message:(0,I.safeStringify)(T);!S||this.k({msg:v,callstack:S})}k(T){const S=(0,E.binarySearch)(this.g,T,P.compare);S<0?(T.count=1,this.g.splice(~S,0,T)):(this.g[S].count||(this.g[S].count=0),this.g[S].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const T of this.g)this.c.publicLogError2("UnhandledError",T);this.g.length=0}}w.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=w}),define(ve[230],Ee([1,0,2]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class A extends E.Disposable{constructor(I,D){super(),this.a=I,this.b=D}async call(I,D,P){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:w}=P;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:y}=P;return this.b?this.b.log(w,y):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${D} not found`)}listen(I,D,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=A}),define(ve[30],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var a;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(a=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[231],Ee([1,0,29,14,70,13,7,3,4,95,22,99,207,17,26,30]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const u=new Map;async function h(t,r){const n=`${t}::${r.join(":")}`,i=u.get(n);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,l=new Map,s=2e4;function g(O,z,ie,ee){const F=z.substring(O.length+1);return A.Promises.withAsyncBody(async Z=>{let $;try{$=await T.Promises.readdir(z,{withFileTypes:!0})}catch{Z();return}if(ee.count>=s){ee.count+=$.length,ee.maxReached=!0,Z();return}let x=$.length;if(x===0){Z();return}let le=$;ee.count+$.length>s&&(ee.maxReached=!0,x=s-ee.count,le=$.slice(0,x)),ee.count+=$.length;for(const be of le)if(be.isDirectory()){if(ie.includes(be.name)||await g(O,(0,D.join)(z,be.name),ie,ee),--x===0){Z();return}}else{const Y=be.name.lastIndexOf(".");if(Y>=0){const H=be.name.substring(Y+1);H&&c.set(H,(c.get(H)??0)+1)}for(const H of o)H.relativePathPattern?.test(F)!==!1&&H.filePattern.test(be.name)&&l.set(H.tag,(l.get(H.tag)??0)+1);if(--x===0){Z();return}}})}const R=A.Promises.withAsyncBody(async O=>{const z={count:0,maxReached:!1};await g(t,t,r,z);const ie=await C(t);O({configFiles:m(l),fileTypes:m(c),fileCount:z.count,maxFilesReached:z.maxReached,launchConfigFiles:ie})});return u.set(n,R),R}e.collectWorkspaceStats=h;function m(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function d(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=d;async function C(t){try{const r=new Map,n=(0,D.join)(t,".vscode","launch.json"),i=await T.Promises.readFile(n),o=[],c=(0,a.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,a.getNodeType)(c)==="object"&&c.configurations)for(const l of c.configurations){const s=l.type;s&&(r.has(s)?r.set(s,r.get(s)+1):r.set(s,1))}return m(r)}catch{return[]}}e.collectLaunchConfigs=C;let k=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||n.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,S.listProcesses)(r.mainPID),this.k(r)]).then(async i=>{let[o,c]=i,l=this.m(r,o);return n.forEach(s=>{if((0,v.isRemoteDiagnosticError)(s))l+=`
${s.errorMessage}`,c+=`
${s.errorMessage}`;else if(l+=`

Remote: ${s.hostName}`,s.processes&&(l+=`
${this.m(r,s.processes)}`),s.workspaceMetadata){c+=`
|  Remote: ${s.hostName}`;for(const g of Object.keys(s.workspaceMetadata)){const R=s.workspaceMetadata[g];let O=`${R.fileCount} files`;R.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${g}): ${O}`,c+=this.h(R)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(r,n){const{memory:i,vmHint:o,os:c,cpus:l}=d(),s={os:c,memory:i,cpus:l,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return P.isWindows||(s.load=`${E.loadavg().map(g=>Math.round(g)).join(", ")}`),P.isLinux&&(s.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(s)}async getDiagnostics(r,n){const i=[];return(0,S.listProcesses)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),n.forEach(c=>{if((0,v.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(r,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const s=c.workspaceMetadata[l];let g=`${s.fileCount} files`;s.maxFilesReached&&(g=`more than ${g}`),i.push(`Folder (${l}): ${g}`),i.push(this.h(s))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const n=[];let o=0;const c=(R,O)=>{const z=` ${R}(${O})`;o+z.length>60?(n.push(l),l="|                 ",o=l.length):o+=z.length,l+=z};let l="|      File types:";const s=10,g=r.fileTypes.length>s?s:r.fileTypes.length;for(let R=0;R<g;R++){const O=r.fileTypes[R];c(O.name,O.count)}if(n.push(l),r.configFiles.length>=0&&(l="|      Conf files:",o=0,r.configFiles.forEach(R=>{c(R.name,R.count)}),n.push(l)),r.launchConfigFiles.length>0){let R="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{R+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(R)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const n=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const l=w.URI.revive(c);if(l.scheme===I.Schemas.file){const s=l.fsPath;i.push(h(s,["node_modules",".git"]).then(g=>{let R=`${g.fileCount} files`;g.maxFilesReached&&(R=`more than ${R}`),n.push(`|    Folder (${(0,D.basename)(s)}): ${R}`),n.push(this.h(g))}).catch(g=>{n.push(`|      Error: Unable to collect workspace stats for folder ${s} (${g.toString()})`)}))}else n.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,n){const i=new Map;r.windows.forEach(c=>i.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,i,o,n,0),o.join(`
`)}n(r,n,i,o,c){const l=c===0;let s;l?s=o.pid===r?`${this.d.applicationName} main`:"remote agent":(s=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(s=`${s} (${n.get(o.pid)})`));const g=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(g/b.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${s}`),Array.isArray(o.children)&&o.children.forEach(R=>this.n(r,n,i,R,c+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:i}of r.folders){const o=w.URI.revive(i);if(o.scheme!==I.Schemas.file)continue;const c=o.fsPath;try{(await h(c,["node_modules",".git"])).fileTypes.forEach(s=>n.add(s.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const i=w.URI.revive(n);if(i.scheme!==I.Schemas.file)continue;const o=i.fsPath;try{const c=await h(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(l=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};k=Le([Re(0,p.ITelemetryService),Re(1,f.IProductService)],k),e.DiagnosticsService=k}),define(ve[40],Ee([1,0,23,8,6,24,66,114,30]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class y{constructor(l){this.value=l}}e.TelemetryTrustedValue=y;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,s){return Promise.resolve(void 0)}publicLog2(l,s){return this.publicLog(l,s)}publicLogError(l,s){return Promise.resolve(void 0)}publicLogError2(l,s){return this.publicLogError(l,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class S{async publicLog(l,s,g){}async publicLogError(l,s,g){}}e.NullEndpointTelemetryService=S,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(c,l){return a.Event.debounce(l.onDidChangeConfiguration,(g,R)=>{const O=g?new Set([...g.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:O}},1e3,!0)(g=>{g.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(g.source),configurationKeys:C(g.affectedKeys)})})}e.configurationTelemetry=v;function b(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=b;function f(c,l){return!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=f;function p(c){const l=c.getValue(w.TELEMETRY_SETTING_ID),s=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function u(c){const l={},s={},g={};d(c,g);for(let R in g){R=R.length>150?R.substr(R.length-149):R;const O=g[R];typeof O=="number"?s[R]=O:typeof O=="boolean"?s[R]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${O.length}`),l[R]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(l[R]=O)}return{properties:l,measurements:s}}e.validateTelemetryData=u;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(c){if(!c)return"none";const l=(0,D.getRemoteName)(c);return h.has(l)?l:"other"}e.cleanRemoteAuthority=m;function d(c,l,s=0,g){if(!!c)for(const R of Object.getOwnPropertyNames(c)){const O=c[R],z=g?g+R:R;Array.isArray(O)?l[z]=(0,E.safeStringify)(O):O instanceof Date?l[z]=O.toISOString():(0,A.isObject)(O)?s<2?d(O,l,s+1,z+"."):l[z]=(0,E.safeStringify)(O):l[z]=O}}function C(c){if(!c)return[];const l=[];return k(l,"",c),l}function k(c,l,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(g=>k(c,l?`${l}.${g}`:g,s[g])):c.push(l)}function t(c,l){const s=c.msftInternalDomains||[],g=l.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(s)||g}e.isInternalTelemetry=t;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function n(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let s=c;const g=[];for(const ie of l)for(;;){const ee=ie.exec(c);if(!ee)break;g.push([ee.index,ie.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let z=0;for(s="";;){const ie=O.exec(c);if(!ie)break;const ee=g.some(([F,Z])=>ie.index<Z&&F<O.lastIndex);!R.test(ie[0])&&!ee&&(s+=c.substring(z,ie.index)+"<REDACTED: user-file-path>",z=O.lastIndex)}return z<c.length&&(s+=c.substr(z)),s}function i(c){if(!c)return c;const l=c.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of s)if(g.regex.test(l))return`<REDACTED: ${g.label}>`;return c}function o(c,l){return(0,E.cloneAndChange)(c,s=>{if(s instanceof y)return s.value;if(typeof s=="string"){let g=s.replaceAll("%20"," ");g=n(g,l);for(const R of l)g=g.replace(R,"");return g=i(g),g}})}e.cleanData=o}),define(ve[35],Ee([1,0,16,32,33,3,4,9,28,40]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,E.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=T;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,c)}static parse(i){const o=S.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const i=b.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=f;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function u(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function h(n,i){return u(p(n,i))}e.getGalleryExtensionId=h;function m(n,i){const o=[],c=l=>{for(const s of o)if(s.some(g=>T(i(g),i(l))))return s;return null};for(const l of n){const s=c(l);s?s.push(l):o.push([l])}return o}e.groupByExtension=m;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function C(n){return{id:new y.TelemetryTrustedValue(n.identifier.id),name:new y.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new a.ExtensionIdentifier("pprice.better-merge");function k(n,i){const o=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const l=c.shift();if(l&&o.every(s=>!T(s.identifier,{id:l}))){const s=n.filter(g=>T(g.identifier,{id:l}));s.length===1&&(o.push(s[0]),c.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=k;async function t(n,i){if(!I.isLinux)return!1;let o;try{o=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function r(n,i){const o=await t(n,i),c=(0,A.getTargetPlatform)(o?"alpine":I.platform,w.arch);return i.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(ve[115],Ee([1,0,19,9,13,20,50,4,173,32,35,33]),function(ae,e,E,A,a,I,D,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const v=u=>(0,w.localize)(0,null,u),b=(0,w.localize)(1,null,"ms-dotnettools.csharp");function f(u,h){return h?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let p=class{constructor(h,m){this.a=h,this.b=m}get d(){}async listExtensions(h,m,d,C=console){let k=await this.a.getInstalled(1,d);const t=S.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(m&&m!==""){if(t.indexOf(m.toLowerCase())<0){C.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}k=k.filter(n=>n.manifest.categories?n.manifest.categories.map(o=>o.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){C.log("Possible Categories: "),t.forEach(n=>{C.log(n)});return}this.d&&C.log((0,w.localize)(2,null,this.d)),k=k.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let r;for(const n of k)r!==n.identifier.id&&(r=n.identifier.id,C.log(f(n.manifest,h)))}async installExtensions(h,m,d,C,k=console){const t=[],r=[];h.length&&k.log(this.d?(0,w.localize)(3,null,this.d):(0,w.localize)(4,null));const n=await this.a.getInstalled(1,d.profileLocation),i=(s,g)=>{const R=n.find(O=>(0,T.areSameExtensions)(O.identifier,{id:s}));if(R){if(!C&&(!g||g==="prerelease"&&R.preRelease))return k.log((0,w.localize)(5,null,s,R.manifest.version,s)),!1;if(g&&R.manifest.version===g)return k.log((0,w.localize)(6,null,`${s}@${g}`)),!1}return!0},o=(s,g,R)=>{l.push({id:s,version:g!=="prerelease"?g:void 0,installOptions:{...d,isBuiltin:R,installPreReleaseVersion:g==="prerelease"||d.installPreReleaseVersion}})},c=[],l=[];for(const s of h)if(s instanceof P.URI)c.push(s);else{const[g,R]=(0,T.getIdAndVersion)(s);i(g,R)&&o(g,R,!1)}for(const s of m){const[g,R]=(0,T.getIdAndVersion)(s);i(g,R)&&o(g,R,!0)}if(c.length&&await Promise.all(c.map(async s=>{try{const g=await this.f(s,{...d,isBuiltin:!1},C,k);g&&r.push(g)}catch(g){k.error(g.message||g.stack||g),t.push(s.toString())}})),l.length){const s=await this.g(l);await Promise.all(l.map(async g=>{const R=s.get(g.id.toLowerCase());if(R)try{const O=await this.h(g,R,n,C,k);O&&r.push(O)}catch(O){k.error(O.message||O.stack||O),t.push(g.id)}else k.error(`${v(g.version?`${g.id}@${g.version}`:g.id)}
${b}`),t.push(g.id)}))}if(t.length)throw new Error((0,w.localize)(7,null,t.join(", ")))}async f(h,m,d,C){const k=await this.a.getManifest(h);if(!k)throw new Error("Invalid vsix");if(await this.k(k,d,m.profileLocation,C))try{return await this.a.install(h,m),C.log((0,w.localize)(8,null,(0,I.basename)(h))),k}catch(r){if((0,A.isCancellationError)(r))return C.log((0,w.localize)(9,null,(0,I.basename)(h))),null;throw r}return null}async g(h){const m=new Map,d=h.some(k=>k.installOptions.installPreReleaseVersion),C=await this.b.getExtensions(h.map(k=>({...k,preRelease:d})),E.CancellationToken.None);for(const k of C)m.set(k.identifier.id.toLowerCase(),k);return m}async h({id:h,version:m,installOptions:d},C,k,t,r){const n=await this.b.getManifest(C,E.CancellationToken.None);if(n&&!this.j(n,r))return null;const i=k.find(o=>(0,T.areSameExtensions)(o.identifier,C.identifier));if(i){if(C.version===i.manifest.version)return r.log((0,w.localize)(10,null,m?`${h}@${m}`:h)),null;r.log((0,w.localize)(11,null,h,C.version))}try{d.isBuiltin?r.log(m?(0,w.localize)(12,null,h,m):(0,w.localize)(13,null,h)):r.log(m?(0,w.localize)(14,null,h,m):(0,w.localize)(15,null,h));const o=await this.a.installFromGallery(C,{...d,installGivenVersion:!!m});return r.log((0,w.localize)(16,null,h,o.manifest.version)),n}catch(o){if((0,A.isCancellationError)(o))return r.log((0,w.localize)(17,null,h)),null;throw o}}j(h,m){return!0}async k(h,m,d,C){const k={id:(0,T.getGalleryExtensionId)(h.publisher,h.name)},r=(await this.a.getInstalled(1,d)).find(n=>(0,T.areSameExtensions)(k,n.identifier)&&(0,D.gt)(n.manifest.version,h.version));return r&&!m?(C.log((0,w.localize)(18,null,r.identifier.id,r.manifest.version,h.version)),!1):this.j(h,C)}async uninstallExtensions(h,m,d,C=console){const k=async r=>{if(r instanceof P.URI){const n=await this.a.getManifest(r);return f(n)}return r},t=[];for(const r of h){const n=await k(r),o=(await this.a.getInstalled(void 0,d)).filter(c=>(0,T.areSameExtensions)(c.identifier,{id:n}));if(!o.length)throw new Error(`${this.l(n)}
${b}`);if(o.some(c=>c.type===0)){C.log((0,w.localize)(19,null,n));return}if(!m&&o.some(c=>c.isBuiltin)){C.log((0,w.localize)(20,null,n));return}C.log((0,w.localize)(21,null,n));for(const c of o)await this.a.uninstall(c,{profileLocation:d}),t.push(c);this.d?C.log((0,w.localize)(22,null,n,this.d)):C.log((0,w.localize)(23,null,n))}}async locateExtension(h,m=console){const d=await this.a.getInstalled();h.forEach(C=>{d.forEach(k=>{if(k.identifier.id===C&&k.location.scheme===a.Schemas.file){m.log(k.location.fsPath);return}})})}l(h){return this.d?(0,w.localize)(24,null,h,this.d):(0,w.localize)(25,null,h)}};p=Le([Re(0,y.IExtensionManagementService),Re(1,y.IExtensionGalleryService)],p),e.ExtensionManagementCLI=p}),define(ve[232],Ee([1,0,14,9,2,13,3,20,50,8,21,22,24,25,32,35,76,17,12]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Pn extends a.Disposable{constructor(k,t,r,n,i,o){super(),this.h=t,this.i=r,this.j=n,this.k=i,this.l=o,this.extensionsDownloadDir=k.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(k,t){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,this.v(k));try{await this.r(k,r,i=>this.i.download(k,i,t))}catch(i){throw new f.ExtensionManagementError(i.message,f.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.m(k)){const i=await this.n(k);try{await this.k.verify(r.fsPath,i.fsPath)&&(n="Verified"),this.l.info(`Extension signature verification: ${k.identifier.id}. Verification status: ${n}.`)}catch(o){const c=o,l=c.code;if(l==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${k.identifier.id}. Verification status: ${n}.`);else if(!c.didExecute)this.l.warn(`Extension signature verification: ${k.identifier.id}. Verification status: ${n} (${l})`);else throw await this.delete(i),await this.delete(r),new f.ExtensionManagementError(l,f.ExtensionManagementErrorCode.Signature)}}return{location:r,verificationStatus:n}}async m(k){if(!k.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,y.isBoolean)(t)?t:!0}async n(k){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,`${this.v(k)}${Pn.c}`);return await this.r(k,t,r=>this.i.downloadSignatureArchive(k,r)),t}async r(k,t,r){if(await this.h.exists(t))return;if(t.scheme!==I.Schemas.file){await r(t);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);await this.h.exists(n)||await r(n);try{await this.t(n,t,Date.now()+2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",k.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,A.getErrorMessage)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(k){await this.g,await this.h.del(k)}async t(k,t,r){try{await S.Promises.rename(k.fsPath,t.fsPath)}catch(n){if(D.isWindows&&n&&n.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${k} to ${t} with 'EPERM' error. Trying again...`),this.t(k,t,r);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const k=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(k.children){const t=[],r=[],n=[];for(const c of k.children)if(c.name.endsWith(Pn.c))n.push(c.resource);else{const l=p.ExtensionKey.parse(c.name);l&&r.push([l,c])}const i=(0,p.groupByExtension)(r,([c])=>c),o=[];for(const c of i)c.sort((l,s)=>w.rcompare(l[0].version,s[0].version)),t.push(...c.slice(1).map(l=>l[1].resource)),o.push(c[0][1]);o.sort((c,l)=>c.mtime-l.mtime),t.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),t.push(...n),await E.Promises.settled(t.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(k){this.l.error(k)}}v(k){return this.f?p.ExtensionKey.create(k).toString().toLowerCase():(0,T.generateUuid)()}};d.c=".sigzip",d=Le([Re(0,b.INativeEnvironmentService),Re(1,h.IFileService),Re(2,f.IExtensionGalleryService),Re(3,v.IConfigurationService),Re(4,u.IExtensionSignatureVerificationService),Re(5,m.ILogService)],d),e.ExtensionsDownloader=d}),define(ve[233],Ee([1,0,6,2,27,35,33]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends A.Disposable{constructor(y,T,S,v,b,f,p){super(),this.f=y,this.g=T,this.h=S,this.i=v,this.j=b,this.k=f,this.l=p,this.a=this.B(new E.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.DisposableMap),this.m().then(null,u=>p.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(y=>this.p(y.added,y.removed))),this.B(this.i.onAddExtensions(y=>this.r(y))),this.B(this.i.onDidAddExtensions(y=>this.s(y))),this.B(this.i.onRemoveExtensions(y=>this.t(y))),this.B(this.i.onDidRemoveExtensions(y=>this.u(y))),this.B(this.k.onDidFilesChange(y=>this.v(y)))}async p(y,T){try{await Promise.all(T.map(S=>(this.c.deleteAndDispose(S.id),this.z(S.extensionsResource)))),y.length&&await Promise.all(y.map(S=>(this.c.set(S.id,(0,A.combinedDisposable)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.y(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async r(y){for(const T of y.extensions)this.D(this.G(T.identifier,T.version),y.profileLocation)}async s(y){for(const T of y.extensions){const S=this.G(T.identifier,T.version);y.error?this.F(S,y.profileLocation):this.D(S,y.profileLocation)}}async t(y){for(const T of y.extensions)this.F(this.G(T.identifier,T.version),y.profileLocation)}async u(y){let T=!1;for(const S of y.extensions){const v=this.G(S.identifier,S.version);y.error?this.D(v,y.profileLocation):(this.F(v,y.profileLocation),T=T||!this.b.has(v))}T&&await this.C()}v(y){for(const T of this.h.profiles)y.contains(T.extensionsResource,0,1)&&this.w(T.extensionsResource)}async w(y){const T=[],S=[],v=await this.i.scanProfileExtensions(y),b=new Set,f=new Set;for(const[p,u]of this.b)u.has(y)&&f.add(p);for(const p of v){const u=this.G(p.identifier,p.version);b.add(u),f.has(u)||(T.push(p.identifier),this.D(u,y))}for(const p of f)if(!b.has(p)){const u=this.H(p);u&&(S.push(u.identifier),this.F(p,y))}(T.length||S.length)&&this.a.fire({added:T.length?{extensions:T,profileLocation:y}:void 0,removed:S.length?{extensions:S,profileLocation:y}:void 0})}async y(y){const T=await this.i.scanProfileExtensions(y);for(const S of T)this.D(this.G(S.identifier,S.version),y)}async z(y){for(const T of[...this.b.keys()])this.F(T,y);await this.C()}async C(){const T=(await this.f.getAllUserInstalled()).filter(S=>S.installedTimestamp&&!this.b.has(this.G(S.identifier,S.manifest.version)));T.length&&await this.f.markAsUninstalled(...T)}D(y,T){let S=this.b.get(y);S||this.b.set(y,S=new a.ResourceSet(v=>this.j.extUri.getComparisonKey(v))),S.add(T)}F(y,T){const S=this.b.get(y);S&&S.delete(T),S?.size||this.b.delete(y)}G(y,T){return`${D.ExtensionIdentifier.toKey(y.id)}@${T}`}H(y){const[T,S]=(0,I.getIdAndVersion)(y);return S?{identifier:{id:T},version:S}:void 0}}e.ExtensionsWatcher=P}),define(ve[234],Ee([1,0,204,40]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function a(I,D,P,w,y,T,S){const v={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${D.nameShort})`};if((0,A.supportsTelemetry)(D,P)&&(0,A.getTelemetryLevel)(w)===3){const b=await(0,E.getServiceMachineId)(P,y,T),{machineId:f}=await S.getTelemetryInfo();v["X-Market-User-Id"]=b,v["VSCode-SessionId"]=f||b}return v}e.resolveMarketplaceHeaders=a}),define(ve[116],Ee([1,0,117,18,14,2,13,7,22,25,32,35,12,78,3,4]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends b.LanguagePackBaseService{constructor(C,k,t,r){super(t),this.h=C,this.i=r,this.g=this.B(new h(k,r)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(C){const t=(await this.g.getLanguagePacks())[f.Language.value()];if(!t){this.i.warn(`No language pack found for ${f.Language.value()}`);return}const r=t.translations[C];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const C=await this.g.getLanguagePacks(),k=Object.keys(C).map(t=>{const r=C[t];return{...this.f(t,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return k.push(this.f("en","English")),k.sort((t,r)=>t.label.localeCompare(r.label)),k}async j(C){C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",C.identifier.id),await this.update())}async k(C){const k=await this.g.getLanguagePacks();Object.keys(k).some(t=>k[t]&&k[t].extensions.some(r=>(0,S.areSameExtensions)(r.extensionIdentifier,C.identifier)))&&(this.i.info("Removing language packs from the extension",C.identifier.id),await this.update())}async update(){const[C,k]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(k);return!(0,A.equals)(Object.keys(C),Object.keys(t))}};u=Le([Re(0,T.IExtensionManagementService),Re(1,y.INativeEnvironmentService),Re(2,T.IExtensionGalleryService),Re(3,v.ILogService)],u),e.NativeLanguagePackService=u;let h=class extends I.Disposable{constructor(C,k){super(),this.i=k,this.c={},this.f=(0,P.join)(C.userDataPath,"languagepacks.json"),this.g=new a.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(C){return this.m(k=>{Object.keys(k).forEach(t=>delete k[t]),this.j(k,...C)}).then(()=>this.c)}j(C,...k){for(const t of k)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(C,t);Object.keys(C).forEach(t=>this.l(C[t]))}k(C,k){const t=k.identifier,r=k.manifest.contributes&&k.manifest.contributes.localizations?k.manifest.contributes.localizations:[];for(const n of r)if(k.location.scheme===D.Schemas.file&&m(n)){let i=C[n.languageId];i||(i={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},C[n.languageId]=i);const o=i.extensions.filter(c=>(0,S.areSameExtensions)(c.extensionIdentifier,t))[0];o?o.version=k.manifest.version:i.extensions.push({extensionIdentifier:t,version:k.manifest.version});for(const c of n.translations)i.translations[c.id]=(0,P.join)(k.location.fsPath,c.path)}}l(C){if(C){const k=(0,E.createHash)("md5");for(const t of C.extensions)k.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);C.hash=k.digest("hex")}}m(C=()=>null){return this.g.queue(()=>{let k=null;return w.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(k=C(t),t)).then(t=>{for(const n of Object.keys(t))t[n]||delete t[n];this.c=t,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),w.Promises.writeFile(this.f,r)}).then(()=>k,t=>this.i.error(t))})}};h=Le([Re(0,y.INativeEnvironmentService),Re(1,v.ILogService)],h);function m(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const C of d.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ve[235],Ee([1,0,9,23,40]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function P(y,T,S){const v=await new Promise((h,m)=>{ae(["@microsoft/1ds-core-js"],h,m)}),b=await new Promise((h,m)=>{ae(["@microsoft/1ds-post-js"],h,m)}),f=new v.AppInsightsCore,p=new b.PostChannel,u={instrumentationKey:y,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(S){u.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:S};u.extensionConfig[p.identifier]=h}return f.initialize(u,[]),f.addTelemetryInitializer(h=>{T&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),f}class w{constructor(T,S,v,b,f){this.e=T,this.f=S,this.g=v,this.h=f,this.c=I,this.d=D,this.g||(this.g={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}i(T){if(!!this.a){if(typeof this.a!="string"){T(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(S=>{T(S)},S=>{(0,E.onUnexpectedError)(S),console.error(S)})}}log(T,S){if(!this.a)return;S=(0,A.mixin)(S,this.g),S=(0,a.validateTelemetryData)(S);const v=this.f+"/"+T;try{this.i(b=>{b.pluginVersionString=S?.properties.version??"Unknown",b.track({name:v,baseData:{name:v,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(T=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,T(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=w}),define(ve[236],Ee([1,0,2,23,3,16,187,24,52,51,26,39,30,40]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(h,m,d){this.k=m,this.l=d,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const C of this.f)this.j.push(new RegExp((0,I.escapeRegExpCharacters)(C),"gi")),C.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.escapeRegExpCharacters)(C.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(C=>{(C.affectsConfiguration(v.TELEMETRY_SETTING_ID)||C.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||C.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,m){this.d[h]=m}m(){let h=(0,b.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const d=m.usage?3:m.error?2:0;h=Math.min(h,d)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,m=h.sessionID,d=h["common.machineId"],C=h["common.firstSessionDate"],k=h["common.msftInternal"];return{sessionId:m,machineId:d,firstSessionDate:C,msftInternal:k}}dispose(){this.i.dispose()}n(h,m,d){return this.g<m?Promise.resolve(void 0):this.c.then(C=>{d=(0,A.mixin)(d,this.d),d=(0,b.cleanData)(d,this.j),d=(0,A.mixin)(d,C),this.b.forEach(k=>k.log(h,d))},C=>{console.error(C)})}publicLog(h,m){return this.n(h,3,m)}publicLog2(h,m){return this.publicLog(h,m)}publicLogError(h,m){return this.h?this.n(h,2,m):Promise.resolve(void 0)}publicLogError2(h,m){return this.publicLogError(h,m)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=Le([Re(1,P.IConfigurationService),Re(2,T.IProductService)],f),e.TelemetryService=f;function p(){const u=(0,D.localize)(0,null,y.default.nameLong),h=y.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=a.isWeb?"":(0,D.localize)(3,null),d=(0,D.localize)(4,null),C=(0,D.localize)(5,null),k=(0,D.localize)(6,null),t=(0,D.localize)(7,null),r=`
|       | ${d} | ${C} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${u} ${h} ${m}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,D.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,D.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[237],Ee([1,0,24,5,26,30,236,40]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let w=class extends D.TelemetryService{constructor(T,S,v,b){super(T,v,b),this.o=S}publicLog(T,S){return this.o<3?Promise.resolve(void 0):super.publicLog(T,S)}publicLog2(T,S){return this.publicLog(T,S)}publicLogError(T,S){return this.o<2?Promise.resolve(void 0):super.publicLogError(T,S)}publicLogError2(T,S){return this.publicLogError(T,S)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,T):T,this.o===0&&this.dispose()}};w=Le([Re(2,E.IConfigurationService),Re(3,a.IProductService)],w),e.ServerTelemetryService=w,e.ServerNullTelemetryService=new class extends P.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,A.refineServiceDecorator)(I.ITelemetryService)}),define(ve[238],Ee([1,0,239,235]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class a extends A.AbstractOneDataSystemAppender{constructor(D,P,w,y){const T={sendPOST:(S,v)=>{const b={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const f=E.request(S.urlString,b,p=>{p.on("data",function(u){v(p.statusCode??200,p.headers,u.toString())}),p.on("error",function(u){v(0,{})})});f.write(S.data),f.end()}catch{v(0,{})}}};super(D,P,w,y,T)}}e.OneDataSystemAppender=a}),define(ve[240],Ee([1,0,9,229]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class a extends A.default{i(){(0,E.setUnexpectedErrorHandler)(P=>console.error(P));const D=[];process.on("unhandledRejection",(P,w)=>{D.push(w),setTimeout(()=>{const y=D.indexOf(w);y>=0&&w.catch(T=>{D.splice(y,1),(0,E.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),P&&(0,E.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const w=D.indexOf(P);w>=0&&D.splice(w,1)}),process.on("uncaughtException",P=>{(0,E.isSigPipeError)(P)||(0,E.onUnexpectedError)(P)})}}e.default=a}),define(ve[118],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(E=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[119],Ee([1,0,3,118]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class a{constructor(w){this.collections=w,this.map=new Map,w.forEach((y,T)=>{const S=y.map.entries();let v=S.next();for(;!v.done;){const b=v.value[0];let f=this.map.get(b);if(f||(f=[],this.map.set(b,f)),f.length>0&&f[0].type===A.EnvironmentVariableMutatorType.Replace){v=S.next();continue}const p=v.value[1];f.unshift({extensionIdentifier:T,value:p.value,type:p.type}),v=S.next()}})}async applyToProcessEnvironment(w,y){let T;E.isWindows&&(T={},Object.keys(w).forEach(S=>T[S.toLowerCase()]=S));for(const[S,v]of this.map){const b=E.isWindows&&T[S.toLowerCase()]||S;for(const f of v){const p=y?await y(f.value):f.value;switch(f.type){case A.EnvironmentVariableMutatorType.Append:w[b]=(w[b]||"")+p;break;case A.EnvironmentVariableMutatorType.Prepend:w[b]=p+(w[b]||"");break;case A.EnvironmentVariableMutatorType.Replace:w[b]=p;break}}}}diff(w){const y=new Map,T=new Map,S=new Map;if(w.map.forEach((v,b)=>{const f=this.map.get(b),p=I(v,f);p&&y.set(b,p)}),this.map.forEach((v,b)=>{const f=w.map.get(b),p=I(v,f);p&&S.set(b,p)}),this.map.forEach((v,b)=>{const f=w.map.get(b),p=D(v,f);p&&T.set(b,p)}),!(y.size===0&&T.size===0&&S.size===0))return{added:y,changed:T,removed:S}}}e.MergedEnvironmentVariableCollection=a;function I(P,w){if(!w)return P;const y=new Set;w.forEach(S=>y.add(S.extensionIdentifier));const T=[];return P.forEach(S=>{y.has(S.extensionIdentifier)||T.push(S)}),T.length===0?void 0:T}function D(P,w){if(!w)return;const y=new Map;w.forEach(S=>y.set(S.extensionIdentifier,S));const T=[];return P.forEach(S=>{const v=y.get(S.extensionIdentifier);v&&(S.type!==v.type||S.value!==v.value)&&T.push(v)}),T.length===0?void 0:T}}),define(ve[81],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=E;function A(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=A;function a(D){return Array.from(D.entries()).map(P=>[P[0],E(P[1].map)])}e.serializeEnvironmentVariableCollections=a;function I(D){return new Map(D.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=I}),define(ve[241],Ee([1,0,14,19,6,2,12]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends I.Disposable{constructor(y,T){super(),this.h=T,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new a.Emitter),this.onCreateRequest=this.g.event,this.b=y===void 0?15e3:y}createRequest(y){return new Promise((T,S)=>{const v=++this.a;this.c.set(v,T),this.g.fire({requestId:v,...y});const b=new A.CancellationTokenSource;(0,E.timeout)(this.b,b.token).then(()=>S(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,I.toDisposable)(()=>b.cancel())])})}acceptReply(y,T){const S=this.c.get(y);S?(this.c.delete(y),(0,I.dispose)(this.f.get(y)||[]),this.f.delete(y),S(T)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};P=Le([Re(1,D.ILogService)],P),e.RequestStore=P}),define(ve[120],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var A;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(A=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var a;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.SmoothScrolling="terminal.integrated.smoothScrolling"})(a=e.TerminalSettingId||(e.TerminalSettingId={}));var I;(function(d){d.FileName="ptyhost"})(I=e.TerminalLogConstants||(e.TerminalLogConstants={}));var D;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(D=e.PosixShellType||(e.PosixShellType={}));var P;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var w;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(w=e.TitleEventSource||(e.TitleEventSource={}));var y;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Logger="logger",d.Heartbeat="heartbeat"})(y=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,E.createDecorator)("ptyService");var T;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(d){d.TerminalView="view",d.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}));var h;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(h=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ve[242],Ee([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function A(D){let P=D;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const w=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(w,""),`'${P}'`}e.escapeNonWindowsPath=A;function a(D,P,w){if(!D)return"";if(!P)return D;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const y=D.replace(/\\/g,"/").toLowerCase(),T=P.replace(/\\/g,"/").toLowerCase();return y.includes(T)?`~${w}${D.slice(P.length+1)}`:D}e.collapseTildePath=a;function I(D){return D.match(/^['"].*['"]$/)&&(D=D.substring(1,D.length-1)),E.OS===1&&D&&D[1]===":"?D[0].toUpperCase()+D.substring(1):D}e.sanitizeCwd=I}),define(ve[243],Ee([1,0,45,4,189,92]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(v,b){const f=[{name:null,description:(0,a.localize)(0,null)}];return f.push(...v.map(p=>({name:p.profileName,description:P(p)}))),b&&f.push(...b.map(p=>({name:p.title,description:w(p)}))),{values:f.map(p=>p.name),markdownDescriptions:f.map(p=>p.description)}}e.createProfileSchemaEnums=D;function P(v){let b=`$(${I.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?b+=`
- args: "${v.args}"`:b+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(b+=`
- overrideName: ${v.overrideName}`),v.color&&(b+=`
- color: ${v.color}`),v.env&&(b+=`
- env: ${JSON.stringify(v.env)}`),b}function w(v){return`$(${I.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function y(v,b){if(!v&&!b)return!0;if(typeof v=="string"&&typeof b=="string")return v===b;if(Array.isArray(v)&&Array.isArray(b)){if(v.length!==b.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==b[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function T(v,b){if(!v&&!b)return!0;if(!v||!b)return!1;if(I.ThemeIcon.isThemeIcon(v)&&I.ThemeIcon.isThemeIcon(b))return v.id===b.id&&v.color===b.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof b=="object"&&"light"in b&&"dark"in b){const f=v,p=b;if((A.URI.isUri(f.light)||S(f.light))&&(A.URI.isUri(f.dark)||S(f.dark))&&(A.URI.isUri(p.light)||S(p.light))&&(A.URI.isUri(p.dark)||S(p.dark)))return f.light.path===p.light.path&&f.dark.path===p.dark.path}if(A.URI.isUri(v)&&A.URI.isUri(b)||S(v)||S(b)){const f=v,p=b;return f.path===p.path&&f.scheme===p.scheme}return!1}e.terminalIconsEqual=T;function S(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=S}),define(ve[244],Ee([1,0,45,188,52,39,243]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,E.getAllCodicons)(),C=>C.id),markdownEnumDescriptions:Array.from((0,E.getAllCodicons)(),C=>`$(${C.id})`)};const P={args:{description:(0,A.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,A.localize)(1,null),type:"boolean"},icon:{description:(0,A.localize)(2,null),...e.terminalIconSchema},color:{description:(0,A.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,A.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},y={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(6,null),type:["string"],items:{type:"string"}},...P}},T=(0,A.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,A.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,A.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),b=(0,A.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,A.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,A.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),u={id:"terminal",order:100,title:(0,A.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,A.localize)(26,null)}},{type:"string",markdownDescription:(0,A.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,A.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(30,null),type:"string"},id:{description:(0,A.localize)(31,null),type:"string"},title:{description:(0,A.localize)(32,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(34,null),type:"string"},id:{description:(0,A.localize)(35,null),type:"string"},title:{description:(0,A.localize)(36,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(38,null),type:"string"},id:{description:(0,A.localize)(39,null),type:"string"},title:{description:(0,A.localize)(40,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,A.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,A.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,A.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,A.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,A.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){I.Registry.as(a.Extensions.Configuration).registerConfiguration(u),d()}e.registerTerminalPlatformConfiguration=h;let m;function d(C,k){const t=I.Registry.as(a.Extensions.Configuration);let r;C&&(r=(0,D.createProfileSchemaEnums)(C?.profiles,k));const n=m;m={id:"terminal",order:100,title:(0,A.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:C?.os===3?r?.values:void 0,markdownEnumDescriptions:C?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:C?.os===2?r?.values:void 0,markdownEnumDescriptions:C?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:C?.os===1?r?.values:void 0,markdownEnumDescriptions:C?.os===1?r?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[m],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(ve[245],Ee([1,0,29,13,23,7,3,28,16,8,22,118,81,119]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function f(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let o=0;return i&&i.length===4&&(o=parseInt(i[3])),o}e.getWindowsBuildNumber=f;async function p(i,o,c,l=P.env,s=T.Promises.exists){if(I.isAbsolute(i))return await s(i)?i:void 0;if(o===void 0&&(o=P.cwd()),I.dirname(i)!=="."){const z=I.join(o,i);return await s(z)?z:void 0}const R=(0,a.getCaseInsensitive)(l,"PATH");if(c===void 0&&(0,y.isString)(R)&&(c=R.split(I.delimiter)),c===void 0||c.length===0){const z=I.join(o,i);return await s(z)?z:void 0}for(const z of c){let ie;if(I.isAbsolute(z)?ie=I.join(z,i):ie=I.join(o,z,i),await s(ie))return ie;if(D.isWindows){let ee=ie+".com";if(await s(ee)||(ee=ie+".exe",await s(ee)))return ee}}const O=I.join(o,i);return await s(O)?O:void 0}e.findExecutable=p;function u(i,o,c,l,s){if(!o.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D.isWindows&&!o.windowsEnableConpty)return;const g=i.args,R=P.platform==="win32"?I.basename(i.executable).toLowerCase():I.basename(i.executable),O=I.dirname(A.FileAccess.asFileUri("").fsPath);let z;const ie={VSCODE_INJECTION:"1"};if(D.isWindows){if(R==="pwsh.exe"||R==="powershell.exe")return!g||r(g)?z=d.get(m.WindowsPwsh):t(g)&&(z=d.get(m.WindowsPwshLogin)),z?(z=[...z],z[z.length-1]=(0,w.format)(z[z.length-1],O,""),o.shellIntegration.suggestEnabled&&(ie.VSCODE_SUGGEST="1"),{newArgs:z,envMixin:ie}):void 0;l.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(R){case"bash":return!g||g.length===0?z=d.get(m.Bash):n(g)&&(ie.VSCODE_SHELL_LOGIN="1",h(o,ie),z=d.get(m.Bash)),z?(z=[...z],z[z.length-1]=(0,w.format)(z[z.length-1],O),{newArgs:z,envMixin:ie}):void 0;case"fish":{const ee=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",F=I.join(O,"out/vs/workbench/contrib/xdg_data");return ie.XDG_DATA_DIRS=`${ee}:${F}`,h(o,ie),{newArgs:void 0,envMixin:ie}}case"pwsh":return!g||r(g)?z=d.get(m.Pwsh):t(g)&&(z=d.get(m.PwshLogin)),z?(o.shellIntegration.suggestEnabled&&(ie.VSCODE_SUGGEST="1"),z=[...z],z[z.length-1]=(0,w.format)(z[z.length-1],O,""),{newArgs:z,envMixin:ie}):void 0;case"zsh":{if(!g||g.length===0?z=d.get(m.Zsh):n(g)?(z=d.get(m.ZshLogin),h(o,ie)):(g===d.get(m.Zsh)||g===d.get(m.ZshLogin))&&(z=g),!z)return;z=[...z],z[z.length-1]=(0,w.format)(z[z.length-1],O);let ee;try{ee=E.userInfo().username}catch{ee="unknown"}const F=I.join(E.tmpdir(),`${ee}-${s.applicationName}-zsh`);ie.ZDOTDIR=F;const Z=c?.ZDOTDIR??E.homedir()??"~";ie.USER_ZDOTDIR=Z;const $=[];return $.push({source:I.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.join(F,".zshrc")}),$.push({source:I.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.join(F,".zprofile")}),$.push({source:I.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.join(F,".zshenv")}),$.push({source:I.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.join(F,".zlogin")}),{newArgs:z,envMixin:ie,filesToCopy:$}}}l.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=u;function h(i,o){if(D.isMacintosh&&i.environmentVariableCollections){const c=(0,v.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),s=new b.MergedEnvironmentVariableCollection(c).map.get("PATH"),g=[];if(s)for(const R of s)R.type===S.EnvironmentVariableMutatorType.Prepend&&g.push(R.value);g.length>0&&(o.VSCODE_PATH_PREFIX=g.join(""))}}var m;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(m||(m={}));const d=new Map;d.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(m.Zsh,["-i"]),d.set(m.ZshLogin,["-il"]),d.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const C=["-login","-l"],k=["-nol","-nologo"];function t(i){return typeof i=="string"?C.includes(i.toLowerCase()):i.length===1&&C.includes(i[0].toLowerCase())||i.length===2&&(C.includes(i[0].toLowerCase())||C.includes(i[1].toLowerCase()))&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))}function r(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===0||i?.length===1&&k.includes(i[0].toLowerCase())}function n(i){return i==="string"&&C.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&C.includes(i[0].toLowerCase())}}),define(ve[246],Ee([1,0,48,45,7,3,8,22,97,245]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,S=!0;function v(r,n,i,o,c=process.env,l,s,g,R){return l=l||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},I.isWindows?b(i,l,c,s,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:o.getValue("terminal.integrated.defaultProfile.windows"),R,g):C(l,s,i,r&&typeof r=="object"?{...r}:o.getValue(I.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:o.getValue(I.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,g,c)}e.detectAvailableProfiles=v;async function b(r,n,i,o,c,l,s,g,R){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),z=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let ie=!1;(0,y.getWindowsBuildNumber)()>=16299&&(ie=!0),await u(g);const ee=new Map;if(r){ee.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${z}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${z}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.Codicon.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${z}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}k(l,ee);const F=await f(ee.entries(),s,n,i,o,R);if(r||c)try{const Z=await m(`${z}\\${ie?"wsl":"bash"}.exe`,s);for(const $ of Z)(!l||!($.profileName in l))&&F.push($)}catch{S&&(o?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return F}async function f(r,n,i,o=process.env,c,l){const s=[];for(const[g,R]of r){if(R===null)continue;let O,z,ie;if("source"in R){const $=T?.get(R.source);if(!$)continue;O=$.paths,z=R.args||$.args,R.icon?ie=p(R.icon):$.icon&&(ie=$.icon)}else O=Array.isArray(R.path)?R.path:[R.path],z=I.isWindows||Array.isArray(R.args)?R.args:void 0,ie=p(R.icon);let ee;if(l){const $=O.map(le=>typeof le=="string"?le:le.path),x=await l($);ee=new Array(O.length);for(let le=0;le<O.length;le++)typeof O[le]=="string"?ee[le]=x[le]:ee[le]={path:x[le],isUnsafe:!0}}else ee=O.slice();let F;if(R.requiresPath){let $;if((0,D.isString)(R.requiresPath)?$=R.requiresPath:($=R.requiresPath.path,R.requiresPath.isUnsafe&&(F=$)),!await i.existsFile($))continue}const Z=await t(g,n,ee,i,o,z,R.env,R.overrideName,R.isAutoDetected,F);Z?(Z.isAutoDetected=R.isAutoDetected,Z.icon=ie,Z.color=R.color,s.push(Z)):c?.debug("Terminal profile not validated",g,O)}return c?.debug("Validated terminal profiles",s),s}function p(r){return typeof r=="string"?{id:r}:r}async function u(r){T&&!r||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),T.set("PowerShell",{profileName:"PowerShell",paths:r||await h(),icon:A.Codicon.terminalPowershell}))}async function h(){const r=[];for await(const n of(0,w.enumeratePowerShellInstallations)())r.push(n.exePath);return r}async function m(r,n){const i=[],o=await new Promise((s,g)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,O)=>{if(R)return g("Problem occurred when getting wsl distros");s(O)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),l=o.split(c).filter(s=>s.trim().length>0&&s!=="");for(const s of l){if(s===""||s.startsWith("docker-desktop"))continue;const g=`${s} (WSL)`,R={profileName:g,path:r,args:["-d",`${s}`],isDefault:g===n,icon:d(s),isAutoDetected:!1};i.push(R)}return i}function d(r){return r.includes("Ubuntu")?A.Codicon.terminalUbuntu:r.includes("Debian")?A.Codicon.terminalDebian:A.Codicon.terminalLinux}async function C(r,n,i,o,c,l,s,g){const R=new Map;if(i){const O=(await r.readFile("/etc/shells")).toString(),z=l||O.split(`
`).filter(ee=>ee.trim().includes("#")&&ee.trim().length>0),ie=new Map;for(const ee of z){let F=(0,a.basename)(ee),Z=ie.get(F)||0;Z++,Z>1&&(F=`${F} (${Z})`),ie.set(F,Z),R.set(F,{path:ee,isAutoDetected:!0})}}return k(o,R),await f(R.entries(),c,r,g,n,s)}function k(r,n){if(!!r)for(const[i,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?n.delete(i):(o.icon=o.icon||n.get(i)?.icon,n.set(i,o))}async function t(r,n,i,o,c,l,s,g,R,O){if(i.length===0)return Promise.resolve(void 0);const z=i.shift();if(z==="")return t(r,n,i,o,c,l,s,g,R);const ie=typeof z!="string"&&z.isUnsafe,ee=typeof z=="string"?z:z.path,F={profileName:r,path:ee,args:l,env:s,overrideName:g,isAutoDetected:R,isDefault:r===n,isUnsafePath:ie,requiresUnsafePath:O};if((0,a.basename)(ee)===ee){const $=c.PATH?c.PATH.split(a.delimiter):void 0,x=await(0,y.findExecutable)(ee,void 0,$,void 0,o.existsFile);return x?(F.path=x,F.isFromPath=!0,F):t(r,n,i,o,c,l)}return await o.existsFile((0,a.normalize)(ee))?F:t(r,n,i,o,c,l,s,g,R)}}),define(ve[247],Ee([1,0,6,2,13,3,42,101,24,25,103,80,12,241,120,244,246,108]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(k){k[k.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let d=0,C=class extends A.Disposable{constructor(t,r,n,i,o,c){super(),this.C=t,this.D=r,this.F=n,this.G=i,this.H=o,this.I=c,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new E.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new E.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new E.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new E.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new E.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new E.Emitter),this.onProcessData=this.s.event,this.t=this.B(new E.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new E.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new E.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new E.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new E.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new E.Emitter),this.onProcessExit=this.z.event,(0,p.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,A.toDisposable)(()=>this.O())),this.f=this.B(new b.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(I.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:d,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,T.parsePtyHostPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?t.debugBrk=r.port:!r.break&&r.port&&(t.debug=r.port));const n=new P.Client(a.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),D.ProxyChannel.toService(n.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(n.onDidProcessExit(c=>{this.l.fire(c.code),this.i||(this.g<=m.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))})),this.B(new h.RemoteLoggerChannelClient(this.I,n.getChannel(f.TerminalIpcChannels.Logger)));const o=D.ProxyChannel.toService(n.getChannel(f.TerminalIpcChannels.PtyHost));return this.B(o.onProcessData(c=>this.s.fire(c))),this.B(o.onProcessReady(c=>this.t.fire(c))),this.B(o.onProcessExit(c=>this.z.fire(c))),this.B(o.onDidChangeProperty(c=>this.y.fire(c))),this.B(o.onProcessReplay(c=>this.u.fire(c))),this.B(o.onProcessOrphanQuestion(c=>this.v.fire(c))),this.B(o.onDidRequestDetach(c=>this.w.fire(c))),[n,o]}dispose(){this.i=!0,super.dispose()}async createProcess(t,r,n,i,o,c,l,s,g,R,O){const z=setTimeout(()=>this.S(),f.HeartbeatConstants.CreateProcessTimeout),ie=await this.b.createProcess(t,r,n,i,o,c,l,s,g,R,O);return clearTimeout(z),d=Math.max(d,ie),ie}updateTitle(t,r,n){return this.b.updateTitle(t,r,n)}updateIcon(t,r,n,i){return this.b.updateIcon(t,r,n,i)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,r){return this.b.detachFromProcess(t,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,r){return this.b.shutdown(t,r)}input(t,r){return this.b.input(t,r)}processBinary(t,r){return this.b.processBinary(t,r)}resize(t,r,n){return this.b.resize(t,r,n)}acknowledgeDataEvent(t,r){return this.b.acknowledgeDataEvent(t,r)}setUnicodeVersion(t,r){return this.b.setUnicodeVersion(t,r)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,r){return this.b.installAutoReply(t,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,r,n,i=!1){const o=await this.c;return(0,u.detectAvailableProfiles)(r,n,i,this.F,o,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,r){return this.b.getWslPath(t,r)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,r){return this.b.requestDetachInstance(t,r)}async acceptDetachInstanceReply(t,r){return this.b.acceptDetachInstanceReply(t,r)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,r){return this.b.reviveTerminalProcesses(t,r)}async refreshProperty(t,r){return this.b.refreshProperty(t,r)}async updateProperty(t,r,n){return this.b.updateProperty(t,r,n)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,r){return this.f.createRequest({workspaceId:t,originalText:r})}async acceptPtyHostResolvedVariables(t,r){this.f.acceptReply(t,r)}};C=Le([Re(2,w.IConfigurationService),Re(3,y.IEnvironmentService),Re(4,v.ILogService),Re(5,v.ILoggerService)],C),e.PtyHostService=C}),define(ve[36],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ve[121],Ee([1,0,36,205,17,20,144,6,2]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class y{constructor(v){this.uri=v,this.time=y._clock++}touch(){return this.time=y._clock++,this}}y._clock=0;let T=class{constructor(v){this.g=v,this.c=new w.DisposableStore,this.f=2**16;const b=new Map,f=p=>{let u=b.get(p.scheme);return u===void 0&&(u=v.hasProvider(p)&&!this.g.hasCapability(p,1024),b.set(p.scheme,u)),u};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{b.delete(p.scheme)})),this.extUri=new I.ExtUri(f),this.d=new D.SkipList((p,u)=>this.extUri.compare(p,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,I.normalizePath)(v));const b=this.d.get(v);return b?b.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new y(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((f,p)=>f[1].touch<p[1].touch?1:f[1].touch>p[1].touch?-1:0);y._clock=0,this.d.clear();const b=this.f*.5;for(let f=0;f<b;f++)this.d.set(v[f][0],v[f][1].touch())}};T=Le([Re(0,a.IFileService)],T),e.UriIdentityService=T,(0,A.registerSingleton)(E.IUriIdentityService,T,1)}),define(ve[82],Ee([1,0,191,7,59,20,4,5,13]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function y(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=y;function T(n){return typeof n?.id=="string"&&!y(n)&&!v(n)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,A.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=S;function v(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=v;function b(n){const i=n;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=b;var f;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function u(n){const i=n;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=u;class h{constructor(i,o,c,l,s){this.h=i,this.j=c,this.k=l,this.l=s,this.c=a.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=a.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class m{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,I.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function d(n){return new m({uri:n,index:0,name:(0,I.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(n,i){return I.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function k(n){let i;return D.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=k;function t(n,i){return!C(n,i)&&!k(n)}e.isSavedWorkspace=t;function r(n){return(typeof n=="string"?(0,A.extname)(n):(0,I.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ve[34],Ee([1,0,91,6,2,20,4,190,25,17,5,12,82,27,36,14,21,16,8]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function d(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function C(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:D.URI.revive(n.location).with({scheme:i}),globalStorageHome:D.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=C;function k(n,i,o,c){return{id:n,name:i,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,I.joinPath)(o,"globalStorage"),settingsResource:(0,I.joinPath)(o,"settings.json"),keybindingsResource:(0,I.joinPath)(o,"keybindings.json"),tasksResource:(0,I.joinPath)(o,"tasks.json"),snippetsHome:(0,I.joinPath)(o,"snippets"),extensionsResource:(0,I.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=k;let t=class extends a.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(i,o,c,l){super(),this.m=i,this.n=o,this.r=c,this.s=l,this.f=!0,this.g=this.B(new A.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new A.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new A.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new A.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new b.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,I.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(i){this.f!==i&&(this.t=void 0,this.f=i)}isEnabled(){return this.f}get u(){if(!this.t){const i=[];if(this.f)for(const s of this.I()){if(!s.name||!(0,m.isString)(s.name)||!s.location){this.s.warn("Skipping the invalid stored profile",s.location||s.name);continue}i.push(k((0,I.basename)(s.location),s.name,s.location,{shortName:s.shortName,useDefaultFlags:s.useDefaultFlags}))}const o=new b.ResourceMap,c=new Map,l=this.v();if(i.unshift({...l,extensionsResource:this.N()??l.extensionsResource,isDefault:!0}),i.length){const s=this.L();if(s.workspaces)for(const[g,R]of Object.entries(s.workspaces)){const O=D.URI.parse(g),z=i.find(ie=>ie.id===R);z&&o.set(O,z)}if(s.emptyWindows)for(const[g,R]of Object.entries(s.emptyWindows)){const O=i.find(z=>z.id===R);O&&c.set(g,O)}}this.t={profiles:i,workspaces:o,emptyWindows:c}}return this.t}v(){return k("__default__profile__",(0,P.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(i){const o="Temp",c=new RegExp(`${(0,h.escapeRegExpCharacters)(o)}\\s(\\d+)`);let l=0;for(const g of this.profiles){const R=c.exec(g.name),O=R?parseInt(R[1]):0;l=O>l?O:l}const s=`${o} ${l+1}`;return this.createProfile((0,E.hash)((0,u.generateUuid)()).toString(16),s,{transient:!0},i)}async createNamedProfile(i,o,c){return this.createProfile((0,E.hash)((0,u.generateUuid)()).toString(16),i,o,c)}async createProfile(i,o,c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const s=await this.w(i,o,c);return l&&await this.setProfileForWorkspace(l,s),s}async w(i,o,c){if(!(0,m.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.k.get(o);return l||(l=(async()=>{try{const s=this.profiles.find(O=>O.name===o||O.id===i);if(s)return s;const g=k(i,o,(0,I.joinPath)(this.profilesHome,i),c);await this.n.createFolder(g.location);const R=[];return this.h.fire({profile:g,join(O){R.push(O)}}),await p.Promises.settled(R),this.C([g],[],[]),g}finally{this.k.delete(o)}})(),this.k.set(o,l)),l}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(l=>l.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=k(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this.i.fire({profile:o,join(l){c.push(l)}});try{await Promise.allSettled(c)}catch(l){this.s.error(l)}for(const l of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(l)?.id&&this.u.emptyWindows.delete(l);for(const l of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(l)?.id&&this.u.workspaces.delete(l);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(l){this.s.error(l)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(l=>l.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.F(i,c)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(i,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.y(i);return D.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}y(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}z(i){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,i.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,i.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,i.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,i.location)))}C(i,o,c){const l=[...this.profiles,...i],s=[];this.l.profiles=[];for(let g of l)g.isDefault||o.some(R=>g.id===R.id)||(g=c.find(R=>g.id===R.id)??g,g.isTransient?this.l.profiles.push(g):s.push({location:g.location,name:g.name,shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}));this.J(s),this.t=void 0,this.D(i,o,c)}D(i,o,c){this.g.fire({added:i,removed:o,updated:c,all:this.profiles})}F(i,o,c){c=o?.isTransient?!0:c,c||this.F(i,void 0,!0);const l=this.y(i),s=c?this.l:this.u;D.URI.isUri(l)?(s.workspaces.delete(l),o&&s.workspaces.set(l,o)):(s.emptyWindows.delete(l),o&&s.emptyWindows.set(l,o)),c||this.G()}G(){const i={};for(const[c,l]of this.u.workspaces.entries())i[c.toString()]=l.id;const o={};for(const[c,l]of this.u.emptyWindows.entries())o[c.toString()]=l.id;this.M({workspaces:i,emptyWindows:o}),this.t=void 0}H(i){const o={},c=this.v();if(i.workspaces)for(const[s,g]of Object.entries(i.workspaces)){const R=D.URI.parse(g);o[s]=this.r.extUri.isEqual(R,c.location)?c.id:this.r.extUri.basename(R)}const l={};if(i.emptyWindows)for(const[s,g]of Object.entries(i.emptyWindows)){const R=D.URI.parse(g);l[s]=this.r.extUri.isEqual(R,c.location)?c.id:this.r.extUri.basename(R)}return{workspaces:o,emptyWindows:l}}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=Le([Re(0,w.IEnvironmentService),Re(1,y.IFileService),Re(2,f.IUriIdentityService),Re(3,S.ILogService)],t),e.UserDataProfilesService=t;class r extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=r}),define(ve[248],Ee([1,0,18,14,19,9,6,2,3,4,171,32,35,33,12,26,30,34]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var m;(function(n){n.Verified="Verified",n.Unverified="Unverified",n.UnknownError="UnknownError"})(m=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let d=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,o,c,l,s){super(),this.t=i,this.u=o,this.v=c,this.w=l,this.y=s,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new D.Emitter),this.m=this.B(new D.Emitter),this.n=this.B(new D.Emitter),this.p=this.B(new D.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:g})=>g.cancel()),this.k.forEach(g=>g.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const o=await this.getTargetPlatform();return i.allTargetPlatforms.some(c=>(0,S.isTargetPlatformCompatible)(c,i.allTargetPlatforms,o))}async installFromGallery(i,o={}){try{if(!this.t.isEnabled())throw new S.ExtensionManagementError(T.localize(0,null),S.ExtensionManagementErrorCode.Internal);const c=await this.G(i,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(c.manifest,c.extension,o)}catch(c){throw t(this.u,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(i),error:c}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(c),k(c)}}async uninstall(i,o={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,o)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,o,c){const l={...c,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,b.isApplicationScopedExtension)(i)?this.y.defaultProfile.extensionsResource:c.profileLocation??this.P()},s=ee=>`${v.ExtensionKey.create(ee).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!y.URI.isUri(o)){const ee=this.j.get(s(o));if(ee){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:F}=await ee.task.waitUntilTaskIsFinished();return F}}const g=[],R=[],O=[],z=this.Q(i,o,l);y.URI.isUri(o)||this.j.set(s(o),{task:z,waitingTasks:[]}),this.l.fire({identifier:z.identifier,source:o,profileLocation:l.profileLocation}),this.v.info("Installing extension:",z.identifier.id),g.push({task:z,manifest:i});let ie=!1;try{if(l.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const F=await this.F(z.identifier,i,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),Z=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:$,manifest:x}of(0,E.distinct)(F,({gallery:le})=>le.identifier.id)){ie=ie||!!x.extensionDependencies?.some(Y=>(0,v.areSameExtensions)({id:Y},z.identifier));const le=s($),be=this.j.get(le);if(be){if(this.C(z,be.task)){const Y=be.task.identifier;this.v.info("Waiting for already requested installing extension",Y.id,z.identifier.id),be.waitingTasks.push(z),R.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,H=>H.some(U=>(0,v.areSameExtensions)(U.identifier,Y)))).then(H=>{if(this.v.info("Finished waiting for already requested installing extension",Y.id,z.identifier.id),!H.find(ne=>(0,v.areSameExtensions)(ne.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else if(!Z.some(({identifier:Y})=>(0,v.areSameExtensions)(Y,$.identifier))){const Y=this.Q(x,$,{...l,donotIncludePackAndDependencies:!0});this.j.set(le,{task:Y,waitingTasks:[z]}),this.l.fire({identifier:Y.identifier,source:$,profileLocation:l.profileLocation}),this.v.info("Installing extension:",Y.identifier.id,z.identifier.id),g.push({task:Y,manifest:x})}}}catch(F){if(y.URI.isUri(z.source))(0,E.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",z.identifier.id,F.message),(0,E.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",z.identifier.id,F.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),F}const ee=g.reduce((F,{task:Z,manifest:$})=>(F.set(Z.identifier.id.toLowerCase(),{task:Z,manifest:$}),F),new Map);for(;ee.size;){let F;const Z=[...ee.values()].filter(({manifest:$})=>!$.extensionDependencies?.some(x=>ee.has(x.toLowerCase())));Z.length?F=ee.size===1?Z:Z.filter(({task:$})=>!($===z&&!ie)):(this.v.info("Found extensions with circular dependencies",Z.map(({task:$})=>$.identifier.id)),F=[...ee.values()]),await this.D(F.map(async({task:$})=>{const x=new Date().getTime();try{const{local:le}=await $.run();if(await this.D(this.s.map(be=>be.postInstall(le,$.source,l,a.CancellationToken.None))),!y.URI.isUri($.source)){const be=$.operation===3,Y=be?void 0:(new Date().getTime()-$.source.lastUpdated)/1e3;if(t(this.u,be?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)($.source),verificationStatus:$.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:Y}),w.isWeb&&$.operation!==3)try{await this.t.reportStatistic(le.manifest.publisher,le.manifest.name,le.manifest.version,"install")}catch{}}O.push({local:le,identifier:$.identifier,operation:$.operation,source:$.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:le.isApplicationScoped})}catch(le){throw y.URI.isUri($.source)||t(this.u,$.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)($.source),verificationStatus:$.verificationStatus,duration:new Date().getTime()-x,error:le}),this.v.error("Error while installing the extension:",$.identifier.id),le}finally{ee.delete($.identifier.id.toLowerCase())}}))}return R.length&&await this.D(R),O.forEach(({identifier:F})=>this.v.info("Extension installed successfully:",F.id)),this.m.fire(O),O.filter(({identifier:F})=>(0,v.areSameExtensions)(F,z.identifier))[0].local}catch(ee){if(g.forEach(({task:F})=>F.cancel()),O.length)try{const F=await Promise.allSettled(O.map(({local:Z})=>this.R(Z,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let Z=0;Z<F.length;Z++){const $=F[Z],{identifier:x}=O[Z];$.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",x.id):this.v.warn("Rollback: Error while uninstalling extension",x.id,(0,I.getErrorMessage)($.reason))}}catch(F){this.v.warn("Error while rolling back extensions",(0,I.getErrorMessage)(F),O.map(({identifier:Z})=>Z.id))}throw this.m.fire(g.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:l.context,profileLocation:l.profileLocation}))),ee}finally{for(const{task:ee}of g)ee.source&&!y.URI.isUri(ee.source)&&this.j.delete(s(ee.source))}}C(i,o){for(const[,{task:c,waitingTasks:l}]of this.j.entries())if(c===i&&(l.includes(o)||l.some(s=>this.C(s,o)))||c===o&&l[0]&&!this.C(i,l[0]))return!1;return!0}async D(i){const o=[],c=[],l=await Promise.allSettled(i);for(const s of l)s.status==="fulfilled"?o.push(s.value):c.push(s.reason);if(c.length)throw C(c);return o}async F(i,o,c,l,s){if(!this.t.isEnabled())return[];const g=await this.getInstalled(void 0,s),R=[],O=[],z=async(ie,ee)=>{R.push(ie);const F=ee.extensionDependencies||[],Z=[...F];if(ee.extensionPack){const $=c?g.find(x=>(0,v.areSameExtensions)(x.identifier,ie)):void 0;for(const x of ee.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(le=>(0,v.areSameExtensions)({id:le},{id:x}))||Z.every(le=>!(0,v.areSameExtensions)({id:le},{id:x}))&&Z.push(x)}if(Z.length){const $=Z.filter(x=>R.every(le=>!(0,v.areSameExtensions)(le,{id:x})));if($.length){const x=await this.t.getExtensions($.map(le=>({id:le,preRelease:l})),a.CancellationToken.None);for(const le of x){if(R.find(H=>(0,v.areSameExtensions)(H,le.identifier)))continue;const be=F.some(H=>(0,v.areSameExtensions)({id:H},le.identifier));let Y;try{Y=await this.G(le,!1,l)}catch(H){if(H instanceof S.ExtensionManagementError&&H.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!be){this.v.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}else throw H}O.push({gallery:Y.extension,manifest:Y.manifest}),await z(Y.extension.identifier,Y.manifest)}}}};return await z(i,o),O}async G(i,o,c){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,v.areSameExtensions)(i.identifier,R)))throw new S.ExtensionManagementError(T.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const R=await this.getTargetPlatform();throw new S.ExtensionManagementError(T.localize(2,null,i.identifier.id,this.w.nameLong,(0,S.TargetPlatformToString)(R)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.H(i,o,c);if(s){if(c&&!o&&i.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(T.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],a.CancellationToken.None))[0]?new S.ExtensionManagementError(T.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(T.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",s.identifier.id);const g=await this.t.getManifest(s,a.CancellationToken.None);if(g===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(g.version!==s.version)throw new S.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:g}}async H(i,o,c){const l=await this.getTargetPlatform();let s=null;return!o&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==c&&(s=(await this.t.getExtensions([{...i.identifier,preRelease:c}],{targetPlatform:l,compatible:!0},a.CancellationToken.None))[0]||null),!s&&await this.t.isExtensionCompatible(i,c,l)&&(s=i),s||(o?s=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},a.CancellationToken.None))[0]||null:s=await this.t.getCompatibleExtension(i,c,l)),s}async I(i,o){const c={...o,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},l=ie=>`${ie.id.toLowerCase()}${c.versionOnly?`-${i.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,s=this.k.get(l(i.identifier));if(s)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),s.waitUntilTaskIsFinished();const g=ie=>{const ee=this.R(ie,c);return this.k.set(l(ee.extension.identifier),ee),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ie.identifier.id}@${ie.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ie.identifier.id}@${ie.manifest.version}`),this.n.fire({identifier:ie.identifier,profileLocation:c.profileLocation,applicationScoped:ie.isApplicationScoped}),ee},R=(ie,ee)=>{ee?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ie.identifier.id}@${ie.manifest.version}`,c.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${ie.identifier.id}@${ie.manifest.version}`,ee.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ie.identifier.id}@${ie.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ie.identifier.id}@${ie.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(ie),error:ee}),this.p.fire({identifier:ie.identifier,error:ee?.code,profileLocation:c.profileLocation,applicationScoped:ie.isApplicationScoped})},O=[],z=[];try{O.push(g(i));const ie=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ee=this.M(i,ie);for(const F of ee)this.k.has(l(F.identifier))?this.v.info("Extensions is already requested to uninstall",F.identifier.id):O.push(g(F))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(O.map(ee=>ee.extension),ie,i),await this.D(O.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(F=>F.postUninstall(ee.extension,c,a.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}R(ee.extension)}catch(F){const Z=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,I.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);throw R(ee.extension,Z),Z}finally{z.push(ee)}}))}catch(ie){const ee=ie instanceof S.ExtensionManagementError?ie:new S.ExtensionManagementError((0,I.getErrorMessage)(ie),S.ExtensionManagementErrorCode.Internal);for(const F of O){try{F.cancel()}catch{}z.includes(F)||R(F.extension,ee)}throw ee}finally{for(const ie of O)this.k.delete(l(ie.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ie.extension.identifier.id)}}J(i,o,c){for(const l of i){const s=this.N(l,o);if(s.length){const g=s.filter(R=>!i.some(O=>(0,v.areSameExtensions)(O.identifier,R.identifier)));if(g.length)throw new Error(this.L(l,g,c))}}}L(i,o,c){return c===i?o.length===1?T.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?T.localize(9,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(10,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(11,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(i,o,c=[]){if(c.indexOf(i)!==-1)return[];c.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const s=o.filter(R=>!R.isBuiltin&&l.some(O=>(0,v.areSameExtensions)({id:O},R.identifier))),g=[];for(const R of s)g.push(...this.M(R,o,c));return[...s,...g]}return[]}N(i,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(l=>(0,v.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=Le([Re(0,S.IExtensionGalleryService),Re(1,u.ITelemetryService),Re(2,f.ILogService),Re(3,p.IProductService),Re(4,h.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function C(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=C;function k(n){if(n instanceof S.ExtensionManagementError)return n;const i=new S.ExtensionManagementError(n.message,S.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:o,verificationStatus:c,duration:l,error:s,durationSinceUpdate:g}){let R,O;s&&(s instanceof S.ExtensionManagementError?(R=s.code,s.code===S.ExtensionManagementErrorCode.Signature&&(O=s.message)):R=S.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...o,verificationStatus:c,success:!s,duration:l,errorcode:R,errorcodeDetail:O,durationSinceUpdate:g})}e.reportTelemetry=t;class r{constructor(){this.d=new A.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.createCancelablePromise)(i=>new Promise((o,c)=>{const l=i.onCancellationRequested(()=>{l.dispose(),c(new I.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(ve[43],Ee([1,0,14,15,2,6,27,4,35,33,17,5,12,34,36,8,9,30]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class d extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let C=class extends a.Disposable{constructor(n,i,o,c,l,s){super(),this.i=n,this.j=i,this.k=o,this.l=c,this.m=l,this.n=s,this.b=this.B(new I.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new I.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new D.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const o=[],c=[];try{return await this.p(i,l=>{const s=[];for(const g of l)n.some(([R])=>(0,w.areSameExtensions)(R.identifier,g.identifier)&&R.manifest.version!==g.version)?o.push(g):s.push(g);for(const[g,R]of n)if(!s.some(O=>(0,w.areSameExtensions)(O.identifier,g.identifier)&&O.version===g.manifest.version)){const O={identifier:g.identifier,version:g.manifest.version,location:g.location,metadata:R};c.push(O),s.push(O)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),s}),c.length&&this.c.fire({extensions:c,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),c}catch(l){throw c.length&&this.c.fire({extensions:c,error:l,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:l,profileLocation:i}),l}}async updateMetadata(n,i){const o=[];return await this.p(i,c=>{const l=[];for(const s of c){const g=n.find(([R])=>(0,w.areSameExtensions)(R.identifier,s.identifier)&&R.manifest.version===s.version);g&&(s.metadata={...s.metadata,...g[1]},o.push(s)),l.push(s)}return l}),o}async removeExtensionFromProfile(n,i){const o=[];this.f.fire({extensions:o,profileLocation:i});try{await this.p(i,c=>{const l=[];for(const s of c)(0,w.areSameExtensions)(s.identifier,n.identifier)?o.push(s):l.push(s);return o.length&&this.f.fire({extensions:o,profileLocation:i}),l}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(c){throw o.length&&this.g.fire({extensions:o,error:c,profileLocation:i}),c}}async p(n,i,o){return this.w(n).queue(async()=>{let c=[],l;try{const s=await this.j.readFile(n);l=JSON.parse(s.value.toString())}catch(s){if((0,T.toFileOperationResult)(s)!==1)throw s;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&o?.bailOutWhenFileNotFound)throw new d((0,u.getErrorMessage)(s),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(n);let s=!1;for(const g of l){k(g)||this.r(n);let R;if((0,p.isString)(g.relativeLocation))R=this.t(g.relativeLocation);else if((0,p.isString)(g.location))R=this.t(g.location),s=!0,g.relativeLocation=g.location,g.location=R.toJSON();else{R=P.URI.revive(g.location);const O=this.s(R);O&&(s=!0,g.relativeLocation=O)}c.push({identifier:g.identifier,location:R,version:g.version,metadata:g.metadata})}s&&await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(l)))}if(i){c=i(c);const s=c.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),relativeLocation:this.s(g.location),metadata:g.metadata}));await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(s)))}return c})}r(n){const i=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(n){return this.l.extUri.isEqualOrParent(n,this.i)?this.l.extUri.relativePath(this.i,n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json");let i;try{i=(await this.j.readFile(n)).value.toString()}catch(c){if((0,T.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",n.toString());let o;try{const c=JSON.parse(i);Array.isArray(c)&&c.every(l=>k(l))?o=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,T.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(n)}catch(c){(0,T.toFileOperationResult)(c)!==1&&this.n.error(c)}return o})()),this.u}w(n){let i=this.h.get(n);return i||(i=new E.Queue,this.h.set(n,i)),i}};C=Le([Re(1,T.IFileService),Re(2,b.IUserDataProfilesService),Re(3,f.IUriIdentityService),Re(4,h.ITelemetryService),Re(5,v.ILogService)],C),e.AbstractExtensionsProfileScannerService=C;function k(r){return(0,p.isObject)(r)&&(0,y.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,p.isString)(r.location))&&((0,p.isUndefined)(r.relativeLocation)||(0,p.isString)(r.relativeLocation))&&r.version&&(0,p.isString)(r.version)}function t(r){return r?(0,p.isString)(r.path)&&(0,p.isString)(r.scheme):!1}}),define(ve[54],Ee([1,0,18,14,23,15,9,70,166,2,13,7,3,20,50,58,8,4,175,25,35,33,73,17,5,12,26,6,46,43,34,36,202,203]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t,r,n,i,o,c,l,s,g,R,O,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ie;(function(be){function Y(H,U){if(H===U)return!0;const ne=Object.keys(H),se=new Set;for(const de of Object.keys(U))se.add(de);if(ne.length!==se.size)return!1;for(const de of ne){if(H[de]!==U[de])return!1;se.delete(de)}return se.size===0}be.equals=Y})(ie=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let ee=class extends y.Disposable{constructor(Y,H,U,ne,se,de,re,j,N,M,q,te){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=H,this.l=U,this.m=ne,this.n=se,this.p=de,this.r=re,this.s=j,this.t=N,this.u=M,this.v=q,this.w=te,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,b.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance($,(0,b.joinPath)(this.m,k.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance($,(0,b.joinPath)(this.m,k.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Z,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,C.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(Y,H,U){const[ne,se]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(H)]),de=U?await this.scanExtensionsUnderDevelopment(Y,[...ne,...se]):[];return this.F(ne,se,de,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const H=[];H.push(this.G(!!Y.useCache,Y.language)),H.push(this.H(Y.language,!!Y.checkControlFile));const[U,ne]=await Promise.all(H);return this.D([...U,...ne],0,Y,!1)}async scanUserExtensions(Y){const H=Y.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",H);const U=this.v.extUri.isEqual(Y.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,ne=await this.J(H,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,U),se=Y.useCache&&!ne.devMode&&ne.excludeObsolete?this.j:this.k;let de;try{de=await se.scanExtensions(ne)}catch(re){if(re instanceof s.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),de=await se.scanExtensions(ne);else throw re}return de=await this.D(de,1,Y,!0),this.s.trace("Scanned user extensions:",de.length),de}async scanExtensionsUnderDevelopment(Y,H){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ne=>ne.scheme===T.Schemas.file).map(async ne=>{const se=await this.J(ne,!1,1,!0,Y.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(se)).map(re=>(re.type=H.find(j=>(0,C.areSameExtensions)(j.identifier,re.identifier))?.type??re.type,this.k.validate(re,se)))}))).flat();return this.D(U,"development",Y,!0)}return[]}async scanExistingExtension(Y,H,U){const ne=await this.J(Y,!1,H,!0,U.language,!0,void 0),se=await this.k.scanExtension(ne);return!se||!U.includeInvalid&&!se.isValid?null:se}async scanOneOrMultipleExtensions(Y,H,U){const ne=await this.J(Y,!1,H,!0,U.language,!0,void 0),se=await this.k.scanOneOrMultipleExtensions(ne);return this.D(se,H,U,!0)}async scanMetadata(Y){const H=(0,b.joinPath)(Y,"package.json"),U=(await this.r.readFile(H)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(Y,H){const U=(0,b.joinPath)(Y,"package.json"),ne=(await this.r.readFile(U)).value.toString(),se=JSON.parse(ne);H.isMachineScoped=H.isMachineScoped||void 0,H.isBuiltin=H.isBuiltin||void 0,H.installedTimestamp=H.installedTimestamp||void 0,se.__metadata={...se.__metadata,...H},await this.r.writeFile((0,b.joinPath)(Y,"package.json"),I.VSBuffer.fromString(JSON.stringify(se,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof s.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw Y}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.p.addExtensionsToProfile(Y.map(H=>[H,H.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,I.VSBuffer.fromString(JSON.stringify([])))}catch(H){(0,r.toFileOperationResult)(H)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(H))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.s.error(Y)}finally{this.z=void 0}})()),this.z}async D(Y,H,U,ne){return U.includeAllVersions||(Y=this.F(H===0?Y:void 0,H===1?Y:void 0,H==="development"?Y:void 0,await this.getTargetPlatform(),ne)),U.includeInvalid||(Y=Y.filter(se=>se.isValid)),Y.sort((se,de)=>{const re=S.basename(se.location.fsPath),j=S.basename(de.location.fsPath);return re<j?-1:re>j?1:0})}F(Y,H,U,ne,se){const de=(j,N,M)=>{if(j.isValid&&!N.isValid)return!1;if(j.isValid===N.isValid){if(se&&f.gt(j.manifest.version,N.manifest.version))return this.s.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(f.eq(j.manifest.version,N.manifest.version)){if(j.type===0)return this.s.debug(`Skipping extension ${N.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===ne)return this.s.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return M?this.s.warn(`Overwriting user extension ${j.location.path} with ${N.location.path}.`):this.s.debug(`Overwriting user extension ${j.location.path} with ${N.location.path}.`),!0},re=new Map;return Y?.forEach(j=>{const N=k.ExtensionIdentifier.toKey(j.identifier.id),M=re.get(N);(!M||de(M,j,!1))&&re.set(N,j)}),H?.forEach(j=>{const N=k.ExtensionIdentifier.toKey(j.identifier.id),M=re.get(N);if(!M&&Y&&j.type===0){this.s.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!M||de(M,j,!1))&&re.set(N,j)}),U?.forEach(j=>{const N=k.ExtensionIdentifier.toKey(j.identifier.id),M=re.get(N);(!M||de(M,j,!0))&&re.set(N,j),re.set(N,j)}),[...re.values()]}async G(Y,H){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0),se=await(Y&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",se.length),se}async H(Y,H){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const ne=H?await this.I():{},se=[],de=h.URI.file(S.normalize(S.join(T.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of U){const N=ne[j.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":se.push((0,b.joinPath)(de,j.name));break;default:se.push(h.URI.file(N));break}}const re=await Promise.all(se.map(async j=>this.k.scanExtension(await this.J(j,!1,0,!0,Y,!0,void 0))));return this.s.trace("Scanned dev system extensions:",re.length),(0,E.coalesce)(re)}async I(){try{const Y=await this.r.readFile(this.l);return JSON.parse(Y.value.toString())}catch{return{}}}async J(Y,H,U,ne,se,de,re){const j=await this.f(se??v.language),N=await this.L(Y),M=H&&!this.v.extUri.isEqual(Y,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,q=M?await this.L(M):void 0;return new F(Y,N,M,q,H,re,U,ne,de,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,se,j)}async L(Y){try{const H=await this.r.stat(Y);if(typeof H.mtime=="number")return H.mtime}catch{}}};ee=Le([Re(4,g.IUserDataProfilesService),Re(5,s.IExtensionsProfileScannerService),Re(6,r.IFileService),Re(7,i.ILogService),Re(8,d.IEnvironmentService),Re(9,o.IProductService),Re(10,R.IUriIdentityService),Re(11,n.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class F{constructor(Y,H,U,ne,se,de,re,j,N,M,q,te,ue,W,K){this.location=Y,this.mtime=H,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=ne,this.profile=se,this.profileScanOptions=de,this.type=re,this.excludeObsolete=j,this.validate=N,this.productVersion=M,this.productDate=q,this.productCommit=te,this.devMode=ue,this.language=W,this.translations=K}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,H){return(0,b.isEqual)(Y.location,H.location)&&Y.mtime===H.mtime&&(0,b.isEqual)(Y.applicationExtensionslocation,H.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&Y.profile===H.profile&&a.equals(Y.profileScanOptions,H.profileScanOptions)&&Y.type===H.type&&Y.excludeObsolete===H.excludeObsolete&&Y.validate===H.validate&&Y.productVersion===H.productVersion&&Y.productDate===H.productDate&&Y.productCommit===H.productCommit&&Y.devMode===H.devMode&&Y.language===H.language&&ie.equals(Y.translations,H.translations)}}e.ExtensionScannerInput=F;let Z=class extends y.Disposable{constructor(Y,H,U,ne,se){super(),this.f=Y,this.g=H,this.h=U,this.i=ne,this.j=se}async scanExtensions(Y){const H=Y.profile?await this.l(Y):await this.k(Y);let U={};if(Y.excludeObsolete&&Y.type===1)try{const ne=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(ne)}catch{}return(0,u.isEmptyObject)(U)?H:H.filter(ne=>!U[C.ExtensionKey.create(ne).toString()])}async k(Y){const H=await this.i.resolve(Y.location);if(!H.children?.length)return[];const U=await Promise.all(H.children.map(async ne=>{if(!ne.isDirectory||Y.type===1&&(0,b.basename)(ne.resource).indexOf(".")===0)return null;const se=new F(ne.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(se)}));return(0,E.coalesce)(U).sort((ne,se)=>ne.location.path<se.location.path?-1:1)}async l(Y){let H=await this.m(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){H=H.filter(ne=>!ne.metadata?.isApplicationScoped);const U=await this.m(Y.applicationExtensionslocation,ne=>!!ne.metadata?.isApplicationScoped,Y);H.push(...U)}return H}async m(Y,H,U){const ne=await this.g.scanProfileExtensions(Y,U.profileScanOptions);if(!ne.length)return[];const se=await Promise.all(ne.map(async de=>{if(H(de)){const re=new F(de.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(re,de.metadata)}return null}));return(0,E.coalesce)(se)}async scanOneOrMultipleExtensions(Y){try{if(await this.i.exists((0,b.joinPath)(Y.location,"package.json"))){const H=await this.scanExtension(Y);return H?[H]:[]}else return await this.scanExtensions(Y)}catch(H){return this.j.error(`Error scanning extensions at ${Y.location.path}:`,(0,D.getErrorMessage)(H)),[]}}async scanExtension(Y,H){try{let U=await this.scanExtensionManifest(Y.location);if(U){U.publisher||(U.publisher=k.UNDEFINED_PUBLISHER),H=H??U.__metadata,delete U.__metadata;const ne=(0,C.getGalleryExtensionId)(U.publisher,U.name),se=H?.id?{id:ne,uuid:H.id}:{id:ne},de=H?.isSystem?0:Y.type,re=de===0||!!H?.isBuiltin;z.ImplicitActivationEvents.updateManifest(U),U=await this.n(Y.location,U,F.createNlsConfiguration(Y));const j={type:de,identifier:se,manifest:U,location:Y.location,isBuiltin:re,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return Y.validate?this.validate(j,Y):j}}catch(U){Y.type!==0&&this.j.error(U)}return null}validate(Y,H){let U=!0;const ne=(0,t.validateExtensionManifest)(H.productVersion,H.productDate,H.location,Y.manifest,Y.isBuiltin);for(const[se,de]of ne)se===p.default.Error&&(U=!1,this.j.error(this.t(H.location,de)));return Y.isValid=U,Y.validations=ne,Y}async scanExtensionManifest(Y){const H=(0,b.joinPath)(Y,"package.json");let U;try{U=(await this.i.readFile(H)).value.toString()}catch(se){return(0,r.toFileOperationResult)(se)!==1&&this.j.error(this.t(Y,(0,m.localize)(0,null,H.path,se.message))),null}let ne;try{ne=JSON.parse(U)}catch{const de=[];(0,P.parse)(U,de);for(const re of de)this.j.error(this.t(Y,(0,m.localize)(1,null,H.path,re.offset,re.length,(0,w.getParseErrorMessage)(re.error))));return null}return(0,P.getNodeType)(ne)!=="object"?(this.j.error(this.t(Y,(0,m.localize)(2,null,H.path))),null):ne}async n(Y,H,U){const ne=await this.p(Y,H,U);if(ne)try{const se=[],de=await this.r(ne.default,se);if(se.length>0)return se.forEach(j=>{this.j.error(this.t(Y,(0,m.localize)(3,null,ne.default?.path,(0,w.getParseErrorMessage)(j.error))))}),H;if((0,P.getNodeType)(ne)!=="object")return this.j.error(this.t(Y,(0,m.localize)(4,null,ne.default?.path))),H;const re=ne.values||Object.create(null);return(0,O.localizeManifest)(H,re,de)}catch{}return H}async p(Y,H,U){const ne=(0,b.joinPath)(Y,"package.nls.json"),se=(N,M)=>{M.forEach(q=>{this.j.error(this.t(Y,(0,m.localize)(5,null,N?.path,(0,w.getParseErrorMessage)(q.error))))})},de=N=>{this.j.error(this.t(Y,(0,m.localize)(6,null,N?.path)))},re=`${H.publisher}.${H.name}`,j=U.translations[re];if(j)try{const N=h.URI.file(j),M=(await this.i.readFile(N)).value.toString(),q=[],te=(0,P.parse)(M,q);return q.length>0?(se(N,q),{values:void 0,default:ne}):(0,P.getNodeType)(te)!=="object"?(de(N),{values:void 0,default:ne}):{values:te.contents?te.contents.package:void 0,default:ne}}catch{return{values:void 0,default:ne}}else{if(!await this.i.exists(ne))return;let M;try{M=await this.s(Y,U)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const q=(await this.i.readFile(M.localized)).value.toString(),te=[],ue=(0,P.parse)(q,te);return te.length>0?(se(M.localized,te),{values:void 0,default:M.original}):(0,P.getNodeType)(ue)!=="object"?(de(M.localized),{values:void 0,default:M.original}):{values:ue,default:M.original}}catch{return{values:void 0,default:M.original}}}}async r(Y,H){if(Y)try{const U=(await this.i.readFile(Y)).value.toString();return(0,P.parse)(U,H)}catch{}}s(Y,H){return new Promise((U,ne)=>{const se=de=>{const re=(0,b.joinPath)(Y,`package.nls.${de}.json`);this.i.exists(re).then(j=>{j&&U({localized:re,original:(0,b.joinPath)(Y,"package.nls.json")});const N=de.lastIndexOf("-");N===-1?U({localized:(0,b.joinPath)(Y,"package.nls.json"),original:null}):(de=de.substring(0,N),se(de))})};if(H.devMode||H.pseudo||!H.language)return U({localized:(0,b.joinPath)(Y,"package.nls.json"),original:null});se(H.language)})}t(Y,H){return`[${Y.path}]: ${H}`}};Z=Le([Re(1,s.IExtensionsProfileScannerService),Re(2,R.IUriIdentityService),Re(3,r.IFileService),Re(4,i.ILogService)],Z);let $=class extends Z{constructor(Y,H,U,ne,se,de){super(H,U,ne,se,de),this.y=Y,this.v=this.B(new A.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(Y){const H=await this.z();if(this.u=Y,H&&H.input&&F.equals(H.input,this.u))return this.j.debug("Using cached extensions scan result",Y.location.toString()),this.v.trigger(()=>this.D()),H.result.map(ne=>(ne.location=h.URI.revive(ne.location),ne));const U=await super.scanExtensions(Y);return await this.C({input:Y,result:U}),U}async z(){try{const Y=await this.i.readFile(this.y),H=JSON.parse(Y.value.toString());return{result:H.result,input:(0,l.revive)(H.input)}}catch(Y){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(Y))}return null}async C(Y){try{await this.i.writeFile(this.y,I.VSBuffer.fromString(JSON.stringify(Y)))}catch(H){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(H))}}async D(){if(!this.u)return;const Y=await this.z();if(!Y)return;const H=Y.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!a.equals(U,H))try{await this.i.del(this.y),this.w.fire()}catch(ne){this.j.error(ne)}}};$=Le([Re(2,s.IExtensionsProfileScannerService),Re(3,R.IUriIdentityService),Re(4,r.IFileService),Re(5,i.ILogService)],$);function x(be,Y){const H=(0,C.getExtensionId)(be.manifest.publisher,be.manifest.name);return{id:H,identifier:new k.ExtensionIdentifier(H),isBuiltin:be.type===0,isUserBuiltin:be.type===1&&be.isBuiltin,isUnderDevelopment:Y,extensionLocation:be.location,uuid:be.identifier.uuid,targetPlatform:be.targetPlatform,...be.manifest}}e.toExtensionDescription=x;class le extends ee{constructor(Y,H,U,ne,se,de,re,j,N,M,q,te){super(Y,H,(0,b.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(ne,k.MANIFEST_CACHE_FOLDER),se,de,re,j,N,M,q,te),this.M=(async()=>{if(v.translationsConfigFile)try{const ue=await this.r.readFile(h.URI.file(v.translationsConfigFile));return JSON.parse(ue.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.M}}e.NativeExtensionsScannerService=le}),define(ve[249],Ee([1,0,48,14,38,6,2,13,7,22,12,34]),function(ae,e,E,A,a,I,D,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends D.Disposable{constructor(f,p){super(),this.b=f,this.f=p,this.a=new A.Limiter(5)}async postUninstall(f){const p=this.g(f,"uninstall");return p&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(p.script,"uninstall",p.args,!0,f).then(()=>this.f.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),u=>this.f.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${u}`)))),y.Promises.rm(this.j(f)).then(void 0,u=>this.f.error("Error while removing extension storage path",u))}g(f,p){const u=`vscode:${p}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[u]=="string"){const h=f.manifest.scripts[u].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${u} should be a node script`),null):{script:(0,w.join)(f.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(f,p,u,h,m){return new Promise((d,C)=>{const k=this.i(f,p,u,m);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?C(n):d(void 0)};k.on("error",n=>{r((0,a.toErrorMessage)(n)||"Unknown")}),k.on("exit",(n,i)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),h&&(t=setTimeout(()=>{t=null,k.kill(),C("timed out")},5e3))})}i(f,p,u,h){const m={silent:!0,execArgv:void 0},d=(0,E.fork)(f,[`--type=extension-post-${p}`,...u],m);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const C=I.Event.fromNodeEventEmitter(d.stdout,"data"),k=I.Event.fromNodeEventEmitter(d.stderr,"data");C(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,n)),k(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,n));const t=I.Event.any(I.Event.map(C,n=>({data:`%c${n}`,format:[""]})),I.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}j(f){return(0,w.join)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};v=Le([Re(0,S.IUserDataProfilesService),Re(1,T.ILogService)],v),e.ExtensionsLifecycle=v}),define(ve[122],Ee([1,0,12,34,36,30,43,17,25,4]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let T=class extends D.AbstractExtensionsProfileScannerService{constructor(v,b,f,p,u,h){super(y.URI.file(v.extensionsPath),b,f,p,u,h)}};T=Le([Re(0,w.INativeEnvironmentService),Re(1,P.IFileService),Re(2,A.IUserDataProfilesService),Re(3,a.IUriIdentityService),Re(4,I.ITelemetryService),Re(5,E.ILogService)],T),e.ExtensionsProfileScannerService=T}),define(ve[250],Ee([1,0,14,6,2,47,8,157,5,34]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var T;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var v;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));function b(m){const d=m.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=b;class f extends a.Disposable{constructor(d={flushInterval:f.a}){super(),this.j=d,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new a.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,a.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.J()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,C){if(C===e.TARGET_KEY){switch(d){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:C,target:this.F(d)[C]})}r(d){this.f.fire({reason:d})}get(d,C,k){return this.L(C)?.get(d,k)}getBoolean(d,C,k){return this.L(C)?.getBoolean(d,k)}getNumber(d,C,k){return this.L(C)?.getNumber(d,k)}store(d,C,k,t){if((0,D.isUndefinedOrNull)(C)){this.remove(d,k);return}this.t(()=>{this.u(d,k,t),this.L(k)?.set(d,C)})}remove(d,C){this.t(()=>{this.u(d,C,void 0),this.L(C)?.delete(d)})}t(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,C){const k=[],t=this.F(d);for(const r of Object.keys(t))t[r]===C&&k.push(r);return k}u(d,C,k){const t=this.F(C);typeof k=="number"?t[d]!==k&&(t[d]=k,this.L(C)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[d]=="number"&&(delete t[d],this.L(C)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.z;default:return this.w}}G(d){const C=this.L(d);return C?b(C):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=T.NONE){this.f.fire({reason:d});const C=this.L(-1),k=this.L(0),t=this.L(1);switch(d){case T.NONE:await E.Promises.settled([C?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await E.Promises.settled([C?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,C=this.L(0)?.items??new Map,k=this.L(1)?.items??new Map;return h(d,C,k,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,C){return this.r(T.NONE),(0,y.isUserDataProfile)(d)?this.N(d,C):this.O(d,C)}H(d,C){return!(d.id===C.id||p(C)&&p(d))}I(d,C,k,t){this.t(()=>{if(t)for(const[r,n]of d)C.set(r,n);else{const r=new Set;for(const[n,i]of d)r.add(n),C.get(n)!==i&&this.n(k,n);for(const[n]of C.items)r.has(n)||this.n(k,n)}})}}f.a=60*1e3,e.AbstractStorageService=f;function p(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class u extends f{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=u;async function h(m,d,C,k,t,r){const n=z=>{try{return JSON.parse(z)}catch{return z}},i=new Map,o=new Map;m.forEach((z,ie)=>{i.set(ie,z),o.set(ie,n(z))});const c=new Map,l=new Map;d.forEach((z,ie)=>{c.set(ie,z),l.set(ie,n(z))});const s=new Map,g=new Map;C.forEach((z,ie)=>{s.set(ie,z),g.set(ie,n(z))}),console.group(k!==t?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const R=[];if(i.forEach((z,ie)=>{R.push({key:ie,value:z})}),console.table(R),console.groupEnd(),console.log(o),k!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const z=[];c.forEach((ie,ee)=>{z.push({key:ee,value:ie})}),console.table(z),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const O=[];s.forEach((z,ie)=>{O.push({key:ie,value:z})}),console.table(O),console.groupEnd(),console.log(g)}e.logStorage=h}),define(ve[123],Ee([1,0,18,19,9,3,28,8,4,24,25,32,35,73,17,12,26,53,234,250,30]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const k=I.isWeb?"web":(0,S.getTargetPlatform)(I.platform,D.arch),t="X-Market-Search-Activity-Id";var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...N){return String(N.reduce((M,q)=>M|q,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class g{constructor(M=s){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,q=this.d.pageSize){return new g({...this.d,pageNumber:M,pageSize:q})}withFilter(M,...q){const te=[...this.d.criteria,...q.length?q.map(ue=>({filterType:M,value:ue})):[{filterType:M}]];return new g({...this.d,criteria:te})}withSortBy(M){return new g({...this.d,sortBy:M})}withSortOrder(M){return new g({...this.d,sortOrder:M})}withFlags(...M){return new g({...this.d,flags:M.reduce((q,te)=>q|te,0)})}withAssetTypes(...M){return new g({...this.d,assetTypes:M})}withSource(M){return new g({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:q,pageSize:te,sortBy:ue,sortOrder:W,flags:K,assetTypes:_}=this.d;return{filters:[{criteria:M,pageNumber:q,pageSize:te,sortBy:ue,sortOrder:W}],assetTypes:_,flags:K}}get searchText(){const M=this.d.criteria.filter(q=>q.filterType===i.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(N,M){const q=(N||[]).filter(te=>te.statisticName===M)[0];return q?q.value:0}function O(N){const M="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(te=>te.assetType.indexOf(M)===0).reduce((te,ue)=>{const W=ee(N,ue.assetType);return W&&te.push([ue.assetType.substring(M.length),W]),te},[])}function z(N){if(N.properties){const M=N.properties.filter(ue=>ue.key===o.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=M.filter(ue=>q.test(ue.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return ee(N,o.Repository)}function ie(N){return{uri:`${N.fallbackAssetUri}/${o.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${o.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ee(N,M){return N.files.filter(te=>te.assetType===M)[0]?{uri:`${N.assetUri}/${M}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${M}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function F(N,M){const q=N.properties?N.properties.filter(ue=>ue.key===M):[],te=q.length>0&&q[0].value;return te?te.split(",").map(ue=>(0,v.adoptToGalleryExtensionId)(ue)):[]}function Z(N){const M=N.properties?N.properties.filter(q=>q.key===c.Engine):[];return M.length>0&&M[0].value||""}function $(N){const M=N.properties?N.properties.filter(q=>q.key===c.PreRelease):[];return M.length>0&&M[0].value==="true"}function x(N){const M=N.properties?N.properties.filter(te=>te.key===c.LocalizedLanguages):[],q=M.length>0&&M[0].value||"";return q?q.split(","):[]}function le(N){return N.properties?.find(M=>M.key===c.SponsorLink)?.value}function be(N){return N.indexOf("preview")!==-1}function Y(N){return N.targetPlatform?(0,S.toTargetPlatform)(N.targetPlatform):"undefined"}function H(N){const M=(0,E.distinct)(N.versions.map(Y)),q=!!N.tags?.includes(S.WEB_EXTENSION_TAG),te=M.indexOf("web");return q?te===-1&&M.push("web"):te!==-1&&M.splice(te,1),M}function U(N,M){const q=(0,S.getFallbackTargetPlarforms)(M);for(let te=0;te<N.length;te++){const ue=N[te];if(ue.version===N[te-1]?.version){let W=te;const K=Y(ue);if(K===M)for(;W>0&&N[W-1].version===ue.version;)W--;else if(q.includes(K))for(;W>0&&N[W-1].version===ue.version&&Y(N[W-1])!==M;)W--;W!==te&&(N.splice(te,1),N.splice(W,0,ue))}}return N}e.sortExtensionVersions=U;function ne(N,M,q){N.telemetryData={index:M,querySource:q,queryActivityId:N.queryContext?.[t]}}function se(N,M,q,te){const ue=N.versions[0],W={manifest:ee(M,o.Manifest),readme:ee(M,o.Details),changelog:ee(M,o.Changelog),license:ee(M,o.License),repository:z(M),download:ie(M),icon:ee(M,o.Icon),signature:ee(M,o.Signature),coreTranslations:O(M)};return{identifier:{id:(0,v.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:M.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(ue),description:N.shortDescription||"",installCount:R(N.statistics,"install"),rating:R(N.statistics,"averagerating"),ratingCount:R(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:q,assets:W,properties:{dependencies:F(M,c.Dependency),extensionPack:F(M,c.ExtensionPack),engine:Z(M),localizedLanguages:x(M),targetPlatform:Y(M),isPreReleaseVersion:$(M)},hasPreReleaseVersion:$(ue),hasReleaseVersion:!0,preview:be(N.flags),isSigned:!!W.signature,queryContext:te}}let de=class{constructor(M,q,te,ue,W,K,_,V){this.k=q,this.l=te,this.n=ue,this.o=W,this.q=K,this.u=_,this.w=V;const Q=_.extensionsGallery,G=Q?.servicePPEUrl&&V.getValue("_extensionsGallery.enablePPE");this.d=G?Q.servicePPEUrl:Q?.serviceUrl,this.g=G?void 0:Q?.searchUrl,this.h=Q?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(_.version,_,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,q,te){const ue=A.CancellationToken.isCancellationToken(q)?{}:q,W=A.CancellationToken.isCancellationToken(q)?q:te,K=[],_=[],V=[],Q=[];let G=!0;for(const pe of M){pe.uuid?_.push(pe.uuid):K.push(pe.id);const Pe=!!(pe.version||pe.preRelease);V.push({id:pe.id,uuid:pe.uuid,includePreRelease:Pe}),pe.version&&Q.push({id:pe.id,uuid:pe.uuid,version:pe.version}),G=G&&!!pe.hasPreRelease&&!Pe}if(!_.length&&!K.length)return[];let X=new g().withPage(1,M.length);_.length&&(X=X.withFilter(i.ExtensionId,..._)),K.length&&(X=X.withFilter(i.ExtensionName,...K)),(ue.queryAllVersions||G)&&(X=X.withFlags(X.flags,r.IncludeVersions)),ue.source&&(X=X.withSource(ue.source));const{extensions:ce}=await this.z(X,{targetPlatform:ue.targetPlatform??k,includePreRelease:V,versions:Q,compatible:!!ue.compatible},W);return ue.source&&ce.forEach((pe,Pe)=>ne(pe,Pe,ue.source)),ce}async getCompatibleExtension(M,q,te){if((0,S.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(M,q,te))return M;const ue=new g().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,M.identifier.uuid),{extensions:W}=await this.z(ue,{targetPlatform:te,compatible:!0,includePreRelease:q},A.CancellationToken.None);return W[0]||null}async isExtensionCompatible(M,q,te){if(!(0,S.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,te)||!q&&M.properties.isPreReleaseVersion)return!1;let ue=M.properties.engine;if(!ue){const W=await this.getManifest(M,A.CancellationToken.None);if(!W)throw new Error("Manifest was not found");ue=W.engines.vscode}return(0,b.isEngineValid)(ue,this.u.version,this.u.date)}async y(M,q,te,ue,W){if(!(0,S.isTargetPlatformCompatible)(Y(M),ue,W)||q!=="any"&&$(M)!==(q==="prerelease"))return!1;if(te)try{const K=await this.E(M);if(!(0,b.isEngineValid)(K,this.u.version,this.u.date))return!1}catch(K){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,a.getErrorMessage)(K)),!1}return!0}async query(M,q){let te=M.text||"";const ue=M.pageSize??50;let W=new g().withPage(1,ue);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,X,ce)=>(W=W.withFilter(i.Category,ce||X),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,X,ce)=>(W=W.withFilter(i.Tag,ce||X),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(i.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),W=W.withFilter(i.SearchText,te)),W=W.withSortBy(0)):M.ids?W=W.withFilter(i.ExtensionId,...M.ids):M.names?W=W.withFilter(i.ExtensionName,...M.names):W=W.withSortBy(4),typeof M.sortBy=="number"&&(W=W.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(W=W.withSortOrder(M.sortOrder)),M.source&&(W=W.withSource(M.source));const K=async(G,X)=>{const{extensions:ce,total:pe}=await this.z(G,{targetPlatform:k,compatible:!1,includePreRelease:!!M.includePreRelease},X);return ce.forEach((Pe,Ae)=>ne(Pe,(G.pageNumber-1)*G.pageSize+Ae,M.source)),{extensions:ce,total:pe}},{extensions:_,total:V}=await K(W,q),Q=async(G,X)=>{if(X.isCancellationRequested)throw new a.CancellationError;const{extensions:ce}=await K(W.withPage(G+1),X);return ce};return{firstPage:_,total:V,pageSize:W.pageSize,getPage:Q}}async z(M,q,te){const ue=M.flags;!!(M.flags&r.IncludeLatestVersionOnly)&&!!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(M.flags&r.IncludeLatestVersionOnly)&&!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags,r.IncludeLatestVersionOnly)),q.versions?.length&&(M=M.withFlags(M.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),M=M.withFlags(M.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:W,total:K,context:_}=await this.B(M,te);if(!(M.flags&r.IncludeLatestVersionOnly)){const X=[];for(const ce of W){const pe=await this.A(ce,q,_);pe&&X.push(pe)}return{extensions:X,total:K}}const Q=[],G=new Map;for(let X=0;X<W.length;X++){const ce=W[X],pe={id:(0,v.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},Pe=(0,P.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Ne=>(0,v.areSameExtensions)(Ne,pe))?.includePreRelease;if(q.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(H(ce),q.targetPlatform))continue;const Ae=await this.A(ce,q,_);!Ae||Ae.properties.isPreReleaseVersion&&(!Pe||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==q.targetPlatform&&Ae.hasPreReleaseVersion?G.set(ce.extensionId,X):Q.push([X,Ae])}if(G.size){const X=new Date().getTime(),ce=new g().withFlags(ue&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,G.size).withFilter(i.ExtensionId,...G.keys()),{extensions:pe}=await this.z(ce,q,te);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-X,count:G.size});for(const Pe of pe){const Ae=G.get(Pe.identifier.uuid);Q.push([Ae,Pe])}}return{extensions:Q.sort((X,ce)=>X[0]-ce[0]).map(([,X])=>X),total:K}}async A(M,q,te){const ue={id:(0,v.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},W=q.versions?.find(Q=>(0,v.areSameExtensions)(Q,ue))?.version,K=(0,P.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Q=>(0,v.areSameExtensions)(Q,ue))?.includePreRelease,_=H(M),V=U(M.versions,q.targetPlatform);if(q.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(_,q.targetPlatform))return null;for(let Q=0;Q<V.length;Q++){const G=V[Q];if(!(W&&G.version!==W)){if(await this.y(G,K?"any":"release",q.compatible,_,q.targetPlatform))return se(M,G,_,te);if(W&&G.version===W)return null}}return W||q.compatible?null:se(M,M.versions[0],_)}async B(M,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(r.Unpublished));const te=await this.j,ue=JSON.stringify(M.raw),W={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},K=new Date().getTime();let _,V,Q=0;try{if(_=await this.k.request({type:"POST",url:this.g&&M.criteria.some(X=>X.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ue,headers:W},q),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:Q};const G=await(0,h.asJson)(_);if(G){const X=G.results[0],ce=X.extensions,pe=X.resultMetadata&&X.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return Q=pe&&pe.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:Q,context:{[t]:_.res.headers.activityid}}}return{galleryExtensions:[],total:Q}}catch(G){throw V=G,G}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-K,success:!!_&&(0,h.isSuccess)(_),responseBodySize:_?.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:V?(0,a.isCancellationError)(V)?"canceled":(0,a.getErrorMessage)(V).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(M,q,te,ue){if(!this.isEnabled())return;const W=I.isWeb?this.x(`/itemName/${M}.${q}/version/${te}/statType/${ue==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${q}/${te}/stats?statType=${ue}`),K=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",V={...await this.j,Accept:K};try{await this.k.request({type:"POST",url:W,headers:V},A.CancellationToken.None)}catch{}}async download(M,q,te){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const ue=(0,v.getGalleryExtensionTelemetryData)(M),W=new Date().getTime(),K=X=>this.o.publicLog("galleryService:downloadVSIX",{...ue,duration:X}),_=te===2?"install":te===3?"update":"",V=_?{uri:`${M.assets.download.uri}${w.URI.parse(M.assets.download.uri).query?"&":"?"}${_}=true`,fallbackUri:`${M.assets.download.fallbackUri}${w.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${_}=true`}:M.assets.download,Q=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,G=await this.D(V,Q?{headers:Q}:void 0);await this.q.writeFile(q,G.stream),K(new Date().getTime()-W)}async downloadSignatureArchive(M,q){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const te=await this.D(M.assets.signature);await this.q.writeFile(q,te.stream)}async getReadme(M,q){if(M.assets.readme){const te=await this.D(M.assets.readme,{},q);return await(0,h.asTextOrError)(te)||""}return""}async getManifest(M,q){if(M.assets.manifest){const te=await this.D(M.assets.manifest,{},q),ue=await(0,h.asTextOrError)(te);return ue?JSON.parse(ue):null}return null}async C(M,q){const te=ee(M,o.Manifest);if(!te)throw new Error("Manifest was not found");const ue={"Accept-Encoding":"gzip"},W=await this.D(te,{headers:ue});return await(0,h.asJson)(W)}async getCoreTranslation(M,q){const te=M.assets.coreTranslations.filter(ue=>ue[0]===q.toUpperCase())[0];if(te){const ue=await this.D(te[1]),W=await(0,h.asTextOrError)(ue);return W?JSON.parse(W):null}return null}async getChangelog(M,q){if(M.assets.changelog){const te=await this.D(M.assets.changelog,{},q);return await(0,h.asTextOrError)(te)||""}return""}async getAllCompatibleVersions(M,q,te){let ue=new g().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ue=ue.withFilter(i.ExtensionId,M.identifier.uuid):ue=ue.withFilter(i.ExtensionName,M.identifier.id);const{galleryExtensions:W}=await this.B(ue,A.CancellationToken.None);if(!W.length)return[];const K=H(W[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(K,te))return[];const _=[];await Promise.all(W[0].versions.map(async G=>{try{await this.y(G,q?"any":"release",!0,K,te)&&_.push(G)}catch{}}));const V=[],Q=new Set;for(const G of U(_,te))Q.has(G.version)||(Q.add(G.version),V.push({version:G.version,date:G.lastUpdated,isPreReleaseVersion:$(G)}));return V}async D(M,q={},te=A.CancellationToken.None){const ue=await this.j,W={type:"GET"},K={...ue,...q.headers||{}};q={...q,...W,headers:K};const _=M.uri,V=M.fallbackUri,Q={...q,url:_};try{const G=await this.k.request(Q,te);if(G.res.statusCode===200)return G;const X=await(0,h.asTextOrError)(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${X}`)}catch(G){if((0,a.isCancellationError)(G))throw G;const X=(0,a.getErrorMessage)(G);this.o.publicLog2("galleryService:cdnFallback",{url:_,message:X});const ce={...q,url:V};return this.k.request(ce,te)}}async E(M){let q=Z(M);if(!q){const te=await this.C(M,A.CancellationToken.None);if(!te)throw new Error("Manifest was not found");q=te.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,h.asJson)(M),te=[],ue={};if(q){for(const W of q.malicious)te.push({id:W});if(q.migrateToPreRelease)for(const[W,K]of Object.entries(q.migrateToPreRelease))(!K.engine||(0,b.isEngineValid)(K.engine,this.u.version,this.u.date))&&(ue[W.toLowerCase()]={disallowInstall:!0,extension:{id:K.id,displayName:K.displayName,autoMigrate:{storage:!!K.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[W,K]of Object.entries(q.deprecated))K&&(ue[W.toLowerCase()]=(0,P.isBoolean)(K)?{}:K)}return{malicious:te,deprecated:ue}}};de=Le([Re(1,h.IRequestService),Re(2,p.ILogService),Re(3,T.IEnvironmentService),Re(4,C.ITelemetryService),Re(5,f.IFileService),Re(6,u.IProductService),Re(7,y.IConfigurationService)],de);let re=class extends de{constructor(M,q,te,ue,W,K,_,V){super(M,q,te,ue,W,K,_,V)}};re=Le([Re(0,d.IStorageService),Re(1,h.IRequestService),Re(2,p.ILogService),Re(3,T.IEnvironmentService),Re(4,C.ITelemetryService),Re(5,f.IFileService),Re(6,u.IProductService),Re(7,y.IConfigurationService)],re),e.ExtensionGalleryService=re;let j=class extends de{constructor(M,q,te,ue,W,K,_){super(void 0,M,q,te,ue,W,K,_)}};j=Le([Re(0,h.IRequestService),Re(1,p.ILogService),Re(2,T.IEnvironmentService),Re(3,C.ITelemetryService),Re(4,f.IFileService),Re(5,u.IProductService),Re(6,y.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j}),define(ve[124],Ee([1,0,8,4,25,17,12,228,36,34]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let T=class extends y.UserDataProfilesService{constructor(b,f,p,u){super(f,p,b,u),this.a=f}N(){return this.r.extUri.joinPath(A.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};T=Le([Re(0,w.IUriIdentityService),Re(1,a.INativeEnvironmentService),Re(2,I.IFileService),Re(3,D.ILogService)],T),e.ServerUserDataProfilesService=T;let S=class xt extends T{constructor(b,f,p,u,h){super(f,p,u,h),this.Q=b}I(){return this.Q.getItem(xt.b,[]).map(f=>({...f,location:(0,E.isString)(f.location)?this.r.extUri.joinPath(this.profilesHome,f.location):A.URI.revive(f.location)}))}L(){const b=this.Q.getItem(xt.c,{});return this.Q.getItem(xt.P,!1)?b:this.H(b)}N(){return this.r.extUri.joinPath(A.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S.P="profileAssociationsMigration",S=Le([Re(0,P.IStateService),Re(1,w.IUriIdentityService),Re(2,a.INativeEnvironmentService),Re(3,I.IFileService),Re(4,D.ILogService)],S),e.UserDataProfilesService=S}),define(ve[125],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,E.createDecorator)("extensionHostStatusService");class A{constructor(){this.a=new Map}setExitInfo(I,D){this.a.set(I,D)}getExitInfo(I){return this.a.get(I)||null}}e.ExtensionHostStatusService=A}),define(ve[251],Ee([1,0,6,14]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function a(D){let P=0,w=0,y=0;D>=1e3&&(y=Math.floor(D/1e3),D-=y*1e3),y>=60&&(w=Math.floor(y/60),y-=w*60),w>=60&&(P=Math.floor(w/60),w-=P*60);const T=P?`${P}h`:"",S=w?`${w}m`:"",v=y?`${y}s`:"",b=D?`${D}ms`:"";return`${T}${S}${v}${b}`}class I{constructor(P,w,y,T){this.i=P,this.j=w,this.a=new E.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=y,this.protocol=T,this.e=!1,this.f=new A.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${a(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new A.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${a(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${a(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${a(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,w,y){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,y),this.protocol.endAcceptReconnection()}}e.ManagementConnection=I}),define(ve[83],Ee([1,0,31,13,7,152,51]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const P=a.join(A.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function y(f){return new Promise(p=>E.exists(f,p))}function T(f,p){return y(P).then(u=>{if(!u||!D.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const h=`${f}||${p}`;let m=w.get(h);return m||(m=I.getNLSConfiguration(D.default.commit,p,P,f).then(d=>(S.is(d)&&(d._languagePackSupport=!0),d.locale!=="en"&&d.locale!=="en-us"&&Object.keys(d.availableLanguages).length===0&&w.delete(h),d)),w.set(h,m)),m})}e.getNLSConfiguration=T;var S;(function(f){function p(u){const h=u;return h&&typeof h._languagePackId=="string"}f.is=p})(S=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const v=async f=>{try{const p=b(await E.promises.readFile(f,"utf8"));return JSON.parse(p).locale}catch(p){return p.code!=="ENOENT"&&console.warn(p),"en"}};e.getLocaleFromConfig=v;const b=f=>{const p=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return f.replace(p,(u,h,m,d,C)=>{if(d)return"";if(C){const k=C.length;return k>2&&C[k-1]===`
`?C[k-2]==="\r"?`\r
`:`
`:""}else return u})}}),define(ve[126],Ee([1,0,20,4,25,43,54,33,17,5,12,26,36,34,83]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends D.AbstractExtensionsScannerService{constructor(h,m,d,C,k,t,r,n){super(A.URI.file(k.builtinExtensionsPath),A.URI.file(k.extensionsPath),(0,E.joinPath)(k.userHome,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(A.URI.file(k.userDataPath),P.MANIFEST_CACHE_FOLDER),h,m,d,C,k,t,r,n),this.M=k}async f(h){const m=await(0,f.getNLSConfiguration)(h,this.M.userDataPath);if(f.InternalNLSConfiguration.is(m))try{const d=await this.r.readFile(A.URI.file(m._translationsConfigFile));return JSON.parse(d.value.toString())}catch{}return Object.create(null)}};p=Le([Re(0,b.IUserDataProfilesService),Re(1,I.IExtensionsProfileScannerService),Re(2,w.IFileService),Re(3,T.ILogService),Re(4,a.INativeEnvironmentService),Re(5,S.IProductService),Re(6,v.IUriIdentityService),Re(7,y.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(ve[252],Ee([1,0,253,31,7,21,13,22]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const w=/^[0-9A-Za-z_-]+$/;var y;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(y=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(m){return!0}}e.NoneServerConnectionToken=T;class S{constructor(m){this.value=m,this.type=1}validate(m){return m===this.value}}e.OptionalServerConnectionToken=S;class v{constructor(m){this.value=m,this.type=2}validate(m){return m===this.value}}e.MandatoryServerConnectionToken=v;class b{constructor(m){this.message=m}}e.ServerConnectionTokenParseError=b;async function f(h,m){const d=h["without-connection-token"],C=h["connection-token"],k=h["connection-token-file"],t=h.compatibility==="1.63";if(d)return typeof C<"u"||typeof k<"u"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof k<"u"){if(typeof C<"u")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let r;try{r=A.readFileSync(k).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${k}'.`)}return w.test(r)?new v(r):new b(`The connection token defined in '${k} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof C<"u"?w.test(C)?t?new S(C):new v(C):new b(`The connection token '${C} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new S(await m())):new v(await m())}e.parseServerConnectionToken=f;async function p(h){return f(h,async()=>{if(!h["user-data-dir"])return(0,I.generateUuid)();const d=a.join(h["user-data-dir"],"token");try{const t=(await P.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(w.test(t))return t}catch{}const C=(0,I.generateUuid)();try{await P.Promises.writeFile(d,C,{mode:384})}catch{}return C})}e.determineServerConnectionToken=p;function u(h,m,d){if(h.validate(d.query[D.connectionTokenQueryName]))return!0;const C=E.parse(m.headers.cookie||"");return h.validate(C[D.connectionTokenCookieName])}e.requestHasValidConnectionToken=u}),define(ve[41],Ee([1,0,192,201,61,5,25]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:E.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:E.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:E.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:E.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:E.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:E.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:E.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:E.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:E.localize(8,null)},"user-data-dir":a.OPTIONS["user-data-dir"],"enable-smoke-test-driver":a.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":a.OPTIONS["disable-telemetry"],"disable-workspace-trust":a.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:a.OPTIONS.log,logsPath:a.OPTIONS.logsPath,"force-disable-user-env":a.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:E.localize(9,null)},"default-workspace":{type:"string",description:E.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":a.OPTIONS["extensions-dir"],"extensions-download-dir":a.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":a.OPTIONS["builtin-extensions-dir"],"install-extension":a.OPTIONS["install-extension"],"install-builtin-extension":a.OPTIONS["install-builtin-extension"],"uninstall-extension":a.OPTIONS["uninstall-extension"],"list-extensions":a.OPTIONS["list-extensions"],"locate-extension":a.OPTIONS["locate-extension"],"show-versions":a.OPTIONS["show-versions"],category:a.OPTIONS.category,force:a.OPTIONS.force,"do-not-sync":a.OPTIONS["do-not-sync"],"pre-release":a.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:E.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:a.OPTIONS.help,version:a.OPTIONS.version,"locate-shell-integration-path":a.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:a.OPTIONS._},e.IServerEnvironmentService=(0,I.refineServiceDecorator)(D.IEnvironmentService);class P extends A.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=P}),define(ve[254],Ee([1,0,74,12,41,26,216,21,18]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let y=class extends D.BaseCredentialsMainService{constructor(S,v,b){super(S),this.k=v,this.l=b,this.k.args["github-auth"]&&this.n(this.k.args["github-auth"]).catch(f=>{this.g.error("Failed to store provided GitHub token",f)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.l.urlProtocol}-server`)}async h(){if(this.f)return this.f;if(this.k.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((S,v)=>{ae(["keytar"],S,v)}),await this.f.findCredentials("test-keytar-loads")}catch(S){this.g.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${S.message??S}`),this.f=new E.InMemoryCredentialsProvider}return this.f}async n(S){const v="vscode.github-authentication",b=`${await this.getSecretStoragePrefix()}${v}`,f="github.auth",u=[["read:user","user:email","repo"]].map(d=>({id:(0,P.generateUuid)(),scopes:d.sort(),accessToken:S})),h=await this.getPassword(b,f);let m;if(h)try{const d=JSON.parse(h);d.content=JSON.parse(d.content),m=d}catch(d){this.g.error("Failed to parse existing GitHub credentials",d)}return m?.content&&(m.content=m.content.filter(d=>{const C=d.scopes.sort();return!u.find(k=>(0,w.equals)(C,k.scopes)&&k.account?.label===d.account?.label)})),this.setPassword(b,f,JSON.stringify({extensionId:v,...m||{},content:JSON.stringify([...u,...m?.content||[]])}))}};y=Le([Re(0,A.ILogService),Re(1,a.IServerEnvironmentService),Re(2,I.IProductService)],y),e.CredentialsWebMainService=y}),define(ve[255],Ee([1,0,285,239,256,29]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class D extends E.AppInsightsCore{constructor(w){super(),this.a=w}track(w){const y=w.baseData||{};y.properties||(y.properties={}),y.measurements||(y.measurements={});try{const T=I.cpus();y.measurements.cores=T.length,y.properties["common.cpuModel"]=T[0].model}catch{}try{y.measurements.memoryFree=I.freemem(),y.measurements.memoryTotal=I.totalmem()}catch{}try{y.properties["common.shell"]=I.userInfo().shell,y.properties["common.release"]=I.release(),y.properties["common.arch"]=I.arch()}catch{}try{const T=(/^http:/.test(this.a)?a:A).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});T.on("error",()=>{}),T.write(JSON.stringify(y)),T.end()}catch{}}}e.TelemetryClient=D}),define(ve[257],Ee([1,0,31,94,79,253,117,37,56,3,12,41,7,13,21,26,53,19,4,15,8,83,66]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const r={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(z,ie,ee,F){ie.writeHead(ee,{"Content-Type":"text/plain"}),ie.end(F)}e.serveError=n;var i;(function(z){z[z.NO_CACHING=0]="NO_CACHING",z[z.ETAG=1]="ETAG",z[z.NO_EXPIRY=2]="NO_EXPIRY"})(i=e.CacheControl||(e.CacheControl={}));async function o(z,ie,ee,F,Z,$){try{const x=await E.promises.stat(z);if(ie===1){const le=`W/"${[x.ino,x.size,x.mtime.getTime()].join("-")}"`;if(F.headers["if-none-match"]===le)return Z.writeHead(304),void Z.end();$.Etag=le}else ie===2?$["Cache-Control"]="public, max-age=31536000":ie===0&&($["Cache-Control"]="no-store");$["Content-Type"]=r[(0,v.extname)(z)]||(0,w.getMediaMime)(z)||"text/plain",Z.writeHead(200,$),(0,E.createReadStream)(z).pipe(Z)}catch(x){return x.code!=="ENOENT"?(ee.error(x),console.error(x.toString())):console.error(`File not found: ${z}`),Z.writeHead(404,{"Content-Type":"text/plain"}),void Z.end("Not found")}}e.serveFile=o;const c=(0,v.dirname)(b.FileAccess.asFileUri("").fsPath);let l=class{constructor(ie,ee,F,Z,$){this.f=ie,this.g=ee,this.h=F,this.i=Z,this.j=$,this.a=this.j.extensionsGallery?.resourceUrlTemplate?m.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const x=(0,t.getRemoteServerRootPath)($);this.b=`${x}/static`,this.c=`${x}/callback`,this.d="/web-extension-resource"}async handle(ie,ee,F){try{const Z=F.pathname;return Z.startsWith(this.b)&&Z.charCodeAt(this.b.length)===47?this.k(ie,ee,F):Z==="/"?this.n(ie,ee,F):Z===this.c?this.p(ee):Z.startsWith(this.d)&&Z.charCodeAt(this.d.length)===47?this.m(ie,ee,F):n(ie,ee,404,"Not found.")}catch(Z){return this.h.error(Z),console.error(Z.toString()),n(ie,ee,500,"Internal Server Error.")}}async k(ie,ee,F){const Z=Object.create(null),x=decodeURIComponent(F.pathname).substring(this.b.length+1),le=(0,v.join)(c,x);return(0,P.isEqualOrParent)(le,c,!y.isLinux)?o(le,this.g.isBuilt?2:1,this.h,ie,ee,Z):n(ie,ee,400,"Bad request.")}l(ie){const ee=ie.authority.indexOf(".");return ee!==-1?ie.authority.substring(ee+1):void 0}async m(ie,ee,F){if(!this.a)return n(ie,ee,500,"No extension gallery service configured.");const Z=decodeURIComponent(F.pathname),$=(0,v.normalize)(Z.substring(this.d.length+1)),x=m.URI.parse($).with({scheme:this.a.scheme,authority:$.substring(0,$.indexOf("/")),path:$.substring($.indexOf("/")+1)});if(this.l(this.a)!==this.l(x))return n(ie,ee,403,"Request Forbidden");const le={},be=de=>{const re=ie.headers[de];re&&((0,C.isString)(re)||re[0])?le[de]=(0,C.isString)(re)?re:re[0]:de!==de.toLowerCase()&&be(de.toLowerCase())};be("X-Client-Name"),be("X-Client-Version"),be("X-Machine-Id"),be("X-Client-Commit");const Y=await this.i.request({type:"GET",url:x.toString(!0),headers:le},h.CancellationToken.None),H=Y.res.statusCode||500;if(H!==200){let de=null;try{de=await(0,u.asTextOrError)(Y)}catch{}return n(ie,ee,H,de||`Request failed with status ${H}`)}const U=Object.create(null),ne=de=>{const re=Y.res.headers[de];re?U[de]=re:de!==de.toLowerCase()&&ne(de.toLowerCase())};ne("Cache-Control"),ne("Content-Type"),ee.writeHead(200,U);const se=await(0,d.streamToBuffer)(Y.stream);return void ee.end(se.buffer)}async n(ie,ee,F){const Z=F.query[b.connectionTokenQueryName];if(typeof Z=="string"){const ue=Object.create(null);ue["Set-Cookie"]=I.serialize(b.connectionTokenCookieName,Z,{sameSite:"lax",maxAge:60*60*24*7});const W=Object.create(null);for(const _ in F.query)_!==b.connectionTokenQueryName&&(W[_]=F.query[_]);const K=a.format({pathname:"/",query:W});return ue.Location=K,ee.writeHead(302,ue),void ee.end()}const $="remote";if(!$)return n(ie,ee,400,"Bad request.");function x(ue){return JSON.stringify(ue).replace(/"/g,"&quot;")}let le;this.g.args["enable-smoke-test-driver"]&&(le=!1);const be=ue=>ue&&m.URI.file(A.resolve(ue)).with({scheme:b.Schemas.vscodeRemote,authority:$}),Y=b.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,H=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,f.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,U=(0,e.relativeRoot)((0,e.getOriginalUrl)(ie)),ne=(0,e.relativePath)((0,e.getOriginalUrl)(ie)),se=this.g.args.locale||await(0,k.getLocaleFromConfig)(this.g.argvResource.fsPath),de=await(0,k.getNLSConfiguration)(se,this.g.userDataPath),re={remoteAuthority:$,webviewEndpoint:ne+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:le,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:be(this.g.args["default-folder"]),workspaceUri:be(this.g.args["default-workspace"]),productConfiguration:{codeServerVersion:this.j.codeServerVersion,rootEndpoint:U,updateEndpoint:this.g.args["disable-update-check"]?void 0:U+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?U+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??U+"/proxy/{{port}}/",serviceWorker:{scope:ne+"/",path:U+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery},callbackRoute:this.c},j=this.j.extensionsGallery?.nlsBaseUrl,N={WORKBENCH_WEB_CONFIGURATION:x(re),WORKBENCH_AUTH_SESSION:H?x(H):"",WORKBENCH_WEB_BASE_URL:ne+this.b,WORKBENCH_NLS_BASE_URL:ne+(j?`${j}${j.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:U,VS_BASE:ne,NLS_CONFIGURATION:x(de)};let M;try{M=(await E.promises.readFile(Y)).toString().replace(/\{\{([^}]+)\}\}/g,(W,K)=>N[K]??"undefined")}catch{return ee.writeHead(404,{"Content-Type":"text/plain"}),void ee.end("Not found")}const q=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(M).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),te={"Content-Type":"text/html","Content-Security-Policy":q};return this.f.type!==0&&(te["Set-Cookie"]=I.serialize(b.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),ee.writeHead(200,te),void ee.end(M)}o(ie){const ee=/<script>([\s\S]+?)<\/script>/img,F=[];let Z;for(;Z=ee.exec(ie);){const $=D.createHash("sha256"),x=Z[1].replace(/\r\n/g,`
`),le=$.update(Buffer.from(x)).digest().toString("base64");F.push(`'sha256-${le}'`)}return F}async p(ie){const ee=b.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,F=(await E.promises.readFile(ee)).toString(),Z=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(F).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ie.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":Z}),void ie.end(F)}};l=Le([Re(1,S.IServerEnvironmentService),Re(2,T.ILogService),Re(3,u.IRequestService),Re(4,p.IProductService)],l),e.WebClientServer=l;const s=(z,ie=!1)=>z.replace(/\/\/+/g,"/").replace(/\/+$/,ie?"/":"");e.normalizeUrlPath=s;const g=z=>{const ie=(z.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(ie>1?"../".repeat(ie-1):""))};e.relativeRoot=g;const R=z=>{const ie=z.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+ie[ie.length-1])};e.relativePath=R;const O=z=>z.originalUrl||z.url;e.getOriginalUrl=O}),define(ve[258],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class A{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=A}),define(ve[67],Ee([1,0,72]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(I){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:I,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function a(I){return new E.URITransformer(A(I))}e.createURITransformer=a}),define(ve[259],Ee([1,0,4,67,64,7,219]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class P extends D.AbstractDiskFileSystemProviderChannel{constructor(T,S){super(new a.DiskFileSystemProvider(T),T),this.H=S,this.G=new Map,this.B(this.a)}c(T){let S=this.G.get(T.remoteAuthority);return S||(S=(0,A.createURITransformer)(T.remoteAuthority),this.G.set(T.remoteAuthority,S)),S}f(T,S,v=!1){if(v&&S.path==="/vscode-resource"&&S.query){const b=JSON.parse(S.query).requestResourcePath;return E.URI.from({scheme:"file",path:b})}return E.URI.revive(T.transformIncoming(S))}F(T,S){return new w(T,S,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=P;class w extends D.AbstractSessionFileWatcher{constructor(T,S,v,b){super(T,S,v,b)}i(T){const S=T.args["file-watcher-polling"];if(S){const v=S.split(I.delimiter),b=Number(v[0]);if(b>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:b}}}j(T){if(T.extensionsPath)return[I.posix.join(T.extensionsPath,"**")]}}}),define(ve[84],Ee([1,0,194,8,4,2,5,39,17,13,38,161,58]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function p(re){const j=re;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=p;function u(re,j,N){for(const M of N.visibleEditorPanes)if(M.group.id===j&&re.matches(M.input))return M.getViewState()}e.findViewStateForEditor=u;function h(re){if(s(re))return!1;const j=re;return a.URI.isUri(j?.resource)}e.isResourceEditorInput=h;function m(re){if(s(re))return!1;const j=re;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=m;function d(re){if(s(re)||m(re))return!1;const j=re;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function C(re){if(s(re))return!1;const j=re;return j?j.resource===void 0||j.resource.scheme===y.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;const k=/Untitled-\d+/;function t(re){return re.scheme===y.Schemas.untitled&&re.path.length>1&&!k.test(re.path)}e.isUntitledWithAssociatedResource=t;function r(re){if(s(re))return!1;const j=re;return a.URI.isUri(j?.base?.resource)&&a.URI.isUri(j?.input1?.resource)&&a.URI.isUri(j?.input2?.resource)&&a.URI.isUri(j?.result?.resource)}e.isResourceMergeEditorInput=r;var n;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(n=e.Verbosity||(e.Verbosity={}));var i;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(j,N){let M=this.a.get(j);return M||(M={source:j,label:N},this.a.set(j,M)),M.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.SaveSourceRegistry=new o;var c;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends I.Disposable{}e.AbstractEditorInput=l;function s(re){return re instanceof l}e.isEditorInput=s;function g(re){const j=re;return a.URI.isUri(j?.preferredResource)}function R(re){const j=re;return s(j?.primary)&&s(j?.secondary)}e.isSideBySideEditorInput=R;function O(re){const j=re;return s(j?.modified)&&s(j?.original)}e.isDiffEditorInput=O;function z(re,j,N,M,q){return de(M,[(0,S.toAction)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const te={...N,limits:{size:Number.MAX_VALUE}};re.openEditor(j,te)}}),(0,S.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=z;function ie(re){return s(re?.editor)}e.isEditorInputWithOptions=ie;function ee(re){const j=re;return ie(re)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=ee;function F(re){const j=re;return typeof j?.groupId=="number"&&s(j.editor)}e.isEditorIdentifier=F;var Z;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(Z=e.EditorCloseContext||(e.EditorCloseContext={}));var $;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LOCKED=2]="GROUP_LOCKED",re[re.EDITOR_OPEN=3]="EDITOR_OPEN",re[re.EDITOR_CLOSE=4]="EDITOR_CLOSE",re[re.EDITOR_MOVE=5]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=7]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=9]="EDITOR_PIN",re[re.EDITOR_STICKY=10]="EDITOR_STICKY",re[re.EDITOR_DIRTY=11]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})($=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class le{getOriginalUri(j,N){if(!j)return;if(r(j))return e.EditorResourceAccessor.getOriginalUri(j.result,N);if(N?.supportSideBySide){const{primary:q,secondary:te}=this.a(j);if(q&&te){if(N?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===x.ANY)return this.getOriginalUri(q,{filterByScheme:N.filterByScheme})??this.getOriginalUri(te,{filterByScheme:N.filterByScheme});j=N.supportSideBySide===x.PRIMARY?q:te}}if(m(j)||d(j)||r(j))return;const M=g(j)?j.preferredResource:j.resource;return!M||!N||!N.filterByScheme?M:this.b(M,N.filterByScheme)}a(j){return R(j)||d(j)?{primary:j.primary,secondary:j.secondary}:O(j)||m(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,N){if(!j)return;if(r(j))return e.EditorResourceAccessor.getCanonicalUri(j.result,N);if(N?.supportSideBySide){const{primary:q,secondary:te}=this.a(j);if(q&&te){if(N?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===x.ANY)return this.getCanonicalUri(q,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:N.filterByScheme});j=N.supportSideBySide===x.PRIMARY?q:te}}if(m(j)||d(j)||r(j))return;const M=j.resource;return!M||!N||!N.filterByScheme?M:this.b(M,N.filterByScheme)}b(j,N){if(Array.isArray(N)){if(N.some(M=>j.scheme===M))return j}else if(N===j.scheme)return j}}e.EditorResourceAccessor=new le;var be;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(be=e.CloseDirection||(e.CloseDirection={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(j){const N=this.a=j.get(D.IInstantiationService);for(const[M,q]of this.c)this.e(M,q,N);this.c.clear()}e(j,N,M){const q=M.createInstance(N);this.d.set(j,q)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(j,N){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,N,this.a):this.c.set(j,N),(0,I.toDisposable)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function H(re,j,N){return!re||!re.length?[]:await Promise.all(re.map(async M=>{const q=a.URI.revive(M.fileUri);if(!q){N.info("Cannot resolve the path because it is not valid.",M);return}if(!await j.canHandleResource(q)){N.info("Cannot resolve the path because it cannot be handled",M);return}let ue=M.exists,W=M.type;if(typeof ue!="boolean"||typeof W!="number")try{W=(await j.stat(q)).isDirectory?w.FileType.Directory:w.FileType.Unknown,ue=!0}catch(_){N.error(_),ue=!1}if(!ue&&M.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",M);return}if(W===w.FileType.Directory){N.info("Cannot resolve the path because it is a directory",M);return}const K={...M.options,pinned:!0};return ue?{resource:q,options:K}:{resource:q,options:K,forceUntitled:!0}}))}e.pathsToEditors=H;var U;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function ne(re){const j=re;if(!j)return!1;const N=j;if(N.modified)return ne(N.modified);const M=j;return!!(M.contributionsState&&M.viewState&&Array.isArray(M.cursorState))}e.isTextEditorViewState=ne;function se(re){return(0,T.isErrorWithActions)(re)}e.isEditorOpenError=se;function de(re,j,N){const M=(0,T.createErrorWithActions)(re,j);return M.forceMessage=N?.forceMessage,M.forceSeverity=N?.forceSeverity,M.allowDialog=N?.allowDialog,M}e.createEditorOpenError=de}),define(ve[127],Ee([1,0,15,71,55,56,13,7,3,104]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var m;(function(x){x.scheme=D.Schemas.vscodeNotebookCell;const le=["W","X","Y","Z","a","b","c","d","e","f"],be=new RegExp(`^[${le.join("")}]+`),Y=7;function H(j,N){const M=N.toString(Y),te=`${M.length<le.length?le[M.length-1]:"z"}${M}s${(0,E.encodeBase64)(E.VSBuffer.fromString(j.scheme),!0,!0)}`;return j.with({scheme:x.scheme,fragment:te})}x.generate=H;function U(j){if(j.scheme!==x.scheme)return;const N=j.fragment.indexOf("s");if(N<0)return;const M=parseInt(j.fragment.substring(0,N).replace(be,""),Y),q=(0,E.decodeBase64)(j.fragment.substring(N+1)).toString();if(!isNaN(M))return{handle:M,notebook:j.with({scheme:q,fragment:null})}}x.parse=U;function ne(j,N){return j.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${j.scheme!==D.Schemas.file?j.scheme:""}`})}x.generateCellOutputUri=ne;function se(j){if(j.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!N)return;const M=N[1]&&N[1]!==""?N[1]:void 0,q=N[2];return{outputId:M,notebook:j.with({scheme:q||D.Schemas.file,fragment:null})}}x.parseCellOutputUri=se;function de(j,N,M){return x.generate(j,N).with({scheme:M})}x.generateCellPropertyUri=de;function re(j,N){if(j.scheme===N)return x.parse(j.with({scheme:x.scheme}))}x.parseCellPropertyUri=re})(m=e.CellUri||(e.CellUri={}));const d=x=>w.isWindows?x.replace(/\//g,"\\"):x;class C{constructor(le=[],be=e.NOTEBOOK_DISPLAY_ORDER){this.e=be,this.d=[...new Set(le)].map(Y=>({pattern:Y,matches:A.parse(d(Y))}))}sort(le){const be=new Map(a.Iterable.map(le,H=>[H,d(H)]));let Y=[];for(const{matches:H}of this.d)for(const[U,ne]of be)if(H(ne)){Y.push(U),be.delete(U);break}return be.size&&(Y=Y.concat([...be.keys()].sort((H,U)=>this.e.indexOf(H)-this.e.indexOf(U)))),Y}prioritize(le,be){const Y=this.f(le);if(Y===-1){this.d.unshift({pattern:le,matches:A.parse(d(le))});return}const H=new Set(be.map(ne=>this.f(ne,Y)));H.delete(-1);const U=Array.from(H).sort();this.d.splice(Y+1,0,...U.map(ne=>this.d[ne]));for(let ne=U.length-1;ne>=0;ne--)this.d.splice(U[ne],1)}toArray(){return this.d.map(le=>le.pattern)}f(le,be=this.d.length){const Y=d(le);for(let H=0;H<be;H++)if(this.d[H].matches(Y))return H;return-1}}e.MimeTypeDisplayOrder=C;function k(x,le,be,Y=(H,U)=>H===U){const H=[];function U(de,re,j){if(re===0&&j.length===0)return;const N=H[H.length-1];N&&N.start+N.deleteCount===de?(N.deleteCount+=re,N.toInsert.push(...j)):H.push({start:de,deleteCount:re,toInsert:j})}let ne=0,se=0;for(;;){if(ne===x.length){U(ne,0,le.slice(se));break}if(se===le.length){U(ne,x.length-ne,[]);break}const de=x[ne],re=le[se];if(Y(de,re)){ne+=1,se+=1;continue}be(re)?(U(ne,1,[]),ne+=1):(U(ne,0,[re]),se+=1)}return H}e.diff=k,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(x){x.default="default",x.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(x){const le=x;return!!((typeof le.include=="string"||A.isRelativePattern(le.include))&&(typeof le.exclude=="string"||A.isRelativePattern(le.exclude)))}e.isDocumentExcludePattern=r;function n(x,le,be){if(Array.isArray(x.viewType)&&x.viewType.indexOf(le)>=0||x.viewType===le)return!0;if(x.filenamePattern){const Y=r(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,H=r(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(A.match(Y,(0,P.basename)(be.fsPath).toLowerCase()))return!(H&&A.match(H,(0,P.basename)(be.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var i;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(le){return`${o.d}${le}`}static parse(le){if(le.startsWith(o.d))return le.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function c(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=c;const l=new TextDecoder;function s(x){const le=[];let be=!1;for(const Y of x)(le.length===0||be)&&(le.push(Y),be=!0);return z(le),$(E.VSBuffer.concat(le.map(Y=>E.VSBuffer.wrap(Y))))}e.compressOutputItemStreams=s;const g=`${String.fromCharCode(27)}[A`,R=g.split("").map(x=>x.charCodeAt(0)),O=10;function z(x){x.forEach((le,be)=>{if(be===0||le.length<g.length)return;const Y=x[be-1],H=le.subarray(0,g.length);if(H[0]===R[0]&&H[1]===R[1]&&H[2]===R[2]){const U=Y.lastIndexOf(O);if(U===-1)return;x[be-1]=Y.subarray(0,U),x[be]=le.subarray(g.length)}})}function ie(x){let le=x;do x=le,le=x.replace(/[^\n]\x08/gm,"");while(le.length<x.length);return x}function ee(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const le=x.match(/^(.*)\r+/m)[1];let be=x.match(/\r+(.*)$/m)[1];be=be+le.slice(be.length,le.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,be)}return x}const F="\b".charCodeAt(0),Z="\r".charCodeAt(0);function $(x){return!x.buffer.includes(F)&&!x.buffer.includes(Z)?x:E.VSBuffer.fromString(ee(ie(l.decode(x.buffer))))}}),define(ve[260],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,E.createDecorator)("environmentVariableService")}),define(ve[261],Ee([1,0,7,57,3,242,8]),function(ae,e,E,A,a,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(t,r){if(!!r)if(a.isWindows)for(const n in r){let i=n;for(const c in t)if(n.toLowerCase()===c.toLowerCase()){i=c;break}const o=r[n];o!==void 0&&w(t,i,o)}else Object.keys(r).forEach(n=>{const i=r[n];i!==void 0&&w(t,n,i)})}e.mergeEnvironments=P;function w(t,r,n){typeof n=="string"?t[r]=n:delete t[r]}function y(t,r,n,i){t.TERM_PROGRAM="vscode",r&&(t.TERM_PROGRAM_VERSION=r),v(t,i)&&(t.LANG=b(n)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=y;function T(t,r){if(!!r)for(const n of Object.keys(r)){const i=r[n];i&&(t[n]=i)}}async function S(t,r){return await Promise.all(Object.entries(r).map(async([n,i])=>{if(typeof i=="string")try{r[n]=await t(i)}catch{r[n]=i}})),r}function v(t,r){if(r==="on")return!0;if(r==="auto"){const n=t.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=v;function b(t){const r=t?t.split("-"):[],n=r.length;if(n===0)return"en_US.UTF-8";if(n===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};r[0]in i&&r.push(i[r[0]])}else r[1]=r[1].toUpperCase();return r.join("_")+".UTF-8"}e.getLangEnvVariable=b;async function f(t,r,n,i,o,c){if(t.cwd){const s=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,g=await p(s,n);return(0,I.sanitizeCwd)(g||s)}let l;return!t.ignoreConfigurationCwd&&o&&(n&&(o=await p(o,n,c)),o&&(E.isAbsolute(o)?l=o:i&&(l=E.join(i.fsPath,o)))),l||(l=i?i.fsPath:r||""),(0,I.sanitizeCwd)(l)}e.getCwd=f;async function p(t,r,n){if(r)try{return await r(t)}catch(i){n?.error("Could not resolve terminal cwd",i);return}return t}function u(t,r,n){if(!!n)return i=>n.resolveWithEnvironment(r,t,i)}e.createVariableResolver=u;async function h(t,r,n,i,o,c,l,s=a.platform){let g;l&&(g=d(t,"automationShell",s)),g||(g=d(t,"shell",s));let R=g||r;if(s===3&&!n&&i){const O=E.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();R&&R.toLowerCase().indexOf(O)===0&&(R=E.join(i,"System32",R.substr(O.length+1)))}if(R&&s===3&&(R=R.replace(/\//g,"\\")),o)try{R=await o(R)}catch(O){c.error("Could not resolve shell",O)}return R}e.getDefaultShell=h;async function m(t,r,n,i,o=a.platform){if(r&&d(t,"automationShell",o))return[];const c=o===3?"windows":o===1?"osx":"linux";let l=t(`terminal.integrated.shellArgs.${c}`);if(!l)return[];if(typeof l=="string"&&o===3)return n?await n(l):l;if(n){const s=[];for(const g of l)try{s.push(await n(g))}catch(R){i.error(`Could not resolve terminal.integrated.shellArgs.${c}`,R),s.push(g)}l=s}return l}e.getDefaultShellArgs=m;function d(t,r,n=a.platform){return t(`terminal.integrated.${r}.${n===3?"windows":n===1?"osx":"linux"}`)}async function C(t,r,n,i,o,c){const l={};if(t.strictEnv)T(l,t.env);else{T(l,c);const s={...r};n&&(s&&await S(n,s),t.env&&await S(n,t.env)),(0,A.sanitizeProcessEnvironment)(l,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),P(l,s),P(l,t.env),y(l,i,a.language,o)}return l}e.createTerminalEnvironment=C;async function k(t,r,n,i,o,c,l=a.isWindows){let s;if((0,D.isString)(t)?s=t:(s=t.fsPath,l&&c!==1?s=s.replace(/\\/g,"/"):!l&&c===1&&(s=s.replace(/\//g,"\\"))),!r)return s;const g=s.includes(" "),R=s.includes("(")||s.includes(")"),O=E.basename(r,".exe"),z=O==="pwsh"||n==="pwsh"||O==="powershell"||n==="powershell";if(z&&(g||s.includes("'")))return`& '${s.replace(/'/g,"''")}'`;if(R&&z)return`& '${s}'`;if(c===1){if(i!==void 0)return i==="gitbash"?(0,I.escapeNonWindowsPath)(s.replace(/\\/g,"/")):i==="wsl"?o?.getWslPath(s,"win-to-unix")||s:g?`"${s}"`:s;const ie=r.toLowerCase();return ie.includes("wsl")||ie.includes("bash.exe")&&!ie.toLowerCase().includes("git")?o?.getWslPath(s,"win-to-unix")||s:g?`"${s}"`:s}return(0,I.escapeNonWindowsPath)(s)}e.preparePathForShell=k}),define(ve[68],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(I){I.Delimiter="\0"})(E=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class a{static fromExtHostTestItem(D,P,w=D.parent){if(D._isRoot)return new a([P]);const y=[D.id];for(let T=w;T&&T.id!==P;T=T.parent)y.push(T.id);return y.push(P),new a(y.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const P=D.indexOf("\0");return P===-1?D:D.slice(0,P)}static fromString(D){return new a(D.split("\0"))}static join(D,P){return new a([...D.path,P])}static joinToString(D,P){return D.toString()+"\0"+P}static parentId(D){const P=D.lastIndexOf("\0");return P===-1?void 0:D.slice(0,P)}static localId(D){const P=D.lastIndexOf("\0");return P===-1?D:D.slice(P+1)}static compare(D,P){return D===P?0:P.startsWith(D+"\0")?2:D.startsWith(P+"\0")?3:1}constructor(D,P=D.length){if(this.path=D,this.d=P,D.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new a(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new a(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new a(this.path,D)}compare(D){if(typeof D=="string")return a.compare(this.toString(),D);for(let P=0;P<D.d&&P<this.d;P++)if(D.path[P]!==this.path[P])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=a}),define(ve[85],Ee([1,0,4,49,68]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(l){l[l.Unset=0]="Unset",l[l.Queued=1]="Queued",l[l.Running=2]="Running",l[l.Passed=3]="Passed",l[l.Failed=4]="Failed",l[l.Skipped=5]="Skipped",l[l.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var D;(function(l){l[l.Run=2]="Run",l[l.Debug=4]="Debug",l[l.Coverage=8]="Coverage",l[l.HasNonDefaultProfile=16]="HasNonDefaultProfile",l[l.HasConfigurable=32]="HasConfigurable",l[l.SupportsContinuousRun=64]="SupportsContinuousRun"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=l=>"runId"in l;e.isStartControllerTests=P;var w;(function(l){l.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),l.deserialize=s=>({range:A.Range.lift(s.range),uri:E.URI.revive(s.uri)})})(w=e.IRichLocation||(e.IRichLocation={}));var y;(function(l){l[l.Error=0]="Error",l[l.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var T;(function(l){l.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&w.serialize(s.location)}),l.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&w.deserialize(s.location)})})(T=e.ITestErrorMessage||(e.ITestErrorMessage={}));const S=(l,s)=>`${s?"s":"e"}${l}`;e.getMarkId=S;var v;(function(l){l.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&w.serialize(s.location)}),l.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&w.deserialize(s.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(l){l.serialize=s=>s.type===0?T.serialize(s):v.serialize(s),l.deserialize=s=>s.type===0?T.deserialize(s):v.deserialize(s)})(b=e.ITestMessage||(e.ITestMessage={}));var f;(function(l){l.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),l.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(b.serialize)}),l.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(b.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",u=(l,s)=>l+p+s;e.namespaceTestTag=u;const h=l=>{const s=l.indexOf(p);return{ctrlId:l.slice(0,s),tagId:l.slice(s+1)}};e.denamespaceTestTag=h;var m;(function(l){l.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),l.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?E.URI.revive(s.uri):void 0,range:s.range?A.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(m=e.ITestItem||(e.ITestItem={}));var d;(function(l){l[l.NotExpandable=0]="NotExpandable",l[l.Expandable=1]="Expandable",l[l.BusyExpanding=2]="BusyExpanding",l[l.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var C;(function(l){l.serialize=s=>({expand:s.expand,item:m.serialize(s.item)}),l.deserialize=s=>({controllerId:a.TestId.root(s.item.extId),expand:s.expand,item:m.deserialize(s.item)})})(C=e.InternalTestItem||(e.InternalTestItem={}));var k;(function(l){l.serialize=s=>{let g;return s.item&&(g={},s.item.label!==void 0&&(g.label=s.item.label),s.item.tags!==void 0&&(g.tags=s.item.tags),s.item.busy!==void 0&&(g.busy=s.item.busy),s.item.uri!==void 0&&(g.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(g.range=s.item.range?.toJSON()),s.item.description!==void 0&&(g.description=s.item.description),s.item.error!==void 0&&(g.error=s.item.error),s.item.sortText!==void 0&&(g.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:g}},l.deserialize=s=>{let g;return s.item&&(g={},s.item.label!==void 0&&(g.label=s.item.label),s.item.tags!==void 0&&(g.tags=s.item.tags),s.item.busy!==void 0&&(g.busy=s.item.busy),s.item.range!==void 0&&(g.range=s.item.range?A.Range.lift(s.item.range):null),s.item.description!==void 0&&(g.description=s.item.description),s.item.error!==void 0&&(g.error=s.item.error),s.item.sortText!==void 0&&(g.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:g}}})(k=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(l,s)=>{s.expand!==void 0&&(l.expand=s.expand),s.item!==void 0&&(l.item=l.item?Object.assign(l.item,s.item):s.item)};e.applyTestItemUpdate=t;var r;(function(l){l.serializeWithoutMessages=s=>({...C.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(f.serializeWithoutMessages),retired:s.retired}),l.serialize=s=>({...C.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(f.serialize),retired:s.retired}),l.deserialize=s=>({...C.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(f.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var n;(function(l){l[l.Function=0]="Function",l[l.Statement=1]="Statement"})(n=e.DetailType||(e.DetailType={}));var i;(function(l){l[l.Add=0]="Add",l[l.Update=1]="Update",l[l.DocumentSynced=2]="DocumentSynced",l[l.Remove=3]="Remove",l[l.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",l[l.Retire=5]="Retire",l[l.AddTag=6]="AddTag",l[l.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(l){l.deserialize=s=>s.op===0?{op:s.op,item:C.deserialize(s.item)}:s.op===1?{op:s.op,item:k.deserialize(s.item)}:s.op===2?{op:s.op,uri:E.URI.revive(s.uri),docv:s.docv}:s,l.serialize=s=>s.op===0?{op:s.op,item:C.serialize(s.item)}:s.op===1?{op:s.op,item:k.serialize(s.item)}:s})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const g=this.o();for(const R of s)switch(R.op){case 0:this.j(C.deserialize(R.item),g);break;case 1:this.k(k.deserialize(R.item),g);break;case 3:this.l(R.itemId,g);break;case 5:this.m(R.itemId);break;case 4:this.updatePendingRoots(R.amount);break;case 6:this.c.set(R.tag.id,R.tag);break;case 7:this.c.delete(R.id);break}g.complete?.()}j(s,g){const R=a.TestId.parentId(s.item.extId)?.toString();let O;if(!R)O=this.p(s),this.f.add(O),this.d.set(s.item.extId,O);else if(this.d.has(R)){const z=this.d.get(R);z.children.add(s.item.extId),O=this.p(s,z),this.d.set(s.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return g.add?.(O),s.expand===2&&this.g++,O}k(s,g){const R=this.d.get(s.extId);if(!!R)return s.expand!==void 0&&(R.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(R,s),g.update?.(R),R}l(s,g){const R=this.d.get(s);if(!R)return;const O=a.TestId.parentId(R.item.extId)?.toString();O?this.d.get(O).children.delete(R.item.extId):this.f.delete(R);const z=[[s]];for(;z.length;)for(const ie of z.pop()){const ee=this.d.get(ie);ee&&(z.push(ee.children),this.d.delete(ie),g.remove?.(ee,ee!==R),ee.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(ve[128],Ee([1,0,14,6,2,87,85,68]),function(ae,e,E,A,a,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(m,d)=>m===d,S=Object.entries({range:(m,d)=>m===d?!0:!m||!d?!1:m.equalsRange(d),busy:y,label:y,description:y,error:y,sortText:y,tags:(m,d)=>!(m.length!==d.length||m.some(C=>!d.includes(C)))}),v=(m,d)=>{let C;for(const[k,t]of S)t(m[k],d[k])||(C?C[k]=d[k]:C={[k]:d[k]});return C};class b extends a.Disposable{get root(){return this.m.root}constructor(d){super(),this.m=d,this.f=this.B(new E.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(d){this.h=d;for(const C of this.tree.values())this.G(C)}collectDiff(){const d=this.k;return this.k=[],d}pushDiff(d){switch(d.op){case 2:{for(const C of this.k)if(C.op===2&&C.uri===d.uri){C.docv=d.docv;return}break}case 1:{const C=this.k[this.k.length-1];if(C){if(C.op===1&&C.item.extId===d.item.extId){(0,D.applyTestItemUpdate)(C.item,d.item);return}if(C.op===0&&C.item.item.extId===d.item.extId){(0,D.applyTestItemUpdate)(C.item,d.item);return}}break}}this.k.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,C){const k=this.tree.get(d);if(!!k){if((k.expandLevels===void 0||C>k.expandLevels)&&(k.expandLevels=C),k.expand===1){const t=this.I(k);return t.isOpen()?this.H(k,C-1):t.wait().then(()=>this.H(k,C-1))}else if(k.expand===3)return k.resolveBarrier?.isOpen()===!1?k.resolveBarrier.wait().then(()=>this.H(k,C-1)):this.H(k,C-1)}}dispose(){for(const d of this.tree.values())this.m.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(d,C){switch(C.op){case 3:this.L(P.TestId.joinToString(d.fullId,C.id));break;case 0:this.u(C.item,d);break;case 5:for(const k of C.ops)this.p(d,k);break;case 1:this.w(C.new,C.old,d.fullId.toString());break;case 2:this.G(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:C.update}});break;case 6:this.s(d.actual.uri);break;default:(0,I.assertNever)(C)}}s(d){d&&this.pushDiff({op:2,uri:d,docv:this.m.getDocumentVersion(d)})}u(d,C){const k=P.TestId.fromExtHostTestItem(d,this.root.id,C?.actual),t=this.m.getApiFor(d);t.parent&&t.parent!==C?.actual&&this.m.getChildren(t.parent).delete(d.id);let r=this.tree.get(k.toString());if(!r){r={fullId:k,actual:d,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},d.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(d,C),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(d)}}),this.F(d,r,C);return}if(r.actual===d){this.D(d,r,C);return}if(r.actual.uri?.toString()!==d.uri?.toString())return this.L(k.toString()),this.u(d,C);const n=this.m.getChildren(r.actual),i=r.actual,o=v(this.m.toITestItem(i),this.m.toITestItem(d));this.m.getApiFor(i).listener=void 0,r.actual=d,r.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(d.tags,i.tags,k.toString()),delete o.tags),this.p(r,{op:4,update:o})),this.F(d,r,C);for(const[c,l]of n)this.m.getChildren(d).get(l.id)||this.L(P.TestId.joinToString(k,l.id));this.s(r.actual.uri)}w(d,C,k){const t=new Set(C.map(r=>r.id));for(const r of d)t.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:k,item:{tags:d.map(r=>(0,D.namespaceTestTag)(this.m.controllerId,r.id))}}}),t.forEach(this.z,this)}y(d){const C=this.j.get(d.id);C?C.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,d.id)}}))}z(d){const C=this.j.get(d);C&&!--C.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,d)}))}C(d,C){this.m.getApiFor(d).parent=C&&C.actual!==this.root?C.actual:void 0}D(d,C,k){this.C(d,k);const t=this.m.getApiFor(d);t.parent=k?.actual,t.listener=r=>this.p(C,r),this.G(C)}F(d,C,k){this.D(d,C,k);for(const[t,r]of this.m.getChildren(d))this.u(r,C)}G(d){let C;this.h?d.resolveBarrier?C=d.resolveBarrier.isOpen()?3:2:C=d.actual.canResolveChildren?1:0:C=0,C!==d.expand&&(d.expand=C,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:C}}),C===1&&d.expandLevels!==void 0&&this.I(d))}H(d,C){if(C<0)return;const k=[];for(const[t,r]of this.m.getChildren(d.actual)){const n=this.expand(P.TestId.joinToString(d.fullId,r.id),C);(0,E.isThenable)(n)&&k.push(n)}if(k.length)return Promise.all(k).then(()=>{})}I(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const r=new E.Barrier;return r.open(),r}d.expand=2,this.J(d);const C=d.resolveBarrier=new E.Barrier,k=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let t;try{t=this.h(d.actual===this.root?void 0:d.actual)}catch(r){k(r)}return(0,E.isThenable)(t)?t.catch(k).then(()=>{C.open(),this.G(d)}):(C.open(),this.G(d)),d.resolveBarrier}J(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}L(d){const C=this.tree.get(d);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const k=[C];for(;k.length;){const t=k.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.z(r.id);this.tree.delete(t.fullId.toString());for(const[r,n]of this.m.getChildren(t.actual))k.push(this.tree.get(P.TestId.joinToString(t.fullId,n.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.TestItemCollection=b;class f extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=f;class p extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class u extends Error{constructor(d,C,k){super(`TestItem with ID "${d}" is from controller "${C}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=u;const h=(m,d,C)=>{let k=new Map;return{get size(){return k.size},forEach(t,r){for(const n of k.values())t.call(r,n,this)},[Symbol.iterator](){return k.entries()},replace(t){const r=new Map,n=new Set(k.keys()),i={op:5,ops:[]};for(const o of t){if(!(o instanceof C))throw new p(o.id);const c=d(o).controllerId;if(c!==m.controllerId)throw new u(o.id,c,m.controllerId);if(r.has(o.id))throw new f(o.id);r.set(o.id,o),n.delete(o.id),i.ops.push({op:0,item:o})}for(const o of n.keys())i.ops.push({op:3,id:o});m.listener?.(i),k=r},add(t){if(!(t instanceof C))throw new p(t.id);k.set(t.id,t),m.listener?.({op:0,item:t})},delete(t){k.delete(t)&&m.listener?.({op:3,id:t})},get(t){return k.get(t)},toJSON(){return Array.from(k.values())}}};e.createTestItemChildren=h}),define(ve[129],Ee([1,0,128]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,a=(D,P)=>{const w={controllerId:P};return A.set(D,w),w};e.createPrivateApiFor=a;const I=D=>{const P=A.get(D);if(!P)throw new E.InvalidTestItemError(D?.id||"<unknown>");return P};e.getPrivateApiFor=I}),define(ve[262],Ee([1,0,24,5]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,A.refineServiceDecorator)(E.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[130],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,E.createDecorator)("configurationResolverService");var A;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class a extends Error{constructor(D,P){super(P),this.variable=D}}e.VariableError=a}),define(ve[263],Ee([1,0,7,28,8,23,3,150,195,130,16]),function(ae,e,E,A,a,I,D,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(b,f,p,u){this.g=new Map,this.a=b,this.b=f,this.d=p,u&&(this.c=u.then(h=>this.h(h)))}h(b){if(D.isWindows){const f=Object.create(null);return Object.keys(b).forEach(p=>{f[p.toLowerCase()]=b[p]}),f}return b}resolveWithEnvironment(b,f,p){return this.j({env:this.h(b),userHome:void 0},f?f.uri:void 0,p)}async resolveAsync(b,f){const p={env:await this.c,userHome:await this.d};return this.j(p,b?b.uri:void 0,f)}async i(b,f,p,u){const h=I.deepClone(f);D.isWindows&&h.windows?Object.keys(h.windows).forEach(d=>h[d]=h.windows[d]):D.isMacintosh&&h.osx?Object.keys(h.osx).forEach(d=>h[d]=h.osx[d]):D.isLinux&&h.linux&&Object.keys(h.linux).forEach(d=>h[d]=h.linux[d]),delete h.windows,delete h.osx,delete h.linux;const m={env:await this.c,userHome:await this.d};return this.j(m,b?b.uri:void 0,h,p,u)}async resolveAnyAsync(b,f,p){return this.i(b,f,p)}async resolveAnyMap(b,f,p){const u=new Map;return{newConfig:await this.i(b,f,p,u),resolvedVariables:u}}resolveWithInteractionReplace(b,f,p,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,p,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,f)}async j(b,f,p,u,h){if(a.isString(p))return this.l(b,f,p,u,h);if(Array.isArray(p))return Promise.all(p.map(m=>this.j(b,f,m,u,h)));if(a.isObject(p)){const m=Object.create(null),d=await Promise.all(Object.keys(p).map(async C=>[await this.l(b,f,C,u,h),await this.j(b,f,p[C],u,h)]));for(const[C,k]of d)m[C]=k;return m}return p}l(b,f,p,u,h){return(0,T.replaceAsync)(p,S.VARIABLE_REGEXP,async(m,d)=>{if(d.includes(S.VARIABLE_LHS))return m;let C=await this.n(b,m,d,f,u);return h?.set(d,C),C!==m&&a.isString(C)&&C.match(S.VARIABLE_REGEXP)&&(C=await this.l(b,f,C,u,h)),C})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,f,p,u,h){let m;const d=p.split(":");d.length>1&&(p=d[0],m=d[1]);const C=r=>{const n=this.a.getFilePath();if(n)return(0,P.normalizeDriveLetter)(n);throw new y.VariableError(r,(0,w.localize)(0,null,f))},k=r=>{const n=C(r);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,P.normalizeDriveLetter)(i)}throw new y.VariableError(r,(0,w.localize)(1,null,f,E.basename(n)))},t=r=>{if(m){const n=this.a.getFolderUri(m);if(n)return n;throw new y.VariableError(r,(0,w.localize)(2,null,f,m))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(r,(0,w.localize)(3,null,f)):new y.VariableError(r,(0,w.localize)(4,null,f))};switch(p){case"env":if(m){if(b.env){const r=b.env[D.isWindows?m.toLowerCase():m];if(a.isString(r))return r}return""}throw new y.VariableError(y.VariableKind.Env,(0,w.localize)(5,null,f));case"config":if(m){const r=this.a.getConfigurationValue(u,m);if(a.isUndefinedOrNull(r))throw new y.VariableError(y.VariableKind.Config,(0,w.localize)(6,null,f,m));if(a.isObject(r))throw new y.VariableError(y.VariableKind.Config,(0,w.localize)(7,null,f,m));return r}throw new y.VariableError(y.VariableKind.Config,(0,w.localize)(8,null,f));case"command":return this.o(y.VariableKind.Command,f,m,h,"command");case"input":return this.o(y.VariableKind.Input,f,m,h,"input");case"extensionInstallFolder":if(m){const r=await this.a.getExtension(m);if(!r)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,f,m));return this.m(r.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,f));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(t(y.VariableKind.WorkspaceFolder)));case"cwd":return u||m?(0,P.normalizeDriveLetter)(this.m(t(y.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(E.basename(this.m(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,w.localize)(11,null,f))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.VariableError(y.VariableKind.LineNumber,(0,w.localize)(12,null,f))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.VariableError(y.VariableKind.SelectedText,(0,w.localize)(13,null,f))}case"file":return C(y.VariableKind.File);case"fileWorkspaceFolder":return k(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||m?E.relative(this.m(t(y.VariableKind.RelativeFile)),C(y.VariableKind.RelativeFile)):C(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.dirname(C(y.VariableKind.RelativeFileDirname));if(u||m){const n=E.relative(this.m(t(y.VariableKind.RelativeFileDirname)),r);return n.length===0?".":n}return r}case"fileDirname":return E.dirname(C(y.VariableKind.FileDirname));case"fileExtname":return E.extname(C(y.VariableKind.FileExtname));case"fileBasename":return E.basename(C(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.basename(C(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.extname(r).length)}case"fileDirnameBasename":return E.basename(E.dirname(C(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||f}case"execInstallFolder":{const r=this.a.getAppRoot();return r||f}case"pathSeparator":return E.sep;default:try{const r=m?`${p}:${m}`:p;return this.o(y.VariableKind.Unknown,f,r,h,void 0)}catch{return f}}}}o(b,f,p,u,h){if(p&&u){const m=h===void 0?u[p]:u[h+":"+p];if(typeof m=="string")return m;throw new y.VariableError(b,(0,w.localize)(14,null,f))}return f}}S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=S}),define(ve[264],Ee([1,0,5,84]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var a;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(a=e.GroupDirection||(e.GroupDirection={}));var I;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function y(f){const p=f;return(0,A.isEditorInput)(p?.editor)&&(0,A.isEditorInput)(p?.replacement)}e.isEditorReplacement=y;var T;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function v(f){const p=f;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=v;function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[131],Ee([1,0,5,264]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function a(I){const D=I;return typeof I=="number"||(0,A.isEditorGroup)(D)}e.isPreferredGroup=a}),define(ve[265],Ee([1,0,8,262,12,113,82,81,130,84,131,13,215,260]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let f=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(u,h,m,d,C,k,t,r,n,i){this.a=u,this.b=h,this.c=m,this.d=d,this.e=C,this.f=k,this.g=t,this.h=r,this.i=n,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(u,h,m,d,C,k,t,r){await this.c.whenRemoteConfigurationLoaded();const n=Object.create(null),i=m?(0,E.withNullAsUndefined)(this.d.getWorkspaceFolder(m)):void 0;let o;try{o=(await this.e.resolveAnyMap(i,{shellLaunchConfig:u,configuration:h})).resolvedVariables}catch(ee){this.h.error(ee)}if(o)for(const[ee,F]of o.entries())(/^config:/.test(ee)||ee==="selectedText"||ee==="lineNumber")&&(n[ee]=F);const c=[];for(const[ee,F]of this.f.collections.entries())c.push([ee,(0,P.serializeEnvironmentVariableCollection)(F.map)]);const l=await this.g.resolveAuthority(this.a),s=l.options&&l.options.extensionHostEnv,g=this.d.getWorkspace(),R=g.folders,O=m?this.d.getWorkspaceFolder(m):null,z=y.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:y.SideBySideEditor.PRIMARY,filterByScheme:[S.Schemas.file,S.Schemas.vscodeUserData,S.Schemas.vscodeRemote]}),ie={configuration:h,resolvedVariables:n,envVariableCollections:c,shellLaunchConfig:u,workspaceId:g.id,workspaceName:this.j.getWorkspaceLabel(g),workspaceFolders:R,activeWorkspaceFolder:O,activeFileResource:z,shouldPersistTerminal:C,options:d,cols:k,rows:t,unicodeVersion:r,resolverEnv:s};return await this.b.call("$createProcess",ie)}requestDetachInstance(u,h){return this.b.call("$requestDetachInstance",[u,h])}acceptDetachInstanceReply(u,h){return this.b.call("$acceptDetachInstanceReply",[u,h])}attachToProcess(u){return this.b.call("$attachToProcess",[u])}detachFromProcess(u,h){return this.b.call("$detachFromProcess",[u,h])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(u,h){return this.b.call("$processBinary",[u,h])}start(u){return this.b.call("$start",[u])}input(u,h){return this.b.call("$input",[u,h])}acknowledgeDataEvent(u,h){return this.b.call("$acknowledgeDataEvent",[u,h])}setUnicodeVersion(u,h){return this.b.call("$setUnicodeVersion",[u,h])}shutdown(u,h){return this.b.call("$shutdown",[u,h])}resize(u,h,m){return this.b.call("$resize",[u,h,m])}getInitialCwd(u){return this.b.call("$getInitialCwd",[u])}getCwd(u){return this.b.call("$getCwd",[u])}orphanQuestionReply(u){return this.b.call("$orphanQuestionReply",[u])}sendCommandResult(u,h,m){return this.b.call("$sendCommandResult",[u,h,m])}freePortKillProcess(u){return this.b.call("$freePortKillProcess",[u])}installAutoReply(u,h){return this.b.call("$installAutoReply",[u,h])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(u){return this.b.call("$getDefaultSystemShell",[u])}getProfiles(u,h,m){return this.b.call("$getProfiles",[this.d.getWorkspace().id,u,h,m])}acceptPtyHostResolvedVariables(u,h){return this.b.call("$acceptPtyHostResolvedVariables",[u,h])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(u,h){return this.b.call("$getWslPath",[u,h])}setTerminalLayoutInfo(u){const m={workspaceId:this.d.getWorkspace().id,tabs:u?u.tabs:[]};return this.b.call("$setTerminalLayoutInfo",m)}updateTitle(u,h,m){return this.b.call("$updateTitle",[u,h,m])}updateIcon(u,h,m,d){return this.b.call("$updateIcon",[u,h,m,d])}refreshProperty(u,h){return this.b.call("$refreshProperty",[u,h])}updateProperty(u,h,m){return this.b.call("$updateProperty",[u,h,m])}getTerminalLayoutInfo(){const h={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",h)}reviveTerminalProcesses(u,h){return this.b.call("$reviveTerminalProcesses",[u,h])}getRevivedPtyNewId(u){return this.b.call("$getRevivedPtyNewId",[u])}serializeTerminalState(u){return this.b.call("$serializeTerminalState",[u])}};f=Le([Re(2,A.IWorkbenchConfigurationService),Re(3,D.IWorkspaceContextService),Re(4,w.IConfigurationResolverService),Re(5,b.IEnvironmentVariableService),Re(6,I.IRemoteAuthorityResolverService),Re(7,a.ILogService),Re(8,T.IEditorService),Re(9,v.ILabelService)],f),e.RemoteTerminalChannelClient=f}),define(ve[266],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var E;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(E=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(S){this.pipeName=S,this.type=1}serialize(S){S[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class a{constructor(){this.type=2}serialize(S){S[a.ENV_KEY]="1"}}a.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=a;class I{constructor(){this.type=3}serialize(S){S[I.ENV_KEY]="1"}}I.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=I;function D(T){delete T[A.ENV_KEY],delete T[a.ENV_KEY],delete T[I.ENV_KEY]}function P(T,S){D(S),T.serialize(S)}e.writeExtHostConnection=P;function w(T){if(T[A.ENV_KEY])return y(T,new A(T[A.ENV_KEY]));if(T[a.ENV_KEY])return y(T,new a);if(T[I.ENV_KEY])return y(T,new I);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function y(T,S){return D(T),S}}),define(ve[132],Ee([1,0,48,96,83,13,7,15,6,60,80,12,41,3,57,125,2,266,24]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function d(i={},o,c,l,s,g){const R=await(0,a.getNLSConfiguration)(c,l.userDataPath);let O={};if(o)try{O=await(0,T.getResolvedShellEnv)(g,s,l.args,process.env)}catch($){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",$)}const ie={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(R,void 0,0),...i},ee=l.isBuilt?(0,D.join)(l.appRoot,"bin"):(0,D.join)(l.appRoot,"resources","server","bin-dev"),F=(0,D.join)(ee,"remote-cli");let Z=t(ie,"PATH");return Z?Z=F+D.delimiter+Z:Z=F,r(ie,"PATH",Z),l.args["without-browser-env-var"]||(ie.BROWSER=(0,D.join)(ee,"helpers",b.isWindows?"browser.cmd":"browser.sh")),n(ie),ie}e.buildUserEnvironment=d;class C{constructor(o,c){this.socket=o,this.initialDataChunk=c}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,c,l;return this.socket instanceof y.NodeSocket?(o=!0,c=!1,l=P.VSBuffer.alloc(0)):(o=!1,c=this.socket.permessageDeflate,l=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:c,inflateBytes:l.buffer.toString("base64")}}}let k=class{constructor(o,c,l,s,g,R,O,z){this.i=o,this.j=g,this.l=R,this.m=O,this.n=z,this.b=new w.Emitter,this.onClose=this.b.event,this.c=!b.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=c,this.g=null,this.h=new C(l,s),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(o){this.l.info(`${this.o}${o}`)}q(o){this.l.error(`${this.o}${o}`)}async r(o,c){const l=new u.DisposableStore;l.add(c.socket),l.add((0,u.toDisposable)(()=>{o.destroy()}));const s=()=>{l.dispose()};l.add(c.socket.onEnd(s)),l.add(c.socket.onClose(s)),l.add(w.Event.fromNodeEventEmitter(o,"end")(s)),l.add(w.Event.fromNodeEventEmitter(o,"close")(s)),l.add(w.Event.fromNodeEventEmitter(o,"error")(s)),l.add(c.socket.onData(g=>o.write(g.buffer))),l.add(w.Event.fromNodeEventEmitter(o,"data")(g=>{c.socket.write(P.VSBuffer.wrap(g))})),c.initialDataChunk.byteLength>0&&o.write(c.initialDataChunk.buffer)}async s(o,c){await c.socketDrain();const l=c.toIExtHostSocketMessage();let s;c.socket instanceof y.NodeSocket?s=c.socket.socket:s=c.socket.socket.socket,o.send(l,s)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(o)}acceptReconnection(o,c,l){this.f=o,this.p("The client has reconnected.");const s=new C(c,l);if(!this.g){this.h=s;return}this.s(this.g,s)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(o){try{let c=process.execArgv?process.execArgv.filter(F=>!/^--inspect(-brk)?=/.test(F)):[];o.port&&!process.pkg&&(c=[`--inspect${o.break?"-brk":""}=${o.port}`]);const l=await d(o.env,!0,o.language,this.j,this.l,this.n);(0,f.removeDangerousEnvVariables)(l);let s;if(this.c)(0,h.writeExtHostConnection)(new h.SocketExtHostConnection,l),s=null;else{const{namedPipeServer:F,pipeName:Z}=await this.u();(0,h.writeExtHostConnection)(new h.IPCExtHostConnection(Z),l),s=F}const g={env:l,execArgv:c,silent:!0},R=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];R.push(`--useHostProxy=${O?"true":"false"}`),this.g=E.fork(I.FileAccess.asFileUri("bootstrap-fork").fsPath,R,g);const z=this.g.pid;this.p(`<${z}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const ie=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),ee=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(ie(F=>this.p(`<${z}> ${F}`)),ee(F=>this.p(`<${z}><stderr> ${F}`)),this.g.on("error",F=>{this.q(`<${z}> Extension Host Process had an error`),this.l.error(F),this.t()}),this.g.on("exit",(F,Z)=>{this.m.setExitInfo(this.i,{code:F,signal:Z}),this.p(`<${z}> Extension Host Process exited with code: ${F}, signal: ${Z}.`),this.t()}),s)s.on("connection",F=>{s.close(),this.r(F,this.h)});else{const F=Z=>{Z.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",F),this.s(this.g,this.h),this.h=null)};this.g.on("message",F)}}catch(c){console.error("ExtensionHostConnection errored"),c&&console.error(c)}}u(){return new Promise((o,c)=>{const l=(0,y.createRandomIPCHandle)(),s=A.createServer();s.on("error",c),s.listen(l,()=>{s?.removeListener("error",c),o({pipeName:l,namedPipeServer:s})})})}};k=Le([Re(4,v.IServerEnvironmentService),Re(5,S.ILogService),Re(6,p.IExtensionHostStatusService),Re(7,m.IConfigurationService)],k),e.ExtensionHostConnection=k;function t(i,o){const c=Object.keys(i).filter(s=>s.toLowerCase()===o.toLowerCase()),l=c.length>0?c[0]:o;return i[l]}function r(i,o,c){const l=Object.keys(i).filter(g=>g.toLowerCase()===o.toLowerCase()),s=l.length>0?l[0]:o;i[s]=c}function n(i){for(const o of Object.keys(i))i[o]===null&&delete i[o]}}),define(ve[267],Ee([1,0,6,4,5,33,35]),function(ae,e,E,A,a,I,D){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,a.createDecorator)("extensionService");class w{constructor(c){this.affinity=c,this.kind=1}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class y{constructor(c){this.affinity=c,this.kind=2}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class T{constructor(){this.kind=3,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"Remote"}}e.RemoteRunningLocation=T;class S{constructor(c){this.dependency=c}}e.MissingExtensionDependency=S;var v;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(c,l){const s=[],g=[],R=[],O=[],z=h(this.c),ie=h(c),ee=(x,le)=>x.extensionLocation.toString()===le.extensionLocation.toString()||x.isBuiltin===le.isBuiltin||x.isUserBuiltin===le.isUserBuiltin||x.isUnderDevelopment===le.isUnderDevelopment;for(const x of this.c){const le=ie.get(I.ExtensionIdentifier.toKey(x.identifier));if(!le){s.push(x.identifier),z.delete(I.ExtensionIdentifier.toKey(x.identifier));continue}if(!ee(x,le)){s.push(x.identifier),z.delete(I.ExtensionIdentifier.toKey(x.identifier));continue}}for(const x of c){const le=z.get(I.ExtensionIdentifier.toKey(x.identifier));if(!le){g.push(x);continue}if(!ee(le,x)){s.push(le.identifier),z.delete(I.ExtensionIdentifier.toKey(le.identifier));continue}}const F=u(this.d),Z=u(l);for(const x of this.d)Z.has(I.ExtensionIdentifier.toKey(x))||R.push(x);for(const x of l)F.has(I.ExtensionIdentifier.toKey(x))||O.push(x);const $={toRemove:s,toAdd:g,myToRemove:R,myToAdd:O};return this.delta($),$}delta(c){const{toRemove:l,toAdd:s,myToRemove:g,myToAdd:R}=c,O=u(l),z=u(g);for(let ie=0;ie<this.c.length;ie++)O.has(I.ExtensionIdentifier.toKey(this.c[ie].identifier))&&(this.c.splice(ie,1),ie--);for(let ie=0;ie<this.d.length;ie++)z.has(I.ExtensionIdentifier.toKey(this.d[ie]))&&(this.d.splice(ie,1),ie--);for(const ie of s)this.c.push(ie);for(const ie of R)this.d.push(ie)}containsExtension(c){for(const l of this.d)if(I.ExtensionIdentifier.equals(l,c))return!0;return!1}}e.ExtensionHostExtensions=f;class p{constructor(c){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=I.ExtensionIdentifier.toKey,c)for(const l of c)this.add(l)}get size(){return this.c.size}add(c){return this.c.set(this.d(c),c),this}clear(){this.c.clear()}delete(c){return this.c.delete(this.d(c))}has(c){return this.c.has(this.d(c))}forEach(c,l){this.c.forEach(s=>c.call(l,s,s,this))}*entries(){for(const[c,l]of this.c)yield[l,l]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=p;function u(o){const c=new Set;for(const l of o)c.add(I.ExtensionIdentifier.toKey(l));return c}e.extensionIdentifiersArrayToSet=u;function h(o){const c=new Map;for(const l of o)c.set(I.ExtensionIdentifier.toKey(l.identifier),l);return c}function m(o,c){return!0}e.isProposedApiEnabled=m;function d(o,c){if(!m(o,c))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=d;class C{constructor(c,l,s,g){this.codeLoadingTime=c,this.activateCallTime=l,this.activateResolvedTime=s,this.activationReason=g}}e.ActivationTimes=C;class k{constructor(c,l){this.description=c,this.value=l}}e.ExtensionPointContribution=k,e.ExtensionHostLogFileName="exthost";var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function r(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function n(o,c){return{identifier:new I.ExtensionIdentifier((0,D.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!c,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c,l){return Promise.resolve(0)}getInspectPorts(c,l){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i});var Nt=this&&this.__classPrivateFieldSet||function(ae,e,E,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!a:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ae,E):a?a.value=E:e.set(ae,E),E},rt=this&&this.__classPrivateFieldGet||function(ae,e,E,A){if(E==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!A:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?A:E==="a"?A.call(ae):A?A.value:e.get(ae)};define(ve[133],Ee([1,0,18,9,93,27,56,16,8,4,21,17,113,127,267]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f){"use strict";var p,u,h,m,d,C,k,t,r,n,i,o,c,l,s,g,R,O,z,ie,ee,F,Z;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function $(B){return Object.assign(B,{apply:function(){const oe=arguments.length===1?[]:arguments[1];return Reflect.construct(B,oe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[oe,...ge]=arguments;return Reflect.construct(B,ge,oe.constructor)}}})}var x;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(x=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var le;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(le=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let be=C=class{static from(...L){let oe=L;return new C(function(){if(oe){for(const ge of oe)ge&&typeof ge.dispose=="function"&&ge.dispose();oe=void 0}})}constructor(L){p.set(this,void 0),Nt(this,p,L,"f")}dispose(){typeof rt(this,p,"f")=="function"&&(rt(this,p,"f").call(this),Nt(this,p,void 0,"f"))}};p=new WeakMap,be=C=Le([$],be),e.Disposable=be;let Y=k=class{static Min(...L){if(L.length===0)throw new TypeError;let oe=L[0];for(let ge=1;ge<L.length;ge++){const Fe=L[ge];Fe.isBefore(oe)&&(oe=Fe)}return oe}static Max(...L){if(L.length===0)throw new TypeError;let oe=L[0];for(let ge=1;ge<L.length;ge++){const Fe=L[ge];Fe.isAfter(oe)&&(oe=Fe)}return oe}static isPosition(L){if(!L)return!1;if(L instanceof k)return!0;const{line:oe,character:ge}=L;return typeof oe=="number"&&typeof ge=="number"}static of(L){if(L instanceof k)return L;if(this.isPosition(L))return new k(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,oe){if(L<0)throw(0,A.illegalArgument)("line must be non-negative");if(oe<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=L,this.e=oe}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,oe=0){if(L===null||oe===null)throw(0,A.illegalArgument)();let ge;return typeof L>"u"?ge=0:typeof L=="number"?ge=L:(ge=typeof L.lineDelta=="number"?L.lineDelta:0,oe=typeof L.characterDelta=="number"?L.characterDelta:0),ge===0&&oe===0?this:new k(this.line+ge,this.character+oe)}with(L,oe=this.character){if(L===null||oe===null)throw(0,A.illegalArgument)();let ge;return typeof L>"u"?ge=this.line:typeof L=="number"?ge=L:(ge=typeof L.line=="number"?L.line:this.line,oe=typeof L.character=="number"?L.character:this.character),ge===this.line&&oe===this.character?this:new k(ge,oe)}toJSON(){return{line:this.line,character:this.character}}};Y=k=Le([$],Y),e.Position=Y;let H=t=class{static isRange(L){return L instanceof t?!0:L?Y.isPosition(L.start)&&Y.isPosition(L.end):!1}static of(L){if(L instanceof t)return L;if(this.isRange(L))return new t(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,oe,ge,Fe){let We,Qe;if(typeof L=="number"&&typeof oe=="number"&&typeof ge=="number"&&typeof Fe=="number"?(We=new Y(L,oe),Qe=new Y(ge,Fe)):Y.isPosition(L)&&Y.isPosition(oe)&&(We=Y.of(L),Qe=Y.of(oe)),!We||!Qe)throw new Error("Invalid arguments");We.isBefore(Qe)?(this.c=We,this.e=Qe):(this.c=Qe,this.e=We)}contains(L){return t.isRange(L)?this.contains(L.start)&&this.contains(L.end):Y.isPosition(L)?!(Y.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const oe=Y.Max(L.start,this.c),ge=Y.Min(L.end,this.e);if(!oe.isAfter(ge))return new t(oe,ge)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const oe=Y.Min(L.start,this.c),ge=Y.Max(L.end,this.end);return new t(oe,ge)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,oe=this.end){if(L===null||oe===null)throw(0,A.illegalArgument)();let ge;return L?Y.isPosition(L)?ge=L:(ge=L.start||this.start,oe=L.end||this.end):ge=this.start,ge.isEqual(this.c)&&oe.isEqual(this.end)?this:new t(ge,oe)}toJSON(){return[this.start,this.end]}};H=t=Le([$],H),e.Range=H;let U=r=class extends H{static isSelection(L){return L instanceof r?!0:L?H.isRange(L)&&Y.isPosition(L.anchor)&&Y.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,oe,ge,Fe){let We,Qe;if(typeof L=="number"&&typeof oe=="number"&&typeof ge=="number"&&typeof Fe=="number"?(We=new Y(L,oe),Qe=new Y(ge,Fe)):Y.isPosition(L)&&Y.isPosition(oe)&&(We=Y.of(L),Qe=Y.of(oe)),!We||!Qe)throw new Error("Invalid arguments");super(We,Qe),this.f=We,this.g=Qe}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=r=Le([$],U),e.Selection=U;class ne{constructor(L,oe,ge){if(typeof L!="string"||L.length===0)throw(0,A.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,A.illegalArgument)("port");if(typeof ge<"u"&&(typeof ge!="string"||ge.length===0||!/^[0-9A-Za-z_\-]+$/.test(ge)))throw(0,A.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(oe),this.connectionToken=ge}}e.ResolvedAuthority=ne;class se extends Error{static NotAvailable(L,oe){return new se(L,v.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(L){return new se(L,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,oe=v.RemoteAuthorityResolverErrorCode.Unknown,ge){super(L),this._message=L,this._code=oe,this._detail=ge,Object.setPrototypeOf(this,se.prototype)}}e.RemoteAuthorityResolverError=se;var de;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(de=e.EndOfLine||(e.EndOfLine={}));var re;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(re=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=n=class{static isTextEdit(L){return L instanceof n?!0:L?H.isRange(L)&&typeof L.newText=="string":!1}static replace(L,oe){return new n(L,oe)}static insert(L,oe){return n.replace(new H(L,L),oe)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const oe=new n(new H(new Y(0,0),new Y(0,0)),"");return oe.newEol=L,oe}get range(){return this.c}set range(L){if(L&&!H.isRange(L))throw(0,A.illegalArgument)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,A.illegalArgument)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,A.illegalArgument)("newEol");this.f=L}constructor(L,oe){this.c=L,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};j=n=Le([$],j),e.TextEdit=j;let N=i=class{static isNotebookCellEdit(L){return L instanceof i?!0:L?Tt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,oe){return new i(L,oe)}static insertCells(L,oe){return new i(new Tt(L,L),oe)}static deleteCells(L){return new i(L,[])}static updateCellMetadata(L,oe){const ge=new i(new Tt(L,L),[]);return ge.newCellMetadata=oe,ge}static updateNotebookMetadata(L){const oe=new i(new Tt(0,0),[]);return oe.newNotebookMetadata=L,oe}constructor(L,oe){this.range=L,this.newCells=oe}};N=i=Le([$],N),e.NotebookEdit=N;class M{static isSnippetTextEdit(L){return L instanceof M?!0:L?H.isRange(L.range)&&ue.isSnippetString(L.snippet):!1}static replace(L,oe){return new M(L,oe)}static insert(L,oe){return M.replace(new H(L,L),oe)}constructor(L,oe){this.range=L,this.snippet=oe}}e.SnippetTextEdit=M;var q;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(q=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,oe,ge,Fe){this.c.push({_type:1,from:L,to:oe,options:ge,metadata:Fe})}createFile(L,oe,ge){this.c.push({_type:1,from:void 0,to:L,options:oe,metadata:ge})}deleteFile(L,oe,ge){this.c.push({_type:1,from:L,to:void 0,options:oe,metadata:ge})}e(L,oe,ge){this.c.push({_type:3,metadata:ge,uri:L,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(L,oe,ge,Fe){const We=oe.start,Qe=oe.end;(We!==Qe||ge.length>0)&&this.c.push({_type:5,uri:L,index:We,count:Qe-We,cells:ge,metadata:Fe})}g(L,oe,ge,Fe){this.c.push({_type:3,metadata:Fe,uri:L,edit:{editType:8,index:oe,metadata:ge}})}replace(L,oe,ge,Fe){this.c.push({_type:2,uri:L,edit:new j(oe,ge),metadata:Fe})}insert(L,oe,ge,Fe){this.replace(L,new H(oe,oe),ge,Fe)}delete(L,oe,ge){this.replace(L,oe,"",ge)}has(L){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===L.toString())}set(L,oe){if(oe)for(const ge of oe){if(!ge)continue;let Fe,We;Array.isArray(ge)?(Fe=ge[0],We=ge[1]):Fe=ge,N.isNotebookCellEdit(Fe)?Fe.newCellMetadata?this.g(L,Fe.range.start,Fe.newCellMetadata,We):Fe.newNotebookMetadata?this.e(L,Fe.newNotebookMetadata,We):this.f(L,Fe.range,Fe.newCells,We):M.isSnippetTextEdit(Fe)?this.c.push({_type:6,uri:L,range:Fe.range,edit:Fe.snippet,metadata:We}):this.c.push({_type:2,uri:L,edit:Fe,metadata:We})}else{for(let ge=0;ge<this.c.length;ge++){const Fe=this.c[ge];switch(Fe._type){case 2:case 6:case 3:case 5:Fe.uri.toString()===L.toString()&&(this.c[ge]=void 0);break}}(0,E.coalesceInPlace)(this.c)}}get(L){const oe=[];for(const ge of this.c)ge._type===2&&ge.uri.toString()===L.toString()&&oe.push(ge.edit);return oe}entries(){const L=new I.ResourceMap;for(const oe of this.c)if(oe._type===2){let ge=L.get(oe.uri);ge||(ge=[oe.uri,[]],L.set(oe.uri,ge)),ge[1].push(oe.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Le([$],te),e.WorkspaceEdit=te;let ue=o=class{static isSnippetString(L){return L instanceof o?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=o.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,oe=this.e++){if(typeof L=="function"){const ge=new o;ge.e=this.e,L(ge),this.e=ge.e,L=ge.value}else L=o.c(L);return this.value+="${",this.value+=oe,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,oe=this.e++){const ge=L.map(Fe=>Fe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ge,this.value+="|}",this}appendVariable(L,oe){if(typeof oe=="function"){const ge=new o;ge.e=this.e,oe(ge),this.e=ge.e,oe=ge.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};ue=o=Le([$],ue),e.SnippetString=ue;var W;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let _=c=class{static isLocation(L){return L instanceof c?!0:L?H.isRange(L.range)&&y.URI.isUri(L.uri):!1}constructor(L,oe){if(this.uri=L,oe)if(H.isRange(oe))this.range=H.of(oe);else if(Y.isPosition(oe))this.range=new H(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};_=c=Le([$],_),e.Location=_;let V=class{static is(L){return L?typeof L.message=="string"&&L.location&&H.isRange(L.location.range)&&y.URI.isUri(L.location.uri):!1}constructor(L,oe){this.location=L,this.message=oe}static isEqual(L,oe){return L===oe?!0:!L||!oe?!1:L.message===oe.message&&L.location.range.isEqual(oe.location.range)&&L.location.uri.toString()===oe.location.uri.toString()}};V=Le([$],V),e.DiagnosticRelatedInformation=V;let Q=class{constructor(L,oe,ge=K.Error){if(!H.isRange(L))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=L,this.message=oe,this.severity=ge}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,oe){return L===oe?!0:!L||!oe?!1:L.message===oe.message&&L.severity===oe.severity&&L.code===oe.code&&L.severity===oe.severity&&L.source===oe.source&&L.range.isEqual(oe.range)&&(0,E.equals)(L.tags,oe.tags)&&(0,E.equals)(L.relatedInformation,oe.relatedInformation,V.isEqual)}};Q=Le([$],Q),e.Diagnostic=Q;let G=class{constructor(L,oe){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=oe}};G=Le([$],G),e.Hover=G;var X;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(X=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ce=class{constructor(L,oe=X.Text){this.range=L,this.kind=oe}toJSON(){return{range:this.range,kind:X[this.kind]}}};ce=Le([$],ce),e.DocumentHighlight=ce;var pe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(pe=e.SymbolKind||(e.SymbolKind={}));var Pe;(function(B){B[B.Deprecated=1]="Deprecated"})(Pe=e.SymbolTag||(e.SymbolTag={}));let Ae=l=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,oe,ge,Fe,We){this.name=L,this.kind=oe,this.containerName=We,typeof ge=="string"&&(this.containerName=ge),Fe instanceof _?this.location=Fe:ge instanceof H&&(this.location=new _(Fe,ge)),l.validate(this)}toJSON(){return{name:this.name,kind:pe[this.kind],location:this.location,containerName:this.containerName}}};Ae=l=Le([$],Ae),e.SymbolInformation=Ae;let Ne=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(s.validate)}constructor(L,oe,ge,Fe,We){this.name=L,this.detail=oe,this.kind=ge,this.range=Fe,this.selectionRange=We,this.children=[],s.validate(this)}};Ne=s=Le([$],Ne),e.DocumentSymbol=Ne;var $e;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})($e=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let me=class{constructor(L,oe){this.title=L,this.kind=oe}};me=Le([$],me),e.CodeAction=me;let we=g=class{constructor(L){this.value=L}append(L){return new g(this.value?this.value+g.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+g.c)}};we.c=".",we=g=Le([$],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ye=class{constructor(L,oe){if(this.range=L,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ye=Le([$],ye),e.SelectionRange=ye;class Me{constructor(L,oe,ge,Fe,We,Qe){this.kind=L,this.name=oe,this.detail=ge,this.uri=Fe,this.range=We,this.selectionRange=Qe}}e.CallHierarchyItem=Me;class je{constructor(L,oe){this.fromRanges=oe,this.from=L}}e.CallHierarchyIncomingCall=je;class Ge{constructor(L,oe){this.fromRanges=oe,this.to=L}}e.CallHierarchyOutgoingCall=Ge;var He;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(L,oe){this.range=L,this.command=oe}get isResolved(){return!!this.command}};Ke=Le([$],Ke),e.CodeLens=Ke;let Xe=R=class{static isMarkdownString(L){return L instanceof R?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,oe=!1){u.set(this,void 0),Nt(this,u,new a.MarkdownString(L,{supportThemeIcons:oe}),"f")}get value(){return rt(this,u,"f").value}set value(L){rt(this,u,"f").value=L}get isTrusted(){return rt(this,u,"f").isTrusted}set isTrusted(L){rt(this,u,"f").isTrusted=L}get supportThemeIcons(){return rt(this,u,"f").supportThemeIcons}set supportThemeIcons(L){rt(this,u,"f").supportThemeIcons=L}get supportHtml(){return rt(this,u,"f").supportHtml}set supportHtml(L){rt(this,u,"f").supportHtml=L}get baseUri(){return rt(this,u,"f").baseUri}set baseUri(L){rt(this,u,"f").baseUri=L}appendText(L){return rt(this,u,"f").appendText(L),this}appendMarkdown(L){return rt(this,u,"f").appendMarkdown(L),this}appendCodeblock(L,oe){return rt(this,u,"f").appendCodeblock(oe??"",L),this}};u=new WeakMap,Xe=R=Le([$],Xe),e.MarkdownString=Xe;let it=class{constructor(L,oe){this.label=L,this.documentation=oe}};it=Le([$],it),e.ParameterInformation=it;let Ye=class{constructor(L,oe){this.label=L,this.documentation=oe,this.parameters=[]}};Ye=Le([$],Ye),e.SignatureInformation=Ye;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=Le([$],xe),e.SignatureHelp=xe;var _e;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(_e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var fe;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(fe=e.InlayHintKind||(e.InlayHintKind={}));let Ie=class{constructor(L){this.value=L}};Ie=Le([$],Ie),e.InlayHintLabelPart=Ie;let Ce=class{constructor(L,oe,ge){this.position=L,this.label=oe,this.kind=ge}};Ce=Le([$],Ce),e.InlayHint=Ce;var Te;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Ve=class{constructor(L,oe){this.label=L,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ve=Le([$],Ve),e.CompletionItem=Ve;let nt=class{constructor(L=[],oe=!1){this.items=L,this.isIncomplete=oe}};nt=Le([$],nt),e.CompletionList=nt;let Je=class{constructor(L,oe,ge){this.insertText=L,this.range=oe,this.command=ge}};Je=Le([$],Je),e.InlineSuggestion=Je;let Ze=class{constructor(L){this.commands=void 0,this.items=L}};Ze=Le([$],Ze),e.InlineSuggestionList=Ze;var at;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(at=e.ViewColumn||(e.ViewColumn={}));var st;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var bt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ut;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ut=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Rt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Rt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function L(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let mt=class{constructor(L,oe){if(oe&&!y.URI.isUri(oe))throw(0,A.illegalArgument)("target");if(!H.isRange(L)||L.isEmpty)throw(0,A.illegalArgument)("range");this.range=L,this.target=oe}};mt=Le([$],mt),e.DocumentLink=mt;let wt=class{constructor(L,oe,ge,Fe){this.red=L,this.green=oe,this.blue=ge,this.alpha=Fe}};wt=Le([$],wt),e.Color=wt;let kt=class{constructor(L,oe){if(oe&&!(oe instanceof wt))throw(0,A.illegalArgument)("color");if(!H.isRange(L)||L.isEmpty)throw(0,A.illegalArgument)("range");this.range=L,this.color=oe}};kt=Le([$],kt),e.ColorInformation=kt;let Lt=class{constructor(L){if(!L||typeof L!="string")throw(0,A.illegalArgument)("label");this.label=L}};Lt=Le([$],Lt),e.ColorPresentation=Lt;var St;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(St=e.ColorFormat||(e.ColorFormat={}));var At;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(At=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ot;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ot=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(L,oe,ge){if(this.startIndex=L,this.length=oe,this.tooltip=ge,typeof L!="number"||L<0)throw(0,A.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,A.illegalArgument)("length");if(ge!==void 0&&typeof ge!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Se;class De{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=De;class he{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=he;var J;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(J=e.TerminalLocation||(e.TerminalLocation={}));class ke{constructor(L){if(this.options=L,typeof L!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=ke;var Oe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var qe;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ue=O=class{static from(L){switch(L){case"clean":return O.Clean;case"build":return O.Build;case"rebuild":return O.Rebuild;case"test":return O.Test;default:return}}constructor(L,oe){if(this.label=oe,typeof L!="string"||typeof oe!="string")throw(0,A.illegalArgument)("name");this.c=L}get id(){return this.c}};Ue.Clean=new O("clean","Clean"),Ue.Build=new O("build","Build"),Ue.Rebuild=new O("rebuild","Rebuild"),Ue.Test=new O("test","Test"),Ue=O=Le([$],Ue),e.TaskGroup=Ue;function tt(B){let L="";for(let oe=0;oe<B.length;oe++)L+=B[oe].replace(/,/g,",,")+",";return L}let lt=class{constructor(L,oe,ge){if(typeof L!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=L,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ge):this.f=oe)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,A.illegalArgument)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)L.push(oe);return tt(L)}};lt=Le([$],lt),e.ProcessExecution=lt;let vt=class{constructor(L,oe,ge){if(this.f=[],Array.isArray(oe)){if(!L)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,A.illegalArgument)("command");this.e=L,this.f=oe,this.g=ge}else{if(typeof L!="string")throw(0,A.illegalArgument)("commandLine");this.c=L,this.g=oe}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,A.illegalArgument)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,A.illegalArgument)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)L.push(typeof oe=="string"?oe:oe.value);return tt(L)}};vt=Le([$],vt),e.ShellExecution=vt;var It;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft=e.TaskScope||(e.TaskScope={}));class Et{constructor(L){this.c=L}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(L){this.c=L}get callback(){return this.c}}e.CustomExecution=Et;let Ot=z=class{constructor(L,oe,ge,Fe,We,Qe){this.j=!1,this.k=this.definition=L;let et;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=ge,this.execution=Fe,et=We,this.j=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.m=this.name=ge,this.t=this.source=Fe,this.execution=We,et=Qe):(this.target=oe,this.m=this.name=ge,this.t=this.source=Fe,this.execution=We,et=Qe),typeof et=="string"?(this.o=[et],this.q=!0):Array.isArray(et)?(this.o=et,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:z.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:z.f,id:this.n.computeId()}:this.n instanceof Et?this.k={type:z.c,id:this.n.computeId()}:this.k={type:z.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=L}get scope(){return this.l}set target(L){this.y(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.y(),this.n=L;const oe=this.k.type;(z.g===oe||z.e===oe||z.f===oe||z.c===oe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.y(),this.o=L,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.y(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.y(),this.u=L}get detail(){return this.x}set detail(L){L===null&&(L=void 0),this.x=L}get presentationOptions(){return this.v}set presentationOptions(L){L==null&&(L=Object.create(null)),this.y(),this.v=L}get runOptions(){return this.w}set runOptions(L){L==null&&(L=Object.create(null)),this.y(),this.w=L}};Ot.c="customExecution",Ot.e="process",Ot.f="shell",Ot.g="$empty",Ot=z=Le([$],Ot),e.Task=Ot;var Tn;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Tn=e.ProgressLocation||(e.ProgressLocation={}));var Rn;(function(B){function L(oe){const ge=oe;return(0,w.isNumber)(ge.value)?ge.tooltip&&!(0,w.isString)(ge.tooltip)?(console.log("INVALID view badge, invalid tooltip",ge.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ge.value),!1)}B.isViewBadge=L})(Rn=e.ViewBadge||(e.ViewBadge={}));let Gt=ie=class{static isTreeItem(L,oe){if(L instanceof ie)return!0;const ge=L;if(ge.label!==void 0&&!(0,w.isString)(ge.label)&&!ge.label?.label)return console.log("INVALID tree item, invalid label",ge.label),!1;if(ge.id!==void 0&&!(0,w.isString)(ge.id))return console.log("INVALID tree item, invalid id",ge.id),!1;if(ge.iconPath!==void 0&&!(0,w.isString)(ge.iconPath)&&!y.URI.isUri(ge.iconPath)&&(!ge.iconPath||!(0,w.isString)(ge.iconPath.id))){const Fe=ge.iconPath;if(!Fe||!(0,w.isString)(Fe.light)&&!y.URI.isUri(Fe.light)&&!(0,w.isString)(Fe.dark)&&!y.URI.isUri(Fe.dark))return console.log("INVALID tree item, invalid iconPath",ge.iconPath),!1}if(ge.description!==void 0&&!(0,w.isString)(ge.description)&&typeof ge.description!="boolean")return console.log("INVALID tree item, invalid description",ge.description),!1;if(ge.resourceUri!==void 0&&!y.URI.isUri(ge.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ge.resourceUri),!1;if(ge.tooltip!==void 0&&!(0,w.isString)(ge.tooltip)&&!(ge.tooltip instanceof Xe))return console.log("INVALID tree item, invalid tooltip",ge.tooltip),!1;if(ge.command!==void 0&&!ge.command.command)return console.log("INVALID tree item, invalid command",ge.command),!1;if(ge.collapsibleState!==void 0&&ge.collapsibleState<$t.None&&ge.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ge.collapsibleState),!1;if(ge.contextValue!==void 0&&!(0,w.isString)(ge.contextValue))return console.log("INVALID tree item, invalid contextValue",ge.contextValue),!1;if(ge.accessibilityInformation!==void 0&&!ge.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ge.accessibilityInformation),!1;if(ge.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(oe,"treeItemCheckbox");const Fe=(0,w.isNumber)(ge.checkboxState)?ge.checkboxState:(0,w.isObject)(ge.checkboxState)&&(0,w.isNumber)(ge.checkboxState.state)?ge.checkboxState.state:void 0,We=!(0,w.isNumber)(ge.checkboxState)&&(0,w.isObject)(ge.checkboxState)?ge.checkboxState.tooltip:void 0;if(Fe===void 0||Fe!==Kt.Checked&&Fe!==Kt.Unchecked||We!==void 0&&!(0,w.isString)(We))return console.log("INVALID tree item, invalid checkboxState",ge.checkboxState),!1}return!0}constructor(L,oe=$t.None){this.collapsibleState=oe,y.URI.isUri(L)?this.resourceUri=L:this.label=L}};Gt=ie=Le([$],Gt),e.TreeItem=Gt;var $t;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Kt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Kt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L,oe){this.value=L,this.id=oe??(0,T.generateUuid)()}};Yt=Le([$],Yt),e.DataTransferItem=Yt;let Jt=class{constructor(L){h.set(this,new Map);for(const[oe,ge]of L??[]){const Fe=rt(this,h,"f").get(oe);Fe?Fe.push(ge):rt(this,h,"f").set(oe,[ge])}}get(L){return rt(this,h,"f").get(L)?.[0]}set(L,oe){rt(this,h,"f").set(L,[oe])}forEach(L,oe){for(const[ge,Fe]of rt(this,h,"f"))for(const We of Fe)L.call(oe,We,ge,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[L,oe]of rt(this,h,"f"))for(const ge of oe)yield[L,ge]}};Jt=Le([$],Jt),e.DataTransfer=Jt;let Xt=class{constructor(L){this.insertText=L}};Xt=Le([$],Xt),e.DocumentDropEdit=Xt;let Qt=class{constructor(L){this.insertText=L}};Qt=Le([$],Qt),e.DocumentPasteEdit=Qt;let Ct=class{constructor(L,oe){this.id=L,this.color=oe}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};Ct=Le([$],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Zt=class{constructor(L){this.id=L}};Zt=Le([$],Zt),e.ThemeColor=Zt;var Ln;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ln=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{get base(){return this.c}set base(L){this.c=L,this.e=y.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,oe){if(typeof L!="string"&&(!L||!y.URI.isUri(L)&&!y.URI.isUri(L.uri)))throw(0,A.illegalArgument)("base");if(typeof oe!="string")throw(0,A.illegalArgument)("pattern");typeof L=="string"?this.baseUri=y.URI.file(L):y.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_t=Le([$],_t),e.RelativePattern=_t;const kn=new WeakMap;function On(B,L){kn.set(B,L)}e.setBreakpointId=On;let Mt=class{constructor(L,oe,ge,Fe){this.enabled=typeof L=="boolean"?L:!0,typeof oe=="string"&&(this.condition=oe),typeof ge=="string"&&(this.hitCondition=ge),typeof Fe=="string"&&(this.logMessage=Fe)}get id(){return this.c||(this.c=kn.get(this)??(0,T.generateUuid)()),this.c}};Mt=Le([$],Mt),e.Breakpoint=Mt;let en=class extends Mt{constructor(L,oe,ge,Fe,We){if(super(oe,ge,Fe,We),L===null)throw(0,A.illegalArgument)("location");this.location=L}};en=Le([$],en),e.SourceBreakpoint=en;let tn=class extends Mt{constructor(L,oe,ge,Fe,We){super(oe,ge,Fe,We),this.functionName=L}};tn=Le([$],tn),e.FunctionBreakpoint=tn;let nn=class extends Mt{constructor(L,oe,ge,Fe,We,Qe,et){if(super(Fe,We,Qe,et),!oe)throw(0,A.illegalArgument)("dataId");this.label=L,this.dataId=oe,this.canPersist=ge}};nn=Le([$],nn),e.DataBreakpoint=nn;let rn=class{constructor(L,oe,ge){this.command=L,this.args=oe||[],this.options=ge}};rn=Le([$],rn),e.DebugAdapterExecutable=rn;let sn=class{constructor(L,oe){this.port=L,this.host=oe}};sn=Le([$],sn),e.DebugAdapterServer=sn;let on=class{constructor(L){this.path=L}};on=Le([$],on),e.DebugAdapterNamedPipeServer=on;let an=class{constructor(L){this.implementation=L}};an=Le([$],an),e.DebugAdapterInlineImplementation=an;let ln=class{constructor(L,oe){this.range=L,this.expression=oe}};ln=Le([$],ln),e.EvaluatableExpression=ln;var Nn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Nn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let cn=class{constructor(L,oe){this.range=L,this.text=oe}};cn=Le([$],cn),e.InlineValueText=cn;let un=class{constructor(L,oe,ge=!0){this.range=L,this.variableName=oe,this.caseSensitiveLookup=ge}};un=Le([$],un),e.InlineValueVariableLookup=un;let fn=class{constructor(L,oe){this.range=L,this.expression=oe}};fn=Le([$],fn),e.InlineValueEvaluatableExpression=fn;let hn=class{constructor(L,oe){this.frameId=L,this.stoppedLocation=oe}};hn=Le([$],hn),e.InlineValueContext=hn;var Fn;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let dn=ee=class extends Error{static FileExists(L){return new ee(L,S.FileSystemProviderErrorCode.FileExists,ee.FileExists)}static FileNotFound(L){return new ee(L,S.FileSystemProviderErrorCode.FileNotFound,ee.FileNotFound)}static FileNotADirectory(L){return new ee(L,S.FileSystemProviderErrorCode.FileNotADirectory,ee.FileNotADirectory)}static FileIsADirectory(L){return new ee(L,S.FileSystemProviderErrorCode.FileIsADirectory,ee.FileIsADirectory)}static NoPermissions(L){return new ee(L,S.FileSystemProviderErrorCode.NoPermissions,ee.NoPermissions)}static Unavailable(L){return new ee(L,S.FileSystemProviderErrorCode.Unavailable,ee.Unavailable)}constructor(L,oe=S.FileSystemProviderErrorCode.Unknown,ge){super(y.URI.isUri(L)?L.toString(!0):L),this.code=ge?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,oe),Object.setPrototypeOf(this,ee.prototype),typeof Error.captureStackTrace=="function"&&typeof ge=="function"&&Error.captureStackTrace(this,ge)}};dn=ee=Le([$],dn),e.FileSystemError=dn;let mn=class{constructor(L,oe,ge){this.start=L,this.end=oe,this.kind=ge}};mn=Le([$],mn),e.FoldingRange=mn;var Mn;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Un;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Bn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Bn=e.CommentMode||(e.CommentMode={}));var jn;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(jn=e.CommentThreadState||(e.CommentThreadState={}));class $n{constructor(L,oe=[]){this.tokenTypes=L,this.tokenModifiers=oe}}e.SemanticTokensLegend=$n;function zn(B){return typeof B>"u"||(0,w.isStringArray)(B)}class gn{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let oe=0,ge=L.tokenTypes.length;oe<ge;oe++)this.j.set(L.tokenTypes[oe],oe);for(let oe=0,ge=L.tokenModifiers.length;oe<ge;oe++)this.k.set(L.tokenModifiers[oe],oe)}}push(L,oe,ge,Fe,We){if(typeof L=="number"&&typeof oe=="number"&&typeof ge=="number"&&typeof Fe=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.n(L,oe,ge,Fe,We);if(H.isRange(L)&&typeof oe=="string"&&zn(ge))return this.m(L,oe,ge);throw(0,A.illegalArgument)()}m(L,oe,ge){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Fe=L.start.line,We=L.start.character,Qe=L.end.character-L.start.character,et=this.j.get(oe);let ct=0;if(ge)for(const dt of ge){if(!this.k.has(dt))throw new Error("`tokenModifier` is not in the provided legend");const pt=this.k.get(dt);ct|=1<<pt>>>0}this.n(Fe,We,Qe,et,ct)}n(L,oe,ge,Fe,We){if(this.f&&(L<this.c||L===this.c&&oe<this.e)){this.f=!1;const ct=this.g.length/5|0;let dt=0,pt=0;for(let yt=0;yt<ct;yt++){let Dt=this.g[5*yt],Bt=this.g[5*yt+1];Dt===0?(Dt=dt,Bt+=pt):Dt+=dt,this.g[5*yt]=Dt,this.g[5*yt+1]=Bt,dt=Dt,pt=Bt}}let Qe=L,et=oe;this.f&&this.h>0&&(Qe-=this.c,Qe===0&&(et-=this.e)),this.g[this.h++]=Qe,this.g[this.h++]=et,this.g[this.h++]=ge,this.g[this.h++]=Fe,this.g[this.h++]=We,this.c=L,this.e=oe}static o(L){const oe=[],ge=L.length/5|0;for(let et=0;et<ge;et++)oe[et]=et;oe.sort((et,ct)=>{const dt=L[5*et],pt=L[5*ct];if(dt===pt){const yt=L[5*et+1],Dt=L[5*ct+1];return yt-Dt}return dt-pt});const Fe=new Uint32Array(L.length);let We=0,Qe=0;for(let et=0;et<ge;et++){const ct=5*oe[et],dt=L[ct+0],pt=L[ct+1],yt=L[ct+2],Dt=L[ct+3],Bt=L[ct+4],An=dt-We,Di=An===0?pt-Qe:pt,jt=5*et;Fe[jt+0]=An,Fe[jt+1]=Di,Fe[jt+2]=yt,Fe[jt+3]=Dt,Fe[jt+4]=Bt,We=dt,Qe=pt}return Fe}build(L){return this.f?new pn(new Uint32Array(this.g),L):new pn(gn.o(this.g),L)}}e.SemanticTokensBuilder=gn;class pn{constructor(L,oe){this.resultId=oe,this.data=L}}e.SemanticTokens=pn;class Wn{constructor(L,oe,ge){this.start=L,this.deleteCount=oe,this.data=ge}}e.SemanticTokensEdit=Wn;class Hn{constructor(L,oe){this.resultId=oe,this.edits=L}}e.SemanticTokensEdits=Hn;var Vn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Vn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let zt=class{constructor(){}};zt.Back={iconPath:new Ct("arrow-left")},zt=Le([$],zt),e.QuickInputButtons=zt;var qn;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(qn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Gn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Gn=e.ExtensionKind||(e.ExtensionKind={}));class Kn{static validate(L){if(typeof L.badge=="string"){let oe=(0,P.nextCharLength)(L.badge,0);if(oe<L.badge.length&&(oe+=(0,P.nextCharLength)(L.badge,oe)),L.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Ct.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,oe,ge){this.badge=L,this.tooltip=oe,this.color=ge}}e.FileDecoration=Kn;let bn=class{constructor(L){this.kind=L}};bn=Le([$],bn),e.ColorTheme=bn;var Yn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Yn=e.ColorThemeKind||(e.ColorThemeKind={}));class Tt{static isNotebookRange(L){return L instanceof Tt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,oe){if(L<0)throw(0,A.illegalArgument)("start must be positive");if(oe<0)throw(0,A.illegalArgument)("end must be positive");L<=oe?(this.c=L,this.e=oe):(this.c=oe,this.e=L)}with(L){let oe=this.c,ge=this.e;return L.start!==void 0&&(oe=L.start),L.end!==void 0&&(ge=L.end),oe===this.c&&ge===this.e?this:new Tt(oe,ge)}}e.NotebookRange=Tt;class Wt{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(oe=>Wt.isNotebookCellData(oe))}static isNotebookCellData(L){return!0}constructor(L,oe,ge,Fe,We,Qe,et){this.kind=L,this.value=oe,this.languageId=ge,this.mime=Fe,this.outputs=We??[],this.metadata=Qe,this.executionSummary=et,Wt.validate(this)}}e.NotebookCellData=Wt;class Jn{constructor(L){this.cells=L}}e.NotebookData=Jn;class gt{static isNotebookCellOutputItem(L){return L instanceof gt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const oe={name:L.name,message:L.message,stack:L.stack};return gt.json(oe,"application/vnd.code.notebook.error")}static stdout(L){return gt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return gt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,oe="application/octet-stream"){return new gt(L,oe)}static text(L,oe=D.Mimes.text){const ge=rt(gt,m,"f",d).encode(String(L));return new gt(ge,oe)}static json(L,oe="text/x-json"){const ge=JSON.stringify(L,void 0,"	");return gt.text(ge,oe)}constructor(L,oe){this.data=L,this.mime=oe;const ge=(0,D.normalizeMimeType)(oe,!0);if(!ge)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ge}}m=gt,d={value:new TextEncoder},e.NotebookCellOutputItem=gt;class Ht{static isNotebookCellOutput(L){return L instanceof Ht?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,oe=!1){const ge=new Set,Fe=new Set;for(let We=0;We<L.length;We++){const Qe=L[We],et=(0,D.normalizeMimeType)(Qe.mime);if(!ge.has(et)||(0,b.isTextStreamMime)(et)){ge.add(et);continue}Fe.add(We),oe&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return Fe.size===0?L:L.filter((We,Qe)=>!Fe.has(Qe))}constructor(L,oe,ge){this.items=Ht.ensureUniqueMimeTypes(L,!0),typeof oe=="string"?(this.id=oe,this.metadata=ge):(this.id=(0,T.generateUuid)(),this.metadata=oe??ge)}}e.NotebookCellOutput=Ht;var Xn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Xn=e.NotebookCellKind||(e.NotebookCellKind={}));var Qn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Zn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Zn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _n;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ei{constructor(L,oe){this.text=L,this.alignment=oe}}e.NotebookCellStatusBarItem=ei;var ti;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(ti=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ni;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ni=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ii{constructor(L,oe=[]){this.uri=L,this.provides=(0,E.asArray)(oe)}}e.NotebookRendererScript=ii;class ri{constructor(L){this.label=L}}e.NotebookKernelSourceAction=ri;let vn=class{constructor(L,oe){this.label=L,this.timestamp=oe}};vn=Le([$],vn),e.TimelineItem=vn;var si;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class li{constructor(L,oe){this.ranges=L,this.wordPattern=oe}}e.LinkedEditingRanges=li;class ci{constructor(L,oe){this.c=L,this.e=oe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ci;var ui;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var fi;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(fi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vt=class{constructor(L=void 0,oe=void 0,ge=void 0){this.include=L,this.exclude=oe,this.profile=ge}};Vt=Le([$],Vt),e.TestRunRequest=Vt;let En=class extends Vt{constructor(L=void 0,oe=void 0,ge=void 0,Fe=!1){super(L,oe,ge),this.continuous=Fe}};En=Le([$],En),e.TestRunRequest2=En;let yn=F=class{static diff(L,oe,ge){const Fe=new F(L);return Fe.expectedOutput=oe,Fe.actualOutput=ge,Fe}constructor(L){this.message=L}};yn=F=Le([$],yn),e.TestMessage=yn;let wn=class{constructor(L){this.id=L}};wn=Le([$],wn),e.TestTag=wn;let Ut=class{constructor(L,oe){this.covered=L,this.total=oe}};Ut=Le([$],Ut),e.CoveredCount=Ut;let Sn=Z=class{static fromDetails(L,oe){const ge=new Ut(0,0),Fe=new Ut(0,0),We=new Ut(0,0);for(const et of oe)if("branches"in et){ge.total+=1,ge.covered+=et.executionCount>0?1:0;for(const ct of et.branches)Fe.total+=1,Fe.covered+=ct.executionCount>0?1:0}else We.total+=1,We.covered+=et.executionCount>0?1:0;const Qe=new Z(L,ge,Fe.total>0?Fe:void 0,We.total>0?We:void 0);return Qe.detailedCoverage=oe,Qe}constructor(L,oe,ge,Fe){this.uri=L,this.statementCoverage=oe,this.branchCoverage=ge,this.functionCoverage=Fe}};Sn=Z=Le([$],Sn),e.FileCoverage=Sn;let In=class{constructor(L,oe,ge=[]){this.executionCount=L,this.location=oe,this.branches=ge}};In=Le([$],In),e.StatementCoverage=In;let Cn=class{constructor(L,oe){this.executionCount=L,this.location=oe}};Cn=Le([$],Cn),e.BranchCoverage=Cn;let Dn=class{constructor(L,oe){this.executionCount=L,this.location=oe}};Dn=Le([$],Dn),e.FunctionCoverage=Dn;var hi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var di;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(di=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(L,oe,ge,Fe,We,Qe){this.kind=L,this.name=oe,this.detail=ge,this.uri=Fe,this.range=We,this.selectionRange=Qe}}e.TypeHierarchyItem=gi;class pi{constructor(L){this.uri=L}}e.TextTabInput=pi;class bi{constructor(L,oe){this.original=L,this.modified=oe}}e.TextDiffTabInput=bi;class vi{constructor(L,oe,ge,Fe){this.base=L,this.input1=oe,this.input2=ge,this.result=Fe}}e.TextMergeTabInput=vi;class Ei{constructor(L,oe){this.uri=L,this.viewType=oe}}e.CustomEditorTabInput=Ei;class yi{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=yi;class wi{constructor(L,oe){this.uri=L,this.notebookType=oe}}e.NotebookEditorTabInput=wi;class Si{constructor(L,oe,ge){this.original=L,this.modified=oe,this.notebookType=ge}}e.NotebookDiffEditorTabInput=Si;class Ii{constructor(){}}e.TerminalEditorTabInput=Ii;class Ci{constructor(L,oe){this.uri=L,this.inputBoxUri=oe}}e.InteractiveWindowInput=Ci}),define(ve[134],Ee([1,0,18,15,151,69,93,27,142,46,56,23,8,4,49,159,221,129,84,127,68,85,131,133]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Se){function De(J){const{selectionStartLineNumber:ke,selectionStartColumn:Oe,positionLineNumber:qe,positionColumn:Ue}=J,tt=new r.Position(ke-1,Oe-1),lt=new r.Position(qe-1,Ue-1);return new r.Selection(tt,lt)}Se.to=De;function he(J){const{anchor:ke,active:Oe}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}Se.from=he})(n=e.Selection||(e.Selection={}));var i;(function(Se){function De(J){if(!J)return;const{start:ke,end:Oe}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}Se.from=De;function he(J){if(!J)return;const{startLineNumber:ke,startColumn:Oe,endLineNumber:qe,endColumn:Ue}=J;return new r.Range(ke-1,Oe-1,qe-1,Ue-1)}Se.to=he})(i=e.Range||(e.Range={}));var o;(function(Se){function De(he){switch(he){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Se.to=De})(o=e.TokenType||(e.TokenType={}));var c;(function(Se){function De(J){return new r.Position(J.lineNumber-1,J.column-1)}Se.to=De;function he(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=he})(c=e.Position||(e.Position={}));var l;(function(Se){function De(ke,Oe){return(0,E.coalesce)((0,E.asArray)(ke).map(qe=>he(qe,Oe)))}Se.from=De;function he(ke,Oe){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Oe),pattern:fe.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType}}function J(ke,Oe){return Oe&&typeof ke=="string"?Oe.transformOutgoingScheme(ke):ke}})(l=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Se){function De(J){switch(J){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Se.from=De;function he(J){switch(J){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Se.to=he})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(Se){function De(J){let ke;return J.code&&((0,v.isString)(J.code)||(0,v.isNumber)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...i.from(J.range),message:J.message,source:J.source,code:ke,severity:O.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(R.from),tags:Array.isArray(J.tags)?(0,E.coalesce)(J.tags.map(s.from)):void 0}}Se.from=De;function he(J){const ke=new r.Diagnostic(i.to(J),J.message,O.to(J.severity));return ke.source=J.source,ke.code=(0,v.isString)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(R.to),ke.tags=J.tags&&(0,E.coalesce)(J.tags.map(s.to)),ke}Se.to=he})(g=e.Diagnostic||(e.Diagnostic={}));var R;(function(Se){function De(J){return{...i.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=De;function he(J){return new r.DiagnosticRelatedInformation(new r.Location(J.resource,i.to(J)),J.message)}Se.to=he})(R=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(Se){function De(J){switch(J){case r.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Se.from=De;function he(J){switch(J){case u.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Se.to=he})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var z;(function(Se){function De(J){return typeof J=="number"&&J>=r.ViewColumn.One?J-1:J===r.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Se.from=De;function he(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=he})(z=e.ViewColumn||(e.ViewColumn={}));function ie(Se){return typeof Se.range<"u"}function ee(Se){return Se.length===0?!0:!!ie(Se[0])}e.isDecorationOptionsArr=ee;var F;(function(Se){function De(Ue){return Ue.map(Se.from)}Se.fromMany=De;function he(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function J(Ue){let tt;if(he(Ue)){const{language:ft,value:Et}=Ue;tt={value:"```"+ft+`
`+Et+"\n```\n"}}else r.MarkdownString.isMarkdownString(Ue)?tt={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?tt={value:Ue}:tt={value:""};const lt=Object.create(null);tt.uris=lt;const vt=ft=>{try{let Et=b.URI.parse(ft,!0);Et=Et.with({query:ke(Et.query,lt)}),lt[ft]=Et}catch{}return""},It=new w.marked.Renderer;return It.link=vt,It.image=ft=>typeof ft=="string"?vt(D.parseHrefAndDimensions(ft).href):"",(0,w.marked)(tt.value,{renderer:It}),tt}Se.from=J;function ke(Ue,tt){if(!Ue)return Ue;let lt;try{lt=(0,y.parse)(Ue)}catch{}if(!lt)return Ue;let vt=!1;return lt=(0,S.cloneAndChange)(lt,It=>{if(b.URI.isUri(It)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[ft]=It,vt=!0,ft}else return}),vt?JSON.stringify(lt):Ue}function Oe(Ue){const tt=new r.MarkdownString(Ue.value,Ue.supportThemeIcons);return tt.isTrusted=Ue.isTrusted,tt.supportHtml=Ue.supportHtml,tt.baseUri=Ue.baseUri?b.URI.from(Ue.baseUri):void 0,tt}Se.to=Oe;function qe(Ue){if(!!Ue)return typeof Ue=="string"?Ue:Se.from(Ue)}Se.fromStrict=qe})(F=e.MarkdownString||(e.MarkdownString={}));function Z(Se){return ee(Se)?Se.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?F.fromMany(De.hoverMessage):De.hoverMessage?F.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Se.map(De=>({range:i.from(De)}))}e.fromRangeOrRangeWithMessage=Z;function $(Se){return typeof Se>"u"?Se:typeof Se=="string"?b.URI.file(Se):Se}e.pathOrURIToURI=$;var x;(function(Se){function De(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?$(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Se.from=De})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var le;(function(Se){function De(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?$(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?x.from(he.before):void 0,after:he.after?x.from(he.after):void 0}}Se.from=De})(le=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var be;(function(Se){function De(he){if(typeof he>"u")return he;switch(he){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=De})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Y;(function(Se){function De(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?be.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?le.from(he.light):void 0,dark:he.dark?le.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?$(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?x.from(he.before):void 0,after:he.after?x.from(he.after):void 0}}Se.from=De})(Y=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(Se){function De(J){return{text:J.newText,eol:J.newEol&&Xe.from(J.newEol),range:i.from(J.range)}}Se.from=De;function he(J){const ke=new r.TextEdit(i.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:Xe.to(J.eol),ke}Se.to=he})(H=e.TextEdit||(e.TextEdit={}));var U;(function(Se){function De(J,ke){const Oe={edits:[]};if(J instanceof r.WorkspaceEdit){const qe=new P.ResourceSet;for(const Ue of J._allEntries())Ue._type===1&&b.URI.isUri(Ue.to)&&Ue.from===void 0&&qe.add(Ue.to);for(const Ue of J._allEntries())Ue._type===1?Oe.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contentsBase64:Ue.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(Ue.options.contents))},metadata:Ue.metadata}):Ue._type===2?Oe.edits.push({resource:Ue.uri,textEdit:H.from(Ue.edit),versionId:qe.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===6?Oe.edits.push({resource:Ue.uri,textEdit:{range:i.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:qe.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===3?Oe.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===5&&Oe.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(nt.from)}})}return Oe}Se.from=De;function he(J){const ke=new r.WorkspaceEdit;for(const Oe of J.edits)Oe.textEdit?ke.replace(b.URI.revive(Oe.resource),i.to(Oe.textEdit.range),Oe.textEdit.text):ke.renameFile(b.URI.revive(Oe.oldResource),b.URI.revive(Oe.newResource),Oe.options);return ke}Se.to=he})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ne;(function(Se){const De=Object.create(null);De[r.SymbolKind.File]=0,De[r.SymbolKind.Module]=1,De[r.SymbolKind.Namespace]=2,De[r.SymbolKind.Package]=3,De[r.SymbolKind.Class]=4,De[r.SymbolKind.Method]=5,De[r.SymbolKind.Property]=6,De[r.SymbolKind.Field]=7,De[r.SymbolKind.Constructor]=8,De[r.SymbolKind.Enum]=9,De[r.SymbolKind.Interface]=10,De[r.SymbolKind.Function]=11,De[r.SymbolKind.Variable]=12,De[r.SymbolKind.Constant]=13,De[r.SymbolKind.String]=14,De[r.SymbolKind.Number]=15,De[r.SymbolKind.Boolean]=16,De[r.SymbolKind.Array]=17,De[r.SymbolKind.Object]=18,De[r.SymbolKind.Key]=19,De[r.SymbolKind.Null]=20,De[r.SymbolKind.EnumMember]=21,De[r.SymbolKind.Struct]=22,De[r.SymbolKind.Event]=23,De[r.SymbolKind.Operator]=24,De[r.SymbolKind.TypeParameter]=25;function he(ke){return typeof De[ke]=="number"?De[ke]:6}Se.from=he;function J(ke){for(const Oe in De)if(De[Oe]===ke)return Number(Oe);return r.SymbolKind.Property}Se.to=J})(ne=e.SymbolKind||(e.SymbolKind={}));var se;(function(Se){function De(J){switch(J){case r.SymbolTag.Deprecated:return 1}}Se.from=De;function he(J){switch(J){case 1:return r.SymbolTag.Deprecated}}Se.to=he})(se=e.SymbolTag||(e.SymbolTag={}));var de;(function(Se){function De(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(se.from),containerName:J.containerName,location:q.from(J.location)}}Se.from=De;function he(J){const ke=new r.SymbolInformation(J.name,ne.to(J.kind),J.containerName,q.to(J.location));return ke.tags=J.tags&&J.tags.map(se.to),ke}Se.to=he})(de=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var re;(function(Se){function De(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:i.from(J.range),selectionRange:i.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(se.from)??[]};return J.children&&(ke.children=J.children.map(De)),ke}Se.from=De;function he(J){const ke=new r.DocumentSymbol(J.name,J.detail,ne.to(J.kind),i.to(J.range),i.to(J.selectionRange));return(0,E.isNonEmptyArray)(J.tags)&&(ke.tags=J.tags.map(se.to)),J.children&&(ke.children=J.children.map(he)),ke}Se.to=he})(re=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(Se){function De(J){const ke=new r.CallHierarchyItem(ne.to(J.kind),J.name,J.detail||"",b.URI.revive(J.uri),i.to(J.range),i.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}Se.to=De;function he(J,ke,Oe){if(ke=ke??J._sessionId,Oe=Oe??J._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:i.from(J.range),selectionRange:i.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=he})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Se){function De(he){return new r.CallHierarchyIncomingCall(j.to(he.from),he.fromRanges.map(J=>i.to(J)))}Se.to=De})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(Se){function De(he){return new r.CallHierarchyOutgoingCall(j.to(he.to),he.fromRanges.map(J=>i.to(J)))}Se.to=De})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var q;(function(Se){function De(J){return{range:J.range&&i.from(J.range),uri:J.uri}}Se.from=De;function he(J){return new r.Location(b.URI.revive(J.uri),i.to(J.range))}Se.to=he})(q=e.location||(e.location={}));var te;(function(Se){function De(J){const ke=J,Oe=J;return{originSelectionRange:ke.originSelectionRange?i.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Oe.uri,range:i.from(ke.targetRange?ke.targetRange:Oe.range),targetSelectionRange:ke.targetSelectionRange?i.from(ke.targetSelectionRange):void 0}}Se.from=De;function he(J){return{targetUri:b.URI.revive(J.uri),targetRange:i.to(J.range),targetSelectionRange:J.targetSelectionRange?i.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?i.to(J.originSelectionRange):void 0}}Se.to=he})(te=e.DefinitionLink||(e.DefinitionLink={}));var ue;(function(Se){function De(J){return{range:i.from(J.range),contents:F.fromMany(J.contents)}}Se.from=De;function he(J){return new r.Hover(J.contents.map(F.to),i.to(J.range))}Se.to=he})(ue=e.Hover||(e.Hover={}));var W;(function(Se){function De(J){return{range:i.from(J.range),expression:J.expression}}Se.from=De;function he(J){return new r.EvaluatableExpression(i.to(J.range),J.expression)}Se.to=he})(W=e.EvaluatableExpression||(e.EvaluatableExpression={}));var K;(function(Se){function De(J){if(J instanceof r.InlineValueText)return{type:"text",range:i.from(J.range),text:J.text};if(J instanceof r.InlineValueVariableLookup)return{type:"variable",range:i.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=De;function he(J){switch(J.type){case"text":return{range:i.to(J.range),text:J.text};case"variable":return{range:i.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:i.to(J.range),expression:J.expression}}}Se.to=he})(K=e.InlineValue||(e.InlineValue={}));var _;(function(Se){function De(J){return{frameId:J.frameId,stoppedLocation:i.from(J.stoppedLocation)}}Se.from=De;function he(J){return new r.InlineValueContext(J.frameId,i.to(J.stoppedLocation))}Se.to=he})(_=e.InlineValueContext||(e.InlineValueContext={}));var V;(function(Se){function De(J){return{range:i.from(J.range),kind:J.kind}}Se.from=De;function he(J){return new r.DocumentHighlight(i.to(J.range),J.kind)}Se.to=he})(V=e.DocumentHighlight||(e.DocumentHighlight={}));var Q;(function(Se){function De(he){switch(he){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Se.to=De})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(Se){function De(he){return{triggerKind:Q.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Se.to=De})(G=e.CompletionContext||(e.CompletionContext={}));var X;(function(Se){function De(J){switch(J){case r.CompletionItemTag.Deprecated:return 1}}Se.from=De;function he(J){switch(J){case 1:return r.CompletionItemTag.Deprecated}}Se.to=he})(X=e.CompletionItemTag||(e.CompletionItemTag={}));var ce;(function(Se){const De=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function he(Oe){return De.get(Oe)??9}Se.from=he;const J=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function ke(Oe){return J.get(Oe)??r.CompletionItemKind.Property}Se.to=ke})(ce=e.CompletionItemKind||(e.CompletionItemKind={}));var pe;(function(Se){function De(he,J){const ke=new r.CompletionItem(he.label);return ke.insertText=he.insertText,ke.kind=ce.to(he.kind),ke.tags=he.tags?.map(X.to),ke.detail=he.detail,ke.documentation=D.isMarkdownString(he.documentation)?F.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,f.Range.isIRange(he.range)?ke.range=i.to(he.range):typeof he.range=="object"&&(ke.range={inserting:i.to(he.range.insert),replacing:i.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules>"u"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?ke.insertText=new r.SnippetString(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof r.Range?new r.TextEdit(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(Oe=>H.to(Oe))),ke.command=J&&he.command?J.fromInternal(he.command):void 0,ke}Se.to=De})(pe=e.CompletionItem||(e.CompletionItem={}));var Pe;(function(Se){function De(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:F.fromStrict(J.documentation)}}Se.from=De;function he(J){return{label:J.label,documentation:D.isMarkdownString(J.documentation)?F.to(J.documentation):J.documentation}}Se.to=he})(Pe=e.ParameterInformation||(e.ParameterInformation={}));var Ae;(function(Se){function De(J){return{label:J.label,documentation:F.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(Pe.from):[],activeParameter:J.activeParameter}}Se.from=De;function he(J){return{label:J.label,documentation:D.isMarkdownString(J.documentation)?F.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(Pe.to):[],activeParameter:J.activeParameter}}Se.to=he})(Ae=e.SignatureInformation||(e.SignatureInformation={}));var Ne;(function(Se){function De(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(Ae.from):[]}}Se.from=De;function he(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(Ae.to):[]}}Se.to=he})(Ne=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(Se){function De(he,J){const ke=new r.InlayHint(c.to(J.position),typeof J.label=="string"?J.label:J.label.map(me.to.bind(void 0,he)),J.kind&&we.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(H.to),ke.tooltip=D.isMarkdownString(J.tooltip)?F.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}Se.to=De})($e=e.InlayHint||(e.InlayHint={}));var me;(function(Se){function De(he,J){const ke=new r.InlayHintLabelPart(J.label);return ke.tooltip=D.isMarkdownString(J.tooltip)?F.to(J.tooltip):J.tooltip,p.Command.is(J.command)&&(ke.command=he.fromInternal(J.command)),J.location&&(ke.location=q.to(J.location)),ke}Se.to=De})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Se){function De(J){return J}Se.from=De;function he(J){return J}Se.to=he})(we=e.InlayHintKind||(e.InlayHintKind={}));var ye;(function(Se){function De(J){return{range:i.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=De;function he(J){let ke;if(J.url)try{ke=typeof J.url=="string"?b.URI.parse(J.url,!0):b.URI.revive(J.url)}catch{}return new r.DocumentLink(i.to(J.range),ke)}Se.to=he})(ye=e.DocumentLink||(e.DocumentLink={}));var Me;(function(Se){function De(J){const ke=new r.ColorPresentation(J.label);return J.textEdit&&(ke.textEdit=H.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Oe=>H.to(Oe))),ke}Se.to=De;function he(J){return{label:J.label,textEdit:J.textEdit?H.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>H.from(ke)):void 0}}Se.from=he})(Me=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(Se){function De(J){return new r.Color(J[0],J[1],J[2],J[3])}Se.to=De;function he(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=he})(je=e.Color||(e.Color={}));var Ge;(function(Se){function De(J){return{range:i.from(J.range)}}Se.from=De;function he(J){return new r.SelectionRange(i.to(J.range))}Se.to=he})(Ge=e.SelectionRange||(e.SelectionRange={}));var He;(function(Se){function De(he){switch(he){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Se.to=De})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(Se){function De(J){switch(J){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=De;function he(J){switch(J){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Se.to=he})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Se){function De(J){if(J===r.EndOfLine.CRLF)return 1;if(J===r.EndOfLine.LF)return 0}Se.from=De;function he(J){if(J===1)return r.EndOfLine.CRLF;if(J===0)return r.EndOfLine.LF}Se.to=he})(Xe=e.EndOfLine||(e.EndOfLine={}));var it;(function(Se){function De(he){if(typeof he=="object")return he.viewId;switch(he){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=De})(it=e.ProgressLocation||(e.ProgressLocation={}));var Ye;(function(Se){function De(he){const J={start:he.start+1,end:he.end+1};return he.kind&&(J.kind=xe.from(he.kind)),J}Se.from=De})(Ye=e.FoldingRange||(e.FoldingRange={}));var xe;(function(Se){function De(he){if(he)switch(he){case r.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}Se.from=De})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _e;(function(Se){function De(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?i.from(he.selection):void 0,override:typeof he.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=De})(_e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(Se){function De(Oe){return Oe instanceof r.RelativePattern?Oe.toJSON():typeof Oe=="string"?Oe:he(Oe)||J(Oe)?new r.RelativePattern(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}Se.from=De;function he(Oe){const qe=Oe;return qe?b.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function J(Oe){const qe=Oe;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function ke(Oe){return typeof Oe=="string"?Oe:new r.RelativePattern(b.URI.revive(Oe.baseUri),Oe.pattern)}Se.to=ke})(fe=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(Se){function De(he){if(he){if(Array.isArray(he))return he.map(De);if(typeof he=="string")return he;{const J=he;return{language:J.language,scheme:J.scheme,pattern:fe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=De})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Se){function De(J){return{start:J.start,end:J.end}}Se.from=De;function he(J){return new r.NotebookRange(J.start,J.end)}Se.to=he})(Ce=e.NotebookRange||(e.NotebookRange={}));var Te;(function(Se){function De(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=De;function he(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=he})(Te=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Se){function De(he){if(he===d.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(he===d.NotebookCellExecutionState.Pending)return;if(he===d.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Se.to=De})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Se){function De(J){switch(J){case r.NotebookCellKind.Markup:return d.CellKind.Markup;case r.NotebookCellKind.Code:default:return d.CellKind.Code}}Se.from=De;function he(J){switch(J){case d.CellKind.Markup:return r.NotebookCellKind.Markup;case d.CellKind.Code:default:return r.NotebookCellKind.Code}}Se.to=he})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Se){function De(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Oe of J.cells)r.NotebookCellData.validate(Oe),ke.cells.push(nt.from(Oe));return ke}Se.from=De;function he(J){const ke=new r.NotebookData(J.cells.map(nt.to));return(0,v.isEmptyObject)(J.metadata)||(ke.metadata=J.metadata),ke}Se.to=he})(Ve=e.NotebookData||(e.NotebookData={}));var nt;(function(Se){function De(J){return{cellKind:ze.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Te.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ze.from):[]}}Se.from=De;function he(J){return new r.NotebookCellData(ze.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ze.to):void 0,J.metadata,J.internalMetadata?Te.to(J.internalMetadata):void 0)}Se.to=he})(nt=e.NotebookCellData||(e.NotebookCellData={}));var Je;(function(Se){function De(J){return{mime:J.mime,valueBytes:A.VSBuffer.wrap(J.data)}}Se.from=De;function he(J){return new r.NotebookCellOutputItem(J.valueBytes.buffer,J.mime)}Se.to=he})(Je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ze;(function(Se){function De(J){return{outputId:J.id,items:J.items.map(Je.from),metadata:J.metadata}}Se.from=De;function he(J){const ke=J.items.map(Je.to);return new r.NotebookCellOutput(ke,J.outputId,J.metadata)}Se.to=he})(Ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(Se){function De(ke){return J(ke)?{include:(0,v.withNullAsUndefined)(fe.from(ke.include)),exclude:(0,v.withNullAsUndefined)(fe.from(ke.exclude))}:(0,v.withNullAsUndefined)(fe.from(ke))}Se.from=De;function he(ke){return J(ke)?{include:fe.to(ke.include),exclude:fe.to(ke.exclude)}:fe.to(ke)}Se.to=he;function J(ke){const Oe=ke;return Oe?!(0,v.isUndefinedOrNull)(Oe.include)&&!(0,v.isUndefinedOrNull)(Oe.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var st;(function(Se){function De(he,J,ke){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Oe,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Se.from=De})(st=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var bt;(function(Se){function De(he,J,ke){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:J.toInternal(Oe,ke),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}Se.from=De})(bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var ut;(function(Se){function De(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Se.from=De})(ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Se){function De(J){return{uri:J.uri,provides:J.provides}}Se.from=De;function he(J){return new r.NotebookRendererScript(b.URI.revive(J.uri),J.provides)}Se.to=he})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(Se){function De(J){return{message:F.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,location:J.location&&{range:i.from(J.location.range),uri:J.location.uri}}}Se.from=De;function he(J){const ke=new r.TestMessage(typeof J.message=="string"?J.message:F.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.location=J.location?q.to(J.location):void 0,ke}Se.to=he})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(Se){Se.namespace=k.namespaceTestTag,Se.denamespace=k.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Rt;(function(Se){function De(J){const ke=(0,h.getPrivateApiFor)(J).controllerId;return{extId:C.TestId.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:b.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Oe=>ht.namespace(ke,Oe.id)),range:f.Range.lift(i.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&F.fromStrict(J.error)||null}}Se.from=De;function he(J){return{parent:void 0,error:void 0,id:C.TestId.fromString(J.extId).localId,label:J.label,uri:b.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Oe}=ht.denamespace(ke);return new r.TestTag(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=he})(Rt=e.TestItem||(e.TestItem={})),function(Se){function De(J){return{id:J.id}}Se.from=De;function he(J){return new r.TestTag(J.id)}Se.to=he}(ht=e.TestTag||(e.TestTag={}));var mt;(function(Se){const De=(J,ke)=>{const Oe=[];for(const[Ue,tt]of ke)C.TestId.compare(tt.item.extId,Ue)===2&&(ke.delete(Ue),Oe.push(tt));const qe={...Rt.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(tt=>tt.type===0).map(Pt.to)})),children:Oe.map(Ue=>De(Ue,ke))};for(const Ue of qe.children)Ue.parent=qe;return qe};function he(J){const ke=[],Oe=new Map;for(const qe of J.items){Oe.set(qe.item.extId,qe);const Ue=C.TestId.root(qe.item.extId);J.request.targets.some(tt=>tt.controllerId===Ue&&tt.testIds.includes(qe.item.extId))&&ke.push(qe)}return{completedAt:J.completedAt,results:ke.map(qe=>De(qe,Oe))}}Se.to=he})(mt=e.TestResults||(e.TestResults={}));var wt;(function(Se){function De(Oe){return{covered:Oe.covered,total:Oe.covered}}function he(Oe){return"line"in Oe?c.from(Oe):i.from(Oe)}function J(Oe){return"branches"in Oe?{count:Oe.executionCount,location:he(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(qe=>({count:qe.executionCount,location:qe.location&&he(qe.location)})):void 0}:{type:0,count:Oe.executionCount,location:he(Oe.location)}}Se.fromDetailed=J;function ke(Oe){return{uri:Oe.uri,statement:De(Oe.statementCoverage),branch:Oe.branchCoverage&&De(Oe.branchCoverage),function:Oe.functionCoverage&&De(Oe.functionCoverage),details:Oe.detailedCoverage?.map(J)}}Se.fromFile=ke})(wt=e.TestCoverage||(e.TestCoverage={}));var kt;(function(Se){function De(he){switch(he){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Se.to=De})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(Se){function De(J){const ke=new r.TypeHierarchyItem(ne.to(J.kind),J.name,J.detail||"",b.URI.revive(J.uri),i.to(J.range),i.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}Se.to=De;function he(J,ke,Oe){if(ke=ke??J._sessionId,Oe=Oe??J._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:i.from(J.range),selectionRange:i.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=he})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var St;(function(Se){function De(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}Se.from=De})(St=e.ViewBadge||(e.ViewBadge={}));var At;(function(Se){function De(Oe,qe,Ue){const tt=qe.fileData;return tt?new class extends r.DataTransferItem{asFile(){return{name:tt.name,uri:b.URI.revive(tt.uri),data:(0,I.once)(()=>Ue())}}}("",qe.id):Oe===T.Mimes.uriList&&qe.uriListData?new r.DataTransferItem(ke(qe.uriListData)):new r.DataTransferItem(qe.asString)}Se.to=De;async function he(Oe,qe){const Ue=await qe.asString();if(Oe===T.Mimes.uriList)return{id:qe.id,asString:Ue,fileData:void 0,uriListData:J(Ue)};const tt=qe.asFile();return{id:qe.id,asString:Ue,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Se.from=he;function J(Oe){return a.UriList.split(Oe).map(qe=>{if(qe.startsWith("#"))return qe;try{return b.URI.parse(qe)}catch{}return qe})}function ke(Oe){return a.UriList.create(Oe.map(qe=>typeof qe=="string"?qe:b.URI.revive(qe)))}})(At=e.DataTransferItem||(e.DataTransferItem={}));var ot;(function(Se){function De(J,ke){const Oe=J.items.map(([qe,Ue])=>[qe,At.to(qe,Ue,()=>ke(Ue.id))]);return new r.DataTransfer(Oe)}Se.toDataTransfer=De;async function he(J){const ke={items:[]},Oe=[];return J.forEach((qe,Ue)=>{Oe.push((async()=>{ke.items.push([Ue,await At.from(Ue,qe)])})())}),await Promise.all(Oe),ke}Se.toDataTransferDTO=he})(ot=e.DataTransfer||(e.DataTransfer={}))}),define(ve[268],Ee([1,0,49,129,68,128,85,134,4]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(d,C,k,t)=>{let r=C;return{enumerable:!0,configurable:!1,get(){return r},set(n){if(!k(r,n)){const i=r;r=n,d.listener?.(t(n,i))}}}},T=(d,C)=>d===C,S={range:(d,C)=>d===C?!0:!d||!C?!1:d.isEqual(C),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(d,C)=>!(d.length!==C.length||d.some(k=>!C.find(t=>k.id===t.id)))},v=d=>C=>({op:4,update:d(C)}),b=(d,C)=>({range:(()=>{let k;const t=v(r=>({range:E.Range.lift(P.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return k},set(r){d.listener?.({op:6}),S.range(k,r)||(k=r,d.listener?.(t(r)))}}})(),label:y(d,C,S.label,v(k=>({label:k}))),description:y(d,void 0,S.description,v(k=>({description:k}))),sortText:y(d,void 0,S.sortText,v(k=>({sortText:k}))),canResolveChildren:y(d,!1,S.canResolveChildren,k=>({op:2,state:k})),busy:y(d,!1,S.busy,v(k=>({busy:k}))),error:y(d,void 0,S.error,v(k=>({error:P.MarkdownString.fromStrict(k)||null}))),tags:y(d,[],S.tags,(k,t)=>({op:1,new:k.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),f=d=>{const C=a.TestId.fromString(d.extId),k=new u(C.controllerId,C.localId,d.label,w.URI.revive(d.uri)||void 0);return k.range=P.Range.to(d.range||void 0),k.description=d.description||void 0,k.sortText=d.sortText||void 0,k.tags=d.tags.map(t=>P.TestTag.to({id:(0,D.denamespaceTestTag)(t).tagId})),k},p=d=>{let C;for(const k of d.tests){const t=f(k.item);(0,A.getPrivateApiFor)(t).parent=C,C=t}return C};e.toItemFromContext=p;class u{constructor(C,k,t,r){if(k.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(k)} symbol`);const n=(0,A.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:k,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof h?void 0:n.parent}},children:{value:(0,I.createTestItemChildren)(n,A.getPrivateApiFor,u),enumerable:!0,writable:!1},...b(n,t)})}}e.TestItemImpl=u;class h extends u{constructor(C,k){super(C,C,k,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class m extends I.TestItemCollection{constructor(C,k,t){super({controllerId:C,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:A.getPrivateApiFor,getChildren:r=>r.children,root:new h(C,k),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(ve[269],Ee([1,0,33,196,50]),function(ae,e,E,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function I(D,P,w,y){const T=new Map;D.forEach(v=>{const b=E.ExtensionIdentifier.toKey(v.identifier),f=T.get(b);f&&y.warn((0,A.localize)(0,null,f.extensionLocation.fsPath,v.extensionLocation.fsPath)),T.set(b,v)}),P.forEach(v=>{const b=E.ExtensionIdentifier.toKey(v.identifier),f=T.get(b);if(f)if(f.isBuiltin){if(a.gte(f.version,v.version)){y.warn(`Skipping extension ${v.extensionLocation.path} in favour of the builtin extension ${f.extensionLocation.path}.`);return}v.isBuiltin=!0}else y.warn((0,A.localize)(1,null,f.extensionLocation.fsPath,v.extensionLocation.fsPath));else if(v.isBuiltin){y.warn(`Skipping obsolete builtin extension ${v.extensionLocation.path}`);return}T.set(b,v)}),w.forEach(v=>{y.info((0,A.localize)(2,null,v.extensionLocation.fsPath));const b=E.ExtensionIdentifier.toKey(v.identifier),f=T.get(b);f&&f.isBuiltin&&(v.isBuiltin=!0),T.set(b,v)});const S=[];return T.forEach(v=>S.push(v)),S}e.dedupExtensions=I}),define(ve[270],Ee([1,0,3,47,4,67,13,72,104,99,231,7,28,54,269]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class p{constructor(h,m,d,C,k,t,r){if(this.c=h,this.d=m,this.f=d,this.g=k,this.h=t,this.i=r,m.args["install-builtin-extension"]){const i={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};this.b=C.installExtensions([],m.args["install-builtin-extension"],i,!!m.args.force).then(null,o=>{k.error(o)})}else this.b=Promise.resolve();const n=m.args["install-extension"];if(n){const i=n.map(o=>/\.vsix$/i.test(o)?a.URI.file((0,S.isAbsolute)(o)?o:(0,S.join)((0,v.cwd)(),o)):o);this.b.then(()=>C.installExtensions(i,[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]},!!m.args.force)).then(null,o=>{k.error(o)})}}async call(h,m,d){switch(m){case"getEnvironmentData":{const C=d,k=(0,I.createURITransformer)(C.remoteAuthority);let t=await this.k();return t=(0,P.transformOutgoingURIs)(t,k),t}case"getExtensionHostExitInfo":{const C=d;return this.h.getExitInfo(C.reconnectionToken)}case"whenExtensionsReady":{await this.b;return}case"scanExtensions":{await this.b;const C=d,k=C.language;this.g.trace(`Scanning extensions using UI language: ${k}`);const t=(0,I.createURITransformer)(C.remoteAuthority),r=C.extensionDevelopmentPath&&C.extensionDevelopmentPath.map(o=>a.URI.revive(t.transformIncoming(o))),n=r?r.filter(o=>o.scheme===D.Schemas.file).map(o=>o.fsPath):void 0;let i=await this.l(k,n);return i=(0,P.transformOutgoingURIs)(i,t),this.g.trace("Scanned Extensions",i),p.j(i),i}case"scanSingleExtension":{await this.b;const C=d,k=C.language,t=C.isBuiltin,r=(0,I.createURITransformer)(C.remoteAuthority),n=a.URI.revive(r.transformIncoming(C.extensionLocation)),i=n.scheme===D.Schemas.file?n.fsPath:null;if(!i)return null;let o=await this.p(i,t,k);return o?(o=(0,P.transformOutgoingURIs)(o,r),p.j([o]),o):null}case"getDiagnosticInfo":{const C=d,k={machineInfo:(0,T.getMachineInfo)()},t=C.includeProcesses?(0,y.listProcesses)(process.pid):Promise.resolve();let r=[];const n={};if(C.folders){const i=(0,I.createURITransformer)("");r=C.folders.map(c=>a.URI.revive(i.transformIncoming(c))).filter(c=>c.scheme==="file").map(c=>(0,T.collectWorkspaceStats)(c.fsPath,["node_modules",".git"]).then(l=>{n[(0,S.basename)(c.fsPath)]=l}))}return Promise.all([t,...r]).then(([i,o])=>(k.processes=i||void 0,k.workspaceMetadata=C.folders?n:void 0,k))}}throw new Error(`IPC Command ${m} not found`)}listen(h,m,d){throw new Error("Not supported")}static j(h){const m=(n,i)=>n.replace(/file/g,"vscode-remote"),d=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(m(n.source,!0),i)},C=new class{mapDefined(n){return w.ContextKeyDefinedExpr.create(n)}mapNot(n){return w.ContextKeyNotExpr.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?w.ContextKeyEqualsExpr.create(n,m(i,!1)):w.ContextKeyEqualsExpr.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?w.ContextKeyNotEqualsExpr.create(n,m(i,!1)):w.ContextKeyNotEqualsExpr.create(n,i)}mapGreater(n,i){return w.ContextKeyGreaterExpr.create(n,i)}mapGreaterEquals(n,i){return w.ContextKeyGreaterEqualsExpr.create(n,i)}mapSmaller(n,i){return w.ContextKeySmallerExpr.create(n,i)}mapSmallerEquals(n,i){return w.ContextKeySmallerEqualsExpr.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?w.ContextKeyRegexExpr.create(n,d(i)):w.ContextKeyRegexExpr.create(n,i)}mapIn(n,i){return w.ContextKeyInExpr.create(n,i)}mapNotIn(n,i){return w.ContextKeyNotInExpr.create(n,i)}},k=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=w.ContextKeyExpr.deserialize(n.when);if(!i)return;const o=i.map(C);n.when=o.serialize()},t=n=>{if(Array.isArray(n))for(const i of n)k(i);else k(n)},r=n=>{for(const i in n)t(n[i])};h.forEach(n=>{n.contributes&&(n.contributes.menus&&r(n.contributes.menus),n.contributes.keybindings&&t(n.contributes.keybindings),n.contributes.views&&r(n.contributes.views))})}async k(){return{pid:process.pid,connectionToken:this.c.type!==0?this.c.value:"",appRoot:a.URI.file(this.d.appRoot),settingsPath:this.d.machineSettingsResource,logsPath:a.URI.file(this.d.logsPath),extensionsPath:a.URI.file(this.d.extensionsPath),extensionHostLogsPath:a.URI.file((0,S.join)(this.d.logsPath,`exthost${p.a++}`)),globalStorageHome:this.f.defaultProfile.globalStorageHome,workspaceStorageHome:this.d.workspaceStorageHome,localHistoryHome:this.d.localHistoryHome,userHome:this.d.userHome,os:E.OS,arch:process.arch,marks:A.getMarks(),useHostProxy:!!this.d.args["use-host-proxy"]}}async l(h,m){const[d,C,k]=await Promise.all([this.n(h),this.o(h),this.m(h,m)]);return(0,f.dedupExtensions)(d,C,k,this.g)}async m(h,m){return m?(await Promise.all(m.map(d=>this.i.scanOneOrMultipleExtensions(a.URI.file((0,S.resolve)(d)),1,{language:h})))).flat().map(d=>(0,b.toExtensionDescription)(d,!0)):[]}async n(h){return(await this.i.scanSystemExtensions({language:h,useCache:!0})).map(d=>(0,b.toExtensionDescription)(d,!1))}async o(h){return(await this.i.scanUserExtensions({profileLocation:this.f.defaultProfile.extensionsResource,language:h,useCache:!0})).map(d=>(0,b.toExtensionDescription)(d,!1))}async p(h,m,d){const C=a.URI.file((0,S.resolve)(h)),k=m?0:1,t=await this.i.scanExistingExtension(C,k,{language:d});return t?(0,b.toExtensionDescription)(t,!1):null}}p.a=1,e.RemoteAgentEnvironmentChannel=p}),define(ve[135],Ee([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++E.count}}E.count=0,e.ProxyIdentifier=E;const A=[];function a(P){const w=new E(P);return A[w.nid]=w,w}e.createProxyIdentifier=a;function I(P){return A[P].sid}e.getStringIdentifierForProxy=I;class D{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=D}),define(ve[271],Ee([1,0,135]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var a;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(a=e.TabInputKind||(e.TabInputKind={}));var I;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(I=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(u){return u._id=S.a++,u}}S.a=0,e.IdObject=S;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,E.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,E.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,E.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,E.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,E.createProxyIdentifier)("ExtHostLocalization")}});var Nt=this&&this.__classPrivateFieldSet||function(ae,e,E,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!a:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ae,E):a?a.value=E:e.set(ae,E),E},rt=this&&this.__classPrivateFieldGet||function(ae,e,E,A){if(E==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!A:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?A:E==="a"?A.call(ae):A?A.value:e.get(ae)};define(ve[272],Ee([1,0,8,133,134,23,271,18,12,46,49,102,4,2,5,258,268,15,135,38,90,40]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k){"use strict";var t,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(g,R){t.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),Nt(this,t,g.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=R,Nt(this,r,g.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new i(this,O=>{const z=this.c.get(O);return z?.result===c.Void?z:void 0},R),this.f=[{processArgument(O){return(0,y.revive)(O)}},{processArgument(O){return(0,I.cloneAndChange)(O,function(z){if(T.Range.isIRange(z))return a.Range.to(z);if(S.Position.isIPosition(z))return a.Position.to(z);if(T.Range.isIRange(z.range)&&v.URI.isUri(z.uri))return a.location.to(z);if(z instanceof h.VSBuffer)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const R=this.registerCommand(!1,g.id,async(...O)=>{const z=g.args.map((ee,F)=>{if(!ee.validate(O[F]))throw new Error(`Invalid argument '${ee.name}' when running '${g.id}', received: ${O[F]}`);return ee.convert(O[F])}),ie=await this.executeCommand(g.internalId,...z);return g.result.convert(ie,O,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new A.Disposable(()=>{R.dispose(),this.c.delete(g.id)})}registerCommand(g,R,O,z,ie,ee){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:O,thisArg:z,description:ie,extension:ee}),g&&rt(this,t,"f").$registerCommand(R),new A.Disposable(()=>{this.b.delete(R)&&g&&rt(this,t,"f").$unregisterCommand(R)})}executeCommand(g,...R){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,R,!0)}async g(g,R,O){if(this.b.has(g))return rt(this,t,"f").$fireCommandActivationEvent(g),this.h(g,R,!1);{let z=!1;const ie=(0,I.cloneAndChange)(R,function(ee){if(ee instanceof A.Position)return a.Position.from(ee);if(ee instanceof A.Range)return a.Range.from(ee);if(ee instanceof A.Location)return a.location.from(ee);if(A.NotebookRange.isNotebookRange(ee))return a.NotebookRange.from(ee);if(ee instanceof ArrayBuffer)return z=!0,h.VSBuffer.wrap(new Uint8Array(ee));if(ee instanceof Uint8Array)return z=!0,h.VSBuffer.wrap(ee);if(ee instanceof h.VSBuffer)return z=!0,ee;if(!Array.isArray(ee))return ee});try{const ee=await rt(this,t,"f").$executeCommand(g,z?new m.SerializableObjectWithBuffers(ie):ie,O);return(0,y.revive)(ee)}catch(ee){if(ee instanceof Error&&ee.message==="$executeCommand:retry")return this.g(g,R,!1);throw ee}}}async h(g,R,O){const z=this.b.get(g);if(!z)throw new Error("Unknown command");const{callback:ie,thisArg:ee,description:F}=z;if(F)for(let $=0;$<F.args.length;$++)try{(0,E.validateConstraint)(R[$],F.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${F.args[$].name}' - ${F.args[$].description}`)}const Z=C.StopWatch.create();try{return await ie.apply(ee,R)}catch($){if(g===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...R);x&&(g=x.command)}throw this.d.error($,g,z.extension?.identifier),O?new class extends Error{constructor(){super((0,d.toErrorMessage)($)),this.id=g,this.source=z.extension?.displayName??z.extension?.name}}:$}finally{this.j(z,g,Z.elapsed())}}j(g,R,O){!g.extension||rt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new k.TelemetryTrustedValue(R),duration:O})}$executeContributedCommand(g,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const O=this.b.get(g);return O?(R=R.map(z=>this.f.reduce((ie,ee)=>ee.processArgument(ie,O.extension?.identifier),z)),this.h(g,R,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),rt(this,t,"f").$getCommands().then(R=>(g&&(R=R.filter(O=>O[0]!=="_")),R))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[R,O]of this.b){const{description:z}=O;z&&(g[R]=z)}return Promise.resolve(g)}};t=new WeakMap,r=new WeakMap,n=Le([Re(0,p.IExtHostRpcService),Re(1,w.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class i{constructor(g,R,O){this.d=g,this.f=R,this.g=O,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,R){if(!g)return;const O={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return O;const z=this.f(g.command);if(z)O.id=z.internalId,O.arguments=z.args.map((ie,ee)=>ie.convert(g.arguments&&g.arguments[ee]));else if((0,P.isNonEmptyArray)(g.arguments)){const ie=`${g.command}/${++this.c}`;this.b.set(ie,g),R.add((0,b.toDisposable)(()=>{this.b.delete(ie),this.g.trace("CommandsConverter#DISPOSE",ie)})),O.$ident=ie,O.id=this.delegatingCommandId,O.arguments=[ie],this.g.trace("CommandsConverter#CREATE",g.command,ie)}return O}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const R=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=i;class o{constructor(g,R,O,z){this.name=g,this.description=R,this.validate=O,this.convert=z}optional(){return new o(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,R){return new o(g??this.name,R??this.description,this.validate,this.convert)}}o.Uri=new o("uri","Uri of a text document",s=>v.URI.isUri(s),s=>s),o.Position=new o("position","A position in a text document",s=>A.Position.isPosition(s),a.Position.from),o.Range=new o("range","A range in a text document",s=>A.Range.isRange(s),a.Range.from),o.Selection=new o("selection","A selection in a text document",s=>A.Selection.isSelection(s),a.Selection.from),o.Number=new o("number","",s=>typeof s=="number",s=>s),o.String=new o("string","",s=>typeof s=="string",s=>s),o.CallHierarchyItem=new o("item","A call hierarchy item",s=>s instanceof A.CallHierarchyItem,a.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",s=>s instanceof A.TypeHierarchyItem,a.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",s=>s instanceof u.TestItemImpl,a.TestItem.from),e.ApiCommandArgument=o;class c{constructor(g,R){this.description=g,this.convert=R}}c.Void=new c("no result",s=>s),e.ApiCommandResult=c;class l{constructor(g,R,O,z,ie){this.id=g,this.internalId=R,this.description=O,this.args=z,this.result=ie}}e.ApiCommand=l}),define(ve[273],Ee([1,0,60,256,31,272,4,12,82]),function(ae,e,E,A,a,I,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(v,b,f){this.b=v,this.c=b,this.f=f,this.a=A.createServer((p,u)=>this.h(p,u)),this.g().catch(p=>(b.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,b){const f=(u,h)=>{b.writeHead(u,{"content-type":"application/json"}),b.end(JSON.stringify(h||null),m=>m&&this.c.error(m))},p=[];v.setEncoding("utf8"),v.on("data",u=>p.push(u)),v.on("end",async()=>{try{const u=JSON.parse(p.join(""));let h;switch(u.type){case"open":h=await this.i(u);break;case"openExternal":h=await this.j(u);break;case"status":h=await this.l(u);break;case"extensionManagement":h=await this.k(u);break;default:f(404,`Unknown message type: ${u.type}`);break}f(200,h)}catch(u){const h=u instanceof Error?u.message:JSON.stringify(u);f(500,h),this.c.error("Error while processing pipe request",u)}})}async i(v){const{fileURIs:b,folderURIs:f,forceNewWindow:p,diffMode:u,mergeMode:h,addMode:m,forceReuseWindow:d,gotoLineMode:C,waitMarkerFilePath:k,remoteAuthority:t}=v,r=[];if(Array.isArray(f))for(const c of f)try{r.push({folderUri:D.URI.parse(c)})}catch{}if(Array.isArray(b))for(const c of b)try{(0,w.hasWorkspaceFileExtension)(c)?r.push({workspaceUri:D.URI.parse(c)}):r.push({fileUri:D.URI.parse(c)})}catch{}const n=k?D.URI.file(k):void 0,o={forceNewWindow:p,diffMode:u,mergeMode:h,addMode:m,gotoLineMode:C,forceReuseWindow:d,preferNewWindow:!d&&!n&&!m,waitMarkerFileURI:n,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",r,o),""}async j(v){for(const b of v.uris){const f=D.URI.parse(b),p=f.scheme==="file"?f:b;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const b=p=>p?.map(u=>/\.vsix$/i.test(u)?D.URI.parse(u):u),f={list:v.list,install:b(v.install),uninstall:b(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",f)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&a.existsSync(this.f)&&a.unlinkSync(this.f)}}e.CLIServerBase=y;let T=class extends y{constructor(v,b){super(v,b,(0,E.createRandomIPCHandle)())}};T=Le([Re(0,I.IExtHostCommands),Re(1,P.ILogService)],T),e.CLIServer=T}),define(ve[274],Ee([1,0,29,6,23,2,7,3,4,60,67,273,119,81,261,263,132]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class h extends p.AbstractVariableResolverService{constructor(C,k,t,r,n){super({getFolderUri:i=>{const o=k.filter(c=>c.name===i);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>k.length,getConfigurationValue:(i,o)=>r[`config:${o}`],getExecPath:()=>C.VSCODE_EXEC_PATH,getAppRoot:()=>C.VSCODE_CWD,getFilePath:()=>{if(t)return D.normalize(t.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async i=>{const c=(await n.getInstalled()).find(l=>l.identifier.id===i);return c&&{extensionLocation:c.location}}},void 0,Promise.resolve(E.homedir()),Promise.resolve(C))}}class m extends I.Disposable{constructor(C,k,t,r,n,i){super(),this.g=C,this.h=k,this.i=t,this.j=r,this.l=n,this.m=i,this.a=0,this.b=new Map,this.c=this.B(new A.Emitter),this.onExecuteCommand=this.c.event}async call(C,k,t){switch(k){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,t);case"$createProcess":{const r=(0,T.createURITransformer)(C.remoteAuthority);return this.n(r,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,t)}throw new Error(`IPC Command ${k} not found`)}listen(C,k,t){switch(k){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||A.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||A.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||A.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||A.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||A.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||A.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(C,k){const t={name:k.shellLaunchConfig.name,executable:k.shellLaunchConfig.executable,args:k.shellLaunchConfig.args,cwd:typeof k.shellLaunchConfig.cwd=="string"||typeof k.shellLaunchConfig.cwd>"u"?k.shellLaunchConfig.cwd:w.URI.revive(C.transformIncoming(k.shellLaunchConfig.cwd)),env:k.shellLaunchConfig.env,useShellEnvironment:k.shellLaunchConfig.useShellEnvironment,reconnectionProperties:k.shellLaunchConfig.reconnectionProperties,type:k.shellLaunchConfig.type,isFeatureTerminal:k.shellLaunchConfig.isFeatureTerminal},r=await(0,u.buildUserEnvironment)(k.resolverEnv,!!k.shellLaunchConfig.useShellEnvironment,P.language,this.g,this.h,this.m);this.h.trace("baseEnv",r);const n=$=>({uri:w.URI.revive(C.transformIncoming($.uri)),name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),i=k.workspaceFolders.map(n),o=k.activeWorkspaceFolder?n(k.activeWorkspaceFolder):void 0,c=k.activeFileResource?w.URI.revive(C.transformIncoming(k.activeFileResource)):void 0,l=new h(r,i,c,k.resolvedVariables,this.l),s=f.createVariableResolver(o,process.env,l),g=await f.getCwd(t,E.homedir(),s,o?.uri,k.configuration["terminal.integrated.cwd"],this.h);t.cwd=g;const R=P.isWindows?"terminal.integrated.env.windows":P.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=k.configuration[R],z=await f.createTerminalEnvironment(t,O,s,this.j.version,k.configuration["terminal.integrated.detectLocale"],r);if(!t.strictEnv){const $=[];for(const[be,Y]of k.envVariableCollections)$.push([be,{map:(0,b.deserializeEnvironmentVariableCollection)(Y)}]);const x=new Map($);await new v.MergedEnvironmentVariableCollection(x).applyToProcessEnvironment(z,s)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:g,cols:k.cols,rows:k.rows,env:z});const ie=(0,y.createRandomIPCHandle)();z.VSCODE_IPC_HOOK_CLI=ie;const ee=await this.i.createProcess(t,g,k.cols,k.rows,k.unicodeVersion,z,r,k.options,k.shouldPersistTerminal,k.workspaceId,k.workspaceName),F={executeCommand:($,...x)=>this.p(ee,$,x,C)},Z=new S.CLIServerBase(F,this.h,ie);return this.i.onProcessExit($=>$.id===ee&&Z.dispose()),{persistentTerminalId:ee,resolvedShellLaunchConfig:t}}p(C,k,t,r){let n,i;const o=new Promise((s,g)=>{n=s,i=g}),c=++this.a;this.b.set(c,{resolve:n,reject:i,uriTransformer:r});const l=(0,a.cloneAndChange)(t,s=>{if(s&&s.$mid===1)return r.transformOutgoing(s);if(s&&s instanceof w.URI)return r.transformOutgoingURI(s)});return this.c.fire({reqId:c,persistentProcessId:C,commandId:k,commandArgs:l}),o}r(C,k,t){const r=this.b.get(C);if(!r)return;this.b.delete(C);const n=(0,a.cloneAndChange)(t,i=>{if(i&&i.$mid===1)return r.uriTransformer.transformIncoming(i)});k?r.reject(n):r.resolve(n)}s(C){return this.i.getDefaultSystemShell(C)}async t(C,k,t,r){return this.i.getProfiles?.(C,k,t,r)||[]}u(){return{...process.env}}w(C,k){return this.i.getWslPath(C,k)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=m}),define(ve[136],Ee([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ve[275],Ee([1,0,9,2,13,210]),function(ae,e,E,A,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class D extends I.DiskFileSystemProviderClient{static register(w,y,T){const S=w.getConnection();if(!S)return A.Disposable.None;const v=new A.DisposableStore,b=(async()=>{try{const f=await w.getRawEnvironment();f?y.registerProvider(a.Schemas.vscodeRemote,v.add(new D(f,S))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(f){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,E.getErrorMessage)(f))}})();return v.add(y.onWillActivateFileSystemProvider(f=>{f.scheme===a.Schemas.vscodeRemote&&f.join(b)})),v}constructor(w,y){super(y.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:w.os===3})}}e.RemoteFileSystemProviderClient=D}),define(ve[137],Ee([1,0,31,14,7,8,22,167,286,287]),function(ae,e,E,A,a,I,D,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=t,this.cause=r}}e.ExtractError=T;function S(k){const t=k.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function v(k){if(k instanceof T)return k;let t;return/end of central directory record signature not found/.test(k.message)&&(t="CorruptZip"),new T(t,k)}function b(k,t,r,n,i,o){const c=a.dirname(t),l=a.join(n,c);if(!l.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const s=a.join(n,t);let g;return o.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(D.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((R,O)=>{if(!o.isCancellationRequested)try{g=(0,E.createWriteStream)(s,{mode:r}),g.once("close",()=>R()),g.once("error",O),k.once("error",O),k.pipe(g)}catch(z){O(z)}}))}function f(k,t,r,n){let i=(0,A.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{i.cancel(),k.close()}),new Promise((c,l)=>{const s=new A.Sequencer,g=R=>{R.isCancellationRequested||(o++,k.readEntry())};k.once("error",l),k.once("close",()=>i.then(()=>{n.isCancellationRequested||k.entryCount===o?c():l(new T("Incomplete",new Error(P.localize(1,null,o,k.entryCount))))},l)),k.readEntry(),k.on("entry",R=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(R.fileName)){g(n);return}const O=R.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(O)){const ee=a.join(t,O);i=(0,A.createCancelablePromise)(F=>D.Promises.mkdir(ee,{recursive:!0}).then(()=>g(F)).then(void 0,l));return}const z=u(k,R),ie=S(R);i=(0,A.createCancelablePromise)(ee=>s.queue(()=>z.then(F=>b(F,O,ie,t,r,ee).then(()=>g(ee)))).then(null,l))})})}function p(k,t=!1){return new Promise((r,n)=>{(0,w.open)(k,t?{lazyEntries:!0}:void 0,(i,o)=>{i?n(v(i)):r((0,I.assertIsDefined)(o))})})}function u(k,t){return new Promise((r,n)=>{k.openReadStream(t,(i,o)=>{i?n(v(i)):r((0,I.assertIsDefined)(o))})})}function h(k,t){return new Promise((r,n)=>{const i=new y.ZipFile;t.forEach(c=>{c.contents?i.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&i.addFile(c.localPath,c.path)}),i.end();const o=(0,E.createWriteStream)(k);i.outputStream.pipe(o),i.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>r(k))})}e.zip=h;function m(k,t,r={},n){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=p(k,!0);return r.overwrite&&(o=o.then(c=>D.Promises.rm(t).then(()=>c))),o.then(c=>f(c,t,{sourcePathRegex:i},n))}e.extract=m;function d(k,t){return p(k).then(r=>new Promise((n,i)=>{r.on("entry",o=>{o.fileName===t&&u(r,o).then(c=>n(c),c=>i(c))}),r.once("close",()=>i(new Error(P.localize(2,null,t))))}))}function C(k,t){return d(k,t).then(r=>new Promise((n,i)=>{const o=[];r.once("error",i),r.on("data",c=>o.push(c)),r.on("end",()=>n(Buffer.concat(o)))}))}e.buffer=C}),define(ve[276],Ee([1,0,137,177]),function(ae,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function a(I){return(0,E.buffer)(I,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.getManifest=a}),define(ve[138],Ee([1,0,14,19,38,9,6,2,27,13,7,3,20,50,8,4,21,22,137,176,75,25,248,32,35,43,54,232,249,276,224,233,33,73,17,5,12,26,30,36,34]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t,r,n,i,o,c,l,s,g,R,O,z,ie,ee,F,Z,$,x,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(r.IExtensionManagementService);let be=class extends t.AbstractExtensionManagementService{constructor(j,N,M,q,te,ue,W,K,_,V,Q,G){super(j,N,M,V,G),this.Z=te,this.ab=ue,this.bb=W,this.cb=_,this.db=Q,this.X=this.B(new D.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new w.ResourceSet;const X=this.B(K.createInstance(l.ExtensionsLifecycle));this.S=this.B(K.createInstance(Y,pe=>X.postUninstall(pe))),this.U=this.B(new g.ExtensionsManifestCache(q,this)),this.W=this.B(K.createInstance(c.ExtensionsDownloader));const ce=this.B(new R.ExtensionsWatcher(this,this.Z,G,ue,Q,_,M));this.B(ce.onDidChangeExtensionsByAnotherSource(pe=>this.kb(pe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(j){this.v.trace("ExtensionManagementService#zip",j.identifier.id);const N=await this.jb(j),M=await(0,m.zip)((0,v.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,N);return p.URI.file(M)}async unzip(j){return this.v.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:N,cleanup:M}=await this.fb(j),q=T.resolve(N.fsPath);try{return await(0,s.getManifest)(q)}finally{await M()}}getInstalled(j,N){return this.S.scanExtensions(j??null,N)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(j,N={}){this.v.trace("ExtensionManagementService#install",j.toString());const{location:M,cleanup:q}=await this.fb(j);try{const te=await(0,s.getManifest)(T.resolve(M.fsPath));if(te.engines&&te.engines.vscode&&!(0,z.isEngineValid)(te.engines.vscode,this.w.version,this.w.date))throw new Error(d.localize(0,null,(0,n.getGalleryExtensionId)(te.publisher,te.name),this.w.version));return await this.z(te,M,N)}finally{await q()}}async installFromLocation(j,N){this.v.trace("ExtensionManagementService#installFromLocation",j.toString());const M=await this.S.scanUserExtensionAtLocation(j);if(!M)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.ob([M],N),this.v.info("Successfully installed extension",M.identifier.id,N.toString()),M}getMetadata(j,N=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(j,N)}async updateMetadata(j,N,M=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",j.identifier.id),N.isPreReleaseVersion&&(N.preRelease=!0),N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.pinned=N.pinned||void 0,j=await this.S.updateMetadata(j,N,M),this.U.invalidate(),this.X.fire(j),j}async reinstallFromGallery(j){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.t.isEnabled())throw new Error(d.localize(1,null));const N=await this.getTargetPlatform(),[M]=await this.t.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:N,compatible:!0},A.CancellationToken.None);if(!M)throw new Error(d.localize(2,null));await this.S.setUninstalled(j);try{await this.S.removeUninstalledExtension(j)}catch(q){throw new Error(d.localize(3,null,(0,a.toErrorMessage)(q)))}return this.installFromGallery(M)}markAsUninstalled(...j){return this.S.setUninstalled(...j)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(j,N){const{location:M}=await this.W.download(j,N);return M}async fb(j){if(j.scheme===y.Schemas.file)return{location:j,async cleanup(){}};this.v.trace("Downloading extension from",j.toString());const N=(0,v.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(j,N),this.v.info("Downloaded extension to",N.toString()),{location:N,cleanup:async()=>{try{await this.cb.del(N)}catch(q){this.v.error(q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(j,N,M){let q;if(p.URI.isUri(N))q=new ne(j,N,M,this.t,this.S,this.v);else{const te=n.ExtensionKey.create(N).toString();q=this.Y.get(te),q||(this.Y.set(te,q=new U(j,N,M,this.W,this.S,this.v)),q.waitUntilTaskIsFinished().then(()=>this.Y.delete(te)))}return new se(q,M.profileLocation,this.db,this.y,this.Z,this.ab)}R(j,N){return new de(j,N.profileLocation,this.ab)}async jb(j){const N=async q=>{let te=await h.Promises.readdir(q);te=te.map(K=>T.join(q,K));const ue=await Promise.all(te.map(K=>h.Promises.stat(K)));let W=Promise.resolve([]);return ue.forEach((K,_)=>{const V=te[_];K.isFile()&&(W=W.then(Q=>[...Q,V])),K.isDirectory()&&(W=W.then(Q=>N(V).then(G=>[...Q,...G])))}),W};return(await N(j.location.fsPath)).map(q=>({path:`extension/${T.relative(j.location.fsPath,q)}`,localPath:q}))}async kb({added:j,removed:N}){if(N)for(const M of N.extensions)this.v.info("Extensions removed from another source",M.id,N.profileLocation.toString()),this.p.fire({identifier:M,profileLocation:N.profileLocation});if(j){const q=(await this.S.scanExtensions(1,j.profileLocation)).filter(te=>j.extensions.some(ue=>(0,n.areSameExtensions)(ue,te.identifier)));this.m.fire(q.map(te=>(this.v.info("Extensions added from another source",te.identifier.id,j.profileLocation.toString()),{identifier:te.identifier,local:te,profileLocation:j.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(N=>this.lb.add(N)));const j=await this.cb.resolve(this.Z.userExtensionsLocation);for(const N of j.children??[])N.isDirectory&&this.lb.add(N.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(N=>this.nb(N)))}async nb(j){if(!j.affects(this.Z.userExtensionsLocation,1))return;const N=[];for(const M of j.rawAdded){if(this.lb.has(M)||!this.db.extUri.isEqual(this.db.extUri.dirname(M),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(M,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(M).startsWith(".")||!(await this.cb.stat(M)).isDirectory)continue;const q=await this.S.scanUserExtensionAtLocation(M);q&&q.installedTimestamp===void 0&&(this.lb.add(M),N.push(q))}N.length&&(await this.ob(N,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",N.map(M=>M.identifier.id)))}async ob(j,N){await this.ab.addExtensionsToProfile(j.map(M=>[M,void 0]),N),this.m.fire(j.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:N})))}};be=Le([Re(0,r.IExtensionGalleryService),Re(1,$.ITelemetryService),Re(2,F.ILogService),Re(3,k.INativeEnvironmentService),Re(4,o.IExtensionsScannerService),Re(5,i.IExtensionsProfileScannerService),Re(6,C.IDownloadService),Re(7,ee.IInstantiationService),Re(8,ie.IFileService),Re(9,Z.IProductService),Re(10,x.IUriIdentityService),Re(11,le.IUserDataProfilesService)],be),e.ExtensionManagementService=be;let Y=class extends P.Disposable{constructor(j,N,M,q,te){super(),this.j=j,this.k=N,this.l=M,this.m=q,this.n=te,this.h=this.B(new D.Emitter),this.onExtract=this.h.event,this.c=(0,v.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new E.Queue}async cleanUp(){await this.w()}async scanExtensions(j,N){const M={includeInvalid:!0,profileLocation:N};let q=[];return j===null||j===0?q.push(...await this.l.scanAllExtensions({includeInvalid:!0},M,!1)):j===1&&q.push(...await this.l.scanUserExtensions(M)),q=j!==null?q.filter(te=>te.type===j):q,Promise.all(q.map(te=>this.v(te)))}async scanAllUserExtensions(j){const N=await this.l.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return Promise.all(N.map(M=>this.v(M)))}async scanUserExtensionAtLocation(j){try{const N=await this.l.scanExistingExtension(j,1,{includeInvalid:!0});if(N)return await this.v(N)}catch(N){this.n.error(N)}return null}async extractUserExtension(j,N,M,q){const te=j.toString(),ue=T.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),W=T.join(this.l.userExtensionsLocation.fsPath,te);try{await h.Promises.rm(W)}catch{throw new r.ExtensionManagementError(d.localize(4,null,W,j.id),r.ExtensionManagementErrorCode.Delete)}await this.s(j,N,ue,q),await this.l.updateMetadata(p.URI.file(ue),M);try{this.h.fire(p.URI.file(W)),await this.t(j,ue,W,Date.now()+2*60*1e3),this.n.info("Renamed to",W)}catch(K){try{await h.Promises.rm(ue)}catch{}if(K.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);else throw this.n.info(`Rename failed because of ${(0,I.getErrorMessage)(K)}. Deleted from extracted location`,ue),K}return this.u(p.URI.file(W),1)}async scanMetadata(j,N){return N?(await this.m.scanProfileExtensions(N)).find(q=>(0,n.areSameExtensions)(q.identifier,j.identifier))?.metadata:this.l.scanMetadata(j.location)}async updateMetadata(j,N,M){return M?await this.m.updateMetadata([[j,N]],M):await this.l.updateMetadata(j.location,N),this.u(j.location,j.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...j){const N=j.map(M=>n.ExtensionKey.create(M));await this.p(M=>N.forEach(q=>{M[q.toString()]=!0,this.n.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(j){await this.p(q=>delete q[j.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(q=>n.ExtensionKey.create(q).equals(j))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(j,N){this.n.trace(`Deleting ${N} extension from disk`,j.identifier.id,j.location.fsPath),await h.Promises.rm(j.location.fsPath),this.n.info("Deleted from disk",j.identifier.id,j.location.fsPath)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.p(N=>delete N[n.ExtensionKey.create(j).toString()])}async p(j){return this.g.queue(async()=>{let N;try{N=await h.Promises.readFile(this.c,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let M={};if(N)try{M=JSON.parse(N)}catch{}return j&&(j(M),Object.keys(M).length?await h.Promises.writeFile(this.c,JSON.stringify(M)):await h.Promises.rm(this.c)),M})}async s(j,N,M,q){this.n.trace(`Started extracting the extension from ${N} to ${M}`);try{await h.Promises.rm(M)}catch(te){throw new r.ExtensionManagementError(this.y(te).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(N,M,{sourcePath:"extension",overwrite:!0},q),this.n.info(`Extracted extension to ${M}:`,j.id)}catch(te){try{await h.Promises.rm(M)}catch{}let ue=r.ExtensionManagementErrorCode.Extract;throw te instanceof m.ExtractError&&(te.type==="CorruptZip"?ue=r.ExtensionManagementErrorCode.CorruptZip:te.type==="Incomplete"&&(ue=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(te.message,ue)}}async t(j,N,M,q){try{await h.Promises.rename(N,M)}catch(te){if(S.isWindows&&te&&te.code==="EPERM"&&Date.now()<q)return this.n.info(`Failed renaming ${N} to ${M} with 'EPERM' error. Trying again...`,j.id),this.t(j,N,M,q);throw new r.ExtensionManagementError(te.message||d.localize(5,null,N,M),te.code||r.ExtensionManagementErrorCode.Rename)}}async u(j,N){const M=await this.l.scanExistingExtension(j,N,{includeInvalid:!0});if(M)return this.v(M);throw new Error(d.localize(6,null,j.path))}async v(j){const N=await this.k.resolve(j.location);let M,q;return N.children&&(M=N.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,q=N.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:M,changelogUrl:q,publisherDisplayName:j.metadata?.publisherDisplayName||null,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned}}async w(){const j=await this.getUninstalledExtensions(),N=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const ue of N)j[n.ExtensionKey.create(ue).toString()]||M.add(ue.identifier.id.toLowerCase());const q=(0,n.groupByExtension)(N,ue=>ue.identifier);await E.Promises.settled(q.map(async ue=>{const W=ue.sort((K,_)=>b.rcompare(K.manifest.version,_.manifest.version))[0];M.has(W.identifier.id.toLowerCase())||await this.j(await this.v(W))}));const te=N.filter(ue=>ue.metadata&&j[n.ExtensionKey.create(ue).toString()]);await E.Promises.settled(te.map(ue=>this.removeUninstalledExtension(ue)))}y(j){const N=Array.isArray(j)?j:[j];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((M,q)=>new Error(`${M.message}${M.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}};Y=Le([Re(1,ie.IFileService),Re(2,o.IExtensionsScannerService),Re(3,i.IExtensionsProfileScannerService),Re(4,F.ILogService)],Y),e.ExtensionsScanner=Y;class H extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,f.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(j,N,M,q,te){super(),this.identifier=j,this.source=N,this.l=M,this.m=q,this.n=te,this.j="Unverified",this.k=2}async o(j,N){try{const M=await this.p(j.key);if(M)return this.m.updateMetadata(M,j.metadata)}catch{throw S.isMacintosh?new r.ExtensionManagementError(d.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(d.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.s(j,N)}async p(j){if(!await this.q(j))return null;this.n.trace("Removing the extension from uninstalled list:",j.id);const M=await this.m.setInstalled(j);return this.n.info("Removed the extension from uninstalled list:",j.id),M}async q(j){return!!(await this.m.getUninstalledExtensions())[j.toString()]}async s({zipPath:j,key:N,metadata:M},q){const te=await this.m.extractUserExtension(N,j,M,q);return this.n.info("Extracting completed.",N.id),te}}class U extends H{constructor(j,N,M,q,te,ue){super(N.identifier,N,M,te,ue),this.t=j,this.u=N,this.v=q}async h(j){const M=(await this.m.scanExtensions(null,this.l.profileLocation)).find(W=>(0,n.areSameExtensions)(W.identifier,this.u.identifier));M&&(this.k=3);const q={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,O.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||M?.isMachineScoped,isBuiltin:this.l.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,f.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(M,q),metadata:q};const{location:te,verificationStatus:ue}=await this.v.download(this.u,this.k);try{return this.j=ue,this.x(te.fsPath),{local:await this.o({zipPath:te.fsPath,key:n.ExtensionKey.create(this.u),metadata:q},j),metadata:q}}catch(W){try{await this.v.delete(te)}catch(K){this.n.warn("Error while deleting the downloaded file",te.toString(),(0,I.getErrorMessage)(K))}throw W}}async x(j){try{await(0,s.getManifest)(j)}catch(N){throw new r.ExtensionManagementError((0,t.joinErrors)(N).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class ne extends H{constructor(j,N,M,q,te,ue){super({id:(0,n.getGalleryExtensionId)(j.publisher,j.name)},N,M,te,ue),this.t=j,this.u=N,this.v=q}async h(j){const N=new n.ExtensionKey(this.identifier,this.t.version),q=(await this.m.scanExtensions(1,this.l.profileLocation)).find(W=>(0,n.areSameExtensions)(this.identifier,W.identifier)),te=await this.x(this.identifier.id,this.t.version,j);if(te.isApplicationScoped=(0,O.isApplicationScopedExtension)(this.t),te.isMachineScoped=this.l.isMachineScoped||q?.isMachineScoped,te.isBuiltin=this.l.isBuiltin||q?.isBuiltin,te.installedTimestamp=Date.now(),te.pinned=this.l.installGivenVersion?!0:void 0,q)if(this.k=3,N.equals(new n.ExtensionKey(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(d.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&b.gt(q.manifest.version,this.t.version)&&await this.m.setUninstalled(q);else{const W=await this.p(N);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(d.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:T.resolve(this.u.fsPath),key:N,metadata:te},j),metadata:te}}async x(j,N,M){try{let[q]=await this.v.getExtensions([{id:j,version:N}],M);if(q||([q]=await this.v.getExtensions([{id:j}],M)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class se{get operation(){return this.d.operation}get verificationStatus(){return this.d.verificationStatus}constructor(j,N,M,q,te,ue){this.d=j,this.g=N,this.h=M,this.j=q,this.k=te,this.l=ue,this.identifier=this.d.identifier,this.source=this.d.source,this.c=this.m()}async m(){const j=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[j.local,j.metadata]],this.g),j}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class de extends t.AbstractExtensionTask{constructor(j,N,M){super(),this.extension=j,this.j=N,this.k=M}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ve[139],Ee([1,0,79,14,15,9,2,8,24,25,80,12,227,288]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends D.Disposable{constructor(u,h,m){super(),this.h=u,this.i=h,this.j=m,this.k(),this.B(u.onDidChangeConfiguration(d=>{d.affectsConfiguration("http")&&this.k()}))}k(){const u=this.h.getValue("http");this.a=u?.proxy,this.b=!!u?.proxyStrictSSL,this.f=u?.proxyAuthorization}async request(u,h){this.j.trace("RequestService#request (node) - begin",u.url);const{a:m,b:d}=this;let C;try{C=await(0,T.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const k={...process.env,...C},t=u.agent?u.agent:await(0,v.getProxyAgent)(u.url||"",k,{proxyUrl:m,strictSSL:d});u.agent=t,u.strictSSL=d,this.f&&(u.headers={...u.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(u,h);return this.j.trace("RequestService#request (node) - success",u.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",u.url,r),r}}async l(u){return((0,E.parse)(u.url).protocol==="https:"?await new Promise((d,C)=>{ae(["https"],d,C)}):await new Promise((d,C)=>{ae(["http"],d,C)})).request}m(u,h){return A.Promises.withAsyncBody(async(m,d)=>{const C=(0,E.parse)(u.url),k=u.getRawRequest?u.getRawRequest(u):await this.l(u),t={hostname:C.hostname,port:C.port?parseInt(C.port):C.protocol==="https:"?443:80,protocol:C.protocol,path:C.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,P.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const r=k(t,n=>{const i=(0,P.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this.m({...u,url:n.headers.location,followRedirects:i-1},h).then(m,d);else{let o=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,b.createGunzip)())),m({res:n,stream:(0,a.streamToBufferReadableStream)(o)})}});r.on("error",d),u.timeout&&r.setTimeout(u.timeout),u.isChromiumNetwork&&r.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&r.write(u.data),r.end(),h.onCancellationRequested(()=>{r.abort(),d(new I.CancellationError)})})}async resolveProxy(u){}};f=Le([Re(0,w.IConfigurationService),Re(1,y.INativeEnvironmentService),Re(2,S.ILogService)],f),e.RequestService=f}),define(ve[277],Ee([1,0,77,12,62,112,24,53,139,40,30,32,123,138,76,106,51,2,107,64,13,17,26,110,136,41,115,78,116,9,4,7,28,225,75,36,121,61,3,54,126,34,43,65,124,122,109]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t,r,n,i,o,c,l,s,g,R,O,z,ie,ee,F,Z,$,x,le,be,Y,H,U,ne,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class de extends h.Disposable{constructor(M,q){super(),this.a=M,this.b=q,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const M=await this.f();await M.invokeFunction(async q=>{const te=q.get(A.ILogService);try{await this.g(M.createInstance(o.ExtensionManagementCLI))}catch(ue){throw te.error(ue),console.error((0,s.getErrorMessage)(ue)),ue}})}async f(){const M=new E.ServiceCollection,q={_serviceBrand:void 0,...u.default};M.set(t.IProductService,q);const te=new i.ServerEnvironmentService(this.a,q);M.set(i.IServerEnvironmentService,te);const ue=new se.LogService(new r.SpdLogLogger(n.RemoteExtensionLogFileName,(0,R.join)(te.logsPath,`${n.RemoteExtensionLogFileName}.log`),!0,!1,(0,A.getLogLevel)(te)));M.set(A.ILogService,ue),ue.trace(`Remote configuration data at ${this.b}`),ue.trace("process arguments:",this.a);const W=this.B(new m.FileService(ue));M.set(k.IFileService,W),W.registerProvider(C.Schemas.file,this.B(new d.DiskFileSystemProvider(ue)));const K=new F.UriIdentityService(W);M.set(ee.IUriIdentityService,K);const _=this.B(new U.ServerUserDataProfilesService(K,te,W,ue));M.set(be.IUserDataProfilesService,_);const V=this.B(new I.ConfigurationService(_.defaultProfile.settingsResource,W,new H.NullPolicyService,ue));return await V.initialize(),M.set(D.IConfigurationService,V),M.set(P.IRequestService,new a.SyncDescriptor(w.RequestService)),M.set(ie.IDownloadService,new a.SyncDescriptor(z.DownloadService)),M.set(T.ITelemetryService,y.NullTelemetryService),M.set(S.IExtensionGalleryService,new a.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService)),M.set(Y.IExtensionsProfileScannerService,new a.SyncDescriptor(ne.ExtensionsProfileScannerService)),M.set(x.IExtensionsScannerService,new a.SyncDescriptor(le.ExtensionsScannerService)),M.set(f.IExtensionSignatureVerificationService,new a.SyncDescriptor(f.ExtensionSignatureVerificationService)),M.set(b.INativeServerExtensionManagementService,new a.SyncDescriptor(b.ExtensionManagementService)),M.set(c.ILanguagePackService,new a.SyncDescriptor(l.NativeLanguagePackService)),new p.InstantiationService(M)}async g(M){if(this.a["list-extensions"])return M.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const q={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return M.installExtensions(this.h(this.a["install-extension"]||[]),this.a["install-builtin-extension"]||[],q,!!this.a.force)}else{if(this.a["uninstall-extension"])return M.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return M.locateExtension(this.a["locate-extension"])}}h(M){return M.map(q=>/\.vsix$/i.test(q)?g.URI.file((0,R.isAbsolute)(q)?q:(0,R.join)((0,O.cwd)(),q)):q)}}function re(N){setTimeout(()=>process.exit(N),0)}async function j(N,M,q){if(N.help){const ue=u.default.serverApplicationName+($.isWindows?".cmd":"");console.log((0,Z.buildHelpMessage)(u.default.nameLong,ue,u.default.version,q,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,Z.buildVersionMessage)(u.default.version,u.default.commit));return}const te=new de(N,M);try{await te.run(),re(0)}catch{re(1)}finally{te.dispose()}}e.run=j}),define(ve[278],Ee([1,0,29,6,2,13,7,95,22,42,24,112,74,254,197,75,198,208,217,25,123,32,76,115,209,138,17,107,64,62,106,77,78,116,12,51,26,53,226,139,114,30,40,240,120,247,36,121,270,259,230,237,274,67,41,265,136,275,125,54,126,43,34,255,65,238,220,4,124,122,109,108,193]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t,r,n,i,o,c,l,s,g,R,O,z,ie,ee,F,Z,$,x,le,be,Y,H,U,ne,se,de,re,j,N,M,q,te,ue,W,K,_,V,Q,G,X,ce,pe,Pe,Ae,Ne,$e,me,we,ye,Me,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ge="monacoworkbench";async function He(Ie,Ce,Te,Be){const ze=new R.ServiceCollection,Ve=new it,nt={_serviceBrand:void 0,...ee.default};ze.set(F.IProductService,nt);const Je=new ue.ServerEnvironmentService(Ce,nt);ze.set(d.IEnvironmentService,Je),ze.set(d.INativeEnvironmentService,Je);const Ze=new Ne.LoggerService((0,ie.getLogLevel)(Je));ze.set(ie.ILoggerService,Ze),Ve.registerChannel("logger",new Me.LoggerChannel(Ze,ot=>Xe(ot.remoteAuthority)));const at=Ze.createLogger($e.URI.file(D.join(Je.logsPath,`${K.RemoteExtensionLogFileName}.log`)),{id:"remoteServerLog",name:(0,je.localize)(0,null)}),st=new ye.LogService(at,[new Ye((0,ie.getLogLevel)(Je))]);ze.set(ie.ILogService,st),setTimeout(()=>fe(Je.logsPath).then(null,ot=>st.error(ot)),1e4),st.trace(`Remote configuration data at ${Te}`),st.trace("process arguments:",Je.args),Array.isArray(nt.serverGreeting)&&st.info(`

${nt.serverGreeting.join(`
`)}

`),Ve.registerChannel(f.ExtensionHostDebugBroadcastChannel.ChannelName,new f.ExtensionHostDebugBroadcastChannel);const bt=new y.StaticRouter(ot=>ot.clientId==="renderer"),ut=Be.add(new c.FileService(st));ze.set(o.IFileService,ut),ut.registerProvider(I.Schemas.file,Be.add(new l.DiskFileSystemProvider(st)));const Ft=new de.UriIdentityService(ut);ze.set(se.IUriIdentityService,Ft);const Pt=new me.ServerUserDataProfilesService(Ft,Je,ut,st);ze.set(ce.IUserDataProfilesService,Pt);const ht=new S.ConfigurationService(Je.machineSettingsResource,ut,new Pe.NullPolicyService,st);ze.set(T.IConfigurationService,ht),await ht.initialize();const Rt=new V.ExtensionHostStatusService;ze.set(V.IExtensionHostStatusService,Rt),ze.set(Z.IRequestService,new s.SyncDescriptor(x.RequestService));let mt=Y.NullAppender;const wt=await(0,P.getMachineId)(),kt=(0,Y.isInternalTelemetry)(nt,ht);if((0,Y.supportsTelemetry)(nt,Je)){const ot=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";ot?mt=new Ae.OneDataSystemAppender(!1,Ge,null,()=>new pe.TelemetryClient(ot)):nt.aiConfig&&nt.aiConfig.ariaKey&&(mt=new Ae.OneDataSystemAppender(kt,Ge,null,nt.aiConfig.ariaKey)),Be.add((0,a.toDisposable)(()=>mt?.flush()));const Se={appenders:[mt],commonProperties:(0,le.resolveCommonProperties)(ut,(0,E.release)(),(0,E.hostname)(),process.arch,nt.commit,nt.version+"-remote",wt,kt,Je.installSourcePath,"remoteAgent"),piiPaths:(0,Y.getPiiPathsFromEnvironment)(Je)},De=Je.args["telemetry-level"];let he=3;De==="all"?he=3:De==="error"?he=2:De==="crash"?he=1:De!==void 0&&(he=0),ze.set(M.IServerTelemetryService,new s.SyncDescriptor(M.ServerTelemetryService,[Se,he]))}else ze.set(M.IServerTelemetryService,M.ServerNullTelemetryService);ze.set(k.IExtensionGalleryService,new s.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService));const Lt=Ve.getChannel("download",bt);ze.set(p.IDownloadService,new u.DownloadServiceChannelClient(Lt,()=>Xe("renderer"))),ze.set(X.IExtensionsProfileScannerService,new s.SyncDescriptor(we.ExtensionsProfileScannerService)),ze.set(Q.IExtensionsScannerService,new s.SyncDescriptor(G.ExtensionsScannerService)),ze.set(t.IExtensionSignatureVerificationService,new s.SyncDescriptor(t.ExtensionSignatureVerificationService)),ze.set(i.INativeServerExtensionManagementService,new s.SyncDescriptor(i.ExtensionManagementService));const St=new g.InstantiationService(ze);ze.set(O.ILanguagePackService,St.createInstance(z.NativeLanguagePackService));const At=St.createInstance(ne.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ht.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,je.localize)(1,null));return ze.set(U.IPtyService,At),ze.set(h.IEncryptionMainService,new s.SyncDescriptor(m.EncryptionMainService,[wt])),ze.set(v.ICredentialsMainService,new s.SyncDescriptor(b.CredentialsWebMainService)),St.invokeFunction(ot=>{const Se=ot.get(i.INativeServerExtensionManagementService),De=ot.get(Q.IExtensionsScannerService),he=new re.RemoteAgentEnvironmentChannel(Ie,Je,Pt,St.createInstance(r.ExtensionManagementCLI),st,Rt,De);Ve.registerChannel("remoteextensionsenvironment",he);const J=new N.ServerTelemetryChannel(ot.get(M.IServerTelemetryService),mt);Ve.registerChannel("telemetry",J),Ve.registerChannel(W.REMOTE_TERMINAL_CHANNEL_NAME,new q.RemoteTerminalChannel(Je,st,At,nt,Se,ht));const ke=new j.RemoteAgentFileSystemProviderChannel(st,Je);Ve.registerChannel(_.REMOTE_FILE_SYSTEM_CHANNEL_NAME,ke),Ve.registerChannel("request",new $.RequestChannel(ot.get(Z.IRequestService)));const Oe=new n.ExtensionManagementChannel(Se,lt=>Xe(lt.remoteAuthority));Ve.registerChannel("extensions",Oe);const qe=y.ProxyChannel.fromService(ot.get(O.ILanguagePackService));Ve.registerChannel("languagePacks",qe);const Ue=y.ProxyChannel.fromService(ot.get(h.IEncryptionMainService));Ve.registerChannel("encryption",Ue);const tt=y.ProxyChannel.fromService(ot.get(v.ICredentialsMainService));return Ve.registerChannel("credentials",tt),Se.removeUninstalledExtensions(),Be.add(new H.default(ot.get(be.ITelemetryService))),{telemetryService:ot.get(be.ITelemetryService)}}),{socketServer:Ve,instantiationService:St}}e.setupServerServices=He;const Ke=Object.create(null);function Xe(Ie){return Ke[Ie]||(Ke[Ie]=(0,te.createURITransformer)(Ie)),Ke[Ie]}class it extends y.IPCServer{constructor(){const Ce=new A.Emitter;super(Ce.event),this.b=Ce}acceptConnection(Ce,Te){this.b.fire({protocol:Ce,onDidClientDisconnect:Te})}}e.SocketServer=it;class Ye extends ie.AbstractLogger{constructor(Ce=ie.DEFAULT_LOG_LEVEL){super(),this.setLevel(Ce),this.g=Boolean(process.stdout.isTTY)}trace(Ce,...Te){this.f(ie.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Ce,...Te):console.log(`[${xe()}]`,Ce,...Te))}debug(Ce,...Te){this.f(ie.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Ce,...Te):console.log(`[${xe()}]`,Ce,...Te))}info(Ce,...Te){this.f(ie.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Ce,...Te):console.log(`[${xe()}]`,Ce,...Te))}warn(Ce,...Te){this.f(ie.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${xe()}]\x1B[0m`,Ce,...Te):console.warn(`[${xe()}]`,Ce,...Te))}error(Ce,...Te){this.f(ie.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${xe()}]\x1B[0m`,Ce,...Te):console.error(`[${xe()}]`,Ce,...Te))}dispose(){}flush(){}}function xe(){const Ie=new Date;return`${_e(Ie.getHours())}:${_e(Ie.getMinutes())}:${_e(Ie.getSeconds())}`}function _e(Ie){return Ie<10?`0${Ie}`:String(Ie)}async function fe(Ie){const Ce=D.basename(Ie),Te=D.dirname(Ie),Ve=(await w.Promises.readdir(Te)).filter(Je=>/^\d{8}T\d{6}$/.test(Je)).sort().filter(Je=>Je!==Ce),nt=Ve.slice(0,Math.max(0,Ve.length-9));await Promise.all(nt.map(Je=>w.Promises.rm(D.join(Te,Je))))}}),define(ve[279],Ee([1,0,117,31,96,280,79,140,15,9,37,2,13,7,47,3,16,4,21,155,100,60,5,12,26,66,30,132,251,252,41,278,257]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v,b,f,p,u,h,m,d,C,k,t,r,n,i,o,c,l,s,g,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const z=5*60*1e3;let ie=class extends S.Disposable{constructor($,x,le,be,Y,H,U,ne){super(),this.k=$,this.l=x,this.m=le,this.n=Y,this.p=H,this.r=U,this.s=ne,this.h=F.create(this.p),this.i=(0,i.getRemoteServerRootPath)(H),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=be?this.s.createInstance(O.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest($,x){if($.method!=="GET")return(0,O.serveError)($,x,405,`Unsupported method ${$.method}`);if(!$.url)return(0,O.serveError)($,x,400,"Bad request.");const le=D.parse($.url,!0);let be=le.pathname;if(!be)return(0,O.serveError)($,x,400,"Bad request.");if(be.startsWith(this.i)&&be.charCodeAt(this.i.length)===47&&(be=be.substring(this.i.length)),be==="/version")return x.writeHead(200,{"Content-Type":"text/plain"}),void x.end(this.p.commit||"");if(be==="/delay-shutdown")return this.H(),x.writeHead(200),void x.end("OK");if(!(0,s.requestHasValidConnectionToken)(this.l,$,le))return(0,O.serveError)($,x,403,"Forbidden.");if(be==="/vscode-remote-resource"){const Y=le.query.path;if(typeof Y!="string")return(0,O.serveError)($,x,400,"Bad request.");let H;try{H=h.URI.from({scheme:v.Schemas.file,path:Y}).fsPath}catch{return(0,O.serveError)($,x,400,"Bad request.")}const U=Object.create(null);this.n.isBuilt&&((0,T.isEqualOrParent)(H,this.n.builtinExtensionsPath,!p.isLinux)||(0,T.isEqualOrParent)(H,this.n.extensionsPath,!p.isLinux))&&(U["Cache-Control"]="public, max-age=31536000"),U.Vary="Origin";const ne=$.headers.origin;return ne&&this.h.matches(ne)&&(U["Access-Control-Allow-Origin"]=ne),(0,O.serveFile)(H,1,this.r,$,x,U)}if(this.g){this.g.handle($,x,le);return}return x.writeHead(404,{"Content-Type":"text/plain"}),void x.end("Not found")}handleUpgrade($,x){let le=(0,m.generateUuid)(),be=!1,Y=!1;if($.url){const re=D.parse($.url,!0).query;typeof re.reconnectionToken=="string"&&(le=re.reconnectionToken),re.reconnection==="true"&&(be=!0),re.skipWebSocketFrames==="true"&&(Y=!0)}if($.headers.upgrade===void 0||$.headers.upgrade.toLowerCase()!=="websocket"){x.end("HTTP/1.1 400 Bad Request");return}const H=$.headers["sec-websocket-key"],U=E.createHash("sha1");U.update(H+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ne=U.digest("base64"),se=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ne}`];let de=!1;if(!Y&&!this.n.args["disable-websocket-compression"]&&$.headers["sec-websocket-extensions"]){const re=Array.isArray($.headers["sec-websocket-extensions"])?$.headers["sec-websocket-extensions"]:[$.headers["sec-websocket-extensions"]];for(const j of re)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(j)){if(/\b(permessage-deflate)\b/.test(j)){de=!0,se.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(j)){de=!0,se.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}x.write(se.join(`\r
`)+`\r
\r
`),x.setTimeout(0),x.setNoDelay(!0),Y?this.v(new k.NodeSocket(x,`server-connection-${le}`),be,le):this.v(new k.WebSocketNodeSocket(new k.NodeSocket(x,`server-connection-${le}`),de,null,!0),be,le)}handleServerError($){this.r.error("Error occurred in server"),this.r.error($)}t($){let x;return $ instanceof k.NodeSocket?x=$.socket:x=$.socket.socket,x.remoteAddress||"<unknown>"}async u($,x,le){const be=x.getSocket();this.r.error(`${$} ${le}.`);const Y={type:"error",reason:le};x.sendControl(w.VSBuffer.fromString(JSON.stringify(Y))),x.dispose(),await be.drain(),be.dispose()}v($,x,le){const be=this.t($),Y=`[${be}][${le.substr(0,8)}]`,H=new C.PersistentProtocol({socket:$}),U=this.m?new this.m.validator:null,ne=this.m?new this.m.signer:null;let se;(function(N){N[N.WaitingForAuth=0]="WaitingForAuth",N[N.WaitingForConnectionType=1]="WaitingForConnectionType",N[N.Done=2]="Done",N[N.Error=3]="Error"})(se||(se={}));let de=0;const re=N=>{de=3,j.dispose(),this.u(Y,H,N)},j=H.onControlMessage(N=>{if(de===0){let M;try{M=JSON.parse(N.toString())}catch{return re("Malformed first message")}if(M.type!=="auth")return re("Invalid first message");if(this.l.type===2&&!this.l.validate(M.auth))return re("Unauthorized client refused: auth mismatch");let q=(0,m.generateUuid)();if(ne)try{q=ne.sign(M.data)}catch{}let te=(0,m.generateUuid)();if(U)try{te=U.createNewMessage(te)}catch{}const ue={type:"sign",data:te,signedData:q};H.sendControl(w.VSBuffer.fromString(JSON.stringify(ue))),de=1}else if(de===1){let M;try{M=JSON.parse(N.toString())}catch{return re("Malformed second message")}if(M.type!=="connectionType")return re("Invalid second message");if(typeof M.signedData!="string")return re("Invalid second message field type");const q=M.commit,te=this.p.commit;if(q&&te&&q!==te)return re("Client refused: version mismatch");let ue=!1;if(!U)ue=!0;else if(this.l.validate(M.signedData))ue=!0;else try{ue=U.validate(M.signedData)==="ok"}catch{}if(!ue){if(this.n.isBuilt)return re("Unauthorized client refused");this.r.error(`${Y} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const W in this.b)this.b[W].shortenReconnectionGraceTimeIfNecessary();for(const W in this.a)this.a[W].shortenReconnectionGraceTimeIfNecessary();de=2,j.dispose(),this.w(be,Y,H,$,x,le,M)}})}async w($,x,le,be,Y,H,U){const ne=U.desiredConnectionType===1?`${x}[ManagementConnection]`:U.desiredConnectionType===2?`${x}[ExtensionHostConnection]`:x;if(U.desiredConnectionType===1)if(Y){if(!this.b[H])return this.f.has(H)?this.u(ne,le,"Unknown reconnection token (seen before)"):this.u(ne,le,"Unknown reconnection token (never seen)");le.sendControl(w.VSBuffer.fromString(JSON.stringify({type:"ok"})));const se=le.readEntireBuffer();le.dispose(),this.b[H].acceptReconnection($,be,se)}else{if(this.b[H])return this.u(ne,le,"Duplicate reconnection token");le.sendControl(w.VSBuffer.fromString(JSON.stringify({type:"ok"})));const se=new l.ManagementConnection(this.r,H,$,le);this.k.acceptConnection(se.protocol,se.onClose),this.b[H]=se,this.f.add(H),se.onClose(()=>{delete this.b[H]})}else if(U.desiredConnectionType===2){const se=U.args||{language:"en"},de=await this.C(se);if(de.port&&this.r.trace(`${ne} - startParams debug port ${de.port}`),this.r.trace(`${ne} - startParams language: ${de.language}`),this.r.trace(`${ne} - startParams env: ${JSON.stringify(de.env)}`),Y){if(!this.a[H])return this.f.has(H)?this.u(ne,le,"Unknown reconnection token (seen before)"):this.u(ne,le,"Unknown reconnection token (never seen)");le.sendPause(),le.sendControl(w.VSBuffer.fromString(JSON.stringify(de.port?{debugPort:de.port}:{})));const re=le.readEntireBuffer();le.dispose(),this.a[H].acceptReconnection($,be,re)}else{if(this.a[H])return this.u(ne,le,"Duplicate reconnection token");le.sendPause(),le.sendControl(w.VSBuffer.fromString(JSON.stringify(de.port?{debugPort:de.port}:{})));const re=le.readEntireBuffer();le.dispose();const j=this.s.createInstance(c.ExtensionHostConnection,H,$,be,re);this.a[H]=j,this.f.add(H),j.onClose(()=>{delete this.a[H],this.D()}),j.start(de)}}else if(U.desiredConnectionType===3){const se=U.args;this.y(le,se)}else return this.u(ne,le,"Unknown initial data received")}async y($,x){const le=$.getSocket().socket,be=$.readEntireBuffer();$.dispose(),le.pause();const Y=await this.z(x.host,x.port);be.byteLength>0&&Y.write(be.buffer),Y.on("end",()=>le.end()),Y.on("close",()=>le.end()),Y.on("error",()=>le.destroy()),le.on("end",()=>Y.end()),le.on("close",()=>Y.end()),le.on("error",()=>Y.destroy()),Y.pipe(le),le.pipe(Y)}z($,x){return new Promise((le,be)=>{const Y=a.createConnection({host:$,port:x},()=>{Y.removeListener("error",be),Y.pause(),le(Y)});Y.once("error",be)})}C($){return typeof $.port=="number"?(0,d.findFreePort)($.port,10,5e3).then(x=>($.port=x,$)):($.debugId=void 0,$.port=void 0,$.break=void 0,Promise.resolve($))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F($=!1){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]&&!$?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},z))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ie=Le([Re(4,g.IServerEnvironmentService),Re(5,n.IProductService),Re(6,r.ILogService),Re(7,t.IInstantiationService)],ie);async function ee(Z,$,x){const le=await(0,s.determineServerConnectionToken)($);le instanceof s.ServerConnectionTokenParseError&&(console.warn(le.message),process.exit(1));const be=new S.DisposableStore,{socketServer:Y,instantiationService:H}=await(0,R.setupServerServices)(le,$,x,be);let U=!1;H.invokeFunction(q=>{const te=q.get(r.ILogService);(0,y.setUnexpectedErrorHandler)(ue=>{(0,y.isSigPipeError)(ue)&&ue.stack&&/unexpectedErrorHandler/.test(ue.stack)||te.error(ue)}),process.on("SIGPIPE",()=>{U||(U=!0,(0,y.onUnexpectedError)(new Error("Unexpected SIGPIPE")))})}),H.invokeFunction(q=>{const te=q.get(r.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const ue=(0,b.join)(process.env.HOMEDRIVE,"node_modules"),W=(0,b.dirname)((0,b.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),K=(0,b.join)(W,"node_modules");if(A.existsSync(ue)||A.existsSync(K)){const _=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${ue}
* ${K}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;te.warn(_),console.warn(_),process.exit(0)}}});const ne=H.invokeFunction(q=>{const te=q.get(r.ILogService);if(A.existsSync((0,b.join)(v.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(W){te.error(W)}return null}),se=A.existsSync(v.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(se&&Z&&typeof Z!="string"){const q=le.type!==0?`?${v.connectionTokenQueryName}=${le.value}`:"";console.log(`Web UI available at http://localhost${Z.port===80?"":`:${Z.port}`}/${q}`)}const de=H.createInstance(ie,Y,le,ne,se);f.mark("code/server/ready");const re=I.performance.now(),j=global.vscodeServerStartTime,N=global.vscodeServerListenTime,M=global.vscodeServerCodeLoadedTime;if(H.invokeFunction(q=>{q.get(o.ITelemetryService).publicLog2("serverStart",{startTime:j,startedTime:N,codeLoadedTime:M,readyTime:re})}),$["print-startup-performance"]){const q=P.LoaderStats.get();let te="";te+=`

### Load AMD-module
`,te+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.amdLoad),te+=`

### Load commonjs-module
`,te+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.nodeRequire),te+=`

### Invoke AMD-module factory
`,te+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.amdInvoke),te+=`

### Invoke commonjs-module
`,te+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.nodeEval),te+=`Start-up time: ${N-j}
`,te+=`Code loading time: ${M-j}
`,te+=`Initialized time: ${re-j}
`,te+=`
`,console.log(te)}return de}e.createServer=ee;class F{static create($){const x=$.webEndpointUrlTemplate,le=$.commit,be=$.quality;if(!x||!le||!be)return new F(null);const Y=(0,m.generateUuid)(),U=new URL(x.replace("{{uuid}}",Y).replace("{{commit}}",le).replace("{{quality}}",be)).origin,ne=(0,u.escapeRegExpCharacters)(U).replace(Y,"[a-zA-Z0-9\\-]+");try{const se=(0,u.createRegExp)(`^${ne}$`,!0,{matchCase:!1});return new F(se)}catch{return new F(null)}}constructor($){this.a=$}matches($){return this.a?this.a.test($):!1}}}),define(ve[289],Ee([1,0,29,31,13,277,279,61,7,280,41,51,47]),function(ae,e,E,A,a,I,D,P,w,y,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=y.performance.now();const b={onMultipleValues:(m,d)=>{console.error(`Option '${m}' can only be defined once. Using value ${d}.`)},onEmptyValue:m=>{console.error(`Ignoring option '${m}': Value must not be empty.`)},onUnknownOption:m=>{console.error(`Ignoring option '${m}': not supported for server.`)},onDeprecatedOption:(m,d)=>{console.warn(`Option '${m}' is deprecated: ${d}`)}};function f(){return(0,P.parseArgs)(process.argv.slice(2),T.serverOptions,b)}function p(m){const d=m["server-data-dir"]||m["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.join)(E.homedir(),S.default.serverDataFolderName||".vscode-remote"),C=m["user-data-dir"]||(0,w.join)(d,"data"),k=(0,w.join)(C,"User"),t=(0,w.join)(k,"globalStorage"),r=(0,w.join)(k,"History"),n=(0,w.join)(C,"Machine");m["user-data-dir"]=C;const i=(0,w.dirname)(a.FileAccess.asFileUri("").fsPath),o=m["builtin-extensions-dir"]||(0,w.join)(i,"extensions");return m["builtin-extensions-dir"]=o,m["extensions-dir"]=m["extensions-dir"]||(0,w.join)(d,"extensions"),[d,m["extensions-dir"],C,k,n,t,r].forEach(c=>{try{A.existsSync(c)||A.mkdirSync(c,{mode:448})}catch(l){console.error(l)}}),d}function u(m=f()){return(0,I.run)(m,p(m),T.serverOptions)}e.spawnCli=u;function h(m,d=f()){return(0,D.createServer)(m,d,p(d))}e.createServer=h})}).call(this);

//# sourceMappingURL=server.main.js.map
