"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","fs","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ne){for(var e=[],c=0,A=ne.length;c<A;c++)e[c]=ye[ne[c]];return e};define(ye[62],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(C,P){const S=Object.create(null);for(const I of C){const L=P(I);let k=S[L];k||(k=S[L]=[]),k.push(I)}return S}e.groupBy=c;function A(C,P){const S=[],I=[];for(const L of C)P.has(L)||S.push(L);for(const L of P)C.has(L)||I.push(L);return{removed:S,added:I}}e.diffSets=A;function u(C,P){const S=[],I=[];for(const[L,k]of C)P.has(L)||S.push(k);for(const[L,k]of P)C.has(L)||I.push(k);return{removed:S,added:I}}e.diffMaps=u;class R{constructor(){this.a=new Map}add(P,S){let I=this.a.get(P);I||(I=new Set,this.a.set(P,I)),I.add(S)}delete(P,S){const I=this.a.get(P);!I||(I.delete(S),I.size===0&&this.a.delete(P))}forEach(P,S){const I=this.a.get(P);!I||I.forEach(S)}}e.SetMap=R}),define(ye[63],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(C){return(P,S,I)=>{let L=null,k=null;if(typeof I.value=="function"?(L="value",k=I.value):typeof I.get=="function"&&(L="get",k=I.get),!k)throw new Error("not supported");I[L]=C(k,S)}}function A(C,P,S){let I=null,L=null;if(typeof S.value=="function"?(I="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",L=S.get),!L)throw new Error("not supported");const k=`$memoize$${P}`;S[I]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[k]}}e.memoize=A;function u(C,P,S){return c((I,L)=>{const k=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...T){this[v]||(this[v]=S?S():void 0),clearTimeout(this[k]),P&&(this[v]=P(this[v],...T),T=[this[v]]),this[k]=setTimeout(()=>{I.apply(this,T),this[v]=S?S():void 0},C)}})}e.debounce=u;function R(C,P,S){return c((I,L)=>{const k=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...m){if(this[v]||(this[v]=S?S():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...m)),this[E])return;const d=this[T]+C;d<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[v]]),this[v]=S?S():void 0):(this[E]=!0,this[k]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),I.apply(this,[this[v]]),this[v]=S?S():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[11],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?y.isErrorNoTelemetry(o)?new y(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=c,e.errorHandler=new c;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function u(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function R(i){I(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=R;function C(i){I(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=C;function P(i){if(i instanceof Error){const{name:o,message:s}=i,l=i.stacktrace||i.stack;return{$isError:!0,name:o,message:s,stack:l,noTelemetry:y.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=P;const S="Canceled";function I(i){return i instanceof L?!0:i instanceof Error&&i.name===S&&i.message===S}e.isCancellationError=I;class L extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=L;function k(){const i=new Error(S);return i.name=i.message,i}e.canceled=k;function v(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=v;function T(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=T;function E(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function m(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=m;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=d;class f extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=f;class p extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=p;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class y extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof y)return o;const s=new y;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class g extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(ye[15],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(oe,ae=0){return oe[oe.length-(1+ae)]}e.tail=A;function u(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=u;function R(oe,ae,fe=(ee,le)=>ee===le){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let ee=0,le=oe.length;ee<le;ee++)if(!fe(oe[ee],ae[ee]))return!1;return!0}e.equals=R;function C(oe,ae){const fe=oe.length-1;ae<fe&&(oe[ae]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=C;function P(oe,ae,fe){return S(oe.length,ee=>fe(oe[ee],ae))}e.binarySearch=P;function S(oe,ae){let fe=0,ee=oe-1;for(;fe<=ee;){const le=(fe+ee)/2|0,re=ae(le);if(re<0)fe=le+1;else if(re>0)ee=le-1;else return le}return-(fe+1)}e.binarySearch2=S;function I(oe,ae){let fe=0,ee=oe.length;if(ee===0)return 0;for(;fe<ee;){const le=Math.floor((fe+ee)/2);ae(oe[le])?ee=le:fe=le+1}return fe}e.findFirstInSorted=I;function L(oe,ae,fe){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const ee=ae[Math.floor(ae.length*Math.random())],le=[],re=[],N=[];for(const W of ae){const K=fe(W,ee);K<0?le.push(W):K>0?re.push(W):N.push(W)}return oe<le.length?L(oe,le,fe):oe<le.length+N.length?N[0]:L(oe-(le.length+N.length),re,fe)}e.quickSelect=L;function k(oe,ae){const fe=[];let ee;for(const le of oe.slice(0).sort(ae))!ee||ae(ee[0],le)!==0?(ee=[le],fe.push(ee)):ee.push(le);return fe}e.groupBy=k;function v(oe,ae,fe){const ee=[];function le(W,K,_){if(K===0&&_.length===0)return;const he=ee[ee.length-1];he&&he.start+he.deleteCount===W?(he.deleteCount+=K,he.toInsert.push(..._)):ee.push({start:W,deleteCount:K,toInsert:_})}let re=0,N=0;for(;;){if(re===oe.length){le(re,0,ae.slice(N));break}if(N===ae.length){le(re,oe.length-re,[]);break}const W=oe[re],K=ae[N],_=fe(W,K);_===0?(re+=1,N+=1):_<0?(le(re,1,[]),re+=1):_>0&&(le(re,0,[K]),N+=1)}return ee}e.sortedDiff=v;function T(oe,ae,fe){const ee=v(oe,ae,fe),le=[],re=[];for(const N of ee)le.push(...oe.slice(N.start,N.start+N.deleteCount)),re.push(...N.toInsert);return{removed:le,added:re}}e.delta=T;function E(oe,ae,fe){if(fe===0)return[];const ee=oe.slice(0,fe).sort(ae);return d(oe,ae,ee,fe,oe.length),ee}e.top=E;function m(oe,ae,fe,ee,le){return fe===0?Promise.resolve([]):new Promise((re,N)=>{(async()=>{const W=oe.length,K=oe.slice(0,fe).sort(ae);for(let _=fe,he=Math.min(fe+ee,W);_<W;_=he,he=Math.min(he+ee,W)){if(_>fe&&await new Promise(we=>setTimeout(we)),le&&le.isCancellationRequested)throw new c.CancellationError;d(oe,ae,K,_,he)}return K})().then(re,N)})}e.topAsync=m;function d(oe,ae,fe,ee,le){for(const re=fe.length;ee<le;ee++){const N=oe[ee];if(ae(N,fe[re-1])<0){fe.pop();const W=I(fe,K=>ae(N,K)<0);fe.splice(W,0,N)}}}function f(oe){return oe.filter(ae=>!!ae)}e.coalesce=f;function p(oe){let ae=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[ae]=oe[fe],ae+=1);oe.length=ae}e.coalesceInPlace=p;function b(oe,ae,fe){oe.splice(fe,0,oe.splice(ae,1)[0])}e.move=b;function y(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=y;function g(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=g;function i(oe,ae=fe=>fe){const fe=new Set;return oe.filter(ee=>{const le=ae(ee);return fe.has(le)?!1:(fe.add(le),!0)})}e.distinct=i;function o(oe){const ae=new Set;return fe=>{const ee=oe(fe);return ae.has(ee)?!1:(ae.add(ee),!0)}}e.uniqueFilter=o;function s(oe,ae){const fe=l(oe,ae);if(fe!==-1)return oe[fe]}e.findLast=s;function l(oe,ae){for(let fe=oe.length-1;fe>=0;fe--){const ee=oe[fe];if(ae(ee))return fe}return-1}e.lastIndex=l;function r(oe,ae){return oe.length>0?oe[0]:ae}e.firstOrDefault=r;function h(oe,ae){return oe.length>0?oe[oe.length-1]:ae}e.lastOrDefault=h;function n(oe,ae,fe=(ee,le)=>ee===le){let ee=0;for(let le=0,re=Math.min(oe.length,ae.length);le<re&&fe(oe[le],ae[le]);le++)ee++;return ee}e.commonPrefixLength=n;function t(oe){return[].concat(...oe)}e.flatten=t;function a(oe,ae){let fe=typeof ae=="number"?oe:0;typeof ae=="number"?fe=oe:(fe=0,ae=oe);const ee=[];if(fe<=ae)for(let le=fe;le<ae;le++)ee.push(le);else for(let le=fe;le>ae;le--)ee.push(le);return ee}e.range=a;function w(oe,ae,fe){return oe.reduce((ee,le)=>(ee[ae(le)]=fe?fe(le):le,ee),Object.create(null))}e.index=w;function D(oe,ae){return oe.push(ae),()=>F(oe,ae)}e.insert=D;function F(oe,ae){const fe=oe.indexOf(ae);if(fe>-1)return oe.splice(fe,1),ae}e.remove=F;function x(oe,ae,fe){const ee=oe.slice(0,ae),le=oe.slice(ae);return ee.concat(fe,le)}e.arrayInsert=x;function V(oe,ae){let fe;if(typeof ae=="number"){let ee=ae;fe=()=>{const le=Math.sin(ee++)*179426549;return le-Math.floor(le)}}else fe=Math.random;for(let ee=oe.length-1;ee>0;ee-=1){const le=Math.floor(fe()*(ee+1)),re=oe[ee];oe[ee]=oe[le],oe[le]=re}}e.shuffle=V;function M(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.unshift(ae))}e.pushToStart=M;function $(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.push(ae))}e.pushToEnd=$;function O(oe,ae){for(const fe of ae)oe.push(fe)}e.pushMany=O;function U(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}e.mapArrayOrNot=U;function B(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=B;function j(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=j;function de(oe,ae){for(const fe of oe){const ee=ae(fe);if(ee!==void 0)return ee}}e.mapFind=de;function Y(oe,ae,fe){const ee=Q(oe,ae),le=oe.length,re=fe.length;oe.length=le+re;for(let N=le-1;N>=ee;N--)oe[N+re]=oe[N];for(let N=0;N<re;N++)oe[N+ee]=fe[N]}e.insertInto=Y;function q(oe,ae,fe,ee){const le=Q(oe,ae),re=oe.splice(le,fe);return Y(oe,le,ee),re}e.splice=q;function Q(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var Z;(function(oe){function ae(le){return le<0}oe.isLessThan=ae;function fe(le){return le>0}oe.isGreaterThan=fe;function ee(le){return le===0}oe.isNeitherLessOrGreaterThan=ee,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function te(oe,ae){return(fe,ee)=>ae(oe(fe),oe(ee))}e.compareBy=te;function X(...oe){return(ae,fe)=>{for(const ee of oe){const le=ee(ae,fe);if(!Z.isNeitherLessOrGreaterThan(le))return le}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const J=(oe,ae)=>oe-ae;e.numberComparator=J;function ie(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const le=oe[ee];ae(le,fe)>0&&(fe=le)}return fe}e.findMaxBy=ie;function pe(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const le=oe[ee];ae(le,fe)>=0&&(fe=le)}return fe}e.findLastMaxBy=pe;function ve(oe,ae){return ie(oe,(fe,ee)=>-ae(fe,ee))}e.findMinBy=ve;class ke{constructor(ae){this.f=ae,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let fe=this.c;for(;fe<this.f.length&&ae(this.f[fe]);)fe++;const ee=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,ee}takeFromEndWhile(ae){let fe=this.d;for(;fe>=0&&ae(this.f[fe]);)fe--;const ee=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ae=this.f[this.c];return this.c++,ae}removeLast(){const ae=this.f[this.d];return this.d--,ae}takeCount(ae){const fe=this.f.slice(this.c,this.c+ae);return this.c+=ae,fe}}e.ArrayQueue=ke;class Oe{constructor(ae){this.iterate=ae}forEach(ae){this.iterate(fe=>(ae(fe),!0))}toArray(){const ae=[];return this.iterate(fe=>(ae.push(fe),!0)),ae}filter(ae){return new Oe(fe=>this.iterate(ee=>ae(ee)?fe(ee):!0))}map(ae){return new Oe(fe=>this.iterate(ee=>fe(ae(ee))))}some(ae){let fe=!1;return this.iterate(ee=>(fe=ae(ee),!fe)),fe}findFirst(ae){let fe;return this.iterate(ee=>ae(ee)?(fe=ee,!1):!0),fe}findLast(ae){let fe;return this.iterate(ee=>(ae(ee)&&(fe=ee),!0)),fe}findLastMaxBy(ae){let fe,ee=!0;return this.iterate(le=>((ee||Z.isGreaterThan(ae(le,fe)))&&(ee=!1,fe=le),!0)),fe}}Oe.empty=new Oe(oe=>{}),e.CallbackIterable=Oe}),define(ye[50],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(S,I){if(!S)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=A;function u(S,I="Unreachable"){throw new Error(I)}e.assertNever=u;function R(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=R;function C(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function P(S,I){let L=0;for(;L<S.length-1;){const k=S[L],v=S[L+1];if(!I(k,v))return!1;L++}return!0}e.checkAdjacentItems=P}),define(ye[64],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(A){const u=this;let R=!1,C;return function(){return R||(R=!0,C=A.apply(u,arguments)),C}}e.once=c}),define(ye[101],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(u){this.a=u,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[65],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(A){function u(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}A.is=u;const R=Object.freeze([]);function C(){return R}A.empty=C;function*P(y){yield y}A.single=P;function S(y){return u(y)?y:P(y)}A.wrap=S;function I(y){return y||R}A.from=I;function L(y){return!y||y[Symbol.iterator]().next().done===!0}A.isEmpty=L;function k(y){return y[Symbol.iterator]().next().value}A.first=k;function v(y,g){for(const i of y)if(g(i))return!0;return!1}A.some=v;function T(y,g){for(const i of y)if(g(i))return i}A.find=T;function*E(y,g){for(const i of y)g(i)&&(yield i)}A.filter=E;function*m(y,g){let i=0;for(const o of y)yield g(o,i++)}A.map=m;function*d(...y){for(const g of y)for(const i of g)yield i}A.concat=d;function f(y,g,i){let o=i;for(const s of y)o=g(o,s);return o}A.reduce=f;function*p(y,g,i=y.length){for(g<0&&(g+=y.length),i<0?i+=y.length:i>y.length&&(i=y.length);g<i;g++)yield y[g]}A.slice=p;function b(y,g=Number.POSITIVE_INFINITY){const i=[];if(g===0)return[i,y];const o=y[Symbol.iterator]();for(let s=0;s<g;s++){const l=o.next();if(l.done)return[i,A.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=b})(c=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var u;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(u=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function C(i,o=!1){let s=0;const l=i.length;let r="",h=0,n=16,t=0;function a($){let O=0,U=0;for(;O<$;){const B=i.charCodeAt(s);if(B>=48&&B<=57)U=U*16+B-48;else if(B>=65&&B<=70)U=U*16+B-65+10;else if(B>=97&&B<=102)U=U*16+B-97+10;else break;s++,O++}return O<$&&(U=-1),U}function w($){s=$,r="",h=0,n=16,t=0}function D(){const $=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&I(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&I(i.charCodeAt(s)))for(s++;s<i.length&&I(i.charCodeAt(s));)s++;else return t=3,i.substring($,s);let O=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&I(i.charCodeAt(s))){for(s++;s<i.length&&I(i.charCodeAt(s));)s++;O=s}else t=3;return i.substring($,O)}function F(){let $="",O=s;for(;;){if(s>=l){$+=i.substring(O,s),t=2;break}const U=i.charCodeAt(s);if(U===34){$+=i.substring(O,s),s++;break}if(U===92){if($+=i.substring(O,s),s++,s>=l){t=2;break}switch(i.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const j=a(4);j>=0?$+=String.fromCharCode(j):t=4;break}default:t=5}O=s;continue}if(U>=0&&U<=31)if(S(U)){$+=i.substring(O,s),t=2;break}else t=6;s++}return $}function x(){if(r="",t=0,h=s,s>=l)return h=l,n=17;let $=i.charCodeAt(s);if(P($)){do s++,r+=String.fromCharCode($),$=i.charCodeAt(s);while(P($));return n=15}if(S($))return s++,r+=String.fromCharCode($),$===13&&i.charCodeAt(s)===10&&(s++,r+=`
`),n=14;switch($){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,r=F(),n=10;case 47:{const O=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<l&&!S(i.charCodeAt(s));)s++;return r=i.substring(O,s),n=12}if(i.charCodeAt(s+1)===42){s+=2;const U=l-1;let B=!1;for(;s<U;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,t=1),r=i.substring(O,s),n=13}return r+=String.fromCharCode($),s++,n=16}case 45:if(r+=String.fromCharCode($),s++,s===l||!I(i.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=D(),n=11;default:for(;s<l&&V($);)s++,$=i.charCodeAt(s);if(h!==s){switch(r=i.substring(h,s),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode($),s++,n=16}}function V($){if(P($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=x();while($>=12&&$<=15);return $}return{setPosition:w,getPosition:()=>s,scan:o?M:x,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>t}}e.createScanner=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function I(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function k(i,o){const s=[],l=new Object;let r;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function t(a,w,D,F){h.value=a,h.offset=w,h.length=D,h.type=F,h.colonOffset=void 0,r=h}try{b(i,{onObjectBegin:(a,w)=>{if(o<=a)throw l;r=void 0,n=o>a,s.push("")},onObjectProperty:(a,w,D)=>{if(o<w||(t(a,w,D,"property"),s[s.length-1]=a,o<=w+D))throw l},onObjectEnd:(a,w)=>{if(o<=a)throw l;r=void 0,s.pop()},onArrayBegin:(a,w)=>{if(o<=a)throw l;r=void 0,s.push(0)},onArrayEnd:(a,w)=>{if(o<=a)throw l;r=void 0,s.pop()},onLiteralValue:(a,w,D)=>{if(o<w||(t(a,w,D,g(a)),o<=w+D))throw l},onSeparator:(a,w,D)=>{if(o<=w)throw l;if(a===":"&&r&&r.type==="property")r.colonOffset=w,n=!1,r=void 0;else if(a===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(n=!0,s[s.length-1]=""),r=void 0}}})}catch(a){if(a!==l)throw a}return{path:s,previousNode:r,isAtPropertyKey:n,matches:a=>{let w=0;for(let D=0;w<a.length&&D<s.length;D++)if(a[w]===s[D]||a[w]==="*")w++;else if(a[w]!=="**")return!1;return w===a.length}}}e.getLocation=k;function v(i,o=[],s=R.DEFAULT){let l=null,r=[];const h=[];function n(a){Array.isArray(r)?r.push(a):l!==null&&(r[l]=a)}return b(i,{onObjectBegin:()=>{const a={};n(a),h.push(r),r=a,l=null},onObjectProperty:a=>{l=a},onObjectEnd:()=>{r=h.pop()},onArrayBegin:()=>{const a=[];n(a),h.push(r),r=a,l=null},onArrayEnd:()=>{r=h.pop()},onLiteralValue:n,onError:(a,w,D)=>{o.push({error:a,offset:w,length:D})}},s),r[0]}e.parse=v;function T(i,o=[],s=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(a){l.type==="property"&&(l.length=a-l.offset,l=l.parent)}function h(a){return l.children.push(a),a}b(i,{onObjectBegin:a=>{l=h({type:"object",offset:a,length:-1,parent:l,children:[]})},onObjectProperty:(a,w,D)=>{l=h({type:"property",offset:w,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:a,offset:w,length:D,parent:l})},onObjectEnd:(a,w)=>{l.length=a+w-l.offset,l=l.parent,r(a+w)},onArrayBegin:(a,w)=>{l=h({type:"array",offset:a,length:-1,parent:l,children:[]})},onArrayEnd:(a,w)=>{l.length=a+w-l.offset,l=l.parent,r(a+w)},onLiteralValue:(a,w,D)=>{h({type:g(a),offset:w,length:D,parent:l,value:a}),r(w+D)},onSeparator:(a,w,D)=>{l.type==="property"&&(a===":"?l.colonOffset=w:a===","&&r(w))},onError:(a,w,D)=>{o.push({error:a,offset:w,length:D})}},s);const t=l.children[0];return t&&delete t.parent,t}e.parseTree=T;function E(i,o){if(!i)return;let s=i;for(const l of o)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===l){s=h.children[1],r=!0;break}if(!r)return}else{const r=l;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=E;function m(i){if(!i.parent||!i.parent.children)return[];const o=m(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.getNodePath=m;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const o=Object.create(null);for(const s of i.children){const l=s.children[1];l&&(o[s.children[0].value]=d(l))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function f(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.contains=f;function p(i,o,s=!1){if(f(i,o,s)){const l=i.children;if(Array.isArray(l))for(let r=0;r<l.length&&l[r].offset<=o;r++){const h=p(l[r],o,s);if(h)return h}return i}}e.findNodeAtOffset=p;function b(i,o,s=R.DEFAULT){const l=C(i,!1);function r(te){return te?()=>te(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(te){return te?X=>te(X,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=r(o.onObjectBegin),t=h(o.onObjectProperty),a=r(o.onObjectEnd),w=r(o.onArrayBegin),D=r(o.onArrayEnd),F=h(o.onLiteralValue),x=h(o.onSeparator),V=r(o.onComment),M=h(o.onError),$=s&&s.disallowComments,O=s&&s.allowTrailingComma;function U(){for(;;){const te=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:$||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:$?B(10):V();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,X=[],J=[]){if(M(te),X.length+J.length>0){let ie=l.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){U();break}else if(J.indexOf(ie)!==-1)break;ie=U()}}}function j(te){const X=l.getTokenValue();return te?F(X):t(X),U(),!0}function de(){switch(l.getToken()){case 11:{let te=0;try{te=JSON.parse(l.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}F(te);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function Y(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(j(!1),l.getToken()===6?(x(":"),U(),Z()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function q(){n(),U();let te=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(te||B(4,[],[]),x(","),U(),l.getToken()===2&&O)break}else te&&B(6,[],[]);Y()||B(4,[],[2,5]),te=!0}return a(),l.getToken()!==2?B(7,[2],[]):U(),!0}function Q(){w(),U();let te=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(te||B(4,[],[]),x(","),U(),l.getToken()===4&&O)break}else te&&B(6,[],[]);Z()||B(4,[],[4,5]),te=!0}return D(),l.getToken()!==4?B(8,[4],[]):U(),!0}function Z(){switch(l.getToken()){case 3:return Q();case 1:return q();case 10:return j(!0);default:return de()}}return U(),l.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):Z()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=b;function y(i,o){const s=C(i),l=[];let r,h=0,n;do switch(n=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:h!==n&&l.push(i.substring(h,n)),o!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,o)),h=s.getPosition();break}while(r!==17);return l.join("")}e.stripComments=y;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ye[66],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(u){this.d=u,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(u){this.c=u}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=c}),define(ye[6],De([1,0,64,65]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let R=null;function C(h){R=h}if(e.setDisposableTracker=C,u){const h="__is_disposable_tracked__";C(new class{trackDisposable(n){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[h]||console.log(t)},3e3)}setParent(n,t){if(n&&n!==p.None)try{n[h]=!0}catch{}}markAsDisposed(n){if(n&&n!==p.None)try{n[h]=!0}catch{}}markAsSingleton(n){}})}function P(h){return R?.trackDisposable(h),h}function S(h){R?.markAsDisposed(h)}function I(h,n){R?.setParent(h,n)}function L(h,n){if(!!R)for(const t of h)R.setParent(t,n)}function k(h){return R?.markAsSingleton(h),h}e.markAsSingleton=k;function v(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=v;function T(h){if(A.Iterable.is(h)){const n=[];for(const t of h)if(t)try{t.dispose()}catch(a){n.push(a)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.dispose=T;function E(h){for(const n of h)v(n)&&n.dispose();return[]}e.disposeIfDisposable=E;function m(...h){const n=d(()=>T(h));return L(h,n),n}e.combinedDisposable=m;function d(h){const n=P({dispose:(0,c.once)(()=>{S(n),h()})});return n}e.toDisposable=d;class f{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{T(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}f.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=f;class p{constructor(){this.q=new f,P(this),I(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}p.None=Object.freeze({dispose(){}}),e.Disposable=p;class b{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&I(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&I(n,null),n}}e.MutableDisposable=b;class y{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(n){let t=n;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,S(this))},this}}e.SafeDisposable=g;class i{constructor(){this.a=new Map}acquire(n,...t){let a=this.a.get(n);a||(a={counter:0,object:this.b(n,...t)},this.a.set(n,a));const{object:w}=a,D=(0,c.once)(()=>{--a.counter===0&&(this.c(n,a.object),this.a.delete(n))});return a.counter++,{object:w,dispose:D}}}e.ReferenceCollection=i;class o{constructor(n){this.a=n}async acquire(n,...t){const a=this.a.acquire(n,...t);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(w){throw a.dispose(),w}}}e.AsyncReferenceCollection=o;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function l(h){const n=new f;try{h(n)}finally{n.dispose()}}e.disposeOnReturn=l;class r{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{T(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,t,a=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),a||this.a.get(n)?.dispose(),this.a.set(n,t)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ye[67],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(R){this.element=R,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class A{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let R=this.a;for(;R!==c.Undefined;){const C=R.next;R.prev=c.Undefined,R.next=c.Undefined,R=C}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const P=new c(R);if(this.a===c.Undefined)this.a=P,this.b=P;else if(C){const I=this.b;this.b=P,P.prev=I,I.next=P}else{const I=this.a;this.a=P,P.next=I,I.prev=P}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(P))}}shift(){if(this.a!==c.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==c.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==c.Undefined&&R.next!==c.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===c.Undefined&&R.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):R.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):R.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==c.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(ye[28],De([1,0]),function(ne,e){"use strict";var c,A,u;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(E,m,d){let f=E.get(m);return f===void 0&&(f=d,E.set(m,f)),f}e.getOrSet=R;function C(E){const m=[];return E.forEach((d,f)=>{m.push(`${f} => ${d}`)}),`Map(${E.size}) {${m.join(", ")}}`}e.mapToString=C;function P(E){const m=[];return E.forEach(d=>{m.push(d)}),`Set(${E.size}) {${m.join(", ")}}`}e.setToString=P;class S{constructor(m,d){this.uri=m,this.value=d}}class I{constructor(m,d){this[c]="ResourceMap",m instanceof I?(this.b=new Map(m.b),this.c=d??I.a):(this.b=new Map,this.c=m??I.a)}set(m,d){return this.b.set(this.c(m),new S(m,d)),this}get(m){return this.b.get(this.c(m))?.value}has(m){return this.b.has(this.c(m))}get size(){return this.b.size}clear(){this.b.clear()}delete(m){return this.b.delete(this.c(m))}forEach(m,d){typeof d<"u"&&(m=m.bind(d));for(const[f,p]of this.b)m(p.value,p.uri,this)}*values(){for(const m of this.b.values())yield m.value}*keys(){for(const m of this.b.values())yield m.uri}*entries(){for(const m of this.b.values())yield[m.uri,m.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.b)yield[m.uri,m.value]}}I.a=E=>E.toString(),e.ResourceMap=I;class L{constructor(m,d){this[A]="ResourceSet",!m||typeof m=="function"?this.a=new I(m):(this.a=new I(d),m.forEach(this.add,this))}get size(){return this.a.size}add(m){return this.a.set(m,m),this}clear(){this.a.clear()}delete(m){return this.a.delete(m)}forEach(m,d){this.a.forEach((f,p)=>m.call(d,p,p,this))}has(m){return this.a.has(m)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var k;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class v{constructor(){this[u]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(m){return this.a.has(m)}get(m,d=0){const f=this.a.get(m);if(!!f)return d!==0&&this.j(f,d),f.value}set(m,d,f=0){let p=this.a.get(m);if(p)p.value=d,f!==0&&this.j(p,f);else{switch(p={key:m,value:d,next:void 0,previous:void 0},f){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(m,p),this.d++}return this}delete(m){return!!this.remove(m)}remove(m){const d=this.a.get(m);if(!!d)return this.a.delete(m),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const m=this.b;return this.a.delete(m.key),this.i(m),this.d--,m.value}forEach(m,d){const f=this.e;let p=this.b;for(;p;){if(d?m.bind(d)(p.value,p.key,this):m(p.value,p.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const m=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}values(){const m=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}entries(){const m=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(m){if(m>=this.size)return;if(m===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>m;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(m){if(!this.b&&!this.c)this.c=m;else if(this.b)m.next=this.b,this.b.previous=m;else throw new Error("Invalid list");this.b=m,this.e++}h(m){if(!this.b&&!this.c)this.b=m;else if(this.c)m.previous=this.c,this.c.next=m;else throw new Error("Invalid list");this.c=m,this.e++}i(m){if(m===this.b&&m===this.c)this.b=void 0,this.c=void 0;else if(m===this.b){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.b=m.next}else if(m===this.c){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.c=m.previous}else{const d=m.next,f=m.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}m.next=void 0,m.previous=void 0,this.e++}j(m,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(m===this.b)return;const f=m.next,p=m.previous;m===this.c?(p.next=void 0,this.c=p):(f.previous=p,p.next=f),m.previous=void 0,m.next=this.b,this.b.previous=m,this.b=m,this.e++}else if(d===2){if(m===this.c)return;const f=m.next,p=m.previous;m===this.b?(f.previous=void 0,this.b=f):(f.previous=p,p.next=f),m.next=void 0,m.previous=this.c,this.c.next=m,this.c=m,this.e++}}}toJSON(){const m=[];return this.forEach((d,f)=>{m.push([f,d])}),m}fromJSON(m){this.clear();for(const[d,f]of m)this.set(d,f)}}e.LinkedMap=v;class T extends v{constructor(m,d=1){super(),this.k=m,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(m){this.k=m,this.m()}get ratio(){return this.l}set ratio(m){this.l=Math.min(Math.max(0,m),1),this.m()}get(m,d=2){return super.get(m,d)}peek(m){return super.get(m,0)}set(m,d){return super.set(m,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=T}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(oe,ae){for(var fe=0;fe<ae.length;fe++){var ee=ae[fe];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(oe,ee.key,ee)}}function c(oe,ae,fe){return ae&&e(oe.prototype,ae),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function A(oe,ae){if(!!oe){if(typeof oe=="string")return u(oe,ae);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return u(oe,ae)}}function u(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var fe=0,ee=new Array(ae);fe<ae;fe++)ee[fe]=oe[fe];return ee}function R(oe,ae){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=A(oe))||ae&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var ee=0;return function(){return ee>=oe.length?{done:!0}:{done:!1,value:oe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=C();function P(oe){ne.defaults=oe}var S=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ae){return v[ae]};function E(oe,ae){if(ae){if(S.test(oe))return oe.replace(I,T)}else if(L.test(oe))return oe.replace(k,T);return oe}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(oe){return oe.replace(m,function(ae,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function p(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var fe={replace:function(le,re){return re=re.source||re,re=re.replace(f,"$1"),oe=oe.replace(le,re),fe},getRegex:function(){return new RegExp(oe,ae)}};return fe}var b=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(oe,ae,fe){if(oe){var ee;try{ee=decodeURIComponent(d(fe)).replace(b,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ae&&!y.test(fe)&&(fe=r(ae,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,ae){i[" "+oe]||(o.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=a(oe,"/",!0)),oe=i[" "+oe];var fe=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?fe?ae:oe.replace(s,"$1")+ae:ae.charAt(0)==="/"?fe?ae:oe.replace(l,"$1")+ae:oe+ae}var h={exec:function(){}};function n(oe){for(var ae=1,fe,ee;ae<arguments.length;ae++){fe=arguments[ae];for(ee in fe)Object.prototype.hasOwnProperty.call(fe,ee)&&(oe[ee]=fe[ee])}return oe}function t(oe,ae){var fe=oe.replace(/\|/g,function(re,N,W){for(var K=!1,_=N;--_>=0&&W[_]==="\\";)K=!K;return K?"|":" |"}),ee=fe.split(/ \|/),le=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ae)ee.splice(ae);else for(;ee.length<ae;)ee.push("");for(;le<ee.length;le++)ee[le]=ee[le].trim().replace(/\\\|/g,"|");return ee}function a(oe,ae,fe){var ee=oe.length;if(ee===0)return"";for(var le=0;le<ee;){var re=oe.charAt(ee-le-1);if(re===ae&&!fe)le++;else if(re!==ae&&fe)le++;else break}return oe.slice(0,ee-le)}function w(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var fe=oe.length,ee=0,le=0;le<fe;le++)if(oe[le]==="\\")le++;else if(oe[le]===ae[0])ee++;else if(oe[le]===ae[1]&&(ee--,ee<0))return le;return-1}function D(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(oe,ae){if(ae<1)return"";for(var fe="";ae>1;)ae&1&&(fe+=oe),ae>>=1,oe+=oe;return fe+oe}function x(oe,ae,fe,ee){var le=ae.href,re=ae.title?E(ae.title):null,N=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){ee.state.inLink=!0;var W={type:"link",raw:fe,href:le,title:re,text:N,tokens:ee.inlineTokens(N)};return ee.state.inLink=!1,W}return{type:"image",raw:fe,href:le,title:re,text:E(N)}}function V(oe,ae){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return ae;var ee=fe[1];return ae.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var N=re[0];return N.length>=ee.length?le.slice(ee.length):le}).join(`
`)}var M=function(){function oe(fe){this.options=fe||ne.defaults}var ae=oe.prototype;return ae.space=function(ee){var le=this.rules.block.newline.exec(ee);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},ae.code=function(ee){var le=this.rules.block.code.exec(ee);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:a(re,`
`)}}},ae.fences=function(ee){var le=this.rules.block.fences.exec(ee);if(le){var re=le[0],N=V(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:N}}},ae.heading=function(ee){var le=this.rules.block.heading.exec(ee);if(le){var re=le[2].trim();if(/#$/.test(re)){var N=a(re,"#");(this.options.pedantic||!N||/ $/.test(N))&&(re=N.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},ae.hr=function(ee){var le=this.rules.block.hr.exec(ee);if(le)return{type:"hr",raw:le[0]}},ae.blockquote=function(ee){var le=this.rules.block.blockquote.exec(ee);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},ae.list=function(ee){var le=this.rules.block.list.exec(ee);if(le){var re,N,W,K,_,he,we,Ae,be,Ce,Te,Ve,xe=le[1].trim(),et=xe.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+xe.slice(0,-1):"",loose:!1,items:[]};xe=et?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=et?xe:"[*+-]");for(var nt=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Ve=!1,!(!(le=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(re=le[0],ee=ee.substring(re.length),Ae=le[2].split(`
`,1)[0],be=ee.split(`
`,1)[0],this.options.pedantic?(K=2,Te=Ae.trimLeft()):(K=le[2].search(/[^ ]/),K=K>4?1:K,Te=Ae.slice(K),K+=le[1].length),he=!1,!Ae&&/^ *$/.test(be)&&(re+=be+`
`,ee=ee.substring(be.length+1),Ve=!0),!Ve)for(var st=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Ae=Ce,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Ae)||rt.test(Ae)||st.test(Ae)||ht.test(ee)));){if(Ae.search(/[^ ]/)>=K||!Ae.trim())Te+=`
`+Ae.slice(K);else if(!he)Te+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),re+=Ce+`
`,ee=ee.substring(Ce.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(re)&&(we=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(Te),N&&(W=N[0]!=="[ ] ",Te=Te.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:re,task:!!N,checked:W,loose:!1,text:Te}),Qe.raw+=re}Qe.items[Qe.items.length-1].raw=re.trimRight(),Qe.items[Qe.items.length-1].text=Te.trimRight(),Qe.raw=Qe.raw.trimRight();var ce=Qe.items.length;for(_=0;_<ce;_++){this.lexer.state.top=!1,Qe.items[_].tokens=this.lexer.blockTokens(Qe.items[_].text,[]);var z=Qe.items[_].tokens.filter(function(Ie){return Ie.type==="space"}),ue=z.every(function(Ie){for(var Le=Ie.raw.split(""),$e=0,Ke=R(Le),Ze;!(Ze=Ke()).done;){var pt=Ze.value;if(pt===`
`&&($e+=1),$e>1)return!0}return!1});!Qe.loose&&z.length&&ue&&(Qe.loose=!0,Qe.items[_].loose=!0)}return Qe}},ae.html=function(ee){var le=this.rules.block.html.exec(ee);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(le[0]):E(le[0]);re.type="paragraph",re.text=N,re.tokens=this.lexer.inline(N)}return re}},ae.def=function(ee){var le=this.rules.block.def.exec(ee);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},ae.table=function(ee){var le=this.rules.block.table.exec(ee);if(le){var re={type:"table",header:t(le[1]).map(function(we){return{text:we}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var N=re.align.length,W,K,_,he;for(W=0;W<N;W++)/^ *-+: *$/.test(re.align[W])?re.align[W]="right":/^ *:-+: *$/.test(re.align[W])?re.align[W]="center":/^ *:-+ *$/.test(re.align[W])?re.align[W]="left":re.align[W]=null;for(N=re.rows.length,W=0;W<N;W++)re.rows[W]=t(re.rows[W],re.header.length).map(function(we){return{text:we}});for(N=re.header.length,K=0;K<N;K++)re.header[K].tokens=this.lexer.inline(re.header[K].text);for(N=re.rows.length,K=0;K<N;K++)for(he=re.rows[K],_=0;_<he.length;_++)he[_].tokens=this.lexer.inline(he[_].text);return re}}},ae.lheading=function(ee){var le=this.rules.block.lheading.exec(ee);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},ae.paragraph=function(ee){var le=this.rules.block.paragraph.exec(ee);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},ae.text=function(ee){var le=this.rules.block.text.exec(ee);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},ae.escape=function(ee){var le=this.rules.inline.escape.exec(ee);if(le)return{type:"escape",raw:le[0],text:E(le[1])}},ae.tag=function(ee){var le=this.rules.inline.tag.exec(ee);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):E(le[0]):le[0]}},ae.link=function(ee){var le=this.rules.inline.link.exec(ee);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var N=a(re.slice(0,-1),"\\");if((re.length-N.length)%2===0)return}else{var W=w(le[2],"()");if(W>-1){var K=le[0].indexOf("!")===0?5:4,_=K+le[1].length+W;le[2]=le[2].substring(0,W),le[0]=le[0].substring(0,_).trim(),le[3]=""}}var he=le[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=le[3]?le[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(re)?he=he.slice(1):he=he.slice(1,-1)),x(le,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ae.reflink=function(ee,le){var re;if((re=this.rules.inline.reflink.exec(ee))||(re=this.rules.inline.nolink.exec(ee))){var N=(re[2]||re[1]).replace(/\s+/g," ");if(N=le[N.toLowerCase()],!N||!N.href){var W=re[0].charAt(0);return{type:"text",raw:W,text:W}}return x(re,N,re[0],this.lexer)}},ae.emStrong=function(ee,le,re){re===void 0&&(re="");var N=this.rules.inline.emStrong.lDelim.exec(ee);if(!!N&&!(N[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=N[1]||N[2]||"";if(!W||W&&(re===""||this.rules.inline.punctuation.exec(re))){var K=N[0].length-1,_,he,we=K,Ae=0,be=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,le=le.slice(-1*ee.length+K);(N=be.exec(le))!=null;)if(_=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!_){if(he=_.length,N[3]||N[4]){we+=he;continue}else if((N[5]||N[6])&&K%3&&!((K+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(K,he)%2){var Ce=ee.slice(1,K+N.index+he);return{type:"em",raw:ee.slice(0,K+N.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var Te=ee.slice(2,K+N.index+he-1);return{type:"strong",raw:ee.slice(0,K+N.index+he+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}}}}},ae.codespan=function(ee){var le=this.rules.inline.code.exec(ee);if(le){var re=le[2].replace(/\n/g," "),N=/[^ ]/.test(re),W=/^ /.test(re)&&/ $/.test(re);return N&&W&&(re=re.substring(1,re.length-1)),re=E(re,!0),{type:"codespan",raw:le[0],text:re}}},ae.br=function(ee){var le=this.rules.inline.br.exec(ee);if(le)return{type:"br",raw:le[0]}},ae.del=function(ee){var le=this.rules.inline.del.exec(ee);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},ae.autolink=function(ee,le){var re=this.rules.inline.autolink.exec(ee);if(re){var N,W;return re[2]==="@"?(N=E(this.options.mangle?le(re[1]):re[1]),W="mailto:"+N):(N=E(re[1]),W=N),{type:"link",raw:re[0],text:N,href:W,tokens:[{type:"text",raw:N,text:N}]}}},ae.url=function(ee,le){var re;if(re=this.rules.inline.url.exec(ee)){var N,W;if(re[2]==="@")N=E(this.options.mangle?le(re[0]):re[0]),W="mailto:"+N;else{var K;do K=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(K!==re[0]);N=E(re[0]),re[1]==="www."?W="http://"+N:W=N}return{type:"link",raw:re[0],text:N,href:W,tokens:[{type:"text",raw:N,text:N}]}}},ae.inlineText=function(ee,le){var re=this.rules.inline.text.exec(ee);if(re){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):E(re[0]):re[0]:N=E(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:N}}},oe}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=p($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=p(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=p($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=p($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=p($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=p($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=n({},$),$.gfm=n({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=p($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=p($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=n({},$.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:p($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=p(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=p($._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=p(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=p(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=p(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=p(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=p(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=p(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=p(O.reflink).replace("label",O._label).replace("ref",$._label).getRegex(),O.nolink=p(O.nolink).replace("ref",$._label).getRegex(),O.reflinkSearch=p(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:p(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=p(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:p(O.br).replace("{2,}","*").getRegex(),text:p(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var ae="",fe,ee,le=oe.length;for(fe=0;fe<le;fe++)ee=oe.charCodeAt(fe),Math.random()>.5&&(ee="x"+ee.toString(16)),ae+="&#"+ee+";";return ae}var j=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ne.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:$.normal,inline:O.normal};this.options.pedantic?(ee.block=$.pedantic,ee.inline=O.pedantic):this.options.gfm&&(ee.block=$.gfm,this.options.breaks?ee.inline=O.breaks:ee.inline=O.gfm),this.tokenizer.rules=ee}oe.lex=function(ee,le){var re=new oe(le);return re.lex(ee)},oe.lexInline=function(ee,le){var re=new oe(le);return re.inlineTokens(ee)};var ae=oe.prototype;return ae.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ae.blockTokens=function(ee,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(we,Ae,be){return Ae+"    ".repeat(be.length)});for(var N,W,K,_;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(N=we.call({lexer:re},ee,le))?(ee=ee.substring(N.raw.length),le.push(N),!0):!1}))){if(N=this.tokenizer.space(ee)){ee=ee.substring(N.raw.length),N.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(N);continue}if(N=this.tokenizer.code(ee)){ee=ee.substring(N.raw.length),W=le[le.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+N.raw,W.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):le.push(N);continue}if(N=this.tokenizer.fences(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.heading(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.hr(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.blockquote(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.list(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.html(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.def(ee)){ee=ee.substring(N.raw.length),W=le[le.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+N.raw,W.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.lheading(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(K=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=ee.slice(1),be=void 0;re.options.extensions.startBlock.forEach(function(Ce){be=Ce.call({lexer:this},Ae),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(K=ee.substring(0,we+1))}(),this.state.top&&(N=this.tokenizer.paragraph(K))){W=le[le.length-1],_&&W.type==="paragraph"?(W.raw+=`
`+N.raw,W.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):le.push(N),_=K.length!==ee.length,ee=ee.substring(N.raw.length);continue}if(N=this.tokenizer.text(ee)){ee=ee.substring(N.raw.length),W=le[le.length-1],W&&W.type==="text"?(W.raw+=`
`+N.raw,W.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):le.push(N);continue}if(ee){var he="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,le},ae.inline=function(ee,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ee,tokens:le}),le},ae.inlineTokens=function(ee,le){var re=this;le===void 0&&(le=[]);var N,W,K,_=ee,he,we,Ae;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)be.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,he.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Te){return(N=Te.call({lexer:re},ee,le))?(ee=ee.substring(N.raw.length),le.push(N),!0):!1}))){if(N=this.tokenizer.escape(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.tag(ee)){ee=ee.substring(N.raw.length),W=le[le.length-1],W&&N.type==="text"&&W.type==="text"?(W.raw+=N.raw,W.text+=N.text):le.push(N);continue}if(N=this.tokenizer.link(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(N.raw.length),W=le[le.length-1],W&&N.type==="text"&&W.type==="text"?(W.raw+=N.raw,W.text+=N.text):le.push(N);continue}if(N=this.tokenizer.emStrong(ee,_,Ae)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.codespan(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.br(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.del(ee)){ee=ee.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.autolink(ee,B)){ee=ee.substring(N.raw.length),le.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(ee,B))){ee=ee.substring(N.raw.length),le.push(N);continue}if(K=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Te=1/0,Ve=ee.slice(1),xe=void 0;re.options.extensions.startInline.forEach(function(et){xe=et.call({lexer:this},Ve),typeof xe=="number"&&xe>=0&&(Te=Math.min(Te,xe))}),Te<1/0&&Te>=0&&(K=ee.substring(0,Te+1))}(),N=this.tokenizer.inlineText(K,U)){ee=ee.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),we=!0,W=le[le.length-1],W&&W.type==="text"?(W.raw+=N.raw,W.text+=N.text):le.push(N);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return le},c(oe,null,[{key:"rules",get:function(){return{block:$,inline:O}}}]),oe}(),de=function(){function oe(fe){this.options=fe||ne.defaults}var ae=oe.prototype;return ae.code=function(ee,le,re){var N=(le||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(ee,N);W!=null&&W!==ee&&(re=!0,ee=W)}return ee=ee.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+E(N,!0)+'">'+(re?ee:E(ee,!0))+`</code></pre>
`:"<pre><code>"+(re?ee:E(ee,!0))+`</code></pre>
`},ae.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ae.html=function(ee){return ee},ae.heading=function(ee,le,re,N){if(this.options.headerIds){var W=this.options.headerPrefix+N.slug(re);return"<h"+le+' id="'+W+'">'+ee+"</h"+le+`>
`}return"<h"+le+">"+ee+"</h"+le+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(ee,le,re){var N=le?"ol":"ul",W=le&&re!==1?' start="'+re+'"':"";return"<"+N+W+`>
`+ee+"</"+N+`>
`},ae.listitem=function(ee){return"<li>"+ee+`</li>
`},ae.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(ee){return"<p>"+ee+`</p>
`},ae.table=function(ee,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+le+`</table>
`},ae.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ae.tablecell=function(ee,le){var re=le.header?"th":"td",N=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return N+ee+("</"+re+`>
`)},ae.strong=function(ee){return"<strong>"+ee+"</strong>"},ae.em=function(ee){return"<em>"+ee+"</em>"},ae.codespan=function(ee){return"<code>"+ee+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(ee){return"<del>"+ee+"</del>"},ae.link=function(ee,le,re){if(ee=g(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var N='<a href="'+E(ee)+'"';return le&&(N+=' title="'+le+'"'),N+=">"+re+"</a>",N},ae.image=function(ee,le,re){if(ee=g(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var N='<img src="'+ee+'" alt="'+re+'"';return le&&(N+=' title="'+le+'"'),N+=this.options.xhtml?"/>":">",N},ae.text=function(ee){return ee},oe}(),Y=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(ee){return ee},ae.em=function(ee){return ee},ae.codespan=function(ee){return ee},ae.del=function(ee){return ee},ae.html=function(ee){return ee},ae.text=function(ee){return ee},ae.link=function(ee,le,re){return""+re},ae.image=function(ee,le,re){return""+re},ae.br=function(){return""},oe}(),q=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(ee,le){var re=ee,N=0;if(this.seen.hasOwnProperty(re)){N=this.seen[ee];do N++,re=ee+"-"+N;while(this.seen.hasOwnProperty(re))}return le||(this.seen[ee]=N,this.seen[re]=0),re},ae.slug=function(ee,le){le===void 0&&(le={});var re=this.serialize(ee);return this.getNextSafeSlug(re,le.dryrun)},oe}(),Q=function(){function oe(fe){this.options=fe||ne.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new q}oe.parse=function(ee,le){var re=new oe(le);return re.parse(ee)},oe.parseInline=function(ee,le){var re=new oe(le);return re.parseInline(ee)};var ae=oe.prototype;return ae.parse=function(ee,le){le===void 0&&(le=!0);var re="",N,W,K,_,he,we,Ae,be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce=ee.length;for(N=0;N<ce;N++){if(Te=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(rt=this.options.extensions.renderers[Te.type].call({parser:this},Te),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Te.type))){re+=rt||"";continue}switch(Te.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(Te.tokens),Te.depth,d(this.parseInline(Te.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(Te.text,Te.lang,Te.escaped);continue}case"table":{for(be="",Ae="",_=Te.header.length,W=0;W<_;W++)Ae+=this.renderer.tablecell(this.parseInline(Te.header[W].tokens),{header:!0,align:Te.align[W]});for(be+=this.renderer.tablerow(Ae),Ce="",_=Te.rows.length,W=0;W<_;W++){for(we=Te.rows[W],Ae="",he=we.length,K=0;K<he;K++)Ae+=this.renderer.tablecell(this.parseInline(we[K].tokens),{header:!1,align:Te.align[K]});Ce+=this.renderer.tablerow(Ae)}re+=this.renderer.table(be,Ce);continue}case"blockquote":{Ce=this.parse(Te.tokens),re+=this.renderer.blockquote(Ce);continue}case"list":{for(Ve=Te.ordered,xe=Te.start,et=Te.loose,_=Te.items.length,Ce="",W=0;W<_;W++)nt=Te.items[W],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Ue=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Ue+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Ue+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Ue}):Qe+=Ue),Qe+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(Qe,ht,st);re+=this.renderer.list(Ce,Ve,xe);continue}case"html":{re+=this.renderer.html(Te.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(Te.tokens));continue}case"text":{for(Ce=Te.tokens?this.parseInline(Te.tokens):Te.text;N+1<ce&&ee[N+1].type==="text";)Te=ee[++N],Ce+=`
`+(Te.tokens?this.parseInline(Te.tokens):Te.text);re+=le?this.renderer.paragraph(Ce):Ce;continue}default:{var z='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return re},ae.parseInline=function(ee,le){le=le||this.renderer;var re="",N,W,K,_=ee.length;for(N=0;N<_;N++){if(W=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(K=this.options.extensions.renderers[W.type].call({parser:this},W),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){re+=K||"";continue}switch(W.type){case"escape":{re+=le.text(W.text);break}case"html":{re+=le.html(W.text);break}case"link":{re+=le.link(W.href,W.title,this.parseInline(W.tokens,le));break}case"image":{re+=le.image(W.href,W.title,W.text);break}case"strong":{re+=le.strong(this.parseInline(W.tokens,le));break}case"em":{re+=le.em(this.parseInline(W.tokens,le));break}case"codespan":{re+=le.codespan(W.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(W.tokens,le));break}case"text":{re+=le.text(W.text);break}default:{var he='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return re},oe}();function Z(oe,ae,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(fe=ae,ae=null),ae=n({},Z.defaults,ae||{}),D(ae),fe){var ee=ae.highlight,le;try{le=j.lex(oe,ae)}catch(_){return fe(_)}var re=function(he){var we;if(!he)try{ae.walkTokens&&Z.walkTokens(le,ae.walkTokens),we=Q.parse(le,ae)}catch(Ae){he=Ae}return ae.highlight=ee,he?fe(he):fe(null,we)};if(!ee||ee.length<3||(delete ae.highlight,!le.length))return re();var N=0;Z.walkTokens(le,function(_){_.type==="code"&&(N++,setTimeout(function(){ee(_.text,_.lang,function(he,we){if(he)return re(he);we!=null&&we!==_.text&&(_.text=we,_.escaped=!0),N--,N===0&&re()})},0))}),N===0&&re();return}function W(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+E(_.message+"",!0)+"</pre>";throw _}try{var K=j.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(Z.walkTokens(K,ae.walkTokens)).then(function(){return Q.parse(K,ae)}).catch(W);Z.walkTokens(K,ae.walkTokens)}return Q.parse(K,ae)}catch(_){W(_)}}Z.options=Z.setOptions=function(oe){return n(Z.defaults,oe),P(Z.defaults),Z},Z.getDefaults=C,Z.defaults=ne.defaults,Z.use=function(){for(var oe=arguments.length,ae=new Array(oe),fe=0;fe<oe;fe++)ae[fe]=arguments[fe];var ee=n.apply(void 0,[{}].concat(ae)),le=Z.defaults.extensions||{renderers:{},childTokens:{}},re;ae.forEach(function(N){if(N.extensions&&(re=!0,N.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var _=le.renderers?le.renderers[K.name]:null;_?le.renderers[K.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var be=K.renderer.apply(this,we);return be===!1&&(be=_.apply(this,we)),be}:le.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[K.level]?le[K.level].unshift(K.tokenizer):le[K.level]=[K.tokenizer],K.start&&(K.level==="block"?le.startBlock?le.startBlock.push(K.start):le.startBlock=[K.start]:K.level==="inline"&&(le.startInline?le.startInline.push(K.start):le.startInline=[K.start]))}K.childTokens&&(le.childTokens[K.name]=K.childTokens)})),N.renderer&&function(){var K=Z.defaults.renderer||new de,_=function(Ae){var be=K[Ae];K[Ae]=function(){for(var Ce=arguments.length,Te=new Array(Ce),Ve=0;Ve<Ce;Ve++)Te[Ve]=arguments[Ve];var xe=N.renderer[Ae].apply(K,Te);return xe===!1&&(xe=be.apply(K,Te)),xe}};for(var he in N.renderer)_(he);ee.renderer=K}(),N.tokenizer&&function(){var K=Z.defaults.tokenizer||new M,_=function(Ae){var be=K[Ae];K[Ae]=function(){for(var Ce=arguments.length,Te=new Array(Ce),Ve=0;Ve<Ce;Ve++)Te[Ve]=arguments[Ve];var xe=N.tokenizer[Ae].apply(K,Te);return xe===!1&&(xe=be.apply(K,Te)),xe}};for(var he in N.tokenizer)_(he);ee.tokenizer=K}(),N.walkTokens){var W=Z.defaults.walkTokens;ee.walkTokens=function(K){var _=[];return _.push(N.walkTokens.call(this,K)),W&&(_=_.concat(W.call(this,K))),_}}re&&(ee.extensions=le),Z.setOptions(ee)})},Z.walkTokens=function(oe,ae){for(var fe=[],ee=function(){var W=re.value;switch(fe=fe.concat(ae.call(Z,W)),W.type){case"table":{for(var K=R(W.header),_;!(_=K()).done;){var he=_.value;fe=fe.concat(Z.walkTokens(he.tokens,ae))}for(var we=R(W.rows),Ae;!(Ae=we()).done;)for(var be=Ae.value,Ce=R(be),Te;!(Te=Ce()).done;){var Ve=Te.value;fe=fe.concat(Z.walkTokens(Ve.tokens,ae))}break}case"list":{fe=fe.concat(Z.walkTokens(W.items,ae));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[W.type]?Z.defaults.extensions.childTokens[W.type].forEach(function(xe){fe=fe.concat(Z.walkTokens(W[xe],ae))}):W.tokens&&(fe=fe.concat(Z.walkTokens(W.tokens,ae)))}},le=R(oe),re;!(re=le()).done;)ee();return fe},Z.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=n({},Z.defaults,ae||{}),D(ae);try{var fe=j.lexInline(oe,ae);return ae.walkTokens&&Z.walkTokens(fe,ae.walkTokens),Q.parseInline(fe,ae)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+E(ee.message+"",!0)+"</pre>";throw ee}},Z.Parser=Q,Z.parser=Q.parse,Z.Renderer=de,Z.TextRenderer=Y,Z.Lexer=j,Z.lexer=j.lex,Z.Tokenizer=M,Z.Slugger=q,Z.parse=Z;var te=Z.options,X=Z.setOptions,J=Z.use,ie=Z.walkTokens,pe=Z.parseInline,ve=Z,ke=Q.parse,Oe=j.lex;ne.Lexer=j,ne.Parser=Q,ne.Renderer=de,ne.Slugger=q,ne.TextRenderer=Y,ne.Tokenizer=M,ne.getDefaults=C,ne.lexer=Oe,ne.marked=Z,ne.options=te,ne.parse=ve,ne.parseInline=pe,ne.parser=ke,ne.setOptions=X,ne.use=J,ne.walkTokens=ie,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[86],De([1,0,28]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new c.LRUCache(1e4);function u(I){return S(I,"NFC",A)}e.normalizeNFC=u;const R=new c.LRUCache(1e4);function C(I){return S(I,"NFD",R)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function S(I,L,k){if(!I)return I;const v=k.get(I);if(v)return v;let T;return P.test(I)?T=I.normalize(L):T=I,k.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return C(L).replace(I,"")}}()}),define(ye[102],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(P,S,I){return Math.min(Math.max(P,S),I)}e.clamp=c;function A(P,S){return(S+P%S)%S}e.rot=A;class u{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=u;class R{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const I=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ne(u){const R=[];typeof u=="number"&&R.push("code/timeOrigin",u);function C(S){R.push(S,Date.now())}function P(){const S=[];for(let I=0;I<R.length;I+=2)S.push({name:R[I],startTime:R[I+1]});return S}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(u+C.startTime)});return R}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=c(A))}(),define(ye[12],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let c=!1,A=!1,u=!1,R=!1,C=!1,P=!1,S=!1,I=!1,L=!1,k=!1,v,T=e.LANGUAGE_DEFAULT,E,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const f=typeof d?.versions?.electron=="string",p=f&&d?.type==="renderer";if(typeof navigator=="object"&&!p){m=navigator.userAgent,c=m.indexOf("Windows")>=0,A=m.indexOf("Macintosh")>=0,I=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=m.indexOf("Linux")>=0,k=m?.indexOf("Mobi")>=0,P=!0,v=e.LANGUAGE_DEFAULT,T=v;const h=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),n=h&&h.getAttribute("data-settings");if(n)try{const t=JSON.parse(n);v=t.locale,E=t._translationsConfigFile,T=t.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof d=="object"){c=d.platform==="win32",A=d.platform==="darwin",u=d.platform==="linux",R=u&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,S=f,L=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,T=e.LANGUAGE_DEFAULT;const h=d.env.VSCODE_NLS_CONFIG;if(h)try{const n=JSON.parse(h),t=n.availableLanguages["*"];v=n.locale,T=t||e.LANGUAGE_DEFAULT,E=n._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var b;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function y(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let g=0;A?g=1:c?g=3:u&&(g=2),e.isWindows=c,e.isMacintosh=A,e.isLinux=u,e.isLinuxSnap=R,e.isNative=C,e.isElectron=S,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=k,e.isCI=L,e.platform=g,e.userAgent=m,e.language=T;var i;(function(h){function n(){return e.language}h.value=n;function t(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=t;function a(){return e.language==="en"}h.isDefault=a})(i=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];e.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeScheduleAsyncWork)for(let a=0,w=h.length;a<w;a++){const D=h[a];if(D.id===t.data.vscodeScheduleAsyncWork){h.splice(a,1),D.callback();return}}});let n=0;return t=>{const a=++n;h.push({id:a,callback:t}),e.globals.postMessage({vscodeScheduleAsyncWork:a},"*")}}return h=>setTimeout(h)})();var o;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||I?2:c?1:3;let s=!0,l=!1;function r(){if(!l){l=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,s=new Uint16Array(h.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const u=c.globals.vscode.process;A={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ye[9],De([1,0,36]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,u=97,R=90,C=122,P=46,S=47,I=92,L=58,k=63;class v extends Error{constructor(o,s,l){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const h=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${h} ${r} of type ${s}`;n+=`. Received type ${typeof l}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function T(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function E(i,o){if(typeof i!="string")throw new v(o,"string",i)}const m=c.platform==="win32";function d(i){return i===S||i===I}function f(i){return i===S}function p(i){return i>=A&&i<=R||i>=u&&i<=C}function b(i,o,s,l){let r="",h=0,n=-1,t=0,a=0;for(let w=0;w<=i.length;++w){if(w<i.length)a=i.charCodeAt(w);else{if(l(a))break;a=S}if(l(a)){if(!(n===w-1||t===1))if(t===2){if(r.length<2||h!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const D=r.lastIndexOf(s);D===-1?(r="",h=0):(r=r.slice(0,D),h=r.length-1-r.lastIndexOf(s)),n=w,t=0;continue}else if(r.length!==0){r="",h=0,n=w,t=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",h=2)}else r.length>0?r+=`${s}${i.slice(n+1,w)}`:r=i.slice(n+1,w),h=w-n-1;n=w,t=0}else a===P&&t!==-1?++t:t=-1}return r}function y(i,o){T(o,"pathObject");const s=o.dir||o.root,l=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${l}`:`${s}${i}${l}`:l}e.win32={resolve(...i){let o="",s="",l=!1;for(let r=i.length-1;r>=-1;r--){let h;if(r>=0){if(h=i[r],E(h,"path"),h.length===0)continue}else o.length===0?h=c.cwd():(h=c.env[`=${o}`]||c.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==o.toLowerCase()&&h.charCodeAt(2)===I)&&(h=`${o}\\`));const n=h.length;let t=0,a="",w=!1;const D=h.charCodeAt(0);if(n===1)d(D)&&(t=1,w=!0);else if(d(D))if(w=!0,d(h.charCodeAt(1))){let F=2,x=F;for(;F<n&&!d(h.charCodeAt(F));)F++;if(F<n&&F!==x){const V=h.slice(x,F);for(x=F;F<n&&d(h.charCodeAt(F));)F++;if(F<n&&F!==x){for(x=F;F<n&&!d(h.charCodeAt(F));)F++;(F===n||F!==x)&&(a=`\\\\${V}\\${h.slice(x,F)}`,t=F)}}}else t=1;else p(D)&&h.charCodeAt(1)===L&&(a=h.slice(0,2),t=2,n>2&&d(h.charCodeAt(2))&&(w=!0,t=3));if(a.length>0)if(o.length>0){if(a.toLowerCase()!==o.toLowerCase())continue}else o=a;if(l){if(o.length>0)break}else if(s=`${h.slice(t)}\\${s}`,l=w,w&&o.length>0)break}return s=b(s,!l,"\\",d),l?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){E(i,"path");const o=i.length;if(o===0)return".";let s=0,l,r=!1;const h=i.charCodeAt(0);if(o===1)return f(h)?"\\":i;if(d(h))if(r=!0,d(i.charCodeAt(1))){let t=2,a=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==a){const w=i.slice(a,t);for(a=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==a){for(a=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return`\\\\${w}\\${i.slice(a)}\\`;t!==a&&(l=`\\\\${w}\\${i.slice(a,t)}`,s=t)}}}else s=1;else p(h)&&i.charCodeAt(1)===L&&(l=i.slice(0,2),s=2,o>2&&d(i.charCodeAt(2))&&(r=!0,s=3));let n=s<o?b(i.slice(s),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(i.charCodeAt(o-1))&&(n+="\\"),l===void 0?r?`\\${n}`:n:r?`${l}\\${n}`:`${l}${n}`},isAbsolute(i){E(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return d(s)||o>2&&p(s)&&i.charCodeAt(1)===L&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let h=0;h<i.length;++h){const n=i[h];E(n,"path"),n.length>0&&(o===void 0?o=s=n:o+=`\\${n}`)}if(o===void 0)return".";let l=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const h=s.length;h>1&&d(s.charCodeAt(1))&&(++r,h>2&&(d(s.charCodeAt(2))?++r:l=!1))}if(l){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(i,o){if(E(i,"from"),E(o,"to"),i===o)return"";const s=e.win32.resolve(i),l=e.win32.resolve(o);if(s===l||(i=s.toLowerCase(),o=l.toLowerCase(),i===o))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===I;)r++;let h=i.length;for(;h-1>r&&i.charCodeAt(h-1)===I;)h--;const n=h-r;let t=0;for(;t<o.length&&o.charCodeAt(t)===I;)t++;let a=o.length;for(;a-1>t&&o.charCodeAt(a-1)===I;)a--;const w=a-t,D=n<w?n:w;let F=-1,x=0;for(;x<D;x++){const M=i.charCodeAt(r+x);if(M!==o.charCodeAt(t+x))break;M===I&&(F=x)}if(x!==D){if(F===-1)return l}else{if(w>D){if(o.charCodeAt(t+x)===I)return l.slice(t+x+1);if(x===2)return l.slice(t+x)}n>D&&(i.charCodeAt(r+x)===I?F=x:x===2&&(F=3)),F===-1&&(F=0)}let V="";for(x=r+F+1;x<=h;++x)(x===h||i.charCodeAt(x)===I)&&(V+=V.length===0?"..":"\\..");return t+=F,V.length>0?`${V}${l.slice(t,a)}`:(l.charCodeAt(t)===I&&++t,l.slice(t,a))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const s=o.charCodeAt(2);if(s!==k&&s!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(p(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return i},dirname(i){E(i,"path");const o=i.length;if(o===0)return".";let s=-1,l=0;const r=i.charCodeAt(0);if(o===1)return d(r)?i:".";if(d(r)){if(s=l=1,d(i.charCodeAt(1))){let t=2,a=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==a){for(a=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==a){for(a=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return i;t!==a&&(s=l=t+1)}}}}else p(r)&&i.charCodeAt(1)===L&&(s=o>2&&d(i.charCodeAt(2))?3:2,l=s);let h=-1,n=!0;for(let t=o-1;t>=l;--t)if(d(i.charCodeAt(t))){if(!n){h=t;break}}else n=!1;if(h===-1){if(s===-1)return".";h=s}return i.slice(0,h)},basename(i,o){o!==void 0&&E(o,"ext"),E(i,"path");let s=0,l=-1,r=!0,h;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(h=i.length-1;h>=s;--h){const a=i.charCodeAt(h);if(d(a)){if(!r){s=h+1;break}}else t===-1&&(r=!1,t=h+1),n>=0&&(a===o.charCodeAt(n)?--n===-1&&(l=h):(n=-1,l=t))}return s===l?l=t:l===-1&&(l=i.length),i.slice(s,l)}for(h=i.length-1;h>=s;--h)if(d(i.charCodeAt(h))){if(!r){s=h+1;break}}else l===-1&&(r=!1,l=h+1);return l===-1?"":i.slice(s,l)},extname(i){E(i,"path");let o=0,s=-1,l=0,r=-1,h=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&p(i.charCodeAt(0))&&(o=l=2);for(let t=i.length-1;t>=o;--t){const a=i.charCodeAt(t);if(d(a)){if(!h){l=t+1;break}continue}r===-1&&(h=!1,r=t+1),a===P?s===-1?s=t:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||r===-1||n===0||n===1&&s===r-1&&s===l+1?"":i.slice(s,r)},format:y.bind(null,"\\"),parse(i){E(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let l=0,r=i.charCodeAt(0);if(s===1)return d(r)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(d(r)){if(l=1,d(i.charCodeAt(1))){let F=2,x=F;for(;F<s&&!d(i.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&d(i.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&!d(i.charCodeAt(F));)F++;F===s?l=F:F!==x&&(l=F+1)}}}}else if(p(r)&&i.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=i,o;if(l=2,d(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;l=3}}l>0&&(o.root=i.slice(0,l));let h=-1,n=l,t=-1,a=!0,w=i.length-1,D=0;for(;w>=l;--w){if(r=i.charCodeAt(w),d(r)){if(!a){n=w+1;break}continue}t===-1&&(a=!1,t=w+1),r===P?h===-1?h=w:D!==1&&(D=1):h!==-1&&(D=-1)}return t!==-1&&(h===-1||D===0||D===1&&h===t-1&&h===n+1?o.base=o.name=i.slice(n,t):(o.name=i.slice(n,h),o.base=i.slice(n,t),o.ext=i.slice(h,t))),n>0&&n!==l?o.dir=i.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(m){const i=/\\/g;return()=>{const o=c.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...i){let o="",s=!1;for(let l=i.length-1;l>=-1&&!s;l--){const r=l>=0?i[l]:g();E(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===S)}return o=b(o,!s,"/",f),s?`/${o}`:o.length>0?o:"."},normalize(i){if(E(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,s=i.charCodeAt(i.length-1)===S;return i=b(i,!o,"/",f),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return E(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const l=i[s];E(l,"path"),l.length>0&&(o===void 0?o=l:o+=`/${l}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(E(i,"from"),E(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const s=1,l=i.length,r=l-s,h=1,n=o.length-h,t=r<n?r:n;let a=-1,w=0;for(;w<t;w++){const F=i.charCodeAt(s+w);if(F!==o.charCodeAt(h+w))break;F===S&&(a=w)}if(w===t)if(n>t){if(o.charCodeAt(h+w)===S)return o.slice(h+w+1);if(w===0)return o.slice(h+w)}else r>t&&(i.charCodeAt(s+w)===S?a=w:w===0&&(a=0));let D="";for(w=s+a+1;w<=l;++w)(w===l||i.charCodeAt(w)===S)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(h+a)}`},toNamespacedPath(i){return i},dirname(i){if(E(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let s=-1,l=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===S){if(!l){s=r;break}}else l=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&E(o,"ext"),E(i,"path");let s=0,l=-1,r=!0,h;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(h=i.length-1;h>=0;--h){const a=i.charCodeAt(h);if(a===S){if(!r){s=h+1;break}}else t===-1&&(r=!1,t=h+1),n>=0&&(a===o.charCodeAt(n)?--n===-1&&(l=h):(n=-1,l=t))}return s===l?l=t:l===-1&&(l=i.length),i.slice(s,l)}for(h=i.length-1;h>=0;--h)if(i.charCodeAt(h)===S){if(!r){s=h+1;break}}else l===-1&&(r=!1,l=h+1);return l===-1?"":i.slice(s,l)},extname(i){E(i,"path");let o=-1,s=0,l=-1,r=!0,h=0;for(let n=i.length-1;n>=0;--n){const t=i.charCodeAt(n);if(t===S){if(!r){s=n+1;break}continue}l===-1&&(r=!1,l=n+1),t===P?o===-1?o=n:h!==1&&(h=1):o!==-1&&(h=-1)}return o===-1||l===-1||h===0||h===1&&o===l-1&&o===s+1?"":i.slice(o,l)},format:y.bind(null,"/"),parse(i){E(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===S;let l;s?(o.root="/",l=1):l=0;let r=-1,h=0,n=-1,t=!0,a=i.length-1,w=0;for(;a>=l;--a){const D=i.charCodeAt(a);if(D===S){if(!t){h=a+1;break}continue}n===-1&&(t=!1,n=a+1),D===P?r===-1?r=a:w!==1&&(w=1):r!==-1&&(w=-1)}if(n!==-1){const D=h===0&&s?1:h;r===-1||w===0||w===1&&r===n-1&&r===h+1?o.base=o.name=i.slice(D,n):(o.name=i.slice(D,r),o.base=i.slice(D,n),o.ext=i.slice(r,n))}return h>0?o.dir=i.slice(0,h-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(ye[103],De([1,0,66,9]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new c.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(t,a,w=!1){const D=t||"",F=a||"",x=u.value.collator.compare(D,F);return u.value.collatorIsNumeric&&x===0&&D!==F?D<F?-1:1:x}e.compareFileNames=P;function S(t,a){const w=R.value.collator;return t=t||"",a=a||"",y(w,t,a)}e.compareFileNamesDefault=S;function I(t,a){const w=R.value.collator;return t=t||"",a=a||"",s(t,a)||y(w,t,a)}e.compareFileNamesUpper=I;function L(t,a){const w=R.value.collator;return t=t||"",a=a||"",o(t,a)||y(w,t,a)}e.compareFileNamesLower=L;function k(t,a){return t=t||"",a=a||"",t===a?0:t<a?-1:1}e.compareFileNamesUnicode=k;function v(t,a){const[w,D]=p(t),[F,x]=p(a);let V=u.value.collator.compare(D,x);if(V===0){if(u.value.collatorIsNumeric&&D!==x)return D<x?-1:1;if(V=u.value.collator.compare(w,F),u.value.collatorIsNumeric&&V===0&&w!==F)return w<F?-1:1}return V}e.compareFileExtensions=v;function T(t,a){t=t||"",a=a||"";const w=b(t),D=b(a),F=R.value.collator,x=C.value.collator;return y(x,w,D)||y(F,t,a)}e.compareFileExtensionsDefault=T;function E(t,a){t=t||"",a=a||"";const w=b(t),D=b(a),F=R.value.collator,x=C.value.collator;return y(x,w,D)||s(t,a)||y(F,t,a)}e.compareFileExtensionsUpper=E;function m(t,a){t=t||"",a=a||"";const w=b(t),D=b(a),F=R.value.collator,x=C.value.collator;return y(x,w,D)||o(t,a)||y(F,t,a)}e.compareFileExtensionsLower=m;function d(t,a){t=t||"",a=a||"";const w=b(t).toLowerCase(),D=b(a).toLowerCase();return w!==D?w<D?-1:1:t!==a?t<a?-1:1:0}e.compareFileExtensionsUnicode=d;const f=/^(.*?)(\.([^.]*))?$/;function p(t,a=!1){const w=t?f.exec(t):[];let D=[w&&w[1]||"",w&&w[3]||""];return a&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function b(t){const a=t?f.exec(t):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function y(t,a,w){const D=t.compare(a,w);return D!==0?D:a.length!==w.length?a.length<w.length?-1:1:0}function g(t){const a=t.charAt(0);return a.toLocaleUpperCase()!==a}function i(t){const a=t.charAt(0);return a.toLocaleLowerCase()!==a}function o(t,a){return g(t)&&i(a)?-1:i(t)&&g(a)?1:0}function s(t,a){return i(t)&&g(a)?-1:g(t)&&i(a)?1:0}function l(t,a,w=!1){return w||(t=t&&t.toLowerCase(),a=a&&a.toLowerCase()),t===a?0:t<a?-1:1}function r(t,a,w=!1){const D=t.split(A.sep),F=a.split(A.sep),x=D.length-1,V=F.length-1;let M,$;for(let O=0;;O++){if(M=x===O,$=V===O,M&&$)return P(D[O],F[O],w);if(M)return-1;if($)return 1;const U=l(D[O],F[O],w);if(U!==0)return U}}e.comparePaths=r;function h(t,a,w){const D=t.toLowerCase(),F=a.toLowerCase(),x=n(t,a,w);if(x)return x;const V=D.endsWith(w),M=F.endsWith(w);if(V!==M)return V?-1:1;const $=P(D,F);return $!==0?$:D.localeCompare(F)}e.compareAnything=h;function n(t,a,w){const D=t.toLowerCase(),F=a.toLowerCase(),x=D.startsWith(w),V=F.startsWith(w);if(x!==V)return x?-1:1;if(x&&V){if(D.length<F.length)return-1;if(D.length>F.length)return 1}return 0}e.compareByPrefix=n}),define(ye[87],De([1,0,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const k=(0,c.extname)(L),v=A[k.toLowerCase()];return v!==void 0?v:C(L)}e.getMediaOrTextMime=R;function C(L){const k=(0,c.extname)(L);return u[k.toLowerCase()]}e.getMediaMime=C;function P(L){for(const k in u)if(u[k]===L)return k}e.getExtensionForMimeType=P;const S=/^(.+)\/(.+?)(;.+)?$/;function I(L,k){const v=S.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:k?void 0:L}e.normalizeMimeType=I}),define(ye[104],De([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var u;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(u=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...S){const I=S.reduce((v,T)=>(v[T]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(v=>!I[v]).forEach(v=>{for(let T=0;T<L.length;T++)if(v.search(L[T])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=R;function C(P){!P||(delete P.DEBUG,c.isMacintosh&&delete P.DYLD_LIBRARY_PATH,c.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var A in c)(typeof exports=="object"?exports:ne)[A]=c[A]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function c(A){if(e[A])return e[A].exports;var u=e[A]={i:A,l:!1,exports:{}};return ne[A].call(u.exports,u,u.exports,c),u.l=!0,u.exports}return c.m=ne,c.c=e,c.d=function(A,u,R){c.o(A,u)||Object.defineProperty(A,u,{enumerable:!0,get:R})},c.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},c.t=function(A,u){if(1&u&&(A=c(A)),8&u||4&u&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(c.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&u&&typeof A!="string")for(var C in A)c.d(R,C,function(P){return A[P]}.bind(null,C));return R},c.n=function(A){var u=A&&A.__esModule?function(){return A.default}:function(){return A};return c.d(u,"a",u),u},c.o=function(A,u){return Object.prototype.hasOwnProperty.call(A,u)},c.p="",c(c.s=0)}([function(ne,e,c){(function(A){var u;e=ne.exports=J,u=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],I=0,L=I++;S[L]="0|[1-9]\\d*";var k=I++;S[k]="[0-9]+";var v=I++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;S[T]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var E=I++;S[E]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var m=I++;S[m]="(?:"+S[L]+"|"+S[v]+")";var d=I++;S[d]="(?:"+S[k]+"|"+S[v]+")";var f=I++;S[f]="(?:-("+S[m]+"(?:\\."+S[m]+")*))";var p=I++;S[p]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var b=I++;S[b]="[0-9A-Za-z-]+";var y=I++;S[y]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var g=I++,i="v?"+S[T]+S[f]+"?"+S[y]+"?";S[g]="^"+i+"$";var o="[v=\\s]*"+S[E]+S[p]+"?"+S[y]+"?",s=I++;S[s]="^"+o+"$";var l=I++;S[l]="((?:<|>)?=?)";var r=I++;S[r]=S[k]+"|x|X|\\*";var h=I++;S[h]=S[L]+"|x|X|\\*";var n=I++;S[n]="[v=\\s]*("+S[h]+")(?:\\.("+S[h]+")(?:\\.("+S[h]+")(?:"+S[f]+")?"+S[y]+"?)?)?";var t=I++;S[t]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[p]+")?"+S[y]+"?)?)?";var a=I++;S[a]="^"+S[l]+"\\s*"+S[n]+"$";var w=I++;S[w]="^"+S[l]+"\\s*"+S[t]+"$";var D=I++;S[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=I++;S[F]="(?:~>?)";var x=I++;S[x]="(\\s*)"+S[F]+"\\s+",P[x]=new RegExp(S[x],"g");var V=I++;S[V]="^"+S[F]+S[n]+"$";var M=I++;S[M]="^"+S[F]+S[t]+"$";var $=I++;S[$]="(?:\\^)";var O=I++;S[O]="(\\s*)"+S[$]+"\\s+",P[O]=new RegExp(S[O],"g");var U=I++;S[U]="^"+S[$]+S[n]+"$";var B=I++;S[B]="^"+S[$]+S[t]+"$";var j=I++;S[j]="^"+S[l]+"\\s*("+o+")$|^$";var de=I++;S[de]="^"+S[l]+"\\s*("+i+")$|^$";var Y=I++;S[Y]="(\\s*)"+S[l]+"\\s*("+o+"|"+S[n]+")",P[Y]=new RegExp(S[Y],"g");var q=I++;S[q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Q=I++;S[Q]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var Z=I++;S[Z]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)u(te,S[te]),P[te]||(P[te]=new RegExp(S[te]));function X(be,Ce){if(be instanceof J)return be;if(typeof be!="string"||be.length>R||!(Ce?P[s]:P[g]).test(be))return null;try{return new J(be,Ce)}catch{return null}}function J(be,Ce){if(be instanceof J){if(be.loose===Ce)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof J))return new J(be,Ce);u("SemVer",be,Ce),this.loose=Ce;var Te=be.trim().match(Ce?P[s]:P[g]);if(!Te)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+Te[1],this.minor=+Te[2],this.patch=+Te[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Te[4]?this.prerelease=Te[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var xe=+Ve;if(xe>=0&&xe<C)return xe}return Ve}):this.prerelease=[],this.build=Te[5]?Te[5].split("."):[],this.format()}e.parse=X,e.valid=function(be,Ce){var Te=X(be,Ce);return Te?Te.version:null},e.clean=function(be,Ce){var Te=X(be.trim().replace(/^[=v]+/,""),Ce);return Te?Te.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(be){return u("SemVer.compare",this.version,this.loose,be),be instanceof J||(be=new J(be,this.loose)),this.compareMain(be)||this.comparePre(be)},J.prototype.compareMain=function(be){return be instanceof J||(be=new J(be,this.loose)),pe(this.major,be.major)||pe(this.minor,be.minor)||pe(this.patch,be.patch)},J.prototype.comparePre=function(be){if(be instanceof J||(be=new J(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ce=0;do{var Te=this.prerelease[Ce],Ve=be.prerelease[Ce];if(u("prerelease compare",Ce,Te,Ve),Te===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(Te===void 0)return-1;if(Te!==Ve)return pe(Te,Ve)}while(++Ce)},J.prototype.inc=function(be,Ce){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Te=this.prerelease.length;--Te>=0;)typeof this.prerelease[Te]=="number"&&(this.prerelease[Te]++,Te=-2);Te===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ce,Te,Ve){typeof Te=="string"&&(Ve=Te,Te=void 0);try{return new J(be,Te).inc(Ce,Ve).version}catch{return null}},e.diff=function(be,Ce){if(oe(be,Ce))return null;var Te=X(be),Ve=X(Ce);if(Te.prerelease.length||Ve.prerelease.length){for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return"pre"+xe;return"prerelease"}for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return xe},e.compareIdentifiers=pe;var ie=/^[0-9]+$/;function pe(be,Ce){var Te=ie.test(be),Ve=ie.test(Ce);return Te&&Ve&&(be=+be,Ce=+Ce),Te&&!Ve?-1:Ve&&!Te?1:be<Ce?-1:be>Ce?1:0}function ve(be,Ce,Te){return new J(be,Te).compare(new J(Ce,Te))}function ke(be,Ce,Te){return ve(be,Ce,Te)>0}function Oe(be,Ce,Te){return ve(be,Ce,Te)<0}function oe(be,Ce,Te){return ve(be,Ce,Te)===0}function ae(be,Ce,Te){return ve(be,Ce,Te)!==0}function fe(be,Ce,Te){return ve(be,Ce,Te)>=0}function ee(be,Ce,Te){return ve(be,Ce,Te)<=0}function le(be,Ce,Te,Ve){var xe;switch(Ce){case"===":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),xe=be===Te;break;case"!==":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),xe=be!==Te;break;case"":case"=":case"==":xe=oe(be,Te,Ve);break;case"!=":xe=ae(be,Te,Ve);break;case">":xe=ke(be,Te,Ve);break;case">=":xe=fe(be,Te,Ve);break;case"<":xe=Oe(be,Te,Ve);break;case"<=":xe=ee(be,Te,Ve);break;default:throw new TypeError("Invalid operator: "+Ce)}return xe}function re(be,Ce){if(be instanceof re){if(be.loose===Ce)return be;be=be.value}if(!(this instanceof re))return new re(be,Ce);u("comparator",be,Ce),this.loose=Ce,this.parse(be),this.semver===N?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(be,Ce){return pe(Ce,be)},e.major=function(be,Ce){return new J(be,Ce).major},e.minor=function(be,Ce){return new J(be,Ce).minor},e.patch=function(be,Ce){return new J(be,Ce).patch},e.compare=ve,e.compareLoose=function(be,Ce){return ve(be,Ce,!0)},e.rcompare=function(be,Ce,Te){return ve(Ce,be,Te)},e.sort=function(be,Ce){return be.sort(function(Te,Ve){return e.compare(Te,Ve,Ce)})},e.rsort=function(be,Ce){return be.sort(function(Te,Ve){return e.rcompare(Te,Ve,Ce)})},e.gt=ke,e.lt=Oe,e.eq=oe,e.neq=ae,e.gte=fe,e.lte=ee,e.cmp=le,e.Comparator=re;var N={};function W(be,Ce){if(be instanceof W)return be.loose===Ce?be:new W(be.raw,Ce);if(be instanceof re)return new W(be.value,Ce);if(!(this instanceof W))return new W(be,Ce);if(this.loose=Ce,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(Te){return this.parseRange(Te.trim())},this).filter(function(Te){return Te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function K(be){return!be||be.toLowerCase()==="x"||be==="*"}function _(be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce){return((Ce=K(Te)?"":K(Ve)?">="+Te+".0.0":K(xe)?">="+Te+"."+Ve+".0":">="+Ce)+" "+(nt=K(st)?"":K(ht)?"<"+(+st+1)+".0.0":K(Ue)?"<"+st+"."+(+ht+1)+".0":rt?"<="+st+"."+ht+"."+Ue+"-"+rt:"<="+nt)).trim()}function he(be,Ce){for(var Te=0;Te<be.length;Te++)if(!be[Te].test(Ce))return!1;if(Ce.prerelease.length){for(Te=0;Te<be.length;Te++)if(u(be[Te].semver),be[Te].semver!==N&&be[Te].semver.prerelease.length>0){var Ve=be[Te].semver;if(Ve.major===Ce.major&&Ve.minor===Ce.minor&&Ve.patch===Ce.patch)return!0}return!1}return!0}function we(be,Ce,Te){try{Ce=new W(Ce,Te)}catch{return!1}return Ce.test(be)}function Ae(be,Ce,Te,Ve){var xe,et,Qe,nt,st;switch(be=new J(be,Ve),Ce=new W(Ce,Ve),Te){case">":xe=ke,et=ee,Qe=Oe,nt=">",st=">=";break;case"<":xe=Oe,et=fe,Qe=ke,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ce,Ve))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Ue=Ce.set[ht],rt=null,ce=null;if(Ue.forEach(function(z){z.semver===N&&(z=new re(">=0.0.0")),rt=rt||z,ce=ce||z,xe(z.semver,rt.semver,Ve)?rt=z:Qe(z.semver,ce.semver,Ve)&&(ce=z)}),rt.operator===nt||rt.operator===st||(!ce.operator||ce.operator===nt)&&et(be,ce.semver)||ce.operator===st&&Qe(be,ce.semver))return!1}return!0}re.prototype.parse=function(be){var Ce=this.loose?P[j]:P[de],Te=be.match(Ce);if(!Te)throw new TypeError("Invalid comparator: "+be);this.operator=Te[1],this.operator==="="&&(this.operator=""),Te[2]?this.semver=new J(Te[2],this.loose):this.semver=N},re.prototype.toString=function(){return this.value},re.prototype.test=function(be){return u("Comparator.test",be,this.loose),this.semver===N||(typeof be=="string"&&(be=new J(be,this.loose)),le(be,this.operator,this.semver,this.loose))},re.prototype.intersects=function(be,Ce){if(!(be instanceof re))throw new TypeError("a Comparator is required");var Te;if(this.operator==="")return Te=new W(be.value,Ce),we(this.value,Te,Ce);if(be.operator==="")return Te=new W(this.value,Ce),we(be.semver,Te,Ce);var Ve=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),et=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),nt=le(this.semver,"<",be.semver,Ce)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),st=le(this.semver,">",be.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return Ve||xe||et&&Qe||nt||st},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(be){var Ce=this.loose;be=be.trim(),u("range",be,Ce);var Te=Ce?P[Q]:P[q];be=be.replace(Te,_),u("hyphen replace",be),be=be.replace(P[Y],"$1$2$3"),u("comparator trim",be,P[Y]),be=(be=(be=be.replace(P[x],"$1~")).replace(P[O],"$1^")).split(/\s+/).join(" ");var Ve=Ce?P[j]:P[de],xe=be.split(" ").map(function(et){return function(Qe,nt){return u("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ce){u("caret",rt,ce);var z=ce?P[B]:P[U];return rt.replace(z,function(ue,Ie,Le,$e,Ke){var Ze;return u("caret",rt,ue,Ie,Le,$e,Ke),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K($e)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Ke?(u("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+Ke+" <"+(+Ie+1)+".0.0"):(u("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+" <"+(+Ie+1)+".0.0"),u("caret return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),u("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ce){var z=ce?P[M]:P[V];return rt.replace(z,function(ue,Ie,Le,$e,Ke){var Ze;return u("tilde",rt,ue,Ie,Le,$e,Ke),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K($e)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Ke?(u("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0",u("tilde return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),u("tildes",Qe),Qe=function(st,ht){return u("replaceXRanges",st,ht),st.split(/\s+/).map(function(Ue){return function(rt,ce){rt=rt.trim();var z=ce?P[w]:P[a];return rt.replace(z,function(ue,Ie,Le,$e,Ke,Ze){u("xRange",rt,ue,Ie,Le,$e,Ke,Ze);var pt=K(Le),gt=pt||K($e),ct=gt||K(Ke);return Ie==="="&&ct&&(Ie=""),pt?ue=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&ct?(gt&&($e=0),ct&&(Ke=0),Ie===">"?(Ie=">=",gt?(Le=+Le+1,$e=0,Ke=0):ct&&($e=+$e+1,Ke=0)):Ie==="<="&&(Ie="<",gt?Le=+Le+1:$e=+$e+1),ue=Ie+Le+"."+$e+"."+Ke):gt?ue=">="+Le+".0.0 <"+(+Le+1)+".0.0":ct&&(ue=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0"),u("xRange return",ue),ue})}(Ue,ht)}).join(" ")}(Qe,nt),u("xrange",Qe),Qe=function(st,ht){return u("replaceStars",st,ht),st.trim().replace(P[Z],"")}(Qe,nt),u("stars",Qe),Qe}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(et){return!!et.match(Ve)})),xe=xe.map(function(et){return new re(et,Ce)})},W.prototype.intersects=function(be,Ce){if(!(be instanceof W))throw new TypeError("a Range is required");return this.set.some(function(Te){return Te.every(function(Ve){return be.set.some(function(xe){return xe.every(function(et){return Ve.intersects(et,Ce)})})})})},e.toComparators=function(be,Ce){return new W(be,Ce).set.map(function(Te){return Te.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},W.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new J(be,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(he(this.set[Ce],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ce,Te){var Ve=null,xe=null;try{var et=new W(Ce,Te)}catch{return null}return be.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==-1||(xe=new J(Ve=Qe,Te)))}),Ve},e.minSatisfying=function(be,Ce,Te){var Ve=null,xe=null;try{var et=new W(Ce,Te)}catch{return null}return be.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==1||(xe=new J(Ve=Qe,Te)))}),Ve},e.validRange=function(be,Ce){try{return new W(be,Ce).range||"*"}catch{return null}},e.ltr=function(be,Ce,Te){return Ae(be,Ce,"<",Te)},e.gtr=function(be,Ce,Te){return Ae(be,Ce,">",Te)},e.outside=Ae,e.prerelease=function(be,Ce){var Te=X(be,Ce);return Te&&Te.prerelease.length?Te.prerelease:null},e.intersects=function(be,Ce,Te){return be=new W(be,Te),Ce=new W(Ce,Te),be.intersects(Ce)},e.coerce=function(be){if(be instanceof J)return be;if(typeof be!="string")return null;var Ce=be.match(P[D]);return Ce==null?null:X((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,c(1))},function(ne,e){var c,A,u=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(d){if(c===setTimeout)return setTimeout(d,0);if((c===R||!c)&&setTimeout)return c=setTimeout,setTimeout(d,0);try{return c(d,0)}catch{try{return c.call(null,d,0)}catch{return c.call(this,d,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:R}catch{c=R}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var S,I=[],L=!1,k=-1;function v(){L&&S&&(L=!1,S.length?I=S.concat(I):k=-1,I.length&&T())}function T(){if(!L){var d=P(v);L=!0;for(var f=I.length;f;){for(S=I,I=[];++k<f;)S&&S[k].run();k=-1,f=I.length}S=null,L=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch{try{return A.call(null,p)}catch{return A.call(this,p)}}}(d)}}function E(d,f){this.fun=d,this.array=f}function m(){}u.nextTick=function(d){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];I.push(new E(d,f)),I.length!==1||L||P(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=m,u.addListener=m,u.once=m,u.off=m,u.removeListener=m,u.removeAllListeners=m,u.emit=m,u.prependListener=m,u.prependOnceListener=m,u.listeners=function(d){return[]},u.binding=function(d){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(d){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(ye[43],De([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=c.globals.performance&&typeof c.globals.performance.now=="function";class u{static create(C=!0){return new u(C)}constructor(C){this.a=A&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=u}),define(ye[3],De([1,0,11,64,6,67,43]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,S=!1;var I;(function(h){h.None=()=>u.Disposable.None;function n(ve){if(S){const{onDidAddListener:ke}=ve,Oe=E.create();let oe=0;ve.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),ke?.()}}}function t(ve,ke){return O(ve,()=>{},0,void 0,void 0,ke)}h.defer=t;function a(ve){return(ke,Oe=null,oe)=>{let ae=!1,fe;return fe=ve(ee=>{if(!ae)return fe?fe.dispose():ae=!0,ke.call(Oe,ee)},null,oe),ae&&fe.dispose(),fe}}h.once=a;function w(ve,ke,Oe){return $((oe,ae=null,fe)=>ve(ee=>oe.call(ae,ke(ee)),null,fe),Oe)}h.map=w;function D(ve,ke,Oe){return $((oe,ae=null,fe)=>ve(ee=>{ke(ee),oe.call(ae,ee)},null,fe),Oe)}h.forEach=D;function F(ve,ke,Oe){return $((oe,ae=null,fe)=>ve(ee=>ke(ee)&&oe.call(ae,ee),null,fe),Oe)}h.filter=F;function x(ve){return ve}h.signal=x;function V(...ve){return(ke,Oe=null,oe)=>(0,u.combinedDisposable)(...ve.map(ae=>ae(fe=>ke.call(Oe,fe),null,oe)))}h.any=V;function M(ve,ke,Oe,oe){let ae=Oe;return w(ve,fe=>(ae=ke(ae,fe),ae),oe)}h.reduce=M;function $(ve,ke){let Oe;const oe={onWillAddFirstListener(){Oe=ve(ae.fire,ae)},onDidRemoveLastListener(){Oe?.dispose()}};ke||n(oe);const ae=new d(oe);return ke?.add(ae),ae.event}function O(ve,ke,Oe=100,oe=!1,ae,fe){let ee,le,re,N=0;const W={leakWarningThreshold:ae,onWillAddFirstListener(){ee=ve(_=>{N++,le=ke(le,_),oe&&!re&&(K.fire(le),le=void 0);const he=()=>{const we=le;le=void 0,re=void 0,(!oe||N>1)&&K.fire(we),N=0};typeof Oe=="number"?(clearTimeout(re),re=setTimeout(he,Oe)):re===void 0&&(re=0,queueMicrotask(he))})},onDidRemoveLastListener(){ee.dispose()}};fe||n(W);const K=new d(W);return fe?.add(K),K.event}h.debounce=O;function U(ve,ke=0,Oe){return h.debounce(ve,(oe,ae)=>oe?(oe.push(ae),oe):[ae],ke,void 0,void 0,Oe)}h.accumulate=U;function B(ve,ke=(oe,ae)=>oe===ae,Oe){let oe=!0,ae;return F(ve,fe=>{const ee=oe||!ke(fe,ae);return oe=!1,ae=fe,ee},Oe)}h.latch=B;function j(ve,ke,Oe){return[h.filter(ve,ke,Oe),h.filter(ve,oe=>!ke(oe),Oe)]}h.split=j;function de(ve,ke=!1,Oe=[]){let oe=Oe.slice(),ae=ve(le=>{oe?oe.push(le):ee.fire(le)});const fe=()=>{oe?.forEach(le=>ee.fire(le)),oe=null},ee=new d({onWillAddFirstListener(){ae||(ae=ve(le=>ee.fire(le)))},onDidAddFirstListener(){oe&&(ke?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return ee.event}h.buffer=de;class Y{constructor(ke){this.event=ke,this.c=new u.DisposableStore}map(ke){return new Y(w(this.event,ke,this.c))}forEach(ke){return new Y(D(this.event,ke,this.c))}filter(ke){return new Y(F(this.event,ke,this.c))}reduce(ke,Oe){return new Y(M(this.event,ke,Oe,this.c))}latch(){return new Y(B(this.event,void 0,this.c))}debounce(ke,Oe=100,oe=!1,ae){return new Y(O(this.event,ke,Oe,oe,ae,this.c))}on(ke,Oe,oe){return this.event(ke,Oe,oe)}once(ke,Oe,oe){return a(this.event)(ke,Oe,oe)}dispose(){this.c.dispose()}}function q(ve){return new Y(ve)}h.chain=q;function Q(ve,ke,Oe=oe=>oe){const oe=(...le)=>ee.fire(Oe(...le)),ae=()=>ve.on(ke,oe),fe=()=>ve.removeListener(ke,oe),ee=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}h.fromNodeEventEmitter=Q;function Z(ve,ke,Oe=oe=>oe){const oe=(...le)=>ee.fire(Oe(...le)),ae=()=>ve.addEventListener(ke,oe),fe=()=>ve.removeEventListener(ke,oe),ee=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}h.fromDOMEventEmitter=Z;function te(ve){return new Promise(ke=>a(ve)(ke))}h.toPromise=te;function X(ve,ke){return ke(void 0),ve(Oe=>ke(Oe))}h.runAndSubscribe=X;function J(ve,ke){let Oe=null;function oe(fe){Oe?.dispose(),Oe=new u.DisposableStore,ke(fe,Oe)}oe(void 0);const ae=ve(fe=>oe(fe));return(0,u.toDisposable)(()=>{ae.dispose(),Oe?.dispose()})}h.runAndSubscribeWithStore=J;class ie{constructor(ke,Oe){this.obs=ke,this.c=0,this.d=!1;const oe={onWillAddFirstListener:()=>{ke.addObserver(this)},onDidRemoveLastListener:()=>{ke.removeObserver(this)}};Oe||n(oe),this.emitter=new d(oe),Oe&&Oe.add(this.emitter)}beginUpdate(ke){this.c++}handleChange(ke,Oe){this.d=!0}endUpdate(ke){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function pe(ve,ke){return new ie(ve,ke).emitter.event}h.fromObservable=pe})(I=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new C.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let k=-1;function v(h){const n=k;return k=h,{dispose(){k=n}}}e.setGlobalLeakWarningThreshold=v;class T{constructor(n,t=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=t,this.d=0}dispose(){this.c?.clear()}check(n,t){const a=this.threshold;if(a<=0||t<a)return;this.c||(this.c=new Map);const w=this.c.get(n.value)||0;if(this.c.set(n.value,w+1),this.d-=1,this.d<=0){this.d=a*.5;let D,F=0;for(const[x,V]of this.c)(!D||F<V)&&(D=x,F=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${F}):`),console.warn(D)}return()=>{const D=this.c.get(n.value)||0;this.c.set(n.value,D-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(n,t,a){this.callback=n,this.callbackThis=t,this.stack=a,this.subscription=new u.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class d{constructor(n){this.j=!1,this.d=n,this.f=k>0||this.d?.leakWarningThreshold?new T(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const n=Array.from(this.q);queueMicrotask(()=>{for(const t of n)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,t,a)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let D,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=E.create(),D=this.f.check(F,this.q.size+1)),P&&(F=F??E.create());const x=new m(n,t,F),V=this.q.push(x);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,t);const M=x.subscription.set(()=>{D?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return a instanceof u.DisposableStore?a.add(M):Array.isArray(a)&&a.push(M),M}),this.l}fire(n){if(this.q){this.m||(this.m=new p);for(const t of this.q)this.m.push(this,t,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class f{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,t,a){this.c.push(new b(n,t,a))}clear(n){const t=new R.LinkedList;for(const a of this.c)a.emitter!==n&&t.push(a);this.c=t}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(t){(0,c.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=f;class p extends f{clear(n){this.c.clear()}}class b{constructor(n,t,a){this.emitter=n,this.listener=t,this.event=a}}class y extends d{async fireAsync(n,t,a){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const w of this.q)this.c.push([w,n]);for(;this.c.size>0&&!t.isCancellationRequested;){const[w,D]=this.c.shift(),F=[],x={...D,token:t,waitUntil:V=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");a&&(V=a(V,w.callback)),F.push(V)}};try{w.invoke(x)}catch(V){(0,c.onUnexpectedError)(V);continue}Object.freeze(F),await Promise.allSettled(F).then(V=>{for(const M of V)M.status==="rejected"&&(0,c.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=y;class g extends d{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=g;class i extends g{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class o extends d{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const t={event:n,listener:null};this.f.push(t),this.d&&this.j(t);const a=()=>{this.d&&this.k(t);const w=this.f.indexOf(t);this.f.splice(w,1)};return(0,u.toDisposable)((0,A.once)(a))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(t=>this.c.fire(t))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class l{constructor(){this.c=[]}wrapEvent(n){return(t,a,w)=>n(D=>{const F=this.c[this.c.length-1];F?F.push(()=>t.call(a,D)):t.call(a,D)},void 0,w)}bufferEvents(n){const t=[];this.c.push(t);const a=n();return this.c.pop(),t.forEach(w=>w()),a}}e.EventBufferer=l;class r{constructor(){this.c=!1,this.d=I.None,this.f=u.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ye[21],De([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,S){const I=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(I)}}});var u;(function(P){function S(I){return I===P.None||I===P.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(u=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=u.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=u.None}}e.CancellationTokenSource=C}),define(ye[148],De([1,0,21]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new c.CancellationTokenSource,S=this.b(P.token);return this.a={promise:S,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class u{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const S=JSON.stringify(P);return this.b!==S&&(this.b=S,this.a=this.c(P)),this.a}}e.LRUCachedFunction=u;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const S=this.b(P);return this.a.set(P,S),S}}e.CachedFunction=R}),define(ye[105],De([1,0,11,6]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(y){const g=y;return g?typeof g.read=="function":!1}e.isReadable=u;function R(y){const g=y;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function C(y){const g=y;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(y,g){return new S(y,g)}e.newWriteableStream=P;class S{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,c.onUnexpectedError)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let o;switch(g){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function I(y,g){const i=[];let o;for(;(o=y.read())!==null;)i.push(o);return g(i)}e.consumeReadable=I;function L(y,g,i){const o=[];let s;for(;(s=y.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?g(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return y.read()}}}e.peekReadable=L;function k(y,g){return new Promise((i,o)=>{const s=[];v(y,{onData:l=>{g&&s.push(l)},onError:l=>{g?o(l):i(void 0)},onEnd:()=>{i(g?g(s):void 0)}})})}e.consumeStream=k;function v(y,g){let i=!1;return y.on("error",o=>{i||g.onError(o)}),y.on("end",()=>{i||g.onEnd()}),y.on("data",o=>{i||g.onData(o)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=v;function T(y,g){return new Promise((i,o)=>{const s=new A.DisposableStore,l=[],r=t=>{if(l.push(t),l.length>g)return s.dispose(),y.pause(),i({stream:y,buffer:l,ended:!1})},h=t=>o(t),n=()=>i({stream:y,buffer:l,ended:!0});s.add((0,A.toDisposable)(()=>y.removeListener("error",h))),y.on("error",h),s.add((0,A.toDisposable)(()=>y.removeListener("end",n))),y.on("end",n),s.add((0,A.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=T;function E(y,g){const i=P(g);return i.end(y),i}e.toStream=E;function m(){const y=P(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=m;function d(y){let g=!1;return{read:()=>g?null:(g=!0,y)}}e.toReadable=d;function f(y,g,i){const o=P(i);return v(y,{onData:s=>o.write(g.data(s)),onError:s=>o.error(g.error?g.error(s):s),onEnd:()=>o.end()}),o}e.transform=f;function p(y,g,i){let o=!1;return{read:()=>{const s=g.read();return o?s:(o=!0,s!==null?i([y,s]):y)}}}e.prefixedReadable=p;function b(y,g,i){let o=!1;const s=P(i);return v(g,{onData:l=>o?s.write(l):(o=!0,s.write(i([y,l]))),onError:l=>s.error(l),onEnd:()=>{o||(o=!0,s.write(y)),s.end()}}),s}e.prefixedStream=b}),define(ye[22],De([1,0,105]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let u,R;class C{static alloc(t){return A?new C(Buffer.allocUnsafe(t)):new C(new Uint8Array(t))}static wrap(t){return A&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new C(t)}static fromString(t,a){return!(a?.dontUseNodeBuffer||!1)&&A?new C(Buffer.from(t)):(u||(u=new TextEncoder),new C(u.encode(t)))}static fromByteArray(t){const a=C.alloc(t.length);for(let w=0,D=t.length;w<D;w++)a.buffer[w]=t[w];return a}static concat(t,a){if(typeof a>"u"){a=0;for(let F=0,x=t.length;F<x;F++)a+=t[F].byteLength}const w=C.alloc(a);let D=0;for(let F=0,x=t.length;F<x;F++){const V=t[F];w.set(V,D),D+=V.byteLength}return w}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=C.alloc(this.byteLength);return t.set(this),t}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,a){return new C(this.buffer.subarray(t,a))}set(t,a){if(t instanceof C)this.buffer.set(t.buffer,a);else if(t instanceof Uint8Array)this.buffer.set(t,a);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),a);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),a);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,a){L(this.buffer,t,a)}readUInt32LE(t){return k(this.buffer,t)}writeUInt32LE(t,a){v(this.buffer,t,a)}readUInt8(t){return T(this.buffer,t)}writeUInt8(t,a){E(this.buffer,t,a)}}e.VSBuffer=C;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function S(n,t,a){n[a+0]=t&255,t=t>>>8,n[a+1]=t&255}e.writeUInt16LE=S;function I(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=I;function L(n,t,a){n[a+3]=t,t=t>>>8,n[a+2]=t,t=t>>>8,n[a+1]=t,t=t>>>8,n[a]=t}e.writeUInt32BE=L;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=k;function v(n,t,a){n[a+0]=t&255,t=t>>>8,n[a+1]=t&255,t=t>>>8,n[a+2]=t&255,t=t>>>8,n[a+3]=t&255}e.writeUInt32LE=v;function T(n,t){return n[t]}e.readUInt8=T;function E(n,t,a){n[a]=t}e.writeUInt8=E;function m(n){return c.consumeReadable(n,t=>C.concat(t))}e.readableToBuffer=m;function d(n){return c.toReadable(n)}e.bufferToReadable=d;function f(n){return c.consumeStream(n,t=>C.concat(t))}e.streamToBuffer=f;async function p(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await f(n.stream)])}e.bufferedStreamToBuffer=p;function b(n){return c.toStream(n,t=>C.concat(t))}e.bufferToStream=b;function y(n){return c.transform(n,{data:t=>typeof t=="string"?C.fromString(t):C.wrap(t)},t=>C.concat(t))}e.streamToBufferReadableStream=y;function g(n){return c.newWriteableStream(t=>C.concat(t),n)}e.newWriteableBufferStream=g;function i(n,t){return c.prefixedReadable(n,t,a=>C.concat(a))}e.prefixedBufferReadable=i;function o(n,t){return c.prefixedStream(n,t,a=>C.concat(a))}e.prefixedBufferStream=o;function s(n){let t=0,a=0,w=0;const D=new Uint8Array(Math.floor(n.length/4*3)),F=V=>{switch(a){case 3:D[w++]=t|V,a=0;break;case 2:D[w++]=t|V>>>2,t=V<<6,a=3;break;case 1:D[w++]=t|V>>>4,t=V<<4,a=2;break;default:t=V<<2,a=1}};for(let V=0;V<n.length;V++){const M=n.charCodeAt(V);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const x=w;for(;a>0;)F(0);return C.wrap(D).slice(0,x)}e.decodeBase64=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:n},t=!0,a=!1){const w=a?r:l;let D="";const F=n.byteLength%3;let x=0;for(;x<n.byteLength-F;x+=3){const V=n[x+0],M=n[x+1],$=n[x+2];D+=w[V>>>2],D+=w[(V<<4|M>>>4)&63],D+=w[(M<<2|$>>>6)&63],D+=w[$&63]}if(F===1){const V=n[x+0];D+=w[V>>>2],D+=w[V<<4&63],t&&(D+="==")}else if(F===2){const V=n[x+0],M=n[x+1];D+=w[V>>>2],D+=w[(V<<4|M>>>4)&63],D+=w[M<<2&63],t&&(D+="=")}return D}e.encodeBase64=h}),define(ye[8],De([1,0,148,66]),function(ne,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function P(z,...ue){return ue.length===0?z:z.replace(C,function(Ie,Le){const $e=parseInt(Le,10);return isNaN($e)||$e<0||$e>=ue.length?Ie:ue[$e]})}e.format=P;const S=/{([^}]+)}/g;function I(z,ue){return z.replace(S,(Ie,Le)=>ue[Le]??Ie)}e.format2=I;function L(z){return z.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=L;function k(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function v(z,ue){let Ie=0;const Le=ue.charCodeAt(0);for(let $e=z.length-1;$e>=0;$e--)z.charCodeAt($e)===Le&&Ie++;return Ie}e.count=v;function T(z,ue,Ie="\u2026"){return z.length<=ue?z:`${z.substr(0,ue)}${Ie}`}e.truncate=T;function E(z,ue=" "){const Ie=m(z,ue);return d(Ie,ue)}e.trim=E;function m(z,ue){if(!z||!ue)return z;const Ie=ue.length;if(Ie===0||z.length===0)return z;let Le=0;for(;z.indexOf(ue,Le)===Le;)Le=Le+Ie;return z.substring(Le)}e.ltrim=m;function d(z,ue){if(!z||!ue)return z;const Ie=ue.length,Le=z.length;if(Ie===0||Le===0)return z;let $e=Le,Ke=-1;for(;Ke=z.lastIndexOf(ue,$e-1),!(Ke===-1||Ke+Ie!==$e);){if(Ke===0)return"";$e=Ke}return z.substring(0,$e)}e.rtrim=d;function f(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p(z){return z.replace(/\*/g,"")}e.stripWildcards=p;function b(z,ue,Ie={}){if(!z)throw new Error("Cannot create regex from empty string");ue||(z=k(z)),Ie.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp(z,Le)}e.createRegExp=b;function y(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function g(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function i(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=i;function o(z){return z.split(/\r\n|\r|\n/)}e.splitLines=o;function s(z){for(let ue=0,Ie=z.length;ue<Ie;ue++){const Le=z.charCodeAt(ue);if(Le!==32&&Le!==9)return ue}return-1}e.firstNonWhitespaceIndex=s;function l(z,ue=0,Ie=z.length){for(let Le=ue;Le<Ie;Le++){const $e=z.charCodeAt(Le);if($e!==32&&$e!==9)return z.substring(ue,Le)}return z.substring(ue,Ie)}e.getLeadingWhitespace=l;function r(z,ue=z.length-1){for(let Ie=ue;Ie>=0;Ie--){const Le=z.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=r;function h(z,ue,Ie){const Le=[];let $e=0;for(const Ke of z.matchAll(ue)){if(Le.push(z.slice($e,Ke.index)),Ke.index===void 0)throw new Error("match.index should be defined");$e=Ke.index+Ke[0].length,Le.push(Ie(Ke[0],...Ke.slice(1),Ke.index,z,Ke.groups))}return Le.push(z.slice($e)),Promise.all(Le).then(Ke=>Ke.join(""))}e.replaceAsync=h;function n(z,ue){return z<ue?-1:z>ue?1:0}e.compare=n;function t(z,ue,Ie=0,Le=z.length,$e=0,Ke=ue.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){const gt=z.charCodeAt(Ie),ct=ue.charCodeAt($e);if(gt<ct)return-1;if(gt>ct)return 1}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstring=t;function a(z,ue){return w(z,ue,0,z.length,0,ue.length)}e.compareIgnoreCase=a;function w(z,ue,Ie=0,Le=z.length,$e=0,Ke=ue.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){let gt=z.charCodeAt(Ie),ct=ue.charCodeAt($e);if(gt===ct)continue;if(gt>=128||ct>=128)return t(z.toLowerCase(),ue.toLowerCase(),Ie,Le,$e,Ke);F(gt)&&(gt-=32),F(ct)&&(ct-=32);const Et=gt-ct;if(Et!==0)return Et}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstringIgnoreCase=w;function D(z){return z>=48&&z<=57}e.isAsciiDigit=D;function F(z){return z>=97&&z<=122}e.isLowerAsciiLetter=F;function x(z){return z>=65&&z<=90}e.isUpperAsciiLetter=x;function V(z,ue){return z.length===ue.length&&w(z,ue)===0}e.equalsIgnoreCase=V;function M(z,ue){const Ie=ue.length;return ue.length>z.length?!1:w(z,ue,0,Ie)===0}e.startsWithIgnoreCase=M;function $(z,ue){const Ie=Math.min(z.length,ue.length);let Le;for(Le=0;Le<Ie;Le++)if(z.charCodeAt(Le)!==ue.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=$;function O(z,ue){const Ie=Math.min(z.length,ue.length);let Le;const $e=z.length-1,Ke=ue.length-1;for(Le=0;Le<Ie;Le++)if(z.charCodeAt($e-Le)!==ue.charCodeAt(Ke-Le))return Le;return Ie}e.commonSuffixLength=O;function U(z){return 55296<=z&&z<=56319}e.isHighSurrogate=U;function B(z){return 56320<=z&&z<=57343}e.isLowSurrogate=B;function j(z,ue){return(z-55296<<10)+(ue-56320)+65536}e.computeCodePoint=j;function de(z,ue,Ie){const Le=z.charCodeAt(Ie);if(U(Le)&&Ie+1<ue){const $e=z.charCodeAt(Ie+1);if(B($e))return j(Le,$e)}return Le}e.getNextCodePoint=de;function Y(z,ue){const Ie=z.charCodeAt(ue-1);if(B(Ie)&&ue>1){const Le=z.charCodeAt(ue-2);if(U(Le))return j(Le,Ie)}return Ie}class q{get offset(){return this.e}constructor(ue,Ie=0){this.c=ue,this.d=ue.length,this.e=Ie}setOffset(ue){this.e=ue}prevCodePoint(){const ue=Y(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=de(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=q;class Q{get offset(){return this.c.offset}constructor(ue,Ie=0){this.c=new q(ue,Ie)}nextGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=ue.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Ke=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.nextCodePoint());if(Ve($e,Ze)){Ie.setOffset(Ke);break}$e=Ze}return Ie.offset-Le}prevGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=ue.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Ke=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.prevCodePoint());if(Ve(Ze,$e)){Ie.setOffset(Ke);break}$e=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function Z(z,ue){return new Q(z,ue).nextGraphemeLength()}e.nextCharLength=Z;function te(z,ue){return new Q(z,ue).prevGraphemeLength()}e.prevCharLength=te;function X(z,ue){ue>0&&B(z.charCodeAt(ue))&&ue--;const Ie=ue+Z(z,ue);return[Ie-te(z,Ie),Ie]}e.getCharContainingOffset=X;function J(z){const ue=new Q(z);let Ie=0;for(;!ue.eol();)Ie++,ue.nextGraphemeLength();return Ie}e.charCount=J;let ie;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(z){return ie||(ie=pe()),ie.test(z)}e.containsRTL=ve;const ke=/^[\t\n\r\x20-\x7E]*$/;function Oe(z){return ke.test(z)}e.isBasicASCII=Oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=oe;function ae(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=ae;function fe(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=fe;function ee(z,ue){if(z.length<ue)return z;const Ie=/\b/g;let Le=0;for(;Ie.test(z)&&!(z.length-Ie.lastIndex<ue);)Le=Ie.lastIndex,Ie.lastIndex+=1;return z.substring(Le).replace(/^\s/,"")}e.lcut=ee;const le=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function W(z){return z&&(z=z.replace(le,""),z=z.replace(re,""),z=z.replace(N,"")),z}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=K;function _(z){return K(z)?z.substr(1):z}e.stripUTF8BOM=_;function he(z,ue){if(!z||!ue||z.length<ue.length)return!1;const Ie=ue.length,Le=z.toLowerCase();let $e=0,Ke=-1;for(;$e<Ie;){const Ze=Le.indexOf(ue[$e],Ke+1);if(Ze<0)return!1;Ke=Ze,$e++}return!0}e.fuzzyContains=he;function we(z,ue=!1){return z?(ue&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=we;function Ae(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ae;function be(z,ue=1){if(ue===0)return"";let Ie=-1;do Ie=z.indexOf(`
`,Ie+1),ue--;while(ue>0&&Ie>=0);return Ie===-1?z:(z[Ie-1]==="\r"&&Ie--,z.substr(0,Ie))}e.getNLines=be;function Ce(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=Ce;function Te(z){return et.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=Te;function Ve(z,ue){return z===0?ue!==5&&ue!==7:z===2&&ue===3?!1:z===4||z===2||z===3||ue===4||ue===2||ue===3?!0:!(z===8&&(ue===8||ue===9||ue===11||ue===12)||(z===11||z===9)&&(ue===9||ue===10)||(z===12||z===10)&&ue===10||ue===5||ue===13||ue===7||z===1||z===13&&ue===14||z===6&&ue===6)}var xe;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const Ie=this.d,Le=Ie.length/3;let $e=1;for(;$e<=Le;)if(ue<Ie[3*$e])$e=2*$e;else if(ue>Ie[3*$e+1])$e=2*$e+1;else return Ie[3*$e+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(z,ue){if(z===0)return 0;const Ie=st(z,ue);if(Ie!==void 0)return Ie;const Le=new q(ue,z);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st(z,ue){const Ie=new q(ue,z);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let $e=Ie.offset;return $e>0&&Ie.prevCodePoint()===8205&&($e=Ie.offset),$e}function ht(z){return 127995<=z&&z<=127999}var Ue;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.noBreakWhitespace="\xA0";class rt{static getInstance(ue){return rt.d.get(Array.from(ue))}static getLocales(){return rt.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}u=rt,rt.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),rt.d=new c.LRUCachedFunction(z=>{function ue(ct){const Et=new Map;for(let tt=0;tt<ct.length;tt+=2)Et.set(ct[tt],ct[tt+1]);return Et}function Ie(ct,Et){const tt=new Map(ct);for(const[ft,At]of Et)tt.set(ft,At);return tt}function Le(ct,Et){if(!ct)return Et;const tt=new Map;for(const[ft,At]of ct)Et.has(ft)&&tt.set(ft,At);return tt}const $e=u.c.value;let Ke=z.filter(ct=>!ct.startsWith("_")&&ct in $e);Ke.length===0&&(Ke=["_default"]);let Ze;for(const ct of Ke){const Et=ue($e[ct]);Ze=Le(Ze,Et)}const pt=ue($e._common),gt=Ie(pt,Ze);return new rt(gt)}),rt.e=new A.Lazy(()=>Object.keys(rt.c.value).filter(z=>!z.startsWith("_"))),e.AmbiguousCharacters=rt;class ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ce.c())),this.d}static isInvisibleCharacter(ue){return ce.e().has(ue)}static get codePoints(){return ce.e()}}ce.d=void 0,e.InvisibleCharacters=ce}),define(ye[106],De([1,0,28,8]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...re){return function(N,W){for(let K=0,_=re.length;K<_;K++){const he=re[K](N,W);if(he)return he}return null}}e.or=u,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(re,N,W){if(!W||W.length<N.length)return null;let K;return re?K=A.startsWithIgnoreCase(W,N):K=W.indexOf(N)===0,K?N.length>0?[{start:0,end:N.length}]:[]:null}function C(re,N){const W=N.toLowerCase().indexOf(re.toLowerCase());return W===-1?null:[{start:W,end:W+re.length}]}e.matchesContiguousSubString=C;function P(re,N){return S(re.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=P;function S(re,N,W,K){if(W===re.length)return[];if(K===N.length)return null;if(re[W]===N[K]){let _=null;return(_=S(re,N,W+1,K+1))?f({start:K,end:K+1},_):null}return S(re,N,W,K+1)}function I(re){return 97<=re&&re<=122}function L(re){return 65<=re&&re<=90}e.isUpper=L;function k(re){return 48<=re&&re<=57}function v(re){return re===32||re===9||re===10||re===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>T.add(re.charCodeAt(0)));function E(re){return v(re)||T.has(re)}function m(re,N){return re===N||E(re)&&E(N)}function d(re){return I(re)||L(re)||k(re)}function f(re,N){return N.length===0?N=[re]:re.end===N[0].start?N[0].start=re.start:N.unshift(re),N}function p(re,N){for(let W=N;W<re.length;W++){const K=re.charCodeAt(W);if(L(K)||k(K)||W>0&&!d(re.charCodeAt(W-1)))return W}return re.length}function b(re,N,W,K){if(W===re.length)return[];if(K===N.length)return null;if(re[W]!==N[K].toLowerCase())return null;{let _=null,he=K+1;for(_=b(re,N,W+1,K+1);!_&&(he=p(N,he))<N.length;)_=b(re,N,W+1,he),he++;return _===null?null:f({start:K,end:K+1},_)}}function y(re){let N=0,W=0,K=0,_=0,he=0;for(let Te=0;Te<re.length;Te++)he=re.charCodeAt(Te),L(he)&&N++,I(he)&&W++,d(he)&&K++,k(he)&&_++;const we=N/re.length,Ae=W/re.length,be=K/re.length,Ce=_/re.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:be,numericPercent:Ce}}function g(re){const{upperPercent:N,lowerPercent:W}=re;return W===0&&N>.6}function i(re){const{upperPercent:N,lowerPercent:W,alphaPercent:K,numericPercent:_}=re;return W>.2&&N<.8&&K>.6&&_<.2}function o(re){let N=0,W=0,K=0,_=0;for(let he=0;he<re.length;he++)K=re.charCodeAt(he),L(K)&&N++,I(K)&&W++,v(K)&&_++;return(N===0||W===0)&&_===0?re.length<=30:N<=5}function s(re,N){if(!N||(N=N.trim(),N.length===0)||!o(re)||N.length>60)return null;const W=y(N);if(!i(W)){if(!g(W))return null;N=N.toLowerCase()}let K=null,_=0;for(re=re.toLowerCase();_<N.length&&(K=b(re,N,0,_))===null;)_=p(N,_+1);return K}e.matchesCamelCase=s;function l(re,N,W=!1){if(!N||N.length===0)return null;let K=null,_=0;for(re=re.toLowerCase(),N=N.toLowerCase();_<N.length&&(K=r(re,N,0,_,W))===null;)_=h(N,_+1);return K}e.matchesWords=l;function r(re,N,W,K,_){if(W===re.length)return[];if(K===N.length)return null;if(m(re.charCodeAt(W),N.charCodeAt(K))){let he=null,we=K+1;if(he=r(re,N,W+1,K+1,_),!_)for(;!he&&(we=h(N,we))<N.length;)he=r(re,N,W+1,we,_),we++;return he?re.charCodeAt(W)!==N.charCodeAt(K)?he:f({start:K,end:K+1},he):null}else return null}function h(re,N){for(let W=N;W<re.length;W++)if(E(re.charCodeAt(W))||W>0&&E(re.charCodeAt(W-1)))return W;return re.length}const n=u(e.matchesPrefix,s,C),t=u(e.matchesPrefix,s,P),a=new c.LRUCache(1e4);function w(re,N,W=!1){if(typeof re!="string"||typeof N!="string")return null;let K=a.get(re);K||(K=new RegExp(A.convertSimple2RegExpPattern(re),"i"),a.set(re,K));const _=K.exec(N);return _?[{start:_.index,end:_.index+_[0].length}]:W?t(re,N):n(re,N)}e.matchesFuzzy=w;function D(re,N){const W=ke(re,re.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?x(W):null}e.matchesFuzzy2=D;function F(re,N,W,K,_,he){const we=Math.min(13,re.length);for(;W<we;W++){const Ae=ke(re,N,W,K,_,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=F;function x(re){if(typeof re>"u")return[];const N=[],W=re[1];for(let K=re.length-1;K>1;K--){const _=re[K]+W,he=N[N.length-1];he&&he.end===_?he.end=_+1:N.push({start:_,end:_+1})}return N}e.createMatches=x;const V=128;function M(){const re=[],N=[];for(let W=0;W<=V;W++)N[W]=0;for(let W=0;W<=V;W++)re.push(N.slice(0));return re}function $(re){const N=[];for(let W=0;W<=re;W++)N[W]=0;return N}const O=$(2*V),U=$(2*V),B=M(),j=M(),de=M(),Y=!1;function q(re,N,W,K,_){function he(Ae,be,Ce=" "){for(;Ae.length<be;)Ae=Ce+Ae;return Ae}let we=` |   |${K.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=W;Ae++)Ae===0?we+=" |":we+=`${N[Ae-1]}|`,we+=re[Ae].slice(0,_+1).map(be=>he(be.toString(),3)).join("|")+`
`;return we}function Q(re,N,W,K){re=re.substr(N),W=W.substr(K),console.log(q(j,re,re.length,W,W.length)),console.log(q(de,re,re.length,W,W.length)),console.log(q(B,re,re.length,W,W.length))}function Z(re,N){if(N<0||N>=re.length)return!1;const W=re.codePointAt(N);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(W)}}function te(re,N){if(N<0||N>=re.length)return!1;switch(re.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function X(re,N,W){return N[re]!==W[re]}function J(re,N,W,K,_,he,we=!1){for(;N<W&&_<he;)re[N]===K[_]&&(we&&(O[N]=_),N+=1),_+=1;return N===W}e.isPatternInWord=J;var ie;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var pe;(function(re){re.Default=[-100,0];function N(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}re.isDefault=N})(pe=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(N,W){this.firstMatchCanBeWeak=N,this.boostFullMatch=W}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function ke(re,N,W,K,_,he,we=ve.default){const Ae=re.length>V?V:re.length,be=K.length>V?V:K.length;if(W>=Ae||he>=be||Ae-W>be-he||!J(N,W,Ae,_,he,be,!0))return;Oe(Ae,be,W,he,N,_);let Ce=1,Te=1,Ve=W,xe=he;const et=[!1];for(Ce=1,Ve=W;Ve<Ae;Ce++,Ve++){const Ue=O[Ve],rt=U[Ve],ce=Ve+1<Ae?U[Ve+1]:be;for(Te=Ue-he+1,xe=Ue;xe<ce;Te++,xe++){let z=Number.MIN_SAFE_INTEGER,ue=!1;xe<=rt&&(z=oe(re,N,Ve,W,K,_,xe,be,he,B[Ce-1][Te-1]===0,et));let Ie=0;z!==Number.MAX_SAFE_INTEGER&&(ue=!0,Ie=z+j[Ce-1][Te-1]);const Le=xe>Ue,$e=Le?j[Ce][Te-1]+(B[Ce][Te-1]>0?-5:0):0,Ke=xe>Ue+1&&B[Ce][Te-1]>0,Ze=Ke?j[Ce][Te-2]+(B[Ce][Te-2]>0?-5:0):0;if(Ke&&(!Le||Ze>=$e)&&(!ue||Ze>=Ie))j[Ce][Te]=Ze,de[Ce][Te]=3,B[Ce][Te]=0;else if(Le&&(!ue||$e>=Ie))j[Ce][Te]=$e,de[Ce][Te]=2,B[Ce][Te]=0;else if(ue)j[Ce][Te]=Ie,de[Ce][Te]=1,B[Ce][Te]=B[Ce-1][Te-1]+1;else throw new Error("not possible")}}if(Y&&Q(re,W,K,he),!et[0]&&!we.firstMatchCanBeWeak)return;Ce--,Te--;const Qe=[j[Ce][Te],he];let nt=0,st=0;for(;Ce>=1;){let Ue=Te;do{const rt=de[Ce][Ue];if(rt===3)Ue=Ue-2;else if(rt===2)Ue=Ue-1;else break}while(Ue>=1);nt>1&&N[W+Ce-1]===_[he+Te-1]&&!X(Ue+he-1,K,_)&&nt+1>B[Ce][Ue]&&(Ue=Te),Ue===Te?nt++:nt=1,st||(st=Ue),Ce--,Te=Ue-1,Qe.push(Te)}be===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=ke;function Oe(re,N,W,K,_,he){let we=re-1,Ae=N-1;for(;we>=W&&Ae>=K;)_[we]===he[Ae]&&(U[we]=Ae,we--),Ae--}function oe(re,N,W,K,_,he,we,Ae,be,Ce,Te){if(N[W]!==he[we])return Number.MIN_SAFE_INTEGER;let Ve=1,xe=!1;return we===W-K?Ve=re[W]===_[we]?7:5:X(we,_,he)&&(we===0||!X(we-1,_,he))?(Ve=re[W]===_[we]?7:5,xe=!0):Z(he,we)&&(we===0||!Z(he,we-1))?Ve=5:(Z(he,we-1)||te(he,we-1))&&(Ve=5,xe=!0),Ve>1&&W===K&&(Te[0]=!0),xe||(xe=X(we,_,he)||Z(he,we-1)||te(he,we-1)),W===K?we>be&&(Ve-=xe?3:5):Ce?Ve+=xe?2:0:Ve+=xe?0:1,we+1===Ae&&(Ve-=xe?3:5),Ve}function ae(re,N,W,K,_,he,we){return ee(re,N,W,K,_,he,!0,we)}e.fuzzyScoreGracefulAggressive=ae;function fe(re,N,W,K,_,he,we){return ee(re,N,W,K,_,he,!1,we)}e.fuzzyScoreGraceful=fe;function ee(re,N,W,K,_,he,we,Ae){let be=ke(re,N,W,K,_,he,Ae);if(be&&!we)return be;if(re.length>=3){const Ce=Math.min(7,re.length-1);for(let Te=W+1;Te<Ce;Te++){const Ve=le(re,Te);if(Ve){const xe=ke(Ve,Ve.toLowerCase(),W,K,_,he,Ae);xe&&(xe[0]-=3,(!be||xe[0]>be[0])&&(be=xe))}}}return be}function le(re,N){if(N+1>=re.length)return;const W=re[N],K=re[N+1];if(W!==K)return re.slice(0,N)+K+W+re.slice(N+2)}}),define(ye[88],De([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(f){return u(f,0)}e.hash=A;function u(f,p){switch(typeof f){case"object":return f===null?R(349,p):Array.isArray(f)?S(f,p):I(f,p);case"string":return P(f,p);case"boolean":return C(f,p);case"number":return R(f,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=u;function R(f,p){return(p<<5)-p+f|0}e.numberHash=R;function C(f,p){return R(f?433:863,p)}function P(f,p){p=R(149417,p);for(let b=0,y=f.length;b<y;b++)p=R(f.charCodeAt(b),p);return p}e.stringHash=P;function S(f,p){return p=R(104579,p),f.reduce((b,y)=>u(y,b),p)}function I(f,p){return p=R(181387,p),Object.keys(f).sort().reduce((b,y)=>(b=P(y,b),u(f[y],b)),p)}class L{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=u(p,this.g),this.g}}e.Hasher=L;var k;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v(f,p,b=32){const y=b-p,g=~((1<<y)-1);return(f<<p|(g&f)>>>y)>>>0}function T(f,p=0,b=f.byteLength,y=0){for(let g=0;g<b;g++)f[p+g]=y}function E(f,p,b="0"){for(;f.length<p;)f=b+f;return f}function m(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),p/4)}e.toHexString=m;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const y=this.p;let g=this.r,i=this.u,o,s;for(i!==0?(o=i,s=-1,i=0):(o=p.charCodeAt(0),s=0);;){let l=o;if(c.isHighSurrogate(o))if(s+1<b){const r=p.charCodeAt(s+1);c.isLowSurrogate(r)?(s++,l=c.computeCodePoint(o,r)):l=65533}else{i=o;break}else c.isLowSurrogate(o)&&(l=65533);if(g=this.w(y,g,l),s++,s<b)o=p.charCodeAt(s);else break}this.r=g,this.u=i}w(p,b,y){return y<128?p[b++]=y:y<2048?(p[b++]=192|(y&1984)>>>6,p[b++]=128|(y&63)>>>0):y<65536?(p[b++]=224|(y&61440)>>>12,p[b++]=128|(y&4032)>>>6,p[b++]=128|(y&63)>>>0):(p[b++]=240|(y&1835008)>>>18,p[b++]=128|(y&258048)>>>12,p[b++]=128|(y&4032)>>>6,p[b++]=128|(y&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,T(this.p,this.r),this.r>56&&(this.y(),T(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=d.g,b=this.q;for(let n=0;n<64;n+=4)p.setUint32(n,b.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)p.setUint32(n,v(p.getUint32(n-12,!1)^p.getUint32(n-32,!1)^p.getUint32(n-56,!1)^p.getUint32(n-64,!1),1),!1);let y=this.h,g=this.l,i=this.m,o=this.n,s=this.o,l,r,h;for(let n=0;n<80;n++)n<20?(l=g&i|~g&o,r=1518500249):n<40?(l=g^i^o,r=1859775393):n<60?(l=g&i|g&o|i&o,r=2400959708):(l=g^i^o,r=3395469782),h=v(y,5)+l+s+r+p.getUint32(n*4,!1)&4294967295,s=o,o=i,i=v(g,30),g=y,y=h;this.h=this.h+y&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}d.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=d}),define(ye[107],De([1,0,103,106,88,9,12,8]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,I=[S,[]];function L(B,j,de,Y){if(!B||!j)return I;const q=B.length,Q=j.length;if(q<Q)return I;const Z=B.toLowerCase();return k(j,de,Q,B,Z,q,Y)}e.scoreFuzzy=L;function k(B,j,de,Y,q,Q,Z){const te=[],X=[];for(let ve=0;ve<de;ve++){const ke=ve*Q,Oe=ke-Q,oe=ve>0,ae=B[ve],fe=j[ve];for(let ee=0;ee<Q;ee++){const le=ee>0,re=ke+ee,N=re-1,W=Oe+ee-1,K=le?te[N]:0,_=oe&&le?te[W]:0,he=oe&&le?X[W]:0;let we;!_&&oe?we=0:we=v(ae,fe,Y,q,ee,he),we&&_+we>=K&&(Z||oe||q.startsWith(j,ee))?(X[re]=he+1,te[re]=_+we):(X[re]=S,te[re]=K)}}const J=[];let ie=de-1,pe=Q-1;for(;ie>=0&&pe>=0;){const ve=ie*Q+pe;X[ve]===S||(J.push(pe),ie--),pe--}return[te[de*Q-1],J.reverse()]}function v(B,j,de,Y,q,Q){let Z=0;if(!T(j,Y[q]))return Z;if(Z+=1,Q>0&&(Z+=Q*5),B===de[q]&&(Z+=1),q===0)Z+=8;else{const te=E(de.charCodeAt(q-1));te?Z+=te:(0,A.isUpper)(de.charCodeAt(q))&&Q===0&&(Z+=2)}return Z}function T(B,j){return B===j?!0:B==="/"||B==="\\"?j==="/"||j==="\\":!1}function E(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function d(B,j,de=0,Y=0){const q=j;return q.values&&q.values.length>1?f(B,q.values,de,Y):p(B,j,de,Y)}e.scoreFuzzy2=d;function f(B,j,de,Y){let q=0;const Q=[];for(const Z of j){const[te,X]=p(B,Z,de,Y);if(typeof te!="number")return m;q+=te,Q.push(...X)}return[q,t(Q)]}function p(B,j,de,Y){const q=(0,A.fuzzyScore)(j.original,j.originalLowercase,de,B,B.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,A.createMatches)(q)]:m}const b=Object.freeze({score:0}),y=1<<18,g=1<<17,i=1<<16;function o(B,j,de,Y){const q=Y.values?Y.values:[Y];return(0,u.hash)({[Y.normalized]:{values:q.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:B,description:j,allowNonContiguousMatches:de}})}function s(B,j,de,Y,q){if(!B||!j.normalized)return b;const Q=Y.getItemLabel(B);if(!Q)return b;const Z=Y.getItemDescription(B),te=o(Q,Z,de,j),X=q[te];if(X)return X;const J=l(Q,Z,Y.getItemPath(B),j,de);return q[te]=J,J}e.scoreItemFuzzy=s;function l(B,j,de,Y,q){const Q=!de||!Y.containsPathSeparator;return de&&(C.isLinux?Y.pathNormalized===de:(0,P.equalsIgnoreCase)(Y.pathNormalized,de))?{score:y,labelMatch:[{start:0,end:B.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:Y.values&&Y.values.length>1?r(B,j,de,Y.values,Q,q):h(B,j,de,Y,Q,q)}function r(B,j,de,Y,q,Q){let Z=0;const te=[],X=[];for(const J of Y){const{score:ie,labelMatch:pe,descriptionMatch:ve}=h(B,j,de,J,q,Q);if(ie===S)return b;Z+=ie,pe&&te.push(...pe),ve&&X.push(...ve)}return{score:Z,labelMatch:t(te),descriptionMatch:t(X)}}function h(B,j,de,Y,q,Q){if(q||!j){const[Z,te]=L(B,Y.normalized,Y.normalizedLowercase,Q&&!Y.expectContiguousMatch);if(Z){const X=(0,A.matchesPrefix)(Y.normalized,B);let J;return X?(J=g,J+=Math.round(Y.normalized.length/B.length*100)):J=i,{score:J+Z,labelMatch:X||n(te)}}}if(j){let Z=j;de&&(Z=`${j}${R.sep}`);const te=Z.length,X=`${Z}${B}`,[J,ie]=L(X,Y.normalized,Y.normalizedLowercase,Q&&!Y.expectContiguousMatch);if(J){const pe=n(ie),ve=[],ke=[];return pe.forEach(Oe=>{Oe.start<te&&Oe.end>te?(ve.push({start:0,end:Oe.end-te}),ke.push({start:Oe.start,end:te})):Oe.start>=te?ve.push({start:Oe.start-te,end:Oe.end-te}):ke.push(Oe)}),{score:J,labelMatch:ve,descriptionMatch:ke}}}return b}function n(B){const j=[];if(!B)return j;let de;for(const Y of B)de&&de.end===Y?de.end+=1:(de={start:Y,end:Y+1},j.push(de));return j}function t(B){const j=B.sort((q,Q)=>q.start-Q.start),de=[];let Y;for(const q of j)!Y||!a(Y,q)?(Y=q,de.push(q)):(Y.start=Math.min(Y.start,q.start),Y.end=Math.max(Y.end,q.end));return de}function a(B,j){return!(B.end<j.start||j.end<B.start)}function w(B,j,de,Y,q,Q){const Z=s(B,de,Y,q,Q),te=s(j,de,Y,q,Q),X=Z.score,J=te.score;if((X===y||J===y)&&X!==J)return X===y?-1:1;if(X>i||J>i){if(X!==J)return X>J?-1:1;if(X<g&&J<g){const ae=F(Z.labelMatch,te.labelMatch);if(ae!==0)return ae}const Oe=q.getItemLabel(B)||"",oe=q.getItemLabel(j)||"";if(Oe.length!==oe.length)return Oe.length-oe.length}if(X!==J)return X>J?-1:1;const ie=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,pe=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ie&&!pe)return-1;if(pe&&!ie)return 1;const ve=D(B,Z,q),ke=D(j,te,q);return ve&&ke&&ve!==ke?ke>ve?-1:1:x(B,j,de,q)}e.compareItemsByFuzzyScore=w;function D(B,j,de){let Y=-1,q=-1;if(j.descriptionMatch&&j.descriptionMatch.length?Y=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(Y=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(q=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const Q=de.getItemDescription(B);Q&&(q+=Q.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(q=j.descriptionMatch[j.descriptionMatch.length-1].end);return q-Y}function F(B,j){if(!B&&!j||(!B||!B.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!B||!B.length)return 1;const de=B[0].start,q=B[B.length-1].end-de,Q=j[0].start,te=j[j.length-1].end-Q;return q===te?0:te<q?1:-1}function x(B,j,de,Y){const q=Y.getItemLabel(B)||"",Q=Y.getItemLabel(j)||"",Z=Y.getItemDescription(B),te=Y.getItemDescription(j),X=q.length+(Z?Z.length:0),J=Q.length+(te?te.length:0);if(X!==J)return X-J;const ie=Y.getItemPath(B),pe=Y.getItemPath(j);return ie&&pe&&ie.length!==pe.length?ie.length-pe.length:q!==Q?(0,c.compareAnything)(q,Q,de.normalized):Z&&te&&Z!==te?(0,c.compareAnything)(Z,te,de.normalized):ie&&pe&&ie!==pe?(0,c.compareAnything)(ie,pe,de.normalized):0}function V(B){return B.startsWith('"')&&B.endsWith('"')}const M=" ";function $(B){typeof B!="string"&&(B="");const j=B.toLowerCase(),{pathNormalized:de,normalized:Y,normalizedLowercase:q}=O(B),Q=de.indexOf(R.sep)>=0,Z=V(B);let te;const X=B.split(M);if(X.length>1)for(const J of X){const ie=V(J),{pathNormalized:pe,normalized:ve,normalizedLowercase:ke}=O(J);ve&&(te||(te=[]),te.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:pe,normalized:ve,normalizedLowercase:ke,expectContiguousMatch:ie}))}return{original:B,originalLowercase:j,pathNormalized:de,normalized:Y,normalizedLowercase:q,values:te,containsPathSeparator:Q,expectContiguousMatch:Z}}e.prepareQuery=$;function O(B){let j;C.isWindows?j=B.replace(/\//g,R.sep):j=B.replace(/\\/g,R.sep);const de=(0,P.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:de,normalizedLowercase:de.toLowerCase()}}function U(B){return Array.isArray(B)?$(B.map(j=>j.original).join(M)):$(B.original)}e.pieceToQuery=U}),define(ye[37],De([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(A||(A={})),function(u){const R="error",C="warning",P="warn",S="info",I="ignore";function L(v){return v?c.equalsIgnoreCase(R,v)?u.Error:c.equalsIgnoreCase(C,v)||c.equalsIgnoreCase(P,v)?u.Warning:c.equalsIgnoreCase(S,v)?u.Info:u.Ignore:u.Ignore}u.fromValue=L;function k(v){switch(v){case u.Error:return R;case u.Warning:return C;case u.Info:return S;default:return I}}u.toString=k}(A||(A={})),e.default=A}),define(ye[149],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[68],De([1,0,15,8]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this.b="",this.c=0}reset(T){return this.b=T,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(T){const E=T.charCodeAt(0),m=this.b.charCodeAt(this.c);return E-m}value(){return this.b[this.c]}}e.StringIterator=u;class R{constructor(T=!0){this.e=T}reset(T){return this.b=T,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let T=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(T)this.c++;else break;else T=!1;return this}cmp(T){return this.e?(0,A.compareSubstring)(T,this.b,0,T.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(T,this.b,0,T.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class C{constructor(T=!0,E=!0){this.f=T,this.g=E}reset(T){this.d=0,this.e=0,this.b=T,this.c=T.length;for(let E=T.length-1;E>=0;E--,this.c--){const m=this.b.charCodeAt(E);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let T=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(T)this.d++;else break;else T=!1}return this}cmp(T){return this.g?(0,A.compareSubstring)(T,this.b,0,T.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(T,this.b,0,T.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(T,E){this.f=T,this.g=E,this.d=[],this.e=0}reset(T){return this.c=T,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(T)),this.b.reset(T.path),this.b.value()&&this.d.push(3)),this.g(T)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(T){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(T,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(T,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(T);if(this.d[this.e]===4)return(0,A.compare)(T,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(T,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const T=this.right;return this.right=T.left,T.left=this,this.updateHeight(),T.updateHeight(),T}rotateRight(){const T=this.left;return this.left=T.right,T.right=this,this.updateHeight(),T.updateHeight(),T}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class k{static forUris(T=()=>!1,E=()=>!1){return new k(new S(T,E))}static forPaths(T=!1){return new k(new C(void 0,!T))}static forStrings(){return new k(new u)}static forConfigKeys(){return new k(new R)}constructor(T){this.b=T}clear(){this.c=void 0}fill(T,E){if(E){const m=E.slice(0);(0,c.shuffle)(m);for(const d of m)this.set(d,T)}else{const m=T.slice(0);(0,c.shuffle)(m);for(const d of m)this.set(d[0],d[1])}}set(T,E){const m=this.b.reset(T);let d;this.c||(this.c=new I,this.c.segment=m.value());const f=[];for(d=this.c;;){const b=m.cmp(d.segment);if(b>0)d.left||(d.left=new I,d.left.segment=m.value()),f.push([-1,d]),d=d.left;else if(b<0)d.right||(d.right=new I,d.right.segment=m.value()),f.push([1,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new I,d.mid.segment=m.value()),f.push([0,d]),d=d.mid;else break}const p=d.value;d.value=E,d.key=T;for(let b=f.length-1;b>=0;b--){const y=f[b][1];y.updateHeight();const g=y.balanceFactor();if(g<-1||g>1){const i=f[b][0],o=f[b+1][0];if(i===1&&o===1)f[b][1]=y.rotateLeft();else if(i===-1&&o===-1)f[b][1]=y.rotateRight();else if(i===1&&o===-1)y.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=y.rotateLeft();else if(i===-1&&o===1)y.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=y.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this.c=f[0][1]}}return p}get(T){return this.d(T)?.value}d(T){const E=this.b.reset(T);let m=this.c;for(;m;){const d=E.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(E.hasNext())E.next(),m=m.mid;else break}return m}has(T){const E=this.d(T);return!(E?.value===void 0&&E?.mid===void 0)}delete(T){return this.e(T,!1)}deleteSuperstr(T){return this.e(T,!0)}e(T,E){const m=this.b.reset(T),d=[];let f=this.c;for(;f;){const p=m.cmp(f.segment);if(p>0)d.push([-1,f]),f=f.left;else if(p<0)d.push([1,f]),f=f.right;else if(m.hasNext())m.next(),d.push([0,f]),f=f.mid;else break}if(!!f){if(E?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this.f(f.right);if(p.key){const{key:b,value:y,segment:g}=p;this.e(p.key,!1),f.key=b,f.value=y,f.segment=g}}else{const p=f.left??f.right;if(d.length>0){const[b,y]=d[d.length-1];switch(b){case-1:y.left=p;break;case 0:y.mid=p;break;case 1:y.right=p;break}}else this.c=p}for(let p=d.length-1;p>=0;p--){const b=d[p][1];b.updateHeight();const y=b.balanceFactor();if(y>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),d[p][1]=b.rotateLeft()):y<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),d[p][1]=b.rotateRight()),p>0)switch(d[p-1][0]){case-1:d[p-1][1].left=d[p][1];break;case 1:d[p-1][1].right=d[p][1];break;case 0:d[p-1][1].mid=d[p][1];break}else this.c=d[0][1]}}}f(T){for(;T.left;)T=T.left;return T}findSubstr(T){const E=this.b.reset(T);let m=this.c,d;for(;m;){const f=E.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(E.hasNext())E.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(T){return this.g(T,!1)}g(T,E){const m=this.b.reset(T);let d=this.c;for(;d;){const f=m.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):E?d.value:void 0}}hasElementOrSubtree(T){return this.g(T,!0)!==void 0}forEach(T){for(const[E,m]of this)T(m,E)}*[Symbol.iterator](){yield*this.h(this.c)}h(T){const E=[];return this.j(T,E),E[Symbol.iterator]()}j(T,E){!T||(T.left&&this.j(T.left,E),T.value&&E.push([T.key,T.value]),T.mid&&this.j(T.mid,E),T.right&&this.j(T.right,E))}_isBalanced(){const T=E=>{if(!E)return!0;const m=E.balanceFactor();return m<-1||m>1?!1:T(E.left)&&T(E.right)};return T(this.c)}}e.TernarySearchTree=k}),define(ye[10],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(o){return typeof o=="string"}e.isString=c;function A(o){return Array.isArray(o)&&o.every(s=>c(s))}e.isStringArray=A;function u(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=u;function R(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=R;function C(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=C;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function S(o){return o===!0||o===!1}e.isBoolean=S;function I(o){return typeof o>"u"}e.isUndefined=I;function L(o){return!k(o)}e.isDefined=L;function k(o){return I(o)||o===null}e.isUndefinedOrNull=k;function v(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=v;function T(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=T;function E(...o){const s=[];for(let l=0;l<o.length;l++){const r=o[l];if(k(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);s.push(r)}return s}e.assertAllDefined=E;const m=Object.prototype.hasOwnProperty;function d(o){if(!u(o))return!1;for(const s in o)if(m.call(o,s))return!1;return!0}e.isEmptyObject=d;function f(o){return typeof o=="function"}e.isFunction=f;function p(...o){return o.length>0&&o.every(f)}e.areFunctions=p;function b(o,s){const l=Math.min(o.length,s.length);for(let r=0;r<l;r++)y(o[r],s[r])}e.validateConstraints=b;function y(o,s){if(c(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(o instanceof s)return}catch{}if(!k(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function g(o){return o===null?void 0:o}e.withNullAsUndefined=g;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(ye[69],De([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function u(P,S){if((0,c.isString)(S)){const I=A[S];if(I===void 0)throw new Error(`${P} references an unknown codicon: ${S}`);S=I}return A[P]=S,{id:P}}function R(){return A}e.getCodiconFontCharacters=R;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(ye[32],De([1,0,9,12,8,10]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function P(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=P;function S(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function I(r,h=c.posix.sep){if(!r)return"";const n=r.length,t=r.charCodeAt(0);if(C(t)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let w=3;const D=w;for(;w<n&&!C(r.charCodeAt(w));w++);if(D!==w&&!C(r.charCodeAt(w+1))){for(w+=1;w<n;w++)if(C(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,h)}}return h}else if(f(t)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+h:r.slice(0,2);let a=r.indexOf("://");if(a!==-1){for(a+=3;a<n;a++)if(C(r.charCodeAt(a)))return r.slice(0,a+1)}return""}e.getRoot=I;function L(r){if(!A.isWindows||!r||r.length<5)return!1;let h=r.charCodeAt(0);if(h!==92||(h=r.charCodeAt(1),h!==92))return!1;let n=2;const t=n;for(;n<r.length&&(h=r.charCodeAt(n),h!==92);n++);return!(t===n||(h=r.charCodeAt(n+1),isNaN(h)||h===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(r,h=A.isWindows){const n=h?k:v;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||h&&T.test(r)||r==="."||r===".."||h&&r[r.length-1]==="."||h&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=E;function m(r,h,n){const t=r===h;return!n||t?t:!r||!h?!1:(0,u.equalsIgnoreCase)(r,h)}e.isEqual=m;function d(r,h,n,t=c.sep){if(r===h)return!0;if(!r||!h||h.length>r.length)return!1;if(n){if(!(0,u.startsWithIgnoreCase)(r,h))return!1;if(h.length===r.length)return!0;let w=h.length;return h.charAt(h.length-1)===t&&w--,r.charAt(w)===t}return h.charAt(h.length-1)!==t&&(h+=t),r.indexOf(h)===0}e.isEqualOrParent=d;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function p(r,h){return A.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(h,r)),r=(0,c.normalize)(r),A.isWindows?(r=(0,u.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,u.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=p;function b(r){const h=(0,c.normalize)(r);return A.isWindows?r.length>3?!1:y(h)&&(r.length===2||h.charCodeAt(2)===92):h===c.posix.sep}e.isRootOrDriveLetter=b;function y(r,h=A.isWindows){return h?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function g(r){return y(r)?r[0]:void 0}e.getDriveLetter=g;function i(r,h,n){return h.length>r.length?-1:r===h?0:(n&&(r=r.toLowerCase(),h=h.toLowerCase()),r.indexOf(h))}e.indexOfPath=i;function o(r){const h=r.split(":");let n,t,a;for(const w of h){const D=Number(w);(0,R.isNumber)(D)?t===void 0?t=D:a===void 0&&(a=D):n=n?[n,w].join(":"):w}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:t!==void 0?t:void 0,column:a!==void 0?a:t!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(r,h,n=8){let t="";for(let w=0;w<n;w++)t+=s.charAt(Math.floor(Math.random()*s.length));let a;return h?a=`${h}-${t}`:a=t,r?(0,c.join)(r,a):a}e.randomPath=l}),define(ye[23],De([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,y])=>{p[b]=y&&typeof y=="object"?A(y):y}),p}e.deepClone=A;function u(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const y in b)if(R.call(b,y)){const g=b[y];typeof g=="object"&&!Object.isFrozen(g)&&!(0,c.isTypedArray)(g)&&p.push(g)}}return f}e.deepFreeze=u;const R=Object.prototype.hasOwnProperty;function C(f,p){return P(f,p,new Set)}e.cloneAndChange=C;function P(f,p,b){if((0,c.isUndefinedOrNull)(f))return f;const y=p(f);if(typeof y<"u")return y;if(Array.isArray(f)){const g=[];for(const i of f)g.push(P(i,p,b));return g}if((0,c.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const g={};for(const i in f)R.call(f,i)&&(g[i]=P(f[i],p,b));return b.delete(f),g}return f}function S(f,p,b=!0){return(0,c.isObject)(f)?((0,c.isObject)(p)&&Object.keys(p).forEach(y=>{y in f?b&&((0,c.isObject)(f[y])&&(0,c.isObject)(p[y])?S(f[y],p[y],b):f[y]=p[y]):f[y]=p[y]}),f):p}e.mixin=S;function I(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let b,y;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(b=0;b<f.length;b++)if(!I(f[b],p[b]))return!1}else{const g=[];for(y in f)g.push(y);g.sort();const i=[];for(y in p)i.push(y);if(i.sort(),!I(g,i))return!1;for(b=0;b<g.length;b++)if(!I(f[g[b]],p[g[b]]))return!1}return!0}e.equals=I;function L(f){const p=new Set;return JSON.stringify(f,(b,y)=>{if((0,c.isObject)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return y})}e.safeStringify=L;function k(f,p){const b=Object.create(null);return!f||!p||Object.keys(p).forEach(g=>{const i=f[g],o=p[g];I(i,o)||(b[g]=o)}),b}e.distinct=k;function v(f,p){const b=p.toLowerCase(),y=Object.keys(f).find(g=>g.toLowerCase()===b);return y?f[y]:f[p]}e.getCaseInsensitive=v;function T(f,p){const b=Object.create(null);for(const[y,g]of Object.entries(f))p(y,g)&&(b[y]=g);return b}e.filter=T;function E(f){let p=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=E;function m(f){const p=[];for(const b of E(f))typeof f[b]=="function"&&p.push(b);return p}e.getAllMethodNames=m;function d(f,p){const b=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},y={};for(const g of f)y[g]=b(g);return y}e.createProxyObject=d}),define(ye[51],De([1,0,69]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(C){function P(S){return S&&typeof S=="object"&&typeof S.id=="string"}C.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function u(C){return{id:C}}e.themeColorFromId=u;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(p){const b=P.exec(p.id);if(!b)return S(c.Codicon.error);const[,y,g]=b,i=["codicon","codicon-"+y];return g&&i.push("codicon-modifier-"+g.substring(1)),i}C.asClassNameArray=S;function I(p){return S(p).join(" ")}C.asClassName=I;function L(p){return"."+S(p).join(".")}C.asCSSSelector=L;function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||A.isThemeColor(p.color))}C.isThemeIcon=k;const v=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function T(p){const b=v.exec(p);if(!b)return;const[,y]=b;return{id:y}}C.fromString=T;function E(p){return{id:p}}C.fromId=E;function m(p,b){let y=p.id;const g=y.lastIndexOf("~");return g!==-1&&(y=y.substring(0,g)),b&&(y=`${y}~${b}`),{id:y}}C.modify=m;function d(p){const b=p.id.lastIndexOf("~");if(b!==-1)return p.id.substring(b+1)}C.getModifier=d;function f(p,b){return p.id===b.id&&p.color?.id===b.color?.id}C.isEqual=f})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[150],De([1,0,106,8,51]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",C=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${C.source}`,"g");function S(f){return f.replace(P,(p,b)=>b?p:`\\${p}`)}e.escapeIcons=S;const I=new RegExp(`\\\\${C.source}`,"g");function L(f){return f.replace(I,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(f){return f.indexOf(R)===-1?f:f.replace(k,(p,b,y,g)=>y?p:b||g||"")}e.stripIcons=v;function T(f){return f?f.replace(/\$\((.*?)\)/g,(p,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=T;const E=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(f){E.lastIndex=0;let p="";const b=[];let y=0;for(;;){const g=E.lastIndex,i=E.exec(f),o=f.substring(g,i?.index);if(o.length>0){p+=o;for(let s=0;s<o.length;s++)b.push(y)}if(!i)break;y+=i[0].length}return{text:p,iconOffsets:b}}e.parseLabelWithIcons=m;function d(f,p,b=!1){const{text:y,iconOffsets:g}=p;if(!g||g.length===0)return(0,c.matchesFuzzy)(f,y,b);const i=(0,A.ltrim)(y," "),o=y.length-i.length,s=(0,c.matchesFuzzy)(f,i,b);if(s)for(const l of s){const r=g[l.start+o]+o;l.start+=r,l.end+=r}return s}e.matchesFuzzyIconAware=d}),define(ye[108],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function u(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=u}),define(ye[2],De([1,0,9,12]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function P(s,l){if(!s.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!u.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,l){return!s&&!l?"file":s}function I(s,l){switch(s){case"https":case"http":case"file":l?l[0]!==k&&(l=k+l):l=k;break}return l}const L="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(l){return l instanceof T?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,r,h,n,t,a=!1){typeof l=="object"?(this.scheme=l.scheme||L,this.authority=l.authority||L,this.path=l.path||L,this.query=l.query||L,this.fragment=l.fragment||L):(this.scheme=S(l,a),this.authority=r||L,this.path=I(this.scheme,h||L),this.query=n||L,this.fragment=t||L,P(this,a))}get fsPath(){return b(this,!1)}with(l){if(!l)return this;let{scheme:r,authority:h,path:n,query:t,fragment:a}=l;return r===void 0?r=this.scheme:r===null&&(r=L),h===void 0?h=this.authority:h===null&&(h=L),n===void 0?n=this.path:n===null&&(n=L),t===void 0?t=this.query:t===null&&(t=L),a===void 0?a=this.fragment:a===null&&(a=L),r===this.scheme&&h===this.authority&&n===this.path&&t===this.query&&a===this.fragment?this:new m(r,h,n,t,a)}static parse(l,r=!1){const h=v.exec(l);return h?new m(h[2]||L,o(h[4]||L),o(h[5]||L),o(h[7]||L),o(h[9]||L),r):new m(L,L,L,L,L)}static file(l){let r=L;if(A.isWindows&&(l=l.replace(/\\/g,k)),l[0]===k&&l[1]===k){const h=l.indexOf(k,2);h===-1?(r=l.substring(2),l=k):(r=l.substring(2,h),l=l.substring(h)||k)}return new m("file",r,l,L,L)}static from(l){const r=new m(l.scheme,l.authority,l.path,l.query,l.fragment);return P(r,!0),r}static joinPath(l,...r){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return A.isWindows&&l.scheme==="file"?h=T.file(c.win32.join(b(l,!0),...r)).path:h=c.posix.join(l.path,...r),l.with({path:h})}toString(l=!1){return y(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof T)return l;{const r=new m(l);return r._formatted=l.external,r._fsPath=l._sep===E?l.fsPath:null,r}}else return l}}e.URI=T;const E=A.isWindows?1:void 0;class m extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(l=!1){return l?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=E),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(s,l,r){let h,n=-1;for(let t=0;t<s.length;t++){const a=s.charCodeAt(t);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||l&&a===47||r&&a===91||r&&a===93||r&&a===58)n!==-1&&(h+=encodeURIComponent(s.substring(n,t)),n=-1),h!==void 0&&(h+=s.charAt(t));else{h===void 0&&(h=s.substr(0,t));const w=d[a];w!==void 0?(n!==-1&&(h+=encodeURIComponent(s.substring(n,t)),n=-1),h+=w):n===-1&&(n=t)}}return n!==-1&&(h+=encodeURIComponent(s.substring(n))),h!==void 0?h:s}function p(s){let l;for(let r=0;r<s.length;r++){const h=s.charCodeAt(r);h===35||h===63?(l===void 0&&(l=s.substr(0,r)),l+=d[h]):l!==void 0&&(l+=s[r])}return l!==void 0?l:s}function b(s,l){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?l?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=b;function y(s,l){const r=l?p:f;let h="",{scheme:n,authority:t,path:a,query:w,fragment:D}=s;if(n&&(h+=n,h+=":"),(t||n==="file")&&(h+=k,h+=k),t){let F=t.indexOf("@");if(F!==-1){const x=t.substr(0,F);t=t.substr(F+1),F=x.lastIndexOf(":"),F===-1?h+=r(x,!1,!1):(h+=r(x.substr(0,F),!1,!1),h+=":",h+=r(x.substr(F+1),!1,!0)),h+="@"}t=t.toLowerCase(),F=t.lastIndexOf(":"),F===-1?h+=r(t,!1,!0):(h+=r(t.substr(0,F),!1,!0),h+=t.substr(F))}if(a){if(a.length>=3&&a.charCodeAt(0)===47&&a.charCodeAt(2)===58){const F=a.charCodeAt(1);F>=65&&F<=90&&(a=`/${String.fromCharCode(F+32)}:${a.substr(3)}`)}else if(a.length>=2&&a.charCodeAt(1)===58){const F=a.charCodeAt(0);F>=65&&F<=90&&(a=`${String.fromCharCode(F+32)}:${a.substr(2)}`)}h+=r(a,!0,!1)}return w&&(h+="?",h+=r(w,!1,!1)),D&&(h+="#",h+=l?D:f(D,!1,!1)),h}function g(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,l=>g(l)):s}}),define(ye[70],De([1,0,22,8,2]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(I){return JSON.stringify(I,P)}e.stringify=R;function C(I){let L=JSON.parse(I);return L=S(L),L}e.parse=C;function P(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function S(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return u.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof c.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=S(I[k],L+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=S(I[k],L+1))}return I}e.revive=S}),define(ye[16],De([1,0,11,12,2]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,k,v){this.a[L]=k,this.b[L]=v}setConnectionToken(L,k){this.c[L]=k}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return c.onUnexpectedError(d),L}const k=L.authority;let v=this.a[k];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const T=this.b[k],E=this.c[k];let m=`path=${encodeURIComponent(L.path)}`;return typeof E=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),u.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${T}`,path:A.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:m})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const k=this.b(L,ne);return this.uriToBrowserUri(k)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${P.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||P.a,query:null,fragment:null}):L}asFileUri(L){const k=this.b(L,ne);return this.uriToFileUri(k)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==P.a?L.authority:null,query:null,fragment:null}):L}b(L,k){return u.URI.isUri(L)?L:u.URI.parse(k.toUrl(L))}}P.a="vscode-app",e.FileAccess=new P;var S;(function(I){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(L.get("3"));const k="vscode-coi";function v(E){let m;typeof E=="string"?m=new URL(E).searchParams:E instanceof URL?m=E.searchParams:u.URI.isUri(E)&&(m=new URL(E.toString(!0)).searchParams);const d=m?.get(k);if(!!d)return L.get(d)}I.getHeadersFromQuery=v;function T(E,m,d){if(!globalThis.crossOriginIsolated)return;const f=m&&d?"3":d?"2":"1";E instanceof URLSearchParams?E.set(k,f):E[k]=f}I.addSearchParam=T})(S=e.COI||(e.COI={}))}),define(ye[24],De([1,0,32,16,9,12,8,2]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(T){return(0,P.uriToFsPath)(T,!0)}e.originalFSPath=S;class I{constructor(E){this.a=E}compare(E,m,d=!1){return E===m?0:(0,C.compare)(this.getComparisonKey(E,d),this.getComparisonKey(m,d))}isEqual(E,m,d=!1){return E===m?!0:!E||!m?!1:this.getComparisonKey(E,d)===this.getComparisonKey(m,d)}getComparisonKey(E,m=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,m,d=!1){if(E.scheme===m.scheme){if(E.scheme===A.Schemas.file)return c.isEqualOrParent(S(E),S(m),this.a(E))&&E.query===m.query&&(d||E.fragment===m.fragment);if((0,e.isEqualAuthority)(E.authority,m.authority))return c.isEqualOrParent(E.path,m.path,this.a(E),"/")&&E.query===m.query&&(d||E.fragment===m.fragment)}return!1}joinPath(E,...m){return P.URI.joinPath(E,...m)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return u.posix.basename(E.path)}extname(E){return u.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let m;return E.scheme===A.Schemas.file?m=P.URI.file(u.dirname(S(E))).path:(m=u.posix.dirname(E.path),E.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),m="/")),E.with({path:m})}normalizePath(E){if(!E.path.length)return E;let m;return E.scheme===A.Schemas.file?m=P.URI.file(u.normalize(S(E))).path:m=u.posix.normalize(E.path),E.with({path:m})}relativePath(E,m){if(E.scheme!==m.scheme||!(0,e.isEqualAuthority)(E.authority,m.authority))return;if(E.scheme===A.Schemas.file){const p=u.relative(S(E),S(m));return R.isWindows?c.toSlashes(p):p}let d=E.path||"/";const f=m.path||"/";if(this.a(E)){let p=0;for(const b=Math.min(d.length,f.length);p<b&&!(d.charCodeAt(p)!==f.charCodeAt(p)&&d.charAt(p).toLowerCase()!==f.charAt(p).toLowerCase());p++);d=f.substr(0,p)+d.substr(p)}return u.posix.relative(d,f)}resolvePath(E,m){if(E.scheme===A.Schemas.file){const d=P.URI.file(u.resolve(S(E),m));return E.with({authority:d.authority,path:d.path})}return m=c.toPosixPath(m),E.with({path:u.posix.resolve(E.path,m)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,m){return E===m||E!==void 0&&m!==void 0&&(0,C.equalsIgnoreCase)(E,m)}hasTrailingPathSeparator(E,m=u.sep){if(E.scheme===A.Schemas.file){const d=S(E);return d.length>c.getRoot(d).length&&d[d.length-1]===m}else{const d=E.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,m=u.sep){return(0,e.hasTrailingPathSeparator)(E,m)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,m=u.sep){let d=!1;if(E.scheme===A.Schemas.file){const f=S(E);d=f!==void 0&&f.length===c.getRoot(f).length&&f[f.length-1]===m}else{m="/";const f=E.path;d=f.length===1&&f.charCodeAt(f.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(E,m)?E.with({path:E.path+"/"}):E}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,E){const m=[];for(let d=0;d<T.length;d++){const f=E(T[d]);T.some((p,b)=>b===d?!1:(0,e.isEqualOrParent)(f,E(p)))||m.push(T[d])}return m}e.distinctParents=L;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function E(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[y,g]=b.split(":");y&&g&&d.set(y,g)});const p=m.path.substring(0,m.path.indexOf(";"));return p&&d.set(T.META_DATA_MIME,p),d}T.parseMetaData=E})(k=e.DataUri||(e.DataUri={}));function v(T,E,m){if(E){let d=T.path;return d&&d[0]!==u.posix.sep&&(d=u.posix.sep+d),T.with({scheme:m,authority:E,path:d})}return T.with({scheme:m})}e.toLocalResource=v}),define(ye[17],De([1,0,21,11,3,6,24,12,149]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(J){return!!J&&typeof J.then=="function"}e.isThenable=I;function L(J){const ie=new c.CancellationTokenSource,pe=J(ie.token),ve=new Promise((ke,Oe)=>{const oe=ie.token.onCancellationRequested(()=>{oe.dispose(),ie.dispose(),Oe(new A.CancellationError)});Promise.resolve(pe).then(ae=>{oe.dispose(),ie.dispose(),ke(ae)},ae=>{oe.dispose(),ie.dispose(),Oe(ae)})});return new class{cancel(){ie.cancel()}then(ke,Oe){return ve.then(ke,Oe)}catch(ke){return this.then(void 0,ke)}finally(ke){return ve.finally(ke)}}}e.createCancelablePromise=L;function k(J,ie,pe){return new Promise((ve,ke)=>{const Oe=ie.onCancellationRequested(()=>{Oe.dispose(),ve(pe)});J.then(ve,ke).finally(()=>Oe.dispose())})}e.raceCancellation=k;function v(J,ie){return new Promise((pe,ve)=>{const ke=ie.onCancellationRequested(()=>{ke.dispose(),ve(new A.CancellationError)});J.then(pe,ve).finally(()=>ke.dispose())})}e.raceCancellationError=v;async function T(J){let ie=-1;const pe=J.map((ke,Oe)=>ke.then(oe=>(ie=Oe,oe))),ve=await Promise.race(pe);return J.forEach((ke,Oe)=>{Oe!==ie&&ke.cancel()}),ve}e.raceCancellablePromises=T;function E(J,ie,pe){let ve;const ke=setTimeout(()=>{ve?.(void 0),pe?.()},ie);return Promise.race([J.finally(()=>clearTimeout(ke)),new Promise(Oe=>ve=Oe)])}e.raceTimeout=E;function m(J){return new Promise((ie,pe)=>{const ve=J();I(ve)?ve.then(ie,pe):ie(ve)})}e.asPromise=m;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(ie){if(this.a){if(this.d=ie,!this.b){const pe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(pe,pe).then(ve)})}return new Promise((pe,ve)=>{this.b.then(pe,ve)})}return this.a=ie(),new Promise((pe,ve)=>{this.a.then(ke=>{this.a=null,pe(ke)},ke=>{this.a=null,ve(ke)})})}}e.Throttler=d;class f{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.Sequencer=f;class p{constructor(){this.a=new Map}queue(ie,pe){const ke=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(ie)===ke&&this.a.delete(ie)});return this.a.set(ie,ke),ke}}e.SequencerByKey=p;const b=(J,ie)=>{let pe=!0;const ve=setTimeout(()=>{pe=!1,ie()},J);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(ve),pe=!1}}},y=J=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,J())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class g{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,pe=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((ke,Oe)=>{this.d=ke,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ke=this.g;return this.g=null,ke()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=pe===S.MicrotaskDelay?y(ve):b(pe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class i{constructor(ie){this.a=new g(ie),this.b=new d}trigger(ie,pe){return this.a.trigger(()=>this.b.queue(ie),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this.a=!1,this.b=new Promise((ie,pe)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class s extends o{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function l(J,ie){return ie?new Promise((pe,ve)=>{const ke=setTimeout(()=>{Oe.dispose(),pe()},J),Oe=ie.onCancellationRequested(()=>{clearTimeout(ke),Oe.dispose(),ve(new A.CancellationError)})}):L(pe=>l(J,pe))}e.timeout=l;function r(J,ie=0){const pe=setTimeout(J,ie);return(0,R.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=r;function h(J){const ie=[];let pe=0;const ve=J.length;function ke(){return pe<ve?J[pe++]():null}function Oe(oe){oe!=null&&ie.push(oe);const ae=ke();return ae?ae.then(Oe):Promise.resolve(ie)}return Promise.resolve(null).then(Oe)}e.sequence=h;function n(J,ie=ve=>!!ve,pe=null){let ve=0;const ke=J.length,Oe=()=>{if(ve>=ke)return Promise.resolve(pe);const oe=J[ve++];return Promise.resolve(oe()).then(fe=>ie(fe)?Promise.resolve(fe):Oe())};return Oe()}e.first=n;function t(J,ie=ve=>!!ve,pe=null){if(J.length===0)return Promise.resolve(pe);let ve=J.length;const ke=()=>{ve=-1;for(const Oe of J)Oe.cancel?.()};return new Promise((Oe,oe)=>{for(const ae of J)ae.then(fe=>{--ve>=0&&ie(fe)?(ke(),Oe(fe)):ve===0&&Oe(pe)}).catch(fe=>{--ve>=0&&(ke(),oe(fe))})})}e.firstParallel=t;class a{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new u.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((pe,ve)=>{this.f.push({factory:ie,c:pe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const pe=ie.factory();pe.then(ie.c,ie.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=a;class w extends a{constructor(){super(1)}}e.Queue=w;class D{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const ie=new Y;return this.b.add(ie),ie.p}d(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,pe=C.extUri){const ve=pe.getComparisonKey(ie);let ke=this.a.get(ve);return ke||(ke=new w,u.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,ke)),ke}f(){!this.d()||this.g()}g(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.g()}}e.ResourceQueue=D;class F{constructor(ie,pe){this.a=-1,typeof ie=="function"&&typeof pe=="number"&&this.setIfNotSet(ie,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},pe)}setIfNotSet(ie,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},pe))}}e.TimeoutTimer=F;class x{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ie,pe){this.cancel(),this.a=setInterval(()=>{ie()},pe)}}e.IntervalTimer=x;class V{constructor(ie,pe){this.b=-1,this.a=ie,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class M{constructor(ie,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=ie,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class $ extends V{constructor(ie,pe){super(ie,pe),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=$;class O extends R.Disposable{constructor(ie,pe){super(),this.g=ie,this.h=pe,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const pe of ie)this.a.push(pe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,P.setTimeout0)(()=>{if(ie)return;const pe=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.runWhenIdle=(J,ie)=>{const pe=requestIdleCallback(J,typeof ie=="number"?{timeout:ie}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(pe))}}}}();class U{constructor(ie){this.d=!1,this.a=()=>{try{this.f=ie()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=U;async function B(J,ie,pe){let ve;for(let ke=0;ke<pe;ke++)try{return await J()}catch(Oe){ve=Oe,await l(ie)}throw ve}e.retry=B;class j{hasPending(ie){return this.a?typeof ie=="number"?this.a.taskId===ie:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(ie,pe,ve){return this.a={taskId:ie,cancel:()=>ve?.(),promise:pe},pe.then(()=>this.d(ie),()=>this.d(ie)),pe}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}setNext(ie){if(this.b)this.b.run=ie;else{let pe,ve;const ke=new Promise((Oe,oe)=>{pe=Oe,ve=oe});this.b={run:ie,promise:ke,promiseResolve:pe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class de{constructor(ie,pe=()=>Date.now()){this.d=ie,this.f=pe,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.IntervalCounter=de;class Y{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((ie,pe)=>{this.a=ie,this.b=pe})}complete(ie){return new Promise(pe=>{this.a(ie),this.f=!0,pe()})}error(ie){return new Promise(pe=>{this.b(ie),this.d=!0,pe()})}cancel(){new Promise(ie=>{this.b(new A.CancellationError),this.d=!0,ie()})}}e.DeferredPromise=Y;var q;(function(J){async function ie(ve){let ke;const Oe=await Promise.all(ve.map(oe=>oe.then(ae=>ae,ae=>{ke||(ke=ae)})));if(typeof ke<"u")throw ke;return Oe}J.settled=ie;function pe(ve){return new Promise(async(ke,Oe)=>{try{await ve(ke,Oe)}catch(oe){Oe(oe)}})}J.withAsyncBody=pe})(q=e.Promises||(e.Promises={}));var Q;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(Q||(Q={}));class Z{static fromArray(ie){return new Z(pe=>{pe.emitMany(ie)})}static fromPromise(ie){return new Z(async pe=>{pe.emitMany(await ie)})}static fromPromises(ie){return new Z(async pe=>{await Promise.all(ie.map(async ve=>pe.emitOne(await ve)))})}static merge(ie){return new Z(async pe=>{await Promise.all(ie.map(async ve=>{for await(const ke of ve)pe.emitOne(ke)}))})}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new u.Emitter,queueMicrotask(async()=>{const pe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(ie(pe)),this.j()}catch(ve){this.k(ve)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await u.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,pe){return new Z(async ve=>{for await(const ke of ie)ve.emitOne(pe(ke))})}map(ie){return Z.map(this,ie)}static filter(ie,pe){return new Z(async ve=>{for await(const ke of ie)pe(ke)&&ve.emitOne(ke)})}filter(ie){return Z.filter(this,ie)}static coalesce(ie){return Z.filter(ie,pe=>!!pe)}coalesce(){return Z.coalesce(this)}static async toPromise(ie){const pe=[];for await(const ve of ie)pe.push(ve);return pe}toPromise(){return Z.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}Z.EMPTY=Z.fromArray([]),e.AsyncIterableObject=Z;class te extends Z{constructor(ie,pe){super(pe),this.l=ie}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=te;function X(J){const ie=new c.CancellationTokenSource,pe=J(ie.token);return new te(ie,async ve=>{const ke=ie.token.onCancellationRequested(()=>{ke.dispose(),ie.dispose(),ve.reject(new A.CancellationError)});try{for await(const Oe of pe){if(ie.token.isCancellationRequested)return;ve.emitOne(Oe)}ke.dispose(),ie.dispose()}catch(Oe){ke.dispose(),ie.dispose(),ve.reject(Oe)}})}e.createCancelableAsyncIterable=X}),define(ye[38],De([1,0,15,17,32,28,9,12,8]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",v=/\//g;function T(de,Y){switch(de){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${Y?`|${L}${k}+`:""})*?`}}function E(de,Y){if(!de)return[];const q=[];let Q=!1,Z=!1,te="";for(const X of de){switch(X){case Y:if(!Q&&!Z){q.push(te),te="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}te+=X}return te&&q.push(te),q}e.splitGlobAware=E;function m(de){if(!de)return"";let Y="";const q=E(de,e.GLOB_SPLIT);if(q.every(Q=>Q===e.GLOBSTAR))Y=".*";else{let Q=!1;q.forEach((Z,te)=>{if(Z===e.GLOBSTAR){if(Q)return;Y+=T(2,te===q.length-1)}else{let X=!1,J="",ie=!1,pe="";for(const ve of Z){if(ve!=="}"&&X){J+=ve;continue}if(ie&&(ve!=="]"||!pe)){let ke;ve==="-"?ke=ve:(ve==="^"||ve==="!")&&!pe?ke="^":ve===e.GLOB_SPLIT?ke="":ke=(0,S.escapeRegExpCharacters)(ve),pe+=ke;continue}switch(ve){case"{":X=!0;continue;case"[":ie=!0;continue;case"}":{Y+=`(?:${E(J,",").map(oe=>m(oe)).join("|")})`,X=!1,J="";break}case"]":{Y+="["+pe+"]",ie=!1,pe="";break}case"?":Y+=k;continue;case"*":Y+=T(1);continue;default:Y+=(0,S.escapeRegExpCharacters)(ve)}}te<q.length-1&&(q[te+1]!==e.GLOBSTAR||te+2<q.length)&&(Y+=L)}Q=Z===e.GLOBSTAR})}return Y}const d=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},s=function(){return null};function l(de,Y){if(!de)return s;let q;typeof de!="string"?q=de.pattern:q=de,q=q.trim();const Q=`${q}_${!!Y.trimForExclusions}`;let Z=i.get(Q);if(Z)return r(Z,de);let te;return d.test(q)?Z=n(q.substr(4),q):(te=f.exec(h(q,Y)))?Z=t(te[1],q):(Y.trimForExclusions?b:p).test(q)?Z=a(q,Y):(te=y.exec(h(q,Y)))?Z=w(te[1].substr(1),q,!0):(te=g.exec(h(q,Y)))?Z=w(te[1],q,!1):Z=D(q),i.set(Q,Z),r(Z,de)}function r(de,Y){if(typeof Y=="string")return de;const q=function(Q,Z){return(0,u.isEqualOrParent)(Q,Y.base,!P.isLinux)?de((0,S.ltrim)(Q.substr(Y.base.length),C.sep),Z):null};return q.allBasenames=de.allBasenames,q.allPaths=de.allPaths,q.basenames=de.basenames,q.patterns=de.patterns,q}function h(de,Y){return Y.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function n(de,Y){return function(q,Q){return typeof q=="string"&&q.endsWith(de)?Y:null}}function t(de,Y){const q=`/${de}`,Q=`\\${de}`,Z=function(X,J){return typeof X!="string"?null:J?J===de?Y:null:X===de||X.endsWith(q)||X.endsWith(Q)?Y:null},te=[de];return Z.basenames=te,Z.patterns=[Y],Z.allBasenames=te,Z}function a(de,Y){const q=B(de.slice(1,-1).split(",").map(J=>l(J,Y)).filter(J=>J!==s),de),Q=q.length;if(!Q)return s;if(Q===1)return q[0];const Z=function(J,ie){for(let pe=0,ve=q.length;pe<ve;pe++)if(q[pe](J,ie))return de;return null},te=q.find(J=>!!J.allBasenames);te&&(Z.allBasenames=te.allBasenames);const X=q.reduce((J,ie)=>ie.allPaths?J.concat(ie.allPaths):J,[]);return X.length&&(Z.allPaths=X),Z}function w(de,Y,q){const Q=C.sep===C.posix.sep,Z=Q?de:de.replace(v,C.sep),te=C.sep+Z,X=C.posix.sep+de;let J;return q?J=function(ie,pe){return typeof ie=="string"&&(ie===Z||ie.endsWith(te)||!Q&&(ie===de||ie.endsWith(X)))?Y:null}:J=function(ie,pe){return typeof ie=="string"&&(ie===Z||!Q&&ie===de)?Y:null},J.allPaths=[(q?"*/":"./")+de],J}function D(de){try{const Y=new RegExp(`^${m(de)}$`);return function(q){return Y.lastIndex=0,typeof q=="string"&&Y.test(q)?de:null}}catch{return s}}function F(de,Y,q){return!de||typeof Y!="string"?!1:x(de)(Y,void 0,q)}e.match=F;function x(de,Y={}){if(!de)return o;if(typeof de=="string"||V(de)){const q=l(de,Y);if(q===s)return o;const Q=function(Z,te){return!!q(Z,te)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return O(de,Y)}e.parse=x;function V(de){const Y=de;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=V;function M(de){return de.allBasenames||[]}e.getBasenameTerms=M;function $(de){return de.allPaths||[]}e.getPathTerms=$;function O(de,Y){const q=B(Object.getOwnPropertyNames(de).map(J=>U(J,de[J],Y)).filter(J=>J!==s)),Q=q.length;if(!Q)return s;if(!q.some(J=>!!J.requiresSiblings)){if(Q===1)return q[0];const J=function(ve,ke){let Oe;for(let oe=0,ae=q.length;oe<ae;oe++){const fe=q[oe](ve,ke);if(typeof fe=="string")return fe;(0,A.isThenable)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const oe of Oe){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},ie=q.find(ve=>!!ve.allBasenames);ie&&(J.allBasenames=ie.allBasenames);const pe=q.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return pe.length&&(J.allPaths=pe),J}const Z=function(J,ie,pe){let ve,ke;for(let Oe=0,oe=q.length;Oe<oe;Oe++){const ae=q[Oe];ae.requiresSiblings&&pe&&(ie||(ie=(0,C.basename)(J)),ve||(ve=ie.substr(0,ie.length-(0,C.extname)(J).length)));const fe=ae(J,ie,ve,pe);if(typeof fe=="string")return fe;(0,A.isThenable)(fe)&&(ke||(ke=[]),ke.push(fe))}return ke?(async()=>{for(const Oe of ke){const oe=await Oe;if(typeof oe=="string")return oe}return null})():null},te=q.find(J=>!!J.allBasenames);te&&(Z.allBasenames=te.allBasenames);const X=q.reduce((J,ie)=>ie.allPaths?J.concat(ie.allPaths):J,[]);return X.length&&(Z.allPaths=X),Z}function U(de,Y,q){if(Y===!1)return s;const Q=l(de,q);if(Q===s)return s;if(typeof Y=="boolean")return Q;if(Y){const Z=Y.when;if(typeof Z=="string"){const te=(X,J,ie,pe)=>{if(!pe||!Q(X,J))return null;const ve=Z.replace("$(basename)",()=>ie),ke=pe(ve);return(0,A.isThenable)(ke)?ke.then(Oe=>Oe?de:null):ke?de:null};return te.requiresSiblings=!0,te}}return Q}function B(de,Y){const q=de.filter(J=>!!J.basenames);if(q.length<2)return de;const Q=q.reduce((J,ie)=>{const pe=ie.basenames;return pe?J.concat(pe):J},[]);let Z;if(Y){Z=[];for(let J=0,ie=Q.length;J<ie;J++)Z.push(Y)}else Z=q.reduce((J,ie)=>{const pe=ie.patterns;return pe?J.concat(pe):J},[]);const te=function(J,ie){if(typeof J!="string")return null;if(!ie){let ve;for(ve=J.length;ve>0;ve--){const ke=J.charCodeAt(ve-1);if(ke===47||ke===92)break}ie=J.substr(ve)}const pe=Q.indexOf(ie);return pe!==-1?Z[pe]:null};te.basenames=Q,te.patterns=Z,te.allBasenames=Q;const X=de.filter(J=>!J.basenames);return X.push(te),X}function j(de,Y){return(0,c.equals)(de,Y,(q,Q)=>typeof q=="string"&&typeof Q=="string"?q===Q:typeof q!="string"&&typeof Q!="string"?q.base===Q.base&&q.pattern===Q.pattern:!1)}e.patternsEquals=j}),define(ye[109],De([1,0,11,150,24,8,2]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(f):f).replace(/([ \t]+)/g,(b,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(f),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(f,p){const b=new RegExp((0,R.escapeRegExpCharacters)(p),"g");return f.replace(b,(y,g)=>f.charAt(g-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=S;function I(d){return L(d)?!d.value:Array.isArray(d)?d.every(I):!0}e.isEmptyMarkdownString=I;function L(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(d,f){return d===f?!0:!d||!f?!1:d.value===f.value&&d.isTrusted===f.isTrusted&&d.supportThemeIcons===f.supportThemeIcons&&d.supportHtml===f.supportHtml&&(d.baseUri===f.baseUri||!!d.baseUri&&!!f.baseUri&&(0,u.isEqual)(C.URI.from(d.baseUri),C.URI.from(f.baseUri)))}e.markdownStringEqual=k;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function T(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function E(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function m(d){const f=[],p=d.split("|").map(y=>y.trim());d=p[0];const b=p[1];if(b){const y=/height=(\d+)/.exec(b),g=/width=(\d+)/.exec(b),i=y?y[1]:"",o=g?g[1]:"",s=isFinite(parseInt(o)),l=isFinite(parseInt(i));s&&f.push(`width="${o}"`),l&&f.push(`height="${i}"`)}return{href:d,dimensions:f}}e.parseHrefAndDimensions=m}),define(ye[110],De([1,0,15,32,9,12,24,8]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(s,l){const{os:r,tildify:h,relative:n}=l;if(n){const w=I(s,n,r);if(typeof w=="string")return w}let t=s.fsPath;if(r===1&&!R.isWindows?t=t.replace(/\//g,"\\"):r!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),r!==1&&h?.userHome){const w=h.userHome.fsPath;let D;s.scheme!==h.userHome.scheme&&s.path.startsWith(u.posix.sep)?D=h.userHome.with({path:s.path}).fsPath:D=s.fsPath,t=v(D,w,r)}return(r===1?u.win32:u.posix).normalize(L(t,r===1))}e.getPathLabel=S;function I(s,l,r){const h=r===1?u.win32:u.posix,n=r===3?C.extUri:C.extUriIgnorePathCase,t=l.getWorkspace(),a=(0,c.firstOrDefault)(t.folders);if(!a)return;s.scheme!==a.uri.scheme&&s.path.startsWith(u.posix.sep)&&(s=a.uri.with({path:s.path}));const w=l.getWorkspaceFolder(s);if(!w)return;let D;if(n.isEqual(w.uri,s)?D="":D=n.relativePath(w.uri,s)??"",D&&(D=h.normalize(D)),t.folders.length>1&&!l.noPrefix){const F=w.name?w.name:n.basenameOrAuthority(w.uri);D=D?`${F} \u2022 ${D}`:F}return D}function L(s,l=R.isWindows){return(0,A.hasDriveLetter)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let k=Object.create(null);function v(s,l,r=R.OS){if(r===1||!s||!l)return s;let h=k.original===l?k.normalized:void 0;h||(h=l,R.isWindows&&(h=(0,A.toSlashes)(h)),h=`${(0,P.rtrim)(h,u.posix.sep)}${u.posix.sep}`,k={original:l,normalized:h});let n=s;return R.isWindows&&(n=(0,A.toSlashes)(n)),(r===3?n.startsWith(h):(0,P.startsWithIgnoreCase)(n,h))?`~/${n.substr(h.length)}`:s}e.tildify=v;function T(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=T;const E="\u2026",m="\\\\",d="~";function f(s,l=u.sep){const r=new Array(s.length);let h=!1;for(let n=0;n<s.length;n++){const t=s[n];if(t===""){r[n]=`.${l}`;continue}if(!t){r[n]=t;continue}h=!0;let a="",w=t;w.indexOf(m)===0?(a=w.substr(0,w.indexOf(m)+m.length),w=w.substr(w.indexOf(m)+m.length)):w.indexOf(l)===0?(a=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(d)===0&&(a=w.substr(0,w.indexOf(d)+d.length),w=w.substr(w.indexOf(d)+d.length));const D=w.split(l);for(let F=1;h&&F<=D.length;F++)for(let x=D.length-F;h&&x>=0;x--){h=!1;let V=D.slice(x,x+F).join(l);for(let M=0;!h&&M<s.length;M++)if(M!==n&&s[M]&&s[M].indexOf(V)>-1){const $=x+F===D.length,O=x>0&&s[M].indexOf(l)>-1?l+V:V,U=s[M].endsWith(O);h=!$||U}if(!h){let M="";(D[0].endsWith(":")||a!=="")&&(x===1&&(x=0,F++,V=D[0]+l+V),x>0&&(M=D[0]+l),M=a+M),x>0&&(M=M+E+l),M=M+V,x+F<D.length&&(M=M+l+E),r[n]=M}}h&&(r[n]=t)}return r}e.shorten=f;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(s,l=Object.create(null)){const r=[];let h=!1,n="";for(const t of s)if(t==="$"||h&&t==="{")n&&r.push({value:n,type:p.TEXT}),n="",h=!0;else if(t==="}"&&h){const a=l[n];if(typeof a=="string")a.length&&r.push({value:a,type:p.VARIABLE});else if(a){const w=r[r.length-1];(!w||w.type!==p.SEPARATOR)&&r.push({value:a.label,type:p.SEPARATOR})}n="",h=!1}else n+=t;return n&&!h&&r.push({value:n,type:p.TEXT}),r.filter((t,a)=>{if(t.type===p.SEPARATOR){const w=r[a-1],D=r[a+1];return[w,D].every(F=>F&&(F.type===p.VARIABLE||F.type===p.TEXT)&&F.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=b;function y(s,l){return R.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function g(s,l){return R.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(s){const l=s.indexOf("/")!==-1?u.posix:u.win32,r=l.basename(s),h=l.dirname(s);return r.length?{name:r,parentPath:h}:{name:h,parentPath:""}}e.splitName=o}),define(ye[111],De([1,0,22,2]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(k){return k.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const T=this.a.transformIncoming(v);return T===v?v:u(A.URI.from(T))}transformOutgoing(v){const T=this.a.transformOutgoing(v);return T===v?v:u(A.URI.from(T))}transformOutgoingURI(v){const T=this.a.transformOutgoing(v);return T===v?v:A.URI.from(T)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function C(k,v,T){if(!k||T>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return v.transformOutgoing(k);for(const E in k)if(Object.hasOwnProperty.call(k,E)){const m=C(k[E],v,T+1);m!==null&&(k[E]=m)}}return null}function P(k,v){const T=C(k,v,0);return T===null?k:T}e.transformOutgoingURIs=P;function S(k,v,T,E){if(!k||E>200)return null;if(typeof k=="object"){if(k.$mid===1)return T?A.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof c.VSBuffer)return null;for(const m in k)if(Object.hasOwnProperty.call(k,m)){const d=S(k[m],v,T,E+1);d!==null&&(k[m]=d)}}return null}function I(k,v){const T=S(k,v,!1,0);return T===null?k:T}e.transformIncomingURIs=I;function L(k,v){const T=S(k,v,!0,0);return T===null?k:T}e.transformAndReviveIncomingURIs=L}),define(ye[30],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(u){return c.test(u)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){u(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,I="";return I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I}}()}),define(ye[151],De([1,0,15,30]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function u(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=u;function R(P,S,I){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:S,data:I}),value:void 0}}e.createFileDataTransferItem=R;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,I){const L=this.a.get(S);L?L.push(I):this.a.set(this.b(S),[I])}replace(S,I){this.a.set(this.b(S),[I])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,I]of this.a.entries())for(const L of I)yield[S,L]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[I,L]of this.entries())S(L,I)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:P=>(0,c.distinct)(P.map(S=>S.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(S=>!S.startsWith("#"))})}),define(ye[29],De([1,0,52,71,317,17,32,86,9,12,24,2]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function T(O,U=v.UNLINK){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?m(O):E(O)}async function E(O){try{const U=(0,C.randomPath)((0,A.tmpdir)());try{await c.promises.rename(O,U)}catch(B){return B.code==="ENOENT"?void 0:m(O)}m(U).catch(B=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function m(O){return(0,u.promisify)(c.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function f(O,U){return y(await(U?p(O):(0,u.promisify)(c.readdir)(O)))}async function p(O){try{return await(0,u.promisify)(c.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],B=await f(O);for(const j of B){let de=!1,Y=!1,q=!1;try{const Q=await e.Promises.lstat((0,S.join)(O,j));de=Q.isFile(),Y=Q.isDirectory(),q=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}U.push({name:j,isFile:()=>de,isDirectory:()=>Y,isSymbolicLink:()=>q})}return U}function b(O){return y(c.readdirSync(O))}e.readdirSync=b;function y(O){return O.map(U=>typeof U=="string"?I.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=I.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function g(O){const U=await f(O),B=[];for(const j of U)await o.existsDirectory((0,S.join)(O,j))&&B.push(j);return B}function i(O,U=1e3){return new Promise(B=>{let j=!1;const de=setInterval(()=>{j||(j=!0,c.access(O,Y=>{j=!1,Y&&(clearInterval(de),B(void 0))}))},U)})}e.whenDeleted=i;var o;(function(O){async function U(de){let Y;try{if(Y=await e.Promises.lstat(de),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(de),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(de)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw Q}throw q}}O.stat=U;async function B(de){try{const{stat:Y,symbolicLink:q}=await O.stat(de);return Y.isFile()&&q?.dangling!==!0}catch{}return!1}O.existsFile=B;async function j(de){try{const{stat:Y,symbolicLink:q}=await O.stat(de);return Y.isDirectory()&&q?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function l(O,U,B){return s.queueFor(k.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=a(B);return new Promise((de,Y)=>n(O,U,j,q=>q?Y(q):de()))})}let r=!0;function h(O){r=O}e.configureFlushOnWrite=h;function n(O,U,B,j){if(!r)return c.writeFile(O,U,{mode:B.mode,flag:B.flag},j);c.open(O,B.flag,B.mode,(de,Y)=>{if(de)return j(de);c.writeFile(Y,U,q=>{if(q)return c.close(Y,()=>j(q));c.fdatasync(Y,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),h(!1)),c.close(Y,Z=>j(Z))))})})}function t(O,U,B){const j=a(B);if(!r)return c.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const de=c.openSync(O,j.flag,j.mode);try{c.writeFileSync(de,U);try{c.fdatasyncSync(de)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{c.closeSync(de)}}e.writeFileSync=t;function a(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch(B){if(O.toLowerCase()!==U.toLowerCase()&&B.code==="EXDEV"||O.endsWith("."))await D(O,U,{preserveSymlinks:!1}),await T(O,v.MOVE);else throw B}}async function D(O,U,B){return x(O,U,{root:{source:O,target:U},options:B,handledSourcePaths:new Set})}const F=511;async function x(O,U,B){if(B.handledSourcePaths.has(O))return;B.handledSourcePaths.add(O);const{stat:j,symbolicLink:de}=await o.stat(O);if(de){if(B.options.preserveSymlinks)try{return await $(O,U,B)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(de.dangling)return}return j.isDirectory()?V(O,U,j.mode&F,B):M(O,U,j.mode&F)}async function V(O,U,B,j){await e.Promises.mkdir(U,{recursive:!0,mode:B});const de=await f(O);for(const Y of de)await x((0,S.join)(O,Y),(0,S.join)(U,Y),j)}async function M(O,U,B){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,B)}async function $(O,U,B){let j=await e.Promises.readlink(O);(0,C.isEqualOrParent)(j,B.root.source,!I.isLinux)&&(j=(0,S.join)(B.root.target,j.substr(B.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,u.promisify)(c.access)}get stat(){return(0,u.promisify)(c.stat)}get lstat(){return(0,u.promisify)(c.lstat)}get utimes(){return(0,u.promisify)(c.utimes)}get read(){return(O,U,B,j,de)=>new Promise((Y,q)=>{c.read(O,U,B,j,de,(Q,Z,te)=>Q?q(Q):Y({bytesRead:Z,buffer:te}))})}get readFile(){return(0,u.promisify)(c.readFile)}get write(){return(O,U,B,j,de)=>new Promise((Y,q)=>{c.write(O,U,B,j,de,(Q,Z,te)=>Q?q(Q):Y({bytesWritten:Z,buffer:te}))})}get appendFile(){return(0,u.promisify)(c.appendFile)}get fdatasync(){return(0,u.promisify)(c.fdatasync)}get truncate(){return(0,u.promisify)(c.truncate)}get rename(){return(0,u.promisify)(c.rename)}get copyFile(){return(0,u.promisify)(c.copyFile)}get open(){return(0,u.promisify)(c.open)}get close(){return(0,u.promisify)(c.close)}get symlink(){return(0,u.promisify)(c.symlink)}get readlink(){return(0,u.promisify)(c.readlink)}get chmod(){return(0,u.promisify)(c.chmod)}get mkdir(){return(0,u.promisify)(c.mkdir)}get unlink(){return(0,u.promisify)(c.unlink)}get rmdir(){return(0,u.promisify)(c.rmdir)}get realpath(){return(0,u.promisify)(c.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return g}get writeFile(){return l}get rm(){return T}get move(){return w}get copy(){return D}}}),define(ye[112],De([1,0,52,9,12,8,29]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(u.isLinux)return v;const T=(0,A.dirname)(v);if(v===T)return v;const E=((0,A.basename)(v)||v).toLowerCase();try{const d=(0,C.readdirSync)(T).filter(f=>f.toLowerCase()===E);if(d.length===1){const f=P(T);if(f)return(0,A.join)(f,d[0])}else if(d.length>1){const f=d.indexOf(E);if(f>=0){const p=P(T);if(p)return(0,A.join)(p,d[f])}}}catch{}return null}e.realcaseSync=P;async function S(v){if(u.isLinux)return v;const T=(0,A.dirname)(v);if(v===T)return v;const E=((0,A.basename)(v)||v).toLowerCase();try{const d=(await C.Promises.readdir(T)).filter(f=>f.toLowerCase()===E);if(d.length===1){const f=await S(T);if(f)return(0,A.join)(f,d[0])}else if(d.length>1){const f=d.indexOf(E);if(f>=0){const p=await S(T);if(p)return(0,A.join)(p,d[f])}}}catch{}return null}e.realcase=S;async function I(v){try{return await C.Promises.realpath(v)}catch{const E=k(v);return await C.Promises.access(E,c.constants.R_OK),E}}e.realpath=I;function L(v){try{return c.realpathSync(v)}catch{const E=k(v);return c.accessSync(E,c.constants.R_OK),E}}e.realpathSync=L;function k(v){return(0,R.rtrim)((0,A.normalize)(v),A.sep)}}),define(ye[113],De([1,0,9,12,36,104,10,29]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function S(k=u.env){return k.comspec||"cmd.exe"}e.getWindowsShell=S;function I(k){let v=[],T=!1;const E=function(m){if(T){v.push(m);return}(!k.send(m,f=>{if(f&&console.error(f),T=!1,v.length>0){const p=v.slice(0);v=[],p.forEach(b=>E(b))}})||A.isWindows)&&(T=!0)};return{send:E}}e.createQueuedSender=I;var L;(function(k){async function v(T,E,m){if(c.isAbsolute(T))return T;if(E===void 0&&(E=u.cwd()),c.dirname(T)!=="."||(m===void 0&&C.isString(u.env.PATH)&&(m=u.env.PATH.split(c.delimiter)),m===void 0||m.length===0))return c.join(E,T);async function f(p){if(await P.Promises.exists(p)){let b;try{b=await P.Promises.stat(p)}catch(y){y.message.startsWith("EACCES")&&(b=await P.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of m){let b;if(c.isAbsolute(p)?b=c.join(p,T):b=c.join(E,p,T),await f(b))return b;let y=b+".com";if(await f(y)||(y=b+".exe",await f(y)))return y}return c.join(E,T)}k.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,c,A){var u=arguments.length,R=u<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,c):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,c,A);else for(var P=ne.length-1;P>=0;P--)(C=ne[P])&&(R=(u<3?C(R):u>3?C(e,c,R):C(e,c))||R);return u>3&&R&&Object.defineProperty(e,c,R),R};define(ye[114],De([1,0,15,17,22,21,63,11,3,6,70,8,10]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var T;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(T||(T={}));function E(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(m||(m={}));function d(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(f||(f={}));function p(Y){let q=0;for(let Q=0;;Q+=7){const Z=Y.read(1);if(q|=(Z.buffer[0]&127)<<Q,!(Z.buffer[0]&128))return q}}const b=s(0);function y(Y,q){if(q===0){Y.write(b);return}let Q=0;for(let te=q;te!==0;te=te>>>7)Q++;const Z=u.VSBuffer.alloc(Q);for(let te=0;q!==0;te++)Z.buffer[te]=q&127,q=q>>>7,q>0&&(Z.buffer[te]|=128);Y.write(Z)}class g{constructor(q){this.b=q,this.a=0}read(q){const Q=this.b.slice(this.a,this.a+q);return this.a+=Q.byteLength,Q}}e.BufferReader=g;class i{constructor(){this.a=[]}get buffer(){return u.VSBuffer.concat(this.a)}write(q){this.a.push(q)}}e.BufferWriter=i;var o;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(o||(o={}));function s(Y){const q=u.VSBuffer.alloc(1);return q.writeUInt8(Y,0),q}const l={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function h(Y,q){if(typeof q>"u")Y.write(l.Undefined);else if(typeof q=="string"){const Q=u.VSBuffer.fromString(q);Y.write(l.String),y(Y,Q.byteLength),Y.write(Q)}else if(r&&Buffer.isBuffer(q)){const Q=u.VSBuffer.wrap(q);Y.write(l.Buffer),y(Y,Q.byteLength),Y.write(Q)}else if(q instanceof u.VSBuffer)Y.write(l.VSBuffer),y(Y,q.byteLength),Y.write(q);else if(Array.isArray(q)){Y.write(l.Array),y(Y,q.length);for(const Q of q)h(Y,Q)}else if(typeof q=="number"&&(q|0)===q)Y.write(l.Uint),y(Y,q);else{const Q=u.VSBuffer.fromString(JSON.stringify(q));Y.write(l.Object),y(Y,Q.byteLength),Y.write(Q)}}e.serialize=h;function n(Y){switch(Y.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return Y.read(p(Y)).toString();case o.Buffer:return Y.read(p(Y)).buffer;case o.VSBuffer:return Y.read(p(Y));case o.Array:{const Q=p(Y),Z=[];for(let te=0;te<Q;te++)Z.push(n(Y));return Z}case o.Object:return JSON.parse(Y.read(p(Y)).toString());case o.Int:return p(Y)}}e.deserialize=n;class t{constructor(q,Q,Z=null,te=1e3){this.h=q,this.j=Q,this.k=Z,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(q,Q){this.b.set(q,Q),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const Q=this.o([q.type]);this.k?.logOutgoing(Q,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([q.type,q.id],q.data);this.k?.logOutgoing(Q,q.id,1,d(q.type),q.data);return}}}o(q,Q=void 0){const Z=new i;return h(Z,q),h(Z,Q),this.p(Z.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const Q=new g(q),Z=n(Q),te=n(Q),X=Z[0];switch(X){case 100:return this.k?.logIncoming(q.byteLength,Z[1],1,`${E(X)}: ${Z[2]}.${Z[3]}`,te),this.s({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case 102:return this.k?.logIncoming(q.byteLength,Z[1],1,`${E(X)}: ${Z[2]}.${Z[3]}`,te),this.t({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case 101:return this.k?.logIncoming(q.byteLength,Z[1],1,`${E(X)}`),this.u({type:X,id:Z[1]});case 103:return this.k?.logIncoming(q.byteLength,Z[1],1,`${E(X)}`),this.u({type:X,id:Z[1]})}}s(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const Z=new R.CancellationTokenSource;let te;try{te=Q.call(this.j,q.name,q.arg,Z.token)}catch(ie){te=Promise.reject(ie)}const X=q.id;te.then(ie=>{this.m({id:X,data:ie,type:201}),this.d.delete(q.id)},ie=>{ie instanceof Error?this.m({id:X,data:{message:ie.message,name:ie.name,stack:ie.stack?ie.stack.split?ie.stack.split(`
`):ie.stack:void 0},type:202}):this.m({id:X,data:ie,type:203}),this.d.delete(q.id)});const J=(0,I.toDisposable)(()=>Z.cancel());this.d.set(q.id,J)}t(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const Z=q.id,X=Q.listen(this.j,q.name,q.arg)(J=>this.m({id:Z,data:J,type:204}));this.d.set(q.id,X)}u(q){const Q=this.d.get(q.id);Q&&(Q.dispose(),this.d.delete(q.id))}v(q){let Q=this.g.get(q.channelName);Q||(Q=[],this.g.set(q.channelName,Q));const Z=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:q,timeoutTimer:Z})}w(q){const Q=this.g.get(q);if(Q){for(const Z of Q)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,I.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var a;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(q,Q=null){this.l=q,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=Q}getChannel(q){const Q=this;return{call(Z,te,X){return Q.a?Promise.reject(new P.CancellationError):Q.m(q,Z,te,X)},listen(Z,te){return Q.a?S.Event.None:Q.o(q,Z,te)}}}m(q,Q,Z,te=R.CancellationToken.None){const X=this.g++,ie={id:X,type:100,channelName:q,name:Q,arg:Z};if(te.isCancellationRequested)return Promise.reject(new P.CancellationError);let pe;return new Promise((ke,Oe)=>{if(te.isCancellationRequested)return Oe(new P.CancellationError);const oe=()=>{const le=re=>{switch(re.type){case 201:this.f.delete(X),ke(re.data);break;case 202:{this.f.delete(X);const N=new Error(re.data.message);N.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,N.name=re.data.name,Oe(N);break}case 203:this.f.delete(X),Oe(re.data);break}};this.f.set(X,le),this.p(ie)};let ae=null;this.b===f.Idle?oe():(ae=(0,A.createCancelablePromise)(le=>this.u()),ae.then(()=>{ae=null,oe()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.p({id:X,type:101}),Oe(new P.CancellationError)},ee=te.onCancellationRequested(fe);pe=(0,I.combinedDisposable)((0,I.toDisposable)(fe),ee),this.d.add(pe)}).finally(()=>{this.d.delete(pe)})}o(q,Q,Z){const te=this.g++,J={id:te,type:102,channelName:q,name:Q,arg:Z};let ie=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{ie=(0,A.createCancelablePromise)(ke=>this.u()),ie.then(()=>{ie=null,this.d.add(pe),this.p(J)})},onDidRemoveLastListener:()=>{ie?(ie.cancel(),ie=null):(this.d.delete(pe),this.p({id:te,type:103}))}}),ve=ke=>pe.fire(ke.data);return this.f.set(te,ve),pe.event}p(q){switch(q.type){case 100:case 102:{const Q=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(Q,q.id,0,`${E(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Q=this.q([q.type,q.id]);this.j?.logOutgoing(Q,q.id,0,E(q.type));return}}}q(q,Q=void 0){const Z=new i;return h(Z,q),h(Z,Q),this.r(Z.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const Q=new g(q),Z=n(Q),te=n(Q),X=Z[0];switch(X){case 200:return this.j?.logIncoming(q.byteLength,0,0,d(X)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,Z[1],0,d(X),te),this.t({type:Z[0],id:Z[1],data:te})}}t(q){if(q.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,I.dispose)(this.d.values()),this.d.clear()}}qe([C.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class D{get connections(){const q=[];return this.f.forEach(Q=>q.push(Q)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,q(({protocol:Q,onDidClientDisconnect:Z})=>{S.Event.once(Q.onMessage)(X=>{const J=new g(X),ie=n(J),pe=new t(Q,ie),ve=new w(Q);this.a.forEach((Oe,oe)=>pe.registerChannel(oe,Oe));const ke={channelServer:pe,channelClient:ve,ctx:ie};this.f.add(ke),this.g.fire(ke),Z(()=>{pe.dispose(),ve.dispose(),this.f.delete(ke),this.h.fire(ke)})})})}getChannel(q,Q){const Z=this;return{call(te,X,J){let ie;if((0,v.isFunction)(Q)){const ve=(0,c.getRandomElement)(Z.connections.filter(Q));ie=ve?Promise.resolve(ve):S.Event.toPromise(S.Event.filter(Z.onDidAddConnection,Q))}else ie=Q.routeCall(Z,te,X);const pe=ie.then(ve=>ve.channelClient.getChannel(q));return x(pe).call(te,X,J)},listen(te,X){if((0,v.isFunction)(Q))return Z.j(q,Q,te,X);const J=Q.routeEvent(Z,te,X).then(ie=>ie.channelClient.getChannel(q));return x(J).listen(te,X)}}}j(q,Q,Z,te){const X=this;let J=new I.DisposableStore;const ie=new S.Emitter({onWillAddFirstListener:()=>{J=new I.DisposableStore;const pe=new S.EventMultiplexer,ve=new Map,ke=oe=>{const fe=oe.channelClient.getChannel(q).listen(Z,te),ee=pe.add(fe);ve.set(oe,ee)},Oe=oe=>{const ae=ve.get(oe);!ae||(ae.dispose(),ve.delete(oe))};X.connections.filter(Q).forEach(ke),S.Event.filter(X.onDidAddConnection,Q)(ke,void 0,J),X.onDidRemoveConnection(Oe,void 0,J),pe.event(ie.fire,ie,J),J.add(pe)},onDidRemoveLastListener:()=>{J.dispose()}});return ie.event}registerChannel(q,Q){this.a.set(q,Q),this.f.forEach(Z=>{Z.channelServer.registerChannel(q,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=D;class F{constructor(q,Q,Z=null){const te=new i;h(te,Q),q.send(te.buffer),this.a=new w(q,Z),this.d=new t(q,Q,Z)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,Q){this.d.registerChannel(q,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function x(Y){return{call(q,Q,Z){return Y.then(te=>te.call(q,Q,Z))},listen(q,Q){const Z=new S.Relay;return Y.then(te=>Z.input=te.listen(q,Q)),Z.event}}}e.getDelayedChannel=x;function V(Y){let q=!1;return{call(Q,Z,te){return q?Y.call(Q,Z,te):(0,A.timeout)(0).then(()=>q=!0).then(()=>Y.call(Q,Z,te))},listen(Q,Z){if(q)return Y.listen(Q,Z);const te=new S.Relay;return(0,A.timeout)(0).then(()=>q=!0).then(()=>te.input=Y.listen(Q,Z)),te.event}}}e.getNextTickChannel=V;class M{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const Q of q.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.StaticRouter=M;var $;(function(Y){function q(X,J){const ie=X,pe=J&&J.disableMarshalling,ve=new Map;for(const ke in ie)Z(ke)&&ve.set(ke,S.Event.buffer(ie[ke],!0));return new class{listen(ke,Oe,oe){const ae=ve.get(Oe);if(ae)return ae;if(te(Oe)){const fe=ie[Oe];if(typeof fe=="function")return fe.call(ie,oe)}throw new Error(`Event not found: ${Oe}`)}call(ke,Oe,oe){const ae=ie[Oe];if(typeof ae=="function"){if(!pe&&Array.isArray(oe))for(let fe=0;fe<oe.length;fe++)oe[fe]=(0,L.revive)(oe[fe]);return ae.apply(ie,oe)}throw new Error(`Method not found: ${Oe}`)}}}Y.fromService=q;function Q(X,J){const ie=J&&J.disableMarshalling;return new Proxy({},{get(pe,ve){if(typeof ve=="string")return J?.properties?.has(ve)?J.properties.get(ve):te(ve)?function(ke){return X.listen(ve,ke)}:Z(ve)?X.listen(ve):async function(...ke){let Oe;J&&!(0,v.isUndefinedOrNull)(J.context)?Oe=[J.context,...ke]:Oe=ke;const oe=await X.call(ve,Oe);return ie?oe:(0,L.revive)(oe)};throw new Error(`Property not found: ${String(ve)}`)}})}Y.toService=Q;function Z(X){return X[0]==="o"&&X[1]==="n"&&k.isUpperAsciiLetter(X.charCodeAt(2))}function te(X){return/^onDynamic/.test(X)&&k.isUpperAsciiLetter(X.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const q=Y.toString();if(q!=="[object Object]")return q}return Y}function B(Y){return Array.isArray(Y)?Y.map(U):U(Y)}function j(Y,q,Q,Z,te,X,J){J=B(J);const ie=O[te],pe=ie[Z%ie.length];let ve=[`%c[${Y}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(X)?(ve=ve.concat(J),ve.push(")")):ve.push(J),console.log.apply(console,ve)}class de{constructor(q,Q){this.d=q,this.f=Q,this.a=0,this.b=0}logOutgoing(q,Q,Z,te,X){this.b+=q,j(this.d,this.b,q,Q,Z,te,X)}logIncoming(q,Q,Z,te,X){this.a+=q,j(this.f,this.a,q,Q,Z,te,X)}}e.IPCLogger=de}),define(ye[115],De([1,0,17,22,3,6,114]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(w){w.enableDiagnostics=!1,w.records=[];const D=new WeakMap;let F=0;function x(M,$){if(!D.has(M)){const O=String(++F);D.set(M,O)}return D.get(M)}function V(M,$,O,U){if(!w.enableDiagnostics)return;const B=x(M,$);if(U instanceof A.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=A.VSBuffer.alloc(U.byteLength);j.set(U),w.records.push({timestamp:Date.now(),id:B,label:$,type:O,buff:j})}else w.records.push({timestamp:Date.now(),id:B,label:$,type:O,data:U})}w.traceSocketEvent=V})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function k(){return L||(L=A.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(D){this.a.push(D),this.b+=D.byteLength}read(D){return this.c(D,!0)}peek(D){return this.c(D,!1)}c(D,F){if(D===0)return k();if(D>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===D){const $=this.a[0];return F&&(this.a.shift(),this.b-=D),$}if(this.a[0].byteLength>D){const $=this.a[0].slice(0,D);return F&&(this.a[0]=this.a[0].slice(D),this.b-=D),$}const x=A.VSBuffer.alloc(D);let V=0,M=0;for(;D>0;){const $=this.a[M];if($.byteLength>D){const O=$.slice(0,D);x.set(O,V),V+=D,F&&(this.a[M]=$.slice(D),this.b-=D),D-=D}else x.set($,V),V+=$.byteLength,F?(this.a.shift(),this.b-=$.byteLength):M++,D-=$.byteLength}return x}}e.ChunkStream=v;var T;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(T||(T={}));function E(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(D,F,x,V){this.type=D,this.id=F,this.ack=x,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(D){super(),this.f=this.B(new u.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=D,this.b=!1,this.c=new v,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(D){if(!(!D||D.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(D);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const x=this.g.messageType,V=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new d(x,V,M,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(D){this.k=null,this.a=!1,this.b=!1,this.c=D,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(D){if(this.a)return;D.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=A.VSBuffer.alloc(13);F.writeUInt8(D.type,0),F.writeUInt32BE(D.id,1),F.writeUInt32BE(D.ack,5),F.writeUInt32BE(D.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(D.type),id:D.id,ack:D.ack,messageSize:D.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",D.data),this.j(F,D.data)}g(D,F){const x=this.f===0;return this.d.push(D,F),this.f+=D.byteLength+F.byteLength,x}h(){const D=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,D}j(D,F){this.g(D,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const D=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:D.byteLength}),this.c.write(D)}}class b extends R.Disposable{constructor(D){super(),this.f=new u.Emitter,this.onMessage=this.f.event,this.g=new u.Emitter,this.onDidDispose=this.g.event,this.a=D,this.b=this.B(new p(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(D){this.b.write(new d(1,0,0,D))}}e.Protocol=b;class y extends C.IPCClient{static fromSocket(D,F){return new y(new b(D),F)}get onDidDispose(){return this.b.onDidDispose}constructor(D,F,x=null){super(D,F,x),this.b=D}dispose(){super.dispose();const D=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),D.end()}}e.Client=y;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(D){this.b?this.d.length>0?this.d.push(D):this.a.fire(D):this.d.push(D)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class i{constructor(D){this.data=D,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let D=0,F=this.a;for(;F;)F=F.next,D++;return D}peek(){return this.a?this.a.data:null}toArray(){const D=[];let F=0,x=this.a;for(;x;)D[F++]=x.data,x=x.next;return D}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(D){const F=new i(D);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const D=Date.now();for(let F=0;F<s.a;F++)this.c[F]=D-1e3*F;setInterval(()=>{for(let F=s.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const D=Date.now(),F=(1+s.a)*1e3;let x=0;for(let V=0;V<s.a;V++)D-this.c[V]<=F&&x++;return 1-x/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var l;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(l=e.ConnectionHealth||(e.ConnectionHealth={}));function r(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class h{constructor(D){this.connectionHealth=D}}e.ConnectionHealthChangedEvent=h;class n{constructor(D,F){this.roundTripTime=D,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=n;class t{get unacknowledgedCount(){return this.c-this.d}constructor(D){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=D.loadEstimator??s.getInstance(),this.v=D.measureRoundTripTime??!1,this.w=D.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=D.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new a),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),D.initialChunk&&this.q.acceptChunk(D.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const D=new d(5,0,0,k());this.p.write(D),this.p.flush()}sendPause(){const D=new d(7,0,0,k());this.p.write(D)}sendResume(){const D=new d(8,0,0,k());this.p.write(D)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(D,F){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=D,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(x=>this.E(x))),this.t.add(this.o.onClose(x=>this.A.fire(x))),this.r=this.t.add(new a),this.t.add(this.r.onSendLatencyRequest(x=>this.J(x))),this.t.add(this.r.onHighRoundTripTime(x=>this.C.fire(x))),this.t.add(this.r.onDidChangeConnectionHealth(x=>this.D.fire(x))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const D=new d(3,0,this.h,k());this.p.write(D);const F=this.b.toArray();for(let x=0,V=F.length;x<V;x++)this.p.write(F[x]);this.G()}acceptDisconnect(){this.z.fire()}E(D){if(D.ack>this.d){this.d=D.ack;do{const F=this.b.peek();if(F&&F.id<=D.ack)this.b.pop();else break}while(!0)}switch(D.type){case 0:break;case 1:{if(D.id>this.g)if(D.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new d(6,0,0,k())))}else this.g=D.id,this.j=Date.now(),this.F(),this.y.fire(D.data);break}case 2:{this.x.fire(D.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let x=0,V=F.length;x<V;x++)this.p.write(F[x]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(D.data);break}case 11:{this.r.handleResponse(D.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(D){const F=++this.c;this.h=this.g;const x=new d(1,F,this.h,D);this.b.push(x),this.a||(this.p.write(x),this.G())}sendControl(D){const F=new d(2,0,0,D);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const D=Date.now()-this.j;if(D>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-D+5)}G(){if(this.c<=this.d||this.f||this.a)return;const D=this.b.peek(),F=Date.now()-D.writtenTime,x=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(F>=2e4&&x>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:x});return}const M=Math.max(2e4-F,2e4-x,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},M)}H(){if(this.g<=this.h)return;this.h=this.g;const D=new d(3,0,this.h,k());this.p.write(D)}I(){this.h=this.g;const D=new d(9,0,this.h,k());this.p.write(D)}J(D){this.h=this.g;const F=new d(10,0,this.h,D);this.p.write(F)}K(D){this.h=this.g;const F=new d(11,0,this.h,D);this.p.write(F)}}e.PersistentProtocol=t;class a extends R.Disposable{constructor(){super(),this.a=this.B(new u.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new u.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new u.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},D=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const D=++this.h,F=A.VSBuffer.alloc(4);F.writeUInt32BE(D,0),this.a.fire(F)},6e4)}handleResponse(D){if(D.byteLength!==4)return;const F=D.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const x=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=x;const M=this.l,$=this.j.filter(O=>O>=1e3).length;this.l=$>=3?1:0,x>1e3&&this.b.fire(new n(x,$)),M!==this.l&&this.c.fire(this.l)}}}),define(ye[116],De([1,0,22,11,3,6,9,12,30,114,115]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,t){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,t)}constructor(n,t=""){this.f=!0,this.debugLabel=t,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=a=>{if(this.traceSocketEvent("error",{code:a?.code,message:a?.message}),a){if(a.code==="EPIPE")return;(0,A.onUnexpectedError)(a)}},this.socket.on("error",this.a),this.b=a=>{this.traceSocketEvent("close",{hadError:a}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const t=a=>{this.traceSocketEvent("read",a),n(c.VSBuffer.wrap(a))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(n){const t=a=>{n({type:0,hadError:a,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(n){const t=()=>{n()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const a=()=>{this.socket.off("close",a),this.socket.off("end",a),this.socket.off("error",a),this.socket.off("timeout",a),this.socket.off("drain",a),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",a),this.socket.on("end",a),this.socket.on("error",a),this.socket.on("timeout",a),this.socket.on("drain",a)})}}e.NodeSocket=v;var T;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var E;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(E||(E={}));class m extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,t){this.socket.traceSocketEvent(n,t)}constructor(n,t,a,w){super(),this.f=this.B(new u.Emitter),this.g=this.B(new u.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:a?.byteLength||0,recordInflateBytes:w}),this.a=this.B(new d(this,t,a,w,this.f,(D,F)=>this.k(D,F))),this.B(this.a.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this.g.fire({type:0,hadError:!0,error:D})})),this.b=new L.ChunkStream,this.B(this.socket.onData(D=>this.l(D))),this.B(this.socket.onClose(D=>this.g.fire(D)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let a=2;n.byteLength<126?a+=0:n.byteLength<2**16?a+=2:a+=8;const w=c.VSBuffer.alloc(a);if(t?w.writeUInt8(194,0):w.writeUInt8(130,0),n.byteLength<126)w.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){w.writeUInt8(126,1);let D=1;w.writeUInt8(n.byteLength>>>8&255,++D),w.writeUInt8(n.byteLength>>>0&255,++D)}else{w.writeUInt8(127,1);let D=1;w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(n.byteLength>>>24&255,++D),w.writeUInt8(n.byteLength>>>16&255,++D),w.writeUInt8(n.byteLength>>>8&255,++D),w.writeUInt8(n.byteLength>>>0&255,++D)}this.socket.write(c.VSBuffer.concat([w,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),a=t.readUInt8(0),w=(a&128)>>>7,D=(a&64)>>>6,F=t.readUInt8(1),x=(F&128)>>>7,V=F&127;this.j.state=2,this.j.readLen=2+(x?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=w,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(D)),this.j.firstFrameOfMessage=Boolean(w),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),a=t.readUInt8(1),w=(a&128)>>>7;let D=a&127,F=1;D===126?D=t.readUInt8(++F)*2**8+t.readUInt8(++F):D===127&&(D=t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*2**24+t.readUInt8(++F)*2**16+t.readUInt8(++F)*2**8+t.readUInt8(++F));let x=0;w&&(x=t.readUInt8(++F)*2**24+t.readUInt8(++F)*2**16+t.readUInt8(++F)*2**8+t.readUInt8(++F)),this.j.state=3,this.j.readLen=D,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),b(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,t,a,w,D,F){super(),this.k=n,this.l=D,this.m=F,this.a=this.B(new u.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,t?(this.b=this.B(new f(this.k,w,a,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const t=await this.r(this.f,n);this.m(t,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,t){return new Promise((a,w)=>{n.write(t),n.flush(D=>a(D))})}acceptFrame(n,t,a){this.h.push({data:n,isCompressed:t,isLastFrameOfMessage:a}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const t=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(t)}else this.l.fire(n.data)}this.s=!1}}u(n,t,a){return new Promise((w,D)=>{n.write(t),a&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(F=>w(F))})}}class f extends R.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(n,t,a,w){super(),this.h=n,this.j=t,this.a=this.B(new u.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(w),this.b.on("error",D=>{this.h.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.h.traceSocketEvent("zlibInflateData",D),this.g.push(c.VSBuffer.wrap(D))}),a&&(this.h.traceSocketEvent("zlibInflateInitialWrite",a.buffer),this.b.write(a.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=c.VSBuffer.concat(this.g);this.g.length=0,n(t)})}}class p extends R.Disposable{constructor(n,t){super(),this.g=n,this.a=this.B(new u.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",a=>{this.g.traceSocketEvent("zlibDeflateError",{message:a?.message,code:a?.code}),this.a.fire(a)}),this.b.on("data",a=>{this.g.traceSocketEvent("zlibDeflateData",a),this.f.push(c.VSBuffer.wrap(a))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=c.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),n(t)})}}function b(h,n){if(n===0)return;const t=h.byteLength>>>2;for(let V=0;V<t;V++){const M=h.readUInt32BE(V*4);h.writeUInt32BE(M^n,V*4)}const a=t*4,w=h.byteLength-a,D=n>>>24&255,F=n>>>16&255,x=n>>>8&255;w>=1&&h.writeUInt8(h.readUInt8(a)^D,a),w>=2&&h.writeUInt8(h.readUInt8(a+1)^F,a+1),w>=3&&h.writeUInt8(h.readUInt8(a+2)^x,a+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const y={[2]:107,[1]:103};function g(){const h=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):n=(0,C.join)(k().os.tmpdir(),`vscode-ipc-${h}.sock`),o(n),n}e.createRandomIPCHandle=g;function i(h,n,t){const a=k().crypto.createHash("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${a}-${t}-${n}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${a.substr(0,8)}-${t}-${n}.sock`):w=(0,C.join)(h,`${t}-${n}.sock`),o(w),w}e.createStaticIPCHandle=i;function o(h){const n=y[P.platform];typeof n=="number"&&h.length>=n&&console.warn(`WARNING: IPC handle "${h}" is longer than ${n} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{static b(n){const t=u.Event.fromNodeEventEmitter(n,"connection");return u.Event.map(t,a=>({protocol:new L.Protocol(new v(a,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(a,"close"))}))}constructor(n){super(s.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=s;function l(h){return new Promise((n,t)=>{const a=k().net.createServer();a.on("error",t),a.listen(h,()=>{a.removeListener("error",t),n(new s(a))})})}e.serve=l;function r(h,n){return new Promise((t,a)=>{const w=k().net.createConnection(h,()=>{w.removeListener("error",a),t(L.Client.fromSocket(new v(w,`ipc-client${n}`),n))});w.once("error",a)})}e.connect=r}),define(ye[117],De([1,0,108]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const S=(0,c.toUint8)(P);this.c=S,this.a=A.d(S),this.b=new Map}static d(P){const S=new Uint8Array(256);return S.fill(P),S}set(P,S){const I=(0,c.toUint8)(S);P>=0&&P<256?this.a[P]=I:this.b.set(P,I)}get(P){return P>=0&&P<256?this.a[P]:this.b.get(P)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var u;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(u||(u={}));class R{constructor(){this.a=new A(0)}add(P){this.a.set(P,1)}has(P){return this.a.get(P)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[53],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(u,R){this.lineNumber=u,this.column=R}with(u=this.lineNumber,R=this.column){return u===this.lineNumber&&R===this.column?this:new c(u,R)}delta(u=0,R=0){return this.with(this.lineNumber+u,this.column+R)}equals(u){return c.equals(this,u)}static equals(u,R){return!u&&!R?!0:!!u&&!!R&&u.lineNumber===R.lineNumber&&u.column===R.column}isBefore(u){return c.isBefore(this,u)}static isBefore(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<R.column}isBeforeOrEqual(u){return c.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<=R.column}static compare(u,R){const C=u.lineNumber|0,P=R.lineNumber|0;if(C===P){const S=u.column|0,I=R.column|0;return S-I}return C-P}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new c(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=c}),define(ye[33],De([1,0,53]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,C,P,S){R>P||R===P&&C>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=R,this.endColumn=C):(this.startLineNumber=R,this.startColumn=C,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,C){return!(C.lineNumber<R.startLineNumber||C.lineNumber>R.endLineNumber||C.lineNumber===R.startLineNumber&&C.column<R.startColumn||C.lineNumber===R.endLineNumber&&C.column>R.endColumn)}static strictContainsPosition(R,C){return!(C.lineNumber<R.startLineNumber||C.lineNumber>R.endLineNumber||C.lineNumber===R.startLineNumber&&C.column<=R.startColumn||C.lineNumber===R.endLineNumber&&C.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,C){return!(C.startLineNumber<R.startLineNumber||C.endLineNumber<R.startLineNumber||C.startLineNumber>R.endLineNumber||C.endLineNumber>R.endLineNumber||C.startLineNumber===R.startLineNumber&&C.startColumn<R.startColumn||C.endLineNumber===R.endLineNumber&&C.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,C){return!(C.startLineNumber<R.startLineNumber||C.endLineNumber<R.startLineNumber||C.startLineNumber>R.endLineNumber||C.endLineNumber>R.endLineNumber||C.startLineNumber===R.startLineNumber&&C.startColumn<=R.startColumn||C.endLineNumber===R.endLineNumber&&C.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,C){let P,S,I,L;return C.startLineNumber<R.startLineNumber?(P=C.startLineNumber,S=C.startColumn):C.startLineNumber===R.startLineNumber?(P=C.startLineNumber,S=Math.min(C.startColumn,R.startColumn)):(P=R.startLineNumber,S=R.startColumn),C.endLineNumber>R.endLineNumber?(I=C.endLineNumber,L=C.endColumn):C.endLineNumber===R.endLineNumber?(I=C.endLineNumber,L=Math.max(C.endColumn,R.endColumn)):(I=R.endLineNumber,L=R.endColumn),new A(P,S,I,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,C){let P=R.startLineNumber,S=R.startColumn,I=R.endLineNumber,L=R.endColumn;const k=C.startLineNumber,v=C.startColumn,T=C.endLineNumber,E=C.endColumn;return P<k?(P=k,S=v):P===k&&(S=Math.max(S,v)),I>T?(I=T,L=E):I===T&&(L=Math.min(L,E)),P>I||P===I&&S>L?null:new A(P,S,I,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,C){return!R&&!C?!0:!!R&&!!C&&R.startLineNumber===C.startLineNumber&&R.startColumn===C.startColumn&&R.endLineNumber===C.endLineNumber&&R.endColumn===C.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new c.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new c.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,C){return new A(this.startLineNumber,this.startColumn,R,C)}setStartPosition(R,C){return new A(R,C,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,C=R){return new A(R.lineNumber,R.column,C.lineNumber,C.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,C){return!(R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn||C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn)}static areIntersecting(R,C){return!(R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn||C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,C){if(R&&C){const I=R.startLineNumber|0,L=C.startLineNumber|0;if(I===L){const k=R.startColumn|0,v=C.startColumn|0;if(k===v){const T=R.endLineNumber|0,E=C.endLineNumber|0;if(T===E){const m=R.endColumn|0,d=C.endColumn|0;return m-d}return T-E}return k-v}return I-L}return(R?1:0)-(C?1:0)}static compareRangesUsingEnds(R,C){return R.endLineNumber===C.endLineNumber?R.endColumn===C.endColumn?R.startLineNumber===C.startLineNumber?R.startColumn-C.startColumn:R.startLineNumber-C.startLineNumber:R.endColumn-C.endColumn:R.endLineNumber-C.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(ye[152],De([1,0,53,33]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(u=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(P,S,I,L){super(P,S,I,L),this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return R.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,P,S):new R(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,S){return this.getDirection()===0?new R(P,S,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new R(P.lineNumber,P.column,S.lineNumber,S.column)}static fromRange(P,S){return S===0?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new R(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new R(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let I=0,L=P.length;I<L;I++)if(!this.selectionsEqual(P[I],S[I]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,I,L,k){return k===0?new R(P,S,I,L):new R(I,L,P,S)}}e.Selection=R}),define(ye[153],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[154],De([1,0,117]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class u extends c.CharacterClassifier{constructor(P){super(0);for(let S=0,I=P.length;S<I;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function R(C){const P={};return S=>(P.hasOwnProperty(S)||(P[S]=C(S)),P[S])}e.getMapForWordSeparators=R(C=>new u(C))}),define(ye[118],De([1,0,65,6,67]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(k=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(v+="\\"+T);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function C(k){let v=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)v=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),v=new RegExp(k.source,T)}return v.lastIndex=0,v}e.ensureValidWordDefinition=C;const P=new u.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(k){const v=P.unshift(k);return(0,A.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=S;function I(k,v,T,E,m){if(m||(m=c.Iterable.first(P)),T.length>m.maxLen){let y=k-m.maxLen/2;return y<0?y=0:E+=y,T=T.substring(y,k+m.maxLen/2),I(k,v,T,E,m)}const d=Date.now(),f=k-1-E;let p=-1,b=null;for(let y=1;!(Date.now()-d>=m.timeBudget);y++){const g=f-m.windowSize*y;v.lastIndex=Math.max(0,g);const i=L(v,T,f,p);if(!i&&b||(b=i,g<=0))break;p=g}if(b){const y={word:b[0],startColumn:E+1+b.index,endColumn:E+1+b.index+b[0].length};return v.lastIndex=0,y}return null}e.getWordAtText=I;function L(k,v,T,E){let m;for(;m=k.exec(v);){const d=m.index||0;if(d<=T&&k.lastIndex>=T)return m;if(E>0&&d>E)return null}return null}}),define(ye[155],De([1,0,38,9]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(R,C,P,S,I,L){if(Array.isArray(R)){let k=0;for(const v of R){const T=u(v,C,P,S,I,L);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof R=="string")return S?R==="*"?5:R===P?10:0:0;if(R){const{language:k,pattern:v,scheme:T,hasAccessToAllModels:E,notebookType:m}=R;if(!S&&!E)return 0;m&&I&&(C=I);let d=0;if(T)if(T===C.scheme)d=10;else if(T==="*")d=5;else return 0;if(k)if(k===P)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(m)if(m===L)d=10;else if(m==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let f;if(typeof v=="string"?f=v:f={...v,base:(0,A.normalize)(v.base)},f===C.fsPath||(0,c.match)(f,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=u}),define(ye[156],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class A{constructor(P){if(this.e=null,this.f=!1,this.open=P.open,this.close=P.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(P.notIn))for(let S=0,I=P.notIn.length;S<I;S++)switch(P.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(P,S){if(P.getTokenCount()===0)return!0;const I=P.findTokenIndexAtOffset(S-2),L=P.getStandardTokenType(I);return this.isOK(L)}g(P,S){for(let I=P;I<=S;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class u{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)R(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),R(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),R(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),R(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&R(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=u;function R(C,P,S){C.has(P)?C.get(P).push(S):C.set(P,[S])}}),define(ye[157],De([1,0,117]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class u{constructor(E,m,d){const f=new Uint8Array(E*m);for(let p=0,b=E*m;p<b;p++)f[p]=d;this.a=f,this.rows=E,this.cols=m}get(E,m){return this.a[E*this.cols+m]}set(E,m,d){this.a[E*this.cols+m]=d}}class R{constructor(E){let m=0,d=0;for(let p=0,b=E.length;p<b;p++){const[y,g,i]=E[p];g>m&&(m=g),y>d&&(d=y),i>d&&(d=i)}m++,d++;const f=new u(d,m,0);for(let p=0,b=E.length;p<b;p++){const[y,g,i]=E[p];f.set(y,g,i)}this.a=f,this.b=m}nextState(E,m){return m<0||m>=this.b?0:this.a.get(E,m)}}e.StateMachine=R;let C=null;function P(){return C===null&&(C=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let I=null;function L(){if(I===null){I=new c.CharacterClassifier(0);const T=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<T.length;m++)I.set(T.charCodeAt(m),1);const E=".;:";for(let m=0;m<E.length;m++)I.set(E.charCodeAt(m),2)}return I}class k{static a(E,m,d,f,p){let b=p-1;do{const y=m.charCodeAt(b);if(E.get(y)!==2)break;b--}while(b>f);if(f>0){const y=m.charCodeAt(f-1),g=m.charCodeAt(b);(y===40&&g===41||y===91&&g===93||y===123&&g===125)&&b--}return{range:{startLineNumber:d,startColumn:f+1,endLineNumber:d,endColumn:b+2},url:m.substring(f,b+1)}}static computeLinks(E,m=P()){const d=L(),f=[];for(let p=1,b=E.getLineCount();p<=b;p++){const y=E.getLineContent(p),g=y.length;let i=0,o=0,s=0,l=1,r=!1,h=!1,n=!1,t=!1;for(;i<g;){let a=!1;const w=y.charCodeAt(i);if(l===13){let D;switch(w){case 40:r=!0,D=0;break;case 41:D=r?0:1;break;case 91:n=!0,h=!0,D=0;break;case 93:n=!1,D=h?0:1;break;case 123:t=!0,D=0;break;case 125:D=t?0:1;break;case 39:case 34:case 96:s===w?D=1:s===39||s===34||s===96?D=0:D=1;break;case 42:D=s===42?1:0;break;case 124:D=s===124?1:0;break;case 32:D=n?0:1;break;default:D=d.get(w)}D===1&&(f.push(k.a(d,y,p,o,i)),a=!0)}else if(l===12){let D;w===91?(h=!0,D=0):D=d.get(w),D===1?a=!0:l=13}else l=m.nextState(l,w),l===0&&(a=!0);a&&(l=1,r=!1,h=!1,t=!1,o=i+1,s=w),i++}l===13&&f.push(k.a(d,y,p,o,g))}return f}}e.LinkComputer=k;function v(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=v}),define(ye[119],De([1,0,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var u;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(u=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),y.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,y.indentSize|0),this.a=!1),this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.a===y.a&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class L{constructor(y,g){this._findMatchBrand=void 0,this.range=y,this.matches=g}}e.FindMatch=L;var k;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var T;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class m{constructor(y,g,i,o,s,l){this.identifier=y,this.range=g,this.text=i,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=l}}e.ValidAnnotatedEditOperation=m;class d{constructor(y,g,i){this.regex=y,this.wordSeparators=g,this.simpleSearch=i}}e.SearchData=d;class f{constructor(y,g,i){this.reverseEdits=y,this.changes=g,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=f;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(ye[158],De([1,0,15,108]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,I){S=(0,A.toUint32)(S);const L=this.a,k=this.b,v=I.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S),S+v),this.a.set(I,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}setValue(S,I){return S=(0,A.toUint32)(S),I=(0,A.toUint32)(I),this.a[S]===I?!1:(this.a[S]=I,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,I){S=(0,A.toUint32)(S),I=(0,A.toUint32)(I);const L=this.a,k=this.b;if(S>=L.length)return!1;const v=L.length-S;return I>=v&&(I=v),I===0?!1:(this.a=new Uint32Array(L.length-I),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S+I),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,A.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let I=this.c[0]+1;I===0&&(this.b[0]=this.a[0],I++),S>=this.a.length&&(S=this.a.length-1);for(let L=I;L<=S;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let I=0,L=this.a.length-1,k=0,v=0,T=0;for(;I<=L;)if(k=I+(L-I)/2|0,v=this.b[k],T=v-this.a[k],S<T)L=k-1;else if(S>=v)I=k+1;else break;return new C(k,S-T)}}e.PrefixSumComputer=u;class R{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const I=this.e[S],L=I>0?this.d[I-1]:0;return new C(I,S-L)}removeValues(S,I){this.a.splice(S,I),this.f(S)}insertValues(S,I){this.a=(0,c.arrayInsert)(this.a,S,I),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,I=this.a.length;S<I;S++){const L=this.a[S],k=S>0?this.d[S-1]:0;this.d[S]=k+L;for(let v=0;v<L;v++)this.e[k+v]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,I){this.a[S]!==I&&(this.a[S]=I,this.f(S))}}e.ConstantTimePrefixSumComputer=R;class C{constructor(S,I){this.index=S,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=I}}e.PrefixSumIndexOfResult=C}),define(ye[159],De([1,0,8,53,158]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(P,S,I,L){this.c=P,this.d=S,this.f=I,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(P){P.eol&&P.eol!==this.f&&(this.f=P.eol,this.h=null);const S=P.changes;for(const I of S)this.n(I.range),this.o(new A.Position(I.range.startLineNumber,I.range.startColumn),I.text);this.g=P.versionId,this.j=null}k(){if(!this.h){const P=this.f.length,S=this.d.length,I=new Uint32Array(S);for(let L=0;L<S;L++)I[L]=this.d[L].length+P;this.h=new u.PrefixSumComputer(I)}}l(P,S){this.d[P]=S,this.h&&this.h.setValue(P,this.d[P].length+this.f.length)}n(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.startLineNumber-1].substring(P.endColumn-1));return}this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.endLineNumber-1].substring(P.endColumn-1)),this.d.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this.h&&this.h.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}o(P,S){if(S.length===0)return;const I=(0,c.splitLines)(S);if(I.length===1){this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+I[0]+this.d[P.lineNumber-1].substring(P.column-1));return}I[I.length-1]+=this.d[P.lineNumber-1].substring(P.column-1),this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+I[0]);const L=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this.d.splice(P.lineNumber+k-1,0,I[k]),L[k-1]=I[k].length+this.f.length;this.h&&this.h.insertValues(P.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[160],De([1,0,8,154,53,33,119]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(p,b,y,g){this.searchString=p,this.isRegex=b,this.matchCase=y,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=I(this.searchString):p=this.searchString.indexOf(`
`)>=0;let b=null;try{b=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!b)return null;let y=!this.isRegex&&!p;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new C.SearchData(b,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=S;function I(f){if(!f||f.length===0)return!1;for(let p=0,b=f.length;p<b;p++){const y=f.charCodeAt(p);if(y===10)return!0;if(y===92){if(p++,p>=b)break;const g=f.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=I;function L(f,p,b){if(!b)return new C.FindMatch(f,null);const y=[];for(let g=0,i=p.length;g<i;g++)y[g]=p[g];return new C.FindMatch(f,y)}e.createFindMatch=L;class k{constructor(p){const b=[];let y=0;for(let g=0,i=p.length;g<i;g++)p.charCodeAt(g)===10&&(b[y++]=g);this.a=b}findLineFeedCountBeforeOffset(p){const b=this.a;let y=0,g=b.length-1;if(g===-1||p<=b[0])return 0;for(;y<g;){const i=y+((g-y)/2>>0);b[i]>=p?g=i-1:b[i+1]>=p?(y=i,g=i):y=i+1}return y+1}}class v{static findMatches(p,b,y,g,i){const o=b.parseSearchRequest();return o?o.regex.multiline?this.b(p,y,new d(o.wordSeparators,o.regex),g,i):this.c(p,y,o,g,i):[]}static a(p,b,y,g,i,o){let s,l=0;g?(l=g.findLineFeedCountBeforeOffset(i),s=b+i+l):s=b+i;let r;if(g){const a=g.findLineFeedCountBeforeOffset(i+o.length)-l;r=s+o.length+a}else r=s+o.length;const h=p.getPositionAt(s),n=p.getPositionAt(r);return new R.Range(h.lineNumber,h.column,n.lineNumber,n.column)}static b(p,b,y,g,i){const o=p.getOffsetAt(b.getStartPosition()),s=p.getValueInRange(b,1),l=p.getEOL()===`\r
`?new k(s):null,r=[];let h=0,n;for(y.reset(0);n=y.next(s);)if(r[h++]=L(this.a(p,o,s,l,n.index,n[0]),n,g),h>=i)return r;return r}static c(p,b,y,g,i){const o=[];let s=0;if(b.startLineNumber===b.endLineNumber){const r=p.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return s=this.d(y,r,b.startLineNumber,b.startColumn-1,s,o,g,i),o}const l=p.getLineContent(b.startLineNumber).substring(b.startColumn-1);s=this.d(y,l,b.startLineNumber,b.startColumn-1,s,o,g,i);for(let r=b.startLineNumber+1;r<b.endLineNumber&&s<i;r++)s=this.d(y,p.getLineContent(r),r,0,s,o,g,i);if(s<i){const r=p.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);s=this.d(y,r,b.endLineNumber,0,s,o,g,i)}return o}static d(p,b,y,g,i,o,s,l){const r=p.wordSeparators;if(!s&&p.simpleSearch){const t=p.simpleSearch,a=t.length,w=b.length;let D=-a;for(;(D=b.indexOf(t,D+a))!==-1;)if((!r||m(r,b,w,D,a))&&(o[i++]=new C.FindMatch(new R.Range(y,D+1+g,y,D+1+a+g),null),i>=l))return i;return i}const h=new d(p.wordSeparators,p.regex);let n;h.reset(0);do if(n=h.next(b),n&&(o[i++]=L(new R.Range(y,n.index+1+g,y,n.index+1+n[0].length+g),n,s),i>=l))return i;while(n);return i}static findNextMatch(p,b,y,g){const i=b.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(p,y,o,g):this.f(p,y,o,g)}static e(p,b,y,g){const i=new u.Position(b.lineNumber,1),o=p.getOffsetAt(i),s=p.getLineCount(),l=p.getValueInRange(new R.Range(i.lineNumber,i.column,s,p.getLineMaxColumn(s)),1),r=p.getEOL()===`\r
`?new k(l):null;y.reset(b.column-1);const h=y.next(l);return h?L(this.a(p,o,l,r,h.index,h[0]),h,g):b.lineNumber!==1||b.column!==1?this.e(p,new u.Position(1,1),y,g):null}static f(p,b,y,g){const i=p.getLineCount(),o=b.lineNumber,s=p.getLineContent(o),l=this.g(y,s,o,b.column,g);if(l)return l;for(let r=1;r<=i;r++){const h=(o+r-1)%i,n=p.getLineContent(h+1),t=this.g(y,n,h+1,1,g);if(t)return t}return null}static g(p,b,y,g,i){p.reset(g-1);const o=p.next(b);return o?L(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,i):null}static findPreviousMatch(p,b,y,g){const i=b.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(p,y,o,g):this.j(p,y,o,g)}static h(p,b,y,g){const i=this.b(p,new R.Range(1,1,b.lineNumber,b.column),y,g,10*P);if(i.length>0)return i[i.length-1];const o=p.getLineCount();return b.lineNumber!==o||b.column!==p.getLineMaxColumn(o)?this.h(p,new u.Position(o,p.getLineMaxColumn(o)),y,g):null}static j(p,b,y,g){const i=p.getLineCount(),o=b.lineNumber,s=p.getLineContent(o).substring(0,b.column-1),l=this.k(y,s,o,g);if(l)return l;for(let r=1;r<=i;r++){const h=(i+o-r-1)%i,n=p.getLineContent(h+1),t=this.k(y,n,h+1,g);if(t)return t}return null}static k(p,b,y,g){let i=null,o;for(p.reset(0);o=p.next(b);)i=L(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,g);return i}}e.TextModelSearch=v;function T(f,p,b,y,g){if(y===0)return!0;const i=p.charCodeAt(y-1);if(f.get(i)!==0||i===13||i===10)return!0;if(g>0){const o=p.charCodeAt(y);if(f.get(o)!==0)return!0}return!1}function E(f,p,b,y,g){if(y+g===b)return!0;const i=p.charCodeAt(y+g);if(f.get(i)!==0||i===13||i===10)return!0;if(g>0){const o=p.charCodeAt(y+g-1);if(f.get(o)!==0)return!0}return!1}function m(f,p,b,y,g){return T(f,p,b,y,g)&&E(f,p,b,y,g)}e.isValidMatch=m;class d{constructor(p,b){this._wordSeparators=p,this.a=b,this.b=-1,this.c=0}reset(p){this.a.lastIndex=p,this.b=-1,this.c=0}next(p){const b=p.length;let y;do{if(this.b+this.c===b||(y=this.a.exec(p),!y))return null;const g=y.index,i=y[0].length;if(g===this.b&&i===this.c){if(i===0){c.getNextCodePoint(p,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=i,!this._wordSeparators||m(this._wordSeparators,p,b,g,i))return y}while(y);return null}}e.Searcher=d}),define(ye[120],De([1,0,22,12]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(u||(u={}));function R(k){for(let v=0,T=k.length;v<T;v+=4){const E=k[v+0],m=k[v+1],d=k[v+2],f=k[v+3];k[v+0]=f,k[v+1]=d,k[v+2]=m,k[v+3]=E}}function C(k){const v=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return A.isLittleEndian()||R(v),c.VSBuffer.wrap(v)}function P(k){const v=k.buffer;if(A.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const T=new Uint8Array(v.byteLength);return T.set(v),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function S(k){const v=new Uint32Array(I(k));let T=0;if(v[T++]=k.id,k.type==="full")v[T++]=1,v[T++]=k.data.length,v.set(k.data,T),T+=k.data.length;else{v[T++]=2,v[T++]=k.deltas.length;for(const E of k.deltas)v[T++]=E.start,v[T++]=E.deleteCount,E.data?(v[T++]=E.data.length,v.set(E.data,T),T+=E.data.length):v[T++]=0}return C(v)}e.encodeSemanticTokensDto=S;function I(k){let v=0;if(v+=1+1,k.type==="full")v+=1+k.data.length;else{v+=1,v+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(v+=T.data.length)}return v}function L(k){const v=P(k);let T=0;const E=v[T++];if(v[T++]===1){const p=v[T++],b=v.subarray(T,T+p);return T+=p,{id:E,type:"full",data:b}}const d=v[T++],f=[];for(let p=0;p<d;p++){const b=v[T++],y=v[T++],g=v[T++];let i;g>0&&(i=v.subarray(T,T+g),T+=g),f[p]={start:b,deleteCount:y,data:i}}return{id:E,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(ye[161],De([1,0,3,6]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,S){return this.a.set(P,S),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===S&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,S){this.b.get(P)?.dispose();const I=new R(this,P,S);return this.b.set(P,I),(0,A.toDisposable)(()=>{const L=this.b.get(P);!L||L!==I||(this.b.delete(P),L.dispose())})}async getOrCreate(P){const S=this.get(P);if(S)return S;const I=this.b.get(P);return!I||I.isResolved?null:(await I.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const I=this.b.get(P);return!!(!I||I.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=u;class R extends A.Disposable{get isResolved(){return this.c}constructor(P,S,I){super(),this.f=P,this.g=S,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ye[72],De([1,0,69,2,33,161]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(a,w,D){this._tokenBrand=void 0,this.offset=a,this.type=w,this.language=D}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class P{constructor(a,w){this._tokenizationResultBrand=void 0,this.tokens=a,this.endState=w}}e.TokenizationResult=P;class S{constructor(a,w){this._encodedTokenizationResultBrand=void 0,this.tokens=a,this.endState=w}}e.EncodedTokenizationResult=S;var I;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(t){const a=new Map;a.set(0,c.Codicon.symbolMethod),a.set(1,c.Codicon.symbolFunction),a.set(2,c.Codicon.symbolConstructor),a.set(3,c.Codicon.symbolField),a.set(4,c.Codicon.symbolVariable),a.set(5,c.Codicon.symbolClass),a.set(6,c.Codicon.symbolStruct),a.set(7,c.Codicon.symbolInterface),a.set(8,c.Codicon.symbolModule),a.set(9,c.Codicon.symbolProperty),a.set(10,c.Codicon.symbolEvent),a.set(11,c.Codicon.symbolOperator),a.set(12,c.Codicon.symbolUnit),a.set(13,c.Codicon.symbolValue),a.set(15,c.Codicon.symbolEnum),a.set(14,c.Codicon.symbolConstant),a.set(15,c.Codicon.symbolEnum),a.set(16,c.Codicon.symbolEnumMember),a.set(17,c.Codicon.symbolKeyword),a.set(27,c.Codicon.symbolSnippet),a.set(18,c.Codicon.symbolText),a.set(19,c.Codicon.symbolColor),a.set(20,c.Codicon.symbolFile),a.set(21,c.Codicon.symbolReference),a.set(22,c.Codicon.symbolCustomColor),a.set(23,c.Codicon.symbolFolder),a.set(24,c.Codicon.symbolTypeParameter),a.set(25,c.Codicon.account),a.set(26,c.Codicon.issues);function w(x){let V=a.get(x);return V||(console.info("No codicon found for CompletionItemKind "+x),V=c.Codicon.symbolProperty),V}t.toIcon=w;const D=new Map;D.set("method",0),D.set("function",1),D.set("constructor",2),D.set("field",3),D.set("variable",4),D.set("class",5),D.set("struct",6),D.set("interface",7),D.set("module",8),D.set("property",9),D.set("event",10),D.set("operator",11),D.set("unit",12),D.set("value",13),D.set("constant",14),D.set("enum",15),D.set("enum-member",16),D.set("enumMember",16),D.set("keyword",17),D.set("snippet",27),D.set("text",18),D.set("color",19),D.set("file",20),D.set("reference",21),D.set("customcolor",22),D.set("folder",23),D.set("type-parameter",24),D.set("typeParameter",24),D.set("account",25),D.set("issue",26);function F(x,V){let M=D.get(x);return typeof M>"u"&&!V&&(M=9),M}t.fromString=F})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(t){t[t.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(t){return t&&A.URI.isUri(t.uri)&&u.Range.isIRange(t.range)&&(u.Range.isIRange(t.originSelectionRange)||u.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=p;var b;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var y;(function(t){t[t.Deprecated=1]="Deprecated"})(y=e.SymbolTag||(e.SymbolTag={}));var g;(function(t){const a=new Map;a.set(0,c.Codicon.symbolFile),a.set(1,c.Codicon.symbolModule),a.set(2,c.Codicon.symbolNamespace),a.set(3,c.Codicon.symbolPackage),a.set(4,c.Codicon.symbolClass),a.set(5,c.Codicon.symbolMethod),a.set(6,c.Codicon.symbolProperty),a.set(7,c.Codicon.symbolField),a.set(8,c.Codicon.symbolConstructor),a.set(9,c.Codicon.symbolEnum),a.set(10,c.Codicon.symbolInterface),a.set(11,c.Codicon.symbolFunction),a.set(12,c.Codicon.symbolVariable),a.set(13,c.Codicon.symbolConstant),a.set(14,c.Codicon.symbolString),a.set(15,c.Codicon.symbolNumber),a.set(16,c.Codicon.symbolBoolean),a.set(17,c.Codicon.symbolArray),a.set(18,c.Codicon.symbolObject),a.set(19,c.Codicon.symbolKey),a.set(20,c.Codicon.symbolNull),a.set(21,c.Codicon.symbolEnumMember),a.set(22,c.Codicon.symbolStruct),a.set(23,c.Codicon.symbolEvent),a.set(24,c.Codicon.symbolOperator),a.set(25,c.Codicon.symbolTypeParameter);function w(D){let F=a.get(D);return F||(console.info("No codicon found for SymbolKind "+D),F=c.Codicon.symbolProperty),F}t.toIcon=w})(g=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(a){this.value=a}}i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region"),e.FoldingRangeKind=i;var o;(function(t){function a(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}t.is=a})(o=e.Command||(e.Command={}));var s;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var h;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[162],De([19,20]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(ye[163],De([1,0,3,6,162]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(v,T="",E="",m=!0,d){super(),this.h=this.B(new c.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=T,this.u=E,this.w=m,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,T){this.C&&await this.C(v)}}e.Action=R;class C extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new c.Emitter),this.onWillRun=this.f.event,this.h=this.B(new c.Emitter),this.onDidRun=this.h.event}async run(v,T){if(!v.enabled)return;this.f.fire({action:v});let E;try{await this.runAction(v,T)}catch(m){E=m}this.h.fire({action:v,error:E})}async runAction(v,T){await v.run(T)}}e.ActionRunner=C;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let T=[];for(const E of v)E.length&&(T.length?T=[...T,new P,...E]:T=E);return T}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class S{get actions(){return this.a}constructor(v,T,E,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=T,this.class=m,this.a=E}async run(){}}e.SubmenuAction=S;class I extends R{constructor(){super(I.ID,u.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function L(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=L}),define(ye[164],De([19,20]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[165],De([1,0,164]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,u=A*60,R=u*24,C=R*7,P=R*30,S=R*365;function I(k,v,T,E){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,c.localize)(0,null,I(new Date().getTime()+m*1e3,!1));if(!E&&m<30)return(0,c.localize)(1,null);let d;return m<A?(d=m,v?d===1?T?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):T?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?T?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):T?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):m<u?(d=Math.floor(m/A),v?d===1?T?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):T?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?T?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):T?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):m<R?(d=Math.floor(m/u),v?d===1?T?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):T?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?T?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):T?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):m<C?(d=Math.floor(m/R),v?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):m<P?(d=Math.floor(m/C),v?d===1?T?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):T?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?T?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):T?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):m<S?(d=Math.floor(m/P),v?d===1?T?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):T?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?T?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):T?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(m/S),v?d===1?T?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):T?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?T?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):T?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=I;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[166],De([19,20]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,10,166]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,v){return v&&(k.stack||k.stacktrace)?u.localize(0,null,P(k),C(k.stack)||C(k.stacktrace)):P(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?u.localize(1,null,k.message):k.message||u.localize(2,null)}function S(k=null,v=!1){if(!k)return u.localize(3,null);if(Array.isArray(k)){const T=c.coalesce(k),E=S(T[0],v);return T.length>1?u.localize(4,null,E,T.length):E}if(A.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return R(T.error,v);if(T.exception)return R(T.exception,v)}return k.stack?R(k,v):k.message?k.message:u.localize(5,null)}e.toErrorMessage=S;function I(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function L(k,v){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=v,T}e.createErrorWithActions=L}),define(ye[167],De([19,20]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,167,12,118,15,23,153]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(z){this.c=z}hasChanged(z){return this.c[z]}}e.ConfigurationChangedEvent=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor(z,ue,Ie,Le){this.id=z,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate(z,ue){return T(z,ue)}compute(z,ue,Ie){return Ie}}class v{constructor(z,ue){this.newValue=z,this.didChange=ue}}e.ApplyUpdateResult=v;function T(ce,z){if(typeof ce!="object"||typeof z!="object"||!ce||!z)return new v(z,ce!==z);if(Array.isArray(ce)||Array.isArray(z)){const Ie=Array.isArray(ce)&&Array.isArray(z)&&R.equals(ce,z);return new v(z,!Ie)}let ue=!1;for(const Ie in z)if(z.hasOwnProperty(Ie)){const Le=T(ce[Ie],z[Ie]);Le.didChange&&(ce[Ie]=Le.newValue,ue=!0)}return new v(ce,ue)}class E{constructor(z){this.schema=void 0,this.id=z,this.name="_never_",this.defaultValue=void 0}applyUpdate(z,ue){return T(z,ue)}validate(z){return this.defaultValue}}class m{constructor(z,ue,Ie,Le){this.id=z,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate(z,ue){return T(z,ue)}validate(z){return typeof z>"u"?this.defaultValue:z}compute(z,ue,Ie){return Ie}}function d(ce,z){return typeof ce>"u"?z:ce==="false"?!1:Boolean(ce)}e.boolean=d;class f extends m{constructor(z,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super(z,ue,Ie,Le)}validate(z){return d(z,this.defaultValue)}}function p(ce,z,ue,Ie){if(typeof ce>"u")return z;let Le=parseInt(ce,10);return isNaN(Le)?z:(Le=Math.max(ue,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=p;class b extends m{static clampedInt(z,ue,Ie,Le){return p(z,ue,Ie,Le)}constructor(z,ue,Ie,Le,$e,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ie,Ke.minimum=Le,Ke.maximum=$e),super(z,ue,Ie,Ke),this.minimum=Le,this.maximum=$e}validate(z){return b.clampedInt(z,this.defaultValue,this.minimum,this.maximum)}}class y extends m{static clamp(z,ue,Ie){return z<ue?ue:z>Ie?Ie:z}static float(z,ue){if(typeof z=="number")return z;if(typeof z>"u")return ue;const Ie=parseFloat(z);return isNaN(Ie)?ue:Ie}constructor(z,ue,Ie,Le,$e){typeof $e<"u"&&($e.type="number",$e.default=Ie),super(z,ue,Ie,$e),this.validationFn=Le}validate(z){return this.validationFn(y.float(z,this.defaultValue))}}class g extends m{static string(z,ue){return typeof z!="string"?ue:z}constructor(z,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super(z,ue,Ie,Le)}validate(z){return g.string(z,this.defaultValue)}}function i(ce,z,ue){return typeof ce!="string"||ue.indexOf(ce)===-1?z:ce}e.stringSet=i;class o extends m{constructor(z,ue,Ie,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.enum=Le,$e.default=Ie),super(z,ue,Ie,$e),this.c=Le}validate(z){return i(z,this.defaultValue,this.c)}}class s extends k{constructor(z,ue,Ie,Le,$e,Ke,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=$e,Ze.default=Le),super(z,ue,Ie,Ze),this.c=$e,this.d=Ke}validate(z){return typeof z!="string"?this.defaultValue:this.c.indexOf(z)===-1?this.defaultValue:this.d(z)}}function l(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(z){switch(z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(z,ue,Ie){return Ie===0?z.accessibilitySupport:Ie}}class h extends k{constructor(){const z={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",z,{"editor.comments.insertSpace":{type:"boolean",default:z.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:z.ignoreEmptyLines,description:c.localize(5,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{insertSpace:d(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ce){switch(ce){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function D(ce){switch(ce){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class F extends E{constructor(){super(135)}compute(z,ue,Ie){const Le=["monaco-editor"];return ue.get(36)&&Le.push(ue.get(36)),z.extraEditorClassName&&Le.push(z.extraEditorClassName),ue.get(70)==="default"?Le.push("mouse-default"):ue.get(70)==="copy"&&Le.push("mouse-copy"),ue.get(105)&&Le.push("showUnused"),ue.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class x extends f{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(z,ue,Ie){return Ie&&z.emptySelectionClipboard}}class V extends k{constructor(){const z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",z,{"editor.find.cursorMoveOnType":{type:"boolean",default:z.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:z.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:z.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:z.globalFindClipboard,description:c.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:z.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:z.loop,description:c.localize(18,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{cursorMoveOnType:d(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof z.seedSearchStringFromSelection=="boolean"?z.seedSearchStringFromSelection?"always":"never":i(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof z.autoFindInSelection=="boolean"?z.autoFindInSelection?"always":"never":i(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ue.loop,this.defaultValue.loop)}}}class M extends k{constructor(){super(48,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(z){return typeof z>"u"?this.defaultValue:typeof z=="string"?z==="false"?M.OFF:z==="true"?M.ON:z:Boolean(z)?M.ON:M.OFF}}M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on',e.EditorFontLigatures=M;class $ extends k{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(z){return typeof z>"u"?this.defaultValue:typeof z=="string"?z==="false"?$.OFF:z==="true"?$.TRANSLATE:z:Boolean(z)?$.TRANSLATE:$.OFF}compute(z,ue,Ie){return z.fontInfo.fontVariationSettings}}$.OFF="normal",$.TRANSLATE="translate",e.EditorFontVariations=$;class O extends E{constructor(){super(47)}compute(z,ue,Ie){return z.fontInfo}}class U extends m{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(z){const ue=y.float(z,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(ue,6,100)}compute(z,ue,Ie){return z.fontInfo.fontSize}}class B extends k{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(z){return z==="normal"||z==="bold"?z:String(b.clampedInt(z,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class j extends k{constructor(){const z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:z.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",z,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ue},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ue},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:z.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:z.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:z.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:z.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:z.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{multiple:i(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??i(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??i(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??i(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??i(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??i(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends k{constructor(){const z={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",z,{"editor.hover.enabled":{type:"boolean",default:z.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:z.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:z.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:z.above,description:c.localize(45,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{enabled:d(ue.enabled,this.defaultValue.enabled),delay:b.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:d(ue.sticky,this.defaultValue.sticky),above:d(ue.above,this.defaultValue.above)}}}var Y;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class q extends E{constructor(){super(138)}compute(z,ue,Ie){return q.computeLayout(ue,{memory:z.memory,outerWidth:z.outerWidth,outerHeight:z.outerHeight,isDominatedByLongLines:z.isDominatedByLongLines,lineHeight:z.fontInfo.lineHeight,viewLineCount:z.viewLineCount,lineNumbersDigitCount:z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:z.fontInfo.maxDigitWidth,pixelRatio:z.pixelRatio})}static computeContainedMinimapLineCount(z){const ue=z.height/z.lineHeight,Ie=Math.floor(z.paddingTop/z.lineHeight);let Le=Math.floor(z.paddingBottom/z.lineHeight);z.scrollBeyondLastLine&&(Le=Math.max(Le,ue-1));const $e=(Ie+z.viewLineCount+Le)/(z.pixelRatio*z.height),Ke=Math.floor(z.viewLineCount/$e);return{typicalViewportLineCount:ue,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:Ke}}static c(z,ue){const Ie=z.outerWidth,Le=z.outerHeight,$e=z.pixelRatio;if(!z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Ke=ue.stableMinimapLayoutInput,Ze=Ke&&z.outerHeight===Ke.outerHeight&&z.lineHeight===Ke.lineHeight&&z.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&z.pixelRatio===Ke.pixelRatio&&z.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&z.paddingTop===Ke.paddingTop&&z.paddingBottom===Ke.paddingBottom&&z.minimap.enabled===Ke.minimap.enabled&&z.minimap.side===Ke.minimap.side&&z.minimap.size===Ke.minimap.size&&z.minimap.showSlider===Ke.minimap.showSlider&&z.minimap.renderCharacters===Ke.minimap.renderCharacters&&z.minimap.maxColumn===Ke.minimap.maxColumn&&z.minimap.scale===Ke.minimap.scale&&z.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&z.isViewportWrapping===Ke.isViewportWrapping,pt=z.lineHeight,gt=z.typicalHalfwidthCharacterWidth,ct=z.scrollBeyondLastLine,Et=z.minimap.renderCharacters;let tt=$e>=2?Math.round(z.minimap.scale*2):z.minimap.scale;const ft=z.minimap.maxColumn,At=z.minimap.size,Kt=z.minimap.side,Rt=z.verticalScrollbarWidth,mt=z.viewLineCount,Tt=z.remainingWidth,$t=z.isViewportWrapping,Nt=Et?2:3;let Xe=Math.floor($e*Le);const Mt=Xe/$e;let Ut=!1,Wt=!1,bt=Nt*tt,Re=tt/$e,Ne=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:lt,extraLinesBeyondLastLine:Pt,desiredRatio:St,minimapLineCount:yt}=q.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:ct,paddingTop:z.paddingTop,paddingBottom:z.paddingBottom,height:Le,lineHeight:pt,pixelRatio:$e});if(mt/yt>1)Ut=!0,Wt=!0,tt=1,bt=1,Re=tt/$e;else{let Dt=!1,Ct=tt+1;if(At==="fit"){const qt=Math.ceil((lt+mt+Pt)*bt);$t&&Ze&&Tt<=ue.stableFitRemainingWidth?(Dt=!0,Ct=ue.stableFitMaxMinimapScale):Dt=qt>Xe}if(At==="fill"||Dt){Ut=!0;const qt=tt;bt=Math.min(pt*$e,Math.max(1,Math.floor(1/St))),$t&&Ze&&Tt<=ue.stableFitRemainingWidth&&(Ct=ue.stableFitMaxMinimapScale),tt=Math.min(Ct,Math.max(1,Math.floor(bt/Nt))),tt>qt&&(Ne=Math.min(2,tt/qt)),Re=tt/$e/Ne,Xe=Math.ceil(Math.max(it,lt+mt+Pt)*bt),$t?(ue.stableMinimapLayoutInput=z,ue.stableFitRemainingWidth=Tt,ue.stableFitMaxMinimapScale=tt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Re),se=Math.min(Se,Math.max(0,Math.floor((Tt-Rt-2)*Re/(gt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor($e*se);const He=Fe/$e;Fe=Math.floor(Fe*Ne);const _e=Et?1:2,je=Kt==="left"?0:Ie-se-Rt;return{renderMinimap:_e,minimapLeft:je,minimapWidth:se,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:tt,minimapLineHeight:bt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:Mt}}static computeLayout(z,ue){const Ie=ue.outerWidth|0,Le=ue.outerHeight|0,$e=ue.lineHeight|0,Ke=ue.lineNumbersDigitCount|0,Ze=ue.typicalHalfwidthCharacterWidth,pt=ue.maxDigitWidth,gt=ue.pixelRatio,ct=ue.viewLineCount,Et=z.get(130),tt=Et==="inherit"?z.get(129):Et,ft=tt==="inherit"?z.get(125):tt,At=z.get(128),Kt=ue.isDominatedByLongLines,Rt=z.get(54),mt=z.get(64).renderType!==0,Tt=z.get(65),$t=z.get(99),Nt=z.get(80),Xe=z.get(69),Mt=z.get(97),Ut=Mt.verticalScrollbarSize,Wt=Mt.verticalHasArrows,bt=Mt.arrowSize,Re=Mt.horizontalScrollbarSize,Ne=z.get(40),Se=z.get(104)!=="never";let se=z.get(62);Ne&&Se&&(se+=16);let Fe=0;if(mt){const wt=Math.max(Ke,Tt);Fe=Math.round(wt*pt)}let He=0;Rt&&(He=$e);let _e=0,je=_e+He,it=je+Fe,lt=it+se;const Pt=Ie-He-Fe-se;let St=!1,yt=!1,kt=-1;tt==="inherit"&&Kt?(St=!0,yt=!0):ft==="on"||ft==="bounded"?yt=!0:ft==="wordWrapColumn"&&(kt=At);const Dt=q.c({outerWidth:Ie,outerHeight:Le,lineHeight:$e,typicalHalfwidthCharacterWidth:Ze,pixelRatio:gt,scrollBeyondLastLine:$t,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:ct,remainingWidth:Pt,isViewportWrapping:yt},ue.memory||new L);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(_e+=Dt.minimapWidth,je+=Dt.minimapWidth,it+=Dt.minimapWidth,lt+=Dt.minimapWidth);const Ct=Pt-Dt.minimapWidth,qt=Math.max(1,Math.floor((Ct-Ut-2)/Ze)),Jt=Wt?bt:0;return yt&&(kt=Math.max(1,qt),ft==="bounded"&&(kt=Math.min(kt,At))),{width:Ie,height:Le,glyphMarginLeft:_e,glyphMarginWidth:He,lineNumbersLeft:je,lineNumbersWidth:Fe,decorationsLeft:it,decorationsWidth:se,contentLeft:lt,contentWidth:Ct,minimap:Dt,viewportColumn:qt,isWordWrapMinified:St,isViewportWrapping:yt,wrappingColumn:kt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Re,overviewRuler:{top:Jt,width:Ut,height:Le-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=q;class Q extends k{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate(z){return i(z,"simple",["simple","advanced"])}compute(z,ue,Ie){return ue.get(2)===2?"advanced":Ie}}class Z extends k{constructor(){const z={enabled:!0};super(61,"lightbulb",z,{"editor.lightbulb.enabled":{type:"boolean",default:z.enabled,description:c.localize(49,null)}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{enabled:d(z.enabled,this.defaultValue.enabled)}}}class te extends k{constructor(){const z={enabled:!1,maxLineCount:5};super(109,"stickyScroll",z,{"editor.stickyScroll.enabled":{type:"boolean",default:z.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:z.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{enabled:d(ue.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ue.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends k{constructor(){const z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",z,{"editor.inlayHints.enabled":{type:"string",default:z.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:z.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:z.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:z.padding,description:c.localize(59,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return typeof ue.enabled=="boolean"&&(ue.enabled=ue.enabled?"on":"off"),{enabled:i(ue.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ue.fontFamily,this.defaultValue.fontFamily),padding:d(ue.padding,this.defaultValue.padding)}}}class J extends k{constructor(){super(62,"lineDecorationsWidth",10)}validate(z){return typeof z=="string"&&/^\d+(\.\d+)?ch$/.test(z)?-parseFloat(z.substring(0,z.length-2)):b.clampedInt(z,this.defaultValue,0,1e3)}compute(z,ue,Ie){return Ie<0?b.clampedInt(-Ie*z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class ie extends y{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,z=>y.clamp(z,0,150),{markdownDescription:c.localize(60,null)})}compute(z,ue,Ie){return z.fontInfo.lineHeight}}class pe extends k{constructor(){const z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",z,{"editor.minimap.enabled":{type:"boolean",default:z.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:z.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:z.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:z.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:z.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:z.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:z.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:z.maxColumn,description:c.localize(71,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{enabled:d(ue.enabled,this.defaultValue.enabled),autohide:d(ue.autohide,this.defaultValue.autohide),size:i(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ue.side,this.defaultValue.side,["right","left"]),showSlider:i(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ue.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ue.scale,1,1,3),maxColumn:b.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(ce){return ce==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends k{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{top:b.clampedInt(ue.top,0,0,1e3),bottom:b.clampedInt(ue.bottom,0,0,1e3)}}}class Oe extends k{constructor(){const z={enabled:!0,cycle:!0};super(81,"parameterHints",z,{"editor.parameterHints.enabled":{type:"boolean",default:z.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:z.cycle,description:c.localize(75,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{enabled:d(ue.enabled,this.defaultValue.enabled),cycle:d(ue.cycle,this.defaultValue.cycle)}}}class oe extends E{constructor(){super(136)}compute(z,ue,Ie){return z.pixelRatio}}class ae extends k{constructor(){const z={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ue,default:z.strings,description:c.localize(79,null)},comments:{anyOf:ue,default:z.comments,description:c.localize(80,null)},other:{anyOf:ue,default:z.other,description:c.localize(81,null)}},default:z,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=z}validate(z){if(typeof z=="boolean"){const gt=z?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!z||typeof z!="object")return this.defaultValue;const{other:ue,comments:Ie,strings:Le}=z,$e=["on","inline","off"];let Ke,Ze,pt;return typeof ue=="boolean"?Ke=ue?"on":"off":Ke=i(ue,this.defaultValue.other,$e),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,$e),typeof Le=="boolean"?pt=Le?"on":"off":pt=i(Le,this.defaultValue.strings,$e),{other:Ke,comments:Ze,strings:pt}}}var fe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends k{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate(z){let ue=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof z<"u"&&(typeof z=="function"?(ue=4,Ie=z):z==="interval"?ue=3:z==="relative"?ue=2:z==="on"?ue=1:ue=0),{renderType:ue,renderFn:Ie}}}function le(ce){const z=ce.get(92);return z==="editable"?ce.get(86):z!=="on"}e.filterValidationDecorations=le;class re extends k{constructor(){const z=[],ue={type:"number",description:c.localize(88,null)};super(96,"rulers",z,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:z,description:c.localize(90,null)})}validate(z){if(Array.isArray(z)){const ue=[];for(const Ie of z)if(typeof Ie=="number")ue.push({column:b.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ue.push({column:b.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ue.sort((Ie,Le)=>Ie.column-Le.column),ue}return this.defaultValue}}function N(ce,z){if(typeof ce!="string")return z;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends k{constructor(){const z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:z.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:z.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:z.scrollByPage,description:c.localize(101,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z,Ie=b.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=b.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ue.vertical,this.defaultValue.vertical),horizontal:N(ue.horizontal,this.defaultValue.horizontal),useShadows:d(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:b.clampedInt(ue.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:b.clampedInt(ue.verticalSliderSize,Le,0,1e3),scrollByPage:d(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:z.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:z.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:z.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:z.allowedLocales,description:c.localize(108,null)}})}applyUpdate(z,ue){let Ie=!1;ue.allowedCharacters&&z&&(C.equals(z.allowedCharacters,ue.allowedCharacters)||(z={...z,allowedCharacters:ue.allowedCharacters},Ie=!0)),ue.allowedLocales&&z&&(C.equals(z.allowedLocales,ue.allowedLocales)||(z={...z,allowedLocales:ue.allowedLocales},Ie=!0));const Le=super.applyUpdate(z,ue);return Ie?new v(Le.newValue,!0):Le}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{nonBasicASCII:Ae(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(z.allowedLocales,this.defaultValue.allowedLocales)}}c(z,ue){if(typeof z!="object"||!z)return ue;const Ie={};for(const[Le,$e]of Object.entries(z))$e===!0&&(Ie[Le]=!0);return Ie}}class _ extends k{constructor(){const z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",z,{"editor.inlineSuggest.enabled":{type:"boolean",default:z.enabled,description:c.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:z.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(110,null),c.localize(111,null)],description:c.localize(112,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{enabled:d(ue.enabled,this.defaultValue.enabled),mode:i(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(ue.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class he extends k{constructor(){const z={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:z.enabled,markdownDescription:c.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:z.independentColorPoolPerBracketType,description:c.localize(114,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{enabled:d(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends k{constructor(){const z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(115,null),c.localize(116,null),c.localize(117,null)],default:z.bracketPairs,description:c.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:z.bracketPairsHorizontal,description:c.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:z.highlightActiveBracketPair,description:c.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:z.indentation,description:c.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(125,null),c.localize(126,null),c.localize(127,null)],default:z.highlightActiveIndentation,description:c.localize(128,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{bracketPairs:Ae(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ce,z,ue){const Ie=ue.indexOf(ce);return Ie===-1?z:ue[Ie]}class be extends k{constructor(){const z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(129,null),c.localize(130,null)],default:z.insertMode,description:c.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:z.filterGraceful,description:c.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:z.localityBonus,description:c.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:z.shareSuggestSelections,markdownDescription:c.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(135,null),c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:z.selectionMode,markdownDescription:c.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:z.snippetsPreventQuickSuggestions,description:c.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:z.showIcons,description:c.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:z.showStatusBar,description:c.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:z.preview,description:c.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:z.showInlineDetails,description:c.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const ue=z;return{insertMode:i(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ue.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ue.showIcons,this.defaultValue.showIcons),showStatusBar:d(ue.showStatusBar,this.defaultValue.showStatusBar),preview:d(ue.preview,this.defaultValue.preview),previewMode:i(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ue.showMethods,this.defaultValue.showMethods),showFunctions:d(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ue.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ue.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ue.showFields,this.defaultValue.showFields),showVariables:d(ue.showVariables,this.defaultValue.showVariables),showClasses:d(ue.showClasses,this.defaultValue.showClasses),showStructs:d(ue.showStructs,this.defaultValue.showStructs),showInterfaces:d(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ue.showModules,this.defaultValue.showModules),showProperties:d(ue.showProperties,this.defaultValue.showProperties),showEvents:d(ue.showEvents,this.defaultValue.showEvents),showOperators:d(ue.showOperators,this.defaultValue.showOperators),showUnits:d(ue.showUnits,this.defaultValue.showUnits),showValues:d(ue.showValues,this.defaultValue.showValues),showConstants:d(ue.showConstants,this.defaultValue.showConstants),showEnums:d(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ue.showKeywords,this.defaultValue.showKeywords),showWords:d(ue.showWords,this.defaultValue.showWords),showColors:d(ue.showColors,this.defaultValue.showColors),showFiles:d(ue.showFiles,this.defaultValue.showFiles),showReferences:d(ue.showReferences,this.defaultValue.showReferences),showFolders:d(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ue.showSnippets,this.defaultValue.showSnippets),showUsers:d(ue.showUsers,this.defaultValue.showUsers),showIssues:d(ue.showIssues,this.defaultValue.showIssues)}}}class Ce extends k{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(177,null),default:!0,type:"boolean"}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Te extends E{constructor(){super(137)}compute(z,ue,Ie){return ue.get(86)?!0:z.tabFocusMode}}var Ve;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(Ve=e.WrappingIndent||(e.WrappingIndent={}));class xe extends k{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(178,null),c.localize(179,null),c.localize(180,null),c.localize(181,null)],description:c.localize(182,null),default:"same"}})}validate(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(z,ue,Ie){return ue.get(2)===2?0:Ie}}class et extends E{constructor(){super(139)}compute(z,ue,Ie){const Le=ue.get(138);return{isDominatedByLongLines:z.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends k{constructor(){const z={enabled:!0};super(33,"dropIntoEditor",z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:z.enabled,markdownDescription:c.localize(183,null)}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{enabled:d(z.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?st:A.isLinux?ht:nt,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var rt;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.autoClosingBrackets=5]="autoClosingBrackets",ce[ce.autoClosingDelete=6]="autoClosingDelete",ce[ce.autoClosingOvertype=7]="autoClosingOvertype",ce[ce.autoClosingQuotes=8]="autoClosingQuotes",ce[ce.autoIndent=9]="autoIndent",ce[ce.automaticLayout=10]="automaticLayout",ce[ce.autoSurround=11]="autoSurround",ce[ce.bracketPairColorization=12]="bracketPairColorization",ce[ce.guides=13]="guides",ce[ce.codeLens=14]="codeLens",ce[ce.codeLensFontFamily=15]="codeLensFontFamily",ce[ce.codeLensFontSize=16]="codeLensFontSize",ce[ce.colorDecorators=17]="colorDecorators",ce[ce.colorDecoratorsLimit=18]="colorDecoratorsLimit",ce[ce.columnSelection=19]="columnSelection",ce[ce.comments=20]="comments",ce[ce.contextmenu=21]="contextmenu",ce[ce.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=23]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=25]="cursorStyle",ce[ce.cursorSurroundingLines=26]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=28]="cursorWidth",ce[ce.disableLayerHinting=29]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ce[ce.domReadOnly=31]="domReadOnly",ce[ce.dragAndDrop=32]="dragAndDrop",ce[ce.dropIntoEditor=33]="dropIntoEditor",ce[ce.emptySelectionClipboard=34]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=36]="extraEditorClassName",ce[ce.fastScrollSensitivity=37]="fastScrollSensitivity",ce[ce.find=38]="find",ce[ce.fixedOverflowWidgets=39]="fixedOverflowWidgets",ce[ce.folding=40]="folding",ce[ce.foldingStrategy=41]="foldingStrategy",ce[ce.foldingHighlight=42]="foldingHighlight",ce[ce.foldingImportsByDefault=43]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=44]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=46]="fontFamily",ce[ce.fontInfo=47]="fontInfo",ce[ce.fontLigatures=48]="fontLigatures",ce[ce.fontSize=49]="fontSize",ce[ce.fontWeight=50]="fontWeight",ce[ce.fontVariations=51]="fontVariations",ce[ce.formatOnPaste=52]="formatOnPaste",ce[ce.formatOnType=53]="formatOnType",ce[ce.glyphMargin=54]="glyphMargin",ce[ce.gotoLocation=55]="gotoLocation",ce[ce.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ce[ce.hover=57]="hover",ce[ce.inDiffEditor=58]="inDiffEditor",ce[ce.inlineSuggest=59]="inlineSuggest",ce[ce.letterSpacing=60]="letterSpacing",ce[ce.lightbulb=61]="lightbulb",ce[ce.lineDecorationsWidth=62]="lineDecorationsWidth",ce[ce.lineHeight=63]="lineHeight",ce[ce.lineNumbers=64]="lineNumbers",ce[ce.lineNumbersMinChars=65]="lineNumbersMinChars",ce[ce.linkedEditing=66]="linkedEditing",ce[ce.links=67]="links",ce[ce.matchBrackets=68]="matchBrackets",ce[ce.minimap=69]="minimap",ce[ce.mouseStyle=70]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=72]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=74]="multiCursorModifier",ce[ce.multiCursorPaste=75]="multiCursorPaste",ce[ce.multiCursorLimit=76]="multiCursorLimit",ce[ce.occurrencesHighlight=77]="occurrencesHighlight",ce[ce.overviewRulerBorder=78]="overviewRulerBorder",ce[ce.overviewRulerLanes=79]="overviewRulerLanes",ce[ce.padding=80]="padding",ce[ce.parameterHints=81]="parameterHints",ce[ce.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=84]="quickSuggestions",ce[ce.quickSuggestionsDelay=85]="quickSuggestionsDelay",ce[ce.readOnly=86]="readOnly",ce[ce.renameOnType=87]="renameOnType",ce[ce.renderControlCharacters=88]="renderControlCharacters",ce[ce.renderFinalNewline=89]="renderFinalNewline",ce[ce.renderLineHighlight=90]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=92]="renderValidationDecorations",ce[ce.renderWhitespace=93]="renderWhitespace",ce[ce.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ce[ce.roundedSelection=95]="roundedSelection",ce[ce.rulers=96]="rulers",ce[ce.scrollbar=97]="scrollbar",ce[ce.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=99]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=100]="scrollPredominantAxis",ce[ce.selectionClipboard=101]="selectionClipboard",ce[ce.selectionHighlight=102]="selectionHighlight",ce[ce.selectOnLineNumbers=103]="selectOnLineNumbers",ce[ce.showFoldingControls=104]="showFoldingControls",ce[ce.showUnused=105]="showUnused",ce[ce.snippetSuggestions=106]="snippetSuggestions",ce[ce.smartSelect=107]="smartSelect",ce[ce.smoothScrolling=108]="smoothScrolling",ce[ce.stickyScroll=109]="stickyScroll",ce[ce.stickyTabStops=110]="stickyTabStops",ce[ce.stopRenderingLineAfter=111]="stopRenderingLineAfter",ce[ce.suggest=112]="suggest",ce[ce.suggestFontSize=113]="suggestFontSize",ce[ce.suggestLineHeight=114]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ce[ce.suggestSelection=116]="suggestSelection",ce[ce.tabCompletion=117]="tabCompletion",ce[ce.tabIndex=118]="tabIndex",ce[ce.unicodeHighlighting=119]="unicodeHighlighting",ce[ce.unusualLineTerminators=120]="unusualLineTerminators",ce[ce.useShadowDOM=121]="useShadowDOM",ce[ce.useTabStops=122]="useTabStops",ce[ce.wordBreak=123]="wordBreak",ce[ce.wordSeparators=124]="wordSeparators",ce[ce.wordWrap=125]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=128]="wordWrapColumn",ce[ce.wordWrapOverride1=129]="wordWrapOverride1",ce[ce.wordWrapOverride2=130]="wordWrapOverride2",ce[ce.wrappingIndent=131]="wrappingIndent",ce[ce.wrappingStrategy=132]="wrappingStrategy",ce[ce.showDeprecated=133]="showDeprecated",ce[ce.inlayHints=134]="inlayHints",ce[ce.editorClassName=135]="editorClassName",ce[ce.pixelRatio=136]="pixelRatio",ce[ce.tabFocusMode=137]="tabFocusMode",ce[ce.layoutInfo=138]="layoutInfo",ce[ce.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(184,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(185,null),""],markdownDescription:c.localize(186,null)})),accessibilitySupport:Ue(new r),accessibilityPageSize:Ue(new b(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(187,null),tags:["accessibility"]})),ariaLabel:Ue(new g(4,"ariaLabel",c.localize(188,null))),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(189,null),c.localize(190,null),""],description:c.localize(191,null)})),autoClosingDelete:Ue(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(192,null),""],description:c.localize(193,null)})),autoClosingOvertype:Ue(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(194,null),""],description:c.localize(195,null)})),autoClosingQuotes:Ue(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(196,null),c.localize(197,null),""],description:c.localize(198,null)})),autoIndent:Ue(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[c.localize(199,null),c.localize(200,null),c.localize(201,null),c.localize(202,null),c.localize(203,null)],description:c.localize(204,null)})),automaticLayout:Ue(new f(10,"automaticLayout",!1)),autoSurround:Ue(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(205,null),c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),bracketPairColorization:Ue(new he),bracketPairGuides:Ue(new we),stickyTabStops:Ue(new f(110,"stickyTabStops",!1,{description:c.localize(209,null)})),codeLens:Ue(new f(14,"codeLens",!0,{description:c.localize(210,null)})),codeLensFontFamily:Ue(new g(15,"codeLensFontFamily","",{description:c.localize(211,null)})),codeLensFontSize:Ue(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(212,null)})),colorDecorators:Ue(new f(17,"colorDecorators",!0,{description:c.localize(213,null)})),colorDecoratorsLimit:Ue(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(214,null)})),columnSelection:Ue(new f(19,"columnSelection",!1,{description:c.localize(215,null)})),comments:Ue(new h),contextmenu:Ue(new f(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new f(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(216,null)})),cursorBlinking:Ue(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:c.localize(217,null)})),cursorSmoothCaretAnimation:Ue(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(218,null),c.localize(219,null),c.localize(220,null)],description:c.localize(221,null)})),cursorStyle:Ue(new s(25,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:c.localize(222,null)})),cursorSurroundingLines:Ue(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(223,null)})),cursorSurroundingLinesStyle:Ue(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(224,null),c.localize(225,null)],description:c.localize(226,null)})),cursorWidth:Ue(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(227,null)})),disableLayerHinting:Ue(new f(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new f(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new f(31,"domReadOnly",!1)),dragAndDrop:Ue(new f(32,"dragAndDrop",!0,{description:c.localize(228,null)})),emptySelectionClipboard:Ue(new x),dropIntoEditor:Ue(new Qe),stickyScroll:Ue(new te),experimentalWhitespaceRendering:Ue(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(229,null),c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),extraEditorClassName:Ue(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Ue(new y(37,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:c.localize(233,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new f(39,"fixedOverflowWidgets",!1)),folding:Ue(new f(40,"folding",!0,{description:c.localize(234,null)})),foldingStrategy:Ue(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(235,null),c.localize(236,null)],description:c.localize(237,null)})),foldingHighlight:Ue(new f(42,"foldingHighlight",!0,{description:c.localize(238,null)})),foldingImportsByDefault:Ue(new f(43,"foldingImportsByDefault",!1,{description:c.localize(239,null)})),foldingMaximumRegions:Ue(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(240,null)})),unfoldOnClickAfterEndOfLine:Ue(new f(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(241,null)})),fontFamily:Ue(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(242,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new M),fontSize:Ue(new U),fontWeight:Ue(new B),fontVariations:Ue(new $),formatOnPaste:Ue(new f(52,"formatOnPaste",!1,{description:c.localize(243,null)})),formatOnType:Ue(new f(53,"formatOnType",!1,{description:c.localize(244,null)})),glyphMargin:Ue(new f(54,"glyphMargin",!0,{description:c.localize(245,null)})),gotoLocation:Ue(new j),hideCursorInOverviewRuler:Ue(new f(56,"hideCursorInOverviewRuler",!1,{description:c.localize(246,null)})),hover:Ue(new de),inDiffEditor:Ue(new f(58,"inDiffEditor",!1)),letterSpacing:Ue(new y(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>y.clamp(ce,-5,20),{description:c.localize(247,null)})),lightbulb:Ue(new Z),lineDecorationsWidth:Ue(new J),lineHeight:Ue(new ie),lineNumbers:Ue(new ee),lineNumbersMinChars:Ue(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new f(66,"linkedEditing",!1,{description:c.localize(248,null)})),links:Ue(new f(67,"links",!0,{description:c.localize(249,null)})),matchBrackets:Ue(new o(68,"matchBrackets","always",["always","near","never"],{description:c.localize(250,null)})),minimap:Ue(new pe),mouseStyle:Ue(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new y(71,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:c.localize(251,null)})),mouseWheelZoom:Ue(new f(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(252,null)})),multiCursorMergeOverlapping:Ue(new f(73,"multiCursorMergeOverlapping",!0,{description:c.localize(253,null)})),multiCursorModifier:Ue(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[c.localize(254,null),c.localize(255,null)],markdownDescription:c.localize(256,null)})),multiCursorPaste:Ue(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(257,null),c.localize(258,null)],markdownDescription:c.localize(259,null)})),multiCursorLimit:Ue(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(260,null)})),occurrencesHighlight:Ue(new f(77,"occurrencesHighlight",!0,{description:c.localize(261,null)})),overviewRulerBorder:Ue(new f(78,"overviewRulerBorder",!0,{description:c.localize(262,null)})),overviewRulerLanes:Ue(new b(79,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),parameterHints:Ue(new Oe),peekWidgetDefaultFocus:Ue(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],description:c.localize(265,null)})),definitionLinkOpensInPeek:Ue(new f(83,"definitionLinkOpensInPeek",!1,{description:c.localize(266,null)})),quickSuggestions:Ue(new ae),quickSuggestionsDelay:Ue(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(267,null)})),readOnly:Ue(new f(86,"readOnly",!1)),renameOnType:Ue(new f(87,"renameOnType",!1,{description:c.localize(268,null),markdownDeprecationMessage:c.localize(269,null)})),renderControlCharacters:Ue(new f(88,"renderControlCharacters",!0,{description:c.localize(270,null),restricted:!0})),renderFinalNewline:Ue(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(271,null)})),renderLineHighlight:Ue(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(272,null)],description:c.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Ue(new f(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(274,null)})),renderValidationDecorations:Ue(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(275,null),c.localize(276,null),c.localize(277,null),""],description:c.localize(278,null)})),revealHorizontalRightPadding:Ue(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new f(95,"roundedSelection",!0,{description:c.localize(279,null)})),rulers:Ue(new re),scrollbar:Ue(new W),scrollBeyondLastColumn:Ue(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(280,null)})),scrollBeyondLastLine:Ue(new f(99,"scrollBeyondLastLine",!0,{description:c.localize(281,null)})),scrollPredominantAxis:Ue(new f(100,"scrollPredominantAxis",!0,{description:c.localize(282,null)})),selectionClipboard:Ue(new f(101,"selectionClipboard",!0,{description:c.localize(283,null),included:A.isLinux})),selectionHighlight:Ue(new f(102,"selectionHighlight",!0,{description:c.localize(284,null)})),selectOnLineNumbers:Ue(new f(103,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(285,null),c.localize(286,null),c.localize(287,null)],description:c.localize(288,null)})),showUnused:Ue(new f(105,"showUnused",!0,{description:c.localize(289,null)})),showDeprecated:Ue(new f(133,"showDeprecated",!0,{description:c.localize(290,null)})),inlayHints:Ue(new X),snippetSuggestions:Ue(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(291,null),c.localize(292,null),c.localize(293,null),c.localize(294,null)],description:c.localize(295,null)})),smartSelect:Ue(new Ce),smoothScrolling:Ue(new f(108,"smoothScrolling",!1,{description:c.localize(296,null)})),stopRenderingLineAfter:Ue(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new be),inlineSuggest:Ue(new _),suggestFontSize:Ue(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new f(115,"suggestOnTriggerCharacters",!0,{description:c.localize(299,null)})),suggestSelection:Ue(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(300,null),c.localize(301,null),c.localize(302,null)],description:c.localize(303,null)})),tabCompletion:Ue(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(304,null),c.localize(305,null),c.localize(306,null)],description:c.localize(307,null)})),tabIndex:Ue(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new K),unusualLineTerminators:Ue(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(308,null),c.localize(309,null),c.localize(310,null)],description:c.localize(311,null)})),useShadowDOM:Ue(new f(121,"useShadowDOM",!0)),useTabStops:Ue(new f(122,"useTabStops",!0,{description:c.localize(312,null)})),wordBreak:Ue(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(313,null),c.localize(314,null)],description:c.localize(315,null)})),wordSeparators:Ue(new g(124,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:c.localize(316,null)})),wordWrap:Ue(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(317,null),c.localize(318,null),c.localize(319,null),c.localize(320,null)],description:c.localize(321,null)})),wordWrapBreakAfterCharacters:Ue(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(322,null)})),wordWrapOverride1:Ue(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new F),pixelRatio:Ue(new oe),tabFocusMode:Ue(new Te),layoutInfo:Ue(new q),wrappingInfo:Ue(new et),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new Q)}}),define(ye[168],De([19,20]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],De([19,20]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],De([19,20]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],De([19,20]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],De([19,20]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[173],De([19,20]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[174],De([19,20]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[175],De([19,20]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[176],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[177],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[178],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[179],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[180],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[181],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[182],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[183],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[184],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[185],De([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[186],De([19,20]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[187],De([19,20]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(ye[188],De([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[189],De([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[190],De([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[191],De([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[192],De([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[193],De([19,20]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[194],De([19,20]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[195],De([19,20]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[196],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(R,C){this.a.set(R,C)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const C in R.contributes){const P=this.a.get(C);if(!P)continue;const S=R.contributes[C],I=Array.isArray(S)?S:[S];try{P(I,R.activationEvents)}catch(L){(0,c.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(ye[197],De([1,0,24,37,170,318]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(f){return f=f.trim(),f==="*"||C.test(f)}e.isValidVersionStr=S;function I(f){if(!S(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function L(f){if(!f)return null;const p=f.majorBase,b=f.majorMustEqual,y=f.minorBase;let g=f.minorMustEqual;const i=f.patchBase;let o=f.patchMustEqual;f.hasCaret&&(p===0||(g=!1),o=!1);let s=0;if(f.preRelease){const l=P.exec(f.preRelease);if(l){const[,r,h,n]=l;s=Date.UTC(Number(r),Number(h)-1,Number(n))}}return{majorBase:p,majorMustEqual:b,minorBase:y,minorMustEqual:g,patchBase:i,patchMustEqual:o,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function k(f,p,b){let y;typeof f=="string"?y=L(I(f)):y=f;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof b=="string"?i=L(I(b)):i=b,!y||!i)return!1;const o=y.majorBase,s=y.minorBase,l=y.patchBase;let r=i.majorBase,h=i.minorBase,n=i.patchBase;const t=i.notBefore;let a=i.majorMustEqual,w=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?o>r?!0:o<r?!1:s>h?!0:s<h||g&&g<t?!1:l>=n:(o===1&&r===0&&(!a||!w||!D)&&(r=1,h=0,n=0,a=!0,w=!1,D=!1),o<r?!1:o>r?!a:s<h?!1:s>h?!w:l<n?!1:l>n?!D:!(g&&g<t))}e.isValidVersion=k;function v(f,p,b,y,g){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([A.default.Error,u.localize(0,null)]),i;if(typeof y.name!="string")return i.push([A.default.Error,u.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([A.default.Error,u.localize(2,null,"version")]),i;if(!y.engines)return i.push([A.default.Error,u.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([A.default.Error,u.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!d(y.extensionDependencies))return i.push([A.default.Error,u.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!d(y.activationEvents))return i.push([A.default.Error,u.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([A.default.Error,u.localize(7,null,"activationEvents","main")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([A.default.Warning,u.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([A.default.Error,u.localize(9,null,"main")]),i;{const l=(0,c.joinPath)(b,y.main);(0,c.isEqualOrParent)(l,b)||i.push([A.default.Warning,u.localize(10,null,l.path,b.path)])}if(typeof y.activationEvents>"u")return i.push([A.default.Error,u.localize(11,null,"activationEvents","main")]),i}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([A.default.Error,u.localize(12,null,"browser")]),i;{const l=(0,c.joinPath)(b,y.browser);(0,c.isEqualOrParent)(l,b)||i.push([A.default.Warning,u.localize(13,null,l.path,b.path)])}if(typeof y.activationEvents>"u")return i.push([A.default.Error,u.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(y.version))return i.push([A.default.Error,u.localize(15,null)]),i;const o=[];if(!T(f,p,y,g,o))for(const l of o)i.push([A.default.Error,l]);return i}e.validateExtensionManifest=v;function T(f,p,b,y,g){return y||typeof b.main>"u"&&typeof b.browser>"u"?!0:m(f,p,b.engines.vscode,g)}e.isValidExtensionVersion=T;function E(f,p,b){return f==="*"||m(p,b,f)}e.isEngineValid=E;function m(f,p,b,y=[]){const g=L(I(b));if(!g)return y.push(u.localize(16,null,b)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return y.push(u.localize(17,null,b)),!1}else if(!g.majorMustEqual)return y.push(u.localize(18,null,b)),!1;return k(f,p,g)?!0:(y.push(u.localize(19,null,f,b)),!1)}function d(f){if(!Array.isArray(f))return!1;for(let p=0,b=f.length;p<b;p++)if(typeof f[p]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(u,R=[],C=!1){this.ctor=u,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=c}),define(ye[89],De([1,0,122]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var u;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(u=e.InstantiationType||(e.InstantiationType={}));function R(P,S,I){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(I))),A.push([P,S])}e.registerSingleton=R;function C(){return A}e.getSingletonServiceDescriptors=C}),define(ye[198],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const P=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(C);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let P=this.a.get(C);return P||(P=new c(C,R),this.a.set(C,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,P]of this.a)R.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const P=new Set([R]),S=this.c(C,P);if(S)return S}}c(R,C){for(const[P,S]of R.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const I=this.c(S,C);if(I)return I;C.delete(P)}}}e.Graph=A}),define(ye[4],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(c=e._util||(e._util={})),e.IInstantiationService=u("instantiationService");function A(C,P,S){P[c.DI_TARGET]===P?P[c.DI_DEPENDENCIES].push({id:C,index:S}):(P[c.DI_DEPENDENCIES]=[{id:C,index:S}],P[c.DI_TARGET]=P)}function u(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const P=function(S,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,S,L)};return P.toString=()=>C,c.serviceIds.set(C,P),P}e.createDecorator=u;function R(C){return C}e.refineServiceDecorator=R}),define(ye[54],De([1,0,10,2,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof A.URI)}e.isConfigurationOverrides=R;function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=C;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function I(d,f){const p=Object.create(null);for(const b in d)L(p,b,d[b],f);return p}e.toValuesTree=I;function L(d,f,p,b){const y=f.split("."),g=y.pop();let i=d;for(let o=0;o<y.length;o++){const s=y[o];let l=i[s];switch(typeof l){case"undefined":l=i[s]=Object.create(null);break;case"object":break;default:b(`Ignoring ${f} as ${y.slice(0,o+1).join(".")} is ${JSON.stringify(l)}`);return}i=l}if(typeof i=="object"&&i!==null)try{i[g]=p}catch{b(`Ignoring ${f} as ${y.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${f} as ${y.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=L;function k(d,f){const p=f.split(".");v(d,p)}e.removeFromValueTree=k;function v(d,f){const p=f.shift();if(f.length===0){delete d[p];return}if(Object.keys(d).indexOf(p)!==-1){const b=d[p];typeof b=="object"&&!Array.isArray(b)&&(v(b,f),Object.keys(b).length===0&&delete d[p])}}function T(d,f,p){function b(i,o){let s=i;for(const l of o){if(typeof s!="object"||s===null)return;s=s[l]}return s}const y=f.split("."),g=b(d,y);return typeof g>"u"?p:g}e.getConfigurationValue=T;function E(d,f,p){Object.keys(f).forEach(b=>{b!=="__proto__"&&(b in d?c.isObject(d[b])&&c.isObject(f[b])?E(d[b],f[b],p):p&&(d[b]=f[b]):d[b]=f[b])})}e.merge=E;function m(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(ye[55],De([1,0,12,8,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",c.isEdge),R.set("isFirefox",c.isFirefox),R.set("isChrome",c.isChrome),R.set("isSafari",c.isSafari);const C=Object.prototype.hasOwnProperty;var P;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return k.INSTANCE}static true(){return v.INSTANCE}static has(M){return T.create(M)}static equals(M,$){return E.create(M,$)}static notEquals(M,$){return f.create(M,$)}static regex(M,$){return s.create(M,$)}static in(M,$){return m.create(M,$)}static notIn(M,$){return d.create(M,$)}static not(M){return p.create(M)}static and(...M){return h.create(M,null,!0)}static or(...M){return n.create(M,null,!0)}static greater(M,$){return y.create(M,$)}static greaterEquals(M,$){return g.create(M,$)}static smaller(M,$){return i.create(M,$)}static smallerEquals(M,$){return o.create(M,$)}static deserialize(M,$=!1){if(!!M)return this.c(M,$)}static c(M,$){const O=M.split("||");return n.create(O.map(U=>this.d(U,$)),null,!0)}static d(M,$){const O=M.split("&&");return h.create(O.map(U=>this.f(U,$)),null,!0)}static f(M,$){if(M=M.trim(),M.indexOf("!=")>=0){const O=M.split("!=");return f.create(O[0].trim(),this.g(O[1],$))}if(M.indexOf("==")>=0){const O=M.split("==");return E.create(O[0].trim(),this.g(O[1],$))}if(M.indexOf("=~")>=0){const O=M.split("=~");return s.create(O[0].trim(),this.h(O[1],$))}if(M.indexOf(" not in ")>=0){const O=M.split(" not in ");return d.create(O[0].trim(),this.g(O[1],$))}if(M.indexOf(" in ")>=0){const O=M.split(" in ");return m.create(O[0].trim(),this.g(O[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const O=M.split(">=");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const O=M.split(">");return y.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const O=M.split("<=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const O=M.split("<");return i.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(M)?p.create(M.substr(1).trim()):T.create(M)}static g(M,$){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const O=/^'([^']*)'$/.exec(M);return O?O[1].trim():M}static h(M,$){if((0,A.isFalsyOrWhitespace)(M)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=M.indexOf("/"),U=M.lastIndexOf("/");if(O===U||O<0){if($)throw new Error(`bad regexp-value '${M}', missing /-enclosure`);return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null}const B=M.slice(O+1,U),j=M[U+1]==="i"?"i":"";try{return new RegExp(B,j)}catch(de){if($)throw new Error(`bad regexp-value '${M}', parse error: ${de}`);return console.warn(`bad regexp-value '${M}', parse error: ${de}`),null}}}e.ContextKeyExpr=S;function I(V,M){const $=V?V.substituteConstants():void 0,O=M?M.substituteConstants():void 0;return!$&&!O?!0:!$||!O?!1:$.equals(O)}e.expressionsAreEqualWithConstantSubstitution=I;function L(V,M){return V.cmp(M)}class k{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}k.INSTANCE=new k,e.ContextKeyFalseExpr=k;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return k.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class T{static create(M,$=null){const O=R.get(M);return typeof O=="boolean"?O?v.INSTANCE:k.INSTANCE:new T(M,$)}constructor(M,$){this.key=M,this.c=$,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:a(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=R.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:k.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=T;class E{static create(M,$,O=null){if(typeof $=="boolean")return $?T.create(M,O):p.create(M,O);const U=R.get(M);return typeof U=="boolean"?$===(U?"true":"false")?v.INSTANCE:k.INSTANCE:new E(M,$,O)}constructor(M,$,O){this.c=M,this.d=$,this.f=O,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const $=M?"true":"false";return this.d===$?v.INSTANCE:k.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=E;class m{static create(M,$){return new m(M,$)}constructor(M,$){this.d=M,this.f=$,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:w(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const $=M.getValue(this.f),O=M.getValue(this.d);return Array.isArray($)?$.includes(O):typeof O=="string"&&typeof $=="object"&&$!==null?C.call($,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class d{static create(M,$){return new d(M,$)}constructor(M,$){this.d=M,this.f=$,this.type=11,this.c=m.create(M,$)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class f{static create(M,$,O=null){if(typeof $=="boolean")return $?p.create(M,O):T.create(M,O);const U=R.get(M);return typeof U=="boolean"?$===(U?"true":"false")?k.INSTANCE:v.INSTANCE:new f(M,$,O)}constructor(M,$,O){this.c=M,this.d=$,this.f=O,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const $=M?"true":"false";return this.d===$?k.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class p{static create(M,$=null){const O=R.get(M);return typeof O=="boolean"?O?k.INSTANCE:v.INSTANCE:new p(M,$)}constructor(M,$){this.c=M,this.d=$,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:a(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=R.get(this.c);return typeof M=="boolean"?M?k.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=T.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function b(V,M){if(typeof V=="string"){const $=parseFloat(V);isNaN($)||(V=$)}return typeof V=="string"||typeof V=="number"?M(V):k.INSTANCE}class y{static create(M,$,O=null){return b($,U=>new y(M,U,O))}constructor(M,$,O){this.c=M,this.d=$,this.f=O,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=y;class g{static create(M,$,O=null){return b($,U=>new g(M,U,O))}constructor(M,$,O){this.c=M,this.d=$,this.f=O,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=g;class i{static create(M,$,O=null){return b($,U=>new i(M,U,O))}constructor(M,$,O){this.c=M,this.d=$,this.f=O,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class o{static create(M,$,O=null){return b($,U=>new o(M,U,O))}constructor(M,$,O){this.c=M,this.d=$,this.f=O,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class s{static create(M,$){return new s(M,$)}constructor(M,$){this.d=M,this.f=$,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const $=this.f?this.f.source:"",O=M.f?M.f.source:"";return $<O?-1:$>O?1:0}equals(M){if(M.type===this.type){const $=this.f?this.f.source:"",O=M.f?M.f.source:"";return this.d===M.d&&$===O}return!1}substituteConstants(){return this}evaluate(M){const $=M.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=l.create(this)),this.c}}e.ContextKeyRegexExpr=s;class l{static create(M){return new l(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new l(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=l;function r(V){let M=null;for(let $=0,O=V.length;$<O;$++){const U=V[$].substituteConstants();if(V[$]!==U&&M===null){M=[];for(let B=0;B<$;B++)M[B]=V[B]}M!==null&&(M[$]=U)}return M===null?V:M}class h{static create(M,$,O){return h.d(M,$,O)}constructor(M,$){this.expr=M,this.c=$,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let $=0,O=this.expr.length;$<O;$++){const U=L(this.expr[$],M.expr[$]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let $=0,O=this.expr.length;$<O;$++)if(!this.expr[$].equals(M.expr[$]))return!1;return!0}return!1}substituteConstants(){const M=r(this.expr);return M===this.expr?this:h.create(M,this.c,!1)}evaluate(M){for(let $=0,O=this.expr.length;$<O;$++)if(!this.expr[$].evaluate(M))return!1;return!0}static d(M,$,O){const U=[];let B=!1;for(const j of M)if(!!j){if(j.type===1){B=!0;continue}if(j.type===0)return k.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&B)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const de=U.pop(),Y=U.length===0,q=n.create(j.expr.map(Q=>h.create([Q,de],null,O)),null,Y);q&&(U.push(q),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let de=j+1;de<U.length;de++)if(U[j].negate().equals(U[de]))return k.INSTANCE;if(U.length===1)return U[0]}return new h(U,$)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const $ of this.expr)M.push(...$.keys());return M}map(M){return new h(this.expr.map($=>$.map(M)),null)}negate(){if(!this.c){const M=[];for(const $ of this.expr)M.push($.negate());this.c=n.create(M,this,!0)}return this.c}}class n{static create(M,$,O){return n.d(M,$,O)}constructor(M,$){this.expr=M,this.c=$,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let $=0,O=this.expr.length;$<O;$++){const U=L(this.expr[$],M.expr[$]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let $=0,O=this.expr.length;$<O;$++)if(!this.expr[$].equals(M.expr[$]))return!1;return!0}return!1}substituteConstants(){const M=r(this.expr);return M===this.expr?this:n.create(M,this.c,!1)}evaluate(M){for(let $=0,O=this.expr.length;$<O;$++)if(this.expr[$].evaluate(M))return!0;return!1}static d(M,$,O){let U=[],B=!1;if(M){for(let j=0,de=M.length;j<de;j++){const Y=M[j];if(!!Y){if(Y.type===0){B=!0;continue}if(Y.type===1)return v.INSTANCE;if(Y.type===9){U=U.concat(Y.expr);continue}U.push(Y)}}if(U.length===0&&B)return k.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let de=j+1;de<U.length;de++)if(U[j].negate().equals(U[de]))return v.INSTANCE;if(U.length===1)return U[0]}return new n(U,$)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const $ of this.expr)M.push(...$.keys());return M}map(M){return new n(this.expr.map($=>$.map(M)),null)}negate(){if(!this.c){const M=[];for(const $ of this.expr)M.push($.negate());for(;M.length>1;){const $=M.shift(),O=M.shift(),U=[];for(const B of x($))for(const j of x(O))U.push(h.create([B,j],null,!1));M.unshift(n.create(U,null,!1))}this.c=n.create(M,this,!0)}return this.c}}class t extends T{static all(){return t.d.values()}constructor(M,$,O){super(M,null),this.f=$,typeof O=="object"?t.d.push({...O,key:M}):O!==!0&&t.d.push({key:M,description:O,type:$!=null?typeof $:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return E.create(this.key,M)}notEqualsTo(M){return f.create(this.key,M)}}t.d=[],e.RawContextKey=t,e.IContextKeyService=(0,u.createDecorator)("contextKeyService");function a(V,M){return V<M?-1:V>M?1:0}function w(V,M,$,O){return V<$?-1:V>$?1:M<O?-1:M>O?1:0}function D(V,M){if(V.type===0||M.type===1)return!0;if(V.type===9)return M.type===9?F(V.expr,M.expr):!1;if(M.type===9){for(const $ of M.expr)if(D(V,$))return!0;return!1}if(V.type===6){if(M.type===6)return F(M.expr,V.expr);for(const $ of V.expr)if(D($,M))return!0;return!1}return V.equals(M)}e.implies=D;function F(V,M){let $=0,O=0;for(;$<V.length&&O<M.length;){const U=V[$].cmp(M[O]);if(U<0)return!1;U===0&&$++,O++}return $===V.length}function x(V){return V.type===9?V.expr:[V]}}),define(ye[199],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,169,4]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function u(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function P(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function S(f,p,b){return P(p,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:I(b).includes(f)}e.isTargetPlatformCompatible=S;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var v;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var T;(function(f){f.Install="install",f.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[200],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(ye[201],De([1,0,46,16,9,12,104,29,113,171,200]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends v{openTerminal(y,g){return this.spawnTerminal(c,y,S.getWindowsShell(),g)}spawnTerminal(y,g,i,o){const s=g.windowsExec||T.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const l=u.basename(s,".exe").toLowerCase();if(l==="cmder")return y.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),l==="wt"&&r.push("-d ."),new Promise((h,n)=>{const t=d(process),a=y.spawn(i,r,{cwd:o,env:t});a.on("error",n),a.on("exit",()=>h())})}runInTerminal(y,g,i,o,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:T.getDefaultTerminalWindows();return new Promise((r,h)=>{const n=`"${g} - ${k}"`,t=`""${i.join('" "')}" & pause"`,a=Object.assign({},d(process),o);Object.keys(a).filter(V=>a[V]===null).forEach(V=>delete a[V]);const w={cwd:g,env:a,windowsVerbatimArguments:!0};let D,F;u.basename(l,".exe")==="wt"?(D=l,F=["-d",".",T.b,"/c",t]):(D=T.b,F=["/c","start",n,"/wait",l,"/c",t]),c.spawn(D,F,w).on("error",V=>{h(f(V))}),r(void 0)})}static getDefaultTerminalWindows(){if(!T.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return T.d}}T.b="cmd.exe",e.WindowsExternalTerminalService=T;class E extends v{openTerminal(y,g){return this.spawnTerminal(c,y,g)}runInTerminal(y,g,i,o,s){const l=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,h)=>{if(l===L.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",a=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",y||k,"-w",g];for(const F of i)a.push("-a"),a.push(F);if(o){const F=Object.assign({},d(process),o);for(const x in F){const V=F[x];V===null?(a.push("-u"),a.push(x)):(a.push("-e"),a.push(`${x}=${V}`))}}let w="";const D=c.spawn(E.b,a);D.on("error",F=>{h(f(F))}),D.stderr.on("data",F=>{w+=F.toString()}),D.on("exit",F=>{if(F===0)r(void 0);else if(w){const x=w.split(`
`,1);h(new Error(x[0]))}else h(new Error(I.localize(1,null,n,F)))})}else h(new Error(I.localize(2,null,l)))})}spawnTerminal(y,g,i){const o=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{const r=["-a",o];i&&r.push(i);const h=d(process),n=y.spawn("/usr/bin/open",r,{cwd:i,env:h});n.on("error",l),n.on("exit",()=>s())})}}E.b="/usr/bin/osascript",e.MacExternalTerminalService=E;class m extends v{openTerminal(y,g){return this.spawnTerminal(c,y,g)}runInTerminal(y,g,i,o,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,h)=>{const n=[];l.then(t=>{t.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const a=`${p(i)}; echo; read -p "${m.b}" -n1;`;n.push(`''${a}''`);const w=Object.assign({},d(process),o);Object.keys(w).filter(V=>w[V]===null).forEach(V=>delete w[V]);const D={cwd:g,env:w};let F="";const x=c.spawn(t,n,D);x.on("error",V=>{h(f(V))}),x.stderr.on("data",V=>{F+=V.toString()}),x.on("exit",V=>{if(V===0)r(void 0);else if(F){const M=F.split(`
`,1);h(new Error(M[0]))}else h(new Error(I.localize(4,null,t,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.isLinux)m.d=Promise.resolve("xterm");else{const y=await P.Promises.exists("/etc/debian_version");m.d=new Promise(g=>{y?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return m.d}spawnTerminal(y,g,i){const o=g.linuxExec?Promise.resolve(g.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{o.then(r=>{const h=d(process),n=y.spawn(r,[],{cwd:i,env:h});n.on("error",l),n.on("exit",()=>s())})})}}m.b=I.localize(3,null),e.LinuxExternalTerminalService=m;function d(b){const y={...b.env};return(0,C.sanitizeProcessEnvironment)(y),y}function f(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function p(b){let y="";for(const g of b)g.indexOf(" ")>=0?y+='"'+g+'"':y+=g,y+=" ";return y}}),define(ye[44],De([1,0,68,9,8,10,2,172,4,12,16]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(q){return q.create===!0}e.isFileOpenForWriteOptions=k;var v;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var T;(function(q){q[q.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var E;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=m;function d(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=d;function f(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=f;function p(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function b(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=b;function y(q){return m(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var g;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{constructor(Q,Z){super(Q),this.code=Z}}e.FileSystemProviderError=i;function o(q,Q){const Z=new i(q.toString(),Q);return l(Z,Q),Z}e.createFileSystemProviderError=o;function s(q){return q||o((0,P.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=s;function l(q,Q){return q.name=Q?`${Q} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=l;function r(q){if(!q)return g.Unknown;if(q instanceof i)return q.code;const Q=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Q)return g.Unknown;switch(Q[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=r;function h(q){if(q instanceof F)return q.fileOperationResult;switch(r(q)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(Q,Z,te){this.resource=Q,this.operation=Z,this.target=te}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=t;var a;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class w{constructor(Q,Z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const X of Q){const J=te.get(X.type);switch(J?J.push([X.resource,X]):te.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,J]of te)switch(X){case 1:this.a=c.TernarySearchTree.forUris(()=>Z),this.a.fill(J);break;case 0:this.b=c.TernarySearchTree.forUris(()=>Z),this.b.fill(J);break;case 2:this.c=c.TernarySearchTree.forUris(()=>Z),this.c.fill(J);break}}contains(Q,...Z){return this.d(Q,{includeChildren:!1},...Z)}affects(Q,...Z){return this.d(Q,{includeChildren:!0},...Z)}d(Q,Z,...te){if(!Q)return!1;const X=te.length>0;return!!((!X||te.includes(1))&&(this.a?.get(Q)||Z.includeChildren&&this.a?.findSuperstr(Q))||(!X||te.includes(0))&&(this.b?.get(Q)||Z.includeChildren&&this.b?.findSuperstr(Q))||(!X||te.includes(2))&&(this.c?.findSubstr(Q)||Z.includeChildren&&this.c?.findSuperstr(Q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=w;function D(q,Q,Z){return!q||!Q||q===Q||Q.length>q.length?!1:(Q.charAt(Q.length-1)!==A.sep&&(Q+=A.sep),Z?(0,u.startsWithIgnoreCase)(q,Q):q.indexOf(Q)===0)}e.isParent=D;class F extends Error{constructor(Q,Z,te){super(Q),this.fileOperationResult=Z,this.options=te}}e.FileOperationError=F;class x extends F{constructor(Q,Z,te,X){super(Q,Z,X),this.fileOperationResult=Z,this.size=te}}e.TooLargeFileOperationError=x;class V extends F{constructor(Q,Z,te){super(Q,2,te),this.stat=Z}}e.NotModifiedSinceFileOperationError=V;var M;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=O;async function U(q,Q){if(!Q.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(Z=>{const te=Q.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===q.scheme&&X.added&&(te.dispose(),Z())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(Q){return(0,R.isNumber)(Q)||(Q=0),Q<B.KB?(0,P.localize)(1,null,Q.toFixed(0)):Q<B.MB?(0,P.localize)(2,null,(Q/B.KB).toFixed(2)):Q<B.GB?(0,P.localize)(3,null,(Q/B.MB).toFixed(2)):Q<B.TB?(0,P.localize)(4,null,(Q/B.GB).toFixed(2)):(0,P.localize)(5,null,(Q/B.TB).toFixed(2))}}B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB,e.ByteSize=B;var j;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function de(q){return{maxFileSize:q===0?300*B.MB:16*B.GB,maxHeapSize:q===0?700*B.MB:2*700*B.MB}}e.getPlatformFileLimits=de;function Y(q){const Q=typeof q=="string"||q?.scheme===L.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===L.Schemas.file?1024*B.MB:Q?10*B.MB:I.isWeb?50*B.MB:1024*B.MB}e.getLargeFileConfirmationLimit=Y}),define(ye[90],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...u){this.a=new Map;for(const[R,C]of u)this.set(R,C)}set(u,R){const C=this.a.get(u);return this.a.set(u,R),C}has(u){return this.a.has(u)}get(u){return this.a.get(u)}}e.ServiceCollection=c}),define(ye[202],De([1,0,17,11,6,122,198,4,90,67]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class k extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new S.ServiceCollection,f=!1,p,b=L){this.f=d,this.g=f,this.h=p,this.i=b,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new C.Graph(y=>y):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...f){const p=E.traceInvocation(this.i,d);let b=!1;try{return d({get:g=>{if(b)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...f)}finally{b=!0,p.stop()}}createInstance(d,...f){let p,b;return d instanceof R.SyncDescriptor?(p=E.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(f),p)):(p=E.traceCreation(this.i,d),b=this.j(d,f,p)),p.stop(),b}j(d,f=[],p){const b=P._util.getServiceDependencies(d).sort((i,o)=>i.index-o.index),y=[];for(const i of b){const o=this.m(i.id,p);o||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(o)}const g=b.length>0?b[0].index:f.length;if(f.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${f.length} static arguments`);const i=g-f.length;i>0?f=f.concat(new Array(i)):f=f.slice(0,g)}return Reflect.construct(d,f.concat(y))}k(d,f){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,f);else if(this.h)this.h.k(d,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const f=this.f.get(d);return!f&&this.h?this.h.l(d):f}m(d,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const p=this.l(d);return p instanceof R.SyncDescriptor?this.q(d,p,f.branch(d,!0)):(f.branch(d,!1),p)}q(d,f,p){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,f,p)}finally{this.o.delete(d)}}r(d,f,p){const b=new C.Graph(i=>i.id.toString());let y=0;const g=[{id:d,desc:f,_trace:p}];for(;g.length;){const i=g.pop();if(b.lookupOrInsertNode(i),y++>1e3)throw new k(b);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof R.SyncDescriptor){const l={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};b.insertEdge(i,l),g.push(l)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:o}of i){if(this.l(o.id)instanceof R.SyncDescriptor){const l=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,l)}b.removeNode(o)}}return this.l(d)}s(d,f,p=[],b,y){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,f,p,b,y);if(this.h)return this.h.s(d,f,p,b,y);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(d,f,p=[],b,y){if(b){const g=new v(void 0,this.g,this,this.i);g.c=String(d);const i=new Map,o=new c.IdleValue(()=>{const s=g.j(f,p,y);for(const[l,r]of i){const h=s[l];if(typeof h=="function")for(const n of r)h.apply(s,n)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!o.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=i.get(l);return n||(n=new I.LinkedList,i.set(l,n)),(a,w,D)=>{const F=n.push([a,w,D]);return(0,u.toDisposable)(F)}}if(l in s)return s[l];const r=o.value;let h=r[l];return typeof h!="function"||(h=h.bind(r),s[l]=h),h},set(s,l,r){return o.value[l]=r,!0},getPrototypeOf(s){return f.prototype}})}else return this.j(f,p,y)}u(d,f){if(f&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var T;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(T||(T={}));class E{static traceInvocation(d,f){return d?new E(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,f){return d?new E(1,f.name):E.c}constructor(d,f){this.type=d,this.name=f,this.g=Date.now(),this.h=[]}branch(d,f){const p=new E(3,d.toString());return this.h.push([d,f,p]),p}stop(){const d=Date.now()-this.g;E.f+=d;let f=!1;function p(y,g){const i=[],o=new Array(y+1).join("	");for(const[s,l,r]of g.h)if(l&&r){f=!0,i.push(`${o}CREATES -> ${s}`);const h=p(y+1,r);h&&i.push(h)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||f)&&E.all.add(b.join(`
`))}}E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0,e.Trace=E}),define(ye[13],De([1,0,45,3,6,28,12,10,2,4]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function L(){return new Date().toISOString()}function k(n){return(0,P.isNumber)(n)}e.isLogLevel=k;var v;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function T(n,t,a){switch(t){case v.Trace:n.trace(a);break;case v.Debug:n.debug(a);break;case v.Info:n.info(a);break;case v.Warning:n.warn(a);break;case v.Error:n.error(a);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=T;function E(n){let t="";for(let a=0;a<n.length;a++){let w=n[a];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}t+=(a>0?" ":"")+w}return t}e.format=E;class m extends u.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=m;class d extends m{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...a){this.f(v.Trace)&&this.g(v.Trace,E([t,...a]))}debug(t,...a){this.f(v.Debug)&&this.g(v.Debug,E([t,...a]))}info(t,...a){this.f(v.Info)&&this.g(v.Info,E([t,...a]))}warn(t,...a){this.f(v.Warning)&&this.g(v.Warning,E([t,...a]))}error(t,...a){if(this.f(v.Error))if(t instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=t.stack,this.g(v.Error,E(w))}else this.g(v.Error,E([t,...a]))}flush(){}}e.AbstractMessageLogger=d;class f extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!C.isWindows}trace(t,...a){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...a):console.log(`[main ${L()}]`,t,...a))}debug(t,...a){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...a):console.log(`[main ${L()}]`,t,...a))}info(t,...a){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...a):console.log(`[main ${L()}]`,t,...a))}warn(t,...a){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,t,...a):console.warn(`[main ${L()}]`,t,...a))}error(t,...a){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,t,...a):console.error(`[main ${L()}]`,t,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class p extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...a){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...a)}debug(t,...a){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...a)}info(t,...a){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...a)}warn(t,...a){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...a)}error(t,...a){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...a)}dispose(){}flush(){}}e.ConsoleLogger=p;class b extends m{constructor(t,a=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(a)}trace(t,...a){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...a])}debug(t,...a){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...a])}info(t,...a){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...a])}warn(t,...a){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...a])}error(t,...a){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...a])}h(t){return typeof t=="string"?t:(0,c.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class y extends m{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const a of this.g)a.setLevel(t);super.setLevel(t)}trace(t,...a){for(const w of this.g)w.trace(t,...a)}debug(t,...a){for(const w of this.g)w.debug(t,...a)}info(t,...a){for(const w of this.g)w.info(t,...a)}warn(t,...a){for(const w of this.g)w.warn(t,...a)}error(t,...a){for(const w of this.g)w.error(t,...a)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=y;class g extends u.Disposable{constructor(t,a){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,a)for(const w of a)this.c.set(w.resource,w)}getLogger(t){return this.b.get(t)}createLogger(t,a){let w=this.b.get(t);const D=a?.logLevel==="always"?v.Trace:a?.logLevel;return w||(w=this.k(t,D??this.getLogLevel(t)??this.j,a),this.b.set(t,w)),this.registerLogger({resource:t,id:a?.id??t.toString(),logLevel:D,name:a?.name,hidden:a?.hidden,extensionId:a?.extensionId}),w}setLogLevel(t,a){if(S.URI.isUri(t)){const w=t,D=a,F=this.c.get(w);F&&D!==F.logLevel&&(F.logLevel=D===this.j?void 0:D,this.b.get(w)?.setLevel(D),this.c.set(F.resource,F),this.g.fire([w,D]))}else{this.j=t;for(const[w,D]of this.b.entries())this.c.get(w)?.logLevel===void 0&&D.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,a){const w=this.c.get(t);w&&a!==!w.hidden&&(w.hidden=!a,this.c.set(w.resource,w),this.h.fire([t,a]))}getLogLevel(t){let a;return t&&(a=this.c.get(t)?.logLevel),a??this.j}registerLogger(t){const a=this.c.get(t.resource);a?a.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const a=this.c.get(t);if(a){this.c.delete(t);const w=this.b.get(t);w&&(this.b.delete(t),w.dispose()),this.f.fire({added:[],removed:[a]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=g;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...a){}debug(t,...a){}info(t,...a){}warn(t,...a){}error(t,...a){}critical(t,...a){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class s extends g{constructor(){super(v.Info)}k(t,a,w){return new i}}e.NullLoggerService=s;function l(n){if(n.verbose)return v.Trace;if(typeof n.logLevel=="string"){const t=h(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function r(n){switch(n){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=r;function h(n){switch(n){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=h}),define(ye[203],De([1,0,6,13]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends c.Disposable{constructor(C,P=[]){super(),this.a=new A.MultiplexLogger([C,...P]),this.B(C.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.LogService=u}),define(ye[204],De([1,0,44,13]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(u||(u={}));async function R(I,L,k,v,T){try{const E=await new Promise((d,f)=>{ne(["spdlog"],d,f)});E.setFlushOn(u.Trace);const m=await E.createAsyncRotatingLogger(I,L,k,v);return T?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(E){console.error(E)}return null}function C(I,L,k){switch(L){case A.LogLevel.Trace:I.trace(k);break;case A.LogLevel.Debug:I.debug(k);break;case A.LogLevel.Info:I.info(k);break;case A.LogLevel.Warning:I.warn(k);break;case A.LogLevel.Error:I.error(k);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(I,L){switch(L){case A.LogLevel.Trace:I.setLevel(u.Trace);break;case A.LogLevel.Debug:I.setLevel(u.Debug);break;case A.LogLevel.Info:I.setLevel(u.Info);break;case A.LogLevel.Warning:I.setLevel(u.Warning);break;case A.LogLevel.Error:I.setLevel(u.Error);break;case A.LogLevel.Off:I.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends A.AbstractMessageLogger{constructor(L,k,v,T,E){super(),this.k=[],this.setLevel(E),this.l=this.n(L,k,v,T),this.B(this.onDidChangeLogLevel(m=>{this.m&&P(this.m,m)}))}async n(L,k,v,T){const E=v?6:1,m=30/E*c.ByteSize.MB,d=await R(L,k,m,E,T);if(d){this.m=d,P(this.m,this.getLevel());for(const{level:f,message:p}of this.k)C(this.m,f,p);this.k=[]}}g(L,k){this.m?C(this.m,L,k):this.getLevel()<=L&&this.k.push({level:L,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(ye[124],De([1,0,37,173,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function I(E,m){return m-E}S.compare=I;const L=Object.create(null);L[S.Error]=(0,A.localize)(0,null),L[S.Warning]=(0,A.localize)(1,null),L[S.Info]=(0,A.localize)(2,null);function k(E){return L[E]||""}S.toString=k;function v(E){switch(E){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=v;function T(E){switch(E){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=T}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const I="";function L(v){return k(v,!0)}S.makeKey=L;function k(v,T){const E=[I];return v.source?E.push(v.source.replace("\xA6","\\\xA6")):E.push(I),v.code?typeof v.code=="string"?E.push(v.code.replace("\xA6","\\\xA6")):E.push(v.code.value.replace("\xA6","\\\xA6")):E.push(I),v.severity!==void 0&&v.severity!==null?E.push(C.toString(v.severity)):E.push(I),v.message&&T?E.push(v.message.replace("\xA6","\\\xA6")):E.push(I),v.startLineNumber!==void 0&&v.startLineNumber!==null?E.push(v.startLineNumber.toString()):E.push(I),v.startColumn!==void 0&&v.startColumn!==null?E.push(v.startColumn.toString()):E.push(I),v.endLineNumber!==void 0&&v.endLineNumber!==null?E.push(v.endLineNumber.toString()):E.push(I),v.endColumn!==void 0&&v.endColumn!==null?E.push(v.endColumn.toString()):E.push(I),E.push(I),E.join("\xA6")}S.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(ye[205],De([1,0,3,37,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,u.createDecorator)("notificationService");var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(ye[125],De([1,0,8,2,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function R(I,L){return A.URI.isUri(I)?(0,c.equalsIgnoreCase)(I.scheme,L):(0,c.startsWithIgnoreCase)(I,L+":")}e.matchesScheme=R;function C(I,...L){return L.some(k=>R(I,k))}e.matchesSomeScheme=C;function P(I,L){return I.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function S(I){let L;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return k&&(L={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},I=I.with({fragment:""})),{selection:L,uri:I}}e.extractSelection=S}),define(ye[206],De([1,0,12,36]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const R=c.globals.vscode.context.configuration();if(R)u=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:R.version})}Object.assign(u,{extensionsGallery:A.env.EXTENSIONS_GALLERY?JSON.parse(A.env.EXTENSIONS_GALLERY):u.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else u={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.75.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.75.1",commit:"441438abd1ac652551dbe4d408dfcec8a499b8bf",date:"2023-02-13T16:47:00.619Z"},Object.keys(u).length===0&&Object.assign(u,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(ye[207],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(c,A){e(c,A,ne)}};define(ye[126],De([1,0,17,21,6,4]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this.a}constructor(k){this.b=k}report(k){this.a=k,this.b(this.a)}}P.None=Object.freeze({report(){}}),e.Progress=P;let S=class extends u.Disposable{constructor(k,v){super(),this.a=new c.DeferredPromise,v.withProgress(k,T=>(this.b=T,this.c&&T.report(this.c),this.a.p)),this.B((0,u.toDisposable)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};S=qe([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class I extends u.Disposable{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new u.DisposableStore)}start(k){this.stop();const v=++this.a,T=new A.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,u.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,u.toDisposable)(()=>T.cancel())),this.b.add((0,u.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:T.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,10]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.a=new Map}add(C,P){c.ok(A.isString(C)),c.ok(A.isObject(P)),c.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new u}),define(ye[91],De([1,0,3,39]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,I){this.a[u(S)]=I,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;A.Registry.add(e.Extensions.JSONContribution,C)}),define(ye[127],De([1,0,15,3,10,168,54,91,39]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=S.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.n(i,o,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.o(i,o),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.o(o,s),this.n(i,!1,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const s=[];for(const{overrides:l,source:r}of i)for(const h in l)if(o.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const n=this.a.get(h),t=n?.valuesSources??new Map;if(r)for(const F of Object.keys(l[h]))t.set(F,r);const a={...n?.value||{},...l[h]};this.a.set(h,{source:r,value:a,valuesSources:t});const w=(0,C.getLanguageTagSettingPlainKey)(h),D={type:"object",default:a,description:R.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:u.isString(r)?void 0:r,defaultValueSource:r};s.push(...m(h)),this.d[h]=D,this.b.properties[h]=D}else{this.a.set(h,{value:l[h],source:r});const n=this.d[h];n&&(this.w(h,n),this.r(h,n))}this.m(s)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:s,source:l}of i)for(const r in s){const h=this.a.get(r),n=u.isString(l)?l:l?.id,t=u.isString(h?.source)?h?.source:h?.source?.id;if(n===t)if(o.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}}this.u()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,s){i.forEach(l=>{this.p(l,o,l.extensionInfo,l.restrictedProperties,void 0,s),this.c.push(l),this.q(l)})}o(i,o){const s=l=>{if(l.properties)for(const r in l.properties){o.add(r);const h=this.d[r];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[r],this.s(r,l.properties[r])}l.allOf?.forEach(r=>s(r))};for(const l of i){s(l);const r=this.c.indexOf(l);r!==-1&&this.c.splice(r,1)}}p(i,o=!0,s,l,r=3,h){r=u.isUndefinedOrNull(i.scope)?r:i.scope;const n=i.properties;if(n)for(const a in n){const w=n[a];if(o&&b(a,w)){delete n[a];continue}if(w.source=s,w.defaultDefaultValue=n[a].default,this.w(a,w),e.OVERRIDE_PROPERTY_REGEX.test(a)?w.scope=void 0:(w.scope=u.isUndefinedOrNull(w.scope)?r:w.scope,w.restricted=u.isUndefinedOrNull(w.restricted)?!!l?.includes(a):w.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.f[a]=n[a],delete n[a];continue}else this.d[a]=n[a],n[a].policy?.name&&this.e.set(n[a].policy.name,a);!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),h.add(a)}const t=i.allOf;if(t)for(const a of t)this.p(a,o,s,l,r,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=s=>{const l=s.properties;if(l)for(const h in l)this.r(h,l[h]);s.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const s=this.a.get(i);let l=s?.value,r=s?.source;u.isUndefined(l)&&(l=o.defaultDefaultValue,r=void 0),u.isUndefined(l)&&(l=f(o.type)),o.default=l,o.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let o=E.exec(g);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=E.exec(g)}}return(0,c.distinct)(i)}e.overrideIdentifiersFromKey=m;function d(g){return g.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function f(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new v;S.Registry.add(e.Extensions.Configuration,p);function b(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?R.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?R.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function y(){const g=[],i=p.getConfigurationProperties();for(const o of Object.keys(i))g.push([o,i[o].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=y}),define(ye[208],De([1,0,15,3,146,6,28,23,10,2,54,127,39]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function T(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class E{constructor(s={},l=[],r=[],h){this.b=s,this.c=l,this.d=r,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof E)return l;const r=new m("");return r.parseRaw(l),r.configurationModel});this.f=s.reduce((l,r)=>r===l?r:l.merge(r),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,l){const r=this.rawConfiguration.getValue(s),h=l?this.rawConfiguration.getOverrideValue(s,l):void 0,n=l?this.rawConfiguration.override(l).getValue(s):r;return{value:r,override:h,merged:n}}getOverrideValue(s,l){const r=this.i(l);return r?s?(0,L.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const r of this.overrides)r.identifiers.includes(s)&&l.push(...r.keys);return c.distinct(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return c.distinct(s)}override(s){let l=this.a.get(s);return l||(l=this.g(s),this.a.set(s,l)),l}merge(...s){const l=P.deepClone(this.contents),r=P.deepClone(this.overrides),h=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const t of s)if(n.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(l,t.contents);for(const a of t.overrides){const[w]=r.filter(D=>c.equals(D.identifiers,a.identifiers));w?(this.h(w.contents,a.contents),w.keys.push(...a.keys),w.keys=c.distinct(w.keys)):r.push(P.deepClone(a))}for(const a of t.keys)h.indexOf(a)===-1&&h.push(a)}return new E(l,h,r,n.every(t=>t instanceof E)?void 0:n)}g(s){const l=this.i(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const r={};for(const h of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let n=this.contents[h];const t=l[h];t&&(typeof n=="object"&&typeof t=="object"?(n=P.deepClone(n),this.h(n,t)):n=t),r[h]=n}return new E(r,this.keys,this.overrides)}h(s,l){for(const r of Object.keys(l)){if(r in s&&S.isObject(s[r])&&S.isObject(l[r])){this.h(s[r],l[r]);continue}s[r]=P.deepClone(l[r])}}i(s){let l=null,r=null;const h=n=>{n&&(r?this.h(r,n):r=P.deepClone(n))};for(const n of this.overrides)c.equals(n.identifiers,[s])?l=n.contents:n.identifiers.includes(s)&&h(n.contents);return h(l),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.j(s,l,!0)}setValue(s,l){this.j(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,L.removeFromValueTree)(this.contents,s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>c.equals(r.identifiers,(0,k.overrideIdentifiersFromKey)(s))),1))}j(s,l,r){(0,L.addToValueTree)(this.contents,s,l,h=>console.error(h)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],h=>console.error(h))})}}e.ConfigurationModel=E;class m{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!S.isUndefinedOrNull(s)){const r=this.g(s);this.parseRaw(r,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:r,keys:h,overrides:n,restricted:t,hasExcludedProperties:a}=this.h(s,l);this.b=new E(r,h,n,a?[s]:void 0),this.c=t||[]}g(s){let l={},r=null,h=[];const n=[],t=[];function a(D){Array.isArray(h)?h.push(D):r!==null&&(h[r]=D)}const w={onObjectBegin:()=>{const D={};a(D),n.push(h),h=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{h=n.pop()},onArrayBegin:()=>{const D=[];a(D),n.push(h),h=D,r=null},onArrayEnd:()=>{h=n.pop()},onLiteralValue:a,onError:(D,F,x)=>{t.push({error:D,offset:F,length:x})}};if(s)try{u.visit(s,w),l=h[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return l}h(s,l){const r=v.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),h=this.i(s,r,!0,l);s=h.raw;const n=(0,L.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),t=Object.keys(s),a=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:n,keys:t,overrides:a,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(s,l,r,h){let n=!1;if(!h?.scopes&&!h?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:n};const t={},a=[];for(const w in s)if(k.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const D=this.i(s[w],l,!1,h);t[w]=D.raw,n=n||D.hasExcludedProperties,a.push(...D.restricted)}else{const D=l[w],F=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&a.push(w),(F===void 0||h.scopes===void 0||h.scopes.includes(F))&&!(h.skipRestricted&&D?.restricted)?t[w]=s[w]:n=!0}return{raw:t,restricted:a,hasExcludedProperties:n}}j(s,l){const r=[];for(const h of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(h)){const n={};for(const t in s[h])n[t]=s[h][t];r.push({identifiers:(0,k.overrideIdentifiersFromKey)(h),keys:Object.keys(n),contents:(0,L.toValuesTree)(n,l)})}return r}}e.ConfigurationModelParser=m;class d extends R.Disposable{constructor(s,l,r,h){super(),this.f=s,this.g=l,this.h=h,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,n=>n.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&r.isEqual(n.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class f{constructor(s,l,r,h,n,t,a,w,D,F,x,V,M){this.a=s,this.b=l,this.c=r,this.overrideIdentifiers=h,this.d=n,this.f=t,this.g=a,this.h=w,this.i=D,this.j=F,this.k=x,this.l=V,this.m=M}get value(){return T(this.c)}n(s,l,r){const h=s.inspect(l,r);return{get value(){return T(h.value)},get override(){return T(h.override)},get merged(){return T(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(s,l,r,h,n=new E,t=new E,a=new C.ResourceMap,w=new E,D=new C.ResourceMap){this.c=s,this.d=l,this.f=r,this.g=h,this.h=n,this.i=t,this.j=a,this.l=w,this.m=D,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(s,l,r){return this.q(s,l,r).getValue(s)}updateValue(s,l,r={}){let h;r.resource?(h=this.m.get(r.resource),h||(h=new E,this.m.set(r.resource,h))):h=this.l,l===void 0?h.removeValue(s):h.setValue(s,l),r.resource||(this.a=null)}inspect(s,l,r){const h=this.q(s,l,r),n=this.u(l.resource,r),t=l.resource?this.m.get(l.resource)||this.l:this.l,a=new Set;for(const w of h.overrides)for(const D of w.identifiers)h.getOverrideValue(s,D)!==void 0&&a.add(D);return new f(s,l,h.getValue(s),a.size?[...a]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,n||void 0,t)}keys(s){const l=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,l){this.j.set(s,l),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const r=[];if(!l){const{added:h,updated:n,removed:t}=g(this.c,s);l=[...h,...n,...t]}for(const h of l)for(const n of(0,k.overrideIdentifiersFromKey)(h)){const t=this.c.getKeysForOverrideIdentifier(n),a=s.getKeysForOverrideIdentifier(n),w=[...a.filter(D=>t.indexOf(D)===-1),...t.filter(D=>a.indexOf(D)===-1),...t.filter(D=>!P.equals(this.c.override(n).getValue(D),s.override(n).getValue(D)))];r.push([n,w])}return this.updateDefaultConfiguration(s),{keys:l,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:r,removed:h}=g(this.d,s),n=[...l,...r,...h];return n.length&&this.updatePolicyConfiguration(s),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:r,removed:h,overrides:n}=g(this.applicationConfiguration,s),t=[...l,...r,...h];return t.length&&this.updateApplicationConfiguration(s),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:r,removed:h,overrides:n}=g(this.localUserConfiguration,s),t=[...l,...r,...h];return t.length&&this.updateLocalUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:r,removed:h,overrides:n}=g(this.remoteUserConfiguration,s),t=[...l,...r,...h];return t.length&&this.updateRemoteUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:r,removed:h,overrides:n}=g(this.workspaceConfiguration,s),t=[...l,...r,...h];return t.length&&this.updateWorkspaceConfiguration(s),{keys:t,overrides:n}}compareAndUpdateFolderConfiguration(s,l){const r=this.p.get(s),{added:h,updated:n,removed:t,overrides:a}=g(r,l),w=[...h,...n,...t];return(w.length||!r)&&this.updateFolderConfiguration(s,l),{keys:w,overrides:a}}compareAndDeleteFolderConfiguration(s){const l=this.p.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:h,removed:n,overrides:t}=g(l,void 0);return{keys:[...r,...h,...n],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,l,r){let h=this.r(l,r);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(h=h.merge(this.d)),h}r({resource:s},l){let r=this.s();if(l&&s){const h=l.getFolder(s);h&&(r=this.t(h.uri)||r);const n=this.m.get(s);n&&(r=r.merge(n))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let l=this.b.get(s);if(!l){const r=this.s(),h=this.j.get(s);h?(l=r.merge(h),this.b.set(s,l)):l=r}return l}u(s,l){if(l&&s){const r=l.getFolder(s);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,l)=>{const{contents:r,overrides:h,keys:n}=this.j.get(l);return s.push([l,{contents:r,overrides:h,keys:n}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.i.keys.forEach(l=>s.add(l)),this.j.forEach(l=>l.keys.forEach(r=>s.add(r))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}w(s){const l=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.i.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(h=>l.add(h))),[...l.values()]}static parse(s){const l=this.x(s.defaults),r=this.x(s.policy),h=this.x(s.application),n=this.x(s.user),t=this.x(s.workspace),a=s.folders.reduce((w,D)=>(w.set(I.URI.revive(D[0]),this.x(D[1])),w),new C.ResourceMap);return new p(l,r,h,n,new E,t,a,new E,new C.ResourceMap)}static x(s){return new E(s.contents,s.keys,s.overrides)}}e.Configuration=p;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,l=new Map;for(const h of o)h.keys.forEach(n=>s.add(n)),h.overrides.forEach(([n,t])=>{const a=(0,C.getOrSet)(l,n,new Set);t.forEach(w=>a.add(w))});const r=[];return l.forEach((h,n)=>r.push([n,[...h.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=b;class y{constructor(s,l,r,h){this.change=s,this.f=l,this.g=r,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const n of s.keys)this.affectedKeys.add(n);for(const[,n]of s.overrides)for(const t of n)this.affectedKeys.add(t);this.d=this.a;for(const n of this.affectedKeys)this.d+=n+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(s,l){const r=this.a+s,h=this.d.indexOf(r);if(h<0)return!1;const n=h+r.length;if(n>=this.d.length)return!1;const t=this.d.charCodeAt(n);if(t!==this.b&&t!==this.c)return!1;if(l){const a=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,w=this.g.getValue(s,l,this.h);return!P.equals(a,w)}return!0}}e.ConfigurationChangeEvent=y;function g(o,s){const{added:l,removed:r,updated:h}=i(s?.rawConfiguration,o?.rawConfiguration),n=[],t=o?.getAllOverrideIdentifiers()||[],a=s?.getAllOverrideIdentifiers()||[];if(s){const w=a.filter(D=>!t.includes(D));for(const D of w)n.push([D,s.getKeysForOverrideIdentifier(D)])}if(o){const w=t.filter(D=>!a.includes(D));for(const D of w)n.push([D,o.getKeysForOverrideIdentifier(D)])}if(s&&o){for(const w of t)if(a.includes(w)){const D=i({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});n.push([w,[...D.added,...D.removed,...D.updated]])}}return{added:l,removed:r,updated:h,overrides:n}}function i(o,s){const l=o?s?o.keys.filter(n=>s.keys.indexOf(n)===-1):[...o.keys]:[],r=s?o?s.keys.filter(n=>o.keys.indexOf(n)===-1):[...s.keys]:[],h=[];if(o&&s){for(const n of s.keys)if(o.keys.indexOf(n)!==-1){const t=(0,L.getConfigurationValue)(s.contents,n),a=(0,L.getConfigurationValue)(o.contents,n);P.equals(t,a)||h.push(n)}}return{added:l,removed:r,updated:h}}}),define(ye[128],De([1,0,11,4]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var u;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(u=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends c.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof R&&S._code===u.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof R&&S._code===u.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof R&&S._code===u.NoResolverFound}static isHandled(S){return S instanceof R&&S.isHandled}constructor(S,I=u.Unknown,L){super(S),this._message=S,this._code=I,this._detail=L,this.isHandled=I===u.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function C(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.getRemoteAuthorityPrefix=C}),define(ye[73],De([1,0,16]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(I){return I.scheme===c.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=A;function u(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=u;function R(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=R;function C(I){const{host:L,port:k}=S(I);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:k}}e.parseAuthorityWithPort=C;function P(I,L){let{host:k,port:v}=S(I);return typeof v>"u"&&(v=L),{host:k,port:v}}e.parseAuthorityWithOptionalPort=P;function S(I){const L=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(ye[26],De([1,0,8,4,73]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=R;function C(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var S;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,d){if(typeof m>"u"||m===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof m=="string"||typeof d=="string"){const f=typeof m=="string"?m:m.value,p=typeof d=="string"?d:d.value;return c.equalsIgnoreCase(f,p)}return m.c===d.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=I;function L(E){return k(E)}e.isApplicationScopedExtension=L;function k(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function v(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function T(E,m){if(m){const d=`onResolveRemoteAuthority:${(0,u.getRemoteName)(m)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[209],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((u,R)=>ne(["vsda"],u,R))}async createNewMessage(u){try{const R=await this.c(),C=new R.validator;if(C){const P=String(c.a++);return this.b.set(P,C),{id:P,data:C.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,R){if(!u.id)return!0;const C=this.b.get(u.id);if(!C)return!1;this.b.delete(u.id);try{return C.validate(R)==="ok"}catch{return!1}}async sign(u){try{const R=await this.c(),C=new R.signer;if(C)return C.sign(u)}catch{}return u}}c.a=1,e.SignService=c}),define(ye[210],De([1,0,12,36,2,30]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(I){if(c.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,L,k,v,T,E,m,d,f,p){const b=Object.create(null);b["common.machineId"]=m,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=T,b.version=E,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,c.PlatformToString)(c.platform),b["common.nodePlatform"]=A.platform,b["common.nodeArch"]=v,b["common.product"]=p||"desktop",d&&(b["common.msftInternal"]=d);let y=0;const g=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),c.isLinuxSnap&&(b["common.snap"]="true");const i=C(k);i&&(b["common.platformDetail"]=i);try{const o=await I.readFile(u.URI.file(f));b["common.source"]=o.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=P;function S(I){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const k=L.toLowerCase();return I.some(v=>k===v)}e.verifyMicrosoftInternalDomain=S}),define(ye[211],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var u;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(u=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[74],De([1,0,23,10,3,54,73,210,211]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(n){this.value=n}}e.TelemetryTrustedValue=I;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,t){return Promise.resolve(void 0)}publicLog2(n,t){return this.publicLog(n,t)}publicLogError(n,t){return Promise.resolve(void 0)}publicLogError2(n,t){return this.publicLogError(n,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class k{async publicLog(n,t,a){}async publicLogError(n,t,a){}}e.NullEndpointTelemetryService=k,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(h,n){return u.Event.debounce(n.onDidChangeConfiguration,(a,w)=>{const D=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:D}},1e3,!0)(a=>{a.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(a.source),configurationKeys:y(a.affectedKeys)})})}e.configurationTelemetry=v;function T(h,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!h.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=T;function E(h,n){return!(n.isBuilt||n.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.isLoggingOnly=E;function m(h){const n=h.getValue(S.TELEMETRY_SETTING_ID),t=h.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(h.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function d(h){const n={},t={},a={};b(h,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const D=a[w];typeof D=="number"?t[w]=D:typeof D=="boolean"?t[w]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${D.length}`),n[w]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[w]=D)}return{properties:n,measurements:t}}e.validateTelemetryData=d;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(h){if(!h)return"none";const n=(0,C.getRemoteName)(h);return f.has(n)?n:"other"}e.cleanRemoteAuthority=p;function b(h,n,t=0,a){if(!!h)for(const w of Object.getOwnPropertyNames(h)){const D=h[w],F=a?a+w:w;Array.isArray(D)?n[F]=(0,c.safeStringify)(D):D instanceof Date?n[F]=D.toISOString():(0,A.isObject)(D)?t<2?b(D,n,t+1,F+"."):n[F]=(0,c.safeStringify)(D):n[F]=D}}function y(h){if(!h)return[];const n=[];return g(n,"",h),n}function g(h,n,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(a=>g(h,n?`${n}.${a}`:a,t[a])):h.push(n)}function i(h,n){const t=h.msftInternalDomains||[],a=n.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(t)||a}e.isInternalTelemetry=i;function o(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=o;function s(h,n){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let t=h;const a=[];for(const x of n)for(;;){const V=x.exec(h);if(!V)break;a.push([V.index,x.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(t="";;){const x=D.exec(h);if(!x)break;const V=a.some(([M,$])=>x.index<$&&M<D.lastIndex);!w.test(x[0])&&!V&&(t+=h.substring(F,x.index)+"<REDACTED: user-file-path>",F=D.lastIndex)}return F<h.length&&(t+=h.substr(F)),t}function l(h){if(!h)return h;const n=h.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(n))return`<REDACTED: ${a.label}>`;return h}function r(h,n){return(0,c.cloneAndChange)(h,t=>{if(t instanceof I)return t.value;if(typeof t=="string"){let a=t.replaceAll("%20"," ");a=s(a,n);for(const w of n)a=a.replace(w,"");return a=l(a),a}})}e.cleanData=r}),define(ye[212],De([1,0,8,123,26,12,2,11,36,74]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,c.compareIgnoreCase)(s.id,l.id)===0}e.areSameExtensions=L;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(l){const r=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new v(l.identifier,r,h)}static parse(l){const r=k.exec(l);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(l,r,h="undefined"){this.version=r,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof v?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=v;const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(s){const l=T.exec(s);return l&&l[1]?[d(l[1]),l[2]]:[d(s),void 0]}e.getIdAndVersion=E;function m(s,l){return`${s}.${l}`}e.getExtensionId=m;function d(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function f(s,l){return d(m(s,l))}e.getGalleryExtensionId=f;function p(s,l){const r=[],h=n=>{for(const t of r)if(t.some(a=>L(l(a),l(n))))return t;return null};for(const n of s){const t=h(n);t?t.push(n):r.push([n])}return r}e.groupByExtension=p;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function y(s){return{id:new I.TelemetryTrustedValue(s.identifier.id),name:new I.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function g(s,l){const r=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const n=h.shift();if(n&&r.every(t=>!L(t.identifier,{id:n}))){const t=s.filter(a=>L(a.identifier,{id:n}));t.length===1&&(r.push(t[0]),h.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=g;async function i(s,l){if(!R.isLinux)return!1;let r;try{r=(await s.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){l.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(n))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function o(s,l){const r=await i(s,l),h=(0,A.getTargetPlatform)(r?"alpine":R.platform,S.arch);return l.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=o}),define(ye[213],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=c;function A(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=A;function u(C){return Array.from(C.entries()).map(P=>[P[0],c(P[1].map)])}e.serializeEnvironmentVariableCollections=u;function R(C){return new Map(C.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[214],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(u){this.b=u,this.a=new Map}dispose(){for(const u of this.a.values())u.dispose()}startBuffering(u,R,C=5){const P=R(S=>{const I=typeof S=="string"?S:S.data;let L=this.a.get(u);if(L){L.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(u),C);L={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(u),P.dispose()}},this.a.set(u,L)});return P}stopBuffering(u){this.a.get(u)?.dispose()}flushBuffer(u){const R=this.a.get(u);R&&(this.a.delete(u),this.b(u,R.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[215],De([1,0,17,69,51,3,10,2,174,91,39]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(y){function g(i,o){let s=i.defaults;for(;u.ThemeIcon.isThemeIcon(s);){const l=E.getIcon(s.id);if(!l)return;s=l.defaults}return s}y.getDefinition=g})(k=e.IconContribution||(e.IconContribution={}));var v;(function(y){function g(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}y.toJSONObject=g;function i(o){const s=l=>(0,C.isString)(l)?l:void 0;if(o&&Array.isArray(o.src)&&o.src.every(l=>(0,C.isString)(l.format)&&(0,C.isString)(l.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(l=>({format:l.format,location:P.URI.parse(l.location)}))}}y.fromJSONObject=i})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class T{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,i,o,s){const l=this.b[g];if(l){if(o&&!l.description){l.description=o,this.d.properties[g].markdownDescription=`${o} $(${g})`;const n=this.e.enum.indexOf(g);n!==-1&&(this.e.enumDescriptions[n]=o),this.a.fire()}return l}const r={id:g,description:o,defaults:i,deprecationMessage:s};this.b[g]=r;const h={$ref:"#/definitions/icons"};return s&&(h.deprecationMessage=s),o&&(h.markdownDescription=`${o}: $(${g})`),this.d.properties[g]=h,this.e.enum.push(g),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,i){const o=this.f[g];return o||(this.f[g]=i,this.a.fire(),i)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(l,r)=>l.id.localeCompare(r.id),i=l=>{for(;u.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(l=>this.b[l]);for(const l of s.filter(r=>!!r.description).sort(g))o.push(`|<i class="${i(l)}"></i>|${l.id}|${u.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const l of s.filter(r=>!u.ThemeIcon.isThemeIcon(r.defaults)).sort(g))o.push(`|<i class="${i(l)}"></i>|${l.id}|`);return o.join(`
`)}}const E=new T;L.Registry.add(e.Extensions.IconContribution,E);function m(y,g,i,o){return E.registerIcon(y,g,i,o)}e.registerIcon=m;function d(){return E}e.getIconRegistry=d;function f(){const y=(0,A.getCodiconFontCharacters)();for(const g in y){const i="\\"+y[g].toString(16);E.registerIcon(g,{fontCharacter:i})}}f(),e.iconsSchemaId="vscode://schemas/icons";const p=L.Registry.as(I.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,E.getIconSchema());const b=new c.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);E.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=m("widget-close",A.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=m("goto-previous-location",A.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=m("goto-next-location",A.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=u.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,54,4,13]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var C;(function(m){m.Http="http",m.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=k;function v(m,d,f,p){if(f===1)return!1;if(f===2&&k(d)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return m<1024}e.isPortPrivileged=v;class T{constructor(d,f,p){this.remoteAddress=d,this.localAddress=f,this.b=p,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=T;let E=class{constructor(d,f){this.i=d,this.j=f,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],f=Array.from(this.d.values());for(const p of f){const b=Array.from(p.values());for(const y of b){const g=await y.value;g&&d.push(g)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:f}of d.values())await f.then(p=>p?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,f,p,b,y){this.o(d,f,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:f,localAddress:p,privacy:b,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,f){(k(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const p=this.q(d,f);if(p)return++p.refcount,p.value}openTunnel(d,f,p,b,y,g=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${y}.`),!d)return;if(f||(f="localhost"),b||(b=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(d,f,p,b,y,g,i,o);return s?s.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(l);return(l.tunnelRemoteHost!==f||l.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const f=this.d.get(d.tunnelRemoteHost);if(f){const p=f.get(d.tunnelRemotePort);p&&(p.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,p))}}}}async n(d,f,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${f}.`);const b=p.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(f),b}}async closeTunnel(d,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${f} `);const p=this.d.get(d);if(p&&p.has(f)){const b=p.get(f);b.refcount=0,await this.n(d,f,b)}}o(d,f,p){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(f,{refcount:1,value:p})}async p(d,f){const p=this.d.get(d);p&&(await p.get(f)||p.delete(f),p.size===0&&this.d.delete(d))}q(d,f){const p=[d];L(d)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):k(d)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(y=>this.d.get(y));for(const y of b){const g=y?.get(f);if(g)return g}}canTunnel(d){return!!I(d)}s(d,f,p,b,y,g,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${b}.`);const o=p;this.h.add(o);const s=b===void 0?p:b,l={elevationRequired:y?this.isPortPrivileged(s):!1},r={remoteAddress:{host:f,port:p},localAddressPort:b,privacy:g,public:g?g!==P.Private:void 0,protocol:i},h=d.forwardPort(r,l);return h?(this.o(f,p,h),h.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),h}};E=qe([We(0,R.ILogService),We(1,A.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ye[216],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var A;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[217],De([1,0,16]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function u(S){if(S.folders.length)return S.folders.every(I=>A(I.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=u;function R(S){return u(S)?.scheme}e.getVirtualWorkspaceScheme=R;function C(S){return u(S)?.authority}e.getVirtualWorkspaceAuthority=C;function P(S){return u(S)!==void 0}e.isVirtualWorkspace=P}),define(ye[47],De([1,0,175,9,68,24,2,4,16]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function I(s){const l=s;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=I;function L(s){return typeof s?.id=="string"&&!I(s)&&!v(s)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(s,l){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.basename)(s)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=k;function v(s){const l=s;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=v;function T(s){const l=s;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=T;var E;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function m(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=m;function d(s){const l=s;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(l,r,h,n,t){this.h=l,this.j=h,this.k=n,this.l=t,this.c=u.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=u.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(l,r){this.raw=r,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(s){return new p({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(s,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,l.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function g(s){let l;return C.URI.isUri(s)?l=s:l=s.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=g;function i(s,l){return!y(s,l)&&!g(s)}e.isSavedWorkspace=i;function o(s){return(typeof s=="string"?(0,A.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(ye[75],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(u){this.d=u,this.b=new Map,this.c=1}add(u){const R=this.c++;return this.b.set(R,u),this.e(),R}get(u,R){return this.b.has(u)?this.b.get(u)[R]:void 0}delete(u){this.b.delete(u),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}c.a=!1,e.Cache=c}),define(ye[48],De([1,0,16,24,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(P=>{const S=this.b.get(P.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(P,S){S===null?this.b.delete(P.scheme):this.b.set(P.scheme,S)}isFreeScheme(P){return!this.b.has(P)&&!this.a.has(P)}getCapabilities(P){return this.b.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[218],De([1,0,13,203,25]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends A.LogService{constructor(P,S){super(P.createLogger(S.logFile,{name:S.logName}))}};R=qe([We(0,c.ILoggerService),We(1,u.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(ye[219],De([1,0,17]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(C,P,S){this.h=new Map,this.a=C,this.b=P,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(I=>(this.f=I,this)),this.g=this.c.onDidChangeStorage(I=>{I.shared===this.b&&I.key===this.a&&(this.f=I.value)}),this.i=new c.RunOnceScheduler(()=>{const I=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of I.values())L.complete()}catch(L){for(const k of I.values())k.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,P){let S=this.f[C];return typeof S>"u"&&(S=P),S}update(C,P){this.f[C]=P;const S=this.h.get(C);if(S!==void 0)return S.p;const I=new c.DeferredPromise;return this.h.set(C,I),this.i.isScheduled()||this.i.schedule(),I.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class u extends A{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,P){super(C.identifier.value,!0,P),this.j=C}}e.ExtensionGlobalMemento=u}),define(ye[220],De([1,0,3,2]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(C){this.c=C,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,P,S,I){const k=this.c.getNotebookDocument(A.URI.revive(C)).acceptModelChanged(P.value,S,I);this.b.fire(k)}$acceptDirtyStateChanged(C,P){this.c.getNotebookDocument(A.URI.revive(C)).acceptDirty(P)}$acceptModelSaved(C){const P=this.c.getNotebookDocument(A.URI.revive(C));this.a.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(ye[18],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[221],De([1,0,26,3]),function(ne,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(P,S){u.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(P.identifier),Je(this,u,S,"f"),Be(this,u,"f").onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(P){return Be(this,u,"f").get(this.a,P)}store(P,S){return Be(this,u,"f").store(this.a,P,S)}delete(P){return Be(this,u,"f").delete(this.a,P)}}e.ExtensionSecrets=R,u=new WeakMap}),define(ye[56],De([1,0,4,129,3,18]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=I;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==A.TunnelPrivacyId.ConstantPrivate&&k.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let P=class{constructor(I){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,k,v,T){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=qe([We(0,R.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(ye[57],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=A}),define(ye[222],De([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(S){let I=this.buffers.indexOf(S);return I<0&&(I=this.buffers.length,this.buffers.push(S)),I}}function u(P,S){if(S.serializeBuffersForPostMessage){const I=new A,L=(T,E)=>{if(E instanceof ArrayBuffer){const m=I.add(E);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(E)){const m=R(E);if(m){const d=I.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:m,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},k=JSON.stringify(P,L),v=I.buffers.map(T=>{const E=new Uint8Array(T);return c.VSBuffer.wrap(E)});return{message:k,buffers:v}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=u;function R(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(P,S){const I=S.map(v=>{const T=new ArrayBuffer(v.byteLength);return new Uint8Array(T).set(v.buffer),T}),L=S.length?(v,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const E=T,{index:m}=E,d=I[m];if(E.view)switch(E.view.type){case 1:return new Int8Array(d,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return T}:void 0;return{message:JSON.parse(P,L),arrayBuffers:I}}e.deserializeWebviewMessage=C}),define(ye[223],De([1,0,111]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:R,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function u(R){return new c.URITransformer(A(R))}e.createURITransformer=u}),define(ye[130],De([1,0,186,10,2,6,4,39,44,16,45,163,37]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(T=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(X){const J=X;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.isEditorPaneWithSelection=m;function d(X,J,ie){for(const pe of ie.visibleEditorPanes)if(pe.group.id===J&&X.matches(pe.input))return pe.getViewState()}e.findViewStateForEditor=d;function f(X){if(t(X))return!1;const J=X;return u.URI.isUri(J?.resource)}e.isResourceEditorInput=f;function p(X){if(t(X))return!1;const J=X;return J?.original!==void 0&&J.modified!==void 0}e.isResourceDiffEditorInput=p;function b(X){if(t(X)||p(X))return!1;const J=X;return J?.primary!==void 0&&J.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function y(X){if(t(X))return!1;const J=X;return J?J.resource===void 0||J.resource.scheme===I.Schemas.untitled||J.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;const g=/Untitled-\d+/;function i(X){return X.scheme===I.Schemas.untitled&&X.path.length>1&&!g.test(X.path)}e.isUntitledWithAssociatedResource=i;function o(X){if(t(X))return!1;const J=X;return u.URI.isUri(J?.base?.resource)&&u.URI.isUri(J?.input1?.resource)&&u.URI.isUri(J?.input2?.resource)&&u.URI.isUri(J?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var l;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(J,ie){let pe=this.a.get(J);return pe||(pe={source:J,label:ie},this.a.set(J,pe)),pe.source}getSourceLabel(J){return this.a.get(J)?.label??J}}e.SaveSourceRegistry=new r;var h;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function t(X){return X instanceof n}e.isEditorInput=t;function a(X){const J=X;return u.URI.isUri(J?.preferredResource)}function w(X){const J=X;return t(J?.primary)&&t(J?.secondary)}e.isSideBySideEditorInput=w;function D(X){const J=X;return t(J?.modified)&&t(J?.original)}e.isDiffEditorInput=D;function F(X,J,ie,pe,ve){return te(pe,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const ke={...ie,limits:{size:Number.MAX_VALUE}};X.openEditor(J,ke)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=F;function x(X){return t(X?.editor)}e.isEditorInputWithOptions=x;function V(X){const J=X;return x(X)&&J?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function M(X){const J=X;return typeof J?.groupId=="number"&&t(J.editor)}e.isEditorIdentifier=M;var $;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class B{getOriginalUri(J,ie){if(!J)return;if(o(J))return e.EditorResourceAccessor.getOriginalUri(J.result,ie);if(ie?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(J);if(ve&&ke){if(ie?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===U.ANY)return this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:ie.filterByScheme});J=ie.supportSideBySide===U.PRIMARY?ve:ke}}if(p(J)||b(J)||o(J))return;const pe=a(J)?J.preferredResource:J.resource;return!pe||!ie||!ie.filterByScheme?pe:this.b(pe,ie.filterByScheme)}a(J){return w(J)||b(J)?{primary:J.primary,secondary:J.secondary}:D(J)||p(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,ie){if(!J)return;if(o(J))return e.EditorResourceAccessor.getCanonicalUri(J.result,ie);if(ie?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(J);if(ve&&ke){if(ie?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===U.ANY)return this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:ie.filterByScheme});J=ie.supportSideBySide===U.PRIMARY?ve:ke}}if(p(J)||b(J)||o(J))return;const pe=J.resource;return!pe||!ie||!ie.filterByScheme?pe:this.b(pe,ie.filterByScheme)}b(J,ie){if(Array.isArray(ie)){if(ie.some(pe=>J.scheme===pe))return J}else if(ie===J.scheme)return J}}e.EditorResourceAccessor=new B;var j;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class de{constructor(){this.c=new Map,this.d=new Map}start(J){const ie=this.a=J.get(C.IInstantiationService);for(const[pe,ve]of this.c)this.e(pe,ve,ie);this.c.clear()}e(J,ie,pe){const ve=pe.createInstance(ie);this.d.set(J,ve)}registerFileEditorFactory(J){if(this.b)throw new Error("Can only register one file editor factory.");this.b=J}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(J,ie){if(this.c.has(J)||this.d.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.a?this.e(J,ie,this.a):this.c.set(J,ie),(0,R.toDisposable)(()=>{this.c.delete(J),this.d.delete(J)})}getEditorSerializer(J){return this.d.get(typeof J=="string"?J:J.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new de);async function Y(X,J,ie){return!X||!X.length?[]:await Promise.all(X.map(async pe=>{const ve=u.URI.revive(pe.fileUri);if(!ve){ie.info("Cannot resolve the path because it is not valid.",pe);return}if(!await J.canHandleResource(ve)){ie.info("Cannot resolve the path because it cannot be handled",pe);return}let Oe=pe.exists,oe=pe.type;if(typeof Oe!="boolean"||typeof oe!="number")try{oe=(await J.stat(ve)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Oe=!0}catch(fe){ie.error(fe),Oe=!1}if(!Oe&&pe.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",pe);return}if(oe===S.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",pe);return}const ae={...pe.options,pinned:!0};return Oe?{resource:ve,options:ae}:{resource:ve,options:ae,forceUntitled:!0}}))}e.pathsToEditors=Y;var q;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function Q(X){const J=X;if(!J)return!1;const ie=J;if(ie.modified)return Q(ie.modified);const pe=J;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}e.isTextEditorViewState=Q;function Z(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=Z;function te(X,J,ie){const pe=(0,L.createErrorWithActions)(X,J);return pe.forceMessage=ie?.forceMessage,pe.forceSeverity=ie?.forceSeverity,pe.allowDialog=ie?.allowDialog,pe}e.createEditorOpenError=te}),define(ye[224],De([1,0,3,187,4,6,28,39,15,62,23,69,215]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",k.Codicon.window,(0,A.localize)(0,null));var T;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(T=e.Extensions||(e.Extensions={}));var E;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(E=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function m(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=m;class d extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(l,r,h){const n=this.get(l.id);if(n)return n;const t=l;return t.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,C.getOrSet)(this.g,r,[]).push(t),h?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:r}),t}deregisterViewContainer(l){for(const r of this.g.keys()){const h=this.g.get(r),n=h?.indexOf(l);if(n!==-1){h?.splice(n,1),h.length===0&&this.g.delete(r),this.f.fire({viewContainer:l,viewContainerLocation:r});return}}}get(l){return this.all.filter(r=>r.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(h=>h?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(r=>this.getViewContainerLocation(r)===l)}}P.Registry.add(T.ViewContainersRegistry,new d);var f;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function p(s,l){const r=s.group??f.More,h=l.group??f.More;return r!==h?r.localeCompare(h):(s.order??5)-(l.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new I.SetMap}registerViews(l,r){this.registerViews2([{views:l,viewContainer:r}])}registerViews2(l){l.forEach(({views:r,viewContainer:h})=>this.l(r,h)),this.c.fire(l)}deregisterViews(l,r){const h=this.m(l,r);h.length&&this.f.fire({views:h,viewContainer:r})}moveViews(l,r){for(const h of this.j.keys())if(h!==r){const n=this.m(l,h);n.length&&(this.l(n,r),this.g.fire({views:n,from:h,to:r}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const r of this.i){const h=(this.j.get(r)||[]).filter(n=>n.id===l)[0];if(h)return h}return null}getViewContainer(l){for(const r of this.i)if((this.j.get(r)||[]).filter(n=>n.id===l)[0])return r;return null}registerViewWelcomeContent(l,r){return this.k.add(l,r),this.h.fire(l),(0,R.toDisposable)(()=>{this.k.delete(l,r),this.h.fire(l)})}registerViewWelcomeContent2(l,r){const h=new Map;for(const[n,t]of r)this.k.add(l,t),h.set(n,(0,R.toDisposable)(()=>{this.k.delete(l,t),this.h.fire(l)}));return this.h.fire(l),h}getViewWelcomeContent(l){const r=[];return this.k.forEach(l,h=>r.push(h)),r.sort(p)}l(l,r){let h=this.j.get(r);h||(h=[],this.j.set(r,h),this.i.push(r));for(const n of l){if(this.getView(n.id)!==null)throw new Error((0,A.localize)(1,null,n.id));h.push(n)}}m(l,r){const h=this.j.get(r);if(!h)return[];const n=[],t=[];for(const a of h)l.includes(a)?n.push(a):t.push(a);return n.length&&(t.length?this.j.set(r,t):(this.j.delete(r),this.i.splice(this.i.indexOf(r),1))),n}}P.Registry.add(T.ViewsRegistry,new b),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var y;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(y=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,r){this.c=!1,this.d=!1,(0,L.mixin)(this,l),this.d=!!r,this.resolve=async h=>{if(r&&!this.c){const n=await r(h);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class o extends Error{constructor(l){super((0,A.localize)(2,null,l))}}e.NoTreeViewError=o}),define(ye[131],De([1,0,3,17,188]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(P){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=P}onEvent(P){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=P}onRequest(P){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=P}sendResponse(P){P.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.s("response",P)}sendRequest(P,S,I,L){const k={command:P};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.s("request",k),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const T=this.f.get(k.seq);if(T){this.f.delete(k.seq);const E={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,u.localize)(0,null,L,P)};T(E)}},L)}return I&&this.f.set(k.seq,I),k.seq}acceptMessage(P){this.j?this.j(P):(this.k.push(P),this.k.length===1&&this.q())}o(P,S){return P.type!=="event"||S.type!=="event"}async q(){let P;for(;this.k.length;){if((!P||this.o(this.k[0],P))&&await(0,A.timeout)(0),P=this.k.shift(),!P)return;switch(P.type){case"event":this.i?.(P);break;case"request":this.g?.(P);break;case"response":{const S=P,I=this.f.get(S.request_seq);I&&(this.f.delete(S.request_seq),I(S));break}}}}s(P,S){S.type=P,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const P=new Map;this.f.forEach((S,I)=>P.set(I,S)),await(0,A.timeout)(500),P.forEach((S,I)=>{S({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.f.delete(I)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[225],De([1,0,189,55,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const R=v=>c.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var C;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(C=e.State||(e.State={}));function P(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var S;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,u.createDecorator)("debugService");var k;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[226],De([1,0,8,2,9,23,16,33,21,15]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function k(n,t,a){return n.replace(L,function(w,D){return t&&D.length>0&&D[0]!=="_"?w:a&&a.hasOwnProperty(D)?a[D]:w})}e.formatPII=k;function v(n){const t={};for(const a of Object.keys(n))a.startsWith("!")||(t[a]=n[a]);return t}e.filterExceptionsFromTelemetry=v;function T(n){return n.configuration.request==="attach"&&!E(n)&&(!n.parentSession||T(n.parentSession))}e.isSessionAttach=T;function E(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(t,"extensionhost")||(0,c.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?E(n.parentSession):void 0}e.getExtensionHostDebugSession=E;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function d(n,t,a){let w,D=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let x=null;for(;x=F.exec(n);){const V=x.index+1,M=V+x[0].length;if(V<=t&&M>=a){w=x[0],D=V;break}}if(w){const V=/\w+/g;let M=null;for(;(M=V.exec(w))&&!(M.index+1+D+M[0].length>=a););M&&(w=w.substring(0,V.lastIndex))}return w?{start:D,end:D+w.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function f(n,t,a,w){if(n.evaluatableExpressionProvider.has(t)){const D=n.evaluatableExpressionProvider.ordered(t),F=(0,I.coalesce)(await Promise.all(D.map(async x=>{try{return await x.provideEvaluatableExpression(t,a,w??S.CancellationToken.None)}catch{return}})));if(F.length>0){let x=F[0].expression;const V=F[0].range;return x||(x=t.getLineContent(a.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:x}}}else{const D=t.getLineContent(a.lineNumber),{start:F,end:x}=d(D,a.column,a.column),V=D.substring(F-1,x);return{matchingExpression:V,range:new P.Range(a.lineNumber,F,a.lineNumber,F+V.length)}}return null}e.getEvaluatableExpressionAtPosition=f;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(n){return!!(n&&n.match(p))}e.isUri=b;function y(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(b(n.path))return A.URI.parse(n.path);if((0,u.isAbsolute)(n.path))return A.URI.file(n.path)}return n.path}function g(n){if(typeof n.path=="object"){const t=A.URI.revive(n.path);if(t)return t.scheme===C.Schemas.file?t.fsPath:t.toString()}return n.path}function i(n,t){const a=t?y:g,w=(0,R.deepClone)(n);return s(w,(D,F)=>{D&&F&&(F.path=a(F))}),w}e.convertToDAPaths=i;function o(n,t){const a=t?y:g,w=(0,R.deepClone)(n);return s(w,(D,F)=>{!D&&F&&(F.path=a(F))}),w}e.convertToVSCPaths=o;function s(n,t){switch(n.type){case"event":{const a=n;switch(a.event){case"output":t(!1,a.body.source);break;case"loadedSource":t(!1,a.body.source);break;case"breakpoint":t(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=n;switch(a.command){case"setBreakpoints":t(!0,a.arguments.source);break;case"breakpointLocations":t(!0,a.arguments.source);break;case"source":t(!0,a.arguments.source);break;case"gotoTargets":t(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(w=>t(!1,w));break;default:break}break}case"response":{const a=n;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(w=>t(!1,w.source));break;case"loadedSources":a.body.sources.forEach(w=>t(!1,w));break;case"scopes":a.body.scopes.forEach(w=>t(!1,w.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(w=>t(!1,w.source));break;case"setBreakpoints":a.body.breakpoints.forEach(w=>t(!1,w.source));break;case"disassemble":a.body?.instructions.forEach(D=>t(!1,D.location));break;default:break}break}}}function l(n){return n.filter(t=>!t.presentation?.hidden).sort((t,a)=>t.presentation?a.presentation?t.presentation.group?a.presentation.group?t.presentation.group!==a.presentation.group?t.presentation.group.localeCompare(a.presentation.group):r(t.presentation.order,a.presentation.order):-1:a.presentation.group?1:r(t.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=l;function r(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function h(n,t){const a=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(a!=="none"&&(await t.saveAll(),a==="allEditorsInActiveGroup")){const w=t.activeEditorPane;w&&w.input.resource?.scheme===C.Schemas.untitled&&await t.save({editor:w.input,groupId:w.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(ye[227],De([1,0,46,228,23,9,12,8,29,190,131]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(f,p){this.p=p,this.r=Buffer.allocUnsafe(0),this.t=-1,f.on("data",b=>this.w(b))}sendMessage(f){if(this.p){const p=JSON.stringify(f);this.p.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${k.a}${p}`,"utf8")}}w(f){for(this.r=Buffer.concat([this.r,f]);;){if(this.t>=0){if(this.r.length>=this.t){const p=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(b){this.m.fire(new Error((b.message||b)+`
`+p))}continue}}else{const p=this.r.indexOf(k.a);if(p!==-1){const y=this.r.toString("utf8",0,p).split(k.b);for(const g of y){const i=g.split(k.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(p+k.a.length);continue}}break}}}k.a=`\r
\r
`,k.b=/\r?\n/,k.l=/: */,e.StreamDebugAdapter=k;class v extends k{startSession(){return new Promise((f,p)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),f(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.x.on("error",y=>{b?this.m.fire(y):p(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class T extends v{constructor(f){super(),this.z=f}y(f){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.SocketDebugAdapter=T;class E extends v{constructor(f){super(),this.z=f}y(f){return A.createConnection(this.z.path,f)}}e.NamedPipeDebugAdapter=E;class m extends k{constructor(f,p){super(),this.y=f,this.z=p}async startSession(){const f=this.y.command,p=this.y.args,b=this.y.options||{};try{if(f)if(R.isAbsolute(f)){if(!await S.Promises.exists(f))throw new Error(I.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.z));let y=process.env;if(b.env&&Object.keys(b.env).length>0&&(y=u.mixin(u.deepClone(process.env),b.env)),f==="node")if(Array.isArray(p)&&p.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:y,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(i.cwd=b.cwd);const o=c.fork(p[0],p.slice(1),i);if(!o.pid)throw new Error(I.localize(2,null,p[0]));this.x=o}else throw new Error(I.localize(3,null));else{const g={env:y};b.cwd&&(g.cwd=b.cwd),this.x=c.spawn(f,p,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,i)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),C.isWindows?new Promise((f,p)=>{const b=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,g,i){if(y)return p(y)});b.on("exit",f),b.on("error",p)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,p){if(!f)return;const b=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?b.runtime=R.join(p,f.runtime):b.runtime=f.runtime),f.runtimeArgs&&(b.runtimeArgs=f.runtimeArgs),f.program&&(R.isAbsolute(f.program)?b.program=f.program:b.program=R.join(p,f.program)),f.args&&(b.args=f.args);const y=f;return y.win&&(b.win=m.A(y.win,p)),y.winx86&&(b.winx86=m.A(y.winx86,p)),y.windows&&(b.windows=m.A(y.windows,p)),y.osx&&(b.osx=m.A(y.osx,p)),y.linux&&(b.linux=m.A(y.linux,p)),b}static platformAdapterExecutable(f,p){let b=Object.create(null);p=p.toLowerCase();for(const l of f)if(l.contributes){const r=l.contributes.debuggers;r&&r.length>0&&r.filter(h=>typeof h.type=="string"&&P.equalsIgnoreCase(h.type,p)).forEach(h=>{const n=m.A(h,l.extensionLocation.fsPath);b=u.mixin(b,n,l.isBuiltin)})}let y;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=b.winx86||b.win||b.windows:C.isWindows?y=b.win||b.windows:C.isMacintosh?y=b.osx:C.isLinux&&(y=b.linux),y=y||b;const g=y.program||b.program,i=y.args||b.args,o=y.runtime||b.runtime,s=y.runtimeArgs||b.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof g=="string"?[g]:[]).concat(i||[])};if(g)return{type:"executable",command:g,args:i||[]}}}e.ExecutableDebugAdapter=m}),define(ye[229],De([1,0,46,32,12]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(I,L){return new Promise((k,v)=>{let T="";const E=c.spawn(I,L);E.pid&&E.stdout.on("data",m=>{T+=m.toString()}),E.on("error",m=>{v(m)}),E.on("close",m=>{k(T)})})}async function C(I){if(I)if(u.isWindows){const L=await new Promise((k,v)=>{ne(["windows-process-tree"],k,v)});return new Promise(k=>{L.getProcessTree(I,v=>{k(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(I)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var P;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(P||(P={}));function S(I,L,k,v,T){I=I.trim().toLowerCase();let E;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?E=1:I.indexOf("cmd.exe")>=0?E=0:I.indexOf("bash")>=0?E=2:u.isWindows?E=0:E=2;let m,d=" ";switch(E){case 1:if(m=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),v){const f=(0,A.getDriveLetter)(v);f&&(d+=`${f}:; `),d+=`cd ${m(v)}; `}if(T)for(const f in T){const p=T[f];p===null?d+=`Remove-Item env:${f}; `:d+=`\${env:${f}}='${p}'; `}if(L.length>0){const f=L.shift(),p=k?f:m(f);d+=p[0]==="'"?`& ${p} `:`${p} `;for(const b of L)d+=b==="<"||b===">"||k?b:m(b),d+=" "}break;case 0:if(m=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>f.includes(p))||f.length===0?`"${f}"`:f),v){const f=(0,A.getDriveLetter)(v);f&&(d+=`${f}: && `),d+=`cd ${m(v)} && `}if(T){d+='cmd /C "';for(const f in T){let p=T[f];p===null?d+=`set "${f}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),d+=`set "${f}=${p}" && `)}}for(const f of L)d+=f==="<"||f===">"||k?f:m(f),d+=" ";T&&(d+='"');break;case 2:{m=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const f=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(v&&(d+=`cd ${m(v)} ; `),T){d+="/usr/bin/env";for(const p in T){const b=T[p];b===null?d+=` -u ${f(p)}`:d+=` ${f(`${p}=${b}`)}`}d+=" "}for(const p of L)d+=p==="<"||p===">"||k?p:m(p),d+=" ";break}}return d}e.prepareCommand=S}),define(ye[92],De([1,0,22,38,65,87,16,9,12,55]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var p;(function(U){U.scheme=C.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${B.join("")}]+`),de=7;function Y(J,ie){const pe=ie.toString(de),ke=`${pe.length<B.length?B[pe.length-1]:"z"}${pe}s${(0,c.encodeBase64)(c.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:U.scheme,fragment:ke})}U.generate=Y;function q(J){if(J.scheme!==U.scheme)return;const ie=J.fragment.indexOf("s");if(ie<0)return;const pe=parseInt(J.fragment.substring(0,ie).replace(j,""),de),ve=(0,c.decodeBase64)(J.fragment.substring(ie+1)).toString();if(!isNaN(pe))return{handle:pe,notebook:J.with({scheme:ve,fragment:null})}}U.parse=q;function Q(J,ie){return J.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${J.scheme!==C.Schemas.file?J.scheme:""}`})}U.generateCellOutputUri=Q;function Z(J){if(J.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!ie)return;const pe=ie[1]&&ie[1]!==""?ie[1]:void 0,ve=ie[2];return{outputId:pe,notebook:J.with({scheme:ve||C.Schemas.file,fragment:null})}}U.parseCellOutputUri=Z;function te(J,ie,pe){return U.generate(J,ie).with({scheme:pe})}U.generateCellPropertyUri=te;function X(J,ie){if(J.scheme===ie)return U.parse(J.with({scheme:U.scheme}))}U.parseCellPropertyUri=X})(p=e.CellUri||(e.CellUri={}));const b=U=>S.isWindows?U.replace(/\//g,"\\"):U;class y{constructor(B=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(B)].map(de=>({pattern:de,matches:A.parse(b(de))}))}sort(B){const j=new Map(u.Iterable.map(B,Y=>[Y,b(Y)]));let de=[];for(const{matches:Y}of this.d)for(const[q,Q]of j)if(Y(Q)){de.push(q),j.delete(q);break}return j.size&&(de=de.concat([...j.keys()].sort((Y,q)=>this.e.indexOf(Y)-this.e.indexOf(q)))),de}prioritize(B,j){const de=this.f(B);if(de===-1){this.d.unshift({pattern:B,matches:A.parse(b(B))});return}const Y=new Set(j.map(Q=>this.f(Q,de)));Y.delete(-1);const q=Array.from(Y).sort();this.d.splice(de+1,0,...q.map(Q=>this.d[Q]));for(let Q=q.length-1;Q>=0;Q--)this.d.splice(q[Q],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,j=this.d.length){const de=b(B);for(let Y=0;Y<j;Y++)if(this.d[Y].matches(de))return Y;return-1}}e.MimeTypeDisplayOrder=y;function g(U,B,j,de=(Y,q)=>Y===q){const Y=[];function q(te,X,J){if(X===0&&J.length===0)return;const ie=Y[Y.length-1];ie&&ie.start+ie.deleteCount===te?(ie.deleteCount+=X,ie.toInsert.push(...J)):Y.push({start:te,deleteCount:X,toInsert:J})}let Q=0,Z=0;for(;;){if(Q===U.length){q(Q,0,B.slice(Z));break}if(Z===B.length){q(Q,U.length-Q,[]);break}const te=U[Q],X=B[Z];if(de(te,X)){Q+=1,Z+=1;continue}j(X)?(q(Q,1,[]),Q+=1):(q(Q,0,[X]),Z+=1)}return Y}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(U){const B=U;return!!((typeof B.include=="string"||A.isRelativePattern(B.include))&&(typeof B.exclude=="string"||A.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=o;function s(U,B,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(B)>=0||U.viewType===B)return!0;if(U.filenamePattern){const de=o(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,Y=o(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(A.match(de,(0,P.basename)(j.fsPath).toLowerCase()))return!(Y&&A.match(Y,(0,P.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var l;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(B){return`${r.d}${B}`}static parse(B){if(B.startsWith(r.d))return B.substring(r.d.length)}}r.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=r;function h(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=h;const n=new TextDecoder;function t(U){const B=[];let j=!1;for(const de of U)(B.length===0||j)&&(B.push(de),j=!0);return F(B),O(c.VSBuffer.concat(B.map(de=>c.VSBuffer.wrap(de))))}e.compressOutputItemStreams=t;const a=`${String.fromCharCode(27)}[A`,w=a.split("").map(U=>U.charCodeAt(0)),D=10;function F(U){U.forEach((B,j)=>{if(j===0||B.length<a.length)return;const de=U[j-1],Y=B.subarray(0,a.length);if(Y[0]===w[0]&&Y[1]===w[1]&&Y[2]===w[2]){const q=de.lastIndexOf(D);if(q===-1)return;U[j-1]=de.subarray(0,q),U[j]=B.subarray(a.length)}})}function x(U){let B=U;do U=B,B=U.replace(/[^\n]\x08/gm,"");while(B.length<U.length);return U}function V(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const B=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+B.slice(j.length,B.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const M="\b".charCodeAt(0),$="\r".charCodeAt(0);function O(U){return!U.buffer.includes(M)&&!U.buffer.includes($)?U:c.VSBuffer.fromString(V(x(n.decode(U.buffer))))}}),define(ye[230],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class u{static fromExtHostTestItem(C,P,S=C.parent){if(C._isRoot)return new u([P]);const I=[C.id];for(let L=S;L&&L.id!==P;L=L.parent)I.push(L.id);return I.push(P),new u(I.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const P=C.indexOf("\0");return P===-1?C:C.slice(0,P)}static fromString(C){return new u(C.split("\0"))}static join(C,P){return new u([...C.path,P])}static joinToString(C,P){return C.toString()+"\0"+P}static parentId(C){const P=C.lastIndexOf("\0");return P===-1?void 0:C.slice(0,P)}static localId(C){const P=C.lastIndexOf("\0");return P===-1?C:C.slice(P+1)}static compare(C,P){return C===P?0:P.startsWith(C+"\0")?2:C.startsWith(P+"\0")?3:1}constructor(C,P=C.length){if(this.path=C,this.d=P,C.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new u(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new u(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new u(this.path,C)}compare(C){if(typeof C=="string")return u.compare(this.toString(),C);for(let P=0;P<C.d&&P<this.d;P++)if(C.path[P]!==this.path[P])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=u}),define(ye[76],De([1,0,2,33,58]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var C;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=n=>"runId"in n;e.isStartControllerTests=P;var S;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:A.Range.lift(t.range),uri:c.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var I;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var L;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(n,t)=>`${t?"s":"e"}${n}`;e.getMarkId=k;var v;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(n){n.serialize=t=>t.type===0?L.serialize(t):v.serialize(t),n.deserialize=t=>t.type===0?L.deserialize(t):v.deserialize(t)})(T=e.ITestMessage||(e.ITestMessage={}));var E;(function(n){n.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(T.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(T.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",d=(n,t)=>n+m+t;e.namespaceTestTag=d;const f=n=>{const t=n.indexOf(m);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=f;var p;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?c.URI.revive(t.uri):void 0,range:t.range?A.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(n){n.serialize=t=>({expand:t.expand,item:p.serialize(t.item)}),n.deserialize=t=>({controllerId:u.TestId.root(t.item.extId),expand:t.expand,item:p.deserialize(t.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(n){n.serialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.uri!==void 0&&(a.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(a.range=t.item.range?.toJSON()),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}},n.deserialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.range!==void 0&&(a.range=t.item.range?A.Range.lift(t.item.range):null),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=i;var o;(function(n){n.serializeWithoutMessages=t=>({...y.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(E.serializeWithoutMessages),retired:t.retired}),n.serialize=t=>({...y.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(E.serialize),retired:t.retired}),n.deserialize=t=>({...y.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(E.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var l;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var r;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:y.deserialize(t.item)}:t.op===1?{op:t.op,item:g.deserialize(t.item)}:t.op===2?{op:t.op,uri:c.URI.revive(t.uri),docv:t.docv}:t,n.serialize=t=>t.op===0?{op:t.op,item:y.serialize(t.item)}:t.op===1?{op:t.op,item:g.serialize(t.item)}:t})(r=e.TestsDiffOp||(e.TestsDiffOp={}));class h{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const a=this.o();for(const w of t)switch(w.op){case 0:this.j(y.deserialize(w.item),a);break;case 1:this.k(g.deserialize(w.item),a);break;case 3:this.l(w.itemId,a);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}a.complete?.()}j(t,a){const w=u.TestId.parentId(t.item.extId)?.toString();let D;if(!w)D=this.p(t),this.f.add(D),this.d.set(t.item.extId,D);else if(this.d.has(w)){const F=this.d.get(w);F.children.add(t.item.extId),D=this.p(t,F),this.d.set(t.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return a.add?.(D),t.expand===2&&this.g++,D}k(t,a){const w=this.d.get(t.extId);if(!!w)return t.expand!==void 0&&(w.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,t),a.update?.(w),w}l(t,a){const w=this.d.get(t);if(!w)return;const D=u.TestId.parentId(w.item.extId)?.toString();D?this.d.get(D).children.delete(w.item.extId):this.f.delete(w);const F=[[t]];for(;F.length;)for(const x of F.pop()){const V=this.d.get(x);V&&(F.push(V.children),this.d.delete(x),a.remove?.(V,V!==w),V.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=h}),define(ye[93],De([1,0,17,3,6,50,76,58]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(p,b)=>p===b,k=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:I,label:I,description:I,error:I,sortText:I,tags:(p,b)=>!(p.length!==b.length||p.some(y=>!b.includes(y)))}),v=(p,b)=>{let y;for(const[g,i]of k)i(p[g],b[g])||(y?y[g]=b[g]:y={[g]:b[g]});return y};class T extends u.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const y of this.tree.values())this.G(y)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===b.uri){y.docv=b.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(y.item,b.item);return}if(y.op===0&&y.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(y.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,y){const g=this.tree.get(b);if(!!g){if((g.expandLevels===void 0||y>g.expandLevels)&&(g.expandLevels=y),g.expand===1){const i=this.I(g);return i.isOpen()?this.H(g,y-1):i.wait().then(()=>this.H(g,y-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,y-1)):this.H(g,y-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,y){switch(y.op){case 3:this.L(P.TestId.joinToString(b.fullId,y.id));break;case 0:this.u(y.item,b);break;case 5:for(const g of y.ops)this.p(b,g);break;case 1:this.w(y.new,y.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:y.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(y)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,y){const g=P.TestId.fromExtHostTestItem(b,this.root.id,y?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==y?.actual&&this.m.getChildren(i.parent).delete(b.id);let o=this.tree.get(g.toString());if(!o){o={fullId:g,actual:b,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(b,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(b)}}),this.F(b,o,y);return}if(o.actual===b){this.D(b,o,y);return}if(o.actual.uri?.toString()!==b.uri?.toString())return this.L(g.toString()),this.u(b,y);const s=this.m.getChildren(o.actual),l=o.actual,r=v(this.m.toITestItem(l),this.m.toITestItem(b));this.m.getApiFor(l).listener=void 0,o.actual=b,o.expand=0,r&&(r.hasOwnProperty("tags")&&(this.w(b.tags,l.tags,g.toString()),delete r.tags),this.p(o,{op:4,update:r})),this.F(b,o,y);for(const[h,n]of s)this.m.getChildren(b).get(n.id)||this.L(P.TestId.joinToString(g,n.id));this.s(o.actual.uri)}w(b,y,g){const i=new Set(y.map(o=>o.id));for(const o of b)i.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:g,item:{tags:b.map(o=>(0,C.namespaceTestTag)(this.m.controllerId,o.id))}}}),i.forEach(this.z,this)}y(b){const y=this.j.get(b.id);y?y.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const y=this.j.get(b);y&&!--y.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}C(b,y){this.m.getApiFor(b).parent=y&&y.actual!==this.root?y.actual:void 0}D(b,y,g){this.C(b,g);const i=this.m.getApiFor(b);i.parent=g?.actual,i.listener=o=>this.p(y,o),this.G(y)}F(b,y,g){this.D(b,y,g);for(const[i,o]of this.m.getChildren(b))this.u(o,y)}G(b){let y;this.h?b.resolveBarrier?y=b.resolveBarrier.isOpen()?3:2:y=b.actual.canResolveChildren?1:0:y=0,y!==b.expand&&(b.expand=y,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:y}}),y===1&&b.expandLevels!==void 0&&this.I(b))}H(b,y){if(y<0)return;const g=[];for(const[i,o]of this.m.getChildren(b.actual)){const s=this.expand(P.TestId.joinToString(b.fullId,o.id),y);(0,c.isThenable)(s)&&g.push(s)}if(g.length)return Promise.all(g).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const o=new c.Barrier;return o.open(),o}b.expand=2,this.J(b);const y=b.resolveBarrier=new c.Barrier,g=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(o){g(o)}return(0,c.isThenable)(i)?i.catch(g).then(()=>{y.open(),this.G(b)}):(y.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const y=this.tree.get(b);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const g=[y];for(;g.length;){const i=g.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.z(o.id);this.tree.delete(i.fullId.toString());for(const[o,s]of this.m.getChildren(i.actual))g.push(this.tree.get(P.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=T;class E extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=E;class m extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class d extends Error{constructor(b,y,g){super(`TestItem with ID "${b}" is from controller "${y}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=d;const f=(p,b,y)=>{let g=new Map;return{get size(){return g.size},forEach(i,o){for(const s of g.values())i.call(o,s,this)},[Symbol.iterator](){return g.entries()},replace(i){const o=new Map,s=new Set(g.keys()),l={op:5,ops:[]};for(const r of i){if(!(r instanceof y))throw new m(r.id);const h=b(r).controllerId;if(h!==p.controllerId)throw new d(r.id,h,p.controllerId);if(o.has(r.id))throw new E(r.id);o.set(r.id,r),s.delete(r.id),l.ops.push({op:0,item:r})}for(const r of s.keys())l.ops.push({op:3,id:r});p.listener?.(l),g=o},add(i){if(!(i instanceof y))throw new m(i.id);g.set(i.id,i),p.listener?.({op:0,item:i})},delete(i){g.delete(i)&&p.listener?.({op:3,id:i})},get(i){return g.get(i)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=f}),define(ye[132],De([1,0,93]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,u=(C,P)=>{const S={controllerId:P};return A.set(C,S),S};e.createPrivateApiFor=u;const R=C=>{const P=A.get(C);if(!P)throw new c.InvalidTestItemError(C?.id||"<unknown>");return P};e.getPrivateApiFor=R}),define(ye[94],De([1,0,16,2]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(P,S){return P.scheme===c.Schemas.http||P.scheme===c.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===c.Schemas.file&&(P=A.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:P.path})),A.URI.from({scheme:c.Schemas.https,authority:`${P.scheme}+${R(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=u;function R(P){return P.replace(/./g,S=>{const I=S.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?S:"-"+I.toString(16).padStart(4,"0")})}function C(P){return P.replace(/-([0-9a-f]{4})/g,(S,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=C}),define(ye[231],De([1,0,3,6,94]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(P,S,I){this.d=P,this.e=S,this.f=I,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const k of this.c.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(P=>P.inset.dispose()),this.b.dispose()}createWebviewEditorInset(P,S,I,L,k){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===P){v=b;break}if(!v)throw new Error("not a visible editor");const T=this,E=this.a++,m=new c.Emitter,d=new c.Emitter,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,u.asWebviewUri)(b,T.f)}get cspSource(){return u.webviewGenericCspSource}set options(b){this.b=b,T.d.$setOptions(E,b)}get options(){return this.b}set html(b){this.a=b,T.d.$setHtml(E,b)}get html(){return this.a}get onDidReceiveMessage(){return m.event}postMessage(b){return T.d.$postMessage(E,b)}},p=new class{constructor(){this.editor=P,this.line=S,this.height=I,this.webview=f,this.onDidDispose=d.event}dispose(){T.c.has(E)&&(T.c.delete(E),T.d.$disposeEditorInset(E),d.fire(),d.dispose(),m.dispose())}};return this.d.$createEditorInset(E,v.id,v.value.document.uri,S+1,I,L||{},k.identifier,k.extensionLocation),this.c.set(E,{editor:P,inset:p,onDidReceiveMessage:m}),p}$onDidDispose(P){const S=this.c.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){this.c.get(P)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=R}),define(ye[232],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class u extends Error{constructor(C,P){super(P),this.variable=C}}e.VariableError=u}),define(ye[233],De([1,0,9,36,10,23,12,110,193,232,8]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,E,m,d){this.g=new Map,this.a=T,this.b=E,this.d=m,d&&(this.c=d.then(f=>this.h(f)))}h(T){if(C.isWindows){const E=Object.create(null);return Object.keys(T).forEach(m=>{E[m.toLowerCase()]=T[m]}),E}return T}resolveWithEnvironment(T,E,m){return this.j({env:this.h(T),userHome:void 0},E?E.uri:void 0,m)}async resolveAsync(T,E){const m={env:await this.c,userHome:await this.d};return this.j(m,T?T.uri:void 0,E)}async i(T,E,m,d){const f=R.deepClone(E);C.isWindows&&f.windows?Object.keys(f.windows).forEach(b=>f[b]=f.windows[b]):C.isMacintosh&&f.osx?Object.keys(f.osx).forEach(b=>f[b]=f.osx[b]):C.isLinux&&f.linux&&Object.keys(f.linux).forEach(b=>f[b]=f.linux[b]),delete f.windows,delete f.osx,delete f.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,T?T.uri:void 0,f,m,d)}async resolveAnyAsync(T,E,m){return this.i(T,E,m)}async resolveAnyMap(T,E,m){const d=new Map;return{newConfig:await this.i(T,E,m,d),resolvedVariables:d}}resolveWithInteractionReplace(T,E,m,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,m,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this.g.has(T))throw new Error("Variable "+T+" is contributed twice.");this.g.set(T,E)}async j(T,E,m,d,f){if(u.isString(m))return this.l(T,E,m,d,f);if(Array.isArray(m))return Promise.all(m.map(p=>this.j(T,E,p,d,f)));if(u.isObject(m)){const p=Object.create(null),b=await Promise.all(Object.keys(m).map(async y=>[await this.l(T,E,y,d,f),await this.j(T,E,m[y],d,f)]));for(const[y,g]of b)p[y]=g;return p}return m}l(T,E,m,d,f){return(0,L.replaceAsync)(m,k.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(k.VARIABLE_LHS))return p;let y=await this.n(T,p,b,E,d);return f?.set(b,y),y!==p&&u.isString(y)&&y.match(k.VARIABLE_REGEXP)&&(y=await this.l(T,E,y,d,f)),y})}m(T){return this.b?this.b.getUriLabel(T,{noPrefix:!0}):T.fsPath}async n(T,E,m,d,f){let p;const b=m.split(":");b.length>1&&(m=b[0],p=b[1]);const y=o=>{const s=this.a.getFilePath();if(s)return(0,P.normalizeDriveLetter)(s);throw new I.VariableError(o,(0,S.localize)(0,null,E))},g=o=>{const s=y(o);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,P.normalizeDriveLetter)(l)}throw new I.VariableError(o,(0,S.localize)(1,null,E,c.basename(s)))},i=o=>{if(p){const s=this.a.getFolderUri(p);if(s)return s;throw new I.VariableError(o,(0,S.localize)(2,null,E,p))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new I.VariableError(o,(0,S.localize)(3,null,E)):new I.VariableError(o,(0,S.localize)(4,null,E))};switch(m){case"env":if(p){if(T.env){const o=T.env[C.isWindows?p.toLowerCase():p];if(u.isString(o))return o}return""}throw new I.VariableError(I.VariableKind.Env,(0,S.localize)(5,null,E));case"config":if(p){const o=this.a.getConfigurationValue(d,p);if(u.isUndefinedOrNull(o))throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(6,null,E,p));if(u.isObject(o))throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(7,null,E,p));return o}throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(8,null,E));case"command":return this.o(I.VariableKind.Command,E,p,f,"command");case"input":return this.o(I.VariableKind.Input,E,p,f,"input");case"extensionInstallFolder":if(p){const o=await this.a.getExtension(p);if(!o)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,E,p));return this.m(o.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,E));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(i(I.VariableKind.WorkspaceFolder)));case"cwd":return d||p?(0,P.normalizeDriveLetter)(this.m(i(I.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(c.basename(this.m(i(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(T.userHome)return T.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,S.localize)(11,null,E))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new I.VariableError(I.VariableKind.LineNumber,(0,S.localize)(12,null,E))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new I.VariableError(I.VariableKind.SelectedText,(0,S.localize)(13,null,E))}case"file":return y(I.VariableKind.File);case"fileWorkspaceFolder":return g(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||p?c.relative(this.m(i(I.VariableKind.RelativeFile)),y(I.VariableKind.RelativeFile)):y(I.VariableKind.RelativeFile);case"relativeFileDirname":{const o=c.dirname(y(I.VariableKind.RelativeFileDirname));if(d||p){const s=c.relative(this.m(i(I.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return c.dirname(y(I.VariableKind.FileDirname));case"fileExtname":return c.extname(y(I.VariableKind.FileExtname));case"fileBasename":return c.basename(y(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=c.basename(y(I.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-c.extname(o).length)}case"fileDirnameBasename":return c.basename(c.dirname(y(I.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||E}case"execInstallFolder":{const o=this.a.getAppRoot();return o||E}case"pathSeparator":return c.sep;default:try{const o=p?`${m}:${p}`:m;return this.o(I.VariableKind.Unknown,E,o,f,void 0)}catch{return E}}}}o(T,E,m,d,f){if(m&&d){const p=f===void 0?d[m]:d[f+":"+m];if(typeof p=="string")return p;throw new I.VariableError(T,(0,S.localize)(14,null,E))}return E}}k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=k}),define(ye[133],De([1,0,4,130]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var u;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(u=e.GroupDirection||(e.GroupDirection={}));var R;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var P;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function I(E){const m=E;return(0,A.isEditorInput)(m?.editor)&&(0,A.isEditorInput)(m?.replacement)}e.isEditorReplacement=I;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function v(E){const m=E;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=v;function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(ye[234],De([1,0,4,133]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(R){const C=R;return typeof R=="number"||(0,A.isEditorGroup)(C)}e.isPreferredGroup=u}),define(ye[235],De([1,0,4,199]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(A.IEnvironmentService)}),define(ye[134],De([1,0,26,3,9]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=R;class C{static isHostExtension(k,v,T){if(v.getExtensionDescription(k))return!1;const E=T.getExtensionDescription(k);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(k){this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=k,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const k of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(k.identifier),k),this.f.push(k),Array.isArray(k.activationEvents))for(let v of k.activationEvents)v==="onUri"&&(v=`onUri:${c.ExtensionIdentifier.toKey(k.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(k)}}set(k){this.d=k,this.h(),this.c.fire(void 0)}deltaExtensions(k,v){this.d=I(this.d,v),this.d=this.d.concat(k);const T=C.j(this.d);return this.d=I(this.d,T.map(E=>E.identifier)),this.h(),this.c.fire(void 0),new R(T)}static j(k){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,p){this.addNode(f),this.addNode(p),this.c.has(f)?this.c.get(f).push(p):this.c.set(f,[p])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,p){const b=v.getArcs(f);for(let y=0;y<b.length;y++)if(!p.has(b[y]))return!1;return!0}getNodes(){return this.e}},T=new Map;for(const f of k){const p=c.ExtensionIdentifier.toKey(f.identifier);if(T.set(p,f),f.extensionDependencies)for(const b of f.extensionDependencies){const y=c.ExtensionIdentifier.toKey(b);v.addArc(p,y)}}const E=new Set;v.getNodes().filter(f=>v.getArcs(f).length===0).forEach(f=>E.add(f));const m=v.getNodes().filter(f=>!E.has(f));let d;do{d=!1;for(let f=0;f<m.length;f++){const p=m[f];v.hasOnlyGoodArcs(p,E)&&(m.splice(f,1),f--,E.add(p),d=!0)}}while(d);return m.map(f=>T.get(f))}containsActivationEvent(k){return this.g.has(k)}containsExtension(k){return this.e.has(c.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const v=this.g.get(k);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(k){const v=this.e.get(c.ExtensionIdentifier.toKey(k));return v||void 0}getExtensionDescriptionByUUID(k){for(const v of this.f)if(v.uuid===k)return v}getExtensionDescriptionByIdOrUUID(k,v){return this.getExtensionDescription(k)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=C;var P;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(P||(P={}));function S(L,k){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(v!==T)return v-T;const E=u.posix.basename(L.extensionLocation.path),m=u.posix.basename(k.extensionLocation.path);return E<m?-1:E>m?1:0}function I(L,k){const v=new Set;return k.forEach(T=>v.add(c.ExtensionIdentifier.toKey(T))),L.filter(T=>!v.has(c.ExtensionIdentifier.toKey(T.identifier)))}}),define(ye[236],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class u{constructor(){this.type=2}serialize(k){k[u.ENV_KEY]="1"}}u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=u;class R{constructor(){this.type=3}serialize(k){k[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function C(L){delete L[A.ENV_KEY],delete L[u.ENV_KEY],delete L[R.ENV_KEY]}function P(L,k){C(k),L.serialize(k)}e.writeExtHostConnection=P;function S(L){if(L[A.ENV_KEY])return I(L,new A(L[A.ENV_KEY]));if(L[u.ENV_KEY])return I(L,new u);if(L[R.ENV_KEY])return I(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function I(L,k){return C(L),k}}),define(ye[95],De([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var u;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(u=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function C(I){const L=c.VSBuffer.alloc(1);switch(I){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function P(I,L){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var S;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],De([1,0,4,3,13,25,95,73,74,23,2,6,180]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let T=class extends k.Disposable{constructor(f,p){super(),this.m=f,this.n=p,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=p.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(p.onDidChangeLogLevel(b=>{(0,u.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(f,p,b){const y=this.getTelemetryDetails(),g=new E(p,b,f,this.k,this.i,this.getBuiltInCommonProperties(f),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled});return this.l.set(f.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(f,p,b){this.f=f,this.g=p,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(f){const p={};switch(p["common.extname"]=`${f.publisher}.${f.name}`,p["common.extversion"]=f.version,p["common.vscodemachineid"]=this.m.telemetryInfo.machineId,p["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,p["common.vscodeversion"]=this.m.version,p["common.isnewappinstall"]=m(this.m.telemetryInfo.firstSessionDate),p["common.product"]=this.m.environment.appHost,this.m.uiKind){case C.UIKind.Web:p["common.uikind"]="web";break;case C.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,P.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),p}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const p=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(f,p){const b=this.l.get(f.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(p),!0)}};T=qe([We(0,R.IExtHostInitDataService),We(1,u.ILoggerService)],T),e.ExtHostTelemetry=T;class E{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,p,b,y,g,i,o){this.g=b,this.h=y,this.i=g,this.j=i,this.b=new A.Emitter,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.c=p?.ignoreBuiltInCommonProperties??!1,this.d=p?.additionalCommonProperties,this.a=f,this.e={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(f,p){this.f&&(this.e={isUsageEnabled:f,isErrorsEnabled:p},this.b.fire(this.f))}mixInCommonPropsAndCleanData(f){let p=f.properties??f;return p=(0,S.cleanData)(p,[]),this.d&&(p=(0,I.mixin)(p,this.d)),this.c||(p=(0,I.mixin)(p,this.j)),f.properties?f.properties=p:f=p,f}k(f,p){this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.a.sendEventData(f,p),this.h.trace(f,p)}logUsage(f,p){!this.e.isUsageEnabled||this.k(f,p)}logError(f,p){!this.e.isErrorsEnabled||(typeof f=="string"?this.k(f,p):this.a.sendErrorData(f,p))}get apiTelemetryLogger(){if(!this.f){const f=this,p={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.e.isUsageEnabled},get isErrorsEnabled(){return f.e.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.b.event.bind(f)};this.f=Object.freeze(p)}return this.f}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function m(d){const f=Date.now()-new Date(d).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=m,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[27],De([1,0,3,2,4,26,212]),function(ne,e,c,A,u,R,C){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,u.createDecorator)("extensionService");class S{constructor(h){this.affinity=h,this.kind=1}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class I{constructor(h){this.affinity=h,this.kind=2}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class L{constructor(){this.kind=3,this.affinity=0}equals(h){return this.kind===h.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class k{constructor(h){this.dependency=h}}e.MissingExtensionDependency=k;var v;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class E{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(h,n){const t=[],a=[],w=[],D=[],F=f(this.c),x=f(h),V=(U,B)=>U.extensionLocation.toString()===B.extensionLocation.toString()||U.isBuiltin===B.isBuiltin||U.isUserBuiltin===B.isUserBuiltin||U.isUnderDevelopment===B.isUnderDevelopment;for(const U of this.c){const B=x.get(R.ExtensionIdentifier.toKey(U.identifier));if(!B){t.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!V(U,B)){t.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of h){const B=F.get(R.ExtensionIdentifier.toKey(U.identifier));if(!B){a.push(U);continue}if(!V(B,U)){t.push(B.identifier),F.delete(R.ExtensionIdentifier.toKey(B.identifier));continue}}const M=d(this.d),$=d(n);for(const U of this.d)$.has(R.ExtensionIdentifier.toKey(U))||w.push(U);for(const U of n)M.has(R.ExtensionIdentifier.toKey(U))||D.push(U);const O={toRemove:t,toAdd:a,myToRemove:w,myToAdd:D};return this.delta(O),O}delta(h){const{toRemove:n,toAdd:t,myToRemove:a,myToAdd:w}=h,D=d(n),F=d(a);for(let x=0;x<this.c.length;x++)D.has(R.ExtensionIdentifier.toKey(this.c[x].identifier))&&(this.c.splice(x,1),x--);for(let x=0;x<this.d.length;x++)F.has(R.ExtensionIdentifier.toKey(this.d[x]))&&(this.d.splice(x,1),x--);for(const x of t)this.c.push(x);for(const x of w)this.d.push(x)}containsExtension(h){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,h))return!0;return!1}}e.ExtensionHostExtensions=E;class m{constructor(h){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,h)for(const n of h)this.add(n)}get size(){return this.c.size}add(h){return this.c.set(this.d(h),h),this}clear(){this.c.clear()}delete(h){return this.c.delete(this.d(h))}has(h){return this.c.has(this.d(h))}forEach(h,n){this.c.forEach(t=>h.call(n,t,t,this))}*entries(){for(const[h,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=m;function d(r){const h=new Set;for(const n of r)h.add(R.ExtensionIdentifier.toKey(n));return h}e.extensionIdentifiersArrayToSet=d;function f(r){const h=new Map;for(const n of r)h.set(R.ExtensionIdentifier.toKey(n.identifier),n);return h}function p(r,h){return!0}e.isProposedApiEnabled=p;function b(r,h){if(!p(r,h))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=b;class y{constructor(h,n,t,a){this.codeLoadingTime=h,this.activateCallTime=n,this.activateResolvedTime=t,this.activationReason=a}}e.ActivationTimes=y;class g{constructor(h,n){this.description=h,this.value=n}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var i;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function s(r,h){return{identifier:new R.ExtensionIdentifier((0,C.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!h,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(h,n){return Promise.resolve(0)}getInspectPorts(h,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(ye[237],De([1,0,11,134,26,27,13,17]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(f,p,b,y){this.startup=f,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=y}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class I{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,p){return f===-1||p===-1?-1:p-f}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=I;class L{constructor(f,p,b,y,g,i){this.activationFailed=f,this.activationFailedError=p,this.activationTimes=b,this.module=y,this.exports=g,this.subscriptions=i}}e.ActivatedExtension=L;class k extends L{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class v extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class T extends L{constructor(f){super(!0,f,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(f,p,b,y){this.g=y,this.a=f,this.b=p,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[f,p]of this.d)p.dispose()}isActivated(f){const p=this.d.get(u.ExtensionIdentifier.toKey(f));return Boolean(p&&p.value)}getActivatedExtension(f){const p=this.d.get(u.ExtensionIdentifier.toKey(f));if(!p||!p.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return p.value}async activateByEvent(f,p){if(this.f[f])return;const b=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(b.map(y=>({id:y.identifier,reason:{startup:p,extensionId:y.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,p){const b=this.a.getExtensionDescription(f);if(!b)throw new Error(`Extension '${f}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(f){const p=f.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(f){if(this.d.has(u.ExtensionIdentifier.toKey(f.id)))return this.d.get(u.ExtensionIdentifier.toKey(f.id));if(this.l(f.id))return this.k(f,null,[],null);const p=this.a.getExtensionDescription(f.id);if(!p){const g=new Error(`Cannot activate unknown extension '${f.id.value}'`),i=this.k(f,null,[],new T(g));return this.c.onExtensionActivationError(f.id,g,new R.MissingExtensionDependency(f.id.value)),i}const b=[],y=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const g of y){if(this.m(g))continue;const i=this.d.get(u.ExtensionIdentifier.toKey(g));if(i){b.push(i);continue}if(this.l(g)){b.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:f.reason}));continue}const o=this.a.getExtensionDescription(g);if(o){if(!o.main&&!o.browser)continue;b.push(this.j({id:o.identifier,reason:f.reason}));continue}const s=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${g}'`),r=this.k(f,p.displayName,[],new T(l));return this.c.onExtensionActivationError(p.identifier,l,new R.MissingExtensionDependency(g)),r}return this.k(f,p.displayName,b,null)}k(f,p,b,y){const g=new m(f.id,p,f.reason,b,y,this.c,this.g);return this.d.set(u.ExtensionIdentifier.toKey(f.id),g),g}l(f){return A.ExtensionDescriptionRegistry.isHostExtension(f,this.a,this.b)}m(f){const p=this.b.getExtensionDescription(f);return p?!p.main&&!p.browser:!1}};E=qe([We(3,C.ILogService)],E),e.ExtensionsActivator=E;let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,p,b,y,g,i,o){this.c=f,this.d=p,this.f=b,this.g=y,this.h=g,this.j=i,this.k=o,this.a=new P.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const p=this.g[f];if(p.value&&!p.value.activationFailed){this.g.splice(f,1),f--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new T(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const p=new Error;if(f&&f.name&&(p.name=f.name),f&&f.message?p.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(p.stack=f.stack),this.h=new T(p),this.b&&c.isCancellationError(f))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=qe([We(6,C.ILogService)],m)});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[7],De([1,0,15,11,109,28,87,8,10,2,30,44,128,92,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";var m,d,f,p,b,y,g,i,o,s,l,r,h,n,t,a,w,D,F,x,V,M,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(G){return Object.assign(G,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(G,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[me,...Pe]=arguments;return Reflect.construct(G,Pe,me.constructor)}}})}var U;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var B;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(B=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=y=class{static from(...H){let me=H;return new y(function(){if(me){for(const Pe of me)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();me=void 0}})}constructor(H){m.set(this,void 0),Je(this,m,H,"f")}dispose(){typeof Be(this,m,"f")=="function"&&(Be(this,m,"f").call(this),Je(this,m,void 0,"f"))}};m=new WeakMap,j=y=qe([O],j),e.Disposable=j;let de=g=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ge=H[Pe];Ge.isBefore(me)&&(me=Ge)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ge=H[Pe];Ge.isAfter(me)&&(me=Ge)}return me}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:me,character:Pe}=H;return typeof me=="number"&&typeof Pe=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(me<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&me===0?this:new g(this.line+Pe,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Pe===this.line&&me===this.character?this:new g(Pe,me)}toJSON(){return{line:this.line,character:this.character}}};de=g=qe([O],de),e.Position=de;let Y=i=class{static isRange(H){return H instanceof i?!0:H?de.isPosition(H.start)&&de.isPosition(H.end):!1}static of(H){if(H instanceof i)return H;if(this.isRange(H))return new i(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Pe,Ge){let Ye,at;if(typeof H=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Ye=new de(H,me),at=new de(Pe,Ge)):de.isPosition(H)&&de.isPosition(me)&&(Ye=de.of(H),at=de.of(me)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(H){return i.isRange(H)?this.contains(H.start)&&this.contains(H.end):de.isPosition(H)?!(de.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=de.Max(H.start,this.c),Pe=de.Min(H.end,this.e);if(!me.isAfter(Pe))return new i(me,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=de.Min(H.start,this.c),Pe=de.Max(H.end,this.end);return new i(me,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,A.illegalArgument)();let Pe;return H?de.isPosition(H)?Pe=H:(Pe=H.start||this.start,me=H.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&me.isEqual(this.end)?this:new i(Pe,me)}toJSON(){return[this.start,this.end]}};Y=i=qe([O],Y),e.Range=Y;let q=o=class extends Y{static isSelection(H){return H instanceof o?!0:H?Y.isRange(H)&&de.isPosition(H.anchor)&&de.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Pe,Ge){let Ye,at;if(typeof H=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Ye=new de(H,me),at=new de(Pe,Ge)):de.isPosition(H)&&de.isPosition(me)&&(Ye=de.of(H),at=de.of(me)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=o=qe([O],q),e.Selection=q;class Q{constructor(H,me,Pe){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,A.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(Pe)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(me),this.connectionToken=Pe}}e.ResolvedAuthority=Q;class Z extends Error{static NotAvailable(H,me){return new Z(H,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new Z(H,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=v.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H),this._message=H,this._code=me,this._detail=Pe,Object.setPrototypeOf(this,Z.prototype)}}e.RemoteAuthorityResolverError=Z;var te;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(te=e.EndOfLine||(e.EndOfLine={}));var X;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=s=class{static isTextEdit(H){return H instanceof s?!0:H?Y.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new s(H,me)}static insert(H,me){return s.replace(new Y(H,H),me)}static delete(H){return s.replace(H,"")}static setEndOfLine(H){const me=new s(new Y(new de(0,0),new de(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!Y.isRange(H))throw(0,A.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};J=s=qe([O],J),e.TextEdit=J;let ie=l=class{static isNotebookCellEdit(H){return H instanceof l?!0:H?xt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new l(H,me)}static insertCells(H,me){return new l(new xt(H,H),me)}static deleteCells(H){return new l(H,[])}static updateCellMetadata(H,me){const Pe=new l(new xt(H,H),[]);return Pe.newCellMetadata=me,Pe}static updateNotebookMetadata(H){const me=new l(new xt(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};ie=l=qe([O],ie),e.NotebookEdit=ie;class pe{static isSnippetTextEdit(H){return H instanceof pe?!0:H?Y.isRange(H.range)&&Oe.isSnippetString(H.snippet):!1}static replace(H,me){return new pe(H,me)}static insert(H,me){return pe.replace(new Y(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.SnippetTextEdit=pe;var ve;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let ke=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Pe,Ge){this.c.push({_type:1,from:H,to:me,options:Pe,metadata:Ge})}createFile(H,me,Pe){this.c.push({_type:1,from:void 0,to:H,options:me,metadata:Pe})}deleteFile(H,me,Pe){this.c.push({_type:1,from:H,to:void 0,options:me,metadata:Pe})}e(H,me,Pe){this.c.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:me},notebookMetadata:me})}f(H,me,Pe,Ge){const Ye=me.start,at=me.end;(Ye!==at||Pe.length>0)&&this.c.push({_type:5,uri:H,index:Ye,count:at-Ye,cells:Pe,metadata:Ge})}g(H,me,Pe,Ge){this.c.push({_type:3,metadata:Ge,uri:H,edit:{editType:8,index:me,metadata:Pe}})}replace(H,me,Pe,Ge){this.c.push({_type:2,uri:H,edit:new J(me,Pe),metadata:Ge})}insert(H,me,Pe,Ge){this.replace(H,new Y(me,me),Pe,Ge)}delete(H,me,Pe){this.replace(H,me,"",Pe)}has(H){return this.c.some(me=>me._type===2&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Pe of me){if(!Pe)continue;let Ge,Ye;Array.isArray(Pe)?(Ge=Pe[0],Ye=Pe[1]):Ge=Pe,ie.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(H,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(H,Ge.newNotebookMetadata,Ye):this.f(H,Ge.range,Ge.newCells,Ye):pe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:H,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:H,edit:Ge,metadata:Ye})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ge=this.c[Pe];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===H.toString()&&(this.c[Pe]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(H){const me=[];for(const Pe of this.c)Pe._type===2&&Pe.uri.toString()===H.toString()&&me.push(Pe.edit);return me}entries(){const H=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Pe=H.get(me.uri);Pe||(Pe=[me.uri,[]],H.set(me.uri,Pe)),Pe[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ke=qe([O],ke),e.WorkspaceEdit=ke;let Oe=r=class{static isSnippetString(H){return H instanceof r?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=r.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Pe=new r;Pe.e=this.e,H(Pe),this.e=Pe.e,H=Pe.value}else H=r.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Pe=H.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Pe=new r;Pe.e=this.e,me(Pe),this.e=Pe.e,me=Pe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Oe=r=qe([O],Oe),e.SnippetString=Oe;var oe;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=h=class{static isLocation(H){return H instanceof h?!0:H?Y.isRange(H.range)&&I.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(Y.isRange(me))this.range=Y.of(me);else if(de.isPosition(me))this.range=new Y(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=h=qe([O],fe),e.Location=fe;let ee=class{static is(H){return H?typeof H.message=="string"&&H.location&&Y.isRange(H.location.range)&&I.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};ee=qe([O],ee),e.DiagnosticRelatedInformation=ee;let le=class{constructor(H,me,Pe=ae.Error){if(!Y.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Pe}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,c.equals)(H.tags,me.tags)&&(0,c.equals)(H.relatedInformation,me.relatedInformation,ee.isEqual)}};le=qe([O],le),e.Diagnostic=le;let re=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};re=qe([O],re),e.Hover=re;var N;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let W=class{constructor(H,me=N.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};W=qe([O],W),e.DocumentHighlight=W;var K;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var _;(function(G){G[G.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));let he=n=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Pe,Ge,Ye){this.name=H,this.kind=me,this.containerName=Ye,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof fe?this.location=Ge:Pe instanceof Y&&(this.location=new fe(Ge,Pe)),n.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};he=n=qe([O],he),e.SymbolInformation=he;let we=t=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(t.validate)}constructor(H,me,Pe,Ge,Ye){this.name=H,this.detail=me,this.kind=Pe,this.range=Ge,this.selectionRange=Ye,this.children=[],t.validate(this)}};we=t=qe([O],we),e.DocumentSymbol=we;var Ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(H,me){this.title=H,this.kind=me}};be=qe([O],be),e.CodeAction=be;let Ce=a=class{constructor(H){this.value=H}append(H){return new a(this.value?this.value+a.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+a.c)}};Ce.c=".",Ce=a=qe([O],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let Te=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=qe([O],Te),e.SelectionRange=Te;class Ve{constructor(H,me,Pe,Ge,Ye,at){this.kind=H,this.name=me,this.detail=Pe,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=Ve;class xe{constructor(H,me){this.fromRanges=me,this.from=H}}e.CallHierarchyIncomingCall=xe;class et{constructor(H,me){this.fromRanges=me,this.to=H}}e.CallHierarchyOutgoingCall=et;var Qe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=w=class{static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){d.set(this,void 0),Je(this,d,new u.MarkdownString(H,{supportThemeIcons:me}),"f")}get value(){return Be(this,d,"f").value}set value(H){Be(this,d,"f").value=H}get isTrusted(){return Be(this,d,"f").isTrusted}set isTrusted(H){Be(this,d,"f").isTrusted=H}get supportThemeIcons(){return Be(this,d,"f").supportThemeIcons}set supportThemeIcons(H){Be(this,d,"f").supportThemeIcons=H}get supportHtml(){return Be(this,d,"f").supportHtml}set supportHtml(H){Be(this,d,"f").supportHtml=H}get baseUri(){return Be(this,d,"f").baseUri}set baseUri(H){Be(this,d,"f").baseUri=H}appendText(H){return Be(this,d,"f").appendText(H),this}appendMarkdown(H){return Be(this,d,"f").appendMarkdown(H),this}appendCodeblock(H,me){return Be(this,d,"f").appendCodeblock(me??"",H),this}};d=new WeakMap,st=w=qe([O],st),e.MarkdownString=st;let ht=class{constructor(H,me){this.label=H,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Ue=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};Ue=qe([O],Ue),e.SignatureInformation=Ue;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=qe([O],rt),e.SignatureHelp=rt;var ce;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ce=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var z;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(z=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(H){this.value=H}};ue=qe([O],ue),e.InlayHintLabelPart=ue;let Ie=class{constructor(H,me,Pe){this.position=H,this.label=me,this.kind=Pe}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function(G){G[G.Deprecated=1]="Deprecated"})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let pt=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};pt=qe([O],pt),e.CompletionList=pt;let gt=class{constructor(H,me,Pe){this.insertText=H,this.range=me,this.command=Pe}};gt=qe([O],gt),e.InlineSuggestion=gt;let ct=class{constructor(H){this.commands=void 0,this.items=H}};ct=qe([O],ct),e.InlineSuggestionList=ct;var Et;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Kt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Rt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function H(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(H,me){if(me&&!I.URI.isUri(me))throw(0,A.illegalArgument)("target");if(!Y.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=me}};$t=qe([O],$t),e.DocumentLink=$t;let Nt=class{constructor(H,me,Pe,Ge){this.red=H,this.green=me,this.blue=Pe,this.alpha=Ge}};Nt=qe([O],Nt),e.Color=Nt;let Xe=class{constructor(H,me){if(me&&!(me instanceof Nt))throw(0,A.illegalArgument)("color");if(!Y.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=me}};Xe=qe([O],Xe),e.ColorInformation=Xe;let Mt=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};Mt=qe([O],Mt),e.ColorPresentation=Mt;var Ut;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(H,me,Pe){if(this.startIndex=H,this.length=me,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,A.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Ne{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Ne;class Se{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=Se;var se;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Fe;var He;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let je=D=class{static from(H){switch(H){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,A.illegalArgument)("name");this.c=H}get id(){return this.c}};je.Clean=new D("clean","Clean"),je.Build=new D("build","Build"),je.Rebuild=new D("rebuild","Rebuild"),je.Test=new D("test","Test"),je=D=qe([O],je),e.TaskGroup=je;function it(G){let H="";for(let me=0;me<G.length;me++)H+=G[me].replace(/,/g,",,")+",";return H}let lt=class{constructor(H,me,Pe){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Pe):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return it(H)}};lt=qe([O],lt),e.ProcessExecution=lt;let Pt=class{constructor(H,me,Pe){if(this.f=[],Array.isArray(me)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H,this.f=me,this.g=Pe}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return it(H)}};Pt=qe([O],Pt),e.ShellExecution=Pt;var St;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=kt;let Dt=F=class{constructor(H,me,Pe,Ge,Ye,at){this.j=!1,this.k=this.definition=H;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Pe,this.execution=Ge,dt=Ye,this.j=!0):me===yt.Global||me===yt.Workspace?(this.target=me,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Ye,dt=at):(this.target=me,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Ye,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const me=this.k.type;(F.g===me||F.e===me||F.f===me||F.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};Dt.c="customExecution",Dt.e="process",Dt.f="shell",Dt.g="$empty",Dt=F=qe([O],Dt),e.Task=Dt;var Ct;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(G){function H(me){const Pe=me;return(0,S.isNumber)(Pe.value)?Pe.tooltip&&!(0,S.isString)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}G.isViewBadge=H})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=x=class{static isTreeItem(H,me){if(H instanceof x)return!0;const Pe=H;if(Pe.label!==void 0&&!(0,S.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,S.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,S.isString)(Pe.iconPath)&&!I.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,S.isString)(Pe.iconPath.id))){const Ge=Pe.iconPath;if(!Ge||!(0,S.isString)(Ge.light)&&!I.URI.isUri(Ge.light)&&!(0,S.isString)(Ge.dark)&&!I.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}if(Pe.description!==void 0&&!(0,S.isString)(Pe.description)&&typeof Pe.description!="boolean")return console.log("INVALID tree item, invalid description",Pe.description),!1;if(Pe.resourceUri!==void 0&&!I.URI.isUri(Pe.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1;if(Pe.tooltip!==void 0&&!(0,S.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1;if(Pe.command!==void 0&&!Pe.command.command)return console.log("INVALID tree item, invalid command",Pe.command),!1;if(Pe.collapsibleState!==void 0&&Pe.collapsibleState<wt.None&&Pe.collapsibleState>wt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1;if(Pe.contextValue!==void 0&&!(0,S.isString)(Pe.contextValue))return console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1;if(Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1;if(Pe.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ge=(0,S.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,S.isObject)(Pe.checkboxState)&&(0,S.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Pe.checkboxState)&&(0,S.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==si.Checked&&Ge!==si.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}return!0}constructor(H,me=wt.None){this.collapsibleState=me,I.URI.isUri(H)?this.resourceUri=H:this.label=H}};Jt=x=qe([O],Jt),e.TreeItem=Jt;var wt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,me){this.value=H,this.id=me??(0,L.generateUuid)()}};oi=qe([O],oi),e.DataTransferItem=oi;let Zt=class{constructor(H){f.set(this,new Map);for(const[me,Pe]of H??[]){const Ge=Be(this,f,"f").get(me);Ge?Ge.push(Pe):Be(this,f,"f").set(me,[Pe])}}get(H){return Be(this,f,"f").get(H)?.[0]}set(H,me){Be(this,f,"f").set(H,[me])}forEach(H,me){for(const[Pe,Ge]of Be(this,f,"f"))for(const Ye of Ge)H.call(me,Ye,Pe,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[H,me]of Be(this,f,"f"))for(const Pe of me)yield[H,Pe]}};Zt=qe([O],Zt),e.DataTransfer=Zt;let bi=class{constructor(H){this.insertText=H}};bi=qe([O],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(H){this.insertText=H}};Lt=qe([O],Lt),e.DocumentPasteEdit=Lt;let Ht=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};Ht=qe([O],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let vi=class{constructor(H){this.id=H}};vi=qe([O],vi),e.ThemeColor=vi;var ai;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(H){this.c=H,this.e=I.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!I.URI.isUri(H)&&!I.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof me!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=I.URI.file(H):I.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([O],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(G,H){ut.set(G,H)}e.setBreakpointId=Bi;let Bt=class{constructor(H,me,Pe,Ge){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ut.get(this)??(0,L.generateUuid)()),this.c}};Bt=qe([O],Bt),e.Breakpoint=Bt;let Qt=class extends Bt{constructor(H,me,Pe,Ge,Ye){if(super(me,Pe,Ge,Ye),H===null)throw(0,A.illegalArgument)("location");this.location=H}};Qt=qe([O],Qt),e.SourceBreakpoint=Qt;let ci=class extends Bt{constructor(H,me,Pe,Ge,Ye){super(me,Pe,Ge,Ye),this.functionName=H}};ci=qe([O],ci),e.FunctionBreakpoint=ci;let wi=class extends Bt{constructor(H,me,Pe,Ge,Ye,at,dt){if(super(Ge,Ye,at,dt),!me)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=me,this.canPersist=Pe}};wi=qe([O],wi),e.DataBreakpoint=wi;let Ei=class{constructor(H,me,Pe){this.command=H,this.args=me||[],this.options=Pe}};Ei=qe([O],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(H,me){this.port=H,this.host=me}};li=qe([O],li),e.DebugAdapterServer=li;let Si=class{constructor(H){this.path=H}};Si=qe([O],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(H){this.implementation=H}};ui=qe([O],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(H,me){this.range=H,this.expression=me}};ti=qe([O],ti),e.EvaluatableExpression=ti;var $i;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(H,me){this.range=H,this.text=me}};ii=qe([O],ii),e.InlineValueText=ii;let ni=class{constructor(H,me,Pe=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Pe}};ni=qe([O],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(H,me){this.range=H,this.expression=me}};yi=qe([O],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};Di=qe([O],Di),e.InlineValueContext=Di;var ri;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ci=V=class extends Error{static FileExists(H){return new V(H,k.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(H){return new V(H,k.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(H){return new V(H,k.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(H){return new V(H,k.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(H){return new V(H,k.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(H){return new V(H,k.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(H,me=k.FileSystemProviderErrorCode.Unknown,Pe){super(I.URI.isUri(H)?H.toString(!0):H),this.code=Pe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};Ci=V=qe([O],Ci),e.FileSystemError=Ci;let Ii=class{constructor(H,me,Pe){this.start=H,this.end=me,this.kind=Pe}};Ii=qe([O],Ii),e.FoldingRange=Ii;var zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.SemanticTokensLegend=Ri;function Li(G){return typeof G>"u"||(0,S.isStringArray)(G)}class ze{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let me=0,Pe=H.tokenTypes.length;me<Pe;me++)this.j.set(H.tokenTypes[me],me);for(let me=0,Pe=H.tokenModifiers.length;me<Pe;me++)this.k.set(H.tokenModifiers[me],me)}}push(H,me,Pe,Ge,Ye){if(typeof H=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(H,me,Pe,Ge,Ye);if(Y.isRange(H)&&typeof me=="string"&&Li(Pe))return this.m(H,me,Pe);throw(0,A.illegalArgument)()}m(H,me,Pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ge=H.start.line,Ye=H.start.character,at=H.end.character-H.start.character,dt=this.j.get(me);let Ft=0;if(Pe)for(const Vt of Pe){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Ft|=1<<Gt>>>0}this.n(Ge,Ye,at,dt,Ft)}n(H,me,Pe,Ge,Ye){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Ft;Xt++){let _t=this.g[5*Xt],Pi=this.g[5*Xt+1];_t===0?(_t=Vt,Pi+=Gt):_t+=Vt,this.g[5*Xt]=_t,this.g[5*Xt+1]=Pi,Vt=_t,Gt=Pi}}let at=H,dt=me;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Pe,this.g[this.h++]=Ge,this.g[this.h++]=Ye,this.c=H,this.e=me}static o(H){const me=[],Pe=H.length/5|0;for(let dt=0;dt<Pe;dt++)me[dt]=dt;me.sort((dt,Ft)=>{const Vt=H[5*dt],Gt=H[5*Ft];if(Vt===Gt){const Xt=H[5*dt+1],_t=H[5*Ft+1];return Xt-_t}return Vt-Gt});const Ge=new Uint32Array(H.length);let Ye=0,at=0;for(let dt=0;dt<Pe;dt++){const Ft=5*me[dt],Vt=H[Ft+0],Gt=H[Ft+1],Xt=H[Ft+2],_t=H[Ft+3],Pi=H[Ft+4],sn=Vt-Ye,Rn=sn===0?Gt-at:Gt,Ai=5*dt;Ge[Ai+0]=sn,Ge[Ai+1]=Rn,Ge[Ai+2]=Xt,Ge[Ai+3]=_t,Ge[Ai+4]=Pi,Ye=Vt,at=Gt}return Ge}build(H){return this.f?new jt(new Uint32Array(this.g),H):new jt(ze.o(this.g),H)}}e.SemanticTokensBuilder=ze;class jt{constructor(H,me){this.resultId=me,this.data=H}}e.SemanticTokens=jt;class Oi{constructor(H,me,Pe){this.start=H,this.deleteCount=me,this.data=Pe}}e.SemanticTokensEdit=Oi;class vt{constructor(H,me){this.resultId=me,this.edits=H}}e.SemanticTokensEdits=vt;var ji;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Ht("arrow-left")},di=qe([O],di),e.QuickInputButtons=di;var Ni;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(H){if(typeof H.badge=="string"){let me=(0,P.nextCharLength)(H.badge,0);if(me<H.badge.length&&(me+=(0,P.nextCharLength)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Ht.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Pe){this.badge=H,this.tooltip=me,this.color=Pe}}e.FileDecoration=qi;let Ti=class{constructor(H){this.kind=H}};Ti=qe([O],Ti),e.ColorTheme=Ti;var xi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(H){return H instanceof xt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(me<0)throw(0,A.illegalArgument)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Pe=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Pe=H.end),me===this.c&&Pe===this.e?this:new xt(me,Pe)}}e.NotebookRange=xt;class fi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>fi.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Pe,Ge,Ye,at,dt){this.kind=H,this.value=me,this.languageId=Pe,this.mime=Ge,this.outputs=Ye??[],this.metadata=at,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(H){this.cells=H}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(H){return H instanceof zt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return zt.json(me,"application/vnd.code.notebook.error")}static stdout(H){return zt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return zt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new zt(H,me)}static text(H,me=C.Mimes.text){const Pe=Be(zt,p,"f",b).encode(String(H));return new zt(Pe,me)}static json(H,me="text/x-json"){const Pe=JSON.stringify(H,void 0,"	");return zt.text(Pe,me)}constructor(H,me){this.data=H,this.mime=me;const Pe=(0,C.normalizeMimeType)(me,!0);if(!Pe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}p=zt,b={value:new TextEncoder},e.NotebookCellOutputItem=zt;class mi{static isNotebookCellOutput(H){return H instanceof mi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Pe=new Set,Ge=new Set;for(let Ye=0;Ye<H.length;Ye++){const at=H[Ye],dt=(0,C.normalizeMimeType)(at.mime);if(!Pe.has(dt)||(0,T.isTextStreamMime)(dt)){Pe.add(dt);continue}Ge.add(Ye),me&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?H:H.filter((Ye,at)=>!Ge.has(at))}constructor(H,me,Pe){this.items=mi.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=me??Pe)}}e.NotebookCellOutput=mi;var Ki;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(H,me){this.text=H,this.alignment=me}}e.NotebookCellStatusBarItem=Me;var ot;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(H,me=[]){this.uri=H,this.provides=(0,c.asArray)(me)}}e.NotebookRendererScript=Ot;class ln{constructor(H){this.label=H}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(H,me){this.label=H,this.timestamp=me}};Qi=qe([O],Qi),e.TimelineItem=Qi;var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(H,me){this.c=H,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(H=void 0,me=void 0,Pe=void 0){this.include=H,this.exclude=me,this.profile=Pe}};Fi=qe([O],Fi),e.TestRunRequest=Fi;let _i=class extends Fi{constructor(H=void 0,me=void 0,Pe=void 0,Ge=!1){super(H,me,Pe),this.continuous=Ge}};_i=qe([O],_i),e.TestRunRequest2=_i;let Yi=M=class{static diff(H,me,Pe){const Ge=new M(H);return Ge.expectedOutput=me,Ge.actualOutput=Pe,Ge}constructor(H){this.message=H}};Yi=M=qe([O],Yi),e.TestMessage=Yi;let Ji=class{constructor(H){this.id=H}};Ji=qe([O],Ji),e.TestTag=Ji;let gi=class{constructor(H,me){this.covered=H,this.total=me}};gi=qe([O],gi),e.CoveredCount=gi;let Zi=$=class{static fromDetails(H,me){const Pe=new gi(0,0),Ge=new gi(0,0),Ye=new gi(0,0);for(const dt of me)if("branches"in dt){Pe.total+=1,Pe.covered+=dt.executionCount>0?1:0;for(const Ft of dt.branches)Ge.total+=1,Ge.covered+=Ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const at=new $(H,Pe,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=me,at}constructor(H,me,Pe,Ge){this.uri=H,this.statementCoverage=me,this.branchCoverage=Pe,this.functionCoverage=Ge}};Zi=$=qe([O],Zi),e.FileCoverage=Zi;let en=class{constructor(H,me,Pe=[]){this.executionCount=H,this.location=me,this.branches=Pe}};en=qe([O],en),e.StatementCoverage=en;let tn=class{constructor(H,me){this.executionCount=H,this.location=me}};tn=qe([O],tn),e.BranchCoverage=tn;let nn=class{constructor(H,me){this.executionCount=H,this.location=me}};nn=qe([O],nn),e.FunctionCoverage=nn;var bn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(H,me,Pe,Ge,Ye,at){this.kind=H,this.name=me,this.detail=Pe,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=En;class Sn{constructor(H){this.uri=H}}e.TextTabInput=Sn;class yn{constructor(H,me){this.original=H,this.modified=me}}e.TextDiffTabInput=yn;class Dn{constructor(H,me,Pe,Ge){this.base=H,this.input1=me,this.input2=Pe,this.result=Ge}}e.TextMergeTabInput=Dn;class Cn{constructor(H,me){this.uri=H,this.viewType=me}}e.CustomEditorTabInput=Cn;class In{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=In;class kn{constructor(H,me){this.uri=H,this.notebookType=me}}e.NotebookEditorTabInput=kn;class Tn{constructor(H,me,Pe){this.original=H,this.modified=me,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,16,8,159,118,7,15]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function L(E,m){m?I.set(E,m):I.delete(E)}e.setWordDefinitionFor=L;function k(E){return I.get(E)}class v extends R.MirrorTextModel{constructor(m,d,f,p,b,y,g,i){super(d,f,p,b),this.m=m,this.p=y,this.q=g,this.notebook=i,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(m){return(0,S.equals)(this.d,m)}get document(){if(!this.a){const m=this;this.a={get uri(){return m.c},get fileName(){return m.c.fsPath},get isUntitled(){return m.c.scheme===A.Schemas.untitled},get languageId(){return m.p},get version(){return m.g},get isClosed(){return m.b},get isDirty(){return m.q},save(){return m.r()},getText(d){return d?m.s(d):m.getText()},get eol(){return m.f===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return m.d.length},lineAt(d){return m.t(d)},offsetAt(d){return m.u(d)},positionAt(d){return m.v(d)},validateRange(d){return m.w(d)},validatePosition(d){return m.x(d)},getWordRangeAtPosition(d,f){return m.y(d,f)}}}return Object.freeze(this.a)}_acceptLanguageId(m){(0,c.ok)(!this.b),this.p=m}_acceptIsDirty(m){(0,c.ok)(!this.b),this.q=m}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(m){const d=this.w(m);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const f=this.f,p=d.start.line,b=d.end.line,y=[];y.push(this.d[p].substring(d.start.character));for(let g=p+1;g<b;g++)y.push(this.d[g]);return y.push(this.d[b].substring(0,d.end.character)),y.join(f)}t(m){let d;if(m instanceof P.Position?d=m.line:typeof m=="number"&&(d=m),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new T(d,this.d[d],d===this.d.length-1)}u(m){return m=this.x(m),this.k(),this.h.getPrefixSum(m.line-1)+m.character}v(m){m=Math.floor(m),m=Math.max(0,m),this.k();const d=this.h.getIndexOf(m),f=this.d[d.index].length;return new P.Position(d.index,Math.min(d.remainder,f))}w(m){if(!(m instanceof P.Range))throw new Error("Invalid argument");const d=this.x(m.start),f=this.x(m.end);return d===m.start&&f===m.end?m:new P.Range(d.line,d.character,f.line,f.character)}x(m){if(!(m instanceof P.Position))throw new Error("Invalid argument");if(this.d.length===0)return m.with(0,0);let{line:d,character:f}=m,p=!1;if(d<0)d=0,f=0,p=!0;else if(d>=this.d.length)d=this.d.length-1,f=this.d[d].length,p=!0;else{const b=this.d[d].length;f<0?(f=0,p=!0):f>b&&(f=b,p=!0)}return p?new P.Position(d,f):m}y(m,d){const f=this.x(m);if(!d)d=k(this.p);else if((0,u.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const p=(0,C.getWordAtText)(f.character+1,(0,C.ensureValidWordDefinition)(d),this.d[f.line],0);if(p)return new P.Range(f.line,p.startColumn-1,f.line,p.endColumn-1)}}e.ExtHostDocumentData=v;class T{constructor(m,d,f){this.a=m,this.b=d,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new P.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new P.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=T}),define(ye[238],De([1,0,7,18,3]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(P){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new u.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(P){let S;switch(P){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],De([1,0,15,22,151,64,109,28,147,70,87,23,10,2,33,72,124,132,130,92,58,76,234,7]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Ne(se){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:_e,positionColumn:je}=se,it=new o.Position(Fe-1,He-1),lt=new o.Position(_e-1,je-1);return new o.Selection(it,lt)}Re.to=Ne;function Se(se){const{anchor:Fe,active:He}=se;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(s=e.Selection||(e.Selection={}));var l;(function(Re){function Ne(se){if(!se)return;const{start:Fe,end:He}=se;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Ne;function Se(se){if(!se)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:_e,endColumn:je}=se;return new o.Range(Fe-1,He-1,_e-1,je-1)}Re.to=Se})(l=e.Range||(e.Range={}));var r;(function(Re){function Ne(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Ne})(r=e.TokenType||(e.TokenType={}));var h;(function(Re){function Ne(se){return new o.Position(se.lineNumber-1,se.column-1)}Re.to=Ne;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Re.from=Se})(h=e.Position||(e.Position={}));var n;(function(Re){function Ne(Fe,He){return(0,c.coalesce)((0,c.asArray)(Fe).map(_e=>Se(_e,He)))}Re.from=Ne;function Se(Fe,He){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:se(Fe.scheme,He),pattern:z.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function se(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Re){function Ne(se){switch(se){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Ne;function Se(se){switch(se){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(Re){function Ne(se){let Fe;return se.code&&((0,v.isString)(se.code)||(0,v.isNumber)(se.code)?Fe=String(se.code):Fe={value:String(se.code.value),target:se.code.target}),{...l.from(se.range),message:se.message,source:se.source,code:Fe,severity:D.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(w.from),tags:Array.isArray(se.tags)?(0,c.coalesce)(se.tags.map(t.from)):void 0}}Re.from=Ne;function Se(se){const Fe=new o.Diagnostic(l.to(se),se.message,D.to(se.severity));return Fe.source=se.source,Fe.code=(0,v.isString)(se.code)?se.code:se.code?.value,Fe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(w.to),Fe.tags=se.tags&&(0,c.coalesce)(se.tags.map(t.to)),Fe}Re.to=Se})(a=e.Diagnostic||(e.Diagnostic={}));var w;(function(Re){function Ne(se){return{...l.from(se.location.range),message:se.message,resource:se.location.uri}}Re.from=Ne;function Se(se){return new o.DiagnosticRelatedInformation(new o.Location(se.resource,l.to(se)),se.message)}Re.to=Se})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var D;(function(Re){function Ne(se){switch(se){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Ne;function Se(se){switch(se){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=Se})(D=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Re){function Ne(se){return typeof se=="number"&&se>=o.ViewColumn.One?se-1:se===o.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Ne;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(F=e.ViewColumn||(e.ViewColumn={}));function x(Re){return typeof Re.range<"u"}function V(Re){return Re.length===0?!0:!!x(Re[0])}e.isDecorationOptionsArr=V;var M;(function(Re){function Ne(je){return je.map(Re.from)}Re.fromMany=Ne;function Se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function se(je){let it;if(Se(je)){const{language:yt,value:kt}=je;it={value:"```"+yt+`
`+kt+"\n```\n"}}else o.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const lt=Object.create(null);it.uris=lt;const Pt=yt=>{try{let kt=T.URI.parse(yt,!0);kt=kt.with({query:Fe(kt.query,lt)}),lt[yt]=kt}catch{}return""},St=new S.marked.Renderer;return St.link=Pt,St.image=yt=>typeof yt=="string"?Pt(C.parseHrefAndDimensions(yt).href):"",(0,S.marked)(it.value,{renderer:St}),it}Re.from=se;function Fe(je,it){if(!je)return je;let lt;try{lt=(0,I.parse)(je)}catch{}if(!lt)return je;let Pt=!1;return lt=(0,k.cloneAndChange)(lt,St=>{if(T.URI.isUri(St)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[yt]=St,Pt=!0,yt}else return}),Pt?JSON.stringify(lt):je}function He(je){const it=new o.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?T.URI.from(je.baseUri):void 0,it}Re.to=He;function _e(je){if(!!je)return typeof je=="string"?je:Re.from(je)}Re.fromStrict=_e})(M=e.MarkdownString||(e.MarkdownString={}));function $(Re){return V(Re)?Re.map(Ne=>({range:l.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?M.fromMany(Ne.hoverMessage):Ne.hoverMessage?M.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Re.map(Ne=>({range:l.from(Ne)}))}e.fromRangeOrRangeWithMessage=$;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?T.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Ne(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Ne})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Re){function Ne(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Ne})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Ne(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ne})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var de;(function(Re){function Ne(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?B.from(Se.light):void 0,dark:Se.dark?B.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Ne})(de=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(Re){function Ne(se){return{text:se.newText,eol:se.newEol&&st.from(se.newEol),range:l.from(se.range)}}Re.from=Ne;function Se(se){const Fe=new o.TextEdit(l.to(se.range),se.text);return Fe.newEol=typeof se.eol>"u"?void 0:st.to(se.eol),Fe}Re.to=Se})(Y=e.TextEdit||(e.TextEdit={}));var q;(function(Re){function Ne(se,Fe){const He={edits:[]};if(se instanceof o.WorkspaceEdit){const _e=new P.ResourceSet;for(const je of se._allEntries())je._type===1&&T.URI.isUri(je.to)&&je.from===void 0&&_e.add(je.to);for(const je of se._allEntries())je._type===1?He.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?He.edits.push({resource:je.uri,textEdit:Y.from(je.edit),versionId:_e.has(je.uri)?void 0:Fe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?He.edits.push({resource:je.uri,textEdit:{range:l.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:_e.has(je.uri)?void 0:Fe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?He.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&He.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(pt.from)}})}return He}Re.from=Ne;function Se(se){const Fe=new o.WorkspaceEdit;for(const He of se.edits)He.textEdit?Fe.replace(T.URI.revive(He.resource),l.to(He.textEdit.range),He.textEdit.text):Fe.renameFile(T.URI.revive(He.oldResource),T.URI.revive(He.newResource),He.options);return Fe}Re.to=Se})(q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Re){const Ne=Object.create(null);Ne[o.SymbolKind.File]=0,Ne[o.SymbolKind.Module]=1,Ne[o.SymbolKind.Namespace]=2,Ne[o.SymbolKind.Package]=3,Ne[o.SymbolKind.Class]=4,Ne[o.SymbolKind.Method]=5,Ne[o.SymbolKind.Property]=6,Ne[o.SymbolKind.Field]=7,Ne[o.SymbolKind.Constructor]=8,Ne[o.SymbolKind.Enum]=9,Ne[o.SymbolKind.Interface]=10,Ne[o.SymbolKind.Function]=11,Ne[o.SymbolKind.Variable]=12,Ne[o.SymbolKind.Constant]=13,Ne[o.SymbolKind.String]=14,Ne[o.SymbolKind.Number]=15,Ne[o.SymbolKind.Boolean]=16,Ne[o.SymbolKind.Array]=17,Ne[o.SymbolKind.Object]=18,Ne[o.SymbolKind.Key]=19,Ne[o.SymbolKind.Null]=20,Ne[o.SymbolKind.EnumMember]=21,Ne[o.SymbolKind.Struct]=22,Ne[o.SymbolKind.Event]=23,Ne[o.SymbolKind.Operator]=24,Ne[o.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Re.from=Se;function se(Fe){for(const He in Ne)if(Ne[He]===Fe)return Number(He);return o.SymbolKind.Property}Re.to=se})(Q=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Re){function Ne(se){switch(se){case o.SymbolTag.Deprecated:return 1}}Re.from=Ne;function Se(se){switch(se){case 1:return o.SymbolTag.Deprecated}}Re.to=Se})(Z=e.SymbolTag||(e.SymbolTag={}));var te;(function(Re){function Ne(se){return{name:se.name,kind:Q.from(se.kind),tags:se.tags&&se.tags.map(Z.from),containerName:se.containerName,location:ve.from(se.location)}}Re.from=Ne;function Se(se){const Fe=new o.SymbolInformation(se.name,Q.to(se.kind),se.containerName,ve.to(se.location));return Fe.tags=se.tags&&se.tags.map(Z.to),Fe}Re.to=Se})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Ne(se){const Fe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:l.from(se.range),selectionRange:l.from(se.selectionRange),kind:Q.from(se.kind),tags:se.tags?.map(Z.from)??[]};return se.children&&(Fe.children=se.children.map(Ne)),Fe}Re.from=Ne;function Se(se){const Fe=new o.DocumentSymbol(se.name,se.detail,Q.to(se.kind),l.to(se.range),l.to(se.selectionRange));return(0,c.isNonEmptyArray)(se.tags)&&(Fe.tags=se.tags.map(Z.to)),se.children&&(Fe.children=se.children.map(Se)),Fe}Re.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Re){function Ne(se){const Fe=new o.CallHierarchyItem(Q.to(se.kind),se.name,se.detail||"",T.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Re.to=Ne;function Se(se,Fe,He){if(Fe=Fe??se._sessionId,He=He??se._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:se.name,detail:se.detail,kind:Q.from(se.kind),uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Re.from=Se})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Re){function Ne(Se){return new o.CallHierarchyIncomingCall(J.to(Se.from),Se.fromRanges.map(se=>l.to(se)))}Re.to=Ne})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(Re){function Ne(Se){return new o.CallHierarchyOutgoingCall(J.to(Se.to),Se.fromRanges.map(se=>l.to(se)))}Re.to=Ne})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Re){function Ne(se){return{range:se.range&&l.from(se.range),uri:se.uri}}Re.from=Ne;function Se(se){return new o.Location(T.URI.revive(se.uri),l.to(se.range))}Re.to=Se})(ve=e.location||(e.location={}));var ke;(function(Re){function Ne(se){const Fe=se,He=se;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:l.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Re.from=Ne;function Se(se){return{targetUri:T.URI.revive(se.uri),targetRange:l.to(se.range),targetSelectionRange:se.targetSelectionRange?l.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?l.to(se.originSelectionRange):void 0}}Re.to=Se})(ke=e.DefinitionLink||(e.DefinitionLink={}));var Oe;(function(Re){function Ne(se){return{range:l.from(se.range),contents:M.fromMany(se.contents)}}Re.from=Ne;function Se(se){return new o.Hover(se.contents.map(M.to),l.to(se.range))}Re.to=Se})(Oe=e.Hover||(e.Hover={}));var oe;(function(Re){function Ne(se){return{range:l.from(se.range),expression:se.expression}}Re.from=Ne;function Se(se){return new o.EvaluatableExpression(l.to(se.range),se.expression)}Re.to=Se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(Re){function Ne(se){if(se instanceof o.InlineValueText)return{type:"text",range:l.from(se.range),text:se.text};if(se instanceof o.InlineValueVariableLookup)return{type:"variable",range:l.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ne;function Se(se){switch(se.type){case"text":return{range:l.to(se.range),text:se.text};case"variable":return{range:l.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:l.to(se.range),expression:se.expression}}}Re.to=Se})(ae=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Ne(se){return{frameId:se.frameId,stoppedLocation:l.from(se.stoppedLocation)}}Re.from=Ne;function Se(se){return new o.InlineValueContext(se.frameId,l.to(se.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Re){function Ne(se){return{range:l.from(se.range),kind:se.kind}}Re.from=Ne;function Se(se){return new o.DocumentHighlight(l.to(se.range),se.kind)}Re.to=Se})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(Re){function Ne(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Ne})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Re){function Ne(Se){return{triggerKind:le.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Ne})(re=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Ne(se){switch(se){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Ne;function Se(se){switch(se){case 1:return o.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Re){const Ne=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Ne.get(He)??9}Re.from=Se;const se=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return se.get(He)??o.CompletionItemKind.Property}Re.to=Fe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Re){function Ne(Se,se){const Fe=new o.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=W.to(Se.kind),Fe.tags=Se.tags?.map(N.to),Fe.detail=Se.detail,Fe.documentation=C.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,E.Range.isIRange(Se.range)?Fe.range=l.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:l.to(Se.range.insert),replacing:l.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new o.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof o.Range?new o.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(He=>Y.to(He))),Fe.command=se&&Se.command?se.fromInternal(Se.command):void 0,Fe}Re.to=Ne})(K=e.CompletionItem||(e.CompletionItem={}));var _;(function(Re){function Ne(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:M.fromStrict(se.documentation)}}Re.from=Ne;function Se(se){return{label:se.label,documentation:C.isMarkdownString(se.documentation)?M.to(se.documentation):se.documentation}}Re.to=Se})(_=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Ne(se){return{label:se.label,documentation:M.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(_.from):[],activeParameter:se.activeParameter}}Re.from=Ne;function Se(se){return{label:se.label,documentation:C.isMarkdownString(se.documentation)?M.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(_.to):[],activeParameter:se.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Ne(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(he.from):[]}}Re.from=Ne;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Ne(Se,se){const Fe=new o.InlayHint(h.to(se.position),typeof se.label=="string"?se.label:se.label.map(be.to.bind(void 0,Se)),se.kind&&Ce.to(se.kind));return Fe.textEdits=se.textEdits&&se.textEdits.map(Y.to),Fe.tooltip=C.isMarkdownString(se.tooltip)?M.to(se.tooltip):se.tooltip,Fe.paddingLeft=se.paddingLeft,Fe.paddingRight=se.paddingRight,Fe}Re.to=Ne})(Ae=e.InlayHint||(e.InlayHint={}));var be;(function(Re){function Ne(Se,se){const Fe=new o.InlayHintLabelPart(se.label);return Fe.tooltip=C.isMarkdownString(se.tooltip)?M.to(se.tooltip):se.tooltip,m.Command.is(se.command)&&(Fe.command=Se.fromInternal(se.command)),se.location&&(Fe.location=ve.to(se.location)),Fe}Re.to=Ne})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Re){function Ne(se){return se}Re.from=Ne;function Se(se){return se}Re.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Te;(function(Re){function Ne(se){return{range:l.from(se.range),url:se.target,tooltip:se.tooltip}}Re.from=Ne;function Se(se){let Fe;if(se.url)try{Fe=typeof se.url=="string"?T.URI.parse(se.url,!0):T.URI.revive(se.url)}catch{}return new o.DocumentLink(l.to(se.range),Fe)}Re.to=Se})(Te=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(Re){function Ne(se){const Fe=new o.ColorPresentation(se.label);return se.textEdit&&(Fe.textEdit=Y.to(se.textEdit)),se.additionalTextEdits&&(Fe.additionalTextEdits=se.additionalTextEdits.map(He=>Y.to(He))),Fe}Re.to=Ne;function Se(se){return{label:se.label,textEdit:se.textEdit?Y.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Fe=>Y.from(Fe)):void 0}}Re.from=Se})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(Re){function Ne(se){return new o.Color(se[0],se[1],se[2],se[3])}Re.to=Ne;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Re.from=Se})(xe=e.Color||(e.Color={}));var et;(function(Re){function Ne(se){return{range:l.from(se.range)}}Re.from=Ne;function Se(se){return new o.SelectionRange(l.to(se.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Ne(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Ne})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Ne(se){switch(se){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ne;function Se(se){switch(se){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Ne(se){if(se===o.EndOfLine.CRLF)return 1;if(se===o.EndOfLine.LF)return 0}Re.from=Ne;function Se(se){if(se===1)return o.EndOfLine.CRLF;if(se===0)return o.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Ne(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ne})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(Re){function Ne(Se){const se={start:Se.start+1,end:Se.end+1};return Se.kind&&(se.kind=rt.from(Se.kind)),se}Re.from=Ne})(Ue=e.FoldingRange||(e.FoldingRange={}));var rt;(function(Re){function Ne(Se){if(Se)switch(Se){case o.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Re.from=Ne})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ce;(function(Re){function Ne(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?l.from(Se.selection):void 0,override:typeof Se.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Ne})(ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var z;(function(Re){function Ne(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||se(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Ne;function Se(He){const _e=He;return _e?T.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function se(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.RelativePattern(T.URI.revive(He.baseUri),He.pattern)}Re.to=Fe})(z=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Re){function Ne(Se){if(Se){if(Array.isArray(Se))return Se.map(Ne);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:z.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Re.from=Ne})(ue=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Ne(se){return{start:se.start,end:se.end}}Re.from=Ne;function Se(se){return new o.NotebookRange(se.start,se.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Ne(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Re.to=Ne;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(Re){function Ne(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Ne})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ke;(function(Re){function Ne(se){switch(se){case o.NotebookCellKind.Markup:return b.CellKind.Markup;case o.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Ne;function Se(se){switch(se){case b.CellKind.Markup:return o.NotebookCellKind.Markup;case b.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=Se})(Ke=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Ne(se){const Fe={metadata:se.metadata??Object.create(null),cells:[]};for(const He of se.cells)o.NotebookCellData.validate(He),Fe.cells.push(pt.from(He));return Fe}Re.from=Ne;function Se(se){const Fe=new o.NotebookData(se.cells.map(pt.to));return(0,v.isEmptyObject)(se.metadata)||(Fe.metadata=se.metadata),Fe}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var pt;(function(Re){function Ne(se){return{cellKind:Ke.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Le.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(ct.from):[]}}Re.from=Ne;function Se(se){return new o.NotebookCellData(Ke.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(ct.to):void 0,se.metadata,se.internalMetadata?Le.to(se.internalMetadata):void 0)}Re.to=Se})(pt=e.NotebookCellData||(e.NotebookCellData={}));var gt;(function(Re){function Ne(se){return{mime:se.mime,valueBytes:A.VSBuffer.wrap(se.data)}}Re.from=Ne;function Se(se){return new o.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Re.to=Se})(gt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(Re){function Ne(se){return{outputId:se.id,items:se.items.map(gt.from),metadata:se.metadata}}Re.from=Ne;function Se(se){const Fe=se.items.map(gt.to);return new o.NotebookCellOutput(Fe,se.outputId,se.metadata)}Re.to=Se})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Re){function Ne(Fe){return se(Fe)?{include:(0,v.withNullAsUndefined)(z.from(Fe.include)),exclude:(0,v.withNullAsUndefined)(z.from(Fe.exclude))}:(0,v.withNullAsUndefined)(z.from(Fe))}Re.from=Ne;function Se(Fe){return se(Fe)?{include:z.to(Fe.include),exclude:z.to(Fe.exclude)}:z.to(Fe)}Re.to=Se;function se(Fe){const He=Fe;return He?!(0,v.isUndefinedOrNull)(He.include)&&!(0,v.isUndefinedOrNull)(He.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Re){function Ne(Se,se,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(He,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Ne})(tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Re){function Ne(Se,se,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(He,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Ne})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var At;(function(Re){function Ne(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Ne})(At=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Kt;(function(Re){function Ne(se){return{uri:se.uri,provides:se.provides}}Re.from=Ne;function Se(se){return new o.NotebookRendererScript(T.URI.revive(se.uri),se.provides)}Re.to=Se})(Kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(Re){function Ne(se){return{message:M.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:l.from(se.location.range),uri:se.location.uri}}}Re.from=Ne;function Se(se){const Fe=new o.TestMessage(typeof se.message=="string"?se.message:M.to(se.message));return Fe.actualOutput=se.actual,Fe.expectedOutput=se.expected,Fe.location=se.location?ve.to(se.location):void 0,Fe}Re.to=Se})(Rt=e.TestMessage||(e.TestMessage={}));var mt;(function(Re){Re.namespace=g.namespaceTestTag,Re.denamespace=g.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var Tt;(function(Re){function Ne(se){const Fe=(0,f.getPrivateApiFor)(se).controllerId;return{extId:y.TestId.fromExtHostTestItem(se,Fe).toString(),label:se.label,uri:T.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(He=>mt.namespace(Fe,He.id)),range:E.Range.lift(l.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&M.fromStrict(se.error)||null}}Re.from=Ne;function Se(se){return{parent:void 0,error:void 0,id:y.TestId.fromString(se.extId).localId,label:se.label,uri:T.URI.revive(se.uri),tags:(se.tags||[]).map(Fe=>{const{tagId:He}=mt.denamespace(Fe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Re.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Re){function Ne(se){return{id:se.id}}Re.from=Ne;function Se(se){return new o.TestTag(se.id)}Re.to=Se}(mt=e.TestTag||(e.TestTag={}));var $t;(function(Re){const Ne=(se,Fe)=>{const He=[];for(const[je,it]of Fe)y.TestId.compare(it.item.extId,je)===2&&(Fe.delete(je),He.push(it));const _e={...Tt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Rt.to)})),children:He.map(je=>Ne(je,Fe))};for(const je of _e.children)je.parent=_e;return _e};function Se(se){const Fe=[],He=new Map;for(const _e of se.items){He.set(_e.item.extId,_e);const je=y.TestId.root(_e.item.extId);se.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(_e.item.extId))&&Fe.push(_e)}return{completedAt:se.completedAt,results:Fe.map(_e=>Ne(_e,He))}}Re.to=Se})($t=e.TestResults||(e.TestResults={}));var Nt;(function(Re){function Ne(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?h.from(He):l.from(He)}function se(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=se;function Fe(He){return{uri:He.uri,statement:Ne(He.statementCoverage),branch:He.branchCoverage&&Ne(He.branchCoverage),function:He.functionCoverage&&Ne(He.functionCoverage),details:He.detailedCoverage?.map(se)}}Re.fromFile=Fe})(Nt=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Re){function Ne(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Ne})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Re){function Ne(se){const Fe=new o.TypeHierarchyItem(Q.to(se.kind),se.name,se.detail||"",T.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Re.to=Ne;function Se(se,Fe,He){if(Fe=Fe??se._sessionId,He=He??se._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:Q.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Re.from=Se})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(Re){function Ne(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Ne})(Ut=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Re){function Ne(He,_e,je){const it=_e.fileData;return it?new class extends o.DataTransferItem{asFile(){return{name:it.name,uri:T.URI.revive(it.uri),data:(0,R.once)(()=>je())}}}("",_e.id):He===L.Mimes.uriList&&_e.uriListData?new o.DataTransferItem(Fe(_e.uriListData)):new o.DataTransferItem(_e.asString)}Re.to=Ne;async function Se(He,_e){const je=await _e.asString();if(He===L.Mimes.uriList)return{id:_e.id,asString:je,fileData:void 0,uriListData:se(je)};const it=_e.asFile();return{id:_e.id,asString:je,fileData:it?{name:it.name,uri:it.uri}:void 0}}Re.from=Se;function se(He){return u.UriList.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return T.URI.parse(_e)}catch{}return _e})}function Fe(He){return u.UriList.create(He.map(_e=>typeof _e=="string"?_e:T.URI.revive(_e)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Re){function Ne(se,Fe){const He=se.items.map(([_e,je])=>[_e,Wt.to(_e,je,()=>Fe(je.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Ne;async function Se(se){const Fe={items:[]},He=[];return se.forEach((_e,je)=>{He.push((async()=>{Fe.items.push([je,await Wt.from(je,_e)])})())}),await Promise.all(He),Fe}Re.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[239],De([1,0,2,11,7,14,67]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(I,L,k,v={timeout:1500,errors:3}){this.c=I,this.d=L,this.f=k,this.g=v,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(L,k,v)=>{const E={dispose:this.a.push([L,k,I])};return Array.isArray(v)&&v.push(E),E}}async $participateInSave(I,L){const k=c.URI.revive(I);let v=!1;const T=setTimeout(()=>v=!0,this.g.timeout),E=[];try{for(const m of[...this.a]){if(v)break;const d=this.d.getDocument(k),f=await this.h(m,{document:d,reason:R.TextDocumentSaveReason.to(L)});E.push(f)}}finally{clearTimeout(T)}return E}h([I,L,k],v){const T=this.b.get(I);return typeof T=="number"&&T>this.g.errors?Promise.resolve(!1):this.i(k,I,L,v).then(()=>!0,E=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,L,k,v){const T=[],E=Date.now(),{document:m,reason:d}=v,{version:f}=m,p=Object.freeze({document:m,reason:d,waitUntil(b){if(Object.isFrozen(T))throw(0,A.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(b))}});try{L.apply(k,[p])}catch(b){return Promise.reject(b)}return Object.freeze(T),new Promise((b,y)=>{const g=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(T).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(g),b(i)}).catch(i=>{clearTimeout(g),y(i)})}).then(b=>{const y={edits:[]};for(const g of b)if(Array.isArray(g)&&g.every(i=>i instanceof u.TextEdit))for(const{newText:i,newEol:o,range:s}of g)y.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:i,eol:o&&R.EndOfLine.from(o)}});if(y.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[240],De([1,0,16,2,14,7,92]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(k,v,T,E){this.start=k,this.deletedCount=v,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,v,T){this.notebook=k,this.h=v,this.j=T,this.handle=T.handle,this.uri=A.URI.revive(T.uri),this.cellKind=T.cellKind,this.a=T.outputs.map(u.NotebookCellOutput.to),this.e=T.internalMetadata??{},this.b=Object.freeze(T.metadata??{}),this.d=Object.freeze(u.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:u.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return k.g},set mime(E){k.g=E},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(T)}return this.f}setOutputs(k){this.a=k.map(u.NotebookCellOutput.to)}setOutputItems(k,v,T){const E=T.map(u.NotebookCellOutputItem.to),m=this.a.find(d=>d.id===k);if(m&&(v||(m.items.length=0),m.items.push(...E),m.items.length>1&&m.items.every(d=>C.isTextStreamMime(d.mime)))){const d=new Map,f=[];m.items.forEach(p=>{let b;d.has(p.mime)?b=d.get(p.mime):(b=[],d.set(p.mime,b),f.push(p.mime)),b.push(p.data)}),m.items.length=0,f.forEach(p=>{const b=C.compressOutputItemStreams(d.get(p));m.items.push({mime:p,data:b.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(u.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=S;class I{constructor(k,v,T,E,m){this.k=k,this.l=v,this.m=T,this.uri=E,this.handle=I.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=m.viewType,this.f=Object.freeze(m.metadata??Object.create(null)),this.r([[0,0,m.cells]],!0,void 0),this.g=m.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const k=this,v={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===c.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(T){return T=k.n(T),k.b[T].apiCell},getCells(T){return(T?k.p(T):k.b).map(m=>m.apiCell)},save(){return k.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,v,T){this.g=k.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},m=[];for(const f of k.rawEvents)f.kind===C.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,E.contentChanges):f.kind===C.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,E.contentChanges):f.kind===C.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),m.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),m.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),m.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===C.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),m.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),m.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const d=new Map;for(let f=0;f<m.length;f++){const p=m[f],b=d.get(p.cell);if(b===void 0){const y=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});d.set(p.cell,y-1)}else E.cellChanges[b]={...E.cellChanges[b],...p}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let v=k.start|0,T=k.end|0;return v<0&&(v=0),T>this.b.length&&(T=this.b.length),k.with({start:v,end:T})}p(k){k=this.o(k);const v=[];for(let T=k.start;T<k.end;T++)v.push(this.b[T]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,v,T){if(this.j)return;const E=[],m=[],d=[];if(k.reverse().forEach(f=>{const b=f[2].map(i=>{const o=new S(this,this.l,i);return v||m.push(S.asModelAddData(this.apiNotebook,i)),o}),y=new P(f[0],f[1],[],b),g=this.b.splice(f[0],f[1],...b);for(const i of g)d.push(i.uri),y.deletedItems.push(i.apiCell);E.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:d}),T)for(const f of E)T.push(f.asApiEvent())}s(k,v,T,E){const m=this.b.splice(k,v);this.b.splice(T,0,...m);const d=[new P(k,v,m.map(f=>f.apiCell),[]),new P(T,0,[],m)];for(const f of d)E.push(f.asApiEvent())}t(k,v){this.b[k].setOutputs(v)}u(k,v,T,E){this.b[k].setOutputItems(v,T,E)}v(k,v){const T=this.b[k];T.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(T.uri,v)}w(k,v){const T=this.b[k];T.apiCell.mime=v}x(k,v){this.b[k].setMetadata(v)}y(k,v){this.b[k].setInternalMetadata(v)}getCellFromApiCell(k){return this.b.find(v=>v.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(v=>v.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}I.a=0,e.ExtHostNotebookDocument=I}),define(ye[136],De([1,0,11,14,7]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(P,S,I,L,k,v){this.id=P,this.f=S,this.notebookData=I,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=L,this.c=v}get apiEditor(){if(!this.e){const P=this;this.e={get notebook(){return P.notebookData.apiNotebook},get selection(){return P.a[0]},set selection(S){this.selections=[S]},get selections(){return P.a},set selections(S){if(!Array.isArray(S)||!S.every(u.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");P.a=S,P.g(S)},get visibleRanges(){return P.b},revealRange(S,I){P.f.$tryRevealRange(P.id,A.NotebookRange.from(S),I??u.NotebookEditorRevealType.Default)},get viewColumn(){return P.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(P){this.d=P}_acceptVisibleRanges(P){this.b=P}_acceptSelections(P){this.a=P}g(P){this.f.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this.c=P}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(ye[241],De([1,0,3,13,14]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(P,S){this.c=P,this.d=S,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(P,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,S);const I=this.d.getEditorById(P);S.visibleRanges&&I._acceptVisibleRanges(S.visibleRanges.ranges.map(u.NotebookRange.to)),S.selections&&I._acceptSelections(S.selections.selections.map(u.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const S in P)this.d.getEditorById(S)._acceptViewColumn(u.ViewColumn.to(P[S]))}};R=qe([We(0,A.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[242],De([1,0,14,126,178,21,63,11]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,T,E){const m=this.b++,{title:d,location:f,cancellable:p}=T,b={label:(0,u.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(m,{location:c.ProgressLocation.from(f),title:d,source:b,cancellable:p},v.isUnderDevelopment?void 0:v.identifier.value).catch(P.onUnexpectedExternalError),this.d(m,E,!!p)}d(v,T,E){let m;E&&(m=new R.CancellationTokenSource,this.c.set(v,m));const d=p=>{this.a.$progressEnd(p),this.c.delete(p),m?.dispose()};let f;try{f=T(new L(this.a,v),E&&m?m.token:R.CancellationToken.None)}catch(p){throw d(v),p}return f.then(p=>d(v),p=>d(v)),f}$acceptProgressCanceled(v){const T=this.c.get(v);T&&(T.cancel(),this.c.delete(v))}}e.ExtHostProgress=S;function I(k,v){return k.message=v.message,typeof v.increment=="number"&&(typeof k.increment=="number"?k.increment+=v.increment:k.increment=v.increment),k}class L extends A.Progress{constructor(v,T){super(E=>this.throttledReport(E)),this.c=v,this.d=T}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,C.throttle)(100,(k,v)=>I(k,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],De([1,0,33,132,58,93,76,14,2]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(b,y,g,i)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!g(o,s)){const l=o;o=s,b.listener?.(i(s,l))}}}},L=(b,y)=>b===y,k={range:(b,y)=>b===y?!0:!b||!y?!1:b.isEqual(y),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,y)=>!(b.length!==y.length||b.some(g=>!y.find(i=>g.id===i.id)))},v=b=>y=>({op:4,update:b(y)}),T=(b,y)=>({range:(()=>{let g;const i=v(o=>({range:c.Range.lift(P.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return g},set(o){b.listener?.({op:6}),k.range(g,o)||(g=o,b.listener?.(i(o)))}}})(),label:I(b,y,k.label,v(g=>({label:g}))),description:I(b,void 0,k.description,v(g=>({description:g}))),sortText:I(b,void 0,k.sortText,v(g=>({sortText:g}))),canResolveChildren:I(b,!1,k.canResolveChildren,g=>({op:2,state:g})),busy:I(b,!1,k.busy,v(g=>({busy:g}))),error:I(b,void 0,k.error,v(g=>({error:P.MarkdownString.fromStrict(g)||null}))),tags:I(b,[],k.tags,(g,i)=>({op:1,new:g.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),E=b=>{const y=u.TestId.fromString(b.extId),g=new d(y.controllerId,y.localId,b.label,S.URI.revive(b.uri)||void 0);return g.range=P.Range.to(b.range||void 0),g.description=b.description||void 0,g.sortText=b.sortText||void 0,g.tags=b.tags.map(i=>P.TestTag.to({id:(0,C.denamespaceTestTag)(i).tagId})),g},m=b=>{let y;for(const g of b.tests){const i=E(g.item);(0,A.getPrivateApiFor)(i).parent=y,y=i}return y};e.toItemFromContext=m;class d{constructor(y,g,i,o){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const s=(0,A.createPrivateApiFor)(this,y);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,A.getPrivateApiFor,d),enumerable:!0,writable:!1},...T(s,i)})}}e.TestItemImpl=d;class f extends d{constructor(y,g){super(y,y,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class p extends R.TestItemCollection{constructor(y,g,i){super({controllerId:y,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new f(y,g),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ye[138],De([1,0,50,11,101,14,7]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(v,T,E){const m=P.c.nextId();v.$registerTextEditorDecorationType(T.identifier,m,R.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:m,dispose(){v.$removeTextEditorDecorationType(m)}})}}P.c=new u.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class S{constructor(v,T){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=T.undoStopBefore,this.f=T.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,T){this.k();let E=null;if(v instanceof C.Position)E=new C.Range(v,v);else if(v instanceof C.Range)E=v;else throw new Error("Unrecognized location");this.l(E,T,!1)}insert(v,T){this.k(),this.l(new C.Range(v,v),T,!0)}delete(v){this.k();let T=null;if(v instanceof C.Range)T=v;else throw new Error("Unrecognized location");this.l(T,null,!0)}l(v,T,E){const m=this.c.validateRange(v);this.g.push({range:m,text:T,forceMoveMarkers:E})}setEndOfLine(v){if(this.k(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=v}}class I{constructor(v,T,E,m){this.c=v,this.d=T,this._accept(E),this.e=m;const d=this;this.value={get tabSize(){return d.f},set tabSize(f){d.m(f)},get indentSize(){return d.g},set indentSize(f){d.o(f)},get insertSpaces(){return d.h},set insertSpaces(f){d.q(f)},get cursorStyle(){return d.j},set cursorStyle(f){d.s(f)},get lineNumbers(){return d.k},set lineNumbers(f){d.t(f)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const T=Math.floor(v);return T>0?T:null}if(typeof v=="string"){const T=parseInt(v,10);return isNaN(T)?null:T>0?T:null}return null}m(v){const T=this.l(v);if(T!==null){if(typeof T=="number"){if(this.f===T)return;this.f=T}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:T}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const T=Math.floor(v);return T>0?T:null}if(typeof v=="string"){const T=parseInt(v,10);return isNaN(T)?null:T>0?T:null}return null}o(v){const T=this.n(v);if(T!==null){if(typeof T=="number"){if(this.g===T)return;this.g=T}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:T}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const T=this.p(v);if(typeof T=="boolean"){if(this.h===T)return;this.h=T}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:T}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const T={};let E=!1;if(typeof v.tabSize<"u"){const m=this.l(v.tabSize);m==="auto"?(E=!0,T.tabSize=m):typeof m=="number"&&this.f!==m&&(this.f=m,E=!0,T.tabSize=m)}if(typeof v.indentSize<"u"){const m=this.n(v.indentSize);m==="tabSize"?(E=!0,T.indentSize=m):typeof m=="number"&&this.g!==m&&(this.g=m,E=!0,T.indentSize=m)}if(typeof v.insertSpaces<"u"){const m=this.p(v.insertSpaces);m==="auto"?(E=!0,T.insertSpaces=m):this.h!==m&&(this.h=m,E=!0,T.insertSpaces=m)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,E=!0,T.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,E=!0,T.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),E&&this.u("setOptions",this.c.$trySetOptions(this.d,T))}u(v,T){T.catch(E=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(E)})}}e.ExtHostTextEditorOptions=I;class L{constructor(v,T,E,m,d,f,p,b){this.id=v,this.j=T,this.k=E,this.g=!1,this.h=new Set,this.c=d,this.d=new I(this.j,this.id,f,E),this.e=p,this.f=b;const y=this;this.value=Object.freeze({get document(){return m.value},set document(g){throw(0,A.readonly)("document")},get selection(){return y.c&&y.c[0]},set selection(g){if(!(g instanceof C.Selection))throw(0,A.illegalArgument)("selection");y.c=[g],y.l()},get selections(){return y.c},set selections(g){if(!Array.isArray(g)||g.some(i=>!(i instanceof C.Selection)))throw(0,A.illegalArgument)("selections");y.c=g,y.l()},get visibleRanges(){return y.e},set visibleRanges(g){throw(0,A.readonly)("visibleRanges")},get options(){return y.d.value},set options(g){y.g||y.d.assign(g)},get viewColumn(){return y.f},set viewColumn(g){throw(0,A.readonly)("viewColumn")},edit(g,i={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(m.value,i);return g(o),y.m(o)},insertSnippet(g,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=y.c.map(l=>R.Range.from(l));else if(i instanceof C.Position){const{lineNumber:l,column:r}=R.Position.from(i);s=[{startLineNumber:l,startColumn:r,endLineNumber:l,endColumn:r}]}else if(i instanceof C.Range)s=[R.Range.from(i)];else{s=[];for(const l of i)if(l instanceof C.Range)s.push(R.Range.from(l));else{const{lineNumber:r,column:h}=R.Position.from(l);s.push({startLineNumber:r,startColumn:h,endLineNumber:r,endColumn:h})}}return T.$tryInsertSnippet(v,m.value.version,g.value,s,o)},setDecorations(g,i){const o=i.length===0;o&&!y.h.has(g.key)||(o?y.h.delete(g.key):y.h.add(g.key),y.n(()=>{if(R.isDecorationOptionsArr(i))return T.$trySetDecorations(v,g.key,R.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let l=0,r=i.length;l<r;l++){const h=i[l];s[4*l]=h.start.line+1,s[4*l+1]=h.start.character+1,s[4*l+2]=h.end.line+1,s[4*l+3]=h.end.character+1}return T.$trySetDecorationsFast(v,g.key,s)}}))},revealRange(g,i){y.n(()=>T.$tryRevealRange(v,R.Range.from(g),i||C.TextEditorRevealType.Default))},show(g){T.$tryShowEditor(v,R.ViewColumn.from(g))},hide(){T.$tryHideEditor(v)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,c.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,c.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,c.ok)(!this.g),this.f=v}_acceptSelections(v){(0,c.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const T=v.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(d=>d.range);E.sort((d,f)=>d.end.line===f.end.line?d.end.character===f.end.character?d.start.line===f.start.line?d.start.character-f.start.character:d.start.line-f.start.line:d.end.character-f.end.character:d.end.line-f.end.line);for(let d=0,f=E.length-1;d<f;d++){const p=E[d].end;if(E[d+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=T.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,T.documentVersionId,m,{setEndOfLine:typeof T.setEndOfLine=="number"?R.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this.k.warn(T),null))}}e.ExtHostTextEditor=L}),define(ye[243],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[244],De([1,0,194,11,37,123,91,39,26,243,207,196]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=P.Registry.as(C.Extensions.JSONContribution);class T{constructor(g,i,o){this.a=g,this.b=i,this.c=o}d(g,i){this.a({type:g,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(u.default.Error,g)}warn(g){this.d(u.default.Warning,g)}info(g){this.d(u.default.Info,g)}}e.ExtensionMessageCollector=T;class E{static a(g){const i=new Set;for(let o=0,s=g.length;o<s;o++)i.add(S.ExtensionIdentifier.toKey(g[o].description.identifier));return i}static compute(g,i){if(!g||!g.length)return new E(i,[]);if(!i||!i.length)return new E([],g);const o=this.a(g),s=this.a(i),l=i.filter(h=>!o.has(S.ExtensionIdentifier.toKey(h.description.identifier))),r=g.filter(h=>!s.has(S.ExtensionIdentifier.toKey(h.description.identifier)));return new E(l,r)}constructor(g,i){this.added=g,this.removed=i}}e.ExtensionPointUserDelta=E;class m{constructor(g,i){this.name=g,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=E.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,A.onUnexpectedError)(g)}}}e.ExtensionPoint=m;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const i=new m(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,i),g.activationEventsGenerator&&k.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,v.registerSchema(f,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=P.Registry.as(b.ExtensionsRegistry),v.registerSchema(f,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(ye[245],De([1,0,191,10,23,244,55,3]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var I;(function(v){function T(E,m,d){if(!E)return;const f=A.isString(E.type)?E.type:void 0;if(!f||f.length===0){d.error(c.localize(3,null));return}const p=[];if(Array.isArray(E.required))for(const b of E.required)A.isString(b)&&p.push(b);return{extensionId:m.value,taskType:f,required:p,properties:E.properties?u.deepClone(E.properties):{},when:E.when?C.ContextKeyExpr.deserialize(E.when):void 0}}v.from=T})(I||(I={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class k{constructor(){this.d=new P.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((T,E)=>{L.setHandler((m,d)=>{this.c=void 0;try{for(const f of d.removed){const p=f.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const f of d.added){const p=f.value;for(const b of p){const y=I.from(b,f.description.identifier,f.collector);y&&(this.a[y.taskType]=y)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}T(void 0)})})}onReady(){return this.b}get(T){return this.a[T]}all(){return Object.keys(this.a).map(T=>this.a[T])}getJsonSchema(){if(this.c===void 0){const T=[];for(const E of this.all()){const m={type:"object",additionalProperties:!1};E.required.length>0&&(m.required=E.required.slice(0)),E.properties!==void 0?m.properties=u.deepClone(E.properties):m.properties=Object.create(null),m.properties.type={type:"string",enum:[E.taskType]},T.push(m)}this.c={oneOf:T}}return this.c}}e.TaskDefinitionRegistry=new k}),define(ye[246],De([1,0,192,10,24,23,55,245]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(S=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(O){function U(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var T;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function B(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(E=e.RuntimeType||(e.RuntimeType={}));var m;(function(O){function U(B){return A.isString(B)?B:B.value}O.value=U})(m=e.CommandString||(e.CommandString={}));var d;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function B(j){if(j!==void 0)return A.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=B})(d=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var p;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var y;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(y=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class i{constructor(U,B,j,de,Y,q){this._label="",this._id=U,B&&(this._label=B),j&&(this.type=j),this.runOptions=de,this.configurationProperties=Y,this._source=q}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,B=!1){if(U===void 0)return!1;if(A.isString(U))return U===this._label||U===this.configurationProperties.identifier||B&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class o extends i{constructor(U,B,j,de,Y,q,Q,Z){super(U,j,void 0,Q,Z,B),this.command={},this._source=B,this.hasDefinedMatchers=q,Y&&(this.command=Y)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case E.Shell:B="shell";break;case E.Process:B="process";break;case E.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(U){return U instanceof o}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let B=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(B+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:B};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new o(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=o;class s extends i{constructor(U,B,j,de,Y,q,Q){super(U,j,de,q,Q,B),this._source=B,this.configures=Y}static is(U){return U instanceof s}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let B=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(B+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:B};return JSON.stringify(j)}}e.ConfiguringTask=s;class l extends i{constructor(U,B,j,de,Y,q,Q,Z,te){super(U,j,de,Z,te,B),this.defines=Y,this.hasDefinedMatchers=Q,this.command=q,this.icon=te.icon,this.hide=te.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof l}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new l(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=l;class r extends i{constructor(U,B,j,de,Y,q){super(U,j,de,Y,q,B),this._source=B}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new r(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=r;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(h=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(U){this.c=new Map;for(let B=0;B<U.length;B++)this.c.set(U[B].uri.toString(),B)}compare(U,B){const j=U.getWorkspaceFolder(),de=B.getWorkspaceFolder();if(j&&de){let Y=this.c.get(j.uri.toString());Y=Y===void 0?0:Y+1;let q=this.c.get(de.uri.toString());return q=q===void 0?0:q+1,Y===q?U._label.localeCompare(B._label):Y-q}else return!j&&de?-1:j&&!de?1:0}}e.TaskSorter=t;var a;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(a=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(O){O.SingleRun="singleRun",O.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var D;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(D=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(O){function U(B,j,de,Y){if(j){const q={kind:B,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:j};return B==="start"?q.resolvedVariables=Y:B==="processStarted"?q.processId=Y:B==="processEnded"&&(q.exitCode=Y),Object.freeze(q)}else return Object.freeze({kind:"changed"})}O.create=U})(F=e.TaskEvent||(e.TaskEvent={}));var x;(function(O){function U(j){const de=Object.keys(j).sort();let Y="";for(const q of de){let Q=j[q];Q instanceof Object?Q=U(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),Y+=q+","+Q+","}return Y}function B(j){const Y={_key:U(j),type:j.taskType};return Object.assign(Y,j),Y}O.create=B})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(O){function U(B,j){const de=P.TaskDefinitionRegistry.get(B.type);if(de===void 0){const Z=R.deepClone(B);return delete Z._key,x.create(Z)}const Y=Object.create(null);Y.type=de.taskType;const q=new Set;de.required.forEach(Z=>q.add(Z));const Q=de.properties;for(const Z of Object.keys(Q)){const te=B[Z];if(te!=null)Y[Z]=te;else if(q.has(Z)){const X=Q[Z];if(X.default!==void 0)Y[Z]=R.deepClone(X.default);else switch(X.type){case"boolean":Y[Z]=!1;break;case"number":case"integer":Y[Z]=0;break;case"string":Y[Z]="";break;default:j.error(c.localize(2,null,JSON.stringify(B,void 0,0),Z));return}}}return x.create(Y)}O.createTaskIdentifier=U})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[247],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,P)=>{this.b=C,this.d=P,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,c.onUnexpectedError)(C))}then(C,P){return this.j().then(C,P)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=A;class u extends A{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=u}),define(ye[59],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}c.count=0,e.ProxyIdentifier=c;const A=[];function u(P){const S=new c(P);return A[S.nid]=S,S}e.createProxyIdentifier=u;function R(P){return A[P].sid}e.getStringIdentifierForProxy=R;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(ye[5],De([1,0,59]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var u;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(u=e.TabInputKind||(e.TabInputKind={}));var R;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(d){return d._id=k.a++,d}}k.a=0,e.IdObject=k;var v;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[77],De([1,0,4,13,5,18]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,I){this.c=I,this.a=new Set,this.b=S.getProxy(u.MainContext.MainThreadTelemetry)}report(S,I,L){const k=this.d(S,I);this.a.has(k)||(this.a.add(k),I.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:S}))}d(S,I){return`${S}-${I.identifier.value}`}};C=qe([We(0,R.IExtHostRpcService),We(1,A.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,I){}})}),define(ye[248],De([1,0,3,5,7,26]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,I,L,k={}){const v=R.ExtensionIdentifier.toKey(S.identifier),T=this.f.get(v)||[],E=[...L].sort().join(" ");let m=T.find(d=>d.providerId===I&&d.scopes===E);if(m)return m.result;{const d=this.g(S,v,I,L,k);m={providerId:I,scopes:E,result:d},T.push(m),this.f.set(v,T);try{await d}finally{const f=T.findIndex(p=>p.providerId===I&&p.scopes===E);f>-1&&(T.splice(f),this.f.set(v,T))}return d}}async g(S,I,L,k,v={}){await this.a.$ensureProvider(L);const T=S.displayName||S.name;return this.a.$getSession(L,k,I,T,v)}async removeSession(S,I){const L=this.b.get(S);return L?L.provider.removeSession(I):this.a.$removeSession(S,I)}registerAuthenticationProvider(S,I,L,k){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:I,provider:L,options:k??{supportsMultipleAccounts:!1}}),this.c.find(T=>T.id===S)||this.c.push({id:S,label:I});const v=L.onDidChangeSessions(T=>{this.a.$sendDidChangeSessions(S,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this.a.$registerAuthenticationProvider(S,I,k?.supportsMultipleAccounts??!1),new u.Disposable(()=>{v.dispose(),this.b.delete(S);const T=this.c.findIndex(E=>E.id===S);T>-1&&this.c.splice(T),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,I){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,I){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,I){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,I){return this.d.fire({provider:{id:S,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ye[249],De([1,0,5,18,14]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(P,S){this.a=P.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>S.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,S,I){const L=u.WorkspaceEdit.from(P,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,I?.isRefactoring??!1)}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[250],De([1,0,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const C=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(P){return C.$writeText(P)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[40],De([1,0,10,7,14,23,5,15,13,70,33,53,2,6,4,18,137,22,59,45,43,74]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(a,w){i.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),Je(this,i,a.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=w,Je(this,o,a.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,D=>{const F=this.c.get(D);return F?.result===h.Void?F:void 0},w),this.f=[{processArgument(D){return(0,I.revive)(D)}},{processArgument(D){return(0,R.cloneAndChange)(D,function(F){if(L.Range.isIRange(F))return u.Range.to(F);if(k.Position.isIPosition(F))return u.Position.to(F);if(L.Range.isIRange(F.range)&&v.URI.isUri(F.uri))return u.location.to(F);if(F instanceof f.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(a){this.f.push(a)}registerApiCommand(a){const w=this.registerCommand(!1,a.id,async(...D)=>{const F=a.args.map((V,M)=>{if(!V.validate(D[M]))throw new Error(`Invalid argument '${V.name}' when running '${a.id}', received: ${D[M]}`);return V.convert(D[M])}),x=await this.executeCommand(a.internalId,...F);return a.result.convert(x,D,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this.c.set(a.id,a),new A.Disposable(()=>{w.dispose(),this.c.delete(a.id)})}registerCommand(a,w,D,F,x,V){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:D,thisArg:F,description:x,extension:V}),a&&Be(this,i,"f").$registerCommand(w),new A.Disposable(()=>{this.b.delete(w)&&a&&Be(this,i,"f").$unregisterCommand(w)})}executeCommand(a,...w){return this.d.trace("ExtHostCommands#executeCommand",a),this.g(a,w,!0)}async g(a,w,D){if(this.b.has(a))return Be(this,i,"f").$fireCommandActivationEvent(a),this.h(a,w,!1);{let F=!1;const x=(0,R.cloneAndChange)(w,function(V){if(V instanceof A.Position)return u.Position.from(V);if(V instanceof A.Range)return u.Range.from(V);if(V instanceof A.Location)return u.location.from(V);if(A.NotebookRange.isNotebookRange(V))return u.NotebookRange.from(V);if(V instanceof ArrayBuffer)return F=!0,f.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return F=!0,f.VSBuffer.wrap(V);if(V instanceof f.VSBuffer)return F=!0,V;if(!Array.isArray(V))return V});try{const V=await Be(this,i,"f").$executeCommand(a,F?new p.SerializableObjectWithBuffers(x):x,D);return(0,I.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(a,w,!1);throw V}}}async h(a,w,D){const F=this.b.get(a);if(!F)throw new Error("Unknown command");const{callback:x,thisArg:V,description:M}=F;if(M)for(let O=0;O<M.args.length;O++)try{(0,c.validateConstraint)(w[O],M.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${M.args[O].name}' - ${M.args[O].description}`)}const $=y.StopWatch.create();try{return await x.apply(V,w)}catch(O){if(a===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...w);U&&(a=U.command)}throw this.d.error(O,a,F.extension?.identifier),D?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=a,this.source=F.extension?.displayName??F.extension?.name}}:O}finally{this.j(F,a,$.elapsed())}}j(a,w,D){!a.extension||Be(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:a.extension.identifier.value,id:new g.TelemetryTrustedValue(w),duration:D})}$executeContributedCommand(a,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",a);const D=this.b.get(a);return D?(w=w.map(F=>this.f.reduce((x,V)=>V.processArgument(x,D.extension?.identifier),F)),this.h(a,w,!0)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this.d.trace("ExtHostCommands#getCommands",a),Be(this,i,"f").$getCommands().then(w=>(a&&(w=w.filter(D=>D[0]!=="_")),w))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(const[w,D]of this.b){const{description:F}=D;F&&(a[w]=F)}return Promise.resolve(a)}};i=new WeakMap,o=new WeakMap,s=qe([We(0,m.IExtHostRpcService),We(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class l{constructor(a,w,D){this.d=a,this.f=w,this.g=D,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(a,w){if(!a)return;const D={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return D;const F=this.f(a.command);if(F)D.id=F.internalId,D.arguments=F.args.map((x,V)=>x.convert(a.arguments&&a.arguments[V]));else if((0,P.isNonEmptyArray)(a.arguments)){const x=`${a.command}/${++this.c}`;this.b.set(x,a),w.add((0,T.toDisposable)(()=>{this.b.delete(x),this.g.trace("CommandsConverter#DISPOSE",x)})),D.$ident=x,D.id=this.delegatingCommandId,D.arguments=[x],this.g.trace("CommandsConverter#CREATE",a.command,x)}return D}fromInternal(a){return typeof a.$ident=="string"?this.b.get(a.$ident):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this.b.get(a[0])}h(...a){const w=this.getActualCommand(...a);return this.g.trace("CommandsConverter#EXECUTE",a[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${a[0]}`)}}e.CommandsConverter=l;class r{constructor(a,w,D,F){this.name=a,this.description=w,this.validate=D,this.convert=F}optional(){return new r(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,w){return new r(a??this.name,w??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",t=>v.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>A.Position.isPosition(t),u.Position.from),r.Range=new r("range","A range in a text document",t=>A.Range.isRange(t),u.Range.from),r.Selection=new r("selection","A selection in a text document",t=>A.Selection.isSelection(t),u.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof A.CallHierarchyItem,u.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof A.TypeHierarchyItem,u.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,u.TestItem.from),e.ApiCommandArgument=r;class h{constructor(a,w){this.description=a,this.convert=w}}h.Void=new h("no result",t=>t),e.ApiCommandResult=h;class n{constructor(a,w,D,F,x){this.id=a,this.internalId=w,this.description=D,this.args=F,this.result=x}}e.ApiCommand=n}),define(ye[251],De([1,0,2,14,7,72,40,15,120,125,16]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(A.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,d)=>{if((0,P.isFalsyOrEmpty)(m))return;class f extends u.SymbolInformation{static to(b){const y=new f(b.name,A.SymbolKind.to(b.kind),b.containerName||"",new u.Location(d[0],A.Range.to(b.range)));return y.detail=b.detail,y.range=y.location.range,y.selectionRange=A.Range.to(b.selectionRange),y.children=b.children?b.children.map(f.to):[],y}}return m.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(A.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(A.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new C.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(A.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(A.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(A.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(d=>u.Position.isPosition(d)),m=>m.map(A.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(d=>{let f;for(const p of d.reverse())f=new u.SelectionRange(A.Range.to(p),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(A.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",m=>m.map(A.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",m=>m.map(A.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",m=>m.map(A.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:A.Range.to(m.range),placeholder:m.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return A.WorkspaceEdit.to(m)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(A.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new u.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const d=(0,S.decodeSemanticTokensDto)(m);if(d.type==="full")return new u.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new u.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const d=(0,S.decodeSemanticTokensDto)(m);if(d.type==="full")return new u.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,d,f)=>{if(!m)return new u.CompletionList([]);const p=m.suggestions.map(b=>A.CompletionItem.to(b,f));return new u.CompletionList(p,m.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return A.SignatureHelp.to(m)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,d,f)=>T(p=>new u.CodeLens(A.Range.to(p.range),p.command&&f.fromInternal(p.command)))(m))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>u.Range.isRange(m),m=>u.Selection.isSelection(m)?A.Selection.from(m):A.Range.from(m)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,d,f)=>T(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(p.command)}else{const b=new u.CodeAction(p.title,p.kind?new u.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=A.WorkspaceEdit.to(p.edit)),p.command&&(b.command=f.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(m))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(d=>new u.ColorInformation(A.Range.to(d.range),A.Color.to(d.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",m=>m instanceof u.Color,A.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:A.Range.from(m.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(A.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,d,f)=>m.map(A.InlayHint.to.bind(void 0,f)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(d=>A.NotebookExclusiveDocumentPattern.to(d))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(A.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>c.URI.isUri(m)||typeof m=="string"&&(0,I.matchesSomeScheme)(m,L.Schemas.http,L.Schemas.https),m=>m),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[A.ViewColumn.from(m),void 0]:[A.ViewColumn.from(m.viewColumn),A.TextEditorOpenOptions.from(m)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[A.ViewColumn.from(m),void 0]:[A.ViewColumn.from(m.viewColumn),A.TextEditorOpenOptions.from(m)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[A.ViewColumn.from(m.viewColumn),A.TextEditorOpenOptions.from(m)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,m=>m)],C.ApiCommandResult.Void)];class v{static register(d){k.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function T(m){return d=>{if(Array.isArray(d))return d.map(m)}}function E(m){if(!Array.isArray(m))return;const d=[];for(const f of m)R.isLocationLink(f)?d.push(A.DefinitionLink.to(f)):d.push(A.location.to(f));return d}}),define(ye[252],De([1,0,17,63,3,6,2,72,26,14,7,5]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(T,E,m){const d=T.getProxy(k.MainContext.MainThreadComments);class f{constructor(){this.b=new Map,this.c=new Map,E.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const h=this.b.get(r.handle);return h?h.value:r}else if(r&&r.$mid===7){const h=this.b.get(r.commentControlHandle);if(!h)return r;const n=h.getCommentThread(r.commentThreadHandle);return n?n.value:r}else if(r&&(r.$mid===9||r.$mid===8)){const h=this.b.get(r.thread.commentControlHandle);if(!h)return r;const n=h.getCommentThread(r.thread.commentThreadHandle);return n?r.$mid===8?n.value:{thread:n.value,text:r.text}:r}else if(r&&r.$mid===10){const h=this.b.get(r.thread.commentControlHandle);if(!h)return r;const n=h.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.commentUniqueId,a=n.getCommentByUniqueId(t);return a||r}else if(r&&r.$mid===11){const h=this.b.get(r.thread.commentControlHandle);if(!h)return r;const n=h.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.text,a=r.commentUniqueId,w=n.getCommentByUniqueId(a);return w?(typeof w.body=="string"?w.body=t:w.body=new L.MarkdownString(t),w):r}return r}})}createCommentController(r,h,n){const t=f.a++,a=new b(r,t,h,n);this.b.set(a.handle,a);const w=this.c.get(S.ExtensionIdentifier.toKey(r.identifier))||[];return w.push(a),this.c.set(S.ExtensionIdentifier.toKey(r.identifier),w),a.value}$createCommentThreadTemplate(r,h,n){const t=this.b.get(r);!t||t.$createCommentThreadTemplate(h,n)}async $updateCommentThreadTemplate(r,h,n){const t=this.b.get(r);!t||t.$updateCommentThreadTemplate(h,n)}$deleteCommentThread(r,h){this.b.get(r)?.$deleteCommentThread(h)}$provideCommentingRanges(r,h,n){const t=this.b.get(r);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const a=m.getDocument(C.URI.revive(h));return(0,c.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(a,n)).then(w=>w?w.map(D=>I.Range.from(D)):void 0)}$toggleReaction(r,h,n,t,a){const w=this.b.get(r);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const D=w.getCommentThread(h);if(D){const F=D.getCommentByUniqueId(t.uniqueIdInThread);if(w!==void 0&&F&&w.reactionHandler)return w.reactionHandler(F,i(a))}return Promise.resolve(void 0)})}dispose(){}}f.a=0;class p{set threadId(r){this.n=r}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(r){r.isEqual(this.p)||(this.p=r,this.b.range=r,this.c.fire())}get range(){return this.p}set canReply(r){this.d!==r&&(this.d=r,this.b.canReply=r,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(r){this.e=r,this.b.label=r,this.c.fire()}get contextValue(){return this.f}set contextValue(r){this.f=r,this.b.contextValue=r,this.c.fire()}get comments(){return this.q}set comments(r){this.q=r,this.b.comments=r,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(r){this.g=r,this.b.collapsibleState=r,this.c.fire()}get state(){return this.h}set state(r){this.h=r,this.b.state=r,this.c.fire()}get isDisposed(){return this.j}constructor(r,h,n,t,a,w,D,F){this.m=h,this.n=n,this.o=t,this.p=a,this.q=w,this.extensionDescription=D,this.r=F,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new u.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${r}.${this.handle}`),d.$createCommentThread(h,this.handle,this.n,this.o,I.Range.from(this.p),D.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{d.$deleteCommentThread(h,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(V){x.range=V},get comments(){return x.comments},set comments(V){x.comments=V},get collapsibleState(){return x.collapsibleState},set collapsibleState(V){x.collapsibleState=V},get canReply(){return x.canReply},set canReply(V){x.canReply=V},get contextValue(){return x.contextValue},set contextValue(V){x.contextValue=V},get label(){return x.label},set label(V){x.label=V},get state(){return x.state},set state(V){x.state=V},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const r=n=>Object.prototype.hasOwnProperty.call(this.b,n),h={};r("range")&&(h.range=I.Range.from(this.p)),r("label")&&(h.label=this.label),r("contextValue")&&(h.contextValue=this.contextValue??null),r("comments")&&(h.comments=this.q.map(n=>y(this,n,this.k))),r("collapsibleState")&&(h.collapseState=o(this.g)),r("canReply")&&(h.canReply=this.canReply),r("state")&&(h.state=s(this.h)),r("isTemplate")&&(h.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,h)}getCommentByUniqueId(r){for(const h of this.k){const n=h[0],t=h[1];if(r===t)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(r=>r.dispose())}}p.a=0,qe([(0,A.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(r){this.b=r,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(r){this.c=r,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this.d}set options(r){this.d=r,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(r,h,n,t){this.f=r,this.g=h,this.h=n,this.i=t,this.a=new Map,d.$registerCommentController(this.handle,n,t);const a=this;this.value=Object.freeze({id:a.id,label:a.label,get options(){return a.options},set options(w){a.options=w},get commentingRangeProvider(){return a.commentingRangeProvider},set commentingRangeProvider(w){a.commentingRangeProvider=w},get reactionHandler(){return a.reactionHandler},set reactionHandler(w){a.reactionHandler=w},createCommentThread(w,D,F){return a.createCommentThread(w,D,F).value},dispose:()=>{a.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(r,h,n,t){if(typeof r=="string"){const a=new p(this.id,this.handle,r,h,n,t,this.f,!1);return this.a.set(a.handle,a),a}else{const a=new p(this.id,this.handle,void 0,r,h,n,this.f,!1);return this.a.set(a.handle,a),a}}$createCommentThreadTemplate(r,h){const n=new p(this.id,this.handle,void 0,C.URI.revive(r),I.Range.to(h),[],this.f,!0);return n.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(r,h){const n=this.a.get(r);n&&(n.range=I.Range.to(h))}$deleteCommentThread(r){this.a.get(r)?.dispose(),this.a.delete(r)}getCommentThread(r){return this.a.get(r)}dispose(){this.a.forEach(r=>{r.dispose()}),this.e.forEach(r=>r.dispose())}}function y(l,r,h){let n=h.get(r);n||(n=++l.commentHandle,h.set(r,n));const t=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:n,body:typeof r.body=="string"?r.body:I.MarkdownString.from(r.body),userName:r.author.name,userIconPath:t,label:r.label,commentReactions:r.reactions?r.reactions.map(a=>g(a)):void 0,timestamp:r.timestamp?.toJSON()}}function g(l){return{label:l.label,iconPath:l.iconPath?I.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function i(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?C.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function o(l){if(l!==void 0)switch(l){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function s(l){if(l!==void 0)switch(l){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new f}e.createExtHostComments=v}),define(ye[253],De([1,0,23,5,25,18]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(L,k){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,k){const v=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,k,T,arguments)}})}e(L,k,v,T){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(T,this.b)}),this.c&&this.f(L,v,T)}};C=qe([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const P=1e5;function S(I,L){const k=[];if(I.length)for(let v=0;v<I.length;v++){let T=I[v];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}k.push(T)}if(L){const v=new Error().stack;v&&k.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,c.safeStringify)(k);return v.length>P?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,18,13,15,8,9,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(E,m){this.h=m,this.f=new Map,this.g=E.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,m){const d=Mi.c++;this.f.set(d,{provider:E,extensionDescription:m}),this.g.$registerDecorationProvider(d,m.identifier.value);const f=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(d,null);return}const b=(0,S.asArray)(p);if(b.length<=Mi.d){this.g.$onDidChange(d,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,b.length);const y=b.map(o=>({uri:o,rank:(0,I.count)(o.path,"/")})),g=(0,S.groupBy)(y,(o,s)=>o.rank-s.rank||(0,I.compare)(o.uri.path,s.uri.path)),i=[];e:for(const o of g){let s;for(const l of o){const r=(0,L.dirname)(l.uri.path);if(s!==r&&(s=r,i.push(l.uri)>=Mi.d))break e}}this.g.$onDidChange(d,i)});return new u.Disposable(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(E,m,d){if(!this.f.has(E))return Object.create(null);const f=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(E);return await Promise.all(m.map(async y=>{try{const{uri:g,id:i}=y,o=await Promise.resolve(p.provideFileDecoration(c.URI.revive(g),d));if(!o)return;try{u.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,k.checkProposedApiEnabled)(b,"codiconDecoration"),f[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(g){this.h.error(g)}})),f}};v.c=0,v.d=250,v=qe([We(0,C.IExtHostRpcService),We(1,P.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[254],De([1,0,176,124,2,5,7,14,3,13,28,48]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";var v,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(p,b,y,g,i,o,s){this.d=p,this.e=b,this.f=y,this.g=g,v.set(this,void 0),T.set(this,void 0),E.set(this,void 0),this.c=!1,Je(this,E,new L.ResourceMap(l=>i.getComparisonKey(l)),"f"),Je(this,v,o,"f"),Je(this,T,s,"f")}dispose(){this.c||(Be(this,T,"f").fire([...Be(this,E,"f").keys()]),Be(this,v,"f")?.$clear(this.e),Be(this,E,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let y=[];if(u.URI.isUri(p)){if(!b){this.delete(p);return}Be(this,E,"f").set(p,b.slice()),y=[p]}else if(Array.isArray(p)){y=[];let i;p=[...p].sort(m.j);for(const o of p){const[s,l]=o;if((!i||s.toString()!==i.toString())&&(i&&Be(this,E,"f").get(i).length===0&&Be(this,E,"f").delete(i),i=s,y.push(s),Be(this,E,"f").set(s,[])),l)Be(this,E,"f").get(s)?.push(...l);else{const r=Be(this,E,"f").get(s);r&&(r.length=0)}}}if(Be(this,T,"f").fire(y),!Be(this,v,"f"))return;const g=[];for(const i of y){let o=[];const s=Be(this,E,"f").get(i);if(s)if(s.length>this.f){o=[];const l=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const h of s)if(h.severity===l[r]&&o.push({...P.Diagnostic.from(h),modelVersionId:this.g(i)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(l=>({...P.Diagnostic.from(l),modelVersionId:this.g(i)}));g.push([i,o])}Be(this,v,"f").$changeMany(this.e,g)}delete(p){this.h(),Be(this,T,"f").fire([p]),Be(this,E,"f").delete(p),Be(this,v,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Be(this,T,"f").fire([...Be(this,E,"f").keys()]),Be(this,E,"f").clear(),Be(this,v,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[y,g]of this)p.call(b,y,g,this)}*[(v=new WeakMap,T=new WeakMap,E=new WeakMap,Symbol.iterator)](){this.h();for(const p of Be(this,E,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Be(this,E,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Be(this,E,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=m;let d=class pi{static _mapper(p){const b=new L.ResourceMap;for(const y of p)b.set(y,y);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,y,g){this.h=b,this.j=y,this.k=g,this.f=new Map,this.g=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=p.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:y,e:g,g:i,h:o,j:s,k:l}=this,r=new class{$changeMany(t,a){g.$changeMany(t,a),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,t,a.length===0?"CLEARING":a)}$clear(t){g.$clear(t),o.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,t)}dispose(){g.dispose()}};let h;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,h=b;else if(!y.has(b))h=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do h=b+pi.c++;while(y.has(h))}return new class extends m{constructor(){super(b,h,pi.d,t=>l.getDocument(t)?.version,s.extUri,r,i),y.set(h,this)}dispose(){super.dispose(),y.delete(h)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,y=[];for(const g of this.f.values())g.forEach((i,o)=>{let s=b.get(i.toString());typeof s>"u"&&(s=y.length,b.set(i.toString(),s),y.push([i,[]])),y[s][1]=y[s][1].concat(...o)});return y}}l(p){let b=[];for(const y of this.f.values())y.has(p)&&(b=b.concat(y.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",y=new m(b,b,pi.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(b,y),this.m=y}for(const[b,y]of p)this.m.set(u.URI.revive(b),y.map(P.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,I.ILogService),We(2,k.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[255],De([1,0,2,5]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class u{constructor(C){this.a=C.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(P=>P?P.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(P=>P?c.URI.revive(P):void 0)}}e.ExtHostDialogs=u}),define(ye[256],De([1,0,11,2,7,5,16,21,8]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,v,T){this.d=v,this.e=T,this.b=new Map,this.c=k.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,v){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=I.a++;this.b.set(T,v),this.c.$registerTextContentProvider(T,k);let E;return typeof v.onDidChange=="function"&&(E=v.onDidChange(m=>{if(m.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this.d.getDocument(m)&&this.$provideTextDocumentContent(T,m).then(d=>{if(!d&&typeof d!="string")return;const f=this.d.getDocument(m);if(!f)return;const p=(0,S.splitLines)(d);if(!f.equalLines(p))return this.c.$onVirtualDocumentChange(m,d)},c.onUnexpectedError)})),new u.Disposable(()=>{this.b.delete(T)&&this.c.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(k,v){const T=this.b.get(k);return T?Promise.resolve(T.provideTextDocumentContent(A.URI.revive(v),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}I.a=0,e.ExtHostDocumentContentProvider=I}),define(ye[257],De([1,0,3,6,2,5,135,14,10,23,7]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,E){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=T.getProxy(R.MainContext.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(m=>{for(const d of m)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(m=>{for(const d of m)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(T){if(!T)return;const E=this.g.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this.g.getDocument(T);if(E)return Promise.resolve(E);let m=this.h.get(T.toString());return m||(m=this.f.$tryOpenDocument(T).then(d=>{this.h.delete(T.toString());const f=u.URI.revive(d);return(0,S.assertIsDefined)(this.g.getDocument(f))},d=>(this.h.delete(T.toString()),Promise.reject(d))),this.h.set(T.toString(),m)),m}createDocumentData(T){return this.f.$tryCreateDocument(T).then(E=>u.URI.revive(E))}$acceptModelLanguageChanged(T,E){const m=u.URI.revive(T),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(E),this.a.fire(d.document)}$acceptModelSaved(T){const E=u.URI.revive(T),m=this.g.getDocument(E);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this.d.fire(m.document)}$acceptDirtyStateChanged(T,E){const m=u.URI.revive(T),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,m){const d=u.URI.revive(T),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(m),f.onEvents(E);let p;E.isUndoing?p=L.TextDocumentChangeReason.Undo:E.isRedoing&&(p=L.TextDocumentChangeReason.Redo),this.c.fire((0,I.deepFreeze)({document:f.document,contentChanges:E.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(T,E){(0,C.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=k}),define(ye[60],De([1,0,50,3,6,2,4,5,135,18,138,14,13,28,16,65,66]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(y,g){this.h=y,this.i=g,this.a=null,this.b=new Map,this.c=new T.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const g=[],i=[],o=[];if(y.removedDocuments)for(const s of y.removedDocuments){const l=R.URI.revive(s),r=this.c.get(l);r?.unref()&&(this.c.delete(l),g.push(r.value))}if(y.addedDocuments)for(const s of y.addedDocuments){const l=R.URI.revive(s.uri);let r=this.c.get(l);if(r&&l.scheme!==E.Schemas.vscodeNotebookCell&&l.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);r||(r=new f(new S.ExtHostDocumentData(this.h.getProxy(P.MainContext.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(l,r),i.push(r.value)),r.ref()}if(y.removedEditors)for(const s of y.removedEditors){const l=this.b.get(s);this.b.delete(s),l&&o.push(l)}if(y.addedEditors)for(const s of y.addedEditors){const l=R.URI.revive(s.documentUri);c.ok(this.c.has(l),`document '${l}' does not exist`),c.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const r=this.c.get(l).value,h=new L.ExtHostTextEditor(s.id,this.h.getProxy(P.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>r.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(n=>k.Range.to(n)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,h)}y.newActiveEditor!==void 0&&(c.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,u.dispose)(g),(0,u.dispose)(o),y.removedDocuments&&this.e.fire(g),y.addedDocuments&&this.d.fire(i),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return m.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const g=this.b.get(this.a);return y?g:g?.value}allEditors(){return[...this.b.values()]}};p=qe([We(0,I.IExtHostRpcService),We(1,v.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[61],De([1,0,14,5,2,3,4,7,18,10,62]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class k{constructor(d,f,p){this.e=p,this.d=f,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,f={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.TextTabInput(u.URI.revive(this.b.input.uri));case 2:return new P.TextDiffTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified));case 3:return new P.TextMergeTabInput(u.URI.revive(this.b.input.base),u.URI.revive(this.b.input.input1),u.URI.revive(this.b.input.input2),u.URI.revive(this.b.input.result));case 6:return new P.CustomEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.WebviewEditorTabInput(this.b.input.viewType);case 4:return new P.NotebookEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(u.URI.revive(this.b.input.uri),u.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,f){this.c=[],this.d="",this.b=d,this.e=f;for(const p of d.tabs)p.isActive&&(this.d=p.id),this.c.push(new k(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,f={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return c.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(p=>p.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(p=>p.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const p=new k(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,p),d.tabDto.isActive&&(this.d=p.tabId),p}else if(d.kind===1){const p=this.c.splice(d.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(d.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,p),p}const f=this.c.find(p=>p.tabId===d.tabDto.id);if(!f)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(d.tabDto),f}activeTabId(){return this.d}}let T=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,f={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(p=>p.apiObject))},get activeTabGroup(){const p=d.d;return(0,I.assertIsDefined)(d.e.find(y=>y.groupId===p)?.apiObject)},close:async(p,b)=>{const y=Array.isArray(p)?p:[p];return y.length?E(y[0])?this.j(y,b):this.i(y,b):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(d){const f=new Set(this.e.map(s=>s.groupId)),p=new Set(d.map(s=>s.groupId)),b=(0,L.diffSets)(f,p),y=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),g=[],i=[];this.e=d.map(s=>{const l=new v(s,()=>this.d);return b.added.includes(l.groupId)?g.push(l.apiObject):i.push(l.apiObject),l});const o=(0,I.assertIsDefined)(d.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:g,closed:y,changed:i}))}$acceptTabGroupUpdate(d){const f=this.e.find(p=>p.groupId===d.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const f=this.e.find(b=>b.groupId===d.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const p=f.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(d){for(const f of this.e)for(const p of f.tabs)if(p.apiObject===d)return p}h(d){return this.e.find(f=>f.apiObject===d)}async i(d,f){const p=[];for(const b of d){const y=this.g(b);if(!y)throw new Error("Tab close: Invalid tab not found!");p.push(y.tabId)}return this.a.$closeTab(p,f)}async j(d,f){const p=[];for(const b of d){const y=this.h(b);if(!y)throw new Error("Group close: Invalid group not found!");p.push(y.groupId)}return this.a.$closeGroup(p,f)}};T=qe([We(0,S.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function E(m){return m.tabs!==void 0}}),define(ye[258],De([1,0,2,5,6,7,14,157,8,22,27]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const m=this.a.indexOf(E);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),m=[];let d,f,p=14,b=14;for(const y of E){let g=d?(0,S.commonPrefixLength)(d,y):0;for(g===0?f=1:f=b;g<y.length;g++)g+1===y.length?(p=b,b=9):b+=1,m.push([f,y.toUpperCase().charCodeAt(g),b]),m.push([f,y.toLowerCase().charCodeAt(g),b]),f=b;d=y,b=p}m.push([9,58,10]),m.push([10,47,12]),this.b=new P.StateMachine(m)}}provideDocumentLinks(E){this.c();const m=[],d=P.LinkComputer.computeLinks({getLineContent(f){return E.lineAt(f-1).text},getLineCount(){return E.lineCount}},this.b);for(const f of d){const p=C.DocumentLink.to(f);p.target&&m.push(p)}return m}}class v{constructor(E,m){this.i=m,this.b=new k,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,m,d,f={}){if(this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const p=this.h++;this.b.add(m),this.d.add(m),this.c.set(p,d);let b=2;f.isCaseSensitive&&(b+=1024),f.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,m,b).catch(g=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${m}`),console.error(g)});const y=d.onDidChangeFile(g=>{const i=[];for(const o of g){const{uri:s,type:l}=o;if(s.scheme!==m)continue;let r;switch(l){case R.FileChangeType.Changed:r=0;break;case R.FileChangeType.Created:r=1;break;case R.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:r})}this.a.$onFileSystemChange(p,i)});return(0,u.toDisposable)(()=>{y.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(E){const{type:m,ctime:d,mtime:f,size:p,permissions:b}=E;return{type:m,ctime:d,mtime:f,size:p,permissions:b}}$stat(E,m){return Promise.resolve(this.k(E).stat(c.URI.revive(m))).then(d=>v.j(d))}$readdir(E,m){return Promise.resolve(this.k(E).readDirectory(c.URI.revive(m)))}$readFile(E,m){return Promise.resolve(this.k(E).readFile(c.URI.revive(m))).then(d=>I.VSBuffer.wrap(d))}$writeFile(E,m,d,f){return Promise.resolve(this.k(E).writeFile(c.URI.revive(m),d.buffer,f))}$delete(E,m,d){return Promise.resolve(this.k(E).delete(c.URI.revive(m),d))}$rename(E,m,d,f){return Promise.resolve(this.k(E).rename(c.URI.revive(m),c.URI.revive(d),f))}$copy(E,m,d,f){const p=this.k(E);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(c.URI.revive(m),c.URI.revive(d),f))}$mkdir(E,m){return Promise.resolve(this.k(E).createDirectory(c.URI.revive(m)))}$watch(E,m,d,f){const p=this.k(E).watch(c.URI.revive(d),f);this.f.set(m,p)}$unwatch(E,m){const d=this.f.get(m);d&&(d.dispose(),this.f.delete(m))}$open(E,m,d){const f=this.k(E);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(c.URI.revive(m),d))}$close(E,m){const d=this.k(E);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(m))}$read(E,m,d,f){const p=this.k(E);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=I.VSBuffer.alloc(f);return Promise.resolve(p.read(m,d,b.buffer,0,f)).then(y=>b.slice(0,y))}$write(E,m,d,f){const p=this.k(E);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(m,d,f.buffer,0,f.byteLength))}k(E){const m=this.c.get(E);if(!m){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return m}}e.ExtHostFileSystem=v}),define(ye[78],De([1,0,5,44,7,22,4,18,48,6]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Yt{constructor(v,T){this.b=new Map,this.a=v.getProxy(c.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(m){try{const d=E.b.get(m.scheme);if(!d)return await E.a.$stat(m);await E.a.$ensureActivation(m.scheme);const f=await d.stat(m);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(d){Yt.c(d)}},async readDirectory(m){try{const d=E.b.get(m.scheme);return d?(await E.a.$ensureActivation(m.scheme),(await d.readDirectory(m)).slice()):await E.a.$readdir(m)}catch(d){return Yt.c(d)}},async createDirectory(m){try{return await E.a.$mkdir(m)}catch(d){return Yt.c(d)}},async readFile(m){try{const d=E.b.get(m.scheme);return d?(await E.a.$ensureActivation(m.scheme),(await d.readFile(m)).slice()):(await E.a.$readFile(m)).buffer}catch(d){return Yt.c(d)}},async writeFile(m,d){try{return await E.a.$writeFile(m,R.VSBuffer.wrap(d))}catch(f){return Yt.c(f)}},async delete(m,d){try{const f=E.b.get(m.scheme);return f?(await E.a.$ensureActivation(m.scheme),await f.delete(m,{recursive:!1,...d})):await E.a.$delete(m,{recursive:!1,useTrash:!1,...d})}catch(f){return Yt.c(f)}},async rename(m,d,f){try{return await E.a.$rename(m,d,{overwrite:!1,...f})}catch(p){return Yt.c(p)}},async copy(m,d,f){try{return await E.a.$copy(m,d,{overwrite:!1,...f})}catch(p){return Yt.c(p)}},isWritableFileSystem(m){const d=T.getCapabilities(m);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof u.FileSystemError)throw v;if(!(v instanceof Error))throw new u.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(v.message);switch(v.name){case A.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(v.message);case A.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(v.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(v.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(v.message);case A.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(v.message);case A.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(v.message);default:throw new u.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,T){return this.b.set(v,T),(0,I.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,P.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[259],De([1,0,3,38,2,5,14,7]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(k,v,T,E,m,d,f,p){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const b=this.h(k,T,m);this.g=0,d&&(this.g+=1),f&&(this.g+=2),p&&(this.g+=4);const y=(0,A.parse)(m),g=typeof m=="string",i=E(o=>{if(!d)for(const s of o.created){const l=u.URI.revive(s);y(l.fsPath)&&(!g||v.getWorkspaceFolder(l))&&this.a.fire(l)}if(!f)for(const s of o.changed){const l=u.URI.revive(s);y(l.fsPath)&&(!g||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!p)for(const s of o.deleted){const l=u.URI.revive(s);y(l.fsPath)&&(!g||v.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=P.Disposable.from(b,this.a,this.b,this.c,i)}h(k,v,T){const E=P.Disposable.from();if(typeof T=="string")return E;const m=k.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(T.pattern.includes(A.GLOBSTAR)||T.pattern.includes(A.GLOB_SPLIT))&&(d=!0);const f=Math.random();return m.$watch(v.identifier.value,f,T.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>m.$unwatch(f)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class I{constructor(k,v,T){this.j=k,this.k=v,this.l=T,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,v,T,E,m,d){return new S(this.j,k,v,this.a.event,C.GlobPattern.from(T),E,m,d)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,v){switch(k){case 2:this.b.fire(Object.freeze({files:v.map(T=>({oldUri:u.URI.revive(T.source),newUri:u.URI.revive(T.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(T=>u.URI.revive(T.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(T=>u.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,v){return(T,E,m)=>{const d=function(p){T.call(E,p)};return d.extension=k,v.event(d,void 0,m)}}async $onWillRunFileOperation(k,v,T,E){switch(k){case 2:return await this.n(this.g,{files:v.map(m=>({oldUri:u.URI.revive(m.source),newUri:u.URI.revive(m.target)}))},T,E);case 1:return await this.n(this.i,{files:v.map(m=>u.URI.revive(m.target))},T,E);case 0:case 3:return await this.n(this.h,{files:v.map(m=>u.URI.revive(m.target))},T,E)}}async n(k,v,T,E){const m=new Set,d=[];if(await k.fireAsync(v,E,async(p,b)=>{const y=Date.now(),g=await Promise.resolve(p);g instanceof P.WorkspaceEdit&&(d.push([b.extension,g]),m.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-y>T&&this.k.warn("SLOW file-participant",b.extension.identifier)}),E.isCancellationRequested||d.length===0)return;const f={edits:[]};for(const[,p]of d){const{edits:b}=C.WorkspaceEdit.from(p,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(b)}return{edit:f,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=I}),define(ye[260],De([1,0,2,40]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(C,P,S,I,L){this.a=P,this.b=S,this.c=I;const k=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new A.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new A.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new A.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new A.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const T=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(C,P,S,I){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,P){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=u}),define(ye[261],De([1,0,6,5]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(C){this.b=0,this.a=C.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const P=this.b++;return this.a.$registerResourceLabelFormatter(P,C),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=u}),define(ye[262],De([1,0,2,23,14,7,72,5,8,33,15,10,152,21,6,120,101,75,43,11,17,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(N,W){this.d=N,this.e=W}async provideDocumentSymbols(N,W){const K=this.d.getDocument(N),_=await this.e.provideDocumentSymbols(K,W);if(!(0,L.isFalsyOrEmpty)(_))return _[0]instanceof R.DocumentSymbol?_.map(u.DocumentSymbol.from):i.f(_)}static f(N){N=N.slice(0).sort((_,he)=>{let we=_.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(_.location.range.end)),we});const W=[],K=[];for(const _ of N){const he={name:_.name||"!!MISSING: name!!",kind:u.SymbolKind.from(_.kind),tags:_.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:u.Range.from(_.location.range),selectionRange:u.Range.from(_.location.range),children:[]};for(;;){if(K.length===0){K.push(he),W.push(he);break}const we=K[K.length-1];if(I.Range.containsRange(we.range,he.range)&&!I.Range.equalsRange(we.range,he.range)){we.children?.push(he),K.push(he);break}K.pop()}}return W}}class o{constructor(N,W,K){this.g=N,this.h=W,this.j=K,this.e=new f.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,W){const K=this.g.getDocument(N),_=await this.j.provideCodeLenses(K,W);if(!_||W.isCancellationRequested)return;const he=this.e.add(_),we=new E.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let be=0;be<_.length;be++)Ae.lenses.push({cacheId:[he,be],range:u.Range.from(_[be].range),command:this.h.toInternal(_[be].command,we)});return Ae}async resolveCodeLens(N,W){const K=N.cacheId&&this.e.get(...N.cacheId);if(!K)return;let _;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?_=K:_=await this.j.resolveCodeLens(K,W),_||(_=K),W.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(_.command??o.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(re){return Array.isArray(re)?re.map(u.DefinitionLink.from):re?[u.DefinitionLink.from(re)]:[]}class l{constructor(N,W){this.d=N,this.e=W}async provideDefinition(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideDefinition(_,he,K);return s(we)}}class r{constructor(N,W){this.d=N,this.e=W}async provideDeclaration(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideDeclaration(_,he,K);return s(we)}}class h{constructor(N,W){this.d=N,this.e=W}async provideImplementation(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideImplementation(_,he,K);return s(we)}}class n{constructor(N,W){this.d=N,this.e=W}async provideTypeDefinition(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideTypeDefinition(_,he,K);return s(we)}}class t{constructor(N,W){this.d=N,this.e=W}async provideHover(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideHover(_,he,K);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=_.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),u.Hover.from(we)}}class a{constructor(N,W){this.d=N,this.e=W}async provideEvaluatableExpression(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideEvaluatableExpression(_,he,K);if(we)return u.EvaluatableExpression.from(we)}}class w{constructor(N,W){this.d=N,this.e=W}async provideInlineValues(N,W,K,_){const he=this.d.getDocument(N),we=await this.e.provideInlineValues(he,u.Range.to(W),u.InlineValueContext.to(K),_);if(Array.isArray(we))return we.map(Ae=>u.InlineValue.from(Ae))}}class D{constructor(N,W){this.d=N,this.e=W}async provideDocumentHighlights(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideDocumentHighlights(_,he,K);if(Array.isArray(we))return we.map(u.DocumentHighlight.from)}}class F{constructor(N,W){this.d=N,this.e=W}async provideLinkedEditingRanges(N,W,K){const _=this.d.getDocument(N),he=u.Position.to(W),we=await this.e.provideLinkedEditingRanges(_,he,K);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(u.Range.from)),wordPattern:we.wordPattern}}}class x{constructor(N,W){this.d=N,this.e=W}async provideReferences(N,W,K,_){const he=this.d.getDocument(N),we=u.Position.to(W),Ae=await this.e.provideReferences(he,we,K,_);if(Array.isArray(Ae))return Ae.map(u.location.from)}}class V{constructor(N,W,K,_,he,we,Ae){this.g=N,this.h=W,this.j=K,this.k=_,this.l=he,this.m=we,this.n=Ae,this.e=new f.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,W,K,_){const he=this.g.getDocument(N),we=v.Selection.isISelection(W)?u.Selection.to(W):u.Range.to(W),Ae=[];for(const et of this.j.getDiagnostics(N))if(we.intersection(et.range)&&Ae.push(et)>V.d)break;const be={diagnostics:Ae,only:K.only?new R.CodeActionKind(K.only):void 0,triggerKind:u.CodeActionTriggerKind.to(K.trigger)},Ce=await this.k.provideCodeActions(he,we,be,_);if(!(0,L.isNonEmptyArray)(Ce)||_.isCancellationRequested)return;const Te=this.e.add(Ce),Ve=new E.DisposableStore;this.f.set(Te,Ve);const xe=[];for(let et=0;et<Ce.length;et++){const Qe=Ce[et];!Qe||(V.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,Ve)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Te,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,Ve),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(u.Diagnostic.from),edit:Qe.edit&&u.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Te,actions:xe}}async resolveCodeAction(N,W){const[K,_]=N,he=this.e.get(K,_);if(!he||V.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,W)??he;return we?.edit?u.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}V.d=1e3;class M{constructor(N,W,K,_){this.d=N,this.e=W,this.f=K,this.g=_}async prepareDocumentPaste(N,W,K,_){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),we=W.map(be=>u.Range.to(be)),Ae=u.DataTransfer.toDataTransfer(K,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,_),u.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,W,K,_,he){const we=this.e.getDocument(W),Ae=K.map(Te=>u.Range.to(Te)),be=u.DataTransfer.toDataTransfer(_,async Te=>(await this.d.$resolvePasteFileData(this.g,N,Te)).buffer),Ce=await this.f.provideDocumentPasteEdits(we,Ae,be,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?u.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ${constructor(N,W){this.d=N,this.e=W}async provideDocumentFormattingEdits(N,W,K){const _=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(_,W,K);if(Array.isArray(he))return he.map(u.TextEdit.from)}}class O{constructor(N,W){this.d=N,this.e=W}async provideDocumentRangeFormattingEdits(N,W,K,_){const he=this.d.getDocument(N),we=u.Range.to(W),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,K,_);if(Array.isArray(Ae))return Ae.map(u.TextEdit.from)}}class U{constructor(N,W){this.d=N,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,W,K,_,he){const we=this.d.getDocument(N),Ae=u.Position.to(W),be=await this.e.provideOnTypeFormattingEdits(we,Ae,K,_,he);if(Array.isArray(be))return be.map(u.TextEdit.from)}}class B{constructor(N,W){this.e=N,this.f=W,this.d=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,W){const K=await this.e.provideWorkspaceSymbols(N,W);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const _=this.d.add(K),he={cacheId:_,symbols:[]};for(let we=0;we<K.length;we++){const Ae=K[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...u.WorkspaceSymbol.from(Ae),cacheId:[_,we]})}return he}async resolveWorkspaceSymbol(N,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const K=this.d.get(...N.cacheId);if(K){const _=await this.e.resolveWorkspaceSymbol(K,W);return _&&(0,A.mixin)(N,u.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,W,K){this.d=N,this.e=W,this.f=K}async provideRenameEdits(N,W,K,_){const he=this.d.getDocument(N),we=u.Position.to(W);try{const Ae=await this.e.provideRenameEdits(he,we,K,_);return Ae?u.WorkspaceEdit.from(Ae):void 0}catch(Ae){const be=j.g(Ae);return be?{rejectReason:be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,W,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(N),he=u.Position.to(W);try{const we=await this.e.prepareRename(_,he,K);let Ae,be;if(R.Range.isRange(we)?(Ae=we,be=_.getText(we)):(0,k.isObject)(we)&&(Ae=we.range,be=we.placeholder),!Ae||!be)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(Ae),text:be}}catch(we){const Ae=j.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class de{constructor(N,W){this.resultId=N,this.tokens=W}}class Y{constructor(N,W){this.f=N,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,W,K){const _=this.f.getDocument(N),he=W!==0?this.d.get(W):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,he.resultId,K):await this.g.provideDocumentSemanticTokens(_,K);return he&&this.d.delete(W),we?(we=Y.h(we),this.o(Y.n(he,we),we)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return Y.j(N)?Y.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):Y.l(N)?Y.m(N)?N:new R.SemanticTokensEdits(N.edits.map(W=>new R.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const W of N.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(N,W){if(!Y.j(W)||!N||!N.tokens)return W;const K=N.tokens,_=K.length,he=W.data,we=he.length;let Ae=0;const be=Math.min(_,we);for(;Ae<be&&K[Ae]===he[Ae];)Ae++;if(Ae===_&&Ae===we)return new R.SemanticTokensEdits([],W.resultId);let Ce=0;const Te=be-Ae;for(;Ce<Te&&K[_-Ce-1]===he[we-Ce-1];)Ce++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:_-Ae-Ce,data:he.subarray(Ae,we-Ce)}],W.resultId)}o(N,W){if(Y.j(N)){const K=this.e++;return this.d.set(K,new de(N.resultId,N.data)),(0,m.encodeSemanticTokensDto)({id:K,type:"full",data:N.data})}if(Y.l(N)){const K=this.e++;return Y.j(W)?this.d.set(K,new de(W.resultId,W.data)):this.d.set(K,new de(N.resultId)),(0,m.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(N.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class q{constructor(N,W){this.d=N,this.e=W}async provideDocumentRangeSemanticTokens(N,W,K){const _=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(_,u.Range.to(W),K);return he?this.f(he):null}f(N){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Q{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,W,K,_,he){this.f=N,this.g=W,this.h=K,this.j=_,this.k=he,this.d=new f.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,W,K,_){const he=this.f.getDocument(N),we=u.Position.to(W),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),be=Ae.with({end:we}),Ce=new p.StopWatch(!0),Te=await this.h.provideCompletionItems(he,we,_,u.CompletionContext.to(K));if(!Te||_.isCancellationRequested)return;const Ve=Array.isArray(Te)?new R.CompletionList(Te):Te,xe=Q.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),et=new E.DisposableStore;this.e.set(xe,et);const Qe=[],nt={x:xe,b:Qe,a:{replace:u.Range.from(Ae),insert:u.Range.from(be)},c:Ve.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<Ve.items.length;st++){const ht=Ve.items[st],Ue=this.l(ht,[xe,st],be,Ae);Qe.push(Ue)}return nt}async resolveCompletionItem(N,W){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...N);if(!K)return;const _=await this.h.resolveCompletionItem(K,W);if(!!_)return this.l(_,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,W,K,_){const he=this.e.get(W[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(N.command,he),Ae={x:W,a:N.label,b:N.kind!==void 0?u.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(u.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:u.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(u.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let be;return N.textEdit?be=N.textEdit.range:N.range&&(be=N.range),R.Range.isRange(be)?Ae.j=u.Range.from(be):be&&(!K?.isEqual(be.inserting)||!_?.isEqual(be.replacing))&&(Ae.j={insert:u.Range.from(be.inserting),replace:u.Range.from(be.replacing)}),Ae}}class Z{async provideInlineCompletions(N,W,K,_){}disposeCompletions(N){}handleDidShowCompletionItem(N,W){}handlePartialAccept(N,W,K){}}class te extends Z{constructor(N,W,K,_){super(),this.f=N,this.g=W,this.h=K,this.j=_,this.d=new X,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,W,K,_){const he=this.g.getDocument(N),we=u.Position.to(W),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:u.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},_);if(!Ae||_.isCancellationRequested)return;const be=Array.isArray(Ae)?Ae:Ae.items,Ce=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Te;return{pid:this.d.createReferenceId({dispose(){Te?.dispose()},items:be}),items:be.map((xe,et)=>{let Qe;xe.command&&(Te||(Te=new E.DisposableStore),Qe=this.j.toInternal(xe.command,Te));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?u.Range.from(xe.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:Ce.map(xe=>(Te||(Te=new E.DisposableStore),this.j.toInternal(xe,Te)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,W){const K=this.d.get(N)?.items[W];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}handlePartialAccept(N,W,K){const _=this.d.get(N)?.items[W];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(_,K)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const W=this.e++;return this.d.set(W,N),W}disposeReferenceId(N){const W=this.d.get(N);return this.d.delete(N),W}get(N){return this.d.get(N)}}class J{constructor(N,W){this.e=N,this.f=W,this.d=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,W,K,_){const he=this.e.getDocument(N),we=u.Position.to(W),Ae=this.g(K),be=await this.f.provideSignatureHelp(he,we,_,Ae);if(be){const Ce=this.d.add([be]);return{...u.SignatureHelp.from(be),id:Ce}}}g(N){let W;if(N.activeSignatureHelp){const K=u.SignatureHelp.to(N.activeSignatureHelp),_=this.d.get(N.activeSignatureHelp.id,0);_?(W=_,W.activeSignature=K.activeSignature,W.activeParameter=K.activeParameter):W=K}return{...N,activeSignatureHelp:W}}releaseSignatureHelp(N){this.d.delete(N)}}class ie{constructor(N,W,K,_,he){this.f=N,this.g=W,this.h=K,this.j=_,this.k=he,this.d=new f.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,W,K){const _=this.f.getDocument(N),he=u.Range.to(W),we=await this.h.provideInlayHints(_,he,K);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new E.DisposableStore);const be={hints:[],cacheId:Ae};for(let Ce=0;Ce<we.length;Ce++)this.l(we[Ce],he)&&be.hints.push(this.m(we[Ce],[Ae,Ce]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),be}async resolveInlayHint(N,W){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...N);if(!K)return;const _=await this.h.resolveInlayHint(K,W);if(!!_&&!!this.l(_))return this.m(_,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,W){return N.label.length===0||Array.isArray(N.label)&&N.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(W&&!W.contains(N.position))}m(N,W){const K=this.e.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const _={label:"",cacheId:W,tooltip:u.MarkdownString.fromStrict(N.tooltip),position:u.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(u.TextEdit.from),kind:N.kind&&u.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?_.label=N.label:_.label=N.label.map(he=>{const we={label:he.value};return we.tooltip=u.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=u.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,K)),we}),_}}class pe{constructor(N,W){this.e=N,this.f=W,this.d=new f.Cache("DocumentLink")}async provideLinks(N,W){const K=this.e.getDocument(N),_=await this.f.provideDocumentLinks(K,W);if(!(!Array.isArray(_)||_.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(pe.g).map(u.DocumentLink.from)};{const he=this.d.add(_),we={links:[],cacheId:he};for(let Ae=0;Ae<_.length;Ae++){if(!pe.g(_[Ae]))continue;const be=u.DocumentLink.from(_[Ae]);be.cacheId=[he,Ae],we.links.push(be)}return we}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,W){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...N);if(!K)return;const _=await this.f.resolveDocumentLink(K,W);if(!(!_||!pe.g(_)))return u.DocumentLink.from(_)}releaseLinks(N){this.d.delete(N)}}class ve{constructor(N,W){this.d=N,this.e=W}async provideColors(N,W){const K=this.d.getDocument(N),_=await this.e.provideDocumentColors(K,W);return Array.isArray(_)?_.map(we=>({color:u.Color.from(we.color),range:u.Range.from(we.range)})):[]}async provideColorPresentations(N,W,K){const _=this.d.getDocument(N),he=u.Range.to(W.range),we=u.Color.to(W.color),Ae=await this.e.provideColorPresentations(we,{document:_,range:he},K);if(!!Array.isArray(Ae))return Ae.map(u.ColorPresentation.from)}}class ke{constructor(N,W){this.d=N,this.e=W}async provideFoldingRanges(N,W,K){const _=this.d.getDocument(N),he=await this.e.provideFoldingRanges(_,W,K);if(!!Array.isArray(he))return he.map(u.FoldingRange.from)}}class Oe{constructor(N,W,K){this.d=N,this.e=W,this.f=K}async provideSelectionRanges(N,W,K){const _=this.d.getDocument(N),he=W.map(u.Position.to),we=await this.e.provideSelectionRanges(_,he,K);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let be=0;be<he.length;be++){const Ce=[];Ae.push(Ce);let Te=he[be],Ve=we[be];for(;;){if(!Ve.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(u.SelectionRange.from(Ve)),!Ve.parent)break;Te=Ve.range,Ve=Ve.parent}}return Ae}}class oe{constructor(N,W){this.f=N,this.g=W,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,W,K){const _=this.f.getDocument(N),he=u.Position.to(W),we=await this.g.prepareCallHierarchy(_,he,K);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideCallsTo(N,W,K){const _=this.j(N,W);if(!_)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(_,K);if(!!he)return he.map(we=>({from:this.h(N,we.from),fromRanges:we.fromRanges.map(Ae=>u.Range.from(Ae))}))}async provideCallsFrom(N,W,K){const _=this.j(N,W);if(!_)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(_,K);if(!!he)return he.map(we=>({to:this.h(N,we.to),fromRanges:we.fromRanges.map(Ae=>u.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,W){const K=this.e.get(N),_=u.CallHierarchyItem.from(W,N,K.size.toString(36));return K.set(_._itemId,W),_}j(N,W){return this.e.get(N)?.get(W)}}class ae{constructor(N,W){this.f=N,this.g=W,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,W,K){const _=this.f.getDocument(N),he=u.Position.to(W),we=await this.g.prepareTypeHierarchy(_,he,K);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideSupertypes(N,W,K){const _=this.j(N,W);if(!_)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(_,K);if(!!he)return he.map(we=>this.h(N,we))}async provideSubtypes(N,W,K){const _=this.j(N,W);if(!_)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(_,K);if(!!he)return he.map(we=>this.h(N,we))}releaseSession(N){this.e.delete(N)}h(N,W){const K=this.e.get(N),_=u.TypeHierarchyItem.from(W,N,K.size.toString(36));return K.set(_._itemId,W),_}j(N,W){return this.e.get(N)?.get(W)}}class fe{constructor(N,W,K,_){this.d=N,this.e=W,this.f=K,this.g=_}async provideDocumentOnDropEdits(N,W,K,_,he){const we=this.e.getDocument(W),Ae=u.Position.to(K),be=u.DataTransfer.toDataTransfer(_,async Te=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Te)).buffer),Ce=await this.f.provideDocumentDropEdits(we,Ae,be,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?u.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(N,W){this.adapter=N,this.extension=W}}class le{constructor(N,W,K,_,he,we,Ae,be){this.g=W,this.h=K,this.j=_,this.k=he,this.l=we,this.m=Ae,this.n=be,this.f=new Map,this.e=N.getProxy(P.MainContext.MainThreadLanguageFeatures)}o(N){return u.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return le.d++}async s(N,W,K,_,he,we=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof W))return _;const be=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ce=K(Ae.adapter,Ae.extension);return Promise.resolve(Ce).catch(Te=>{(0,b.isCancellationError)(Te)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Te),this.n.onExtensionError(Ae.extension.identifier,Te))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),T.CancellationToken.isCancellationToken(he)?(0,y.raceCancellationError)(Ce,he):Ce}t(N,W){const K=this.q();return this.f.set(K,new ee(N,W)),K}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,W,K,_){const he=this.t(new i(this.h,K),N),we=_&&_.label||le.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(W),we),this.p(he)}$provideDocumentSymbols(N,W,K){return this.s(N,i,_=>_.provideDocumentSymbols(c.URI.revive(W),K),void 0,K)}registerCodeLensProvider(N,W,K){const _=this.q(),he=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new ee(new o(this.h,this.j.converter,K),N)),this.e.$registerCodeLensSupport(_,this.o(W),he);let we=this.p(_);if(he!==void 0){const Ae=K.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(N,W,K){return this.s(N,o,_=>_.provideCodeLenses(c.URI.revive(W),K),void 0,K)}$resolveCodeLens(N,W,K){return this.s(N,o,_=>_.resolveCodeLens(W,K),void 0,void 0)}$releaseCodeLenses(N,W){this.s(N,o,K=>Promise.resolve(K.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(N,W,K){const _=this.t(new l(this.h,K),N);return this.e.$registerDefinitionSupport(_,this.o(W)),this.p(_)}$provideDefinition(N,W,K,_){return this.s(N,l,he=>he.provideDefinition(c.URI.revive(W),K,_),[],_)}registerDeclarationProvider(N,W,K){const _=this.t(new r(this.h,K),N);return this.e.$registerDeclarationSupport(_,this.o(W)),this.p(_)}$provideDeclaration(N,W,K,_){return this.s(N,r,he=>he.provideDeclaration(c.URI.revive(W),K,_),[],_)}registerImplementationProvider(N,W,K){const _=this.t(new h(this.h,K),N);return this.e.$registerImplementationSupport(_,this.o(W)),this.p(_)}$provideImplementation(N,W,K,_){return this.s(N,h,he=>he.provideImplementation(c.URI.revive(W),K,_),[],_)}registerTypeDefinitionProvider(N,W,K){const _=this.t(new n(this.h,K),N);return this.e.$registerTypeDefinitionSupport(_,this.o(W)),this.p(_)}$provideTypeDefinition(N,W,K,_){return this.s(N,n,he=>he.provideTypeDefinition(c.URI.revive(W),K,_),[],_)}registerHoverProvider(N,W,K,_){const he=this.t(new t(this.h,K),N);return this.e.$registerHoverProvider(he,this.o(W)),this.p(he)}$provideHover(N,W,K,_){return this.s(N,t,he=>he.provideHover(c.URI.revive(W),K,_),void 0,_)}registerEvaluatableExpressionProvider(N,W,K,_){const he=this.t(new a(this.h,K),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(W)),this.p(he)}$provideEvaluatableExpression(N,W,K,_){return this.s(N,a,he=>he.provideEvaluatableExpression(c.URI.revive(W),K,_),void 0,_)}registerInlineValuesProvider(N,W,K,_){const he=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new w(this.h,K),N);this.e.$registerInlineValuesProvider(we,this.o(W),he);let Ae=this.p(we);if(he!==void 0){const be=K.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,be)}return Ae}$provideInlineValues(N,W,K,_,he){return this.s(N,w,we=>we.provideInlineValues(c.URI.revive(W),K,_,he),void 0,he)}registerDocumentHighlightProvider(N,W,K){const _=this.t(new D(this.h,K),N);return this.e.$registerDocumentHighlightProvider(_,this.o(W)),this.p(_)}$provideDocumentHighlights(N,W,K,_){return this.s(N,D,he=>he.provideDocumentHighlights(c.URI.revive(W),K,_),void 0,_)}registerLinkedEditingRangeProvider(N,W,K){const _=this.t(new F(this.h,K),N);return this.e.$registerLinkedEditingRangeProvider(_,this.o(W)),this.p(_)}$provideLinkedEditingRanges(N,W,K,_){return this.s(N,F,async he=>{const we=await he.provideLinkedEditingRanges(c.URI.revive(W),K,_);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?le.w(we.wordPattern):void 0}},void 0,_)}registerReferenceProvider(N,W,K){const _=this.t(new x(this.h,K),N);return this.e.$registerReferenceSupport(_,this.o(W)),this.p(_)}$provideReferences(N,W,K,_,he){return this.s(N,x,we=>we.provideReferences(c.URI.revive(W),K,_,he),void 0,he)}registerCodeActionProvider(N,W,K,_){const he=new E.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,K,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(we,this.o(W),{providedKinds:_?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:_?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},le.u(N),Boolean(K.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(N,W,K,_,he){return this.s(N,V,we=>we.provideCodeActions(c.URI.revive(W),K,_,he),void 0,he)}$resolveCodeAction(N,W,K){return this.s(N,V,_=>_.resolveCodeAction(W,K),void 0,void 0)}$releaseCodeActions(N,W){this.s(N,V,K=>Promise.resolve(K.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(N,W,K){const _=this.t(new $(this.h,K),N);return this.e.$registerDocumentFormattingSupport(_,this.o(W),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentFormattingEdits(N,W,K,_){return this.s(N,$,he=>he.provideDocumentFormattingEdits(c.URI.revive(W),K,_),void 0,_)}registerDocumentRangeFormattingEditProvider(N,W,K){const _=this.t(new O(this.h,K),N);return this.e.$registerRangeFormattingSupport(_,this.o(W),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentRangeFormattingEdits(N,W,K,_,he){return this.s(N,O,we=>we.provideDocumentRangeFormattingEdits(c.URI.revive(W),K,_,he),void 0,he)}registerOnTypeFormattingEditProvider(N,W,K,_){const he=this.t(new U(this.h,K),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(W),_,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,W,K,_,he,we){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(W),K,_,he,we),void 0,we)}registerWorkspaceSymbolProvider(N,W){const K=this.t(new B(W,this.l),N);return this.e.$registerNavigateTypeSupport(K,typeof W.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(N,W,K){return this.s(N,B,_=>_.provideWorkspaceSymbols(W,K),{symbols:[]},K)}$resolveWorkspaceSymbol(N,W,K){return this.s(N,B,_=>_.resolveWorkspaceSymbol(W,K),void 0,void 0)}$releaseWorkspaceSymbols(N,W){this.s(N,B,K=>K.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(N,W,K){const _=this.t(new j(this.h,K,this.l),N);return this.e.$registerRenameSupport(_,this.o(W),j.supportsResolving(K)),this.p(_)}$provideRenameEdits(N,W,K,_,he){return this.s(N,j,we=>we.provideRenameEdits(c.URI.revive(W),K,_,he),void 0,he)}$resolveRenameLocation(N,W,K,_){return this.s(N,j,he=>he.resolveRenameLocation(c.URI.revive(W),K,_),void 0,_)}registerDocumentSemanticTokensProvider(N,W,K,_){const he=this.t(new Y(this.h,K),N),we=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(W),_,we);let Ae=this.p(he);if(we){const be=K.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,be)}return Ae}$provideDocumentSemanticTokens(N,W,K,_){return this.s(N,Y,he=>he.provideDocumentSemanticTokens(c.URI.revive(W),K,_),null,_)}$releaseDocumentSemanticTokens(N,W){this.s(N,Y,K=>K.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,W,K,_){const he=this.t(new q(this.h,K),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(W),_),this.p(he)}$provideDocumentRangeSemanticTokens(N,W,K,_){return this.s(N,q,he=>he.provideDocumentRangeSemanticTokens(c.URI.revive(W),K,_),null,_)}registerCompletionItemProvider(N,W,K,_){const he=this.t(new Q(this.h,this.j.converter,K,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(W),_,Q.supportsResolving(K),`${N.identifier.value}(${_.join("")})`),this.p(he)}$provideCompletionItems(N,W,K,_,he){return this.s(N,Q,we=>we.provideCompletionItems(c.URI.revive(W),K,_,he),void 0,he)}$resolveCompletionItem(N,W,K){return this.s(N,Q,_=>_.resolveCompletionItem(W,K),void 0,K)}$releaseCompletionItems(N,W){this.s(N,Q,K=>K.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(N,W,K){const _=new te(N,this.h,K,this.j.converter),he=this.t(_,N);return this.e.$registerInlineCompletionsSupport(he,this.o(W),_.supportsHandleEvents),this.p(he)}$provideInlineCompletions(N,W,K,_,he){return this.s(N,Z,we=>we.provideInlineCompletions(c.URI.revive(W),K,_,he),void 0,he)}$handleInlineCompletionDidShow(N,W,K){this.s(N,Z,async _=>{_.handleDidShowCompletionItem(W,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,W,K,_){this.s(N,Z,async he=>{he.handlePartialAccept(W,K,_)},void 0,void 0)}$freeInlineCompletionsList(N,W){this.s(N,Z,async K=>{K.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(N,W,K,_){const he=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,we=this.t(new J(this.h,K),N);return this.e.$registerSignatureHelpProvider(we,this.o(W),he),this.p(we)}$provideSignatureHelp(N,W,K,_,he){return this.s(N,J,we=>we.provideSignatureHelp(c.URI.revive(W),K,_,he),void 0,he)}$releaseSignatureHelp(N,W){this.s(N,J,K=>K.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(N,W,K){const _=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new ie(this.h,this.j.converter,K,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(W),typeof K.resolveInlayHint=="function",_,le.u(N));let we=this.p(he);if(_!==void 0){const Ae=K.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(_));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(N,W,K,_){return this.s(N,ie,he=>he.provideInlayHints(c.URI.revive(W),K,_),void 0,_)}$resolveInlayHint(N,W,K){return this.s(N,ie,_=>_.resolveInlayHint(W,K),void 0,K)}$releaseInlayHints(N,W){this.s(N,ie,K=>K.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(N,W,K){const _=this.t(new pe(this.h,K),N);return this.e.$registerDocumentLinkProvider(_,this.o(W),typeof K.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(N,W,K){return this.s(N,pe,_=>_.provideLinks(c.URI.revive(W),K),void 0,K,W.scheme==="output")}$resolveDocumentLink(N,W,K){return this.s(N,pe,_=>_.resolveLink(W,K),void 0,void 0,!0)}$releaseDocumentLinks(N,W){this.s(N,pe,K=>K.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(N,W,K){const _=this.t(new ve(this.h,K),N);return this.e.$registerDocumentColorProvider(_,this.o(W)),this.p(_)}$provideDocumentColors(N,W,K){return this.s(N,ve,_=>_.provideColors(c.URI.revive(W),K),[],K)}$provideColorPresentations(N,W,K,_){return this.s(N,ve,he=>he.provideColorPresentations(c.URI.revive(W),K,_),void 0,_)}registerFoldingRangeProvider(N,W,K){const _=this.q(),he=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new ee(new ke(this.h,K),N)),this.e.$registerFoldingRangeProvider(_,this.o(W),N.identifier,he);let we=this.p(_);if(he!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(N,W,K,_){return this.s(N,ke,he=>he.provideFoldingRanges(c.URI.revive(W),K,_),void 0,_)}registerSelectionRangeProvider(N,W,K){const _=this.t(new Oe(this.h,K,this.l),N);return this.e.$registerSelectionRangeProvider(_,this.o(W)),this.p(_)}$provideSelectionRanges(N,W,K,_){return this.s(N,Oe,he=>he.provideSelectionRanges(c.URI.revive(W),K,_),[],_)}registerCallHierarchyProvider(N,W,K){const _=this.t(new oe(this.h,K),N);return this.e.$registerCallHierarchyProvider(_,this.o(W)),this.p(_)}$prepareCallHierarchy(N,W,K,_){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(c.URI.revive(W),K,_)),void 0,_)}$provideCallHierarchyIncomingCalls(N,W,K,_){return this.s(N,oe,he=>he.provideCallsTo(W,K,_),void 0,_)}$provideCallHierarchyOutgoingCalls(N,W,K,_){return this.s(N,oe,he=>he.provideCallsFrom(W,K,_),void 0,_)}$releaseCallHierarchy(N,W){this.s(N,oe,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(N,W,K){const _=this.t(new ae(this.h,K),N);return this.e.$registerTypeHierarchyProvider(_,this.o(W)),this.p(_)}$prepareTypeHierarchy(N,W,K,_){return this.s(N,ae,he=>Promise.resolve(he.prepareSession(c.URI.revive(W),K,_)),void 0,_)}$provideTypeHierarchySupertypes(N,W,K,_){return this.s(N,ae,he=>he.provideSupertypes(W,K,_),void 0,_)}$provideTypeHierarchySubtypes(N,W,K,_){return this.s(N,ae,he=>he.provideSubtypes(W,K,_),void 0,_)}$releaseTypeHierarchy(N,W){this.s(N,ae,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(N,W,K){const _=this.q();return this.f.set(_,new ee(new fe(this.e,this.h,K,_),N)),this.e.$registerDocumentOnDropEditProvider(_,this.o(W)),this.p(_)}$provideDocumentOnDropEdits(N,W,K,_,he,we){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(W,c.URI.revive(K),_,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,W,K,_){const he=this.q();return this.f.set(he,new ee(new M(this.e,this.h,K,he),N)),this.e.$registerPasteEditProvider(he,this.o(W),!!K.prepareDocumentPaste,_.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,W,K,_,he){return this.s(N,M,we=>we.prepareDocumentPaste(c.URI.revive(W),K,_,he),void 0,he)}$providePasteEdits(N,W,K,_,he,we){return this.s(N,M,Ae=>Ae.providePasteEdits(W,c.URI.revive(K),_,he,we),void 0,we)}static w(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:le.w(N.decreaseIndentPattern),increaseIndentPattern:le.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?le.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?le.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:le.w(N.beforeText),afterText:N.afterText?le.w(N.afterText):void 0,previousLineText:N.previousLineText?le.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(le.z)}setLanguageConfiguration(N,W,K){const{wordPattern:_}=K;if(_&&(0,S.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(W,_):this.h.setWordDefinitionFor(W,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),we={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?le.w(K.wordPattern):void 0,indentationRules:K.indentationRules?le.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?le.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(he,W,we),this.p(he)}$setWordDefinitions(N){for(const W of N)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}le.d=0,e.ExtHostLanguageFeatures=le}),define(ye[263],De([1,0,5,14,7,37,17,6]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,k,v,T){this.c=k,this.d=v,this.e=T,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,k){await this.a.$changeLanguage(L,k);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,k){const v=L.version,T=A.Position.from(k),E=await this.a.$tokensAtPosition(L.uri,T),m={type:u.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new u.Range(k.line,k.character,k.line,k.character)};if(!E)return m;const d={range:A.Range.to(E.range),type:A.TokenType.to(E.type)};return!d.range.contains(k)||v!==L.version?m:d}createLanguageStatusItem(L,k,v){const T=this.f++,E=this.a,m=this.g,d=`${L.identifier.value}/${k}`;if(m.has(d))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);m.add(d);const f={selector:v,id:k,name:L.displayName??L.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new P.DisposableStore,y=()=>{p?.dispose(),p=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(T,{id:d,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===u.LanguageStatusSeverity.Error?R.default.Error:f.severity===u.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,b),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},g={dispose(){b.dispose(),p?.dispose(),E.$removeLanguageStatus(T),m.delete(d)},get id(){return f.id},get name(){return f.name},set name(i){f.name=i,y()},get selector(){return f.selector},set selector(i){f.selector=i,y()},get text(){return f.text},set text(i){f.text=i,y()},get detail(){return f.detail},set detail(i){f.detail=i,y()},get severity(){return f.severity},set severity(i){f.severity=i,y()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(i){f.accessibilityInformation=i,y()},get command(){return f.command},set command(i){f.command=i,y()},get busy(){return f.busy},set busy(i){f.busy=i,y()}};return y(),g}}e.ExtHostLanguages=S}),define(ye[97],De([1,0,12,8,2,4,13,5,25,18]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,T,E){this.f=E,this.d=new Map,this.a=T.getProxy(P.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(v,T){const{message:E,args:m,comment:d}=T;if(this.c)return(0,A.format2)(E,m??{});let f=E;d&&d.length>0&&(f+=`/${Array.isArray(d)?d.join(""):d}`);const p=this.d.get(v)?.contents[f];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,A.format2)(p??E,m??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let T;const E=await this.g(v);if(!E){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const m=await this.a.$fetchBundleContents(E),d=JSON.parse(m);T=v.isBuiltin?d.contents?.bundle:d}catch(m){this.f.error(`Failed to load translations for ${v.identifier.value} from ${E}: ${m.message}`);return}T&&this.d.set(v.identifier.value,{contents:T,uri:E})}async g(v){if(v.isBuiltin){const T=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return u.URI.revive(T)}return v.l10n?u.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,S.IExtHostInitDataService),We(1,I.IExtHostRpcService),We(2,C.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,18,2,70]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends c.AbstractLoggerService{constructor(k,v){super(v.logLevel,v.loggers.map(T=>(0,P.revive)(T))),this.l=k.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(k,v){v?this.setLogLevel(C.URI.revive(v),k):this.setLogLevel(k)}setVisibility(k,v){super.setVisibility(k,v),this.l.$setVisibility(k,v)}k(k,v,T){return new I(this.l,k,v,T)}};S=qe([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class I extends c.AbstractMessageLogger{constructor(k,v,T,E){super(E?.logLevel==="always"),this.m=k,this.n=v,this.k=!1,this.l=[],this.setLevel(T),this.m.$createLogger(v,E).then(()=>{this.r(this.l),this.k=!0})}g(k,v){const T=[[k,v]];this.k?this.r(T):this.l.push(...T)}r(k){this.m.$log(this.n,k)}}}),define(ye[264],De([1,0,5,13,27]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(P){return P&&P.title}let C=class{constructor(S,I){this.b=I,this.a=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,I,L,k,v){const T={source:{identifier:S.identifier,label:S.displayName||S.name}};let E;typeof k=="string"||R(k)?E=[k,...v]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,E=v),T.useCustom&&(0,u.checkProposedApiEnabled)(S,"resolvers");const m=[];for(let d=0;d<E.length;d++){const f=E[d];if(typeof f=="string")m.push({title:f,handle:d,isCloseAffordance:!1});else if(typeof f=="object"){const{title:p,isCloseAffordance:b}=f;m.push({title:p,isCloseAffordance:!!b,handle:d})}else this.b.warn("Invalid message item:",f)}return this.a.$showMessage(I,L,T,m).then(d=>{if(typeof d=="number")return E[d]})}};C=qe([We(1,A.ILogService)],C),e.ExtHostMessageService=C}),define(ye[265],De([1,0,22,3,6,28,8,10,2,75,5,40,14,7,59,240,136]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,y,g,i){this.q=g,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const s=o.notebookEditor?.notebookUri,l=o.cell.handle,h=this.g.get(s)?.getCell(l);if(h)return h.apiCell}if(o&&o.$mid===14){const s=o.uri,l=this.g.get(s);if(l)return l.apiNotebook}return o}}),f.x(y)}getEditorById(b){const y=this.h.get(b);if(!y)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(b){for(const[y,g]of this.h)if(g.apiEditor===b)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,y){const g=this.g.get(b);if(!g&&!y)throw new Error(`NO notebook document for '${b}'`);return g}static s(b,y){if(!y)return;const g=y.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(y.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:y.displayName,filenamePattern:g,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,y,g){const i=f.a++,o=typeof g.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(i,g),this.b.$registerNotebookCellStatusBarItemProvider(i,o,y);let s;return o!==void 0&&(s=g.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(o))),new T.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,o),s?.dispose()})}async createNotebookDocument(b){const y=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return S.URI.revive(y)}async openNotebookDocument(b){const y=this.g.get(b);if(y)return y.apiNotebook;const g=await this.c.$tryOpenNotebook(b),i=this.g.get(S.URI.revive(g));return(0,P.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,y){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof y=="object"?g={position:v.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(v.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:g={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,g),o=i&&this.h.get(i)?.apiEditor;if(o)return o;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,y,g,i){const o=this.f.get(b),s=S.URI.revive(y),l=this.g.get(s);if(!l||!o)return;const r=l.getCellFromIndex(g);if(!r)return;const h=await o.provideCellStatusBarItems(r.apiCell,i);if(!h)return;const n=new u.DisposableStore,t=this.p.add([n]),w=(Array.isArray(h)?h:[h]).map(D=>v.NotebookStatusBarItem.from(D,this.i,n));return{cacheId:t,items:w}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,y,g,i,o){if((0,C.isFalsyOrWhitespace)(y))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,g),this.b.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},y,v.NotebookDocumentContentOptions.from(i),f.s(b,o)),(0,u.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,y,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const o=await i.deserializeNotebook(y.buffer,g);return new E.SerializableObjectWithBuffers(v.NotebookData.from(o))}async $notebookToData(b,y,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const o=await i.serializeNotebook(v.NotebookData.to(y.value),g);return c.VSBuffer.wrap(o)}w(b,y,g){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const i=new d.ExtHostNotebookEditor(y,this.d,b,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(y,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const g of b.value.removedDocuments){const i=S.URI.revive(g),o=this.g.get(i);o&&(o.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(o.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===i.toString()&&this.h.delete(s.id)}if(b.value.addedDocuments){const g=[];for(const i of b.value.addedDocuments){const o=S.URI.revive(i.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const s=new m.ExtHostNotebookDocument(this.c,this.q,this.r,o,i);g.push(...i.cells.map(l=>m.ExtHostCell.asModelAddData(s.apiNotebook,l))),this.g.get(o)?.dispose(),this.g.set(o,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(s.apiNotebook)}}if(b.value.addedEditors)for(const g of b.value.addedEditors){if(this.h.has(g.id))return;const i=S.URI.revive(g.documentUri),o=this.g.get(i);o&&this.w(o,g.id,g)}const y=[];if(b.value.removedEditors)for(const g of b.value.removedEditors){const i=this.h.get(g);i&&(this.h.delete(g),this.k?.id===i.id&&(this.k=void 0),y.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const g=new Set;this.l.forEach(i=>g.add(i.id));for(const i of this.h.values()){const o=g.has(i.id);i._acceptVisibility(o)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const y=k.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new k.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>c.VSBuffer.wrap(o))],new k.ApiCommandResult("Notebook Data",o=>v.NotebookData.to(o.value))),i=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new E.SerializableObjectWithBuffers(v.NotebookData.from(o)))],new k.ApiCommandResult("Bytes",o=>o.buffer));b.registerApiCommand(g),b.registerApiCommand(i)}}f.a=0,e.ExtHostNotebookController=f}),define(ye[266],De([1,0,15,17,21,3,6,28,2,26,13,75,5,40,14,7,94,230,27,59]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(r,h,n,t,a){this.k=h,this.l=n,this.m=t,this.n=a,this.b=new P.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new k.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=r.getProxy(v.MainContext.MainThreadNotebookKernels);const w=new T.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new T.ApiCommandArgument("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const F=this.l.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:F}}else if(D&&"notebookEditor"in D){const F=this.l.getIdByEditor(D.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return D})],T.ApiCommandResult.Void);this.m.registerApiCommand(w)}createNotebookController(r,h,n,t,a,w){for(const Z of this.h.values())if(Z.controller.id===h&&I.ExtensionIdentifier.equals(r.identifier,Z.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const D=this.i++,F=this;this.n.trace(`NotebookController[${D}], CREATED by ${r.identifier.value}, ${h}`);const x=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${r.identifier}'`);let V=!1;const M=new C.DisposableStore,$=new R.Emitter,O=new R.Emitter,U={id:s(r.identifier,h),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:t||r.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let B=a??x,j;this.a.$addKernel(D,U).catch(Z=>{console.log(Z),V=!0});let de=0;const Y=()=>{if(V)return;const Z=++de;Promise.resolve().then(()=>{Z===de&&this.a.$updateKernel(D,U)})},q=new P.ResourceMap,Q={get id(){return h},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return U.label},set label(Z){U.label=Z??r.displayName??r.name,Y()},get detail(){return U.detail??""},set detail(Z){U.detail=Z,Y()},get description(){return U.description??""},set description(Z){U.description=Z,Y()},get kind(){return(0,p.checkProposedApiEnabled)(r,"notebookControllerKind"),U.kind??""},set kind(Z){(0,p.checkProposedApiEnabled)(r,"notebookControllerKind"),U.kind=Z,Y()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(Z){U.supportedLanguages=Z,Y()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){U.supportsExecutionOrder=Z,Y()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(Z){B=Z??x},get interruptHandler(){return j},set interruptHandler(Z){j=Z,U.supportsInterrupt=Boolean(Z),Y()},createNotebookCellExecution(Z){if(V)throw new Error("notebook controller is DISPOSED");if(!q.has(Z.notebook.uri))throw F.n.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return F._createNotebookCellExecution(Z,s(r.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${D}], DISPOSED`),V=!0,this.h.delete(D),M.dispose(),$.dispose(),O.dispose(),this.a.$removeKernel(D))},updateNotebookAffinity(Z,te){te===m.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(D,Z.uri,te)},onDidReceiveMessage:O.event,postMessage(Z,te){return(0,p.checkProposedApiEnabled)(r,"notebookMessaging"),F.a.$postMessage(D,te&&F.l.getIdByEditor(te),Z)},asWebviewUri(Z){return(0,p.checkProposedApiEnabled)(r,"notebookMessaging"),(0,d.asWebviewUri)(Z,F.k.remote)}};return this.h.set(D,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:O,onDidChangeSelection:$,associatedNotebooks:q}),Q}getIdByController(r){for(const[h,n]of this.h)if(n.controller===r)return s(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,h){const n=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this.a.$addKernelDetectionTask(n,h);const a={dispose:()=>{this.c.delete(n),t.a.$removeKernelDetectionTask(n)}};return this.c.set(n,a),a}registerKernelSourceActionProvider(r,h,n){const t=this.f++,a=typeof n.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,w=this;this.e.set(t,n),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${r.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,h);let D;return a!==void 0&&(D=n.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(a))),{dispose:()=>{this.e.delete(t),w.a.$removeKernelSourceActionProvider(t,t),D?.dispose()}}}async $provideKernelSourceActions(r,h){const n=this.e.get(r);if(n){const t=new C.DisposableStore;return this.g.add([t]),(await n.provideNotebookKernelSourceActions(h)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.m.converter,t))}return[]}$acceptNotebookAssociation(r,h,n){const t=this.h.get(r);if(t){const a=this.l.getNotebookDocument(S.URI.revive(h));n?t.associatedNotebooks.set(a.uri,!0):t.associatedNotebooks.delete(a.uri),this.n.trace(`NotebookController[${r}] ASSOCIATE notebook`,a.uri.toString(),n),t.onDidChangeSelection.fire({selected:n,notebook:a.apiNotebook})}}async $executeCells(r,h,n){const t=this.h.get(r);if(!t)return;const a=this.l.getNotebookDocument(S.URI.revive(h)),w=[];for(const D of n){const F=a.getCell(D);F&&w.push(F.apiCell)}try{this.n.trace(`NotebookController[${r}] EXECUTE cells`,a.uri.toString(),w.length),await t.controller.executeHandler.call(t.controller,w,a.apiNotebook,t.controller)}catch(D){this.n.error(`NotebookController[${r}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(r,h,n){const t=this.h.get(r);if(!t)return;const a=this.l.getNotebookDocument(S.URI.revive(h));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,a.apiNotebook);else for(const w of n){const D=a.getCell(w);D&&this.b.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,h,n){const t=this.h.get(r);if(!t)return;const a=this.l.getEditorById(h);t.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:n}))}$cellExecutionChanged(r,h,n){const a=this.l.getNotebookDocument(S.URI.revive(r)).getCell(h);if(a){const w=n?E.NotebookCellExecutionState.to(n):m.NotebookCellExecutionState.Idle;w!==void 0&&this.j.fire({cell:a.apiCell,state:w})}}_createNotebookCellExecution(r,h){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const a=new i(h,t,this.a);this.b.set(t.uri,a);const w=a.onDidChangeState(()=>{a.state===g.Resolved&&(a.dispose(),w.dispose(),this.b.delete(t.uri))});return a.asApiObject()}};y=qe([We(4,L.ILogService)],y),e.ExtHostNotebookKernels=y;var g;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(g||(g={}));class i extends C.Disposable{get state(){return this.f}constructor(r,h,n){super(),this.j=h,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new u.CancellationTokenSource),this.h=new o(10,t=>this.m(t)),this.i=h.internalMetadata.executionOrder,this.k.$createExecution(this.b,r,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(r){await this.h.addItem(r)}async m(r){const h=Array.isArray(r)?r:[r];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(h))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(r){let h=this.j;if(r&&(h=this.j.notebook.getCellFromApiCell(r)),!h)throw new Error("INVALID cell");return h.handle}s(r){return r.map(h=>{const n=m.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return n===h.items?E.NotebookCellOutput.from(h):E.NotebookCellOutput.from({items:n,id:h.id,metadata:h.metadata})})}async t(r,h,n){const t=this.r(h),a=this.s((0,c.asArray)(r));return this.l({editType:f.CellExecutionUpdateType.Output,cellHandle:t,append:n,outputs:a})}async w(r,h,n){return r=m.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.l({editType:f.CellExecutionUpdateType.OutputItems,items:r.map(E.NotebookCellOutputItem.from),outputId:h.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r.g.token},get cell(){return r.j.apiCell},get executionOrder(){return r.i},set executionOrder(n){r.i=n,r.m([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:r.i}])},start(n){if(r.f===g.Resolved||r.f===g.Started)throw new Error("Cannot call start again");r.f=g.Started,r.c.fire(),r.m({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,t){if(r.f===g.Resolved)throw new Error("Cannot call resolve twice");r.f=g.Resolved,r.c.fire(),r.h.flush(),r.k.$completeExecution(r.b,new b.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:n}))},clearOutput(n){return r.n(),r.t([],n,!1)},appendOutput(n,t){return r.n(),r.t(n,t,!0)},replaceOutput(n,t){return r.n(),r.t(n,t,!1)},appendOutputItems(n,t){return r.n(),r.w(n,t,!0)},replaceOutputItems(n,t){return r.n(),r.w(n,t,!1)}})}}i.a=0;class o{constructor(r,h){this.d=r,this.e=h,this.a=[],this.b=Date.now()}addItem(r){return this.a.push(r),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const r=this.c;this.c=void 0;const h=this.a;return this.a=[],this.e(h).finally(()=>r.complete())}}function s(l,r){return`${l.value}/${r}`}e.createKernelId=s}),define(ye[267],De([1,0,3,5,136]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(P,S){this.c=S,this.a=new Map,this.b=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,I){const L=this.c.getEditorById(P);this.a.get(S)?.fire({editor:L.apiEditor,message:I})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,k,v)=>this.d(S).event(L,k,v),postMessage:(L,k)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const v=k&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.b.$postMessage(v?.id,S,L)}}}d(P){let S=this.a.get(P);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(P)}}),this.a.set(P,S),S)}}e.ExtHostNotebookRenderers=R}),define(ye[268],De([1,0,6,10,2,27,5]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(I){this.b=new Map,this.a=I.getProxy(C.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,L,k){if((0,R.checkProposedApiEnabled)(I,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,k),this.a.$registerProfileContentHandler(L,k.name,k.description,I.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(I,L,k,v){const T=this.b.get(I);if(!T)throw new Error(`Unknown handler with id: ${I}`);return T.saveProfile(L,k,v)}async $readProfile(I,L,k){const v=this.b.get(I);if(!v)throw new Error(`Unknown handler with id: ${I}`);return v.readProfile((0,A.isString)(L)?L:u.URI.revive(L),k)}}e.ExtHostProfileContentHandlers=P}),define(ye[269],De([1,0,2,5,17,14]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class C{constructor(S,I){this.d=I,this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,I,L){const k=c.URI.revive(I),v=this.c.get(S);return v?(0,u.asPromise)(()=>v.provideOriginalResource(k,L)).then(T=>T||null):Promise.resolve(null)}registerQuickDiffProvider(S,I,L,k){const v=C.a++;return this.c.set(v,I),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(S,this.d),L,k),{dispose:()=>this.c.delete(v)}}}C.a=0,e.ExtHostQuickDiff=C}),define(ye[270],De([1,0,21,3,6,5,2,7,11,15,37,51]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(T,E,m){const d=T.getProxy(R.MainContext.MainThreadQuickOpen);class f{constructor(r,h){this.e=new Map,this.f=0,this.a=r,this.b=h}showQuickPick(r,h,n=c.CancellationToken.None){this.c=void 0;const t=Promise.resolve(r),a=++this.f,w=d.$show(a,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},n),D={},F=w.then(()=>D);return Promise.race([F,t]).then(x=>{if(x!==D)return t.then(V=>{const M=[];for(let $=0;$<V.length;$++){const O=V[$];typeof O=="string"?M.push({label:O,handle:$}):O.kind===P.QuickPickItemKind.Separator?M.push({type:"separator",label:O.label}):M.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:$})}return h&&typeof h.onDidSelectItem=="function"&&(this.c=$=>{h.onDidSelectItem(V[$])}),d.$setItems(a,M),w.then($=>{if(typeof $=="number")return V[$];if(Array.isArray($))return $.map(O=>V[O])})})}).then(void 0,x=>{if(!(0,S.isCancellationError)(x))return d.$setError(a,x),Promise.reject(x)})}$onItemSelected(r){this.c?.(r)}showInput(r,h=c.CancellationToken.None){return this.d=r?.validateInput,d.$input(r,typeof this.d=="function",h).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this.d)return;const h=await this.d(r);if(!h||typeof h=="string")return h;let n;switch(h.severity){case P.InputBoxValidationSeverity.Info:n=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=h.message?L.default.Error:L.default.Ignore;break}return{content:h.message,severity:n}}async showWorkspaceFolderPick(r,h=c.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const t=await this.a.getWorkspaceFolders2();if(!!t)return t.find(a=>a.uri.toString()===n.uri.toString())}createQuickPick(r){const h=new o(r,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}createInputBox(r){const h=new s(r,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}$onDidChangeValue(r,h){this.e.get(r)?._fireDidChangeValue(h)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,h){const n=this.e.get(r);n instanceof o&&n._fireDidChangeActive(h)}$onDidChangeSelection(r,h){const n=this.e.get(r);n instanceof o&&n._fireDidChangeSelection(h)}$onDidTriggerButton(r,h){this.e.get(r)?._fireDidTriggerButton(h)}$onDidTriggerItemButton(r,h,n){const t=this.e.get(r);t instanceof o&&t._fireDidTriggerItemButton(h,n)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class p{constructor(r,h){this.x=r,this.y=h,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((h,n)=>{const t=h===P.QuickInputButtons.Back?-1:n;this.o.set(t,h)}),this.z({buttons:r.map((h,n)=>({...i(h),tooltip:h.tooltip,handle:h===P.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const h=this.o.get(r);h&&this.r.fire(h)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,u.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(r){if(!this.v){for(const h of Object.keys(r)){const n=r[h];this.u[h]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function b(l){if(l instanceof P.ThemeIcon)return{id:l.id};const r=g(l),h=y(l);return{dark:typeof r=="string"?C.URI.file(r):r,light:typeof h=="string"?C.URI.file(h):h}}function y(l){return typeof l=="object"&&"light"in l?l.light:l}function g(l){return typeof l=="object"&&"dark"in l?l.dark:l}function i(l){const r=b(l.iconPath);let h,n;return"id"in r?n=k.ThemeIcon.asClassName(r):h=r,{iconPath:h,iconClass:n}}class o extends p{constructor(r,h){super(r.identifier,h),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((n,t)=>{this.C.set(t,n),this.D.set(n,t)});const h=[];for(let n=0;n<r.length;n++){const t=r[n];t.kind===P.QuickPickItemKind.Separator?h.push({type:"separator",label:t.label}):h.push({handle:n,label:t.label,description:t.description,detail:t.detail,picked:t.picked,alwaysShow:t.alwaysShow,buttons:t.buttons?.map((a,w)=>({...i(a),tooltip:a.tooltip,handle:w}))})}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(h=>this.D.has(h)),this.z({activeItems:this.J.map(h=>this.D.get(h))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(h=>this.D.has(h)),this.z({selectedItems:this.L.map(h=>this.D.get(h))})}_fireDidChangeActive(r){const h=(0,I.coalesce)(r.map(n=>this.C.get(n)));this.J=h,this.K.fire(h)}_fireDidChangeSelection(r){const h=(0,I.coalesce)(r.map(n=>this.C.get(n)));this.L=h,this.M.fire(h)}_fireDidTriggerItemButton(r,h){const n=this.C.get(r);if(!n||!n.buttons||!n.buttons.length)return;const t=n.buttons[h];t&&this.N.fire({button:t,item:n})}}class s extends p{constructor(r,h){super(r.identifier,h),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:L.default.Error}):this.z({validationMessage:r.message,severity:r.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new f(E,m)}e.createExtHostQuickOpen=v});var Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c};define(ye[271],De([1,0,2,3,63,6,17,5,15,103,13,26,51,14,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";var m,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(t){if(t)return typeof t.iconPath=="string"?c.URI.file(t.iconPath):c.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function p(t,a){if(!t.iconPath&&!a.iconPath)return 0;if(t.iconPath){if(!a.iconPath)return 1}else return-1;const w=typeof t.iconPath=="string"?t.iconPath:c.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,D=typeof a.iconPath=="string"?a.iconPath:c.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id;return(0,I.comparePaths)(w,D)}function b(t,a){let w=0;if(t.strikeThrough!==a.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==a.faded)return t.faded?1:-1;if(t.tooltip!==a.tooltip)return(t.tooltip||"").localeCompare(a.tooltip||"");if(w=p(t,a),w!==0)return w;if(t.light&&a.light)w=p(t.light,a.light);else{if(t.light)return 1;if(a.light)return-1}if(w!==0)return w;if(t.dark&&a.dark)w=p(t.dark,a.dark);else{if(t.dark)return 1;if(a.dark)return-1}return w}function y(t,a){if(t.command!==a.command)return t.command<a.command?-1:1;if(t.title!==a.title)return t.title<a.title?-1:1;if(t.tooltip!==a.tooltip){if(t.tooltip!==void 0&&a.tooltip!==void 0)return t.tooltip<a.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(t.arguments===a.arguments)return 0;if(t.arguments)if(a.arguments){if(t.arguments.length!==a.arguments.length)return t.arguments.length-a.arguments.length}else return 1;else return-1;for(let w=0;w<t.arguments.length;w++){const D=t.arguments[w],F=a.arguments[w];if(D!==F)return D<F?-1:1}return 0}function g(t,a){let w=(0,I.comparePaths)(t.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(w!==0)return w;if(t.command&&a.command)w=y(t.command,a.command);else{if(t.command)return 1;if(a.command)return-1}if(w!==0)return w;if(t.decorations&&a.decorations)w=b(t.decorations,a.decorations);else{if(t.decorations)return 1;if(a.decorations)return-1}return w}function i(t,a){for(let w=0;w<t.length;w++)if(t[w]!==a[w])return!1;return!0}function o(t,a){return t.command===a.command&&t.title===a.title&&t.tooltip===a.tooltip&&(t.arguments&&a.arguments?i(t.arguments,a.arguments):t.arguments===a.arguments)}function s(t,a){return(0,S.equals)(t,a,o)}class l{get value(){return this.d}set value(a){a=a??"",Be(this,m,"f").$setInputBoxValue(this.l,a),this.m(a)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(a){Be(this,m,"f").$setInputBoxPlaceholder(this.l,a),this.f=a}get validateInput(){return(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(a){if((0,E.checkProposedApiEnabled)(this.k,"scmValidation"),a&&typeof a!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=a,Be(this,m,"f").$setValidationProviderIsEnabled(this.l,!!a)}get enabled(){return this.h}set enabled(a){a=!!a,this.h!==a&&(this.h=a,Be(this,m,"f").$setInputBoxEnablement(this.l,a))}get visible(){return this.j}set visible(a){a=!!a,this.j!==a&&(this.j=a,Be(this,m,"f").$setInputBoxVisibility(this.l,a))}constructor(a,w,D){this.k=a,this.l=D,m.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,m,w,"f")}showValidationMessage(a,w){(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),Be(this,m,"f").$showValidationMessage(this.l,a,w)}$onInputBoxValueChange(a){this.m(a)}m(a){this.d=a,this.e.fire(a)}}e.ExtHostSCMInputBox=l,m=new WeakMap;class r{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(a){this.v=a,this.q.$updateGroupLabel(this.t,this.handle,a)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(a){this.p=a,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(a){this.f=[...a],this.k.fire()}constructor(a,w,D,F,x){this.q=a,this.s=w,this.t=D,this.u=F,this.v=x,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=r.d++}getResourceState(a){return this.g.get(a)}$executeResourceCommand(a,w){const D=this.h.get(a);return D?(0,C.asPromise)(()=>this.s.executeCommand(D.command,...D.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const a=[...this.f].sort(g),D=(0,S.sortedDiff)(this.o,a,g).map(V=>{const M=V.toInsert.map($=>{const O=this.e++;this.g.set(O,$);const U=$.resourceUri;let B;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ie=new R.DisposableStore;B=this.s.converter.toInternal($.command,ie),this.j.set(O,ie)}else this.h.set(O,$.command);const j=f($.decorations),de=$.decorations&&f($.decorations.light)||j,Y=$.decorations&&f($.decorations.dark)||j,q=[de,Y],Q=$.decorations&&$.decorations.tooltip||"",Z=$.decorations&&!!$.decorations.strikeThrough,te=$.decorations&&!!$.decorations.faded,X=$.contextValue||"";return{rawResource:[O,U,q,Q,Z,te,X,B],handle:O}});return{start:V.start,deleteCount:V.deleteCount,toInsert:M}}),F=D.map(({start:V,deleteCount:M,toInsert:$})=>[V,M,$.map(O=>O.rawResource)]),x=D.reverse();for(const{start:V,deleteCount:M,toInsert:$}of x){const O=$.map(B=>B.handle),U=this.n.splice(V,M,...O);for(const B of U)this.g.delete(B),this.h.delete(B),this.j.get(B)?.dispose(),this.j.delete(B)}return this.o=a,F}dispose(){this.l=!0,this.m.fire()}}r.d=0;class h{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(a){this.g!==a&&(this.g=a,Be(this,d,"f").$updateSourceControl(this.t,{count:a}))}get quickDiffProvider(){return this.h}set quickDiffProvider(a){this.h=a,Be(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this.j}set commitTemplate(a){a!==this.j&&(this.j=a,Be(this,d,"f").$updateSourceControl(this.t,{commitTemplate:a}))}get acceptInputCommand(){return this.l}set acceptInputCommand(a){this.k.value=new R.DisposableStore,this.l=a;const w=this.v.converter.toInternal(a,this.k.value);Be(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:w})}get actionButton(){return(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(a){(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=a;const w=a!==void 0?{command:this.v.converter.toInternal(a.command,this.m.value),secondaryCommands:a.secondaryCommands?.map(D=>D.map(F=>this.v.converter.toInternal(F,this.m.value))),description:a.description,enabled:a.enabled}:void 0;Be(this,d,"f").$updateSourceControl(this.t,{actionButton:w??null})}get statusBarCommands(){return this.p}set statusBarCommands(a){if(this.p&&a&&s(this.p,a))return;this.o.value=new R.DisposableStore,this.p=a;const w=(a||[]).map(D=>this.v.converter.toInternal(D,this.o.value));Be(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:w})}get selected(){return this.q}constructor(a,w,D,F,x,V){this.u=a,this.v=D,this.w=F,this.x=x,this.y=V,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=h.d++,this.z=new Map,this.A=new Set,Je(this,d,w,"f"),this.f=new l(a,Be(this,d,"f"),this.t),Be(this,d,"f").$registerSourceControl(this.t,F,x,V)}createResourceGroup(a,w){const D=new r(Be(this,d,"f"),this.v,this.t,a,w),F=A.Event.once(D.onDidDispose)(()=>this.z.delete(D));return this.z.set(D,F),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const a=[],w=[];for(const[D,F]of this.z){F.dispose();const x=D.onDidUpdateResourceStates(()=>{this.A.add(D),this.eventuallyUpdateResourceStates()});A.Event.once(D.onDidDispose)(()=>{this.A.delete(D),x.dispose(),this.e.delete(D.handle),Be(this,d,"f").$unregisterGroup(this.t,D.handle)}),a.push([D.handle,D.id,D.label,D.features]);const V=D._takeResourceStateSnapshot();V.length>0&&w.push([D.handle,V]),this.e.set(D.handle,D)}Be(this,d,"f").$registerGroups(this.t,a,w),this.z.clear()}eventuallyUpdateResourceStates(){const a=[];this.A.forEach(w=>{const D=w._takeResourceStateSnapshot();D.length!==0&&a.push([w.handle,D])}),a.length>0&&Be(this,d,"f").$spliceResourceStates(this.t,a),this.A.clear()}getResourceGroup(a){return this.e.get(a)}setSelectionState(a){this.q=a,this.s.fire(a)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(a=>a.dispose()),Be(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,h.d=0,qe([(0,u.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),qe([(0,u.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(a,w,D){this.l=w,this.m=D,this.g=new Map,this.h=new Map,this.j=new A.Emitter,this.e=a.getProxy(P.MainContext.MainThreadSCM),this.f=a.getProxy(P.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const x=this.g.get(F.sourceControlHandle);if(!x)return F;const V=x.getResourceGroup(F.groupHandle);return V?V.getResourceState(F.handle):F}else if(F&&F.$mid===4){const x=this.g.get(F.sourceControlHandle);return x?x.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const x=this.g.get(F.handle);return x||F}return F}})}createSourceControl(a,w,D,F){this.m.trace("ExtHostSCM#createSourceControl",a.identifier.value,w,D,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const x=on.d++,V=new h(a,this.e,this.l,w,D,F);this.g.set(x,V);const M=this.h.get(k.ExtensionIdentifier.toKey(a.identifier))||[];return M.push(V),this.h.set(k.ExtensionIdentifier.toKey(a.identifier),M),V}getLastInputBox(a){this.m.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const w=this.h.get(k.ExtensionIdentifier.toKey(a.identifier)),D=w&&w[w.length-1];return D&&D.inputBox}$provideOriginalResource(a,w,D){const F=c.URI.revive(w);this.m.trace("ExtHostSCM#$provideOriginalResource",a,F.toString());const x=this.g.get(a);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(F,D)).then(V=>V||null)}$onInputBoxValueChange(a,w){this.m.trace("ExtHostSCM#$onInputBoxValueChange",a);const D=this.g.get(a);return D&&D.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(a,w,D,F){this.m.trace("ExtHostSCM#$executeResourceCommand",a,w,D);const x=this.g.get(a);if(!x)return Promise.resolve(void 0);const V=x.getResourceGroup(w);return V?V.$executeResourceCommand(D,F):Promise.resolve(void 0)}$validateInput(a,w,D){this.m.trace("ExtHostSCM#$validateInput",a);const F=this.g.get(a);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>F.inputBox.validateInput(w,D)).then(x=>{if(!x)return Promise.resolve(void 0);const V=T.MarkdownString.fromStrict(x.message);return V?Promise.resolve([V,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(a){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&this.g.get(a)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=a,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[98],De([1,0,5,3,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(P){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=P.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this.b.fire(P)}get(P,S){return this.a.$getPassword(P,S)}store(P,S,I){return this.a.$setPassword(P,S,I)}delete(P,S){return this.a.$deletePassword(P,S)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[272],De([1,0,7,5,179,6,14,10]),function(ne,e,c,A,u,R,C,P){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,m,d,f,p=c.StatusBarAlignment.Left,b){S.set(this,void 0),I.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Je(this,S,E,"f"),Je(this,I,m,"f"),this.c=L.a++,this.e=d,this.f=f,this.g=p,this.h=this.u(b)}u(E){if(!!(0,P.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(E){this.k=E,this.v()}set name(E){this.m=E,this.v()}set tooltip(E){this.l=E,this.v()}set color(E){this.n=E,this.v()}set backgroundColor(E){E&&!L.b.has(E.id)&&(E=void 0),this.o=E,this.v()}set command(E){this.r?.fromApi!==E&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof E=="string"?this.r={fromApi:E,internal:Be(this,I,"f").toInternal({title:"",command:E},this.p)}:E?this.r={fromApi:E,internal:Be(this,I,"f").toInternal(E,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(E){this.t=E,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let E;this.e?this.f?E=`${this.e.identifier.value}.${this.f}`:E=this.e.identifier.value:E=this.f;let m;this.m?m=this.m:m=(0,u.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const f=C.MarkdownString.fromStrict(this.l);Be(this,S,"f").$setEntry(this.c,E,m,this.k,f,this.r?.internal,d,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,I=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class k{constructor(E){this.b=[],this.a=E.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,u.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(E){const m={message:E};return this.b.unshift(m),this.c(),new c.Disposable(()=>{const d=this.b.indexOf(m);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(E,m){this.a=E.getProxy(A.MainContext.MainThreadStatusBar),this.b=m,this.c=new k(this)}createStatusBarEntry(E,m,d,f){return new L(this.a,this.b,E,m,d,f)}setStatusBarMessage(E,m){const d=this.c.setMessage(E);let f;return typeof m=="number"?f=setTimeout(()=>d.dispose(),m):typeof m<"u"&&m.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(P,S){this.c=S,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=P.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this.a.$registerExtensionStorageKeysToSync(P,S)}async initializeExtensionStorage(P,S,I){const L=await this.a.$initializeExtensionStorage(P,S);let k;return L&&(k=this.d(P,S,L)),k||I}setValue(P,S,I){return this.a.$setValue(P,S,I)}$acceptValue(P,S,I){const L=this.d(P,S,I);L&&this.b.fire({shared:P,key:S,value:L})}d(P,S,I){try{return JSON.parse(I)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${P}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(ye[79],De([1,0,4,25,13,78,2]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let P=class{constructor(I,L,k){this.d=L,this.f=k,this.a=I.workspace??void 0,this.b=I.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(I){return C.URI.joinPath(this.b.workspaceStorageHome,I)}async h(){if(!this.a)return Promise.resolve(void 0);const I=this.a.id,L=await this.g(I);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this.c)return C.URI.joinPath(this.c,I.identifier.value)}globalValue(I){return C.URI.joinPath(this.b.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=qe([We(0,A.IExtHostInitDataService),We(1,u.ILogService),We(2,R.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[41],De([1,0,3,5,4,2,18,6,7,181,11,213,21,30,214,51,10,17,14]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class b{constructor(n,t,a,w){this.k=n,this._id=t,this.l=a,this.m=w,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(F=>this.f=F);const D=this;this.value={get name(){return D.m||""},get processId(){return D.b},get creationOptions(){return D.l},get exitStatus(){return D.h},get state(){return D.j},sendText(F,x=!0){D.o(),D.k.$sendText(D._id,F,x)},show(F){D.o(),D.k.$show(D._id,F)},hide(){D.o(),D.k.$hide(D._id)},dispose(){D.a||(D.a=!0,D.k.$dispose(D._id))},get dimensions(){if(!(D.d===void 0||D.g===void 0))return{columns:D.d,rows:D.g}}}}async create(n,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,d.withNullAsUndefined)(n.shellPath),shellArgs:(0,d.withNullAsUndefined)(n.shellArgs),cwd:(0,d.withNullAsUndefined)(n.cwd),env:(0,d.withNullAsUndefined)(n.env),icon:(0,d.withNullAsUndefined)(l(n.iconPath)),color:m.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,d.withNullAsUndefined)(n.message),strictEnv:(0,d.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(n.location,t?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,t,a,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:a,color:m.ThemeColor.isThemeColor(w)?w.id:void 0,location:this.n(n,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,t){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in n?{viewColumn:p.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,t){this.h=Object.freeze({code:n,reason:t})}setDimensions(n,t){return n===this.d&&t===this.g||n===0||t===0?!1:(this.d=n,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(t=>{t!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class y{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,t){this.g.setDimensions?.({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let g=1,i=class extends P.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(A.MainContext.MainThreadTerminalService),this.s=new E.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[a,w]of this.g)w.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,t){const a=new b(this.a,(0,T.generateUuid)(),n,n.name),w=new y(n.pty);return a.createExtensionTerminal(n.location,this.L(n,t).resolvedExtHostIdentifier,l(n.iconPath),r(n.color)).then(D=>{const F=this.M(D,w);this.h[D]=F}),this.f.push(a),a.value}L(n,t){if(t=t||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const a=n.location.parentTerminal;if(a){const w=this.f.find(D=>D.value===a);w&&(t.resolvedExtHostIdentifier=w._id)}}else n.location&&typeof n.location!="object"?t.location=n.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(n,t){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const w=new y(t),D=this.M(n,w);this.h[n]=D}async $acceptActiveTerminalChanged(n){const t=this.b;if(n===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const a=this.O(n);a&&(this.b=a,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,t){const a=this.O(n);a&&this.I.fire({terminal:a.value,data:t})}async $acceptTerminalDimensions(n,t,a){const w=this.O(n);w&&w.setDimensions(t,a)&&this.G.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,a){this.g.get(n)?.resize(t,a)}async $acceptTerminalTitleChange(n,t){const a=this.O(n);a&&(a.name=t)}async $acceptTerminalClosed(n,t,a){const w=this.Q(this.f,n);if(w!==null){const D=this.f.splice(w,1)[0];D.setExitStatus(t,a),this.C.fire(D.value)}}$acceptTerminalOpened(n,t,a,w){if(t){const x=this.Q(this.f,t);if(x!==null){this.f[x]._id=n,this.D.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const D={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:R.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},F=new b(this.a,n,D,a);this.f.push(F),this.D.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(n,t){this.O(n)?._setProcessId(t)}async $startExtensionTerminal(n,t){const a=this.O(n);if(!a)return{message:(0,I.localize)(0,null,n)};a.isOpen||await new Promise(D=>{const F=this.onDidOpenTerminal(async x=>{x===a.value&&(F.dispose(),D())})});const w=this.g.get(n);w?w.startSendingEvents(t):this.j[n]={initialDimensions:t}}M(n,t){const a=new P.DisposableStore;a.add(t.onProcessReady(D=>this.a.$sendProcessReady(n,D.pid,D.cwd))),a.add(t.onDidChangeProperty(D=>this.a.$sendProcessProperty(n,D))),this.s.startBuffering(n,t.onProcessData),a.add(t.onProcessExit(D=>this.N(n,D))),this.g.set(n,t);const w=this.j[n];return w&&t instanceof y&&(t.startSendingEvents(w.initialDimensions),delete this.j[n]),a}$acceptProcessAckDataEvent(n,t){this.g.get(n)?.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){this.g.get(n)?.input(t)}$acceptTerminalInteraction(n){const t=this.O(n);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(n,t,a){try{this.g.get(n)?.resize(t,a)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(n,t){this.g.get(n)?.shutdown(t)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(t=>this.a.$sendProcessProperty(n,{type:"cwd",value:t}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,t,a){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,a),this.a.$registerProfileProvider(t,n.identifier.value),new S.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(n,t,a){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,a),this.a.$registerQuickFixProvider(n,t),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,t){const a=new v.CancellationTokenSource().token;if(a.isCancellationRequested)return;const w=this.w.get(n);if(!w)return;const D=await w.provideTerminalQuickFixes(t,a);if(D!==null)return D}async $createContributedProfileTerminal(n,t){const a=new v.CancellationTokenSource().token;let w=await this.v.get(n)?.provideTerminalProfile(a);if(!a.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,t);return}this.createTerminalFromOptions(w.options,t)}}async $provideLinks(n,t){const a=this.O(n);if(!a)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const D=new v.CancellationTokenSource;this.z.set(n,D);const F=[],x={terminal:a.value,line:t},V=[];for(const O of this.u)V.push(f.Promises.withAsyncBody(async U=>{D.token.onCancellationRequested(()=>U({provider:O,links:[]}));const B=await O.provideTerminalLinks(x,D.token)||[];D.token.isCancellationRequested||U({provider:O,links:B})}));const M=await Promise.all(V);if(D.token.isCancellationRequested)return[];const $=new Map;for(const O of M)O&&O.links.length>0&&F.push(...O.links.map(U=>{const B={id:g++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return $.set(B.id,{provider:O.provider,link:U}),B}));return this.y.set(n,$),F}$activateLink(n,t){const a=this.y.get(n)?.get(t);!a||a.provider.handleTerminalLink(a.link)}N(n,t){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const a=this.h[n];a&&(a.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,t)}O(n){return this.P(this.f,n)}P(n,t){const a=this.Q(n,t);return a!==null?n[a]:null}Q(n,t){let a=null;return n.some((w,D)=>w._id===t?(a=D,!0):!1),a}getEnvironmentVariableCollection(n){let t=this.l.get(n.identifier.value);return t||(t=new o,this.S(n.identifier.value,t)),t}R(n,t){const a=(0,k.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(n,t.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const a=t[0],w=new o(t[1]);this.S(a,w)})}$acceptDefaultProfile(n,t){const a=this.m;this.m=n,this.n=t,a?.path!==n.path&&this.J.fire(n.path)}S(n,t){this.l.set(n,t),t.onDidChangeCollection(()=>{this.R(n,t)})}};i=qe([We(1,C.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Replace})}append(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,t){const a=this.map.get(n);(!a||a.value!==t.value||a.type!==t.type)&&(this.map.set(n,t),this.b.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((a,w)=>n.call(t,w,a,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends i{constructor(n){super(!1,n)}createTerminal(n,t,a){throw new L.NotSupportedError}createTerminalFromOptions(n,t){throw new L.NotSupportedError}};s=qe([We(0,C.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function l(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function r(h){return m.ThemeColor.isThemeColor(h)?h:void 0}});var Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c};define(ye[273],De([1,0,15,17,22,21,3,64,88,6,23,10,30,5,18,137,14,7,58,93,76,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(O,U,B){this.j=B,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(T.MainContext.MainThreadTesting),this.h=new x(this.f),this.g=new n(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const de=j,Y=de.tests[de.tests.length-1].item.extId;return this.d.get(p.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,m.toItemFromContext)(j)}})}createTestController(O,U,B,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const de=new I.DisposableStore,Y=de.add(new m.ExtHostTestItemCollection(U,B,this.j));Y.root.label=B;const q=new Map,Q=this.f,Z={items:Y.root.children,get label(){return B},set label(X){B=X,Y.root.label=X,Q.$updateController(U,{label:B})},get refreshHandler(){return j},set refreshHandler(X){j=X,Q.$updateController(U,{canRefresh:!!X})},get id(){return U},createRunProfile:(X,J,ie,pe,ve,ke)=>{let Oe=(0,S.hash)(X);for(;q.has(Oe);)Oe++;return ke!==void 0&&(0,g.checkProposedApiEnabled)(O,"testContinuousRun"),new V(this.f,q,U,Oe,X,J,ie,pe,ve,ke)},createTestItem(X,J,ie){return new m.TestItemImpl(U,X,J,ie)},createTestRun:(X,J,ie=!0)=>this.g.createTestRun(U,Y,X,J,ie),set resolveHandler(X){Y.resolveHandler=X},get resolveHandler(){return Y.resolveHandler},dispose:()=>{de.dispose()}};Q.$registerTestController(U,B,!!j),de.add((0,I.toDisposable)(()=>Q.$unregisterTestController(U)));const te={controller:Z,collection:Y,profiles:q};return this.d.set(U,te),de.add((0,I.toDisposable)(()=>this.d.delete(U))),de.add(Y.onDidGenerateDiff(X=>Q.$publishDiff(U,X.map(y.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.h.checkout()}async runTests(O,U=R.CancellationToken.None){const B=t(O);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(B.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(de=>p.TestId.fromExtHostTestItem(de,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:M[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:O.exclude?.map(de=>de.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,B){return(0,c.mapFind)(this.g.trackers,de=>de.id===O?de.getCoverage(U):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(O,U,B,j){return(0,c.mapFind)(this.g.trackers,Y=>Y.id===O?Y.getCoverage(U):void 0)?.resolveFileCoverage(B,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(d.TestResults.to(U))).concat(this.results).sort((U,B)=>B.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const B=this.d.get(p.TestId.fromString(O).controllerId)?.collection;B&&(await B.expand(O,U<0?1/0:U),B.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(y.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map(B=>this.k(B,!1,U)))}async $startContinuousRun(O,U){const B=new R.CancellationTokenSource(U),j=await Promise.all(O.map(de=>this.k(de,!0,B.token)));return!U.isCancellationRequested&&!j.some(de=>de.error)&&await new Promise(de=>U.onCancellationRequested(de)),B.dispose(!0),j}async k(O,U,B){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:de,profiles:Y}=j,q=Y.get(O.profileId);if(!q)return{};const Q=O.testIds.map(J=>de.tree.get(J)).filter(k.isDefined),Z=O.excludeExtIds.map(J=>j.collection.tree.get(J)).filter(k.isDefined).filter(J=>Q.some(ie=>ie.fullId.compare(J.fullId)===2));if(!Q.length)return{};const te=new f.TestRunRequest2(Q.some(J=>J.actual instanceof m.TestItemRootImpl)?void 0:Q.map(J=>J.actual),Z.map(J=>J.actual),q,U),X=(0,y.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(te,a.fromInternal(O,j.collection),B);try{return await q.runHandler(te,B),{}}catch(J){return{error:String(J)}}finally{X&&(X.hasRunningTasks&&!B.isCancellationRequested&&await C.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};s=qe([We(0,E.IExtHostRpcService)],s),e.ExtHostTesting=s;const l=1e4;var r;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(r||(r={}));class h extends I.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,B){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(B));const j=this.B(new A.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,B=this.k.controllerId,j=(0,v.generateUuid)(),de=new w(this.l,U,j),Y=te=>(X,...J)=>{if(Q){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),te(X,...J))},q=(te,X)=>{const J=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(te.uri&&te.range){const ie={range:d.Range.from(te.range),uri:te.uri};for(const pe of J)pe.location=pe.location||ie}this.l.$appendTestMessagesInRun(U,j,p.TestId.fromExtHostTestItem(te,B).toString(),J)};let Q=!1;const Z={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return de.coverageProvider},set coverageProvider(te){de.coverageProvider=te},enqueued:Y(te=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(te,B).toString(),1)}),skipped:Y(te=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(te,B).toString(),5)}),started:Y(te=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(te,B).toString(),2)}),errored:Y((te,X,J)=>{q(te,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(te,B).toString(),6,J)}),failed:Y((te,X,J)=>{q(te,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(te,B).toString(),4,J)}),passed:Y((te,X)=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(te,this.k.controllerId).toString(),3,X)}),appendOutput:(te,X,J)=>{Q||(J&&(this.k.isIncluded(J)?this.s(J):J=void 0),this.l.$appendOutputToRun(U,j,u.VSBuffer.fromString(te),X&&d.location.from(X),J&&p.TestId.fromExtHostTestItem(J,B).toString()))},end:()=>{Q||(Q=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:Z,coverage:de}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),Z}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof m.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.g.has(p.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],B=this.k.colllection.root;for(;;){const j=d.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===B))break;O=O.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class n{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,B){return this.f(O,U,B)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,B,j,de){const Y=this.c.get(B);if(Y)return Y.createRun(j);const q=a.fromPublic(O,U,B,de),Q=t(B);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!B.continuous,profile:Q&&{group:M[Q.kind],id:Q.profileId},exclude:B.exclude?.map(te=>p.TestId.fromExtHostTestItem(te,U.root.id).toString())??[],id:q.id,include:B.include?.map(te=>p.TestId.fromExtHostTestItem(te,U.root.id).toString())??[U.root.id],persist:de});const Z=this.f(B,q);return Z.onEnd(()=>{this.d.$finishedExtensionTestRun(q.id),Z.dispose()}),Z.createRun(j)}f(O,U,B){const j=new h(U,this.d,B);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=n;const t=$=>{if(!!$.profile){if(!($.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class a{static fromPublic(O,U,B,j){return new a(O,(0,v.generateUuid)(),B.include?.map(de=>p.TestId.fromExtHostTestItem(de,O).toString())??[O],B.exclude?.map(de=>p.TestId.fromExtHostTestItem(de,O).toString())??[],j,U)}static fromInternal(O,U){return new a(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,B,j,de,Y){this.controllerId=O,this.id=U,this.isPersisted=de,this.colllection=Y,this.c=B.map(q=>q+"\0"),this.d=j.map(q=>q+"\0")}isIncluded(O){const U=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const B of this.d)if(U===B||U.startsWith(B))return!1;for(const B of this.c)if(U===B||U.startsWith(B))return!0;return!1}}e.TestRunDto=a;class w{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,B){this.f=O,this.g=U,this.h=B}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const B=await this.d;let j=B?.[O];return!this.c||!B||!j?[]:(j.detailedCoverage||(j=B[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,d.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=p.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:B}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...B].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class F extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:d.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new D(this.q)}}class x{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new F;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class V{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?d.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,B,j,de,Y,q,Q=!1,Z=void 0,te=!1){this.controllerId=B,this.profileId=j,this.d=de,this.kind=Y,this.runHandler=q,this.f=Q,this._tag=Z,this.g=te,i.set(this,void 0),o.set(this,void 0),Je(this,i,O,"f"),Je(this,o,U,"f"),U.set(j,this);const X=M[Y];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Be(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:B,tag:Z?d.TestTag.namespace(this.controllerId,Z.id):null,label:de,group:X,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){Be(this,o,"f")?.delete(this.profileId)&&(Je(this,o,void 0,"f"),Be(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,i=new WeakMap,o=new WeakMap;const M={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ye[274],De([1,0,15,3,5,138,14,7]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,k){this.i=k,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(u.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const k=this.i.allEditors();return L?k:k.map(v=>v.value)}async showTextDocument(L,k,v){let T;typeof k=="number"?T={position:C.ViewColumn.from(k),preserveFocus:v}:typeof k=="object"?T={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(L.uri,T),m=E&&this.i.getEditor(E);if(m)return m.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new R.TextEditorDecorationType(this.h,L,k).value}$acceptEditorPropertiesChanged(L,k){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(k.options&&v._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(C.Selection.to);v._acceptSelections(T)}if(k.visibleRanges){const T=c.coalesce(k.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(T)}if(k.options&&this.b.fire({textEditor:v.value,options:{...k.options,lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),E=k.selections.selections.map(C.Selection.to);this.a.fire({textEditor:v.value,selections:E,kind:T})}if(k.visibleRanges){const T=c.coalesce(k.visibleRanges.map(C.Range.to));this.c.fire({textEditor:v.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const k in L){const v=this.i.getEditor(k);if(!v)throw new Error("Unknown text editor");const T=C.ViewColumn.to(L[k]);v.value.viewColumn!==T&&(v._acceptViewColumn(T),this.d.fire({textEditor:v.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(ye[275],De([1,0,2,4,5,6,7,14,26,10]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(T,E){this.b=new Map,this.c=new Map,this.a=T.getProxy(u.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(m,d)=>{if(m&&m.$mid===12)if(this.b.get(m.source)&&S.ExtensionIdentifier.equals(d,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:c.URI.revive(m.uri);return this.c.get(m.source)?.get(k(f))?.get(m.handle)}else return;return m}})}async $getTimeline(T,E,m,d){return this.b.get(T)?.provider.provideTimeline(c.URI.revive(E),m,d)}registerTimelineProvider(T,E,m,d){const f=new R.DisposableStore,p=this.d(E.id,d,f).bind(this);let b;E.onDidChange&&(b=E.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:E.id}),this));const y=this.c;return this.f({...E,scheme:T,onDidChange:void 0,async provideTimeline(g,i,o){i?.resetCache&&(f.clear(),y.get(E.id)?.clear());const s=await E.provideTimeline(g,i,o);if(s==null)return;const l=p(g,i);return{...s,source:E.id,items:s.items.map(l)}},dispose(){for(const g of y.values())g.get(E.id)?.clear();b?.dispose(),f.dispose()}},m)}d(T,E,m){return(d,f)=>{let p;if(f?.cacheResults){let b=this.c.get(T);b===void 0&&(b=new Map,this.c.set(T,b));const y=k(d);p=b.get(y),p===void 0&&(p=new Map,b.set(y,p))}return b=>{const{iconPath:y,...g}=b,i=`${T}|${b.id??b.timestamp}`;p?.set(i,b);let o,s,l;b.iconPath&&(y instanceof C.ThemeIcon?l={id:y.id,color:y.color}:c.URI.isUri(y)?(o=y,s=y):{light:o,dark:s}=y);let r;return C.MarkdownString.isMarkdownString(g.tooltip)?r=P.MarkdownString.from(g.tooltip):(0,I.isString)(g.tooltip)?r=g.tooltip:C.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=P.MarkdownString.from(g.detail)):(0,I.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=g.detail),{...g,id:g.id??void 0,handle:i,source:T,command:b.command?E.toInternal(b.command,m):void 0,icon:o,iconDark:s,themeIcon:l,tooltip:r,accessibilityInformation:b.accessibilityInformation}}}}f(T,E){if(this.b.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this.a.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this.b.set(T.id,{provider:T,extension:E}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(T.id)?.clear();this.b.delete(T.id),this.a.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=L;function k(v){return v?.toString()}}),define(ye[276],De([1,0,6,16,2,5]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,I,L,k){if(this.c.has(I))throw new Error(`Opener with id '${I}' already registered`);const v=k.schemes.find(T=>!C.a.has(T));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(I,L),this.b.$registerUriOpener(I,k.schemes,S,k.label),(0,c.toDisposable)(()=>{this.c.delete(I),this.b.$unregisterUriOpener(I)})}async $canOpenUri(S,I,L){const k=this.c.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const v=u.URI.revive(I);return k.canOpenExternalUri(v,L)}async $openUri(S,I,L){const k=this.c.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(u.URI.revive(I.resolvedUri),{sourceUri:u.URI.revive(I.sourceUri)},L)}}C.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=C}),define(ye[277],De([1,0,5,2,6,11,26]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(I){this.c=new Set,this.d=new Map,this.b=I.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.c.has(C.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=P.a++;return this.c.add(C.ExtensionIdentifier.toKey(I)),this.d.set(k,L),this.b.$registerUriHandler(k,I),(0,u.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(I)),this.d.delete(k),this.b.$unregisterUriHandler(k)})}$handleExternalUri(I,L){const k=this.d.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(A.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(I){return A.URI.revive(await this.b.$createAppUri(I))}}P.a=0,e.ExtHostUrls=P});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[80],De([1,0,3,16,23,2,197,222,94,5]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";var L,k,v,T,E,m,d,f,p,b,y,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(D,F,x,V,M,$,O){L.set(this,void 0),k.set(this,void 0),v.set(this,void 0),T.set(this,void 0),E.set(this,void 0),m.set(this,void 0),d.set(this,""),f.set(this,void 0),p.set(this,!1),b.set(this,!1),y.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new c.Emitter),this._onDidDispose=Be(this,i,"f").event,Je(this,L,D,"f"),Je(this,k,F,"f"),Je(this,f,x,"f"),Je(this,T,V,"f"),Je(this,E,M,"f"),Je(this,m,$,"f"),Je(this,y,s($),"f"),Je(this,g,l($),"f"),Je(this,v,O,"f")}dispose(){Je(this,p,!0,"f"),Be(this,i,"f").fire(),Be(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return Je(this,b,!0,"f"),(0,S.asWebviewUri)(D,Be(this,T,"f"))}get cspSource(){const D=Be(this,m,"f").extensionLocation;if(D.scheme===A.Schemas.https||D.scheme===A.Schemas.http){let F=D.toString();return F.endsWith("/")||(F+="/"),F+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Be(this,d,"f")}set html(D){this.a(),Be(this,d,"f")!==D&&(Je(this,d,D,"f"),Be(this,g,"f")&&!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(Je(this,b,!0,"f"),Be(this,v,"f").report("Webview vscode-resource: uris",Be(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,L,"f"),this.b(D)))}get options(){return this.a(),Be(this,f,"f")}set options(D){this.a(),u.equals(Be(this,f,"f"),D)||Be(this,k,"f").$setOptions(Be(this,L,"f"),n(Be(this,m,"f"),Be(this,E,"f"),D)),Je(this,f,D,"f")}async postMessage(D){if(Be(this,p,"f"))return!1;const F=(0,P.serializeWebviewMessage)(D,{serializeBuffersForPostMessage:Be(this,y,"f")});return Be(this,k,"f").$postMessage(Be(this,L,"f"),F.message,...F.buffers)}a(){if(Be(this,p,"f"))throw new Error("Webview is disposed")}b(D){if(!Be(this,g,"f"))return D;const F=Be(this,m,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,x=Be(this,m,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Be(this,m,"f").extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,M,$,O,U,B)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),de=(0,S.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${de}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,M,$,O,U,B)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),de=(0,S.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${de}${B}`})}}e.ExtHostWebview=o,L=new WeakMap,k=new WeakMap,v=new WeakMap,T=new WeakMap,E=new WeakMap,m=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,y=new WeakMap,g=new WeakMap,i=new WeakMap;function s(w){try{const D=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function l(w){try{const D=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class r{constructor(D,F,x,V,M){this.c=F,this.d=x,this.e=V,this.f=M,this.b=new Map,this.a=D.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(D,F,x){const V=this.g(D);if(V){const{message:M}=(0,P.deserializeWebviewMessage)(F,x.value);V._onMessageEmitter.fire(M)}}$onMissingCsp(D,F){this.e.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,F,x){const V=new o(D,this.a,t(F),this.c,this.d,x,this.f);return this.b.set(D,V),V._onDidDispose(()=>{this.b.delete(D)}),V}deleteWebview(D){this.b.delete(D)}g(D){return this.b.get(D)}}e.ExtHostWebviews=r;function h(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=h;function n(w,D,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||a(w,D)}}e.serializeWebviewOptions=n;function t(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(D=>R.URI.from(D))}}function a(w,D){return[...(D?.getWorkspaceFolders()||[]).map(F=>F.uri),w.extensionLocation]}}),define(ye[278],De([1,0,21,88,6,16,24,2,14,80,75,5,7]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=g(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class E{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,l){const r=this.b(o,s.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const h=new T(s,l);return this.a.set(r,h),h}delete(o,s){const l=this.b(o,s.uri);this.a.delete(l)}b(o,s){return`${o}@@@${s}`}}var m;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(m||(m={}));class d{constructor(){this.a=new Map}addTextProvider(o,s,l){return this.b(0,o,s,l)}addCustomProvider(o,s,l){return this.b(1,o,s,l)}get(o){return this.a.get(o)}b(o,s,l,r){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:l,provider:r}),new v.Disposable(()=>this.a.delete(s))}}class f{constructor(o,s,l,r,h){this.d=s,this.f=l,this.g=r,this.h=h,this.b=new d,this.c=new E,this.a=o.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,l,r){const h=new u.DisposableStore;return b(l)?(h.add(this.b.addTextProvider(s,o,l)),this.a.$registerTextEditorProvider((0,I.toExtensionData)(o),s,r.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(o))):(h.add(this.b.addCustomProvider(s,o,l)),p(l)&&h.add(l.onDidChangeCustomDocument(n=>{const t=this.i(s,n.document.uri);if(y(n)){const a=t.addEdit(n);this.a.$onDidEdit(n.document.uri,s,a,n.label)}else this.a.$onContentChange(n.document.uri,s)})),this.a.$registerCustomEditorProvider((0,I.toExtensionData)(o),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(o))),v.Disposable.from(h,new v.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,l,r,h){const n=this.b.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${s}'`);const t=P.URI.revive(o),a=await n.provider.openCustomDocument(t,{backupId:l,untitledDocumentData:r?.buffer},h);let w;return p(n.provider)&&this.f&&(w=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(s,a,w),{editable:p(n.provider)}}async $disposeCustomDocument(o,s){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=P.URI.revive(o),{document:h}=this.i(s,r);this.c.delete(s,h),h.dispose()}async $resolveCustomEditor(o,s,l,r,h,n){const t=this.b.get(l);if(!t)throw new Error(`No provider found for '${l}'`);const a=S.ViewColumn.to(h),w=this.g.createNewWebview(s,r.contentOptions,t.extension),D=this.h.createNewWebviewPanel(s,l,r.title,a,r.options,w,!0),F=P.URI.revive(o);switch(t.type){case 1:{const{document:x}=this.i(l,F);return t.provider.resolveCustomEditor(x,D,n)}case 0:{const x=this.d.getDocument(F);return t.provider.resolveCustomTextEditor(x,D,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,l){this.i(s,o).disposeEdits(l)}async $onMoveCustomEditor(o,s,l){const r=this.b.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(o);if(!h)throw new Error("No webview found");const n=P.URI.revive(s),t=this.d.getDocument(n);await r.provider.moveCustomTextEditor(t,h,c.CancellationToken.None)}async $undo(o,s,l,r){return this.i(s,o).undo(l,r)}async $redo(o,s,l,r){return this.i(s,o).redo(l,r)}async $revert(o,s,l){const r=this.i(s,o);await this.j(s).revertCustomDocument(r.document,l),r.disposeBackup()}async $onSave(o,s,l){const r=this.i(s,o);await this.j(s).saveCustomDocument(r.document,l),r.disposeBackup()}async $onSaveAs(o,s,l,r){const h=this.i(s,o);return this.j(s).saveCustomDocumentAs(h.document,P.URI.revive(l),r)}async $backup(o,s,l){const r=this.i(s,o),n=await this.j(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},l);return r.updateBackup(n),n.id}i(o,s){const l=this.c.get(o,P.URI.revive(s));if(!l)throw new Error("No custom document found");return l}j(o){const l=this.b.get(o)?.provider;if(!l||!p(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=f;function p(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function y(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function g(i){const o=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,A.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[279],De([1,0,3,6,2,30,14,80,5,7]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";var L,k,v,T,E,m,d,f,p,b,y,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(h,n,t,a){super(),L.set(this,void 0),k.set(this,void 0),v.set(this,void 0),T.set(this,void 0),E.set(this,void 0),m.set(this,void 0),d.set(this,void 0),f.set(this,void 0),p.set(this,!0),b.set(this,void 0),y.set(this,!1),g.set(this,this.B(new c.Emitter)),this.onDidDispose=Be(this,g,"f").event,i.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Be(this,i,"f").event,Je(this,L,h,"f"),Je(this,k,n,"f"),Je(this,T,t,"f"),Je(this,v,a.viewType,"f"),Je(this,E,a.panelOptions,"f"),Je(this,f,a.viewColumn,"f"),Je(this,m,a.title,"f"),Je(this,b,a.active,"f")}dispose(){Be(this,y,"f")||(Je(this,y,!0,"f"),Be(this,g,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,L,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,T,"f")}get viewType(){return this.c(),Be(this,v,"f")}get title(){return this.c(),Be(this,m,"f")}set title(h){this.c(),Be(this,m,"f")!==h&&(Je(this,m,h,"f"),Be(this,k,"f").$setTitle(Be(this,L,"f"),h))}get iconPath(){return this.c(),Be(this,d,"f")}set iconPath(h){this.c(),Be(this,d,"f")!==h&&(Je(this,d,h,"f"),Be(this,k,"f").$setIconPath(Be(this,L,"f"),u.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Be(this,E,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,f,"f")=="number"&&Be(this,f,"f")<0))return Be(this,f,"f")}get active(){return this.c(),Be(this,b,"f")}get visible(){return this.c(),Be(this,p,"f")}_updateViewState(h){Be(this,y,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Je(this,b,h.active,"f"),Je(this,p,h.visible,"f"),Je(this,f,h.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(h,n){this.c(),Be(this,k,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof h>"u"?void 0:C.ViewColumn.from(h),preserveFocus:!!n})}c(){if(Be(this,y,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,v=new WeakMap,T=new WeakMap,E=new WeakMap,m=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,y=new WeakMap,g=new WeakMap,i=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(h,n,t){this.g=n,this.h=t,this.e=new Map,this.f=new Map,this.d=h.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(h,n,t,a,w={}){const D=typeof a=="object"?a.viewColumn:a,F={viewColumn:C.ViewColumn.from(D),preserveFocus:typeof a=="object"&&!!a.preserveFocus},x=(0,P.shouldSerializeBuffersForPostMessage)(h),V=s.c();this.d.$createWebviewPanel((0,P.toExtensionData)(h),V,n,{title:t,panelOptions:l(w),webviewOptions:(0,P.serializeWebviewOptions)(h,this.h,w),serializeBuffersForPostMessage:x},F);const M=this.g.createNewWebview(V,w,h);return this.createNewWebviewPanel(V,n,t,D,w,M,!0)}$onDidChangeWebviewPanelViewStates(h){const n=Object.keys(h);n.sort((t,a)=>{const w=h[t],D=h[a];return w.active?1:D.active?-1:+w.visible-+D.visible});for(const t of n){const a=this.getWebviewPanel(t);if(!a)continue;const w=h[t];a._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this.e.delete(h),this.g.deleteWebview(h)}registerWebviewPanelSerializer(h,n,t){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:t,extension:h}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(h)}),new I.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(h,n,t,a){const w=this.f.get(n);if(!w)throw new Error(`No serializer found for '${n}'`);const{serializer:D,extension:F}=w,x=this.g.createNewWebview(h,t.webviewOptions,F),V=this.createNewWebviewPanel(h,n,t.title,a,t.panelOptions,x,t.active);await D.deserializeWebviewPanel(V,t.state)}createNewWebviewPanel(h,n,t,a,w,D,F){const x=new o(h,this.d,D,{viewType:n,title:t,viewColumn:a,panelOptions:w,active:F});return this.e.set(h,x),x}getWebviewPanel(h){return this.e.get(h)}}e.ExtHostWebviewPanels=s;function l(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[280],De([1,0,3,6,80,14,5,7]),function(ne,e,c,A,u,R,C,P){"use strict";var S,I,L,k,v,T,E,m,d,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends A.Disposable{constructor(i,o,s,l,r,h){super(),S.set(this,void 0),I.set(this,void 0),L.set(this,void 0),k.set(this,void 0),v.set(this,!1),T.set(this,void 0),E.set(this,void 0),m.set(this,void 0),d.set(this,void 0),f.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Be(this,f,"f").event,p.set(this,this.B(new c.Emitter)),this.onDidDispose=Be(this,p,"f").event,Je(this,L,s,"f"),Je(this,E,l,"f"),Je(this,S,i,"f"),Je(this,I,o,"f"),Je(this,k,r,"f"),Je(this,T,h,"f")}dispose(){Be(this,v,"f")||(Je(this,v,!0,"f"),Be(this,p,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,E,"f")}set title(i){this.a(),Be(this,E,"f")!==i&&(Je(this,E,i,"f"),Be(this,I,"f").$setWebviewViewTitle(Be(this,S,"f"),i))}get description(){return this.a(),Be(this,m,"f")}set description(i){this.a(),Be(this,m,"f")!==i&&(Je(this,m,i,"f"),Be(this,I,"f").$setWebviewViewDescription(Be(this,S,"f"),i))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,L,"f")}_setVisible(i){i===Be(this,T,"f")||Be(this,v,"f")||(Je(this,T,i,"f"),Be(this,f,"f").fire())}get badge(){return this.a(),Be(this,d,"f")}set badge(i){this.a(),!(i?.value===Be(this,d,"f")?.value&&i?.tooltip===Be(this,d,"f")?.tooltip)&&(Je(this,d,R.ViewBadge.from(i),"f"),Be(this,I,"f").$setWebviewViewBadge(Be(this,S,"f"),i))}show(i){this.a(),Be(this,I,"f").$show(Be(this,S,"f"),!!i)}a(){if(Be(this,v,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,I=new WeakMap,L=new WeakMap,k=new WeakMap,v=new WeakMap,T=new WeakMap,E=new WeakMap,m=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap;class y{constructor(i,o){this.d=o,this.b=new Map,this.c=new Map,this.a=i.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,s,l){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:i}),this.a.$registerWebviewViewProvider((0,u.toExtensionData)(i),o,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(i)}),new P.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,s,l,r){const h=this.b.get(o);if(!h)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:t}=h,a=this.d.createNewWebview(i,{},t),w=new b(i,this.a,o,s,a,!0);this.c.set(i,w),await n.resolveWebviewView(w,{state:l},r)}async $onDidChangeWebviewViewVisibility(i,o){this.e(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.e(i);this.c.delete(i),o.dispose(),this.d.deleteWebview(i)}e(i){const o=this.c.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=y}),define(ye[141],De([1,0,3,5,2,16,8,4,18]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this.d}constructor(k){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=k.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(k){k!==this.d.focused&&(this.d={...this.d,focused:k},this.c.fire(this.d))}openUri(k,v){let T;if(typeof k=="string"){T=k;try{k=u.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,T,v)}async asExternalUri(k,v){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this.b.$asExternalUri(k,v);return u.URI.from(T)}};I.a={focused:!0},I=qe([We(0,S.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[281],De([1,0,116,282,52,40,2,13,47]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(v,T,E){this.b=v,this.c=T,this.f=E,this.a=A.createServer((m,d)=>this.h(m,d)),this.g().catch(m=>(T.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,T){const E=(d,f)=>{T.writeHead(d,{"content-type":"application/json"}),T.end(JSON.stringify(f||null),p=>p&&this.c.error(p))},m=[];v.setEncoding("utf8"),v.on("data",d=>m.push(d)),v.on("end",async()=>{try{const d=JSON.parse(m.join(""));let f;switch(d.type){case"open":f=await this.i(d);break;case"openExternal":f=await this.j(d);break;case"status":f=await this.l(d);break;case"extensionManagement":f=await this.k(d);break;default:E(404,`Unknown message type: ${d.type}`);break}E(200,f)}catch(d){const f=d instanceof Error?d.message:JSON.stringify(d);E(500,f),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:T,folderURIs:E,forceNewWindow:m,diffMode:d,mergeMode:f,addMode:p,forceReuseWindow:b,gotoLineMode:y,waitMarkerFilePath:g,remoteAuthority:i}=v,o=[];if(Array.isArray(E))for(const h of E)try{o.push({folderUri:C.URI.parse(h)})}catch{}if(Array.isArray(T))for(const h of T)try{(0,S.hasWorkspaceFileExtension)(h)?o.push({workspaceUri:C.URI.parse(h)}):o.push({fileUri:C.URI.parse(h)})}catch{}const s=g?C.URI.file(g):void 0,r={forceNewWindow:m,diffMode:d,mergeMode:f,addMode:p,gotoLineMode:y,forceReuseWindow:b,preferNewWindow:!b&&!s&&!p,waitMarkerFileURI:s,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",o,r),""}async j(v){for(const T of v.uris){const E=C.URI.parse(T),m=E.scheme==="file"?E:T;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(v){const T=m=>m?.map(d=>/\.vsix$/i.test(d)?C.URI.parse(d):d),E={list:v.list,install:T(v.install),uninstall:T(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",E)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&u.existsSync(this.f)&&u.unlinkSync(this.f)}}e.CLIServerBase=I;let L=class extends I{constructor(v,T){super(v,T,(0,c.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,P.ILogService)],L),e.CLIServer=L}),define(ye[283],De([1,0,253,25,18]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let C=class extends c.AbstractExtHostConsoleForwarder{constructor(S,I){super(S,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,I,L){const k=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,L),k.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,I){const L=process[S],k=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,E,m)=>{if(!this.g){v+=T.toString(E);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[I](v.slice(0,d)),v=v.slice(d+1))}k.call(L,T,E,m)}})}};C=qe([We(0,u.IExtHostRpcService),We(1,A.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(ye[284],De([1,0,9,71,30,40,6,5,2,18]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(v,T){super();const E=v.getProxy(P.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async m=>{const d=S.URI.file((0,c.join)((0,A.tmpdir)(),(0,u.generateUuid)()));return await E.$download(m,d),d})}};L=qe([We(0,I.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[285],De([1,0,140,16,204,30]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends c.ExtHostLoggerService{k(S,I,L){return S.scheme===A.Schemas.file?new u.SpdLogLogger(L?.name||(0,R.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.k(S,I,L)}registerLogger(S){super.registerLogger(S),this.l.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.l.$deregisterLogger(S)}}e.ExtHostLoggerService=C}),define(ye[286],De([1,0,52,9,2,79,6,16,17,29]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const o=await super.g(i);if(o.scheme!==P.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let l=0;do{let r;l===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${l}`:`${s}-${l}`,await k(r);const h=A.join(r,"vscode.lock"),n=await m(this.d,h,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),u.URI.file(r);l++}while(l<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const v=1e3,T=10*60*1e3;class E extends C.Disposable{constructor(i,o){super(),this.b=i,this.c=o,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await d(i,o);(!s||s.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await I.Promises.utimes(o,new Date,new Date)}catch(l){i.error(l),i.info(`Lock '${o}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await I.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function m(g,i,o){try{const l={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(i,JSON.stringify(l),{flag:"wx"})}catch(l){g.error(l)}const s=await d(g,i);return!s||s.pid!==process.pid?o?(g.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),b(g,i)):(g.info(`Lock '${i}': Lock acquired.`),new E(g,i))}async function d(g,i){let o;try{o=await I.Promises.readFile(i)}catch(s){return g.error(s),null}try{return JSON.parse(String(o))}catch(s){return g.error(s),null}}async function f(g,i){let o;try{o=await I.Promises.stat(i)}catch(s){return g.error(s),0}return o.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function b(g,i){const o=await d(g,i);if(!o)return g.info(`Lock '${i}': Could not read pid of lock holder.`),y(g,i);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?g.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):g.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await f(g,i)===0)return y(g,i);n=o.willReleaseAt-Date.now()}return y(g,i)}}if(!p(o.pid))return g.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),y(g,i);const s=await f(g,i),l=Date.now()-s;if(l<=T)return g.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;g.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await f(g,i),h=Date.now()-r;return h<=T?(g.info(`Lock '${i}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(g.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),y(g,i))}async function y(g,i){g.info(`Lock '${i}': Deleting a stale lock.`);try{await I.Promises.unlink(i)}catch{}return m(g,i,!0)}}),define(ye[287],De([1,0,30,18,41]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends u.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,S,I){return this.createTerminalFromOptions({name:P,shellPath:S,shellArgs:I})}createTerminalFromOptions(P,S){const I=new u.ExtHostTerminal(this.a,(0,c.generateUuid)(),P,P.name);return this.f.push(I),I.create(P,this.L(P,S)),I.value}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[288],De([1,0,5,18,185,6,25,2,46,24,29,7,12,56,3,129,102,13]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class p extends m.DisposableTunnel{}function b(n){const t=n.trim().split(`
`),a=[];return t.forEach(D=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(D);F&&F.length>=3&&a.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),a.reduce((D,F)=>(D[F.socket]=F,D),{})}e.getSockets=b;function y(...n){const t=[].concat(...n.map(i));return[...new Map(t.filter(a=>a.st==="0A").map(a=>{const w=a.local_address.split(":");return{socket:parseInt(a.inode,10),ip:g(w[0]),port:parseInt(w[1],16)}}).map(a=>[a.ip+":"+a.port,a])).values()]}e.loadListeningPorts=y;function g(n){let t="";if(n.length===8)for(let a=n.length-2;a>=0;a-=2)t+=parseInt(n.substr(a,2),16),a!==0&&(t+=".");else for(let a=n.length-4;a>=0;a-=4)t+=parseInt(n.substr(a,4),16).toString(16),a!==0&&(t+=":");return t}function i(n){const t=n.trim().split(`
`),a=t.shift().trim().split(/\s+/).filter(D=>D!=="rx_queue"&&D!=="tm->when");return t.map(D=>D.trim().split(/\s+/).reduce((F,x,V)=>(F[a[V]||V]=x,F),{}))}e.loadConnectionTable=i;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function s(n){const t=n.trim().split(`
`),a=[];return t.forEach(w=>{const D=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);D&&D.length>=4&&a.push({pid:parseInt(D[1],10),ppid:parseInt(D[2]),cmd:D[3]})}),a}e.getRootProcesses=s;async function l(n,t,a){const w=a.reduce((F,x)=>(F[x.pid]=x,F),{}),D=[];return n.forEach(({socket:F,ip:x,port:V})=>{const M=t[F]?t[F].pid:void 0,$=M?w[M]?.cmd:void 0;M&&$&&!o($)&&D.push({host:x,port:V,detail:$,pid:M})}),D}e.findPorts=l;function r(n,t,a){const w=new Map,D=s(t);for(const F of n){const x=a.get(F.port);if(x){w.set(F.port,x);continue}const V=D.find(M=>M.cmd.includes(`${F.port}`));if(V){let M=V,$;do $=D.find(O=>O.ppid===M.pid),$&&(M=$);while($);w.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else w.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let h=class extends R.Disposable{constructor(t,a,w){super(),this.n=w,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new E.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(c.MainContext.MainThreadTunnelService),v.isLinux&&a.remote.isRemote&&a.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,a){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const w=await this.a.$openTunnel(a,t.displayName);if(w){const D=new p(w.remoteAddress,w.localAddress,()=>this.a.$closeTunnel(w.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,a){const w=this.r();return this.l.set(w,{selector:t,provider:a}),this.a.$registerPortsAttributesProvider(t,w),new k.Disposable(()=>{this.l.delete(w),this.a.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(t,a,w,D,F){const x=[];for(const M of t){const $=this.l.get(M);if(!$)return[];x.push(...await Promise.all(a.map(async O=>$.provider.providePortAttributes(O,w,D,F))))}const V=x.filter(M=>!!M);return V.length>0?V.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const a=new d.MovingAverage;let w;for(;this.h;){const D=new Date().getTime(),F=(await this.findCandidatePorts()).filter(V=>(0,m.isLocalhost)(V.host)||(0,m.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(V=>V.port).join(", ")}`);const x=new Date().getTime()-D;a.update(x),(!w||JSON.stringify(w)!==JSON.stringify(F))&&(w=F,await this.a.$onFoundNewCandidates(w)),await new Promise(V=>setTimeout(()=>V(),this.p(a.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let a=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const w=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(w)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,a){if(this.f.has(t.host)){const w=this.f.get(t.host);w.has(t.port)&&(a&&w.get(t.port).disposeListener.dispose(),await w.get(t.port).tunnel.dispose(),w.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,a){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this.b(t,a);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const D=await w;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const F=this.B(D.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:D,disposeListener:F}),T.TunnelDtoConverter.fromApiTunnel(D)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const a=await Promise.all(t.map(D=>this.c(D.host,D.port,D.detail??""))),w=t.filter((D,F)=>a[F]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(D=>D.port).join(", ")} to ${w.map(D=>D.port).join(", ")}`),w}async findCandidatePorts(){let t="",a="";try{t=await L.Promises.readFile("/proc/net/tcp","utf8"),a=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=y(t,a),D=await new Promise(B=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,de,Y)=>{B(de)})}),F=b(D),x=await L.Promises.readdir("/proc"),V=[];for(const B of x)try{const j=Number(B),de=I.joinPath(P.URI.file("/proc"),B);if((await L.Promises.stat(de.fsPath)).isDirectory()&&!isNaN(j)){const q=await L.Promises.readlink(I.joinPath(de,"cwd").fsPath),Q=await L.Promises.readFile(I.joinPath(de,"cmdline").fsPath,"utf8");V.push({pid:j,cwd:q,cmd:Q})}}catch{}const M=[],$=w.filter(B=>{const j=F[B.socket];return j||M.push(B),j}),O=l($,F,V);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const B=await new Promise(j=>{(0,S.exec)("ps -F -A -l | grep root",(de,Y,q)=>{j(Y)})});this.j=r(M,B,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then(B=>U?B.concat(U):B)}};h=qe([We(0,A.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,f.ILogService)],h),e.ExtHostTunnelService=h}),define(ye[289],De([1,0,17,22,21,11,3,6,111,247,59]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(w,D){try{return JSON.stringify(w,D)}catch{return"null"}}const T="$$ref$$",E={[T]:-1};class m{constructor(D,F){this.jsonString=D,this.referencedBuffers=F}}function d(w,D=null,F=!1){const x=[];return{jsonString:(F?v:JSON.stringify)(w,(M,$)=>{if(typeof $>"u")return E;if(typeof $=="object"){if($ instanceof A.VSBuffer){const O=x.push($)-1;return{[T]:O}}if(D)return D(M,$)}return $}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=d;function f(w,D,F){return JSON.parse(w,(x,V)=>{if(V){const M=V[T];if(typeof M=="number")return D[M];if(F&&V.$mid===1)return F.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=f;function p(w,D){return JSON.stringify(w,D)}function b(w){return w?(D,F)=>F&&F.$mid===1?w.transformOutgoing(F):F:null}var y;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends P.Disposable{constructor(D,F=null,x=null){super(),this[k]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=F,this.g=x,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,M=L.ProxyIdentifier.count;V<M;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(D=>{this.s[D].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(D){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(D){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(D){this.t!==D&&(this.t=D,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(D){return this.g?(0,S.transformIncomingURIs)(D,this.g):D}getProxy(D){const{nid:F,sid:x}=D;return this.l[F]||(this.l[F]=this.F(F,x)),this.l[F]}F(D,F){const x={get:(V,M)=>(typeof M=="string"&&!V[M]&&M.charCodeAt(0)===36&&(V[M]=(...$)=>this.O(D,M,$)),M===s?F:V[M])};return new Proxy(Object.create(null),x)}set(D,F){return this.k[D.nid]=F,F}assertRegistered(D){for(let F=0,x=D.length;F<x;F++){const V=D[F];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(D){if(this.j)return;const F=D.byteLength,x=r.read(D,0),V=x.readUInt8(),M=x.readUInt32();switch(V){case 1:case 2:{let{rpcId:$,method:O,args:U}=n.deserializeRequestJSONArgs(x);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(F,M,$,O,U,V===2);break}case 3:case 4:{let{rpcId:$,method:O,args:U}=n.deserializeRequestMixedArgs(x);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(F,M,$,O,U,V===4);break}case 5:{this.f?.logIncoming(F,M,0,"ack"),this.z(M);break}case 6:{this.I(F,M);break}case 7:{this.J(F,M,void 0);break}case 9:{let $=n.deserializeReplyOKJSON(x);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.J(F,M,$);break}case 10:{const $=n.deserializeReplyOKJSONWithBuffers(x,this.g);this.J(F,M,$);break}case 8:{const $=n.deserializeReplyOKVSBuffer(x);this.J(F,M,$);break}case 11:{let $=n.deserializeReplyErrError(x);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.L(F,M,$);break}case 12:{this.L(F,M,void 0);break}default:console.error("received unexpected message"),console.error(D)}}H(D,F,x,V,M,$){this.f?.logIncoming(D,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(x)}.${V}(`,M);const O=String(F);let U,B;if($){const de=new u.CancellationTokenSource;M.push(de.token),U=this.M(x,V,M),B=()=>de.cancel()}else U=this.M(x,V,M),B=i;this.p[O]=B;const j=n.serializeAcknowledged(F);this.f?.logOutgoing(j.byteLength,F,1,"ack"),this.c.send(j),U.then(de=>{delete this.p[O];const Y=n.serializeReplyOK(F,de,this.h);this.f?.logOutgoing(Y.byteLength,F,1,"reply:",de),this.c.send(Y)},de=>{delete this.p[O];const Y=n.serializeReplyErr(F,de);this.f?.logOutgoing(Y.byteLength,F,1,"replyErr:",de),this.c.send(Y)})}I(D,F){this.f?.logIncoming(D,F,1,"receiveCancel");const x=String(F);this.p[x]?.()}J(D,F,x){this.f?.logIncoming(D,F,0,"receiveReply:",x);const V=String(F);if(!this.s.hasOwnProperty(V))return;const M=this.s[V];delete this.s[V],M.resolveOk(x)}L(D,F,x){this.f?.logIncoming(D,F,0,"receiveReplyErr:",x);const V=String(F);if(!this.s.hasOwnProperty(V))return;const M=this.s[V];delete this.s[V];let $;x&&(x.$isError?($=new Error,$.name=x.name,$.message=x.message,$.stack=x.stack):$=x),M.resolveErr($)}M(D,F,x){try{return Promise.resolve(this.N(D,F,x))}catch(V){return Promise.reject(V)}}N(D,F,x){const V=this.k[D];if(!V)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(D));const M=V[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(D));return M.apply(V,x)}O(D,F,x){if(this.j)return new I.CanceledLazyPromise;let V=null;if(x.length>0&&u.CancellationToken.isCancellationToken(x[x.length-1])&&(V=x.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const M=n.serializeRequestArguments(x,this.h),$=++this.m,O=String($),U=new I.LazyPromise;V&&V.onCancellationRequested(()=>{const j=n.serializeCancel($);this.f?.logOutgoing(j.byteLength,$,0,"cancel"),this.c.send(n.serializeCancel($))}),this.s[O]=U,this.y($);const B=n.serializeRequest($,D,F,M,!!V);return this.f?.logOutgoing(B.byteLength,$,0,`request: ${(0,L.getStringIdentifierForProxy)(D)}.${F}(`,x),this.c.send(B),U}}k=o,l.a=3*1e3,e.RPCProtocol=l;class r{static alloc(D,F,x){const V=new r(A.VSBuffer.alloc(x+1+4),0);return V.writeUInt8(D),V.writeUInt32(F),V}static read(D,F){return new r(D,F)}get buffer(){return this.a}constructor(D,F){this.a=D,this.b=F}static sizeUInt8(){return 1}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const x=this.a.slice(this.b,this.b+D).toString();return this.b+=D,x}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const x=this.a.slice(this.b,this.b+D).toString();return this.b+=D,x}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+D);return this.b+=D,F}static sizeMixedArray(D){let F=0;F+=1;for(let x=0,V=D.length;x<V;x++){const M=D[x];switch(F+=1,M.type){case 1:F+=this.sizeLongString(M.value);break;case 2:F+=this.sizeVSBuffer(M.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let $=0;$<M.buffers.length;++$)F+=this.sizeVSBuffer(M.buffers[$]);break;case 4:break}}return F}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let F=0,x=D.length;F<x;F++){const V=D[F];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let M=0;M<V.buffers.length;++M)this.writeBuffer(V.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const F=new Array(D);for(let x=0;x<D;x++)switch(this.readUInt8()){case 1:F[x]=this.readLongString();break;case 2:F[x]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),$=this.readLongString(),O=[];for(let U=0;U<M;++U)O.push(this.readVSBuffer());F[x]=new L.SerializableObjectWithBuffers(f($,O,null));break}case 4:F[x]=void 0;break}return F}}r.sizeUInt32=4;var h;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(h||(h={}));class n{static a(D){for(let F=0,x=D.length;F<x;F++)if(D[F]instanceof A.VSBuffer||D[F]instanceof L.SerializableObjectWithBuffers||typeof D[F]>"u")return!0;return!1}static serializeRequestArguments(D,F){if(this.a(D)){const x=[];for(let V=0,M=D.length;V<M;V++){const $=D[V];if($ instanceof A.VSBuffer)x[V]={type:2,value:$};else if(typeof $>"u")x[V]={type:4};else if($ instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=d($.value,F);x[V]={type:3,value:A.VSBuffer.fromString(O),buffers:U}}else x[V]={type:1,value:A.VSBuffer.fromString(p($,F))}}return{type:1,args:x}}return{type:0,args:p(D,F)}}static serializeRequest(D,F,x,V,M){switch(V.type){case 0:return this.b(D,F,x,V.args,M);case 1:return this.c(D,F,x,V.args,M)}}static b(D,F,x,V,M){const $=A.VSBuffer.fromString(x),O=A.VSBuffer.fromString(V);let U=0;U+=r.sizeUInt8(),U+=r.sizeShortString($),U+=r.sizeLongString(O);const B=r.alloc(M?2:1,D,U);return B.writeUInt8(F),B.writeShortString($),B.writeLongString(O),B.buffer}static deserializeRequestJSONArgs(D){const F=D.readUInt8(),x=D.readShortString(),V=D.readLongString();return{rpcId:F,method:x,args:JSON.parse(V)}}static c(D,F,x,V,M){const $=A.VSBuffer.fromString(x);let O=0;O+=r.sizeUInt8(),O+=r.sizeShortString($),O+=r.sizeMixedArray(V);const U=r.alloc(M?4:3,D,O);return U.writeUInt8(F),U.writeShortString($),U.writeMixedArray(V),U.buffer}static deserializeRequestMixedArgs(D){const F=D.readUInt8(),x=D.readShortString(),V=D.readMixedArray(),M=new Array(V.length);for(let $=0,O=V.length;$<O;$++){const U=V[$];typeof U=="string"?M[$]=JSON.parse(U):M[$]=U}return{rpcId:F,method:x,args:M}}static serializeAcknowledged(D){return r.alloc(5,D,0).buffer}static serializeCancel(D){return r.alloc(6,D,0).buffer}static serializeReplyOK(D,F,x){if(typeof F>"u")return this.d(D);if(F instanceof A.VSBuffer)return this.e(D,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:M}=d(F.value,x,!0);return this.g(D,V,M)}else return this.f(D,v(F,x))}static d(D){return r.alloc(7,D,0).buffer}static e(D,F){let x=0;x+=r.sizeVSBuffer(F);const V=r.alloc(8,D,x);return V.writeVSBuffer(F),V.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,F){const x=A.VSBuffer.fromString(F);let V=0;V+=r.sizeLongString(x);const M=r.alloc(9,D,V);return M.writeLongString(x),M.buffer}static g(D,F,x){const V=A.VSBuffer.fromString(F);let M=0;M+=r.sizeUInt32,M+=r.sizeLongString(V);for(const O of x)M+=r.sizeVSBuffer(O);const $=r.alloc(10,D,M);$.writeUInt32(x.length),$.writeLongString(V);for(const O of x)$.writeBuffer(O);return $.buffer}static deserializeReplyOKJSON(D){const F=D.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(D,F){const x=D.readUInt32(),V=D.readLongString(),M=[];for(let $=0;$<x;++$)M.push(D.readVSBuffer());return new L.SerializableObjectWithBuffers(f(V,M,F))}static serializeReplyErr(D,F){const x=F?v(R.transformErrorForSerialization(F),null):void 0;if(typeof x!="string")return this.h(D);const V=A.VSBuffer.fromString(x);let M=0;M+=r.sizeLongString(V);const $=r.alloc(11,D,M);return $.writeLongString(V),$.buffer}static deserializeReplyErrError(D){const F=D.readLongString();return JSON.parse(F)}static h(D){return r.alloc(12,D,0).buffer}}var t;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var a;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(a||(a={}))}),define(ye[290],De([1,0,3,39,55,4]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(I){this.a.has(I.id)||(this.a.set(I.id,I),this.b.fire(I.id))}getChannels(){const I=[];return this.a.forEach(L=>I.push(L)),I}getChannel(I){return this.a.get(I)}removeChannel(I){this.a.delete(I),this.c.fire(I)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,18,26,13,290,78,25,48,165,22,10,44,3,6]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(g,i,o,s,l){super(),this.id=g,this.name=i,this.m=o,this.n=s,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Clear,g)}replace(g){const i=this.k;this.info(g),this.n.$update(this.id,P.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(g,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:i))}hide(){this.n.$close(this.id)}g(g,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,C.log)(this.m,g,i),this.visible&&(this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends f{appendLine(g){this.append(g)}}let b=class{constructor(g,i,o,s,l,r){this.i=i,this.j=o,this.k=s,this.l=l,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[i,o]of this.g)o.visible=i===this.h}createOutputChannel(g,i,o){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,l=(0,T.isString)(i)?i:void 0;if((0,T.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const h=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(o.identifier,t))?.[1];h&&(r=(0,C.parseLogLevel)(h));const n=s?this.o(g,r,o):this.n(g,l,o);return n.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),s?this.r(g,r??this.m.getLevel(),n):this.q(g,n)}async n(g,i,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,l=this.k.extUri.joinPath(s,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(g,l,i,o.identifier.value);return new f(h,g,r,this.a,o)}async o(g,i,o){const s=await this.p(o),l=this.k.extUri.joinPath(s,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=l.toString(),h=this.l.createLogger(l,{id:r,name:g,logLevel:i,extensionId:o.identifier.value});return new p(r,g,h,this.a,o)}p(g){let i=this.d.get(g.identifier.value);if(!i){const o=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return i}q(g,i){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return g},append(l){s(),i.then(r=>r.append(l))},appendLine(l){s(),i.then(r=>r.appendLine(l))},clear(){s(),i.then(l=>l.clear())},replace(l){s(),i.then(r=>r.replace(l))},show(l,r){s(),i.then(h=>h.show(l,r))},hide(){s(),i.then(l=>l.hide())},dispose(){o=!0,i.then(l=>l.dispose())}}}r(g,i,o){const s=new d.DisposableStore,l=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new m.Emitter);function h(n){i=n,r.fire(n)}return o.then(n=>{s.add(n),n.logLevel!==i&&h(n.logLevel),s.add(n.onDidChangeLogLevel(t=>h(t)))}),{...this.q(g,o),get logLevel(){return i},onDidChangeLogLevel:r.event,trace(n,...t){l(),o.then(a=>a.trace(n,...t))},debug(n,...t){l(),o.then(a=>a.debug(n,...t))},info(n,...t){l(),o.then(a=>a.info(n,...t))},warn(n,...t){l(),o.then(a=>a.warn(n,...t))},error(n,...t){l(),o.then(a=>a.error(n,...t))},dispose(){s.dispose()}}}};b=qe([We(0,u.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,C.ILoggerService),We(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(ye[291],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(ye[292],De([1,0,32,16,9,12,24,2,4,217,47,235,291]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let T=class cn{constructor(m,d,f,p){this.d=m,this.e=d,this.f=f,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??m})()}hasValidBasename(m,d,f){return typeof d=="string"||typeof d>"u"?this.a.then(p=>this.h(m,p,d)):this.h(m,d,f)}h(m,d,f){return m.scheme===A.Schemas.file||m.scheme===A.Schemas.vscodeRemote?(0,c.isValidBasename)(f??(0,C.basename)(m),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,d){if(m.remoteAuthority)return A.Schemas.vscodeRemote;const f=(0,I.getVirtualWorkspaceScheme)(d.getWorkspace());if(f)return f;const p=d.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:A.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?u.win32:u.posix)}async fileURI(m){let d="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(d=m.substring(2),m="/"):(d=m.substring(2,p),m=m.substring(p)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:d,path:m,query:"",fragment:""})}};T=qe([We(1,v.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(ye[81],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(C,P){this.line=C,this.character=P}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,P){return new c(0,0)}with(C){return new c(0,0)}}e.Position=c;class A{constructor(C,P,S,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(C,P),this.end=new c(S,I)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new A(0,0,0,0)}with(C){return new A(0,0,0,0)}}e.Range=A;var u;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(u=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,32,8,4,9,11,81,17]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",T=" characters skipped \u27EB",E=(v.length+T.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var m;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function f(Q){return!!Q.preview}e.resultIsMatch=f;function p(Q){return!!Q.resource}e.isFileMatch=p;function b(Q){return!!Q.message}e.isProgressMessage=b;var y;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(y=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=g;class i{constructor(Z,te,X){this.ranges=te;const J=Array.isArray(te)?te:[te];if(X&&X.matchLines===1&&o(J)){Z=(0,C.getNLines)(Z,X.matchLines);let ie="",pe=0,ve=0;const ke=Math.floor(X.charsPerLine/5),Oe=[];for(const oe of J){const ae=Math.max(oe.startColumn-ke,0),fe=oe.startColumn+X.charsPerLine;if(ae>ve+ke+E){const ee=v+(ae-ve)+T;ie+=ee+Z.slice(ae,fe),pe+=ae-(ve+ee.length)}else ie+=Z.slice(ve,fe);Oe.push(new l(0,oe.startColumn-pe,oe.endColumn-pe)),ve=fe}this.preview={text:ie,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ie=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:Z,matches:(0,c.mapArrayOrNot)(te,pe=>new s(pe.startLineNumber-ie,pe.startColumn,pe.endLineNumber-ie,pe.endColumn))}}}}e.TextSearchMatch=i;function o(Q){const Z=Q[0].startLineNumber;for(const te of Q)if(te.startLineNumber!==Z||te.endLineNumber!==Z)return!1;return!0}class s{constructor(Z,te,X,J){this.startLineNumber=Z,this.startColumn=te,this.endLineNumber=X,this.endColumn=J}}e.SearchRange=s;class l extends s{constructor(Z,te,X){super(Z,te,Z,X)}}e.OneLineRange=l;var r;(function(Q){Q.List="list",Q.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var h;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,Z=!0){const te=Q&&Q.files&&Q.files.exclude,X=Z&&Q&&Q.search&&Q.search.exclude;if(!te&&!X)return;if(!te||!X)return te||X;let J=Object.create(null);return J=u.mixin(J,u.deepClone(te)),J=u.mixin(J,u.deepClone(X),!0),J}e.getExcludes=n;function t(Q,Z){return Q.excludePattern&&A.match(Q.excludePattern,Z)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&A.match(Q.includePattern,Z)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(te=>{const X=te.folder.fsPath;if(R.isEqualOrParent(Z,X)){const J=S.relative(X,Z);return!te.includePattern||!!A.match(te.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var a;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(a=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(Z,te){super(Z),this.code=te}}e.SearchError=w;function D(Q){const Z=Q.message;if((0,I.isCancellationError)(Q))return new w(Z,a.canceled);try{const te=JSON.parse(Z);return new w(te.message,te.code)}catch{return new w(Z,a.other)}}e.deserializeSearchError=D;function F(Q){const Z={message:Q.message,code:Q.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=F;function x(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=x;function V(Q){return Q.type==="success"}e.isSerializedSearchSuccess=V;function M(Q){return!!Q.path}e.isSerializedFileMatch=M;function $(Q,Z){const te=Q.searchPath?Q.searchPath:Q.relativePath;return(0,C.fuzzyContains)(te,Z)}e.isFilePatternMatch=$;class O{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(Q,Z){const te={...Q||{},...Z||{}};return Object.keys(te).filter(X=>{const J=te[X];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=U;class B{constructor(Z,te){this.c=null,this.a={...Z.excludePattern||{},...te.excludePattern||{}},this.b=A.parse(this.a);let X=Z.includePattern;te.includePattern&&(X?X={...X,...te.includePattern}:X=te.includePattern),X&&(this.c=A.parse(X))}matchesExcludesSync(Z,te,X){return!!(this.b&&this.b(Z,te,X))}includedInQuerySync(Z,te,X){return!(this.b&&this.b(Z,te,X)||this.c&&!this.c(Z,te,X))}includedInQuery(Z,te,X){const J=this.b(Z,te,X),ie=()=>this.c?!!this.c(Z,te,X):!0;return(0,k.isThenable)(J)?J.then(pe=>pe?!1:ie()):ie()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=B;function j(Q){for(const Z in Q)if(typeof Q[Z]!="boolean")return!0;return!1}function de(Q){if(!Q)return;let Z;return te=>(Z||(Z=(Q()||Promise.resolve([])).then(X=>X?q(X):{})),Z.then(X=>!!X[te]))}e.hasSiblingPromiseFn=de;function Y(Q){if(!Q)return;let Z;return te=>{if(!Z){const X=Q();Z=X?q(X):{}}return!!Z[te]}}e.hasSiblingFn=Y;function q(Q){const Z={};for(const te of Q)Z[te]=!0;return Z}}),define(ye[34],De([1,0,15,17,21,3,6,68,16,102,24,8,10,2,183,4,13,205,47,48,25,18,14,7,57,31,5]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g,i,o,s,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function h(V,M,$){return new L.ExtUri(O=>w(O,$)).isEqual(V,M)}function n(V,M,$){return h(V.uri,M.uri,$)?0:(0,k.compare)(V.uri.toString(),M.uri.toString())}function t(V,M,$){return V.index!==M.index?V.index<M.index?-1:1:h(V.uri,M.uri,$)?(0,k.compare)(V.name,M.name):(0,k.compare)(V.uri.toString(),M.uri.toString())}function a(V,M,$,O){const U=V.slice(0).sort((j,de)=>$(j,de,O)),B=M.slice(0).sort((j,de)=>$(j,de,O));return(0,c.delta)(U,B,(j,de)=>$(j,de,O))}function w(V,M){const $=M.getCapabilities(V.scheme);return!($&&$&1024)}class D extends p.Workspace{static toExtHostWorkspace(M,$,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:B,name:j,folders:de,configuration:Y,transient:q,isUntitled:Q}=M,Z=[],te=$;$?de.forEach((pe,ve)=>{const ke=T.URI.revive(pe.uri),Oe=D.o(O||$,ke,U);Oe?(Oe.name=pe.name,Oe.index=pe.index,Z.push(Oe)):Z.push({uri:ke,name:pe.name,index:ve})}):Z.push(...de.map(({uri:pe,name:ve,index:ke})=>({uri:T.URI.revive(pe),name:ve,index:ke}))),Z.sort((pe,ve)=>pe.index<ve.index?-1:1);const X=new D(B,j,Z,!!q,Y?T.URI.revive(Y):null,!!Q,pe=>w(pe,U)),{added:J,removed:ie}=a(te?te.workspaceFolders:[],X.workspaceFolders,n,U);return{workspace:X,added:J,removed:ie}}static o(M,$,O){for(let U=0;U<M.folders.length;U++){const B=M.workspaceFolders[U];if(h(B.uri,$,O))return B}}constructor(M,$,O,U,B,j,de){super(M,O.map(Y=>new p.WorkspaceFolder(Y)),U,B,de),this.t=$,this.u=j,this.q=[],this.s=P.TernarySearchTree.forUris(de),O.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,$){return $&&this.s.get(M)&&(M=(0,L.dirname)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let F=class{constructor(M,$,O,U,B){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=U,this.s=O,this.t=B,this.j=new I.Counter,this.k=new A.Barrier,this.o=M.getProxy(r.MainContext.MainThreadWorkspace),this.q=M.getProxy(r.MainContext.MainThreadMessageService);const j=$.workspace;this.l=j?new D(j.id,j.name,[],!!j.transient,j.configuration?T.URI.revive(j.configuration):null,!!j.isUntitled,de=>w(de,O)):void 0}$initializeWorkspace(M,$){this.v=$,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?T.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,$,O,...U){const B=[];if(Array.isArray(U)&&U.forEach(Q=>{T.URI.isUri(Q.uri)&&!B.some(Z=>h(Z.uri,Q.uri,this.s))&&B.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this.n||[$,O].some(Q=>typeof Q!="number"||Q<0)||O===0&&B.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if($+O>j.length)return!1;const de=j.slice(0);de.splice($,O,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<de.length;Q++){const Z=de[Q];if(de.some((te,X)=>X!==Q&&h(Z.uri,te.uri,this.s)))return!1}de.forEach((Q,Z)=>Q.index=Z);const{added:Y,removed:q}=a(j,de,t,this.s);if(Y.length===0&&q.length===0)return!1;if(this.o){const Q=M.displayName||M.name;this.o.$updateWorkspaceFolders(Q,$,O,B).then(void 0,Z=>{this.n=void 0;const te={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(f.Severity.Error,(0,E.localize)(0,null,Q,Z.toString()),te,[])})}return this.y(de),!0}getWorkspaceFolder(M,$){if(!!this.x)return this.x.getWorkspaceFolder(M,$)}async getWorkspaceFolder2(M,$){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,$)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,$){let O,U="";if(typeof M=="string"?(O=T.URI.file(M),U=M):typeof M<"u"&&(O=M,U=M.fsPath),!O)return U;const B=this.getWorkspaceFolder(O,!0);if(!B)return U;typeof $>"u"&&this.x&&($=this.x.folders.length>1);let j=(0,L.relativePath)(B.uri,O);return $&&B.name&&(j=`${B.name}/${j}`),j}y(M){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:$,added:O,removed:U}=D.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=$||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(M,$,O,U,B=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if($===null?j=!1:$&&(typeof $=="string"?j=$:j=$.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:Y}=x(i.GlobPattern.from(M));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(de),(0,v.withUndefinedAsNull)(Y),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(O),B).then(q=>Array.isArray(q)?q.map(Q=>T.URI.revive(Q)):[])}async findTextInFiles(M,$,O,U,B=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),de=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:Y,folder:q}=x(i.GlobPattern.from($.include)),Q=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,Z={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:de,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:Y,excludePattern:Q},te=!1;if(this.u[j]=X=>{if(te)return;const J=T.URI.revive(X.resource);X.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?O({uri:J,preview:{text:ie.preview.text,matches:(0,c.mapArrayOrNot)(ie.preview.matches,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))},ranges:(0,c.mapArrayOrNot)(ie.ranges,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))}):O({uri:J,text:ie.text,lineNumber:ie.lineNumber})})},B.isCancellationRequested)return{};try{const X=await this.o.$startTextSearch(M,(0,v.withUndefinedAsNull)(q),Z,j,B);return delete this.u[j],X||{}}catch(X){throw delete this.u[j],X}}$handleTextSearchResult(M,$){this.u[$]?.(M)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,$){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,$);const O=this.t.transformOutgoingScheme(M),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,O),(0,C.toDisposable)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(M,$){this.h.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(T.URI.revive(M));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const B=await U.provideEditSessionIdentity(O,$);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(M,$,O,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const B=await this.resolveWorkspaceFolder(T.URI.revive(M));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const j=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!j),!j)return;const de=await j.provideEditSessionIdentityMatch?.($,O,U);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(M){return($,O,U)=>{const B=function(de){$.call(O,de)};return B.extension=M,this.A.event(B,void 0,U)}}async $onWillCreateEditSessionIdentity(M,$,O){const U=await this.resolveWorkspaceFolder(T.URI.revive(M));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},$,async(B,j)=>{const de=Date.now();await Promise.resolve(B),Date.now()-de>O&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),$.isCancellationRequested}};F=qe([We(0,g.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,s.IURITransformerService)],F),e.ExtHostWorkspace=F,e.IExtHostWorkspace=(0,m.createDecorator)("IExtHostWorkspace");function x(V){let M,$;return V&&(typeof V=="string"?M=V:(M=V.pattern,$=T.URI.revive(V.baseUri))),{includePattern:M,folder:$}}}),define(ye[35],De([1,0,23,3,34,5,7,208,127,10,17,4,18,13,2]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(o,s){if(s){const l=s.split(".");let r=o;for(let h=0;r&&h<l.length;h++)r=r[l[h]];return r}}function d(o){return o instanceof E.URI}function f(o){return o&&o.uri instanceof E.URI&&o.languageId&&typeof o.languageId=="string"}function p(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&o.uri instanceof E.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function y(o){if(d(o))return{resource:o};if(f(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(p(o))return{overrideIdentifier:o.languageId};if(b(o))return{resource:o.uri};if(o===null)return{resource:null}}let g=class{constructor(s,l,r){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=l,this.b=r,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new i(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,l))}};g=qe([We(0,v.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,T.ILogService)],g),e.ExtHostConfiguration=g;class i{constructor(s,l,r,h){this.a=new A.Emitter,this.b=s,this.f=h,this.c=l,this.e=P.Configuration.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,l){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=P.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(l,r))}getConfiguration(s,l,r){const h=y(l)||{},n=this.g(s?m(this.e.getValue(void 0,h,this.c.workspace),s):this.e.getValue(void 0,h,this.c.workspace));s&&this.h(s,h,r?.identifier);function t(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const a={has(w){return typeof m(n,w)<"u"},get:(w,D)=>{this.h(s?`${s}.${w}`:w,h,r?.identifier);let F=m(n,w);if(typeof F>"u")F=D;else{let x;const V=(M,$)=>{let O;const U=()=>{x=x||(0,c.deepClone)(n),O=O||m(x,$)};return(0,I.isObject)(M)?new Proxy(M,{get:(B,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(x)return O=O||m(x,$),O[j];const de=B[j];return typeof j=="string"?V(de,`${$}.${j}`):de},set:(B,j,de)=>(U(),O&&(O[j]=de),!0),deleteProperty:(B,j)=>(U(),O&&delete O[j],!0),defineProperty:(B,j,de)=>(U(),O&&Object.defineProperty(O,j,de),!0)}):M};F=V(F,w)}return F},update:(w,D,F,x)=>{w=s?`${s}.${w}`:w;const V=t(F);return D!==void 0?this.b.$updateConfigurationOption(V,w,D,h,x):this.b.$removeConfigurationOption(V,w,h,x)},inspect:w=>{w=s?`${s}.${w}`:w;const D=this.e.inspect(w,h,this.c.workspace);if(D)return{key:w,defaultValue:(0,c.deepClone)(D.policy?.value??D.default?.value),globalValue:(0,c.deepClone)(D.user?.value??D.application?.value),workspaceValue:(0,c.deepClone)(D.workspace?.value),workspaceFolderValue:(0,c.deepClone)(D.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(D.default?.override),globalLanguageValue:(0,c.deepClone)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,c.deepClone)(D.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(D.workspaceFolder?.override),languageIds:(0,c.deepClone)(D.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(a,n,!1),Object.freeze(a)}g(s){const l=r=>(0,I.isObject)(r)?new Proxy(r,{get:(h,n)=>l(h[n]),set:(h,n,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(h,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(h,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return l(s)}h(s,l,r){const h=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),n=r?`[${r.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,l){const r=new P.ConfigurationChangeEvent(s,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,n)=>r.affectsConfiguration(h,y(n))})}k(s){return s.reduce((l,r)=>(l.set(r[0],r[1]),l),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[82],De([1,0,2,17,3,5,7,34,60,35,21,41,18,25,4,16,12,13,77,246,11]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(M){function $(U){if(U!=null)return U}M.from=$;function O(U){if(U!=null)return U}M.to=O})(i||(i={}));var o;(function(M){function $(U){if(U!=null)return U}M.from=$;function O(U){if(U!=null)return U}M.to=O})(o||(o={}));var s;(function(M){function $(U){if(U!=null)return U}M.from=$;function O(U){if(U!=null)return U}M.to=O})(s||(s={}));var l;(function(M){function $(B){if(B){const j=B;return j&&!!j.process}else return!1}M.is=$;function O(B){if(B==null)return;const j={process:B.process,args:B.args};return B.options&&(j.options=s.from(B.options)),j}M.from=O;function U(B){if(B!=null)return new C.ProcessExecution(B.process,B.args,B.options)}M.to=U})(l||(l={}));var r;(function(M){function $(U){if(U!=null)return U}M.from=$;function O(U){if(U!=null)return U}M.to=O})(r||(r={}));var h;(function(M){function $(B){if(B){const j=B;return j&&(!!j.commandLine||!!j.command)}else return!1}M.is=$;function O(B){if(B==null)return;const j={};return B.commandLine!==void 0?j.commandLine=B.commandLine:(j.command=B.command,j.args=B.args),B.options&&(j.options=r.from(B.options)),j}M.from=O;function U(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new C.ShellExecution(B.commandLine,B.options):new C.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=U})(h||(h={}));var n;(function(M){function $(B){if(B){const j=B;return j&&j.customExecution==="customExecution"}else return!1}M.is=$;function O(B){return{customExecution:"customExecution"}}M.from=O;function U(B,j){return j.get(B)}M.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(M){function $(O,U){let B;return O.scope!==void 0&&typeof O.scope!="number"?B=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===C.TaskScope.Workspace&&U&&U.workspaceFile?B=U.workspaceFile:B=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:B}}M.from=$})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var a;(function(M){function $(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}M.from=$})(a||(a={}));var w;(function(M){function $(B,j){if(B==null)return[];const de=[];for(const Y of B){const q=O(Y,j);q&&de.push(q)}return de}M.fromMany=$;function O(B,j){if(B==null)return;let de;B.execution instanceof C.ProcessExecution?de=l.from(B.execution):B.execution instanceof C.ShellExecution?de=h.from(B.execution):B.execution&&B.execution instanceof C.CustomExecution&&(de=n.from(B.execution));const Y=i.from(B.definition);let q;return B.scope?typeof B.scope=="number"?q=B.scope:q=B.scope.uri:q=C.TaskScope.Workspace,!Y||!q?void 0:{_id:B._id,definition:Y,name:B.name,source:{extensionId:j.identifier.value,label:B.source,scope:q},execution:de,isBackground:B.isBackground,group:a.from(B.group),presentationOptions:o.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=O;async function U(B,j,de){if(B==null)return;let Y;l.is(B.execution)?Y=l.to(B.execution):h.is(B.execution)?Y=h.to(B.execution):n.is(B.execution)&&(Y=n.to(B._id,de));const q=i.to(B.definition);let Q;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Q=B.source.scope:Q=await j.resolveWorkspaceFolder(c.URI.revive(B.source.scope)):Q=C.TaskScope.Workspace),!q||!Q)return;const Z=new C.Task(q,Q,B.name,B.source.label,Y,B.problemMatchers);return B.isBackground!==void 0&&(Z.isBackground=B.isBackground),B.group!==void 0&&(Z.group=C.TaskGroup.from(B.group._id),Z.group&&B.group.isDefault&&(Z.group=new C.TaskGroup(Z.group.id,Z.group.label),B.group.isDefault===!0&&(Z.group.isDefault=B.group.isDefault))),B.presentationOptions&&(Z.presentationOptions=o.to(B.presentationOptions)),B._id&&(Z._id=B._id),B.detail&&(Z.detail=B.detail),Z}M.to=U})(w=e.TaskDTO||(e.TaskDTO={}));var D;(function(M){function $(U){return U}M.from=$;function O(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=O})(D||(D={}));class F{constructor($,O,U){this._id=O,this.a=U,g.set(this,void 0),Je(this,g,$,"f")}get task(){return this.a}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}g=new WeakMap;let x=class{constructor($,O,U,B,j,de,Y,q){this.q=new u.Emitter,this.r=new u.Emitter,this.s=new u.Emitter,this.t=new u.Emitter,this.a=$.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=B,this.d=j,this.e=de,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Y,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,O,U){if(!U)return new C.Disposable(()=>{});const B=this.w();return this.j.set(B,{type:O,provider:U,extension:$}),this.a.$registerTaskProvider(B,O),new C.Disposable(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem($,O){this.a.$registerTaskSystem($,O)}fetchTasks($){return this.a.$fetchTasks(D.from($)).then(async O=>{const U=[];for(const B of O){const j=await w.to(B,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const $=[];return this.k.forEach(O=>$.push(O)),$}terminateTask($){if(!($ instanceof F))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,O,U){const B=this.m.get($.id);B&&(this.o.set($.id,B),this.e.attachPtyToTerminal(O,await B.callback(U))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const O=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const O=await this.y($.id);this.s.fire({execution:O,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const O=await this.y($.id);this.t.fire({execution:O,exitCode:$.exitCode})}$provideTasks($,O){const U=this.j.get($);if(!U)return Promise.reject(new Error("no handler found"));const B=[],j=(0,A.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(de=>this.u(O,B,U,de));return new Promise(de=>{j.then(Y=>{Promise.all(B).then(()=>{de(Y)})})})}async $resolveTask($,O){const U=this.j.get($);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const B=await w.to(O,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(B,L.CancellationToken.None);if(!j)return;this.z(j,U);const de=w.from(j,U.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(de.execution)&&await this.x(de,j,!0),await this.v(de)}w(){return this.h++}async x($,O,U){const B=await this.a.$createTaskId($);!U&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,O.execution)),this.m.set(B,O.execution)}async y($,O){if(typeof $=="string"){const j=this.l.get($);if(!j)throw new y.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get($.id);if(U)return U;const B=new Promise((j,de)=>{function Y(q,Q,Z){Z?j(new F(q,Q.id,Z)):de("Unexpected: Task does not exist.")}O?Y(this,$,O):w.to($.task,this.b,this.m).then(q=>Y(this,$,q))});return this.l.set($.id,B),B.then(j=>(this.k.set($.id,j),j),j=>Promise.reject(j))}z($,O){$._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const U=this.n.values();let B=U.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=U.next()}};x=qe([We(0,v.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let V=class extends x{constructor($,O,U,B,j,de,Y,q){super($,O,U,B,j,de,Y,q),this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask($,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=w.from(O,$);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.x(U,O,!1);else throw new y.NotSupportedError;const B=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),B}u($,O,U,B){const j=[];if(B)for(const de of B){this.z(de,U),(!de.definition||!$[de.definition.type])&&this.f.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=w.from(de,U.extension);Y&&n.is(Y.execution)?(j.push(Y),O.push(this.x(Y,de,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v($){if(n.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,O,U){}};V=qe([We(0,v.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(ye[293],De([1,0,9,21,45,38,24,43,31]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(v,T,E){this.k=v,this.l=T,this.o=E,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const T=this.k.folderQueries||[];return new Promise((E,m)=>{const d=f=>{this.f++,v(f)};if(this.g)return E({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const p=f.toString(),b=c.basename(p);this.j&&this.j(p,b)||this.v(d,{base:f,basename:b})}),Promise.all(T.map(f=>this.p(f,d))).then(f=>{E({limitHit:this.e,stats:f[0]||void 0})},f=>{m(new Error((0,u.toErrorMessage)(f)))})})}async p(v,T){const E=new A.CancellationTokenSource,m=this.q(v),d=this.r(),f=new S.QueryGlobTester(this.k,v),p=!f.hasSiblingExcludeClauses();let b;try{this.h.add(E),b=P.StopWatch.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},m,E.token),g=b.elapsed(),i=P.StopWatch.create();return this.g&&!this.e||(y&&y.forEach(o=>{const s=c.posix.relative(v.folder.path,o.path);if(p){const l=c.basename(o.path);this.v(T,{base:v.folder,relativePath:s,basename:l});return}this.s(d,v.folder,s,T)}),this.g&&!this.e)?null:(this.u(d,f,T),{providerTime:g,postProcessTime:i.elapsed()})}finally{E.dispose(),this.h.delete(E)}}q(v){const T=(0,S.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),E=(0,S.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:E,includes:T,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},T,E,m){if(E===this.a){const f=c.basename(this.a);this.v(m,{base:T,relativePath:this.a,basename:f})}function d(f){const p=c.basename(f),b=c.dirname(f);let y=v[b];y||(y=v[b]=[],d(b)),y.push({base:T,relativePath:f,basename:p})}d(E)}u({rootEntries:v,pathToEntries:T},E,m){const d=this,f=this.a;function p(b){const y=(0,S.hasSiblingFn)(()=>b.map(g=>g.basename));for(let g=0,i=b.length;g<i;g++){const o=b[g],{relativePath:s,basename:l}=o;if(E.matchesExcludesSync(s,l,f!==l?y:void 0))continue;const r=T[s];if(r)p(r);else{if(s===f)continue;d.v(m,o)}if(d.e)break}}p(v)}v(v,T){(!this.b||T.relativePath&&this.b(T.relativePath,T.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(T))}}class L{constructor(){this.b=new Map}fileSearch(v,T,E,m){const d=this.c(v.cacheKey),f=new I(v,T,d&&d.token);let p=0;const b=y=>{p+=y.length,E(y.map(g=>this.d(g)))};return this.e(f,L.a,b,m).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:y.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new A.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,T,E,m){m.onCancellationRequested(()=>{v.cancel()});const d=p=>{p&&(f.push(p),T>0&&f.length>=T&&(E(f),f=[]))};let f=[];return v.search(d).then(p=>(f.length&&E(f),p),p=>(f.length&&E(f),Promise.reject(p)))}}L.a=512,e.FileSearchManager=L}),define(ye[294],De([1,0,15,62,38,110,28,16,9,24,8,10,2,160,195,54,13,47,133,292,31]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(a,w,D,F,x){this.a=a,this.b=w,this.c=D,this.d=F,this.e=x}text(a,w,D={}){a=this.f(a,D);const F=this.a.getValue(),x=w&&w.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(w?.map(f.toWorkspaceFolder),D),type:2,contentPattern:a,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:F.search.usePCRE2||x||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(a,w){const D=this.a.getValue();a.isRegExp&&(a.pattern=a.pattern.replace(/\r?\n/g,"\\n"));const F={...a,wordSeparators:D.editor.wordSeparators};return this.j(a,w)&&(F.isCaseSensitive=!0),this.k(a)&&(F.isMultiline=!0),F}file(a,w={}){return{...this.h(a,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(a,w){return a?(a=Array.isArray(a)?a.map(r):r(a),w?this.parseSearchPaths(a):{pattern:o(...Array.isArray(a)?a:[a])}):{}}h(a=[],w={}){const D=this.g(w.includePattern,w.expandPatterns),F=this.g(w.excludePattern,w.expandPatterns),x=a.length>1,V=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(O=>this.q(O,w,F)):a.map(O=>this.r(O,w,F,x))).filter(O=>!!O),M={_reason:w._reason,folderQueries:V,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:F.pattern,includePattern:D.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=c.coalesce(c.flatten(this.c.groups.map(j=>j.editors.map(de=>de.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(j=>(0,y.pathIncludedInQuery)(M,j.fsPath)),B=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...M,...B}}const $=w.extraFileResources&&w.extraFileResources.filter(O=>(0,y.pathIncludedInQuery)(M,O.fsPath));return M.extraFileResources=$&&$.length?$:void 0,M}i(a){const w=[],D=new C.ResourceMap,F={};let x=!1;return a.forEach(V=>{if(V.scheme===P.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(V)){const $=this.b.getWorkspaceFolder(V)?.uri??V.with({path:S.dirname(V.fsPath)});let O=D.get($);O||(x=!0,O={folder:$,includePattern:{}},w.push(O),D.set($,O));const U=S.relative($.fsPath,V.fsPath);(0,k.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else V.fsPath&&(x=!0,F[V.fsPath]=!0)}),{folderQueries:w,includePattern:F,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}j(a,w){if(w.isSmartCase){if(a.isRegExp){if(L.containsUppercaseCharacter(a.pattern,!0))return!0}else if(L.containsUppercaseCharacter(a.pattern))return!0}return!!a.isCaseSensitive}k(a){return a.isMultiline||a.isRegExp&&(0,T.isMultilineRegexSource)(a.pattern)||a.pattern.indexOf(`
`)>=0?!0:!!a.isMultiline}parseSearchPaths(a){const w=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),F=(Array.isArray(a)?a:s(a)).map(B=>{const j=this.e.resolvedUserHome;return j?(0,R.untildify)(B,j.scheme===P.Schemas.file?j.fsPath:j.path):B}),x=A.groupBy(F,B=>w(B)?"searchPaths":"exprSegments"),V=(x.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),M={},$=this.m(x.searchPaths||[]);$&&$.length&&(M.searchPaths=$);const O=c.flatten(V),U=o(...O);return U&&(M.pattern=U),M}l(a,w){return w.disregardExcludeSettings?void 0:(0,y.getExcludes)(a,!w.disregardSearchExcludeSettings)}m(a){if(!a||!a.length)return[];const w=a.flatMap(F=>{let{pathPortion:x,globPortion:V}=i(F);return V&&(V=h(V)),this.n(x).flatMap($=>this.o($,V))}),D=new Map;return w.forEach(F=>{const x=F.searchPath.toString(),V=D.get(x);V?F.pattern&&(V.pattern=V.pattern||{},V.pattern[F.pattern]=!0):D.set(x,{searchPath:F.searchPath,pattern:F.pattern?o(F.pattern):void 0})}),Array.from(D.values())}n(a){if(S.isAbsolute(a)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==P.Schemas.file?[{searchPath:w[0].uri.with({path:a})}]:[{searchPath:v.URI.file(S.normalize(a))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(a=r(a),a.startsWith("../")||a===".."){const F=S.posix.resolve(w.path,a);return[{searchPath:w.with({path:F})}]}const D=h(a);return[{searchPath:w,pattern:D}]}else{if(a==="./"||a===".\\")return[];{const w=a.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(x=>{const V=w.match(new RegExp(`^${L.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return V?{match:V,folder:x}:null}).filter(k.isDefined);if(F.length)return F.map(x=>{const V=x.match[1];return{searchPath:x.folder.uri,pattern:V&&h(V)}});{const x=a.match(/\.[\/\\](.+)[\/\\]?/),V=x?x[1]:a,M=E.localize(0,null,V);throw new Error(M)}}}}o(a,w){const D=a.pattern&&w?`${a.pattern}/${w}`:a.pattern||w,F=[{searchPath:a.searchPath,pattern:D}];return D&&!D.endsWith("**")&&F.push({searchPath:a.searchPath,pattern:D+"/**"}),F}q(a,w,D){const F=this.r((0,f.toWorkspaceFolder)(a.searchPath),w,D,!1);return F?{...F,includePattern:a.pattern}:null}r(a,w,D,F){let x;const V=v.URI.isUri(a)?a:a.uri;if(D.searchPaths){const B=D.searchPaths.filter(j=>(0,I.isEqual)(j.searchPath,V))[0];if(B&&!B.pattern)return null;B&&(x=B.pattern)}const M=this.a.getValue({resource:V}),O={...this.l(M,w)||{},...x||{}},U=v.URI.isUri(a)?(0,I.basename)(a):a.name;return{folder:V,folderName:F?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!M.search.followSymlinks}}};g=qe([We(0,m.IConfigurationService),We(1,f.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,d.ILogService),We(4,b.IPathService)],g),e.QueryBuilder=g;function i(t){const a=t.match(/[\*\{\}\(\)\[\]\?]/);if(a){const w=a.index,D=t.substr(0,w).match(/[/|\\][^/\\]*$/);if(D){let F=t.substr(0,D.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:t.substr((D.index||0)+1)}}}return{pathPortion:t}}function o(...t){return t.length?t.reduce((a,w)=>(a[w]=!0,a),Object.create(null)):void 0}function s(t){return u.splitGlobAware(t,",").map(a=>a.trim()).filter(a=>!!a.length)}function l(t){return[`**/${t}/**`,`**/${t}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r(t){return t.replace(/\\/g,"/")}function h(t){return r(t).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(t,a){t=c.distinct(t,F=>F.toString());const w=[],D=a.getWorkspace();return t&&t.forEach(F=>{let x;if(a.getWorkbenchState()===2)x=(0,I.relativePath)(D.folders[0].uri,F),x&&x!=="."&&(x="./"+x);else{const V=a.getWorkspaceFolder(F);if(V){const M=V.name;if(D.folders.filter(O=>O.name===M).length===1){const O=(0,I.relativePath)(V.uri,F);O===""?x=`./${V.name}`:x=`./${V.name}/${O}`}else x=F.fsPath}}x&&w.push(x)}),w}e.resolveResourcesForSearchIncludes=n}),define(ye[295],De([1,0,24,2,21,11,4,294,31,47]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(m,d){const f=d.activationEvents;if(!f)return Promise.resolve(void 0);const p=[],b=[];for(const l of f)if(/^workspaceContains:/.test(l)){const r=l.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||m.forceUsingSearch?b.push(r):p.push(r)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let y;const g=new Promise((l,r)=>{y=l}),i=l=>y({activationEvent:l}),o=Promise.all(p.map(l=>v(m,l,i))).then(()=>{}),s=T(m,d.identifier,b,i);return Promise.all([o,s]).then(()=>{y(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function v(m,d,f){for(const p of m.folders)if(await m.exists(c.joinPath(A.URI.revive(p),d))){f(`workspaceContains:${d}`);return}}async function T(m,d,f,p){if(f.length===0)return Promise.resolve(void 0);const b=new u.CancellationTokenSource,y=m.checkExists(m.folders,f,b.token),g=setTimeout(async()=>{b.cancel(),m.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let i=!1;try{i=await y}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}b.dispose(),clearTimeout(g),i&&p(`workspaceContains:${f.join(",")}`)}function E(m,d,f,p){const b=m.get(C.IInstantiationService),y=m.get(S.ISearchService),i=b.createInstance(P.QueryBuilder).file(d.map(o=>(0,I.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:f,exists:!0});return y.fileSearch(i,p).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=E});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[42],De([1,0,177,9,83,24,17,6,68,2,13,5,35,237,99,34,27,134,11,26,22,219,7,128,4,25,79,18,90,56,41,3,295,98,221,16,97,43]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g,i,o,s,l,r,h,n,t,a,w,D,F,x,V,M,$){"use strict";var O,U,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Ui extends P.Disposable{constructor(te,X,J,ie,pe,ve,ke,Oe,oe,ae,fe){super(),this.a=this.B(new w.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=J,this.f=ke,this.j=ie,this.k=pe,this.l=ve,this.m=oe,this.p=ae,this.s=fe,this.t=this.g.getProxy(k.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(k.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(k.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new f.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new f.ExtensionDescriptionRegistry(q(this.F,ee)),this.G=new E.ExtHostStorage(this.g,this.l),this.H=new F.ExtHostSecretState(this.g),this.I=Oe,this.h=te.createChild(new n.ServiceCollection([E.IExtHostStorage,this.G],[F.IExtHostSecretState,this.H])),this.J=this.B(new T.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(le,re,N)=>{this.v.$onExtensionActivationError(le,p.transformErrorForSerialization(re),N)},actualActivateExtension:async(le,re)=>{if(f.ExtensionDescriptionRegistry.isHostExtension(le,this.D,this.F))return await this.v.$activateExtension(le,re),new T.HostExtension;const N=this.D.getExtensionDescription(le);return this.Y(N,re)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),u.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){p.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.X(pe))}catch{}await Promise.all(te)}terminate(te,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(ie=>{this.l.error(ie)}),this.g.dispose();const J=this.Q();Promise.race([(0,C.timeout)(5e3),J]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const X=await this.v.$getExtension(te);let J;if(X?.browserNlsBundleUris){J={};for(const ie of Object.keys(X.browserNlsBundleUris))J[ie]=I.URI.revive(X.browserNlsBundleUris[ie])}return X&&{...X,identifier:new b.ExtensionIdentifier(X.identifier.value),extensionLocation:I.URI.revive(X.extensionLocation),browserNlsBundleUris:J}}R(te,X){return this.J.activateByEvent(te,X)}S(te,X){return this.J.activateById(te,X)}activateByIdWithErrors(te,X){return this.S(te,X).then(()=>{const J=this.J.getActivatedExtension(te);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==V.Schemas.file)return te;const X=await this.c.realpath(te.fsPath);return I.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Q(te))),this.L}async W(te){const X=S.TernarySearchTree.forUris(J=>R.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(te.map(async J=>{if(this.ob(J)){const ie=await this.U(J.extensionLocation);X.set(ie,J)}})),X}X(te){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return X;const J=this.J.getActivatedExtension(te);if(!J)return X;try{typeof J.module.deactivate=="function"&&(X=Promise.resolve(J.module.deactivate()).then(void 0,ie=>(this.l.error(ie),Promise.resolve(void 0))))}catch(ie){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ie)}try{(0,P.dispose)(J.subscriptions)}catch(ie){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ie)}return X}async Y(te,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,X).then(J=>{const ie=J.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ie.codeLoadingTime,ie.activateCallTime,ie.activateResolvedTime,X),this.Z(te,X,"success",ie),J},J=>{throw this.Z(te,X,"failure"),J})}Z(te,X,J,ie){const pe=de(te,X);this.u.$publicLog2("extensionActivationTimes",{...pe,...ie||{},outcome:J})}ab(te,X){const J=de(te,X);this.u.$publicLog2("activatePlugin",J);const ie=this.ob(te);if(!ie)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${te.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const pe=new T.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.pb(te,(0,R.joinPath)(te.extensionLocation,ie),pe),this.bb(te)]).then(ve=>(u.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ui.cb(this.l,te.identifier,ve[0],ve[1],pe))).then(ve=>(u.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ve))}bb(te){const X=new g.ExtensionGlobalMemento(te,this.G),J=new g.ExtensionMemento(te.identifier.value,!1,this.G),ie=new x.ExtensionSecrets(te,this.H),pe=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([X.whenReady,J.whenReady,this.I.whenReady]).then(()=>{const ke=this;let Oe,oe;const ae=(0,d.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:J,secrets:ie,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(fe){return A.join(te.extensionLocation.fsPath,fe)},get storagePath(){return ke.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return ke.I.globalValue(te).fsPath},get logPath(){return A.join(ke.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return I.URI.joinPath(ke.f.logsLocation,te.identifier.value)},get storageUri(){return ke.I.workspaceValue(te)},get globalStorageUri(){return ke.I.globalValue(te)},get extensionMode(){return pe},get extension(){return Oe===void 0&&(Oe=new Y(ke,te.identifier,te,ve,!1)),Oe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(te,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!oe){if(!ae)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ae,"message",ee=>ee.data));ae.start(),oe={onDidReceiveMessage:fe,postMessage:ae.postMessage.bind(ae)}}return oe}})})}static cb(te,X,J,ie,pe){return J=J||{activate:void 0,deactivate:void 0},this.db(te,X,J,ie,pe).then(ve=>new T.ActivatedExtension(!1,null,pe.build(),J,ve,ie.subscriptions))}static db(te,X,J,ie,pe){if(typeof J.activate=="function")try{pe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${X.value}`);const ve=typeof global=="object"?global:self,ke=J.activate.apply(ve,[ie]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ke).then(Oe=>(pe.activateResolveStop(),Oe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(J)}eb(te,X){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:X}).then(void 0,J=>{this.l.error(J)})}fb(){this.v.$setPerformanceMarks(u.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const X of te.activationEvents)X==="onStartupFinished"&&this.eb(te,X)}gb(){const te=this.R("*",!0).then(void 0,pe=>{this.l.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.hb(pe.added)));const X=this.j.workspace?this.j.workspace.folders:[],J=this.hb(X),ie=Promise.all([te,J]).then(()=>{});return Promise.race([ie,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),ie}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.ib(te,X))).then(()=>{})}async ib(te,X){if(this.isActivated(X.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,ie={logService:this.l,folders:te.map(ve=>ve.uri),forceUsingSearch:J,exists:ve=>this.c.exists(ve.fsPath),checkExists:(ve,ke,Oe)=>this.t.$checkExists(ve,ke,Oe)},pe=await(0,D.checkActivateWorkspaceContainsExtension)(ie,X);if(!!pe)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:pe.activationEvent}).then(void 0,ve=>this.l.error(ve))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:X}=this.f.environment;if(!te||!X)throw new Error(c.localize(0,null));const J=await this.pb(null,X,new T.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(c.localize(1,null,X.toString()));return new Promise((ie,pe)=>{const ve=(oe,ae)=>{oe?pe(oe):ie(typeof ae=="number"&&ae>0?1:0)},ke=(0,R.originalFSPath)(X),Oe=J.run(ke,ve);Oe&&Oe.then&&Oe.then(()=>{ie(0)}).catch(oe=>{pe(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,X){return this.M[te]=X,(0,P.toDisposable)(()=>{delete this.M[te]})}async lb(te){const X=te.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const J=te.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.M[J]}}async $resolveAuthority(te,X){const J=$.StopWatch.create(!1),ie=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(te)},${X})][${J.elapsed()}ms] `,pe=ae=>this.l.info(`${ie()}${ae}`),ve=(ae,fe=void 0)=>this.l.error(`${ie()}${ae}`,fe);pe("activating resolver...");const{authorityPrefix:ke,resolver:Oe}=await this.lb(te);if(!Oe)return ve("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ke}.`,detail:void 0}};const oe=new C.IntervalTimer;try{pe("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Oe)),oe.cancelAndSet(()=>pe("waiting..."),1e3),pe("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${ke}`);const ae=await Oe.resolve(te,{resolveAttempt:X});u.mark(`code/extHost/didResolveAuthorityOK/${ke}`),oe.dispose(),pe(`returned ${ae.host}:${ae.port}`);const fe={authority:te,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},ee={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:ee,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(u.mark(`code/extHost/didResolveAuthorityError/${ke}`),oe.dispose(),ve("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(te,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(te)})`);const{resolver:J}=await this.lb(te);if(!J)return null;const ie=I.URI.revive(X);if(typeof J.getCanonicalURI>"u")return ie;const pe=await(0,C.asPromise)(()=>J.getCanonicalURI(ie));return pe||ie}static mb(te,X,J){const ie=new f.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ie.deltaExtensions(J.toAdd,J.toRemove);const pe=(0,d.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of J.myToRemove)pe.delete(b.ExtensionIdentifier.toKey(ke));for(const ke of J.myToAdd)pe.add(b.ExtensionIdentifier.toKey(ke));const ve=q(ie,pe);return{globalRegistry:ie,myExtensions:ve}}$startExtensionHost(te){te.toAdd.forEach(ie=>ie.extensionLocation=I.URI.revive(ie.extensionLocation));const{globalRegistry:X,myExtensions:J}=Ui.mb(this.F,this.D,te);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(J),this.kb()}$activateByEvent(te,X){return X===1?this.R(te,!1):this.z.wait().then(J=>this.R(te,!1))}async $activate(te,X){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,X),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ve=>ve.extensionLocation=I.URI.revive(ve.extensionLocation));const{globalRegistry:X,myExtensions:J}=Ui.mb(this.F,this.D,te),ie=await this.W(J);return(await this.getExtensionPathIndex()).setSearchTree(ie),this.F.set(X.getAllExtensionDescriptions()),this.D.set(J),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const X=y.VSBuffer.alloc(te),J=Math.random()%256;for(let ie=0;ie<te;ie++)X.writeUInt8(J,ie);return X}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};j=qe([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,h.IExtHostRpcService),We(3,m.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,l.IExtHostInitDataService),We(7,r.IExtensionStoragePaths),We(8,t.IExtHostTunnelService),We(9,a.IExtHostTerminalService),We(10,M.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function de(Z,te){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class Y{constructor(te,X,J,ie,pe){O.set(this,void 0),U.set(this,void 0),B.set(this,void 0),Je(this,O,te,"f"),Je(this,U,X,"f"),Je(this,B,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=ie,this.isFromDifferentExtensionHost=pe}get isActive(){return Be(this,O,"f").isActivated(Be(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,O,"f").getExtensionExports(Be(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,O,"f").activateByIdWithErrors(Be(this,B,"f"),{startup:!1,extensionId:Be(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=Y,O=new WeakMap,U=new WeakMap,B=new WeakMap;function q(Z,te){return Z.getAllExtensionDescriptions().filter(X=>te.has(b.ExtensionIdentifier.toKey(X.identifier)))}class Q{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Q}),define(ye[296],De([1,0,83,2,5,35,27,26,18,25,4,42,36,13,8]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(g,i,o,s,l,r,h){this.c=g,this.d=i,this.e=o,this.f=s,this.g=l,this.h=r,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new f(this.c,i,this.d,g,this.i)),this.register(this.e.createInstance(p,i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const i of g.nodeModuleName)this.a.set(i,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(i=>g.alternativeModuleName(i))}};m=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,k.IExtHostExtensionService),We(5,I.IExtHostInitDataService),We(6,T.ILogService)],m),e.RequireInterceptor=m;let d=class rn{constructor(g){if(g.environment.appRoot&&rn.a.size){const i=(0,E.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${l}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const i=this.b.exec(this.c(g));if(!i)return;const[,o,s,l]=i,r=rn.a.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),o+r+l}c(g){return g.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,I.IExtHostInitDataService)],d);class f{constructor(g,i,o,s,l){this.c=g,this.d=i,this.e=o,this.f=s,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(g,i){const o=this.d.findSubstr(i);if(o){let s=this.a.get(P.ExtensionIdentifier.toKey(o.identifier));return s||(s=this.c(o,this.e,this.f),this.a.set(P.ExtensionIdentifier.toKey(o.identifier),s)),s}if(!this.b){let s="";this.d.forEach((l,r)=>s+=`	${r} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(g,i,o){this.d=g,this.nodeModuleName="keytar",this.a=i.getProxy(u.MainContext.MainThreadTelemetry);const{environment:s}=o,l=i.getProxy(u.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.b=new Set,this.b.add(`${r}/node_modules.asar/keytar`),this.b.add(`${r}/node_modules/keytar`)}this.c={getPassword:(r,h)=>l.$getPassword(r,h),setPassword:(r,h,n)=>l.$setPassword(r,h,n),deletePassword:(r,h)=>l.$deletePassword(r,h),findPassword:r=>l.$findPassword(r),findCredentials(r){return l.$findCredentials(r)}}}load(g,i){const o=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const i=g.length;if(i<=7||!this.b)return;const o=i-7;if((g.charAt(o)==="/"||g.charAt(o)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};p=qe([We(1,S.IExtHostRpcService),We(2,I.IExtHostInitDataService)],p);let b=class{constructor(g,i,o){this.e=g,this.f=i,this.nodeModuleName=["open","opn"],this.d=o.getProxy(u.MainContext.MainThreadTelemetry);const s=o.getProxy(u.MainContext.MainThreadWindow);this.c=(l,r)=>{const h=A.URI.parse(l);return r?this.g(l,r):h.scheme==="http"||h.scheme==="https"?s.$openUri(h,l,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?s.$openUri(h,l,{}):this.g(l,r)}}load(g,i,o){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=o(g),this.c}g(g,i){return this.i(),this.b(g,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([We(2,S.IExtHostRpcService)],b)}),define(ye[49],De([1,0,66,6,9,36,4,60,61,42,7,34,233,35]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class E extends v.AbstractVariableResolverService{constructor(f,p,b,y,g,i,o){function s(){if(b){const l=b.activeEditor();if(l)return l.document.uri;const r=y.tabGroups.all.find(h=>h.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.TextDiffTabInput||r.input instanceof L.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof L.TextTabInput||r.input instanceof L.NotebookEditorTabInput||r.input instanceof L.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:l=>{const r=i.folders.filter(h=>h.name===l);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,r)=>g.getConfiguration(void 0,l).get(r),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return u.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const l=s();if(l){const r=p.getWorkspaceFolder(l);if(r)return u.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(b){const l=b.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(b){const l=b.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>f.getExtension(l)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let m=class extends A.Disposable{constructor(f,p,b,y,g){super(),this.b=f,this.c=p,this.g=b,this.h=y,this.i=g,this.a=new c.Lazy(async()=>{const i=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new E(this.b,this.c,this.g,this.i,i,s,this.j())})}getResolver(){return this.a.value}j(){}};m=qe([We(0,I.IExtHostExtensionService),We(1,k.IExtHostWorkspace),We(2,P.IExtHostDocumentsAndEditors),We(3,T.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(ye[84],De([1,0,17,3,10,2,4,5,61,42,18,7,34,131,226,35,49]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,l,r,h,n,t){this.D=l,this.E=r,this.F=h,this.G=n,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(P.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(a=>{a.onDidChange(w=>{this.I(a)}),this.I(a)})}asDebugSourceUri(s,l){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let h=`debug:${encodeURIComponent(r.path||"")}`,n="?";return l&&(h+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),h+=`${n}ref=${r.sourceReference}`,R.URI.parse(h)}else{if(r.path)return R.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const l=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const h=r.contributes.debuggers;if(h&&h.length>0)for(const n of h)(0,E.isDebuggerMainContribution)(n)&&l.push(n.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(l=>s.push(l)),s}addBreakpoints(s){this.T();const l=s.filter(n=>{const t=n.id;return this.w.has(t)?!1:(this.w.set(t,n),!0)});this.U(l,[],[]);const r=[],h=new Map;for(const n of l)if(n instanceof k.SourceBreakpoint){let t=h.get(n.location.uri.toString());t||(t={type:"sourceMulti",uri:n.location.uri,lines:[]},h.set(n.location.uri.toString(),t),r.push(t)),t.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof k.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(r)}removeBreakpoints(s){this.T();const l=s.filter(t=>this.w.delete(t.id));this.U([],l,[]);const r=l.filter(t=>t instanceof k.SourceBreakpoint).map(t=>t.id),h=l.filter(t=>t instanceof k.FunctionBreakpoint).map(t=>t.id),n=l.filter(t=>t instanceof k.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(r,h,n)}startDebugging(s,l,r){return this.k.$startDebugging(s?s.uri:void 0,l,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,l,r){if(!l)return new k.Disposable(()=>{});const h=this.d++;return this.f.push({type:s,handle:h,provider:l}),this.k.$registerDebugConfigurationProvider(s,r,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,h),new k.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==l),this.k.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(s,l,r){if(!r)return new k.Disposable(()=>{});if(!this.P(s,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this.g++;return this.h.push({type:l,handle:h,factory:r}),this.k.$registerDebugAdapterDescriptorFactory(l,h),new k.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==r),this.k.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(s,l){if(!l)return new k.Disposable(()=>{});const r=this.i++;return this.j.push({type:s,handle:r,factory:l}),new k.Disposable(()=>{this.j=this.j.filter(h=>h.factory!==l)})}async $runInTerminal(s,l){return Promise.resolve(void 0)}async $substituteVariables(s,l){let r;const h=await this.W(s);return h&&(r={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(r,l)}J(s,l){if(s.type==="implementation")return new g(s.implementation)}K(){}async $startDASession(s,l){const r=this,h=await this.V(l);return this.R(this.M(h.type),h).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const t=this.L(n),a=this.J(t,h);if(!a)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const w=a;return this.A.set(s,w),this.Q(h).then(D=>(D&&this.B.set(s,D),w.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const x=F,V={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const M=await this.C.sign(x.arguments.value);V.body={signature:M},w.sendResponse(V)}else throw new Error("no signer")}catch(M){V.success=!1,V.message=M.message,w.sendResponse(V)}}else D&&D.onDidSendMessage&&D.onDidSendMessage(F),F=(0,E.convertToVSCPaths)(F,!0),r.k.$acceptDAMessage(s,F)}),w.onError(F=>{D&&D.onError&&D.onError(F),this.k.$acceptDAError(s,F.name,F.message,F.stack)}),w.onExit(F=>{D&&D.onExit&&D.onExit((0,u.withNullAsUndefined)(F),void 0),this.k.$acceptDAExit(s,(0,u.withNullAsUndefined)(F),void 0)}),D&&D.onWillStartSession&&D.onWillStartSession(),w.startSession()))})}$sendDAMessage(s,l){l=(0,E.convertToDAPaths)(l,!1);const r=this.B.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(l),this.A.get(s)?.sendMessage(l)}$stopDASession(s){const l=this.B.get(s);this.B.delete(s),l&&l.onWillStopSession&&l.onWillStopSession();const r=this.A.get(s);return this.A.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const l=[],r=[],h=[];if(s.added)for(const n of s.added){const t=n.id;if(t&&!this.w.has(t)){let a;if(n.type==="function")a=new k.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")a=new k.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const w=R.URI.revive(n.uri);a=new k.SourceBreakpoint(new k.Location(w,new k.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,k.setBreakpointId)(a,t),this.w.set(t,a),l.push(a)}}if(s.removed)for(const n of s.removed){const t=this.w.get(n);t&&(this.w.delete(n),r.push(t))}if(s.changed){for(const n of s.changed)if(n.id){const t=this.w.get(n.id);if(t){if(t instanceof k.FunctionBreakpoint&&n.type==="function"){const a=t;a.enabled=n.enabled,a.condition=n.condition,a.hitCondition=n.hitCondition,a.logMessage=n.logMessage,a.functionName=n.functionName}else if(t instanceof k.SourceBreakpoint&&n.type==="source"){const a=t;a.enabled=n.enabled,a.condition=n.condition,a.hitCondition=n.hitCondition,a.logMessage=n.logMessage,a.location=new k.Location(R.URI.revive(n.uri),new k.Position(n.line,n.character))}h.push(t)}}}this.U(l,r,h)}$provideDebugConfigurations(s,l,r){return(0,c.asPromise)(async()=>{const h=this.O(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(l);return h.provideDebugConfigurations(n,r)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(s,l,r,h){return(0,c.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(l);return n.resolveDebugConfiguration(t,r,h)})}$resolveDebugConfigurationWithSubstitutedVariables(s,l,r,h){return(0,c.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(l);return n.resolveDebugConfigurationWithSubstitutedVariables(t,r,h)})}async $provideDebugAdapter(s,l){const r=this.N(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.V(l);return this.R(r,h).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(s){const l=await this.V(s);this.m.fire(l)}async $acceptDebugSessionTerminated(s){const l=await this.V(s);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,l){(await this.V(s))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(s,l){const h={session:await this.V(s),event:l.event,body:l.body};this.u.fire(h)}L(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const l=this.h.filter(r=>r.type===s);if(l.length>0)return l[0].factory}N(s){const l=this.h.filter(r=>r.handle===s);if(l.length>0)return l[0].factory}O(s){const l=this.f.filter(r=>r.handle===s);if(l.length>0)return l[0].provider}P(s,l){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const h of r)if(h.label&&h.type&&h.type===l)return!0}}return!1}Q(s){const r=s.configuration.type,h=this.j.filter(n=>n.type===r||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(s)).then(t=>t,t=>null));return Promise.race([Promise.all(h).then(n=>{const t=n.filter(a=>!!a);if(t.length>0)return new y(t)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(s,l){const r=l.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new k.DebugAdapterServer(r));if(s){const n=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>s.createDebugAdapterDescriptor(l,this.S(l,n))).then(t=>{if(t)return t})}const h=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,h))}S(s,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,l,r){(s.length>0||l.length>0||r.length>0)&&this.z.fire(Object.freeze({added:s,removed:l,changed:r}))}async V(s){if(s)if(typeof s=="string"){const l=this.l.get(s);if(l)return l}else{let l=this.l.get(s.id);if(!l){const r=await this.W(s.folderUri),h=s.parent?this.l.get(s.parent):void 0;l=new p(this.k,s.id,s.type,s.name,r,s.configuration,h),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(s){if(s){const l=R.URI.revive(s);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};f=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class p{constructor(s,l,r,h,n,t,a){this.d=s,this.f=l,this.g=r,this.h=h,this.i=n,this.j=t,this.k=a}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,l){return this.d.$customDebugAdapterRequest(this.f,s,l)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=p;class b{constructor(s){this.value=Object.freeze({append(l){s.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=b;class y{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(l=>l.onError?l.onError(s):void 0)}onExit(s,l){this.d.forEach(r=>r.onExit?r.onExit(s,l):void 0)}}class g extends T.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends f{constructor(s,l,r,h,n,t){super(s,l,r,h,n,t)}};i=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[297],De([1,0,11,83,2,5,289,13,89,90,25,202,18,57,42,96]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(b){const y=b.get(P.ILogService),i=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(o=>{y.error(o);const s=c.transformErrorForSerialization(o);i.$onUnexpectedError(s)})}static async installFullHandler(b){const y=b.get(P.ILogService),g=b.get(v.IExtHostRpcService),i=b.get(E.IExtHostExtensionService),o=b.get(m.IExtHostTelemetry),s=g.getProxy(R.MainContext.MainThreadExtensionService),l=g.getProxy(R.MainContext.MainThreadErrors),r=await i.getExtensionPathIndex(),h=new WeakMap;Error.prepareStackTrace=(n,t)=>{let a="",w,D;for(const F of t)a+=`
	at ${F.toString()}`,D=F.getFileName(),!w&&D&&(w=r.findSubstr(u.URI.file(D)));return h.set(n,w?.identifier),`${n.name||"Error"}: ${n.message||""}${a}`},c.setUnexpectedErrorHandler(n=>{y.error(n);const t=c.transformErrorForSerialization(n),a=h.get(n);if(!a){l.$onUnexpectedError(t);return}s.$onExtensionRuntimeError(a,t);const w=o.onExtensionError(a,n);y.trace("forwarded error to extension?",w,a)})}}Error.stackTraceLimit=100;class f{constructor(b,y,g,i,o){this.a=g,this.b=new C.RPCProtocol(b,null,i),y=f.e(y,this.b);const s=new I.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:o}),s.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),s.set(T.IURITransformerService,new T.URITransformerService(i)),s.set(E.IHostUtils,g);const l=new k.InstantiationService(s,!0);l.invokeFunction(d.installEarlyHandler),this.d=l.invokeFunction(r=>r.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=l.invokeFunction(r=>r.get(E.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(d.installFullHandler)}async asBrowserUri(b){const y=this.b.getProxy(R.MainContext.MainThreadExtensionService);return u.URI.revive(await y.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,y){b.allExtensions.forEach(i=>{i.extensionLocation=u.URI.revive(y.transformIncomingURIs(i.extensionLocation));const o={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(s=>o[s]=u.URI.revive(y.transformIncomingURIs(i.browserNlsBundleUris[s]))),i.browserNlsBundleUris=o)}),b.environment.appRoot=u.URI.revive(y.transformIncomingURIs(b.environment.appRoot));const g=b.environment.extensionDevelopmentLocationURI;return g&&(b.environment.extensionDevelopmentLocationURI=g.map(i=>u.URI.revive(y.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=u.URI.revive(y.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=u.URI.revive(y.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=u.URI.revive(y.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=u.URI.revive(y.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=u.URI.revive(y.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=u.URI.revive(y.transformIncomingURIs(b.logsLocation)),b.logFile=u.URI.revive(y.transformIncomingURIs(b.logFile)),b.workspace=y.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=f}),define(ye[298],De([1,0,17,12,184,201,209,84,61,42,18,41,7,49,34,227,229,35]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let p=class extends P.ExtHostDebugServiceBase{constructor(o,s,l,r,h,n,t){super(o,s,l,r,n,t),this.Z=h,this.X=new g}J(o,s){switch(o.type){case"server":return new m.SocketDebugAdapter(o);case"pipeServer":return new m.NamedPipeDebugAdapter(o);case"executable":return new m.ExecutableDebugAdapter(o,s.type)}return super.J(o,s)}S(o,s){const l=m.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(l)return new v.DebugAdapterExecutable(l.command,l.args,l.options)}K(){return new C.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const l=await this.F.getConfigProvider(),r=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),n=o.title||u.localize(0,null),t=JSON.stringify({shell:r,shellArgs:h});let a=await this.X.checkout(t,n),w,D=!1;if(a)w=o.cwd;else{const M={shellPath:r,shellArgs:h,cwd:o.cwd,name:n,iconPath:new v.ThemeIcon("debug")};D=!0,a=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(a,t)}a.show(!0);const F=await a.processId;D?await new Promise(M=>setTimeout(M,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?a.sendText("cls"):r.indexOf("bash")>=0?a.sendText("clear"):A.isWindows?a.sendText("cls"):a.sendText("clear"));const x=(0,d.prepareCommand)(r,o.args,!!o.argsCanBeInterpretedByShell,w,o.env);a.sendText(x);const V=this.onDidTerminateDebugSession(M=>{M.id===s&&(this.X.free(a),V.dispose())});return F}else if(o.kind==="external")return y(o,await this.F.getConfigProvider());return super.$runInTerminal(o,s)}};p=qe([We(0,L.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,k.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,T.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let b;function y(i,o){if(!b)if(A.isWindows)b=new R.WindowsExternalTerminalService;else if(A.isMacintosh)b=new R.MacExternalTerminalService;else if(A.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return b.runInTerminal(i.title,i.cwd,i.args,i.env||{},s.external||{})}class g{constructor(){this.b=new Map}async checkout(o,s){const r=[...this.b.entries()].map(([h,n])=>(0,c.createCancelablePromise)(async t=>{if(h.name!==s||n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await h.processId))return null;const a=Date.now();return n.lastUsedAt+g.a>a||t.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=a,h)}));return await(0,c.firstParallel)(r,h=>!!h)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}g.a=1e3}),define(ye[299],De([1,0,9,2,113,34,60,35,47,41,18,25,82,16,13,77,24,71,49]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(g,i,o,s,l,r,h,n,t){super(g,i,o,s,l,r,h,n),this.B=o,this.C=t,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=v.TaskHandleDTO.from(o,this.B),l=await this.a.$getTaskExecution(s);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(l,i);return this.a.$executeTask(s).catch(()=>{}),r}else{const s=v.TaskDTO.from(i,g);if(s===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(s.execution)&&await this.x(s,i,!1);const l=await this.y(await this.a.$getTaskExecution(s),i);return this.a.$executeTask(s).catch(()=>{}),l}}u(g,i,o,s){const l=[];if(s)for(const r of s){this.z(r,o),(!r.definition||!g[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const h=v.TaskDTO.from(r,o.extension);h&&(l.push(h),v.CustomExecutionDTO.is(h.execution)&&i.push(this.x(h,r,!0)))}return{tasks:l,extension:o.extension}}async v(g){return g}async F(g){let i=g&&g.length>0?g[0]:void 0;if(!i){const o=A.URI.file((0,f.homedir)());i=new S.WorkspaceFolder({uri:o,name:d.basename(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,i){const o=A.URI.revive(g),s={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(o),r=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const t of i.variables)s.variables[t]=await h.resolveAsync(n,t);if(i.process!==void 0){let t;if(i.process.path!==void 0){t=i.process.path.split(c.delimiter);for(let a=0;a<t.length;a++)t[a]=await h.resolveAsync(n,t[a])}s.process=await u.win32.findExecutable(await h.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await h.resolveAsync(n,i.process.cwd):void 0,t)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(g,i,o){return u.win32.findExecutable(g,i,o)}};b=qe([We(0,L.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,E.ILogService),We(7,m.IExtHostApiDeprecationService),We(8,p.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[300],De([1,0,71,49]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends A.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(ye[143],De([1,0,15,17,21,45,16,9,24,2,31]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(p,b,y,g){this.d=p,this.e=b,this.f=y,this.g=g,this.a=null,this.b=!1,this.c=0}search(p,b){const y=this.d.folderQueries||[],g=new u.CancellationTokenSource;return b.onCancellationRequested(()=>g.cancel()),new Promise((i,o)=>{this.a=new T(p);let s=!1;const l=(r,h)=>{if(!s&&!this.b){const n=this.h(r);m(r)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,s=!0,g.cancel(),r=this.j(r,this.d.maxResults-this.c));const t=this.h(r);this.c+=t,(t>0||!m(r))&&this.a.add(r,h)}};Promise.all(y.map((r,h)=>this.k(r,n=>l(n,h),g.token))).then(r=>{g.dispose(),this.a.flush();const h=r.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||h,messages:(0,c.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},r=>{g.dispose();const h=(0,R.toErrorMessage)(r);o(new Error(h))})})}h(p){return m(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const y=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:y.slice(0,b),preview:{matches:g.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,y){const g=new L.QueryGlobTester(this.d,p),i=[],o={report:r=>{if(!this.l(r))return;const h=p.folder.scheme===C.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(r.uri))):void 0,n=S.relativePath(p.folder,r.uri);if(n){const t=g.includedInQuery(n,P.basename(n),h);(0,A.isThenable)(t)?i.push(t.then(a=>{a&&b(r)})):t&&b(r)}}},s=this.n(p),l=await this.e.provideTextSearchResults(v(this.d.contentPattern),s,o,y);return i.length&&await Promise.all(i),l}l(p){if(m(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),y=(0,L.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),g={folder:I.URI.from(p.folder),excludes:y,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=k;function v(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class T{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new d(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!S.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(E(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=T;function E(f){return m(f)?{preview:{matches:(0,c.mapArrayOrNot)(f.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:f.preview.text},ranges:(0,c.mapArrayOrNot)(f.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function m(f){return!!f.preview}e.extensionResultIsMatch=m;class d{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}d.a=4e3,d.b=50,e.BatchedCollector=d}),define(ye[85],De([1,0,6,5,4,293,18,57,13,2,143]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let k=class{constructor(m,d,f){this.k=m,this.l=d,this.n=f,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(m){return this.l.transformOutgoingScheme(m)}registerTextSearchProvider(m,d){if(this.g.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this.g.add(m);const f=this.d++;return this.e.set(f,d),this.c.$registerTextSearchProvider(f,this.o(m)),(0,c.toDisposable)(()=>{this.g.delete(m),this.e.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(m,d){if(this.i.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this.i.add(m);const f=this.d++;return this.h.set(f,d),this.c.$registerFileSearchProvider(f,this.o(m)),(0,c.toDisposable)(()=>{this.i.delete(m),this.h.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(m,d,f,p){const b=v(f),y=this.h.get(m);if(y)return this.j.fileSearch(b,y,g=>{this.c.$handleFileMatch(m,d,g.map(i=>i.resource))},p);throw new Error("unknown provider: "+m)}$clearCache(m){return this.j.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,d,f,p){const b=this.e.get(m);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const y=v(f);return this.q(y,b).search(i=>this.c.$handleTextMatch(m,d,i),p)}$enableExtensionHostSearch(){}q(m,d){return new L.TextSearchManager(m,d,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};k=qe([We(0,C.IExtHostRpcService),We(1,P.IURITransformerService),We(2,S.ILogService)],k),e.ExtHostSearch=k;function v(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(m=>I.URI.revive(m))}}e.reviveQuery=v;function T(E){return{...E,folder:I.URI.revive(E.folder)}}}),define(ye[301],De([1,0,89,142,34,139,35,40,60,41,82,84,85,99,56,77,141,78,48,98,96,61,140,13,218,49,97]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g,i,o,s,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,c.registerSingleton)(o.ILoggerService,i.ExtHostLoggerService,1),(0,c.registerSingleton)(o.ILogService,s.ExtHostLogService,1),(0,c.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,c.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,c.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,c.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,c.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,c.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,c.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,c.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,c.registerSingleton)(y.IExtHostTelemetry,y.ExtHostTelemetry,0),(0,c.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,c.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,81]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function P(k,v,T,E){const m=(0,c.mapArrayOrNot)(T,S),d=new u.TextSearchMatch(v,m,E),f=d.preview.matches;return{ranges:(0,c.mapArrayOrNot)(m,I),uri:k,preview:{text:d.preview.text,matches:(0,c.mapArrayOrNot)(f,I)}}}e.createTextSearchResult=P;function S(k){return new u.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new R.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(v,T){this.a=v,this.b=T}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,A.ILogService)],L),e.OutputChannel=L}),define(ye[302],De([1,0,46,9,86,32,12,8,100,303]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(b,y,g,i){const o=v(b,y,g,i),s=y.folder.fsPath;return{cmd:c.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=k;function v(b,y,g,i){const o=["--files","--hidden","--case-sensitive"];E([y],g,!1).forEach(l=>{const r=(0,S.anchorGlob)(l);if(o.push("-g",r),C.isMacintosh){const h=(0,u.normalizeNFD)(r);h!==r&&o.push("-g",h)}});const s=T([y],i,void 0,!1);return s.globArgs.forEach(l=>{const r=`!${(0,S.anchorGlob)(l)}`;if(o.push("-g",r),C.isMacintosh){const h=(0,u.normalizeNFD)(r);h!==r&&o.push("-g",h)}}),y.disregardIgnoreFiles!==!1?o.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),y.ignoreSymlinks||o.push("--follow"),b.exists&&o.push("--quiet"),o.push("--no-config"),y.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function T(b,y,g,i=!0){const o=[];let s={};return b.forEach(l=>{const r=Object.assign({},l.excludePattern||{},y||{}),h=m(r,i?l.folder.fsPath:void 0,g);o.push(...h.globArgs),h.siblingClauses&&(s=Object.assign(s,h.siblingClauses))}),{globArgs:o,siblingClauses:s}}function E(b,y,g=!0){const i=[];return b.forEach(o=>{const s=Object.assign({},y||{},o.includePattern||{}),l=m(s,g?o.folder.fsPath:void 0);i.push(...l.globArgs)}),i}function m(b,y,g){const i=[],o={};return Object.keys(b).forEach(s=>{if(g&&g.has(s)||!s)return;const l=b[s];s=f(y?d(y,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof l=="boolean"&&l?(s.startsWith("\\\\")&&(s+="**"),i.push(p(s))):l&&l.when&&(o[s]=l)}),{globArgs:i,siblingClauses:o}}function d(b,y){return A.isAbsolute(y)?y:A.join(b,y)}e.getAbsoluteGlob=d;function f(b){return b=P.rtrim(b,"\\"),P.rtrim(b,"/")}function p(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=p}),define(ye[304],De([1,0,46,52,9,305,15,45,38,86,32,12,43,8,10,29,31,302,107]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(s=>s())});class y{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&S.parse(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,p.prepareQuery)(this.b).normalizedLowercase),this.u=l.excludePattern&&S.parse(l.excludePattern),this.t=new Map,l.folderQueries.forEach(r=>{const h=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),n=r.folder.fsPath;l.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==n).forEach(t=>{(0,L.isEqualOrParent)(t,n)&&(h[u.relative(n,t)]=!0)}),this.t.set(n,new i(h,n))})}cancel(){this.l=!0,b.forEach(l=>l())}walk(l,r,h,n,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);r.forEach(a=>{const w=u.basename(a.fsPath);this.u&&this.u(a.fsPath,w)||this.J(h,{relativePath:a.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(l,(a,w)=>{this.x(this.y,this,a,h,n,D=>{if(D){const F=(0,P.toErrorMessage)(D);console.error(F),this.q.push(F),w(D,void 0)}else w(null,void 0)})},(a,w)=>{this.m.stop();const D=a?C.coalesce(a)[0]:null;t(D,this.j)})}w(l,r,h){const n=new Array(l.length),t=new Array(l.length);let a=!1,w=0;if(l.length===0)return h(null,[]);l.forEach((D,F)=>{r(D,(x,V)=>{if(x?(a=!0,n[F]=null,t[F]=x):(n[F]=V,t[F]=null),++w===l.length)return h(a?t:null,n)})})}x(l,r,...h){try{l.apply(r,h)}catch(n){h[h.length-1](n)}}y(l,r,h,n){const t=l.folder.fsPath,a=k.isMacintosh,w=()=>M&&M.kill();b.add(w);let D=B=>{b.delete(w),D=()=>{},n(B)},F="";const x=this.D(),V=(0,f.spawnRipgrepCmd)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),M=V.cmd,$=!Object.keys(V.siblingClauses).length,O=V.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let U=`${V.rgDiskPath} ${O}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),h({message:U}),this.s=0,this.z(M,"utf8",h,(B,j,de)=>{if(B){D(B);return}if(this.j){D();return}const q=(F+(a?I.normalizeNFC(j||""):j)).split(`
`);if(de){const Q=q.length;q[Q-1]=q[Q-1].trim(),q[Q-1]||q.pop()}else F=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=q.length,$){for(const Q of q)if(this.J(r,{base:t,relativePath:Q,searchPath:this.N(l,Q)}),this.j){w();break}(de||this.j)&&D();return}this.G(l,x,t,q,r),de&&(this.H(x,t,r),D())})}spawnFindCmd(l){const r=this.t.get(l.folder.fsPath),h=r.getBasenameTerms(),n=r.getPathTerms(),t=["-L","."];if(h.length||n.length){t.push("-not","(","(");for(const a of h)t.push("-name",a),t.push("-o");for(const a of n)t.push("-path",a),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),c.spawn("find",t,{cwd:l.folder.fsPath})}readStdout(l,r,h){let n="";this.z(l,r,()=>{},(t,a,w)=>{if(t){h(t);return}n+=a,w&&h(null,n)})}z(l,r,h,n){let t=(D,F,x)=>{(D||x)&&(t=()=>{},this.r?.stop()),n(D,F,x)},a=!1;l.stdout?(this.A(l.stdout,r,t),l.stdout.once("data",()=>a=!0)):h({message:"stdout is null"});let w;l.stderr?w=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",D=>{t(D)}),l.on("close",D=>{let F;!a&&(F=this.C(w,r))&&o(F)?t(new Error(`command failed with error code ${D}: ${this.C(w,r)}`)):(this.g&&D===0&&(this.j=!0),t(null,"",!0))})}A(l,r,h){const n=new R.StringDecoder(r);return l.on("data",t=>{h(null,n.write(t))}),n}B(l){const r=[];return l.on("data",h=>{r.push(h)}),r}C(l,r){const h=new R.StringDecoder(r);return l.map(n=>h.write(n)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:r},h,n,t){n.indexOf(this.b)!==-1&&this.J(t,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const a=w=>{const D=u.basename(w),F=u.dirname(w);let x=r[F];x||(x=r[F]=[],a(F)),x.push({base:h,relativePath:w,basename:D,searchPath:this.N(l,w)})};n.forEach(a)}H({rootEntries:l,pathToEntries:r},h,n){const t=this,a=this.t.get(h),w=this.b;function D(F){t.o++;const x=(0,d.hasSiblingFn)(()=>F.map(V=>V.basename));for(let V=0,M=F.length;V<M;V++){const $=F[V],{relativePath:O,basename:U}=$;if(a.test(O,U,w!==U?x:void 0))continue;const B=r[O];if(B)D(B);else{if(t.p++,O===w)continue;t.J(n,$)}if(t.j)break}}D(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,r,h,n,t){const a=l.folder,w=(0,d.hasSiblingFn)(()=>h);this.w(h,(D,F)=>{if(this.l||this.j)return F(null);const x=r?[r,D].join(u.sep):D;if(this.t.get(l.folder.fsPath).test(x,D,this.a.filePattern!==D?w:void 0))return F(null);const V=[a.fsPath,x].join(u.sep);A.lstat(V,(M,$)=>{if(M||this.l||this.j)return F(null);this.L(V,$,(O,U)=>O||this.l||this.j?F(null):U.isDirectory()?(this.o++,this.M(V,$,(B,j)=>B||this.l||this.j||(j=j||"",this.v[j])?F(null):(this.v[j]=!0,m.Promises.readdir(V).then(de=>{if(this.l||this.j)return F(null);this.I(l,x,de,n,Y=>F(Y||null))},de=>{F(null)})))):(this.p++,x===this.b||this.h&&E.isNumber(U.size)&&U.size>this.h||this.J(n,{base:a.fsPath,relativePath:x,searchPath:this.N(l,x)}),F(null,void 0)))})},D=>{const F=D&&C.coalesce(D);return t(F&&F.length>0?F[0]:void 0)})}J(l,r){this.K(r)&&(!this.d||this.d(r.relativePath,u.basename(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(r))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(l,this.c)}return!0}L(l,r,h){return r.isSymbolicLink()?A.stat(l,h):h(null,r)}M(l,r,h){return r.isSymbolicLink()?A.realpath(l,(n,t)=>n?h(n):h(null,t)):h(null,l)}N(l,r){return l.folderName?u.join(l.folderName,r):r}}e.FileWalker=y;class g{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new y(l)}search(l,r,h){this.c.walk(this.a,this.b,l,r,(n,t)=>{h(n,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class i{constructor(l,r){this.expression=l,this.c=r,this.d(l)}d(l){let r,h;Object.keys(l).filter(n=>l[n]).forEach(n=>{u.isAbsolute(n)?(r=r||S.getEmptyExpression(),r[n]=l[n]):(h=h||S.getEmptyExpression(),h[n]=l[n])}),this.a=r&&S.parse(r,{trimForExclusions:!0}),this.b=h&&S.parse(h,{trimForExclusions:!0})}test(l,r,h){return this.b&&this.b(l,r,h)||this.a&&this.a(u.join(this.c,l),r,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...S.getBasenameTerms(this.a)),this.b&&l.push(...S.getBasenameTerms(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...S.getPathTerms(this.a)),this.b&&l.push(...S.getPathTerms(this.b)),l}}function o(s){const l=s.trim().split(`
`),r=l[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return T.uppercaseFirstLetter(l[l.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(ye[306],De([1,0,105,22]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===s)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,C=512,P=512*8,S=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(l,r){super(l),this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class k{static async create(l){let r;if(l!==e.UTF8)r=(await new Promise((n,t)=>{ne(["@vscode/iconv-lite-umd"],n,t)})).getDecoder(m(l));else{const h=new TextDecoder;r={write(n){return h.decode(n,{stream:!0})},end(){return h.decode()}}}return new k(r)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function v(s,l){const r=l.minBytesRequiredForDetection??l.guessEncoding?P:C;return new Promise((h,n)=>{const t=(0,c.newWriteableStream)(V=>V.join("")),a=[];let w=0,D;const F=async()=>{try{const V=await o({buffer:A.VSBuffer.concat(a),bytesRead:w},l.guessEncoding);if(V.seemsBinary&&l.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);V.encoding=await l.overwriteEncoding(V.encoding),D=await k.create(V.encoding);const M=D.write(A.VSBuffer.concat(a).buffer);t.write(M),a.length=0,w=0,h({stream:t,detected:V})}catch(V){x?.dispose(),t.destroy(),n(V)}},x=(0,c.listenStream)(s,{onData:async V=>{D?t.write(D.write(V.buffer)):(a.push(V),w+=V.byteLength,w>=r&&(s.pause(),await F(),setTimeout(()=>s.resume())))},onError:V=>t.error(V),onEnd:async()=>{D||await F(),t.end(D?.end())}})})}e.toDecodeStream=v;async function T(s,l,r){const n=(await new Promise((w,D)=>{ne(["@vscode/iconv-lite-umd"],w,D)})).getEncoder(m(l),r);let t=!1,a=!1;return{read(){if(a)return null;const w=s.read();if(typeof w!="string"){if(a=!0,!t&&r?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=n.end();return D&&D.length>0?(t=!0,A.VSBuffer.wrap(D)):null}return t=!0,A.VSBuffer.wrap(n.write(w))}}}e.toEncodeReadable=T;async function E(s){return(await new Promise((r,h)=>{ne(["@vscode/iconv-lite-umd"],r,h)})).encodingExists(m(s))}e.encodingExists=E;function m(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=m;function d(s,l){if(!s||l<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),h=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&h===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&h===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=s.readUInt8(2);return r===e.UTF8_BOM[0]&&h===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const f=["ascii","utf-16","utf-32"];async function p(s){const l=await new Promise((a,w)=>{ne(["jschardet"],a,w)}),r=s.slice(0,S),h=g(r.buffer),n=l.detect(h);if(!n||!n.encoding)return null;const t=n.encoding.toLowerCase();return 0<=f.indexOf(t)?null:y(n.encoding)}const b={ibm866:"cp866",big5:"cp950"};function y(s){const l=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[l]||l}function g(s){let l="";for(let r=0;r<s.length;r++)l+=String.fromCharCode(s[r]);return l}function i(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=s.match(/windows(\d+)/);return l?"windows-"+l[1]:s}}}e.toCanonicalName=i;function o({buffer:s,bytesRead:l},r){let h=d(s,l),n=!1;if(h!==e.UTF16be&&h!==e.UTF16le&&s){let t=!0,a=!0,w=!1;for(let D=0;D<l&&D<R;D++){const F=D%2===1,x=s.readUInt8(D)===0;if(x&&(w=!0),t&&(F&&!x||!F&&x)&&(t=!1),a&&(F&&x||!F&&!x)&&(a=!1),x&&!t&&!a)break}w&&(t?h=e.UTF16le:a?h=e.UTF16be:n=!0)}return r&&!n&&!h&&s?p(s.slice(0,l)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:n,encoding:h}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,306,29,143]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends u.TextSearchManager{constructor(P,S,I=A,L="searchProcess"){super(P,S,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,c.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=R}),define(ye[307],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(u){if(u&&this.a.has(u)){const R=this.a.get(u);return this.a.delete(u),R}}addDragOperationTransfer(u,R){this.a.set(u,R)}getRenderedTreeElement(u){if(this.b.has(u))return this.b.get(u)}addRenderedTreeItemElement(u,R){this.b.set(u,R)}removeRenderedTreeItemElement(u){this.b.has(u)&&this.b.delete(u)}}e.TreeviewsService=c}),define(ye[308],De([1,0,182,7,24,2,3,6,224,17,7,10,15,14,21,307,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(y,g){if((0,k.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let i;return Array.isArray(y.highlights)&&(i=y.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),i=i.length?i:void 0),{label:y.label,highlights:i}}}class p{constructor(g,i,o){this.d=g,this.e=i,this.f=o,this.a=new Map,this.b=new m.TreeviewsService;function s(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>s(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(r=>s(r)?this.i(r):r):l})}registerTreeDataProvider(g,i,o){const s=this.createTreeView(g,{treeDataProvider:i},o);return{dispose:()=>s.dispose()}}createTreeView(g,i,o){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],r=!!i.dragAndDropController?.handleDrag,h=!!i.dragAndDropController?.handleDrop,n=this.h(g,i,o),t=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:l,hasHandleDrag:r,hasHandleDrop:h});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(o,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(a){n.message=a},get title(){return n.title},set title(a){n.title=a},get description(){return n.description},set description(a){n.description=a},get badge(){return n.badge},set badge(a){a!==void 0&&L.ViewBadge.isViewBadge(a)?n.badge={value:Math.floor(Math.abs(a.value)),tooltip:a.tooltip}:a===void 0&&(n.badge=void 0)},reveal:(a,w)=>n.reveal(a,w),dispose:async()=>{await t,this.a.delete(g),n.dispose()}}}$getChildren(g,i){const o=this.a.get(g);return o?o.getChildren(i):Promise.reject(new S.NoTreeViewError(g))}async $handleDrop(g,i,o,s,l,r,h,n){const t=this.a.get(g);if(!t)return Promise.reject(new S.NoTreeViewError(g));const a=T.DataTransfer.toDataTransfer(o,async w=>(await this.d.$resolveDropFileData(g,i,w)).buffer);return h===g&&n&&await this.g(a,t,n,l,r),t.onDrop(a,s,l)}async g(g,i,o,s,l){const r=this.b.removeDragOperationTransfer(l);if(r)(await r)?.forEach((h,n)=>{h&&g.set(n,h)});else if(l&&i.handleDrag){const h=i.handleDrag(o,g,s);this.b.addDragOperationTransfer(l,h),await h}return g}async $handleDrag(g,i,o,s){const l=this.a.get(g);if(!l)return Promise.reject(new S.NoTreeViewError(g));const r=await this.g(new A.DataTransfer,l,i,s,o);if(!!r)return T.DataTransfer.toDataTransferDTO(r)}async $hasResolve(g){const i=this.a.get(g);if(!i)throw new S.NoTreeViewError(g);return i.hasResolve}$resolve(g,i,o){const s=this.a.get(g);if(!s)throw new S.NoTreeViewError(g);return s.resolveTreeItem(i,o)}$setExpanded(g,i,o){const s=this.a.get(g);if(!s)throw new S.NoTreeViewError(g);s.setExpanded(i,o)}$setSelection(g,i){const o=this.a.get(g);if(!o)throw new S.NoTreeViewError(g);o.setSelection(i)}$setFocus(g,i){const o=this.a.get(g);if(!o)throw new S.NoTreeViewError(g);o.setFocus(i)}$setVisible(g,i){const o=this.a.get(g);if(!o)throw new S.NoTreeViewError(g);o.setVisible(i)}$changeCheckboxState(g,i){const o=this.a.get(g);if(!o)throw new S.NoTreeViewError(g);o.setCheckboxState(i)}h(g,i,o){const s=new b(g,i,this.d,this.e.converter,this.f,o);return this.a.set(g,s),s}i(g){const i=this.a.get(g.$treeViewId);return i&&"$treeItemHandle"in g?i.getExtensionElement(g.$treeItemHandle):i&&"$focusedTreeItem"in g&&g.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=p;class b extends P.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,k.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,i,o,s,l,r){if(super(),this.C=g,this.D=o,this.F=s,this.G=l,this.H=r,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new E.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const a of r.contributes.views[t])a.id===g&&(this.J=a.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let h,n;this.B(C.Event.debounce(this.w.event,(t,a)=>(t||(t={message:!1,elements:[]}),a.element!==!1&&(h||(h=new Promise(w=>n=w),this.y=this.y.then(()=>h)),Array.isArray(a.element)?t.elements.push(...a.element):t.elements.push(a.element)),a.message&&(t.message=!0),t),200,!0)(({message:t,elements:a})=>{a.length&&(this.z=this.z.then(()=>{const w=n;return h=null,this.U(a).then(()=>w())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const i=g?this.getExtensionElement(g):void 0;if(g&&!i)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let o=this.Q(g);return o||(o=await this.R(i)),o?o.map(s=>s.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,i){i=i||{select:!0,focus:!1};const o=(0,k.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,k.isUndefinedOrNull)(i.focus)?!1:i.focus,l=(0,k.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(r=>this.P(g,r[r.length-1]).then(h=>this.D.$reveal(this.C,{item:h.item,parentChain:r.map(n=>n.item)},{select:o,focus:s,expand:l})),r=>this.G.error(r)):this.D.$reveal(this.C,void 0,{select:o,focus:s,expand:l})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=T.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,i){const o=this.getExtensionElement(g);o&&(i?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(g){(0,v.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const i=(await Promise.all(g.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);i.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(o=>[o.extensionItem,o.newState])})}async handleDrag(g,i,o){const s=[];for(const l of g){const r=this.getExtensionElement(l);r&&s.push(r)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,i,o),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,i,o){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.g?.handleDrop))return(0,I.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,g,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,i){if(!this.f.resolveTreeItem)return;const o=this.i.get(g);if(o){const s=this.j.get(o);if(s){const l=await this.f.resolveTreeItem(s.extensionItem,o,i)??s.extensionItem;return this.db(l),s.item.tooltip=this.ab(l.tooltip),s.item.command=this.bb(s.disposableStore,l.command),s.item}}}N(g){return this.O(g).then(i=>i?this.N(i).then(o=>this.P(i,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}O(g){const i=this.j.get(g);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,I.asPromise)(()=>this.f.getParent(g))}P(g,i){const o=this.j.get(g);return o?Promise.resolve(o):(0,I.asPromise)(()=>this.f.getTreeItem(g)).then(s=>this.gb(g,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(s);if(l){const r=this.j.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(g){if(g){let i;if(typeof g=="string"){const o=this.getExtensionElement(g);i=o?this.j.get(o):void 0}else i=g;return i&&i.children||void 0}return this.h}async R(g){this.nb(g);const i=new E.CancellationTokenSource(this.S.token);try{const o=g?this.j.get(g):void 0,s=await this.f.getChildren(g);if(i.token.isCancellationRequested)return;const l=await Promise.all((0,v.coalesce)(s||[]).map(async r=>{const h=await this.f.getTreeItem(r);return h&&!i.token.isCancellationRequested?this.Z(r,h,o):null}));return i.token.isCancellationRequested?void 0:(0,v.coalesce)(l)}finally{i.dispose()}}U(g){if(g.some(o=>!o))return this.S.dispose(!0),this.S=new E.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(g);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(g){const i=new Set,o=g.map(l=>this.j.get(l));for(const l of o)if(l&&!i.has(l.item.handle)){let r=l;for(;r&&r.parent&&o.findIndex(h=>r&&r.parent&&h&&h.item.handle===r.parent.item.handle)===-1;){const h=this.i.get(r.parent.item.handle);r=h?this.j.get(h):void 0}r&&!r.parent&&i.add(l.item.handle)}const s=[];return i.forEach(l=>{const r=this.i.get(l);if(r){const h=this.j.get(r);h&&(!h.parent||!i.has(h.parent.item.handle))&&s.push(l)}}),s}X(g){const i={};return Promise.all(g.map(o=>this.Y(o).then(s=>{s&&(i[o]=s.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(g){const i=this.getExtensionElement(g);if(i){const o=this.j.get(i);if(o)return this.nb(i),(0,I.asPromise)(()=>this.f.getTreeItem(i)).then(s=>{if(s){const l=this.eb(i,s,o.parent);return this.lb(i,l,o,o.parent),o.dispose(),l}return null})}return Promise.resolve(null)}Z(g,i,o){const s=this.eb(g,i,o);if(i.id&&this.i.has(s.item.handle))throw new Error((0,c.localize)(0,null,i.id));return this.kb(g,s),this.mb(s,o),s}ab(g){return L.MarkdownString.isMarkdownString(g)?T.MarkdownString.from(g):g}bb(g,i){return i?{...this.F.toInternal(i,g),originalId:i.command}:void 0}cb(g){if(!g.checkboxState)return;let i,o;return typeof g.checkboxState=="number"?i=g.checkboxState:(i=g.checkboxState.state,o=g.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:o}}db(g){if(!L.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,i,o){this.db(i);const s=new P.DisposableStore,l=this.gb(g,i,o),r=this.hb(i);return{item:{handle:l,parentHandle:o?o.item.handle:void 0,label:f(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(s,i.command),contextValue:i.contextValue,icon:r,iconDark:this.ib(i)||r,themeIcon:this.fb(i),collapsibleState:(0,k.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(g){return g.iconPath instanceof L.ThemeIcon?g.iconPath:void 0}gb(g,{id:i,label:o,resourceUri:s},l,r){if(i)return`${b.b}/${i}`;const h=f(o,this.H),n=l?l.item.handle:b.a;let t=h?h.label:s?(0,u.basename)(s):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const a=this.j.has(g)?this.j.get(g).item.handle:void 0,w=this.Q(l)||[];let D,F=0;do{if(D=`${n}/${F}:${t}`,r||!this.i.has(D)||a===D)break;F++}while(F<=w.length);return D}hb(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return R.URI.isUri(g)?g:R.URI.file(g)}kb(g,i){this.i.set(i.item.handle,g),this.j.set(g,i)}lb(g,i,o,s){this.i.delete(i.item.handle),this.j.delete(g),i.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(g,i);const l=this.Q(s)||[],r=l.filter(h=>h.item.handle===o.item.handle)[0];r&&l.splice(l.indexOf(r),1,i)}mb(g,i){i?(i.children||(i.children=[]),i.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const i=this.j.get(g);if(i){if(i.children)for(const o of i.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}i.children=void 0}}else this.pb()}ob(g){const i=this.j.get(g);if(i){if(i.children)for(const o of i.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}this.j.delete(g),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[309],De([1,0,21,11,3,37,2,121,119,156,155,44,5,95,251,250,40,252,35,254,255,256,239,257,60,42,258,259,262,263,264,142,242,270,271,272,99,41,274,308,14,7,74,277,80,141,34,231,261,73,139,82,84,85,13,57,18,25,265,238,56,77,248,275,79,78,280,278,279,249,48,273,276,98,61,96,266,81,267,16,125,241,220,260,6,27,225,97,216,268,269]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y,g,i,o,s,l,r,h,n,t,a,w,D,F,x,V,M,$,O,U,B,j,de,Y,q,Q,Z,te,X,J,ie,pe,ve,ke,Oe,oe,ae,fe,ee,le,re,N,W,K,_,he,we,Ae,be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce,z,ue,Ie,Le,$e,Ke,Ze,pt,gt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(tt){const ft=tt.get(fe.IExtHostInitDataService),At=tt.get(Te.IExtHostFileSystemInfo),Kt=tt.get(he.IExtHostConsumerFileSystem),Rt=tt.get(l.IExtHostExtensionService),mt=tt.get(Z.IExtHostWorkspace),Tt=tt.get(nt.IExtHostTelemetry),$t=tt.get(p.IExtHostConfiguration),Nt=tt.get(oe.IURITransformerService),Xe=tt.get(ae.IExtHostRpcService),Mt=tt.get(M.IExtHostStorage),Ut=tt.get(_.IExtensionStoragePaths),Wt=tt.get(Oe.ILoggerService),bt=tt.get(Oe.ILogService),Re=tt.get(re.IExtHostTunnelService),Ne=tt.get(N.IExtHostApiDeprecationService),Se=tt.get(Q.IExtHostWindow),se=tt.get(et.IExtHostSecretState),Fe=tt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,At),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Xe.set(v.ExtHostContext.ExtHostWorkspace,mt),Xe.set(v.ExtHostContext.ExtHostConfiguration,$t),Xe.set(v.ExtHostContext.ExtHostExtensionService,Rt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Re),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const He=Xe.set(v.ExtHostContext.ExtHostDecorations,tt.get(ie.IExtHostDecorations)),_e=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(s.IExtHostDocumentsAndEditors)),je=Xe.set(v.ExtHostContext.ExtHostCommands,tt.get(d.IExtHostCommands)),it=Xe.set(v.ExtHostContext.ExtHostTerminalService,tt.get($.IExtHostTerminalService)),lt=Xe.set(v.ExtHostContext.ExtHostDebugService,tt.get(ve.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,tt.get(ke.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,tt.get(pe.IExtHostTask)),yt=Xe.set(v.ExtHostContext.ExtHostOutputService,tt.get(w.IExtHostOutputService)),kt=Xe.set(v.ExtHostContext.ExtHostLocalization,tt.get(Ze.IExtHostLocalizationService)),Dt=Xe.set(v.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Xe)),Ct=Xe.set(v.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Xe,_e)),qt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Xe,_e,bt)),Jt=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,Ct,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),wt=Xe.set(v.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,je,_e,Ct)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(wt)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new z.ExtHostNotebookEditors(bt,wt)),Zt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,ft,wt,je,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(Xe,wt)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Xe,_e)),Ht=Xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),je,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,ft.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,bt,At,_e)),ei=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,Ct,je.converter,Nt)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Nt,Ct,je,ai,bt,Ne,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Xe,ut)),Bt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(Xe,bt,_e)),Qt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Xe,mt,je)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Xe,je,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new ct.ExtHostQuickDiff(Xe,Nt)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,je,Ct)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new D.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Xe)),ti=Xe.set(v.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new K.ExtHostTimeline(Xe,je)),ii=Xe.set(v.ExtHostContext.ExtHostWebviews,new q.ExtHostWebviews(Xe,ft.remote,mt,bt,Ne)),ni=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ii,mt)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,Ct,Ut,ii,ni)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ii)),ri=Xe.set(v.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Xe,je,_e)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new gt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,wt,_e,je,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,_e),Hi=new m.ExtHostClipboard(Xe),ki=new a.ExtHostMessageService(Xe,bt),Ri=new y.ExtHostDialogs(Xe),Li=new V.ExtHostStatusBar(Xe,je.converter);return E.ExtHostApiCommands.register(je),function(ze,jt,Oi){const vt=function(){let ge=!ze.isUnderDevelopment;function Ee(){ge||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const It=ot;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),ji={getSession(ge,Ee,Me){return ti.getSession(ze,ge,Ee,Me)},async hasSession(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"authSession"),!!await ti.getSession(ze,ge,Ee,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ge,Ee,Me,ot){return ti.registerAuthenticationProvider(ge,Ee,Me,ot)}},di={registerCommand(ge,Ee,Me){return je.registerCommand(!0,ge,Ee,Me,void 0,ze)},registerTextEditorCommand(ge,Ee,Me){return je.registerCommand(!0,ge,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{Ee.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+ge+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"diffCommand"),je.registerCommand(!0,ge,async(...ot)=>{const It=_e.activeEditor(!0);if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);Ee.apply(Me,[Ot,...ot])},void 0,void 0,ze)),executeCommand(ge,...Ee){return je.executeCommand(ge,...Ee)},getCommands(ge=!1){return je.getCommands(ge)}},Ni={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(ze,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return nt.ExtHostTelemetryLogger.validateSender(ge),Tt.instantiateLogger(ze,ge)},openExternal(ge,Ee){return Se.openUri(ge,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ft.environment.appUriScheme)return Dt.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!ft.remote.authority})}catch(Ee){if((0,ce.matchesScheme)(ge,rt.Schemas.http)||(0,ce.matchesScheme)(ge,rt.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,J.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,Ee,Me){return ri.createTestController(ze,ge,Ee,Me)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.results}},hi=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ge,Ee){(0,$e.isProposedApiEnabled)(ze,"extensionsAny")||(Ee=!1);const Me=jt.mine.getExtensionDescription(ge);if(Me)return new l.Extension(Rt,ze.identifier,Me,hi,!1);if(Ee){const ot=jt.all.getExtensionDescription(ge);if(ot)return new l.Extension(Rt,ze.identifier,ot,hi,!0)}},get all(){const ge=[];for(const Ee of jt.mine.getAllExtensionDescriptions())ge.push(new l.Extension(Rt,ze.identifier,Ee,hi,!1));return ge},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(ze,"extensionsAny");const ge=new $e.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of jt.all.getAllExtensionDescriptions()){const ot=!ge.has(Me.identifier);Ee.push(new l.Extension(Rt,ze.identifier,Me,hi,ot))}return Ee},get onDidChange(){return(0,$e.isProposedApiEnabled)(ze,"extensionsAny")?u.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Ti={createDiagnosticCollection(ge){return ai.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ge,Ee){return ei.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Me=Ct.getDocumentData(Ee.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(ge),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Ee,Me){return ut.registerCodeActionProvider(ze,vt(ge),Ee,Me)},registerDocumentPasteEditProvider(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,vt(ge),Ee,Me)},registerCodeLensProvider(ge,Ee){return ut.registerCodeLensProvider(ze,vt(ge),Ee)},registerDefinitionProvider(ge,Ee){return ut.registerDefinitionProvider(ze,vt(ge),Ee)},registerDeclarationProvider(ge,Ee){return ut.registerDeclarationProvider(ze,vt(ge),Ee)},registerImplementationProvider(ge,Ee){return ut.registerImplementationProvider(ze,vt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return ut.registerTypeDefinitionProvider(ze,vt(ge),Ee)},registerHoverProvider(ge,Ee){return ut.registerHoverProvider(ze,vt(ge),Ee,ze.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return ut.registerEvaluatableExpressionProvider(ze,vt(ge),Ee,ze.identifier)},registerInlineValuesProvider(ge,Ee){return ut.registerInlineValuesProvider(ze,vt(ge),Ee,ze.identifier)},registerDocumentHighlightProvider(ge,Ee){return ut.registerDocumentHighlightProvider(ze,vt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return ut.registerLinkedEditingRangeProvider(ze,vt(ge),Ee)},registerReferenceProvider(ge,Ee){return ut.registerReferenceProvider(ze,vt(ge),Ee)},registerRenameProvider(ge,Ee){return ut.registerRenameProvider(ze,vt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Me){return ut.registerDocumentSymbolProvider(ze,vt(ge),Ee,Me)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,Ee){return ut.registerDocumentFormattingEditProvider(ze,vt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return ut.registerDocumentRangeFormattingEditProvider(ze,vt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Me,...ot){return ut.registerOnTypeFormattingEditProvider(ze,vt(ge),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(ge,Ee,Me){return ut.registerDocumentSemanticTokensProvider(ze,vt(ge),Ee,Me)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Me){return ut.registerDocumentRangeSemanticTokensProvider(ze,vt(ge),Ee,Me)},registerSignatureHelpProvider(ge,Ee,Me,...ot){return typeof Me=="object"?ut.registerSignatureHelpProvider(ze,vt(ge),Ee,Me):ut.registerSignatureHelpProvider(ze,vt(ge),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(ge,Ee,...Me){return ut.registerCompletionItemProvider(ze,vt(ge),Ee,Me)},registerInlineCompletionItemProvider(ge,Ee){return Ee.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,vt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return ut.registerDocumentLinkProvider(ze,vt(ge),Ee)},registerColorProvider(ge,Ee){return ut.registerColorProvider(ze,vt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return ut.registerFoldingRangeProvider(ze,vt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return ut.registerSelectionRangeProvider(ze,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return ut.registerCallHierarchyProvider(ze,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return ut.registerTypeHierarchyProvider(ze,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>ut.setLanguageConfiguration(ze,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return ut.registerInlayHintsProvider(ze,ge,Ee)},createLanguageStatusItem(ge,Ee){return ei.createLanguageStatusItem(ze,ge,Ee)},registerDocumentDropEditProvider(ge,Ee){return ut.registerDocumentOnDropEditProvider(ze,ge,Ee)}},xi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ge,Ee,Me){const ot=await(C.URI.isUri(ge)?Promise.resolve(xt.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,Ee,Me){return Lt.onDidChangeActiveTextEditor(ge,Ee,Me)},onDidChangeVisibleTextEditors(ge,Ee,Me){return Lt.onDidChangeVisibleTextEditors(ge,Ee,Me)},onDidChangeTextEditorSelection(ge,Ee,Me){return Lt.onDidChangeTextEditorSelection(ge,Ee,Me)},onDidChangeTextEditorOptions(ge,Ee,Me){return Lt.onDidChangeTextEditorOptions(ge,Ee,Me)},onDidChangeTextEditorVisibleRanges(ge,Ee,Me){return Lt.onDidChangeTextEditorVisibleRanges(ge,Ee,Me)},onDidChangeTextEditorViewColumn(ge,Ee,Me){return Lt.onDidChangeTextEditorViewColumn(ge,Ee,Me)},onDidCloseTerminal(ge,Ee,Me){return it.onDidCloseTerminal(ge,Ee,Me)},onDidOpenTerminal(ge,Ee,Me){return it.onDidOpenTerminal(ge,Ee,Me)},onDidChangeActiveTerminal(ge,Ee,Me){return it.onDidChangeActiveTerminal(ge,Ee,Me)},onDidChangeTerminalDimensions(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDimensions"),it.onDidChangeTerminalDimensions(ge,Ee,Me)},onDidChangeTerminalState(ge,Ee,Me){return it.onDidChangeTerminalState(ge,Ee,Me)},onDidWriteTerminalData(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ge,Ee,Me)},get state(){return Se.state},onDidChangeWindowState(ge,Ee,Me){return Se.onDidChangeWindowState(ge,Ee,Me)},showInformationMessage(ge,...Ee){return ki.showMessage(ze,R.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return ki.showMessage(ze,R.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return ki.showMessage(ze,R.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Me){return Qt.showQuickPick(ge,Ee,Me)},showWorkspaceFolderPick(ge){return Qt.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Qt.showInput(ge,Ee)},showOpenDialog(ge){return Ri.showOpenDialog(ge)},showSaveDialog(ge){return Ri.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Me){let ot,It,Ot;return typeof ge=="string"?(ot=ge,It=Ee,Ot=Me):(It=ge,Ot=Ee),Li.createStatusBarEntry(ze,ot,It,Ot)},setStatusBarMessage(ge,Ee){return Li.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return Ne.report("window.withScmProgress",ze,"Use 'withProgress' instead."),li.withProgress(ze,{location:j.ProgressLocation.SourceControl},(Ee,Me)=>ge({report(ot){}}))},withProgress(ge,Ee){return li.withProgress(ze,ge,Ee)},createOutputChannel(ge,Ee){return yt.createOutputChannel(ge,Ee,ze)},createWebviewPanel(ge,Ee,Me,ot){return ni.createWebviewPanel(ze,ge,Ee,Me,ot)},createWebviewTextEditorInset(ge,Ee,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"editorInsets"),vi.createWebviewEditorInset(ge,Ee,Me,ot,ze)},createTerminal(ge,Ee,Me){return typeof ge=="object"?"pty"in ge?it.createExtensionTerminal(ge):it.createTerminalFromOptions(ge):it.createTerminal(ge,Ee,Me)},registerTerminalLinkProvider(ge){return it.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return it.registerProfileProvider(ze,ge,Ee)},registerTerminalQuickFixProvider(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),it.registerTerminalQuickFixProvider(ge,ze.identifier.value,Ee)},registerTreeDataProvider(ge,Ee){return Ht.registerTreeDataProvider(ge,Ee,ze)},createTreeView(ge,Ee){return Ht.createTreeView(ge,Ee,ze)},registerWebviewPanelSerializer:(ge,Ee)=>ni.registerWebviewPanelSerializer(ze,ge,Ee),registerCustomEditorProvider:(ge,Ee,Me={})=>yi.registerCustomEditorProvider(ze,ge,Ee,Me),registerFileDecorationProvider(ge){return He.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return Dt.registerUriHandler(ze.identifier,ge)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Me){return ui.onDidChangeActiveColorTheme(ge,Ee,Me)},registerWebviewViewProvider(ge,Ee,Me){return Di.registerWebviewViewProvider(ze,ge,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Me){return wt.onDidChangeActiveNotebookEditor(ge,Ee,Me)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Ee,Me){return oi.onDidChangeNotebookEditorSelection(ge,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me){return oi.onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me)},showNotebookDocument(ge,Ee){return wt.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"externalUriOpener"),Ci.registerExternalUriOpener(ze.identifier,ge,Ee,Me)},registerProfileContentHandler(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ii.registrProfileContentHandler(ze,ge,Ee)},registerQuickDiffProvider(ge,Ee,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(ge),Ee,Me,ot)},get tabGroups(){return Fe.tabGroups}},xt={get rootPath(){return Ne.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw A.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw A.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw A.readonly()},updateWorkspaceFolders:(ge,Ee,...Me)=>mt.updateWorkspaceFolders(ze,ge,Ee||0,...Me),onDidChangeWorkspaceFolders:function(ge,Ee,Me){return mt.onDidChangeWorkspace(ge,Ee,Me)},asRelativePath:(ge,Ee)=>mt.getRelativePath(ge,Ee),findFiles:(ge,Ee,Me,ot)=>mt.findFiles(ge,Ee,Me,ze.identifier,ot),findTextInFiles:(ge,Ee,Me,ot)=>{(0,$e.checkProposedApiEnabled)(ze,"findTextInFiles");let It,Ot;return typeof Ee=="object"?(It=Ee,Ot=Me):(It={},Ot=Ee,ot=Me),mt.findTextInFiles(ge,It||{},Ot,ze.identifier,ot)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge,Ee){return Wi.applyWorkspaceEdit(ge,ze,Ee)},createFileSystemWatcher:(ge,Ee,Me,ot)=>Bt.createFileSystemWatcher(mt,ze,ge,Ee,Me,ot),get textDocuments(){return Ct.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw A.readonly()},openTextDocument(ge){let Ee;const Me=ge;if(typeof ge=="string")Ee=Promise.resolve(C.URI.file(ge));else if(C.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Me||typeof Me=="object")Ee=Ct.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>Ct.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(ge,Ee,Me)=>Ct.onDidAddDocument(ge,Ee,Me),onDidCloseTextDocument:(ge,Ee,Me)=>Ct.onDidRemoveDocument(ge,Ee,Me),onDidChangeTextDocument:(ge,Ee,Me)=>Ct.onDidChangeDocument(ge,Ee,Me),onDidSaveTextDocument:(ge,Ee,Me)=>Ct.onDidSaveDocument(ge,Ee,Me),onWillSaveTextDocument:(ge,Ee,Me)=>Jt.getOnWillSaveTextDocumentEvent(ze)(ge,Ee,Me),get notebookDocuments(){return wt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Me;if(C.URI.isUri(ge))Me=ge,await wt.openNotebookDocument(ge);else if(typeof ge=="string")Me=C.URI.revive(await wt.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Me){return si.onDidSaveNotebookDocument(ge,Ee,Me)},onDidChangeNotebookDocument(ge,Ee,Me){return si.onDidChangeNotebookDocument(ge,Ee,Me)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Ee,Me,ot){return wt.registerNotebookSerializer(ze,ge,Ee,Me,(0,$e.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,Ee,Me)=>Oi.onDidChangeConfiguration(ge,Ee,Me),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(ge,Ee,ze)},registerTextDocumentContentProvider(ge,Ee){return qt.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(Ne.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(ze,ge,Ee)),registerFileSystemProvider(ge,Ee,Me){return(0,Le.combinedDisposable)(Bi.registerFileSystemProvider(ze,ge,Ee,Me),Kt.addFileSystemProvider(ge,Ee))},get fs(){return Kt.value},registerFileSearchProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"fileSearchProvider"),Pt.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"textSearchProvider"),Pt.registerTextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Ee,Me)=>Bt.onDidCreateFile(ge,Ee,Me),onDidDeleteFiles:(ge,Ee,Me)=>Bt.onDidDeleteFile(ge,Ee,Me),onDidRenameFiles:(ge,Ee,Me)=>Bt.onDidRenameFile(ge,Ee,Me),onWillCreateFiles:(ge,Ee,Me)=>Bt.getOnWillCreateFileEvent(ze)(ge,Ee,Me),onWillDeleteFiles:(ge,Ee,Me)=>Bt.getOnWillDeleteFileEvent(ze)(ge,Ee,Me),onWillRenameFiles:(ge,Ee,Me)=>Bt.getOnWillRenameFileEvent(ze)(ge,Ee,Me),openTunnel:ge=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.openTunnel(ze,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.onDidChangeTunnels(ge,Ee,Me)),registerPortAttributesProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"portsAttributes"),Re.registerPortsAttributesProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"timeline"),$i.registerTimelineProvider(ge,Ee,ze.identifier,je.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,$e.checkProposedApiEnabled)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Me)=>mt.onDidGrantWorkspaceTrust(ge,Ee,Me),registerEditSessionIdentityProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,Ee)),onWillCreateEditSessionIdentity:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(ze)(ge,Ee,Me))},fi={get inputBox(){return Ne.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(ze)},createSourceControl(ge,Ee,Me){return ci.createSourceControl(ze,ge,Ee,Me)}},Gi={createCommentController(ge,Ee){return Ei.createCommentController(ze,ge,Ee)}},zt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,Ee,Me){return lt.onDidStartDebugSession(ge,Ee,Me)},onDidTerminateDebugSession(ge,Ee,Me){return lt.onDidTerminateDebugSession(ge,Ee,Me)},onDidChangeActiveDebugSession(ge,Ee,Me){return lt.onDidChangeActiveDebugSession(ge,Ee,Me)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Me){return lt.onDidReceiveDebugSessionCustomEvent(ge,Ee,Me)},onDidChangeBreakpoints(ge,Ee,Me){return lt.onDidChangeBreakpoints(ge,Ee,Me)},registerDebugConfigurationProvider(ge,Ee,Me){return lt.registerDebugConfigurationProvider(ge,Ee,Me||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return lt.registerDebugAdapterDescriptorFactory(ze,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return lt.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?lt.startDebugging(ge,Ee,{parentSession:Me}):lt.startDebugging(ge,Ee,Me||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return lt.asDebugSourceUri(ge,Ee)}},mi={registerTaskProvider:(ge,Ee)=>St.registerTaskProvider(ze,ge,Ee),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask(ze,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,Ee,Me)=>St.onDidStartTask(ge,Ee,Me),onDidEndTask:(ge,Ee,Me)=>St.onDidEndTask(ge,Ee,Me),onDidStartTaskProcess:(ge,Ee,Me)=>St.onDidStartTaskProcess(ge,Ee,Me),onDidEndTaskProcess:(ge,Ee,Me)=>St.onDidEndTaskProcess(ge,Ee,Me)},Ki={createNotebookController(ge,Ee,Me,ot,It){return Zt.createNotebookController(ze,ge,Ee,Me,ot,(0,$e.isProposedApiEnabled)(ze,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>wt.registerNotebookCellStatusBarItemProvider(ze,ge,Ee),createRendererMessaging(ge){return bi.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,ge,Ee)},onDidChangeNotebookCellExecutionState(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ge,Ee,Me)}},Xi={t(...ge){if(typeof ge[0]=="string"){const Ee=ge.shift(),Me=!ge||typeof ge[0]!="object"?ge:ge[0];return kt.getMessage(ze.identifier.value,{message:Ee,args:Me})}return kt.getMessage(ze.identifier.value,ge[0])},get bundle(){return kt.getBundle(ze.identifier.value)},get uri(){return kt.getBundleUri(ze.identifier.value)}};return{version:ft.version,authentication:ji,commands:di,comments:Gi,debug:zt,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:xt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:I.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:T.UIKind,Uri:C.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:de.TelemetryTrustedValue,LogLevel:Oe.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[310],De([1,0,282,319,320,2,321]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,v,T,E,m,d){const f=d.environment.useHostProxy,p=typeof f=="boolean"?f:!d.remote.isRemote,b=(0,C.createProxyResolver)({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(g,i,...o)=>{switch(g){case C.LogLevel.Trace:E.trace(i,...o);break;case C.LogLevel.Debug:E.debug(i,...o);break;case C.LogLevel.Info:E.info(i,...o);break;case C.LogLevel.Warning:E.warn(i,...o);break;case C.LogLevel.Error:E.error(i,...o);break;case C.LogLevel.Critical:E.error(i,...o);break;case C.LogLevel.Off:break;default:s(g,i,o);break}function s(l,r,...h){E.error("Unknown log level",l),E.error(r,...h)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),y=S(v,b);return L(T,y)}e.connectProxyResolver=P;function S(k,v){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(m=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(m=>{E.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"off"},E,!0)),on:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"on"},E,!0)),override:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"override"},E,!0)),onRequest:Object.assign({},c,(0,C.createHttpPatch)(c,v,T,E,!0)),default:Object.assign(c,(0,C.createHttpPatch)(c,v,T,E,!1))},https:{off:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"off"},E,!0)),on:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"on"},E,!0)),override:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"override"},E,!0)),onRequest:Object.assign({},A,(0,C.createHttpPatch)(A,v,T,E,!0)),default:Object.assign(A,(0,C.createHttpPatch)(A,v,T,E,!1))},tls:Object.assign(u,(0,C.createTlsPatch)(u))}}const I=new Map;function L(k,v){return k.getExtensionPathIndex().then(T=>{const E=globalThis._VSCODE_NODE_MODULES.module,m=E._load;E._load=function(f,p,b){if(f==="tls")return v.tls;if(f!=="http"&&f!=="https")return m.apply(this,arguments);const y=v[f],g=T.findSubstr(R.URI.file(p.filename));let i=I.get(g);if(i||I.set(g,i={}),!i[f]){const o=y.default;i[f]={...o}}return i[f]}})}}),define(ye[311],De([1,0,52,71,9,83,309,296,310,42,284,2,16,7,281,112,283]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends P.RequireInterceptor{j(){const y=this,g=globalThis._VSCODE_NODE_MODULES.module,i=g._load;g._load=function(r,h,n){return r=s(r),y.a.has(r)?y.a.get(r).load(r,k.URI.file((0,m.realpathSync)(h.filename)),t=>i.apply(this,[t,h,n])):i.apply(this,arguments)};const o=g._resolveLookupPaths;g._resolveLookupPaths=(l,r)=>o.call(this,s(l),r);const s=l=>{for(const r of y.b){const h=r(l);if(h){l=h;break}}return l}}}class p extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Node}async nb(){this.h.createInstance(d.ExtHostConsoleForwarder);const y=this.h.invokeFunction(C.createApiFactoryAndRegisterActors);if(this.h.createInstance(L.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(E.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath,c.promises.writeFile(u.join(A.tmpdir(),"vscode-ipc"),o.ipcHandlePath).catch(s=>{this.l.error(s)})}await this.h.createInstance(f,y,{mine:this.D,all:this.F}).install(),R.mark("code/extHost/didInitAPI");const i=await this.k.getConfigProvider();await(0,S.connectProxyResolver)(this.j,i,this,this.l,this.u,this.f),R.mark("code/extHost/didInitProxyResolver")}ob(y){return y.main}async pb(y,g,i){if(g.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let o=null;i.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this.l.flush();const s=y?.identifier.value;y&&await this.s.initializeLocalizedMessages(y);try{s&&R.mark(`code/extHost/willLoadExtensionCode/${s}`),o=ne.__$__nodeRequire(g.fsPath)}finally{s&&R.mark(`code/extHost/didLoadExtensionCode/${s}`),i.codeLoadingStop()}return o}async $setRemoteEnvironment(y){if(!!this.f.remote.isRemote)for(const g in y){const i=y[g];i===null?delete process.env[g]:process.env[g]=i}}}e.ExtHostExtensionService=p}),define(ye[145],De([1,0,46,322,305,15,62,38,9,8,2,31,81,323,303,100]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(a){this.a=a}provideTextSearchResults(a,w,D,F){return this.a.appendLine(`provideTextSearchResults ${a.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((x,V)=>{F.onCancellationRequested(()=>Y());const M=o(a,w),$=w.folder.fsPath,O=M.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${d} ${O}
 - cwd: ${$}`);let U=c.spawn(d,M,{cwd:$});U.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),V((0,k.serializeSearchError)(new k.SearchError(X&&X.message,k.SearchErrorCode.rgProcessError)))});let B=!1;const j=new y(w.maxResults,$,w.previewOptions);j.on("result",X=>{B=!0,Q="",D.report(X)});let de=!1;const Y=()=>{de=!0,U?.kill(),j?.cancel()};let q=!1;j.on("hitLimit",()=>{q=!0,Y()});let Q="";U.stdout.on("data",X=>{j.handleData(X),B||(Q+=X)});let Z=!1;U.stdout.once("data",()=>Z=!0);let te="";U.stderr.on("data",X=>{const J=X.toString();this.a.appendLine(J),te.length+J.length<1e6&&(te+=J)}),U.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine(B?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),de)x({limitHit:q});else{j.flush(),U=null;let X;te&&!Z&&(X=p(te))?V((0,k.serializeSearchError)(new k.SearchError(X.message,X.code))):x({limitHit:q})}})})}}e.RipgrepTextSearchEngine=f;function p(t){const a=t.split(`
`),w=a[0].trim();if(a.some(F=>F.startsWith("regex parse error")))return new k.SearchError(b(a),k.SearchErrorCode.regexParseError);const D=w.match(/grep config error: unknown encoding: (.*)/);if(D)return new k.SearchError(`Unknown encoding: ${D[1]}`,k.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(w,k.SearchErrorCode.regexParseError)}function b(t){const a=["Regex parse error"],w=t.filter(D=>D.startsWith("PCRE2:"));if(w.length>=1){const D=w[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const F=D.split(":")[1];a.push(":"+F)}}return a.join("")}class y extends A.EventEmitter{constructor(a,w,D){super(),this.g=a,this.h=w,this.j=D,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new u.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(a,w){return super.on(a,w),this}handleData(a){if(this.b)return;const w=typeof a=="string"?a:this.d.write(a);this.k(w)}k(a){let w=a.indexOf(`
`);const D=this.a+a;if(w>=0)w+=this.a.length;else{this.a=D;return}let F=0;for(;w>=0;)this.m(D.substring(F,w).trim()),F=w+1,w=D.indexOf(`
`,F);this.a=D.substring(F)}m(a){if(this.b||!a)return;let w;try{w=JSON.parse(a)}catch{throw new Error(`malformed line from rg: ${a}`)}if(w.type==="match"){const D=g(w.data.path),F=L.URI.file(S.join(this.h,D)),x=this.n(w.data,F);this.p(x),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const D=g(w.data.path),F=L.URI.file(S.join(this.h,D));this.o(w.data,F).forEach(V=>this.p(V))}}n(a,w){const D=a.line_number-1,F=g(a.lines),x=Buffer.from(F);let V=0,M=0,$=D;a.submatches.length===0&&a.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(a.submatches.map((U,B)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=g(U.match),de=x.slice(V,U.start).toString(),Y=i(de),q=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+M,Q=i(j),Z=Y.numLines+$,te=Q.numLines+Z,X=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+q;return V=U.end,M=X,$=te,new v.Range(Z,q,te,X)}));return(0,m.createTextSearchResult)(w,F,O,this.j)}o(a,w){const D=g(a.lines),F=a.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((x,V)=>({text:x,uri:w,lineNumber:F+V}))}p(a){this.emit("result",a)}}e.RipgrepParser=y;function g(t){return t.bytes?Buffer.from(t.bytes,"base64").toString():t.text}function i(t){const a=/\n/g;let w=0,D=-1,F;for(;F=a.exec(t);)w++,D=F.index;const x=D>=0?t.length-D-1:t.length;return{numLines:w,lastLineLength:x}}function o(t,a){const w=["--hidden"];w.push(t.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:F}=(0,C.groupBy)(a.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const V=new Set;F.forEach(M=>{V.add(M)}),w.push("-g","!*"),V.forEach(M=>{s(M).map(m.anchorGlob).forEach($=>{w.push("-g",$)})})}D&&D.length&&D.forEach(V=>{w.push("-g",V)}),a.excludes.map(m.anchorGlob).forEach(V=>w.push("-g",`!${V}`)),a.maxFileSize&&w.push("--max-filesize",a.maxFileSize+""),a.useIgnoreFiles?a.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),a.followSymlinks&&w.push("--follow"),a.encoding&&a.encoding!=="utf8"&&w.push("--encoding",a.encoding),t.pattern==="--"&&(t.isRegExp=!0,t.pattern="\\-\\-"),t.isMultiline&&!t.isRegExp&&(t.pattern=(0,I.escapeRegExpCharacters)(t.pattern),t.isRegExp=!0),a.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),t.isRegExp&&(t.pattern=l(t.pattern),w.push("--engine","auto"));let x;if(t.isWordMatch){const M=(0,I.createRegExp)(t.pattern,!!t.isRegExp,{wholeWord:t.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",M)}else if(t.isRegExp){let V=h(t.pattern);V=n(V),w.push("--regexp",V)}else x=t.pattern,w.push("--fixed-strings");return w.push("--no-config"),a.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),t.isMultiline&&w.push("--multiline"),a.beforeContext&&w.push("--before-context",a.beforeContext+""),a.afterContext&&w.push("--after-context",a.afterContext+""),w.push("--"),x&&w.push(x),w.push("."),w}function s(t){const a=(0,P.splitGlobAware)(t,"/");return a.map((w,D)=>a.slice(0,D+1).join("/"))}function l(t){const a=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;t.match(a);)t=t.replace(a,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;t.match(w);)t=t.replace(w,"$1\\x{$2}");return t}e.unicodeEscapesToPCRE2=l;const r=t=>t.type==="Assertion"&&t.kind==="lookbehind";function h(t){let a;try{a=new T.RegExpParser().parsePattern(t)}catch{return t}let w="",D=0;const F=(M,$,O)=>{w+=t.slice(D,M)+O,D=$},x=[];return new T.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const $=x[0];if(!$)F(M.start,M.end,"\\r?\\n");else if(!x.some(r))if($.type==="CharacterClass")if($.negate){const O=t.slice($.start+2,M.start)+t.slice(M.end,$.end-1);$.parent?.type==="Quantifier"?F($.start,$.end,O?`[^${O}]`:"."):F($.start,$.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=t.slice($.start+1,M.start)+t.slice(M.end,$.end-1);F($.start,$.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else $.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){x.unshift(M)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(M){x.unshift(M)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(M){x.unshift(M)},onCharacterClassLeave(){x.shift()},onAssertionEnter(M){r(M)&&x.push(M)},onAssertionLeave(M){x[0]===M&&x.shift()}}).visit(a),w+=t.slice(D),w}e.fixRegexNewline=h;function n(t){return t.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[312],De([1,0,21,145,126,16]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(I){this.b=I,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(I,L,k,v){const T=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:R.Schemas.file})},m=new u.Progress(d=>k.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>T.provideTextSearchResults(I,E,m,d))}else return this.c(v,E=>T.provideTextSearchResults(I,L,k,E))}async c(I,L){const k=P(I);this.a.add(k);const v=await L(k.token);return this.a.delete(k),v}d(){this.a.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=C;function P(S){const I=new c.CancellationTokenSource;return S.onCancellationRequested(()=>I.cancel()),I}}),define(ye[313],De([1,0,29,145,144]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(S){this.a=S}search(S,I,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){L({message:T})}},v=new u.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(k),c);return new Promise((T,E)=>v.search(m=>{I(m.map(C))},S).then(m=>T({limitHit:m.limitHit,type:"success",stats:m.stats}),E))}}e.TextSearchEngineAdapter=R;function C(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,I)=>{if(I.ranges){const L=I;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(ye[314],De([1,0,15,17,11,3,107,9,43,2,44,31,304,313]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let g;const i=f(y),o=new R.Emitter({onDidAddFirstListener:()=>{g=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(v.Engine,i,l=>o.fire(l),s)),g.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return o.event}textSearch(y){let g;const i=f(y),o=new R.Emitter({onDidAddFirstListener:()=>{g=(0,A.createCancelablePromise)(s=>this.f(i,l=>o.fire(l),s)),g.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return o.event}f(y,g,i){return y.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(y).search(i,g,g)}doFileSearch(y,g,i){return this.doFileSearchWithEngine(v.Engine,y,g,i)}doFileSearchWithEngine(y,g,i,o,s=E.a){let l=0;const r=n=>{Array.isArray(n)?(l+=n.length,i(n.map(t=>this.g(t)))):n.relativePath?(l++,i(this.g(n))):i(n)};if(g.sortByScore){let n=this.k(g,r,o);if(!n){const t=g.maxResults?Object.assign({},g,{maxResults:null}):g,a=new y(t);n=this.h(a,g,i,r,o)}return new Promise((t,a)=>{n.then(([w,D])=>{const F=D.map(x=>this.g(x));this.n(F,i,s),t(w)},a)})}const h=new y(g);return this.q(h,r,s,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}g(y){return{path:y.base?(0,P.join)(y.base,y.relativePath):y.relativePath}}h(y,g,i,o,s){const l=new R.Emitter;let r=(0,A.createCancelablePromise)(n=>{let t=[];const a=w=>{Array.isArray(w)?t=w:(o(w),l.fire(w))};return this.q(y,a,-1,n).then(w=>[w,t])}),h;if(g.cacheKey){h=this.j(g.cacheKey);const n={promise:r,event:l.event,resolved:!1};h.resultsToSearchCache[g.filePattern||""]=n,r.then(()=>{n.resolved=!0},t=>{delete h.resultsToSearchCache[g.filePattern||""]}),r=this.r(r)}return r.then(([n,t])=>{const a=h?h.scorerCache:Object.create(null),w=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.l(g,t,a,s).then(D=>{const F=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:F,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:D.length},messages:n.messages,limitHit:n.limitHit||typeof g.maxResults=="number"&&t.length>g.maxResults},D]})})}j(y){const g=this.b[y];return g||(this.b[y]=new m)}k(y,g,i){const o=y.cacheKey&&this.b[y.cacheKey];if(!o)return;const s=this.o(o,y.filePattern||"",g,i);if(s)return s.then(([l,r,h])=>{const n=S.StopWatch.create(!1);return this.l(y,r,o.scorerCache,i).then(t=>{const a=n.elapsed(),w={fromCache:!0,detailStats:h,type:this.d,resultCount:r.length,sortingTime:a};return[{type:"success",limitHit:l.limitHit||typeof y.maxResults=="number"&&r.length>y.maxResults,stats:w},t]})})}l(y,g,i,o){const s=(0,C.prepareQuery)(y.filePattern||""),l=(h,n)=>(0,C.compareItemsByFuzzyScore)(h,n,s,!0,d,i),r=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return c.topAsync(g,l,r,1e4,o)}n(y,g,i){if(i&&i>0)for(let o=0;o<y.length;o+=i)g(y.slice(o,o+i));else g(y)}o(y,g,i,o){const s=S.StopWatch.create(!1),l=g.indexOf(P.sep)>=0;let r;for(const a in y.resultsToSearchCache)if(g.startsWith(a)){if(l&&a.indexOf(P.sep)<0&&a!=="")continue;const w=y.resultsToSearchCache[a];r={promise:this.r(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const h=s.elapsed(),n=S.StopWatch.create(!1),t=r.event(i);return o&&o.onCancellationRequested(()=>{t.dispose()}),r.promise.then(([a,w])=>{if(o&&o.isCancellationRequested)throw(0,u.canceled)();const D=[],F=(0,C.prepareQuery)(g).normalizedLowercase;for(const x of w)!(0,k.isFilePatternMatch)(x,F)||D.push(x);return[a,D,{cacheWasResolved:r.resolved,cacheLookupTime:h,cacheFilterTime:n.elapsed(),cacheEntryCount:w.length}]})}q(y,g,i,o){return new Promise((s,l)=>{let r=[];o?.onCancellationRequested(()=>y.cancel()),y.search(h=>{h&&(i?(r.push(h),i>0&&r.length>=i&&(g(r),r=[])):g(h))},h=>{g(h)},(h,n)=>{r.length&&g(r),h?l(h):s(n)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}r(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,i){return y.then(g,i)}catch(g){return this.then(void 0,g)}finally(g){return y.finally(g)}}}}E.a=512,e.SearchService=E;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(b){return(0,P.basename)(b.relativePath)}getItemDescription(b){return(0,P.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function f(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(y=>I.URI.revive(y))}}function p(b){return{...b,folder:I.URI.revive(b.folder)}}}),define(ye[315],De([1,0,6,16,2,29,13,25,18,85,57,31,314,312,100,144]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends I.ExtHostSearch{constructor(p,b,y,g){super(p,y,g),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new E.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new T.RipgrepSearchProvider(i)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const p=new E.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new T.RipgrepSearchProvider(p)),this.y(A.Schemas.file,new v.SearchService("fileSearchProvider"))}y(p,b){const y=this.d++;return this.v=b,this.t=y,this.c.$registerFileSearchProvider(y,this.o(p)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(p,b,y,g){const i=(0,I.reviveQuery)(y);return p===this.t?this.z(p,b,i,g):super.$provideFileSearchResults(p,b,y,g)}z(p,b,y,g){const i=o=>{if((0,k.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(p,b,o.map(s=>u.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,i,g)}$clearCache(p){return this.v?.clearCache(p),super.$clearCache(p)}q(p,b){return new m.NativeTextSearchManager(p,b,void 0,"textSearchProvider")}};d=qe([We(0,S.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,C.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[316],De([1,0,89,287,299,298,315,311,288,84,42,85,82,41,56,79,286,285,13,300,49]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,c.registerSingleton)(p.ILoggerService,f.ExtHostLoggerService,1),(0,c.registerSingleton)(m.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,c.registerSingleton)(I.IExtHostDebugService,R.ExtHostDebugService,0),(0,c.registerSingleton)(k.IExtHostSearch,C.NativeExtHostSearch,0),(0,c.registerSingleton)(v.IExtHostTask,u.ExtHostTask,0),(0,c.registerSingleton)(T.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,c.registerSingleton)(E.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(y.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[324],De([1,0,228,325,83,11,115,116,206,95,297,22,29,112,17,121,223,236,301,316]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const p=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,h=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const b=process.exit.bind(process);function y(r){process.exit=function(h){if(r)b(h);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(r){b()};function i(){const r=(0,f.readExtHostConnection)(process.env);if(r.type===3)return new Promise((h,n)=>{const t=a=>{const w=a[0],D=new C.BufferedEmitter;w.on("message",F=>D.fire(k.VSBuffer.wrap(F.data))),w.on("close",()=>{g("renderer closed the MessagePort")}),w.start(),h({onMessage:D.event,send:F=>w.postMessage(F.buffer)})};process.parentPort.on("message",a=>t(a.ports))});if(r.type===2)return new Promise((h,n)=>{let t=null;const a=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,D=3e5,F=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),w),x=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),D);process.on("message",(M,$)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){$.setNoDelay(!0);const O=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new P.NodeSocket($,"extHost-socket");else{const B=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new P.WebSocketNodeSocket(new P.NodeSocket($,"extHost-socket"),M.permessageDeflate,B,!1)}t?(F.cancel(),x.cancel(),t.beginAcceptReconnection(U,O),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(a),t=new C.PersistentProtocol({socket:U,initialChunk:O}),t.sendResume(),t.onDidDispose(()=>g("renderer disconnected")),h(t),t.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(x.isScheduled())return;F.isScheduled()&&x.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const h=r.pipeName;return new Promise((n,t)=>{const a=c.createConnection(h,()=>{a.removeListener("error",t);const w=new C.PersistentProtocol({socket:new P.NodeSocket(a,"extHost-renderer")});w.sendResume(),n(w)});a.once("error",t),a.on("close",()=>{g("renderer closed the socket")})})}}async function o(){const r=await i();return new class{constructor(){this.a=new C.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,r.onMessage(h=>{(0,I.isMessageOfType)(h,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||r.send(h)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(h=>{const n=r.onMessage(t=>{n.dispose();const a=JSON.parse(t.toString()),w=a.commit,D=S.default.commit;if(w&&D&&w!==D&&b(55),a.parentPid){let F=0;setInterval(function(){try{process.kill(a.parentPid,0),F=0}catch(V){V&&V.code==="EPERM"?(F++,F>=3&&g(`parent process ${a.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):g(`parent process ${a.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let x;try{x=globalThis._VSCODE_NODE_MODULES["native-watchdog"],x.start(a.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}r.send((0,I.createMessageOfType)(0)),h({protocol:r,initData:a})});r.send((0,I.createMessageOfType)(1))})}async function l(){const r=[];process.on("unhandledRejection",(F,x)=>{r.push(x),setTimeout(()=>{const V=r.indexOf(x);V>=0&&x.catch(M=>{r.splice(V,1),(0,R.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,R.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const x=r.indexOf(F);x>=0&&r.splice(x,1)}),process.on("uncaughtException",function(F){(0,R.isSigPipeError)(F)||(0,R.onUnexpectedError)(F)}),u.mark("code/extHost/willConnectToRenderer");const h=await o();u.mark("code/extHost/didConnectToRenderer");const n=await s(h);u.mark("code/extHost/didWaitForInitData");const{initData:t}=n;y(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,m.boolean)(p.skipWorkspaceStorageLock,!1);const a=new class{constructor(){this.pid=process.pid}exit(x){b(x)}exists(x){return v.Promises.exists(x)}realpath(x){return(0,T.realpath)(x)}};let w=null;t.remote.authority&&p.transformURIs&&(w=(0,d.createURITransformer)(t.remote.authority));const D=new L.ExtensionHostMain(n.protocol,t,a,w);g=F=>D.terminate(F)}l().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
